/******************************************************************** 
 * Copyright (c) 2000                                               *
 * GMD FOKUS                                                        *
 * Kaiserin-Augusta-Allee 31                                        *
 * 10589 Berlin                                                     *
 * Germany                                                          *
 * Tel: +49-30-3463-7000                                            *
 * Fax: +49-30-3463-8000                                            *
 *                                                                  *        
 * All rights reserved. No part of this source code may be          *
 * reproduced, stored in a retrieval system, or transmitted,        *
 * in any form or by any means, electronic, mechanical,             *
 * photocopying, recording or otherwise,                            *
 * except as stated in the end-user licence agreement,              * 
 * without the prior permission of the copyright owners.            *
 *                                                                  *
 * Project: CORVAL2                                                 *
 *                                                                  *
 * Contact:                                                         *
 * Mang Li                                                          *
 * e-mail: m.li@fokus.gmd.de                                        *
 *                                                                  *
 * Date: Oct. 2000                                                  *
 ********************************************************************/


#ifdef __cplusplus
extern "C" {
#endif

#include "begemot.h"
#include "rpoll.h"
#include "defines4tsp1.h"
#include "mesg.h" 
#include "string_coding.h"
#include "asn-incl.h"
#include "general-definitions.h"
#include "tpi-pdus.h"
#include "gci-pdus.h"

  int openFIFO();
  
  int fifo_outfunc(int type, char *buf, int len);
  
  void fifo_infunc(int fd, int mask, void *vtpi_infunc);
  
  void tpi_outfunc(TPI_PDUs *pdu);
  
  void tpi_infunc(TPI_PDUs *m);
  
#ifdef __cplusplus
}
#endif

