//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/inc/DSI.hh
//
// Modifications:
// $Log: DSI.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:08  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:50  stephen
// Initial vsOrb code base
//
//

class ServerRequest
{

public:
    Identifier op_name(VSORB_ENV2);
    OperationDef_ptr op_def(VSORB_ENV2);
    Context_ptr ctx(VSORB_ENV2);// throw( SystemException);
    void params( NVList_ptr parameters VSORB_ENV);
    void result( Any *value VSORB_ENV);
    void exception( Any *value VSORB_ENV);
};

class DynamicImplementation
{

public:
    virtual void invoke(ServerRequest_ptr request VSORB_ENV) = 0;
};
