//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/inc/NVList.hh
//
// Modifications:
// $Log: NVList.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:50  stephen
// Initial vsOrb code base
//
//

class NVList
{

public:
    ULong count(VSORB_ENV2) const;
    NamedValue_ptr add( Flags VSORB_ENV);
    NamedValue_ptr add_item( const char*, Flags VSORB_ENV);
    NamedValue_ptr add_value( const char*, const Any&, Flags VSORB_ENV);
    NamedValue_ptr add_item_consume(char*, Flags VSORB_ENV);
    NamedValue_ptr add_value_consume(char*,Any *,Flags VSORB_ENV);
    NamedValue_ptr item( ULong VSORB_ENV);
    Status remove( ULong VSORB_ENV);
    
    static NVList_ptr _duplicate(VSORB_ENV2);
    static NVList_ptr _nil(VSORB_ENV2);
};

typedef T_var<NVList> NVList_var;


