//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/lib/Basic.cpp
//
// Modifications:
// $Log: Basic.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:07:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.2  1997/08/20 13:08:26  james
// Added string_alloc, string_dup and string_free
//
//

#include <vsorbref.hh>


const CORBA::Flags CORBA::ARG_IN=1;
const CORBA::Flags CORBA::ARG_OUT=2;
const CORBA::Flags CORBA::ARG_INOUT=4;
const CORBA::Flags CORBA::OUT_LIST_MEMORY=8;
const CORBA::Flags CORBA::IN_COPY_VALUE=16;
const CORBA::Flags CORBA::INV_NO_RESPONSE=32;
const CORBA::Flags CORBA::INV_TERM_ON_ERR=64;
const CORBA::Flags CORBA::RESP_NO_WAIT=128;
const CORBA::Flags CORBA::DEPENDENT_LIST=256;
const CORBA::Flags CORBA::CTX_RESTRICT_SCOPE=512;
const CORBA::Flags CORBA::CTX_DELETE_DESCENDENTS=1024;
 
char *CORBA::string_alloc(CORBA::ULong) {return (char *)0;};
char *CORBA::string_dup(const char *) {return (char *)0;};
void CORBA::string_free(char *) {};

