//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/lib/IR.cpp
//
// Modifications:
// $Log: IR.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:07:10  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:51  stephen
// Initial vsOrb code base
//
//

#include <vsorbref.hh>

CORBA::IRObject_ptr CORBA::IRObject::_duplicate(CORBA::IRObject_ptr)
{
	return 0;
}

CORBA::IRObject_ptr CORBA::IRObject::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::IRObject_ptr CORBA::IRObject::_nil()
{
	return 0;
}

CORBA::DefinitionKind CORBA::IRObject::def_kind(VSORB_ENV2)
{
	return CORBA::dk_none;
}

void CORBA::IRObject::destroy(VSORB_ENV2)
{
}

CORBA::Contained_ptr CORBA::Contained::_duplicate(CORBA::Contained_ptr)
{
	return 0;
}

CORBA::Contained_ptr CORBA::Contained::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::Contained_ptr CORBA::Contained::_nil()
{
	return 0;
}

CORBA::RepositoryId CORBA::Contained::id(VSORB_ENV2)
{
	return 0;
}

void CORBA::Contained::id(const char * VSORB_ENV)
{
}

CORBA::Identifier CORBA::Contained::name(VSORB_ENV2)
{
	return 0;
}

void CORBA::Contained::name(const char *VSORB_ENV)
{
}

CORBA::VersionSpec CORBA::Contained::version(VSORB_ENV2)
{
	return 0;
}

void CORBA::Contained::version(const char * VSORB_ENV)
{
}

CORBA::Container_ptr CORBA::Contained::defined_in(VSORB_ENV2)
{
	return 0;
}

CORBA::ScopedName CORBA::Contained::absolute_name(VSORB_ENV2)
{
	return 0;
}

CORBA::Repository_ptr CORBA::Contained::containing_repository(VSORB_ENV2)
{
	return 0;
}

CORBA::Contained::Description* CORBA::Contained::describe(VSORB_ENV2)
{
	return 0;
}

void CORBA::Contained::move(CORBA::Container_ptr, const char *,const char * VSORB_ENV)
{
}

CORBA::Container_ptr CORBA::Container::_duplicate(CORBA::Container_ptr)
{
	return 0;
}

CORBA::Container_ptr CORBA::Container::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::Container_ptr CORBA::Container::_nil()
{
	return 0;
}

CORBA::Contained_ptr CORBA::Container::lookup(const char * VSORB_ENV)
{
	return 0;
}


CORBA::ContainedSeq_ptr CORBA::Container::contents(CORBA::DefinitionKind,
			  CORBA::Boolean VSORB_ENV)
{
	return 0;
}

CORBA::ContainedSeq_ptr CORBA::Container::lookup_name(const char *, CORBA::Long,
																											CORBA::DefinitionKind, CORBA::Boolean VSORB_ENV)
{
	return 0;
}

CORBA::Container::DescriptionSeq_ptr CORBA::Container::describe_contents(CORBA::DefinitionKind,
																																				 CORBA::Boolean,
																																				 CORBA::Long VSORB_ENV)
{
	return 0;
}


CORBA::ModuleDef_ptr CORBA::Container::create_module(const char *, const char *,
																										const char * VSORB_ENV)
{
	return 0;
}

CORBA::ConstantDef_ptr CORBA::Container::create_constant(const char *,
				const char *,
				const char *,
				const CORBA::IDLType_ptr,
				const CORBA::Any& VSORB_ENV)
{
	return 0;
}

CORBA::StructDef_ptr CORBA::Container::create_struct(const char *,
		const char *,
		const char *,
		const CORBA::StructMemberSeq& VSORB_ENV)
{
	return 0;
}

CORBA::UnionDef_ptr CORBA::Container::create_union(const char *,
			  const char *,
			  const char *,
			  const CORBA::IDLType_ptr,
			  const CORBA::UnionMemberSeq& VSORB_ENV)
{
	return 0;
}

CORBA::EnumDef_ptr CORBA::Container::create_enum(const char *,
			const char *,
			const char *,
			const CORBA::EnumMemberSeq& VSORB_ENV)
{
	return 0;
}

CORBA::AliasDef_ptr CORBA::Container::create_alias(const char *,
			  const char *,
			  const char *,
			  const CORBA::IDLType_ptr VSORB_ENV)
{
	return 0;
}

CORBA::InterfaceDef_ptr CORBA::Container::create_interface(const char *,
				  const char *,
				  const char *,
				  const CORBA::InterfaceDefSeq& VSORB_ENV)
{
	return 0;
}

CORBA::ExceptionDef_ptr CORBA::Container::create_exception(const char *,
				  const char *,
				  const char *,
				  const CORBA::StructMemberSeq& VSORB_ENV)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::IDLType::_duplicate(CORBA::IDLType_ptr)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::IDLType::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::IDLType::_nil()
{
	return 0;
}

CORBA::TypeCode_ptr CORBA::IDLType::type(VSORB_ENV2)
{
	return 0;
}

CORBA::Repository_ptr CORBA::Repository::_duplicate(CORBA::Repository_ptr)
{
	return 0;
}

CORBA::Repository_ptr CORBA::Repository::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::Repository_ptr CORBA::Repository::_nil()
{
	return 0;
}

CORBA::Contained_ptr CORBA::Repository::lookup_id(const char * VSORB_ENV)
{
	return 0;
}

CORBA::PrimitiveDef_ptr CORBA::Repository::get_primitive(CORBA::PrimitiveKind VSORB_ENV)
{
	return 0;
}

CORBA::StringDef_ptr CORBA::Repository::create_string(CORBA::ULong VSORB_ENV)
{
	return 0;
}

CORBA::SequenceDef_ptr CORBA::Repository::create_sequence(CORBA::ULong,
				const CORBA::IDLType_ptr VSORB_ENV)
{
	return 0;
}

CORBA::ArrayDef_ptr CORBA::Repository::create_array(CORBA::ULong,
			  CORBA::IDLType_ptr VSORB_ENV)
{
	return 0;
}

CORBA::ModuleDef_ptr CORBA::ModuleDef::_duplicate(CORBA::ModuleDef_ptr)
{
	return 0;
}

CORBA::ModuleDef_ptr CORBA::ModuleDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::ModuleDef_ptr CORBA::ModuleDef::_nil()
{
	return 0;
}

CORBA::ConstantDef_ptr CORBA::ConstantDef::_duplicate(CORBA::ConstantDef_ptr)
{
	return 0;
}

CORBA::ConstantDef_ptr CORBA::ConstantDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::ConstantDef_ptr CORBA::ConstantDef::_nil()
{
	return 0;
}

CORBA::TypeCode_ptr CORBA::ConstantDef::type(VSORB_ENV2)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::ConstantDef::type_def(VSORB_ENV2)
{
	return 0;
}

void CORBA::ConstantDef::type_def(IDLType_ptr VSORB_ENV)
{
}

CORBA::Any* CORBA::ConstantDef::value(VSORB_ENV2)
{
	return 0;
}

void CORBA::ConstantDef::value(const CORBA::Any& VSORB_ENV)
{
}

CORBA::TypedefDef_ptr CORBA::TypedefDef::_duplicate(CORBA::TypedefDef_ptr)
{
	return 0;
}

CORBA::TypedefDef_ptr CORBA::TypedefDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::TypedefDef_ptr CORBA::TypedefDef::_nil()
{
	return 0;
}

CORBA::StructDef_ptr CORBA::StructDef::_duplicate(CORBA::StructDef_ptr)
{
	return 0;
}

CORBA::StructDef_ptr  CORBA::StructDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::StructDef_ptr  CORBA::StructDef::_nil()
{
	return 0;
}

CORBA::StructMemberSeq*  CORBA::StructDef::members(VSORB_ENV2)
{
	return 0;
}

void  CORBA::StructDef::members(const CORBA::StructMemberSeq& VSORB_ENV)
{
}

CORBA::UnionDef_ptr CORBA::UnionDef::_duplicate(CORBA::UnionDef_ptr)
{
	return 0;
}

CORBA::UnionDef_ptr CORBA::UnionDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::UnionDef_ptr CORBA::UnionDef::_nil()
{
	return 0;
}

CORBA::TypeCode_ptr CORBA::UnionDef::discriminator_type(VSORB_ENV2)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::UnionDef::discriminator_type_def(VSORB_ENV2)
{
	return 0;
}

void CORBA::UnionDef::discriminator_type_def(CORBA::IDLType_ptr VSORB_ENV)
{
}

CORBA::UnionMemberSeq* CORBA::UnionDef::members(VSORB_ENV2)
{
	return 0;
}

void CORBA::UnionDef::members(const CORBA::UnionMemberSeq& VSORB_ENV)
{
}

CORBA::EnumDef_ptr  CORBA::EnumDef::_duplicate( CORBA::EnumDef_ptr)
{
	return 0;
}

CORBA::EnumDef_ptr  CORBA::EnumDef::_narrow( CORBA::Object_ptr)
{
	return 0;
}

CORBA::EnumDef_ptr  CORBA::EnumDef::_nil()
{
	return 0;
}

CORBA::EnumMemberSeq * CORBA::EnumDef::members(VSORB_ENV2)
{
	return 0;
}

void CORBA::EnumDef::members(const CORBA::EnumMemberSeq & VSORB_ENV)
{
}

CORBA::AliasDef_ptr CORBA::AliasDef::_duplicate(CORBA::AliasDef_ptr)
{
	return 0;
}

CORBA::AliasDef_ptr CORBA::AliasDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::AliasDef_ptr CORBA::AliasDef::_nil()
{
	return 0;
}

CORBA::IDLType_ptr CORBA::AliasDef::original_type_def(VSORB_ENV2)
{
	return 0;
}

void CORBA::AliasDef::original_type_def(CORBA::IDLType_ptr VSORB_ENV)
{
}

CORBA::PrimitiveDef_ptr CORBA::PrimitiveDef::_duplicate(CORBA::PrimitiveDef_ptr )
{
	return 0;
}

CORBA::PrimitiveDef_ptr CORBA::PrimitiveDef::_narrow(CORBA::Object_ptr )
{
	return 0;
}

CORBA::PrimitiveDef_ptr CORBA::PrimitiveDef::_nil()
{
	return 0;
}

CORBA::PrimitiveKind CORBA::PrimitiveDef::kind(VSORB_ENV2)
{
	return CORBA::pk_null;
}

CORBA::StringDef_ptr CORBA::StringDef::_duplicate(CORBA::StringDef_ptr)
{
	return 0;
}

CORBA::StringDef_ptr CORBA::StringDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::StringDef_ptr CORBA::StringDef::_nil()
{
	return 0;
}

CORBA::ULong CORBA::StringDef::bound(VSORB_ENV2)
{
	return 0;
}

void CORBA::StringDef::bound(CORBA::ULong VSORB_ENV)
{
}

CORBA::SequenceDef_ptr CORBA::SequenceDef::_duplicate(CORBA::SequenceDef_ptr)
{
	return 0;
}

CORBA::SequenceDef_ptr CORBA::SequenceDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::SequenceDef_ptr CORBA::SequenceDef::_nil()
{
	return 0;
}

CORBA::ULong CORBA::SequenceDef::bound(VSORB_ENV2)
{
	return 0;
}

void CORBA::SequenceDef::bound(CORBA::ULong VSORB_ENV)
{
}

CORBA::TypeCode_ptr CORBA::SequenceDef::element_type(VSORB_ENV2)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::SequenceDef::element_type_def(VSORB_ENV2)
{
	return 0;
}

void CORBA::SequenceDef::element_type_def(CORBA::IDLType_ptr VSORB_ENV)
{
}

CORBA::ArrayDef_ptr CORBA::ArrayDef::_duplicate(CORBA::ArrayDef_ptr)
{
	return 0;
}

CORBA::ArrayDef_ptr CORBA::ArrayDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::ArrayDef_ptr CORBA::ArrayDef::_nil()
{
	return 0;
}

CORBA::ULong CORBA::ArrayDef::length(VSORB_ENV2)
{
	return 0;
}

void CORBA::ArrayDef::length(CORBA::ULong VSORB_ENV)
{
}

CORBA::TypeCode_ptr CORBA::ArrayDef::element_type(VSORB_ENV2)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::ArrayDef::element_type_def(VSORB_ENV2)
{
	return 0;
}

void CORBA::ArrayDef::element_type_def(CORBA::IDLType_ptr VSORB_ENV)
{
}

CORBA::ExceptionDef_ptr CORBA::ExceptionDef::_duplicate(CORBA::ExceptionDef_ptr)
{
	return 0;
}

CORBA::ExceptionDef_ptr CORBA::ExceptionDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::ExceptionDef_ptr CORBA::ExceptionDef::_nil()
{
	return 0;
}

CORBA::TypeCode_ptr CORBA::ExceptionDef::type(VSORB_ENV2)
{
	return 0;
}

CORBA::StructMemberSeq * CORBA::ExceptionDef::members(VSORB_ENV2)
{
	return 0;
}

void CORBA::ExceptionDef::members(const CORBA::StructMemberSeq& VSORB_ENV)
{
}

CORBA::AttributeDef_ptr CORBA::AttributeDef::_duplicate(CORBA::AttributeDef_ptr)
{
	return 0;
}

CORBA::AttributeDef_ptr CORBA::AttributeDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::AttributeDef_ptr CORBA::AttributeDef::_nil()
{
	return 0;
}

CORBA::TypeCode_ptr CORBA::AttributeDef::type(VSORB_ENV2)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::AttributeDef::type_def(VSORB_ENV2)
{
	return 0;
}

void CORBA::AttributeDef::type_def(CORBA::IDLType_ptr VSORB_ENV)
{
}

CORBA::AttributeMode CORBA::AttributeDef::mode(VSORB_ENV2)
{
	return CORBA::ATTR_NORMAL;
}

void CORBA::AttributeDef::mode(CORBA::AttributeMode VSORB_ENV)
{
}

CORBA::OperationDef_ptr CORBA::OperationDef::_duplicate(CORBA::OperationDef_ptr)
{
	return 0;
}

CORBA::OperationDef_ptr CORBA::OperationDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::OperationDef_ptr CORBA::OperationDef::_nil()
{
	return 0;
}

CORBA::TypeCode_ptr CORBA::OperationDef::result(VSORB_ENV2)
{
	return 0;
}

CORBA::IDLType_ptr CORBA::OperationDef::result_def(VSORB_ENV2)
{
	return 0;
}

void CORBA::OperationDef::result_def(CORBA::IDLType_ptr VSORB_ENV)
{
}

CORBA::ParDescriptionSeq* CORBA::OperationDef::params(VSORB_ENV2)
{
	return 0;
}

void CORBA::OperationDef::params(const CORBA::ParDescriptionSeq& VSORB_ENV)
{
}

CORBA::OperationMode CORBA::OperationDef::mode(VSORB_ENV2)
{
	return CORBA::OP_NORMAL;
}

void CORBA::OperationDef::mode(CORBA::OperationMode VSORB_ENV)
{
}

CORBA::ContextIdSeq* CORBA::OperationDef::contexts(VSORB_ENV2)
{
	return 0;
}

void CORBA::OperationDef::contexts(const CORBA::ContextIdSeq& VSORB_ENV)
{
}

CORBA::ExceptionDefSeq* CORBA::OperationDef::exceptions(VSORB_ENV2)
{
	return 0;
}

void CORBA::OperationDef::exceptions(const CORBA::ExceptionDefSeq& VSORB_ENV)
{
}

CORBA::InterfaceDef_ptr CORBA::InterfaceDef::_duplicate(CORBA::InterfaceDef_ptr)
{
	return 0;
}

CORBA::InterfaceDef_ptr CORBA::InterfaceDef::_narrow(CORBA::Object_ptr)
{
	return 0;
}

CORBA::InterfaceDef_ptr CORBA::InterfaceDef::_nil()
{
	return 0;
}

CORBA::InterfaceDefSeq* CORBA::InterfaceDef::base_interfaces(VSORB_ENV2)
{
	return 0;
}

void CORBA::InterfaceDef::base_interfaces(const CORBA::InterfaceDefSeq & VSORB_ENV)
{
}

CORBA::Boolean CORBA::InterfaceDef::is_a(const char * VSORB_ENV)
{
	return 0;
}

CORBA::InterfaceDef::FullInterfaceDescription* CORBA::InterfaceDef::describe_interface(VSORB_ENV2)
{
	return 0;
}

CORBA::AttributeDef_ptr CORBA::InterfaceDef::create_attribute(const char *,
				  const char *,
				  const char *,
				  const CORBA::IDLType_ptr,
				  CORBA::AttributeMode VSORB_ENV)
{
	return 0;
}

CORBA::OperationDef_ptr CORBA::InterfaceDef::create_operation(const char *,
				  const char *,
				  const char *,
				  const CORBA::IDLType_ptr,
				  CORBA::OperationMode,
				  const CORBA::ParDescriptionSeq&,
				  const CORBA::ExceptionDefSeq&,
				  const CORBA::ContextIdSeq& VSORB_ENV)
{
	return 0;
}

