//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/lib/TypeCode.cpp
//
// Modifications:
// $Log: TypeCode.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:07:10  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.2  1997/08/20 12:36:51  james
// _narrow method added to exceptions
//
//

#include <vsorbref.hh>

CORBA::TypeCode::Bounds *
CORBA::TypeCode::Bounds::_narrow(CORBA::Exception *)
{
    return (CORBA::TypeCode::Bounds *)0;
}

CORBA::TypeCode::BadKind *
CORBA::TypeCode::BadKind::_narrow(CORBA::Exception *)
{
    return (CORBA::TypeCode::BadKind *)0;
}

CORBA::TCKind
CORBA::TypeCode::kind(VSORB_ENV2) const
{
    return (CORBA::TCKind)0;
}

CORBA::Boolean
CORBA::TypeCode::equal( TypeCode_ptr VSORB_ENV) const
{
    return 0;
}

const char*
CORBA::TypeCode::id(VSORB_ENV2) const
{
    return 0;
}

const char*
CORBA::TypeCode::name(VSORB_ENV2) const
{
    return 0;
}
    
CORBA::ULong
CORBA::TypeCode::member_count(VSORB_ENV2) const
{
    return 0;
}

const char*
CORBA::TypeCode::member_name( CORBA::ULong VSORB_ENV) const
{
    return 0;
}
    
CORBA::TypeCode_ptr
CORBA::TypeCode::member_type( CORBA::ULong  VSORB_ENV) const
{
    return 0;
}
    
CORBA::Any *
CORBA::TypeCode::member_label( CORBA::ULong  VSORB_ENV) const
{
    return 0;
}

CORBA::TypeCode_ptr
CORBA::TypeCode::discriminator_type(VSORB_ENV2) const
{
    return 0;
}

CORBA::Long
CORBA::TypeCode::default_index(VSORB_ENV2) const
{
    return 0;
}

CORBA::ULong
CORBA::TypeCode::length(VSORB_ENV2) const
{
    return 0;
}

CORBA::TypeCode_ptr
CORBA::TypeCode::content_type(VSORB_ENV2) const
{
    return 0;
}

CORBA::Long
CORBA::TypeCode::param_count(VSORB_ENV2) const
{
    return 0;
}

CORBA::Any *
CORBA::TypeCode::parameter( CORBA::Long VSORB_ENV) const
{
    return 0;
}
    
CORBA::TypeCode_ptr
CORBA::TypeCode::_duplicate(VSORB_ENV2)
{
    return 0;
}

CORBA::TypeCode_ptr
CORBA::TypeCode::_nil(VSORB_ENV2)
{
    return 0;
}





const CORBA::TypeCode_ptr CORBA::_tc_null = 0;
const CORBA::TypeCode_ptr CORBA::_tc_void = 0;
const CORBA::TypeCode_ptr CORBA::_tc_short = 0;
const CORBA::TypeCode_ptr CORBA::_tc_long = 0;
const CORBA::TypeCode_ptr CORBA::_tc_ushort = 0;
const CORBA::TypeCode_ptr CORBA::_tc_ulong = 0;
const CORBA::TypeCode_ptr CORBA::_tc_float = 0;
const CORBA::TypeCode_ptr CORBA::_tc_double = 0;
const CORBA::TypeCode_ptr CORBA::_tc_boolean = 0;
const CORBA::TypeCode_ptr CORBA::_tc_char = 0;
const CORBA::TypeCode_ptr CORBA::_tc_octet = 0;
const CORBA::TypeCode_ptr CORBA::_tc_any = 0;
const CORBA::TypeCode_ptr CORBA::_tc_TypeCode = 0;
const CORBA::TypeCode_ptr CORBA::_tc_Principal = 0;
const CORBA::TypeCode_ptr CORBA::_tc_Object  = 0;
const CORBA::TypeCode_ptr CORBA::_tc_string = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_NamedValue = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_InterfaceDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_OperationDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_AttributeDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_ParameterDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_ModuleDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_ConstantDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_ExceptionDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_TypeDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_CORBA_InterfaceDef_FullInterfaceDescription = 0;
const CORBA::TypeCode_ptr CORBA::_tc_longlong = 0;
const CORBA::TypeCode_ptr CORBA::_tc_ulonglong = 0;
const CORBA::TypeCode_ptr CORBA::_tc_longdouble = 0;
const CORBA::TypeCode_ptr CORBA::_tc_wchar = 0;
const CORBA::TypeCode_ptr CORBA::_tc_wstring  = 0;

