
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif

{
    char *string;

    AddExpr *addExpr;
    AddOper *addOper;
    AndExpr *andExpr;
    AndOper *andOper;
    AnyType *anyType;
    ArrayDeclarator *arrayDeclarator;
    AttrDcl *attrDcl;
    BaseTypeSpec *baseTypeSpec;
    BooleanLiteral *booleanLiteral;
    BooleanType *booleanType;
    Case *_case;
    CaseLabel *caseLabel;
    CaseLabelList *caseLabelList;
    CharType *charType;
    CharacterLiteral *characterLiteral;
    ComplexDeclarator *complexDeclarator;
    ConstDcl *constDcl;
    ConstExp *constExp;
    ConstType *constType;
    ConstrTypeSpec *constrTypeSpec;
    ContextExpr *contextExpr;
    Declarator *declarator;
    Declarators *declarators;
    Definition *definition;
    Definitions *definitions;
    DivOper *divOper;
    ElementSpec *elementSpec;
    EnumType *enumType;
    Enumerator *enumerator;
    EnumeratorList *enumeratorList;
    ExceptDcl *exceptDcl;
    Export *exp;
    FixedArraySize *fixedArraySize;
    FixedArraySizeList *fixedArraySizeList;
    FloatingPtLiteral *floatingPtLiteral;
    FloatingPtType *floatingPtType;
    FloatType *floatType;
    DoubleType *doubleType;
    ForwardDcl *forwardDcl;
    _Identifier *identifier;
    InheritanceSpec *inheritanceSpec;
    IntegerLiteral *integerLiteral;
    IntegerType *integerType;
    Interface *interface;
    InterfaceBody *interfaceBody;
    InterfaceDcl *interfaceDcl;
    Literal *literal;
    Member *member;
    MemberList *memberList;
    Module *module;
    MultExpr *multExpr;
    MultOper *multOper;
    ObjectType *objectType;
    OctetType *octetType;
    OpAttribute *opAttribute;
    OpDcl *opDcl;
    OpTypeSpec *opTypeSpec;
    OpTypeSpecA *opTypeSpecA;
    OpTypeSpecB *opTypeSpecB;
    OrExpr *orExpr;
    OrOper *orOper;
    ParamAttribute *paramAttribute;
    ParamDcl *paramDcl;
    ParamTypeSpec *paramTypeSpec;
    ParameterDcls *parameterDcls;
    ParameterDclsA *parameterDclsA;
    PositiveIntConst *positiveIntConst;
    PrimaryExpr *primaryExpr;
    RaisesExpr *raisesExpr;
    Readonly *readonly;
    RemainderOper *remainderOper;
    _ScopedName *scopedName;
    ScopedNameA *scopedNameA;
    ScopedNameB *scopedNameB;
    SequenceType *sequenceType;
    ShiftExpr *shiftExpr;
    ShiftLeftOper *shiftLeftOper;
    ShiftRightOper *shiftRightOper;
    SignedInt *signedInt;
    SignedLongInt *signedLongInt;
    SignedShortInt *signedShortInt;
    SimpleDeclarator *simpleDeclarator;
    SimpleDeclaratorList *simpleDeclaratorList;
    SimpleTypeSpec *simpleTypeSpec;
    Specification *specification;
    StringLiteral *stringLiteral;
    char *stringLiteralList;
    StringType *stringType;
    StructType *structType;
    SubtractOper *subtractOper;
    SwitchBody *switchBody;
    SwitchTypeSpec *switchTypeSpec;
    TemplateTypeSpec *templateTypeSpec;
    TypeDcl *typeDcl;
    TypeDeclarator *typeDeclarator;
    TypeSpec *typeSpec;
    UnaryExpr *unaryExpr;
    UnaryMinusOper *unaryMinusOper;
    UnaryNotOper *unaryNotOper;
    UnaryPlusOper *unaryPlusOper;
    UnionType *unionType;
    UnionSwitch *unionSwitch;
    UnsignedInt *unsignedInt;
    UnsignedLongInt *unsignedLongInt;
    UnsignedShortInt *unsignedShortInt;
    XorExpr *xorExpr;
    XorOper *xorOper;
} YYSTYPE;
extern YYSTYPE yylval;
# define ANY 257
# define ATTRIBUTE 258
# define BOOLEAN 259
# define CASE 260
# define CHAR 261
# define CONST 262
# define CONTEXT 263
# define DEFAULT 264
# define DOUBLE 265
# define ENUM 266
# define EXCEPTION 267
# define FLOAT 268
# define IN 269
# define INOUT 270
# define INTERFACE 271
# define LONG 272
# define MODULE 273
# define OBJECT 274
# define OCTET 275
# define ONEWAY 276
# define OUT 277
# define RAISES 278
# define READONLY 279
# define SEQUENCE 280
# define SHORT 281
# define STRING 282
# define STRUCT 283
# define SWITCH 284
# define TYPEDEF 285
# define UNSIGNED 286
# define UNION 287
# define VOID 288
# define SEMI_COLON 289
# define LEFT_CURLY_BRACKET 290
# define RIGHT_CURLY_BRACKET 291
# define COLON 292
# define COMMA 293
# define EQUALS_SIGN 294
# define PLUS_SIGN 295
# define MINUS_SIGN 296
# define LEFT_PARENTHESIS 297
# define RIGHT_PARENTHESIS 298
# define LESS_THAN_SIGN 299
# define GREATER_THAN_SIGN 300
# define LEFT_SQUARE_BRACKET 301
# define RIGHT_SQUARE_BRACKET 302
# define APOSTROPHE 303
# define DOUBLE_QUOTE 304
# define REVERSE_SOLIDUS 305
# define VERTICAL_LINE 306
# define CIRCUMFLEX 307
# define AMPERSAND 308
# define ASTERISK 309
# define SOLIDUS 310
# define PERCENT_SIGN 311
# define TILDA 312
# define SHIFT_LEFT 313
# define SHIFT_RIGHT 314
# define SCOPE_DELIMITOR 315
# define IDENTIFIER 316
# define INTEGER_LITERAL 317
# define STRING_LITERAL 318
# define CHARACTER_LITERAL 319
# define FLOATING_PT_LITERAL 320
# define BOOLEAN_LITERAL 321
