/* ADL test driver from t1.tdr
 *
 * test VSinsert_reference(daRefVal, Boo, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_2892[] = {
    {"tRef", PdaRefVal_prop_1_tRef, 0},
    {"tVal", PdaRefVal_prop_1_tVal, 0},
    {"tComp", PdaRefVal_prop_1_tComp, 0},
    {0, 0, 0}
};

/* values for literal variable Boo */
static VSBoolean ADL__litvar_val_2710[] = {
    0,
    1,
};

static struct ADL__propertyValue ADL__litvar_info_2709[] = {
    {"0", 0, ADL__litvar_val_2710},
    {"1", 1, ADL__litvar_val_2710},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_2893[] = {
    {"prop_1", "prop", ADL__prop_values_2892, 3},
    {"Boo", "litvar", ADL__litvar_info_2709, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_2897[4] = {
    {"daRefVal", "VSDynAny_ptr *", ADL__prop_info_2893, 0, 1},
    {"Boo", "VSBoolean", ADL__prop_info_2893, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_2893, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSinsert_reference_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSDYNANY_PTR_P
#define ADL__PRINT_VSDYNANY_PTR_P
void (*ADL__print_VSDynAny_ptr_P)(VSDynAny_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNANY_PTR_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */

void ADL__emit_VSDynAny_ptr_P (void* val, emitter_t emitter)
{
  VSDynAny_ptr *tmp;

  if (ADL__print_VSDynAny_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSDynAny_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {3, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSDynAny_ptr *daRefVal_2894;
    VSBoolean Boo_2895;
    VSEnvironment *env_2896;
    VSBoolean fut_return_2891;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSinsert_reference_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSinsert_reference_InfoArrayIdx,
        ADL__VSinsert_reference_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_daRefVal(&daRefVal_2894, ADL__prop_values_2892[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSDynAny_ptr_P(&daRefVal_2894, rf->variableReport->emitVariable);

       Boo_2895 = ADL__litvar_val_2710[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 1, tvec + 1, 1);
       ADL__emit_VSBoolean(&Boo_2895, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_2896)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_2896, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSinsert_reference_assertionReport = rf->assertionReport;
       fut_return_2891 = ADL__ACF_VSinsert_reference(daRefVal_2894, Boo_2895, env_2896);
       test_value = ADL__VSinsert_reference_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_2896);
SKIP_2:
       relvec[1] = 1;	/* relinquish succeeds for Boo_2895 */
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_daRefVal(&daRefVal_2894, ADL__prop_values_2892[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_2897,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSinsert_reference_head);

    return 0;
}


struct ADL__Directive_info VSinsert_reference1_info = {
    N_VARS,
    ADL__var_info_2897
};

struct ADL__TDD_info ADL__test_info = {
    6,
    &ADL__VSinsert_reference_InfoArrayIdx,
    ADL__VSinsert_reference_InfoArray,
    ADL__test_driver,
    "VSinsert_reference",
    "VSinsert_reference1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSinsert_reference1",
    "t1_tr.rif",
    &VSinsert_reference1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

