/* ADL test driver from t1.tdr
 *
 * test VStype(dany, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_702[] = {
    {"tshort", Pdany_prop_1_tshort, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_703[] = {
    {"prop_1", "prop", ADL__prop_values_702, 1},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_706[3] = {
    {"dany", "VSDynAny_ptr *", ADL__prop_info_703, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_703, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VStype_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSDYNANY_PTR_P
#define ADL__PRINT_VSDYNANY_PTR_P
void (*ADL__print_VSDynAny_ptr_P)(VSDynAny_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNANY_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSLONG
#define ADL__PRINT_VSLONG
void (*ADL__print_VSLong)(VSLong, emitter_t) = 0;

#endif /* ADL__PRINT_VSLONG */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSTYPECODE_PTR_P
#define ADL__PRINT_VSTYPECODE_PTR_P
void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR_P */
#ifndef ADL__PRINT_VSANY_PTR
#define ADL__PRINT_VSANY_PTR
void (*ADL__print_VSAny_ptr)(VSAny_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSANY_PTR */
#ifndef ADL__PRINT_VSANY_PTR_P
#define ADL__PRINT_VSANY_PTR_P
void (*ADL__print_VSAny_ptr_P)(VSAny_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSANY_PTR_P */

void ADL__emit_VSDynAny_ptr_P (void* val, emitter_t emitter)
{
  VSDynAny_ptr *tmp;

  if (ADL__print_VSDynAny_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSDynAny_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSLong (void* val, emitter_t emitter)
{
  VSLong tmp;

  if (ADL__print_VSLong != 0) {
    tmp = *(VSLong*) val;
    ADL__print_VSLong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter)
{
  VSTypeCode_ptr *tmp;

  if (ADL__print_VSTypeCode_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSTypeCode_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAny_ptr (void* val, emitter_t emitter)
{
  VSAny_ptr tmp;

  if (ADL__print_VSAny_ptr != 0) {
    tmp = *(VSAny_ptr*) val;
    ADL__print_VSAny_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAny_ptr_P (void* val, emitter_t emitter)
{
  VSAny_ptr *tmp;

  if (ADL__print_VSAny_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSAny_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {1};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSDynAny_ptr *dany_704;
    VSEnvironment *env_705;
    VSTypeCode_ptr *fut_return_701;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VStype_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VStype_InfoArrayIdx,
        ADL__VStype_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_dany(&dany_704, ADL__prop_values_702[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSDynAny_ptr_P(&dany_704, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_705)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_705, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VStype_assertionReport = rf->assertionReport;
       fut_return_701 = ADL__ACF_VStype(dany_704, env_705);
       test_value = ADL__VStype_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_env(&env_705);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_dany(&dany_704, ADL__prop_values_702[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_706,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VStype_head);

    return 0;
}


struct ADL__Directive_info VStype1_info = {
    N_VARS,
    ADL__var_info_706
};

struct ADL__TDD_info ADL__test_info = {
    1,
    &ADL__VStype_InfoArrayIdx,
    ADL__VStype_InfoArray,
    ADL__test_driver,
    "VStype",
    "VStype1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VStype1",
    "t1_tr.rif",
    &VStype1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

