/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int return_correct_count(VSDynAny_ptr *, VSULong);

extern int count_greater_index(VSDynAny_ptr *, VSLong);

extern int equal_seek0(VSDynAny_ptr *);

extern int comp_count(VSDynAny_ptr *);

extern int same_component_withoutIterating(VSDynAny_ptr *, VSDynAny_ptr *);

extern int valid_DynAny(VSDynAny_ptr *);

extern int is_nil_dany(VSDynAny_ptr *);

extern int return_correct_TypeCode(VSTypeCode_ptr *);

extern int same_TypeCode(VSDynAny_ptr *, VSDynAny_ptr *);

extern int same_dany(VSDynAny_ptr *, VSDynAny_ptr *);

extern int equal_DynAnyValue(VSDynAny_ptr *, VSDynAny_ptr *);

extern int equal_AnyTypeCode(VSDynAny_ptr *, VSAny_ptr);

extern int equal_AnyValue(VSDynAny_ptr *, VSAny_ptr);

extern int valid_AnyValue(VSAny_ptr);

extern int equal_Any(VSDynAny_ptr *, VSAny_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSDynAny_ptr_P)(VSDynAny_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSLong)(VSLong, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSAny_ptr)(VSAny_ptr, emitter_t);
extern void (*ADL__print_VSAny_ptr_P)(VSAny_ptr*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSULong (*ADL__VScomponent_count_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSseek_wrapper)(VSDynAny_ptr*, VSLong, VSEnvironment*);
extern VSBoolean (*ADL__VSrewind_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSnext_wrapper)(VSDynAny_ptr*, VSULong, VSEnvironment*);
extern VSDynAny_ptr *(*ADL__VScurrent_component_wrapper)(VSDynAny_ptr*, VSULong, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSassign_wrapper)(VSDynAny_ptr*, VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSequal_wrapper)(VSDynAny_ptr*, VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSfrom_any_wrapper)(VSDynAny_ptr*, VSAny_ptr, VSEnvironment*);
extern VSAny_ptr *(*ADL__VSto_any_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSdestroy_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSDynAny_ptr *(*ADL__VScopy_wrapper)(VSDynAny_ptr*, VSEnvironment*);

#endif
