/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSset_elements
 *
 */
VSBoolean ADL__ACF_VSset_elements (VSDynArray_ptr *darray_21, VSAnySeq_ptr aseq_22, VSEnvironment *ev_10){

VSBoolean VSset_elements_RtnVal_4;
  void *dummyVarName_176;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_23;
  int tmp_25;
  int tmp_26;
  VSEnvironment *ev_10_tmp_30;
    int tmp_31;
  int tmp_33;
  int tmp_34;
  int tmp_35;
  VSDynArray_ptr *darray_21_tmp_38;
  VSAnySeq_ptr aseq_22_tmp_40;
  int tmp_41;
  VSDynArray_ptr *darray_21_tmp_44;
  VSAnySeq_ptr aseq_22_tmp_46;
  int tmp_47;
  VSEnvironment *ev_10_tmp_51;
    int tmp_52;
  int tmp_53;
  int tmp_54;
  VSDynArray_ptr *darray_21_tmp_57;
  VSAnySeq_ptr aseq_22_tmp_59;
  int tmp_60;
  VSEnvironment *ev_10_tmp_64;
    int tmp_65;
  int tmp_66;
  int groupExpr_70;
  int tmp_67;

/* Declare vars for result of normal and exception bindings */
  int VSset_elements_NormalOutcome_5, VSset_elements_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSset_elements_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSset_elements_InfoArray, 0, ADL__VSset_elements_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSset_elements_assertionReport->setPhase(ADL__VSset_elements_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_elements_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSset_elements_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSset_elements_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSset_elements_InfoArray[forLoopIdx_1].error > VSset_elements_ACF_Result_3))
  VSset_elements_ACF_Result_3 = ADL__VSset_elements_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSset_elements_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSset_elements_assertionReport->setPhase(ADL__VSset_elements_assertionReport, PH_call);
  ADL__release(ADL__VSset_elements_assertionReport->parent, &this_seq);
  VSset_elements_RtnVal_4 = ADL__VSset_elements_wrapper(darray_21, aseq_22, ev_10);
  ADL__recover(ADL__VSset_elements_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSset_elements_assertionReport->setPhase(ADL__VSset_elements_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 7,&tmp_7);
  VSset_elements_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 2,&tmp_13);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_elements_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 1,&tmp_12);

  VSset_elements_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSset_elements_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSset_elements_InfoArray[0].result = (VSset_elements_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_elements_InfoArray[0].evaluated = 1;
  ADL__VSset_elements_InfoArray[0].value = (VSset_elements_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSset_elements_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSset_elements_InfoArray[6].result = (VSset_elements_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_elements_InfoArray[6].evaluated = 1;
  ADL__VSset_elements_InfoArray[6].value = (VSset_elements_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSset_elements_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSset_elements_ACF_Result_3 = ADL__VSset_elements_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSset_elements_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSset_elements_ACF_Result_3 = ADL__VSset_elements_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSset_elements_ExceptionOutcome_6 && !VSset_elements_NormalOutcome_5) {
  VSset_elements_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSset_elements_ExceptionOutcome_6 && VSset_elements_NormalOutcome_5) {
  VSset_elements_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSset_elements_InfoArray, 10,&VSset_elements_ExceptionOutcome_6);
  ev_10_tmp_30 = ev_10;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 13,&ev_10_tmp_30);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_26 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 12,&tmp_26);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = !tmp_26;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 11,&tmp_25);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = (!VSset_elements_ExceptionOutcome_6 || tmp_25);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 9,&tmp_23);
    darray_21_tmp_38 = darray_21;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 18,&darray_21_tmp_38);
  aseq_22_tmp_40 = aseq_22;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 19,&aseq_22_tmp_40);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[17]);

/* Evaluate valid_type_any_seq(darray, aseq) */
  tmp_35 = valid_type_any_seq(darray_21, aseq_22);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 17,&tmp_35);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[16]);

/* Evaluate !valid_type_any_seq(darray, aseq) */
  tmp_34 = !tmp_35;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 16,&tmp_34);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[15]);

/* Evaluate !valid_type_any_seq(darray, aseq) && valid_value_any_seq(darray, aseq) */
  tmp_33 = tmp_34;
  if (tmp_34) {
      darray_21_tmp_44 = darray_21;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 21,&darray_21_tmp_44);
  aseq_22_tmp_46 = aseq_22;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 22,&aseq_22_tmp_46);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[20]);

/* Evaluate valid_value_any_seq(darray, aseq) */
  tmp_41 = valid_value_any_seq(darray_21, aseq_22);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 20,&tmp_41);
    tmp_33 = tmp_41;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_elements_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 15,&tmp_33);
  ev_10_tmp_51 = ev_10;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 24,&ev_10_tmp_51);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[23]);

/* Evaluate DAny_user_exception_is("TypeMismatch", ev) */
  tmp_47 = DAny_user_exception_is("TypeMismatch", ev_10);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 23,&tmp_47);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[14]);

/* Evaluate (!valid_type_any_seq(darray, aseq) && valid_value_any_seq(darray, aseq)) --> DAny_user_exception_is("TypeMismatch", ev) */
  tmp_31 = (!tmp_33 || tmp_47);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 14,&tmp_31);
    darray_21_tmp_57 = darray_21;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 28,&darray_21_tmp_57);
  aseq_22_tmp_59 = aseq_22;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 29,&aseq_22_tmp_59);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[27]);

/* Evaluate valid_value_any_seq(darray, aseq) */
  tmp_54 = valid_value_any_seq(darray_21, aseq_22);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 27,&tmp_54);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[26]);

/* Evaluate !valid_value_any_seq(darray, aseq) */
  tmp_53 = !tmp_54;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 26,&tmp_53);
  ev_10_tmp_64 = ev_10;
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 31,&ev_10_tmp_64);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[30]);

/* Evaluate DAny_user_exception_is("InvalidValue", ev) */
  tmp_60 = DAny_user_exception_is("InvalidValue", ev_10);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 30,&tmp_60);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[25]);

/* Evaluate !valid_value_any_seq(darray, aseq) --> DAny_user_exception_is("InvalidValue", ev) */
  tmp_52 = (!tmp_53 || tmp_60);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 25,&tmp_52);
    ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[32]);

/* Evaluate normally { ... } */
  if(VSset_elements_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSset_elements_InfoArray, 34,&VSset_elements_RtnVal_4);
  ADL__VSset_elements_assertionReport->exprMark(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_assertionReport->assrt_info[33]);

/* Evaluate return == 1 */
  tmp_67 = (VSset_elements_RtnVal_4 == 1);
  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 33,&tmp_67);
  groupExpr_70 = (tmp_67);
  tmp_66 = (groupExpr_70);
  tmp_65 = tmp_66;
  }
  else {
    ADL__resetInfoStruct(ADL__VSset_elements_InfoArray, 32, 34);
  tmp_65 = 1;
}

  ADL__setResultAndError(ADL__VSset_elements_InfoArray, 32,&tmp_65);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_elements_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSset_elements_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSset_elements_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSset_elements_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSset_elements_InfoArray[forLoopIdx_1].level == 0))
        VSset_elements_ACF_Result_3 = calculate_ACF_result(VSset_elements_ACF_Result_3, ADL__VSset_elements_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSset_elements_assertionReport->value = VSset_elements_ACF_Result_3;
  ADL__VSset_elements_assertionReport->parent->openReport(ADL__VSset_elements_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_elements_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSset_elements_assertionReport->emitTest(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_InfoArray[forLoopIdx_1])) {
     ADL__VSset_elements_assertionReport->exprStart(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_InfoArray[forLoopIdx_1]);
      if(!ADL__VSset_elements_InfoArray[forLoopIdx_1].testable || !ADL__VSset_elements_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSset_elements_assertionReport->emitter);
      else if (ADL__VSset_elements_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSset_elements_InfoArray[forLoopIdx_1].error, ADL__VSset_elements_assertionReport->emitter);
      else
        ADL__VSset_elements_InfoArray[forLoopIdx_1].emitFunc(ADL__VSset_elements_InfoArray[forLoopIdx_1].value, ADL__VSset_elements_assertionReport->emitter);
     ADL__VSset_elements_assertionReport->exprEnd(ADL__VSset_elements_assertionReport, &ADL__VSset_elements_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSset_elements_RtnVal_4);
}


VSBoolean (*ADL__VSset_elements_wrapper)(VSDynArray_ptr*, VSAnySeq_ptr, VSEnvironment*) = VSset_elements;

void ADL__emit_VSDynArray_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSAnySeq_ptr (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSBoolean (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSset_elements_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "(!valid_type_any_seq(darray, aseq) && valid_value_any_seq(darray, aseq)) --> DAny_user_exception_is(\"TypeMismatch\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "!valid_type_any_seq(darray, aseq) && valid_value_any_seq(darray, aseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "!valid_type_any_seq(darray, aseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "valid_type_any_seq(darray, aseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "darray", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynArray_ptr_P },
  {2, 19, 17, 0, 0, "aseq", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSAnySeq_ptr },
  {2, 20, 15, 0, 0, "valid_value_any_seq(darray, aseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "darray", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynArray_ptr_P },
  {2, 22, 20, 0, 0, "aseq", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSAnySeq_ptr },
  {2, 23, 14, 0, 0, "DAny_user_exception_is(\"TypeMismatch\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 24, 23, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 25, 25, 0, 0, "!valid_value_any_seq(darray, aseq) --> DAny_user_exception_is(\"InvalidValue\", ev)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 26, 25, 0, 0, "!valid_value_any_seq(darray, aseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 27, 26, 0, 0, "valid_value_any_seq(darray, aseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 28, 27, 0, 0, "darray", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynArray_ptr_P },
  {3, 29, 27, 0, 0, "aseq", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSAnySeq_ptr },
  {3, 30, 25, 0, 0, "DAny_user_exception_is(\"InvalidValue\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 31, 30, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 32, 32, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 33, 32, 0, 0, "return == 1", 33, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 34, 33, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean }
};


unsigned int ADL__VSset_elements_InfoArrayIdx = 35;

struct ADL__reportAssertion *ADL__VSset_elements_assertionReport = 0;

/*
 *
 * ACF of VSget_elements
 *
 */
VSAnySeq_ptr ADL__ACF_VSget_elements (VSDynArray_ptr *darray_90, VSEnvironment *ev_79){

VSAnySeq_ptr VSget_elements_RtnVal_73;
  void *dummyVarName_176;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_91;
  int tmp_93;
  int tmp_94;
  VSEnvironment *ev_79_tmp_98;
    int tmp_99;
  int tmp_100;
  int groupExpr_106;
  int tmp_101;
  VSDynArray_ptr *darray_90_tmp_104;

/* Declare vars for result of normal and exception bindings */
  int VSget_elements_NormalOutcome_74, VSget_elements_ExceptionOutcome_75;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_76;
  VSEnvironment *ev_79_tmp_80;
    int tmp_81;
  int tmp_82;
  VSEnvironment *ev_79_tmp_85;
  int tmp_86;
  VSEnvironment *ev_79_tmp_89;
  enum ADL__ACF_result VSget_elements_ACF_Result_72 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSget_elements_InfoArray, 0, ADL__VSget_elements_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSget_elements_assertionReport->setPhase(ADL__VSget_elements_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_elements_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSget_elements_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSget_elements_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSget_elements_InfoArray[forLoopIdx_1].error > VSget_elements_ACF_Result_72))
  VSget_elements_ACF_Result_72 = ADL__VSget_elements_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSget_elements_ACF_Result_72 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSget_elements_assertionReport->setPhase(ADL__VSget_elements_assertionReport, PH_call);
  ADL__release(ADL__VSget_elements_assertionReport->parent, &this_seq);
  VSget_elements_RtnVal_73 = ADL__VSget_elements_wrapper(darray_90, ev_79);
  ADL__recover(ADL__VSget_elements_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSget_elements_assertionReport->setPhase(ADL__VSget_elements_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_79_tmp_80 = ev_79;
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 8,&ev_79_tmp_80);
  ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_76 = no_exception(ev_79);
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 7,&tmp_76);
  VSget_elements_NormalOutcome_74 = (tmp_76);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_79_tmp_85 = ev_79;
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 3,&ev_79_tmp_85);
  ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_82 = system_exception(ev_79);
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 2,&tmp_82);
  ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_81 = tmp_82;
  if (!tmp_82) {
      ev_79_tmp_89 = ev_79;
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 5,&ev_79_tmp_89);
  ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_86 = user_exception(ev_79);
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 4,&tmp_86);
    tmp_81 = tmp_86;
  }
  else {
  ADL__resetInfoStruct(ADL__VSget_elements_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 1,&tmp_81);

  VSget_elements_ExceptionOutcome_75 = (tmp_81);

/* Exception binding is the first assertion */
  if (ADL__VSget_elements_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSget_elements_InfoArray[0].result = (VSget_elements_ExceptionOutcome_75 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_elements_InfoArray[0].evaluated = 1;
  ADL__VSget_elements_InfoArray[0].value = (VSget_elements_ExceptionOutcome_75 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSget_elements_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSget_elements_InfoArray[6].result = (VSget_elements_NormalOutcome_74 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_elements_InfoArray[6].evaluated = 1;
  ADL__VSget_elements_InfoArray[6].value = (VSget_elements_NormalOutcome_74 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSget_elements_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSget_elements_ACF_Result_72 = ADL__VSget_elements_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSget_elements_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSget_elements_ACF_Result_72 = ADL__VSget_elements_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSget_elements_ExceptionOutcome_75 && !VSget_elements_NormalOutcome_74) {
  VSget_elements_ACF_Result_72 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSget_elements_ExceptionOutcome_75 && VSget_elements_NormalOutcome_74) {
  VSget_elements_ACF_Result_72 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSget_elements_InfoArray, 10,&VSget_elements_ExceptionOutcome_75);
  ev_79_tmp_98 = ev_79;
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 13,&ev_79_tmp_98);
  ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_94 = user_exception_is("NOT_IMPLEMENTED", ev_79);
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 12,&tmp_94);
  ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_93 = !tmp_94;
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 11,&tmp_93);
  ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_91 = (!VSget_elements_ExceptionOutcome_75 || tmp_93);
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 9,&tmp_91);
    ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSget_elements_NormalOutcome_74){
      darray_90_tmp_104 = darray_90;
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 16,&darray_90_tmp_104);
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 17,&VSget_elements_RtnVal_73);
  ADL__VSget_elements_assertionReport->exprMark(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_assertionReport->assrt_info[15]);

/* Evaluate is_correct_anyseq(darray, return) */
  tmp_101 = is_correct_anyseq(darray_90, VSget_elements_RtnVal_73);
  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 15,&tmp_101);
  groupExpr_106 = (tmp_101);
  tmp_100 = (groupExpr_106);
  tmp_99 = tmp_100;
  }
  else {
    ADL__resetInfoStruct(ADL__VSget_elements_InfoArray, 14, 17);
  tmp_99 = 1;
}

  ADL__setResultAndError(ADL__VSget_elements_InfoArray, 14,&tmp_99);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_elements_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSget_elements_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSget_elements_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSget_elements_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSget_elements_InfoArray[forLoopIdx_1].level == 0))
        VSget_elements_ACF_Result_72 = calculate_ACF_result(VSget_elements_ACF_Result_72, ADL__VSget_elements_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSget_elements_assertionReport->value = VSget_elements_ACF_Result_72;
  ADL__VSget_elements_assertionReport->parent->openReport(ADL__VSget_elements_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_elements_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSget_elements_assertionReport->emitTest(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_InfoArray[forLoopIdx_1])) {
     ADL__VSget_elements_assertionReport->exprStart(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_InfoArray[forLoopIdx_1]);
      if(!ADL__VSget_elements_InfoArray[forLoopIdx_1].testable || !ADL__VSget_elements_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSget_elements_assertionReport->emitter);
      else if (ADL__VSget_elements_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSget_elements_InfoArray[forLoopIdx_1].error, ADL__VSget_elements_assertionReport->emitter);
      else
        ADL__VSget_elements_InfoArray[forLoopIdx_1].emitFunc(ADL__VSget_elements_InfoArray[forLoopIdx_1].value, ADL__VSget_elements_assertionReport->emitter);
     ADL__VSget_elements_assertionReport->exprEnd(ADL__VSget_elements_assertionReport, &ADL__VSget_elements_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSget_elements_RtnVal_73);
}


VSAnySeq_ptr (*ADL__VSget_elements_wrapper)(VSDynArray_ptr*, VSEnvironment*) = VSget_elements;

void ADL__emit_VSDynArray_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSAnySeq_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSget_elements_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "is_correct_anyseq(darray, return)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "darray", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynArray_ptr_P },
  {3, 17, 15, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSAnySeq_ptr }
};


unsigned int ADL__VSget_elements_InfoArrayIdx = 18;

struct ADL__reportAssertion *ADL__VSget_elements_assertionReport = 0;

/*
 *
 * ACF of VSset_elements_as_dyn_any
 *
 */
VSBoolean ADL__ACF_VSset_elements_as_dyn_any (VSDynArray_ptr *darray_126, VSDynAnySeq_ptr dseq_127, VSEnvironment *ev_115){

VSBoolean VSset_elements_as_dyn_any_RtnVal_109;
  void *dummyVarName_176;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_128;
  int tmp_130;
  int tmp_131;
  VSEnvironment *ev_115_tmp_135;
    int tmp_136;
  int tmp_138;
  int tmp_139;
  int tmp_140;
  VSDynArray_ptr *darray_126_tmp_143;
  VSDynAnySeq_ptr dseq_127_tmp_145;
  int tmp_146;
  VSDynArray_ptr *darray_126_tmp_149;
  VSDynAnySeq_ptr dseq_127_tmp_151;
  int tmp_152;
  VSEnvironment *ev_115_tmp_156;
    int tmp_157;
  int tmp_158;
  int tmp_159;
  VSDynArray_ptr *darray_126_tmp_162;
  VSDynAnySeq_ptr dseq_127_tmp_164;
  int tmp_165;
  VSEnvironment *ev_115_tmp_169;
    int tmp_170;
  int tmp_171;
  int groupExpr_175;
  int tmp_172;

/* Declare vars for result of normal and exception bindings */
  int VSset_elements_as_dyn_any_NormalOutcome_110, VSset_elements_as_dyn_any_ExceptionOutcome_111;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_112;
  VSEnvironment *ev_115_tmp_116;
    int tmp_117;
  int tmp_118;
  VSEnvironment *ev_115_tmp_121;
  int tmp_122;
  VSEnvironment *ev_115_tmp_125;
  enum ADL__ACF_result VSset_elements_as_dyn_any_ACF_Result_108 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSset_elements_as_dyn_any_InfoArray, 0, ADL__VSset_elements_as_dyn_any_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSset_elements_as_dyn_any_assertionReport->setPhase(ADL__VSset_elements_as_dyn_any_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_elements_as_dyn_any_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].error > VSset_elements_as_dyn_any_ACF_Result_108))
  VSset_elements_as_dyn_any_ACF_Result_108 = ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSset_elements_as_dyn_any_ACF_Result_108 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSset_elements_as_dyn_any_assertionReport->setPhase(ADL__VSset_elements_as_dyn_any_assertionReport, PH_call);
  ADL__release(ADL__VSset_elements_as_dyn_any_assertionReport->parent, &this_seq);
  VSset_elements_as_dyn_any_RtnVal_109 = ADL__VSset_elements_as_dyn_any_wrapper(darray_126, dseq_127, ev_115);
  ADL__recover(ADL__VSset_elements_as_dyn_any_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSset_elements_as_dyn_any_assertionReport->setPhase(ADL__VSset_elements_as_dyn_any_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_115_tmp_116 = ev_115;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 8,&ev_115_tmp_116);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_112 = no_exception(ev_115);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 7,&tmp_112);
  VSset_elements_as_dyn_any_NormalOutcome_110 = (tmp_112);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_115_tmp_121 = ev_115;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 3,&ev_115_tmp_121);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_118 = system_exception(ev_115);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 2,&tmp_118);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_117 = tmp_118;
  if (!tmp_118) {
      ev_115_tmp_125 = ev_115;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 5,&ev_115_tmp_125);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_122 = user_exception(ev_115);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 4,&tmp_122);
    tmp_117 = tmp_122;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_elements_as_dyn_any_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 1,&tmp_117);

  VSset_elements_as_dyn_any_ExceptionOutcome_111 = (tmp_117);

/* Exception binding is the first assertion */
  if (ADL__VSset_elements_as_dyn_any_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSset_elements_as_dyn_any_InfoArray[0].result = (VSset_elements_as_dyn_any_ExceptionOutcome_111 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_elements_as_dyn_any_InfoArray[0].evaluated = 1;
  ADL__VSset_elements_as_dyn_any_InfoArray[0].value = (VSset_elements_as_dyn_any_ExceptionOutcome_111 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSset_elements_as_dyn_any_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSset_elements_as_dyn_any_InfoArray[6].result = (VSset_elements_as_dyn_any_NormalOutcome_110 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_elements_as_dyn_any_InfoArray[6].evaluated = 1;
  ADL__VSset_elements_as_dyn_any_InfoArray[6].value = (VSset_elements_as_dyn_any_NormalOutcome_110 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSset_elements_as_dyn_any_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSset_elements_as_dyn_any_ACF_Result_108 = ADL__VSset_elements_as_dyn_any_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSset_elements_as_dyn_any_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSset_elements_as_dyn_any_ACF_Result_108 = ADL__VSset_elements_as_dyn_any_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSset_elements_as_dyn_any_ExceptionOutcome_111 && !VSset_elements_as_dyn_any_NormalOutcome_110) {
  VSset_elements_as_dyn_any_ACF_Result_108 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSset_elements_as_dyn_any_ExceptionOutcome_111 && VSset_elements_as_dyn_any_NormalOutcome_110) {
  VSset_elements_as_dyn_any_ACF_Result_108 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 10,&VSset_elements_as_dyn_any_ExceptionOutcome_111);
  ev_115_tmp_135 = ev_115;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 13,&ev_115_tmp_135);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_131 = user_exception_is("NOT_IMPLEMENTED", ev_115);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 12,&tmp_131);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_130 = !tmp_131;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 11,&tmp_130);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_128 = (!VSset_elements_as_dyn_any_ExceptionOutcome_111 || tmp_130);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 9,&tmp_128);
    darray_126_tmp_143 = darray_126;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 18,&darray_126_tmp_143);
  dseq_127_tmp_145 = dseq_127;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 19,&dseq_127_tmp_145);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[17]);

/* Evaluate valid_type_dynany_seq(darray, dseq) */
  tmp_140 = valid_type_dynany_seq(darray_126, dseq_127);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 17,&tmp_140);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[16]);

/* Evaluate !valid_type_dynany_seq(darray, dseq) */
  tmp_139 = !tmp_140;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 16,&tmp_139);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[15]);

/* Evaluate !valid_type_dynany_seq(darray, dseq) && valid_value_dynany_seq(darray, dseq) */
  tmp_138 = tmp_139;
  if (tmp_139) {
      darray_126_tmp_149 = darray_126;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 21,&darray_126_tmp_149);
  dseq_127_tmp_151 = dseq_127;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 22,&dseq_127_tmp_151);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[20]);

/* Evaluate valid_value_dynany_seq(darray, dseq) */
  tmp_146 = valid_value_dynany_seq(darray_126, dseq_127);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 20,&tmp_146);
    tmp_138 = tmp_146;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_elements_as_dyn_any_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 15,&tmp_138);
  ev_115_tmp_156 = ev_115;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 24,&ev_115_tmp_156);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[23]);

/* Evaluate DAny_user_exception_is("TypeMismatch", ev) */
  tmp_152 = DAny_user_exception_is("TypeMismatch", ev_115);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 23,&tmp_152);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[14]);

/* Evaluate (!valid_type_dynany_seq(darray, dseq) && valid_value_dynany_seq(darray, dseq)) --> DAny_user_exception_is("TypeMismatch", ev) */
  tmp_136 = (!tmp_138 || tmp_152);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 14,&tmp_136);
    darray_126_tmp_162 = darray_126;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 28,&darray_126_tmp_162);
  dseq_127_tmp_164 = dseq_127;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 29,&dseq_127_tmp_164);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[27]);

/* Evaluate valid_value_dynany_seq(darray, dseq) */
  tmp_159 = valid_value_dynany_seq(darray_126, dseq_127);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 27,&tmp_159);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[26]);

/* Evaluate !valid_value_dynany_seq(darray, dseq) */
  tmp_158 = !tmp_159;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 26,&tmp_158);
  ev_115_tmp_169 = ev_115;
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 31,&ev_115_tmp_169);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[30]);

/* Evaluate DAny_user_exception_is("InvalidValue", ev) */
  tmp_165 = DAny_user_exception_is("InvalidValue", ev_115);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 30,&tmp_165);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[25]);

/* Evaluate !valid_value_dynany_seq(darray, dseq) --> DAny_user_exception_is("InvalidValue", ev) */
  tmp_157 = (!tmp_158 || tmp_165);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 25,&tmp_157);
    ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[32]);

/* Evaluate normally { ... } */
  if(VSset_elements_as_dyn_any_NormalOutcome_110){
      ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 34,&VSset_elements_as_dyn_any_RtnVal_109);
  ADL__VSset_elements_as_dyn_any_assertionReport->exprMark(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_assertionReport->assrt_info[33]);

/* Evaluate return == 1 */
  tmp_172 = (VSset_elements_as_dyn_any_RtnVal_109 == 1);
  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 33,&tmp_172);
  groupExpr_175 = (tmp_172);
  tmp_171 = (groupExpr_175);
  tmp_170 = tmp_171;
  }
  else {
    ADL__resetInfoStruct(ADL__VSset_elements_as_dyn_any_InfoArray, 32, 34);
  tmp_170 = 1;
}

  ADL__setResultAndError(ADL__VSset_elements_as_dyn_any_InfoArray, 32,&tmp_170);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_elements_as_dyn_any_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].level == 0))
        VSset_elements_as_dyn_any_ACF_Result_108 = calculate_ACF_result(VSset_elements_as_dyn_any_ACF_Result_108, ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSset_elements_as_dyn_any_assertionReport->value = VSset_elements_as_dyn_any_ACF_Result_108;
  ADL__VSset_elements_as_dyn_any_assertionReport->parent->openReport(ADL__VSset_elements_as_dyn_any_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_elements_as_dyn_any_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSset_elements_as_dyn_any_assertionReport->emitTest(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1])) {
     ADL__VSset_elements_as_dyn_any_assertionReport->exprStart(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1]);
      if(!ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].testable || !ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSset_elements_as_dyn_any_assertionReport->emitter);
      else if (ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].error, ADL__VSset_elements_as_dyn_any_assertionReport->emitter);
      else
        ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].emitFunc(ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1].value, ADL__VSset_elements_as_dyn_any_assertionReport->emitter);
     ADL__VSset_elements_as_dyn_any_assertionReport->exprEnd(ADL__VSset_elements_as_dyn_any_assertionReport, &ADL__VSset_elements_as_dyn_any_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSset_elements_as_dyn_any_RtnVal_109);
}


VSBoolean (*ADL__VSset_elements_as_dyn_any_wrapper)(VSDynArray_ptr*, VSDynAnySeq_ptr, VSEnvironment*) = VSset_elements_as_dyn_any;

void ADL__emit_VSDynArray_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSDynAnySeq_ptr (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSBoolean (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSset_elements_as_dyn_any_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "(!valid_type_dynany_seq(darray, dseq) && valid_value_dynany_seq(darray, dseq)) --> DAny_user_exception_is(\"TypeMismatch\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "!valid_type_dynany_seq(darray, dseq) && valid_value_dynany_seq(darray, dseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "!valid_type_dynany_seq(darray, dseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "valid_type_dynany_seq(darray, dseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "darray", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynArray_ptr_P },
  {2, 19, 17, 0, 0, "dseq", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynAnySeq_ptr },
  {2, 20, 15, 0, 0, "valid_value_dynany_seq(darray, dseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "darray", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynArray_ptr_P },
  {2, 22, 20, 0, 0, "dseq", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynAnySeq_ptr },
  {2, 23, 14, 0, 0, "DAny_user_exception_is(\"TypeMismatch\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 24, 23, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 25, 25, 0, 0, "!valid_value_dynany_seq(darray, dseq) --> DAny_user_exception_is(\"InvalidValue\", ev)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 26, 25, 0, 0, "!valid_value_dynany_seq(darray, dseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 27, 26, 0, 0, "valid_value_dynany_seq(darray, dseq)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 28, 27, 0, 0, "darray", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynArray_ptr_P },
  {3, 29, 27, 0, 0, "dseq", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynAnySeq_ptr },
  {3, 30, 25, 0, 0, "DAny_user_exception_is(\"InvalidValue\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 31, 30, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 32, 32, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 33, 32, 0, 0, "return == 1", 33, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 34, 33, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean }
};


unsigned int ADL__VSset_elements_as_dyn_any_InfoArrayIdx = 35;

struct ADL__reportAssertion *ADL__VSset_elements_as_dyn_any_assertionReport = 0;

/*
 *
 * ACF of VSget_elements_as_dyn_any
 *
 */
VSDynAnySeq_ptr ADL__ACF_VSget_elements_as_dyn_any (VSDynArray_ptr *darray_195, VSEnvironment *ev_184){

VSDynAnySeq_ptr VSget_elements_as_dyn_any_RtnVal_178;
  void *dummyVarName_176;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_196;
  int tmp_198;
  int tmp_199;
  VSEnvironment *ev_184_tmp_203;
    int tmp_204;
  int tmp_205;
  int groupExpr_211;
  int tmp_206;
  VSDynArray_ptr *darray_195_tmp_209;

/* Declare vars for result of normal and exception bindings */
  int VSget_elements_as_dyn_any_NormalOutcome_179, VSget_elements_as_dyn_any_ExceptionOutcome_180;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_181;
  VSEnvironment *ev_184_tmp_185;
    int tmp_186;
  int tmp_187;
  VSEnvironment *ev_184_tmp_190;
  int tmp_191;
  VSEnvironment *ev_184_tmp_194;
  enum ADL__ACF_result VSget_elements_as_dyn_any_ACF_Result_177 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSget_elements_as_dyn_any_InfoArray, 0, ADL__VSget_elements_as_dyn_any_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSget_elements_as_dyn_any_assertionReport->setPhase(ADL__VSget_elements_as_dyn_any_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_elements_as_dyn_any_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].error > VSget_elements_as_dyn_any_ACF_Result_177))
  VSget_elements_as_dyn_any_ACF_Result_177 = ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSget_elements_as_dyn_any_ACF_Result_177 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSget_elements_as_dyn_any_assertionReport->setPhase(ADL__VSget_elements_as_dyn_any_assertionReport, PH_call);
  ADL__release(ADL__VSget_elements_as_dyn_any_assertionReport->parent, &this_seq);
  VSget_elements_as_dyn_any_RtnVal_178 = ADL__VSget_elements_as_dyn_any_wrapper(darray_195, ev_184);
  ADL__recover(ADL__VSget_elements_as_dyn_any_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSget_elements_as_dyn_any_assertionReport->setPhase(ADL__VSget_elements_as_dyn_any_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_184_tmp_185 = ev_184;
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 8,&ev_184_tmp_185);
  ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_181 = no_exception(ev_184);
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 7,&tmp_181);
  VSget_elements_as_dyn_any_NormalOutcome_179 = (tmp_181);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_184_tmp_190 = ev_184;
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 3,&ev_184_tmp_190);
  ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_187 = system_exception(ev_184);
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 2,&tmp_187);
  ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_186 = tmp_187;
  if (!tmp_187) {
      ev_184_tmp_194 = ev_184;
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 5,&ev_184_tmp_194);
  ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_191 = user_exception(ev_184);
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 4,&tmp_191);
    tmp_186 = tmp_191;
  }
  else {
  ADL__resetInfoStruct(ADL__VSget_elements_as_dyn_any_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 1,&tmp_186);

  VSget_elements_as_dyn_any_ExceptionOutcome_180 = (tmp_186);

/* Exception binding is the first assertion */
  if (ADL__VSget_elements_as_dyn_any_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSget_elements_as_dyn_any_InfoArray[0].result = (VSget_elements_as_dyn_any_ExceptionOutcome_180 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_elements_as_dyn_any_InfoArray[0].evaluated = 1;
  ADL__VSget_elements_as_dyn_any_InfoArray[0].value = (VSget_elements_as_dyn_any_ExceptionOutcome_180 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSget_elements_as_dyn_any_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSget_elements_as_dyn_any_InfoArray[6].result = (VSget_elements_as_dyn_any_NormalOutcome_179 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_elements_as_dyn_any_InfoArray[6].evaluated = 1;
  ADL__VSget_elements_as_dyn_any_InfoArray[6].value = (VSget_elements_as_dyn_any_NormalOutcome_179 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSget_elements_as_dyn_any_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSget_elements_as_dyn_any_ACF_Result_177 = ADL__VSget_elements_as_dyn_any_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSget_elements_as_dyn_any_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSget_elements_as_dyn_any_ACF_Result_177 = ADL__VSget_elements_as_dyn_any_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSget_elements_as_dyn_any_ExceptionOutcome_180 && !VSget_elements_as_dyn_any_NormalOutcome_179) {
  VSget_elements_as_dyn_any_ACF_Result_177 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSget_elements_as_dyn_any_ExceptionOutcome_180 && VSget_elements_as_dyn_any_NormalOutcome_179) {
  VSget_elements_as_dyn_any_ACF_Result_177 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 10,&VSget_elements_as_dyn_any_ExceptionOutcome_180);
  ev_184_tmp_203 = ev_184;
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 13,&ev_184_tmp_203);
  ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_199 = user_exception_is("NOT_IMPLEMENTED", ev_184);
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 12,&tmp_199);
  ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_198 = !tmp_199;
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 11,&tmp_198);
  ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_196 = (!VSget_elements_as_dyn_any_ExceptionOutcome_180 || tmp_198);
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 9,&tmp_196);
    ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSget_elements_as_dyn_any_NormalOutcome_179){
      darray_195_tmp_209 = darray_195;
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 16,&darray_195_tmp_209);
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 17,&VSget_elements_as_dyn_any_RtnVal_178);
  ADL__VSget_elements_as_dyn_any_assertionReport->exprMark(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_assertionReport->assrt_info[15]);

/* Evaluate is_correct_DynAnySeq(darray, return) */
  tmp_206 = is_correct_DynAnySeq(darray_195, VSget_elements_as_dyn_any_RtnVal_178);
  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 15,&tmp_206);
  groupExpr_211 = (tmp_206);
  tmp_205 = (groupExpr_211);
  tmp_204 = tmp_205;
  }
  else {
    ADL__resetInfoStruct(ADL__VSget_elements_as_dyn_any_InfoArray, 14, 17);
  tmp_204 = 1;
}

  ADL__setResultAndError(ADL__VSget_elements_as_dyn_any_InfoArray, 14,&tmp_204);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_elements_as_dyn_any_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].level == 0))
        VSget_elements_as_dyn_any_ACF_Result_177 = calculate_ACF_result(VSget_elements_as_dyn_any_ACF_Result_177, ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSget_elements_as_dyn_any_assertionReport->value = VSget_elements_as_dyn_any_ACF_Result_177;
  ADL__VSget_elements_as_dyn_any_assertionReport->parent->openReport(ADL__VSget_elements_as_dyn_any_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_elements_as_dyn_any_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSget_elements_as_dyn_any_assertionReport->emitTest(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1])) {
     ADL__VSget_elements_as_dyn_any_assertionReport->exprStart(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1]);
      if(!ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].testable || !ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSget_elements_as_dyn_any_assertionReport->emitter);
      else if (ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].error, ADL__VSget_elements_as_dyn_any_assertionReport->emitter);
      else
        ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].emitFunc(ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1].value, ADL__VSget_elements_as_dyn_any_assertionReport->emitter);
     ADL__VSget_elements_as_dyn_any_assertionReport->exprEnd(ADL__VSget_elements_as_dyn_any_assertionReport, &ADL__VSget_elements_as_dyn_any_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSget_elements_as_dyn_any_RtnVal_178);
}


VSDynAnySeq_ptr (*ADL__VSget_elements_as_dyn_any_wrapper)(VSDynArray_ptr*, VSEnvironment*) = VSget_elements_as_dyn_any;

void ADL__emit_VSDynArray_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDynAnySeq_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSget_elements_as_dyn_any_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "is_correct_DynAnySeq(darray, return)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "darray", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynArray_ptr_P },
  {3, 17, 15, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynAnySeq_ptr }
};


unsigned int ADL__VSget_elements_as_dyn_any_InfoArrayIdx = 18;

struct ADL__reportAssertion *ADL__VSget_elements_as_dyn_any_assertionReport = 0;
