/* ADL test driver from t1.tdr
 *
 * test VScurrent_member_kind(dVal, position, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_348[] = {
    {"tVal", PdVal_prop_1_tVal, 0},
    {"tValempty", PdVal_prop_1_tValempty, 0},
    {0, 0, 0}
};

/* values for literal variable position */
static VSLong ADL__litvar_val_341[] = {
    0,
    -1,
};

static struct ADL__propertyValue ADL__litvar_info_340[] = {
    {"0", 0, ADL__litvar_val_341},
    {"-1", 1, ADL__litvar_val_341},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_349[] = {
    {"prop_1", "prop", ADL__prop_values_348, 2},
    {"position", "litvar", ADL__litvar_info_340, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_353[4] = {
    {"dVal", "VSDynValue_ptr *", ADL__prop_info_349, 0, 1},
    {"position", "VSLong", ADL__prop_info_349, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_349, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScurrent_member_kind_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSDYNVALUE_PTR_P
#define ADL__PRINT_VSDYNVALUE_PTR_P
void (*ADL__print_VSDynValue_ptr_P)(VSDynValue_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNVALUE_PTR_P */
#ifndef ADL__PRINT_VSLONG
#define ADL__PRINT_VSLONG
void (*ADL__print_VSLong)(VSLong, emitter_t) = 0;

#endif /* ADL__PRINT_VSLONG */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */
#ifndef ADL__PRINT_VSTCKIND
#define ADL__PRINT_VSTCKIND
void (*ADL__print_VSTCKind)(VSTCKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSTCKIND */
#ifndef ADL__PRINT_VSNAMEVALUEPAIRSEQ_PTR
#define ADL__PRINT_VSNAMEVALUEPAIRSEQ_PTR
void (*ADL__print_VSNameValuePairSeq_ptr)(VSNameValuePairSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSNAMEVALUEPAIRSEQ_PTR */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSNAMEDYNANYPAIRSEQ_PTR
#define ADL__PRINT_VSNAMEDYNANYPAIRSEQ_PTR
void (*ADL__print_VSNameDynAnyPairSeq_ptr)(VSNameDynAnyPairSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSNAMEDYNANYPAIRSEQ_PTR */

void ADL__emit_VSDynValue_ptr_P (void* val, emitter_t emitter)
{
  VSDynValue_ptr *tmp;

  if (ADL__print_VSDynValue_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSDynValue_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSLong (void* val, emitter_t emitter)
{
  VSLong tmp;

  if (ADL__print_VSLong != 0) {
    tmp = *(VSLong*) val;
    ADL__print_VSLong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSTCKind (void* val, emitter_t emitter)
{
  VSTCKind tmp;

  if (ADL__print_VSTCKind != 0) {
    tmp = *(VSTCKind*) val;
    ADL__print_VSTCKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSNameValuePairSeq_ptr (void* val, emitter_t emitter)
{
  VSNameValuePairSeq_ptr tmp;

  if (ADL__print_VSNameValuePairSeq_ptr != 0) {
    tmp = *(VSNameValuePairSeq_ptr*) val;
    ADL__print_VSNameValuePairSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSNameDynAnyPairSeq_ptr (void* val, emitter_t emitter)
{
  VSNameDynAnyPairSeq_ptr tmp;

  if (ADL__print_VSNameDynAnyPairSeq_ptr != 0) {
    tmp = *(VSNameDynAnyPairSeq_ptr*) val;
    ADL__print_VSNameDynAnyPairSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSDynValue_ptr *dVal_350;
    VSLong position_351;
    VSEnvironment *env_352;
    VSTCKind fut_return_347;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScurrent_member_kind_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScurrent_member_kind_InfoArrayIdx,
        ADL__VScurrent_member_kind_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_dVal(&dVal_350, ADL__prop_values_348[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSDynValue_ptr_P(&dVal_350, rf->variableReport->emitVariable);

       position_351 = ADL__litvar_val_341[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 1, tvec + 1, 1);
       ADL__emit_VSLong(&position_351, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_352)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_352, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScurrent_member_kind_assertionReport = rf->assertionReport;
       fut_return_347 = ADL__ACF_VScurrent_member_kind(dVal_350, position_351, env_352);
       test_value = ADL__VScurrent_member_kind_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_352);
SKIP_2:
       relvec[1] = 1;	/* relinquish succeeds for position_351 */
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_dVal(&dVal_350, ADL__prop_values_348[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_353,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScurrent_member_kind_head);

    return 0;
}


struct ADL__Directive_info VScurrent_member_kind1_info = {
    N_VARS,
    ADL__var_info_353
};

struct ADL__TDD_info ADL__test_info = {
    4,
    &ADL__VScurrent_member_kind_InfoArrayIdx,
    ADL__VScurrent_member_kind_InfoArray,
    ADL__test_driver,
    "VScurrent_member_kind",
    "VScurrent_member_kind1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScurrent_member_kind1",
    "t1_tr.rif",
    &VScurrent_member_kind1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

