/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int valid_current_position(VSLong);

extern int is_empty_value(VSDynValue_ptr *);

extern int is_correct_FieldName(VSString);

extern int is_correct_TCKind(VSTCKind);

extern int valid_type_NameValuePairSeq(VSDynValue_ptr *, VSNameValuePairSeq_ptr);

extern int valid_num_NameValuePairSeq(VSDynValue_ptr *, VSNameValuePairSeq_ptr);

extern int is_correct_NameValuePairSeq(VSDynValue_ptr *, VSNameValuePairSeq_ptr);

extern int valid_type_NameDynAnyPairSeq(VSDynValue_ptr *, VSNameDynAnyPairSeq_ptr);

extern int valid_num_NameDynAnyPairSeq(VSDynValue_ptr *, VSNameDynAnyPairSeq_ptr);

extern int is_correct_NameDynAnyPairSeq(VSDynValue_ptr *, VSNameValuePairSeq_ptr);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSDynValue_ptr_P)(VSDynValue_ptr*, emitter_t);
extern void (*ADL__print_VSLong)(VSLong, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSString)(VSString, emitter_t);
extern void (*ADL__print_VSTCKind)(VSTCKind, emitter_t);
extern void (*ADL__print_VSNameValuePairSeq_ptr)(VSNameValuePairSeq_ptr, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSNameDynAnyPairSeq_ptr)(VSNameDynAnyPairSeq_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSString (*ADL__VScurrent_member_name_wrapper)(VSDynValue_ptr*, VSLong, VSEnvironment*);
extern VSTCKind (*ADL__VScurrent_member_kind_wrapper)(VSDynValue_ptr*, VSLong, VSEnvironment*);
extern VSBoolean (*ADL__VSset_members_wrapper)(VSDynValue_ptr*, VSNameValuePairSeq_ptr, VSEnvironment*);
extern VSNameValuePairSeq_ptr (*ADL__VSget_members_wrapper)(VSDynValue_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSset_members_as_dyn_any_wrapper)(VSDynValue_ptr*, VSNameDynAnyPairSeq_ptr, VSEnvironment*);
extern VSNameDynAnyPairSeq_ptr (*ADL__VSget_members_as_dyn_any_wrapper)(VSDynValue_ptr*, VSEnvironment*);

#endif
