/* ADL test driver from t1.tdr
 *
 * test VSset_one_value(context_ptr, name, any_string, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_195[] = {
    {"valid", Pcontext_ptr_v_valid, 0},
    {"nil", Pcontext_ptr_v_nil, 0},
    {"null", Pcontext_ptr_v_null, 0},
    {"invalid", Pcontext_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_196[] = {
    {"good", Pname_v_good, 0},
    {"empty", Pname_v_empty, 0},
    {0, 0, 0}
};

/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_197[] = {
    {"valid", Pany_string_v_valid, 0},
    {"nil", Pany_string_v_nil, 0},
    {"null", Pany_string_v_null, 0},
    {"invalid", Pany_string_v_invalid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_198[] = {
    {"v", "prop", ADL__prop_values_195, 4},
    {"v", "prop", ADL__prop_values_196, 2},
    {"v", "prop", ADL__prop_values_197, 4},
    {0, 0, 0}
};
#define TVEC_SIZE 3

static struct ADL__variableInfo ADL__var_info_203[5] = {
    {"context_ptr", "VSContext_ptr *", ADL__prop_info_198, 0, 1},
    {"name", "VSIdentifier", ADL__prop_info_198, 1, 1},
    {"any_string", "VSAny *", ADL__prop_info_198, 2, 1},
    {"env", "VSEnvironment *", ADL__prop_info_198, 3, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 4


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSset_one_value_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSCONTEXT_PTR_P
#define ADL__PRINT_VSCONTEXT_PTR_P
void (*ADL__print_VSContext_ptr_P)(VSContext_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTEXT_PTR_P */
#ifndef ADL__PRINT_VSIDENTIFIER
#define ADL__PRINT_VSIDENTIFIER
void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDENTIFIER */
#ifndef ADL__PRINT_VSANY_P
#define ADL__PRINT_VSANY_P
void (*ADL__print_VSAny_P)(VSAny*, emitter_t) = 0;

#endif /* ADL__PRINT_VSANY_P */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContext_ptr_P (void* val, emitter_t emitter)
{
  VSContext_ptr *tmp;

  if (ADL__print_VSContext_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSContext_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIdentifier (void* val, emitter_t emitter)
{
  VSIdentifier tmp;

  if (ADL__print_VSIdentifier != 0) {
    tmp = *(VSIdentifier*) val;
    ADL__print_VSIdentifier(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAny_P (void* val, emitter_t emitter)
{
  VSAny *tmp;

  if (ADL__print_VSAny_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSAny_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {4, 2, 4};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSContext_ptr *context_ptr_199;
    VSIdentifier name_200;
    VSAny *any_string_201;
    VSEnvironment *env_202;
    VSStatus fut_return_194;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSset_one_value_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSset_one_value_InfoArrayIdx,
        ADL__VSset_one_value_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_context_ptr(&context_ptr_199, ADL__prop_values_195[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSContext_ptr_P(&context_ptr_199, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_name(&name_200, ADL__prop_values_196[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSIdentifier(&name_200, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_any_string(&any_string_201, ADL__prop_values_197[tvec[2]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 1);
       ADL__emit_VSAny_P(&any_string_201, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_env(&env_202)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
       ADL__emit_VSEnvironment_P(&env_202, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSset_one_value_assertionReport = rf->assertionReport;
       fut_return_194 = ADL__ACF_VSset_one_value(context_ptr_199, name_200, any_string_201, env_202);
       test_value = ADL__VSset_one_value_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_env(&env_202);
SKIP_3:
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_any_string(&any_string_201, ADL__prop_values_197[tvec[2]].propValCode);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_name(&name_200, ADL__prop_values_196[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_context_ptr(&context_ptr_199, ADL__prop_values_195[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_203,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSset_one_value_head);

    return 0;
}


struct ADL__Directive_info VSset_one_value1_info = {
    N_VARS,
    ADL__var_info_203
};

struct ADL__TDD_info ADL__test_info = {
    32,
    &ADL__VSset_one_value_InfoArrayIdx,
    ADL__VSset_one_value_InfoArray,
    ADL__test_driver,
    "VSset_one_value",
    "VSset_one_value1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSset_one_value1",
    "t1_tr.rif",
    &VSset_one_value1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

