/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_same_ctxlist_ptr(VSContextList_ptr *, VSContextList_ptr *);

extern int cleanup_ctxlist_ptr(VSContextList_ptr *);

extern int out_of_bounds_for_remove(VSContextList_ptr *, VSULong);

extern int out_of_bounds(VSContextList_ptr *, VSULong);

extern int has_been_removed(VSContextList_ptr *);

extern unsigned long count(VSContextList_ptr *);

extern int item_count_is_good(VSContextList_ptr *);

extern int count_is_good(VSContextList_ptr *);

extern int string_is_good(VSString);

extern int ctxlist_is_good(VSContextList_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSContextList_ptr_P)(VSContextList_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSString)(VSString, emitter_t);
extern void (*ADL__print_VSStatus)(VSStatus, emitter_t);

/* Declarations of wrapper of FUT */
extern VSULong (*ADL__VScount_wrapper)(VSContextList_ptr*, VSEnvironment*);
extern void (*ADL__VSadd_wrapper)(VSContextList_ptr*, VSString, VSEnvironment*);
extern void (*ADL__VSadd_consume_wrapper)(VSContextList_ptr*, VSString, VSEnvironment*);
extern VSString (*ADL__VSitem_wrapper)(VSContextList_ptr*, VSULong, VSEnvironment*);
extern VSStatus (*ADL__VSremove_wrapper)(VSContextList_ptr*, VSULong, VSEnvironment*);
extern VSContextList_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSContextList_ptr *(*ADL__VSduplicate_wrapper)(VSContextList_ptr*, VSEnvironment*);

#endif
