/* ADL test driver from t1.tdr
 *
 * test VSitem(exlist_ptr, index, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_433[] = {
    {"valid", Pexlist_ptr_v_valid, 0},
    {"valid1", Pexlist_ptr_v_valid1, 0},
    {"nil", Pexlist_ptr_v_nil, 0},
    {"null", Pexlist_ptr_v_null, 0},
    {"invalid", Pexlist_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for literal variable index */
static VSULong ADL__litvar_val_435[] = {
    0,
    1,
    2,
    99,
};

static struct ADL__propertyValue ADL__litvar_info_434[] = {
    {"0", 0, ADL__litvar_val_435},
    {"1", 1, ADL__litvar_val_435},
    {"2", 2, ADL__litvar_val_435},
    {"99", 3, ADL__litvar_val_435},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_436[] = {
    {"v", "prop", ADL__prop_values_433, 5},
    {"index", "litvar", ADL__litvar_info_434, 4},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_440[4] = {
    {"exlist_ptr", "VSExceptionList_ptr *", ADL__prop_info_436, 0, 1},
    {"index", "VSULong", ADL__prop_info_436, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_436, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSitem_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSEXCEPTIONLIST_PTR_P
#define ADL__PRINT_VSEXCEPTIONLIST_PTR_P
void (*ADL__print_VSExceptionList_ptr_P)(VSExceptionList_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSEXCEPTIONLIST_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSTYPECODE_PTR_P
#define ADL__PRINT_VSTYPECODE_PTR_P
void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR_P */
#ifndef ADL__PRINT_VSSTATUS
#define ADL__PRINT_VSSTATUS
void (*ADL__print_VSStatus)(VSStatus, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTATUS */

void ADL__emit_VSExceptionList_ptr_P (void* val, emitter_t emitter)
{
  VSExceptionList_ptr *tmp;

  if (ADL__print_VSExceptionList_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSExceptionList_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter)
{
  VSTypeCode_ptr *tmp;

  if (ADL__print_VSTypeCode_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSTypeCode_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSStatus (void* val, emitter_t emitter)
{
  VSStatus tmp;

  if (ADL__print_VSStatus != 0) {
    tmp = *(VSStatus*) val;
    ADL__print_VSStatus(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {5, 4};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSExceptionList_ptr *exlist_ptr_437;
    VSULong index_438;
    VSEnvironment *env_439;
    VSTypeCode_ptr *fut_return_432;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSitem_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSitem_InfoArrayIdx,
        ADL__VSitem_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_exlist_ptr(&exlist_ptr_437, ADL__prop_values_433[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSExceptionList_ptr_P(&exlist_ptr_437, rf->variableReport->emitVariable);

       index_438 = ADL__litvar_val_435[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 1, tvec + 1, 1);
       ADL__emit_VSULong(&index_438, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_439)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_439, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSitem_assertionReport = rf->assertionReport;
       fut_return_432 = ADL__ACF_VSitem(exlist_ptr_437, index_438, env_439);
       test_value = ADL__VSitem_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_439);
SKIP_2:
       relvec[1] = 1;	/* relinquish succeeds for index_438 */
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_exlist_ptr(&exlist_ptr_437, ADL__prop_values_433[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_440,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSitem_head);

    return 0;
}


struct ADL__Directive_info VSitem1_info = {
    N_VARS,
    ADL__var_info_440
};

struct ADL__TDD_info ADL__test_info = {
    20,
    &ADL__VSitem_InfoArrayIdx,
    ADL__VSitem_InfoArray,
    ADL__test_driver,
    "VSitem",
    "VSitem1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSitem1",
    "t1_tr.rif",
    &VSitem1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

