/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_same_exlist_ptr(VSExceptionList_ptr *, VSExceptionList_ptr *);

extern int cleanup_exlist_ptr(VSExceptionList_ptr *);

extern int out_of_bounds(VSExceptionList_ptr *, VSULong);

extern int out_of_bounds_for_remove(VSExceptionList_ptr *, VSULong);

extern int has_been_removed(VSExceptionList_ptr *);

extern unsigned long count(VSExceptionList_ptr *);

extern int item_count_is_good(VSExceptionList_ptr *);

extern int count_is_good(VSExceptionList_ptr *);

extern int typecode_is_good(VSTypeCode_ptr *);

extern int exlist_is_good(VSExceptionList_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSExceptionList_ptr_P)(VSExceptionList_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSStatus)(VSStatus, emitter_t);

/* Declarations of wrapper of FUT */
extern VSULong (*ADL__VScount_wrapper)(VSExceptionList_ptr*, VSEnvironment*);
extern void (*ADL__VSadd_wrapper)(VSExceptionList_ptr*, VSTypeCode_ptr*, VSEnvironment*);
extern void (*ADL__VSadd_consume_wrapper)(VSExceptionList_ptr*, VSTypeCode_ptr*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VSitem_wrapper)(VSExceptionList_ptr*, VSULong, VSEnvironment*);
extern VSStatus (*ADL__VSremove_wrapper)(VSExceptionList_ptr*, VSULong, VSEnvironment*);
extern VSExceptionList_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSExceptionList_ptr *(*ADL__VSduplicate_wrapper)(VSExceptionList_ptr*, VSEnvironment*);

#endif
