/* ADL test driver from t1.tdr
 *
 * test VSadd_item(nvlist_ptr, lname, flags_ptr, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_546[] = {
    {"valid", Pnvlist_ptr_v_valid, 0},
    {"valid1", Pnvlist_ptr_v_valid1, 0},
    {"nil", Pnvlist_ptr_v_nil, 0},
    {"null", Pnvlist_ptr_v_null, 0},
    {"invalid", Pnvlist_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_547[] = {
    {"valid", Plname_v_valid, 0},
    {"nil", Plname_v_nil, 0},
    {0, 0, 0}
};

/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_548[] = {
    {"in", Pflags_ptr_v_in, 0},
    {"out", Pflags_ptr_v_out, 0},
    {"inout", Pflags_ptr_v_inout, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_549[] = {
    {"v", "prop", ADL__prop_values_546, 5},
    {"v", "prop", ADL__prop_values_547, 2},
    {"v", "prop", ADL__prop_values_548, 3},
    {0, 0, 0}
};
#define TVEC_SIZE 3

static struct ADL__variableInfo ADL__var_info_554[5] = {
    {"nvlist_ptr", "VSNVList_ptr *", ADL__prop_info_549, 0, 1},
    {"lname", "VSString", ADL__prop_info_549, 1, 1},
    {"flags_ptr", "VSFlags *", ADL__prop_info_549, 2, 1},
    {"env", "VSEnvironment *", ADL__prop_info_549, 3, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 4


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSadd_item_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSNVLIST_PTR_P
#define ADL__PRINT_VSNVLIST_PTR_P
void (*ADL__print_VSNVList_ptr_P)(VSNVList_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSNVLIST_PTR_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSFLAGS_P
#define ADL__PRINT_VSFLAGS_P
void (*ADL__print_VSFlags_P)(VSFlags*, emitter_t) = 0;

#endif /* ADL__PRINT_VSFLAGS_P */
#ifndef ADL__PRINT_VSNAMEDVALUE_PTR_P
#define ADL__PRINT_VSNAMEDVALUE_PTR_P
void (*ADL__print_VSNamedValue_ptr_P)(VSNamedValue_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSNAMEDVALUE_PTR_P */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */
#ifndef ADL__PRINT_VSSTATUS
#define ADL__PRINT_VSSTATUS
void (*ADL__print_VSStatus)(VSStatus, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTATUS */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter)
{
  VSNVList_ptr *tmp;

  if (ADL__print_VSNVList_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSNVList_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSFlags_P (void* val, emitter_t emitter)
{
  VSFlags *tmp;

  if (ADL__print_VSFlags_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSFlags_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t emitter)
{
  VSNamedValue_ptr *tmp;

  if (ADL__print_VSNamedValue_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSNamedValue_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSStatus (void* val, emitter_t emitter)
{
  VSStatus tmp;

  if (ADL__print_VSStatus != 0) {
    tmp = *(VSStatus*) val;
    ADL__print_VSStatus(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {5, 2, 3};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSNVList_ptr *nvlist_ptr_550;
    VSString lname_551;
    VSFlags *flags_ptr_552;
    VSEnvironment *env_553;
    VSNamedValue_ptr *fut_return_545;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSadd_item_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSadd_item_InfoArrayIdx,
        ADL__VSadd_item_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_nvlist_ptr(&nvlist_ptr_550, ADL__prop_values_546[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSNVList_ptr_P(&nvlist_ptr_550, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_lname(&lname_551, ADL__prop_values_547[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSString(&lname_551, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_flags_ptr(&flags_ptr_552, ADL__prop_values_548[tvec[2]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 1);
       ADL__emit_VSFlags_P(&flags_ptr_552, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_env(&env_553)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
       ADL__emit_VSEnvironment_P(&env_553, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSadd_item_assertionReport = rf->assertionReport;
       fut_return_545 = ADL__ACF_VSadd_item(nvlist_ptr_550, lname_551, flags_ptr_552, env_553);
       test_value = ADL__VSadd_item_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_env(&env_553);
SKIP_3:
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_flags_ptr(&flags_ptr_552, ADL__prop_values_548[tvec[2]].propValCode);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_lname(&lname_551, ADL__prop_values_547[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_nvlist_ptr(&nvlist_ptr_550, ADL__prop_values_546[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_554,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSadd_item_head);

    return 0;
}


struct ADL__Directive_info VSadd_item1_info = {
    N_VARS,
    ADL__var_info_554
};

struct ADL__TDD_info ADL__test_info = {
    30,
    &ADL__VSadd_item_InfoArrayIdx,
    ADL__VSadd_item_InfoArray,
    ADL__test_driver,
    "VSadd_item",
    "VSadd_item1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSadd_item1",
    "t1_tr.rif",
    &VSadd_item1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

