/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSnil
 *
 */
VSNVList_ptr *ADL__ACF_VSnil (VSEnvironment *ev_10){

VSNVList_ptr *VSnil_RtnVal_4;
  void *dummyVarName_432;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_22;
  int tmp_24;
  int tmp_25;
  VSEnvironment *ev_10_tmp_29;
    int tmp_30;
  int tmp_32;
  int tmp_33;
  int tmp_34;
  VSEnvironment *ev_10_tmp_37;
  int tmp_38;
  int tmp_39;
  VSEnvironment *ev_10_tmp_42;
    int tmp_43;
  int tmp_44;
  int groupExpr_53;
  int tmp_46;
  int tmp_47;
  int tmp_50;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_5, VSnil_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSnil_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_3))
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_4 = ADL__VSnil_wrapper(ev_10);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_7);
  VSnil_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_13);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_12);

  VSnil_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_6 && !VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_6 && VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_29 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_10_tmp_29);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_25);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = !tmp_25;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_24);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_22 = (!VSnil_ExceptionOutcome_6 || tmp_24);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_22);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_37 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_10_tmp_37);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_34 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_34);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_33 = !tmp_34;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_33);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_32 = tmp_33;
  if (tmp_33) {
      ev_10_tmp_42 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_10_tmp_42);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_39 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_39);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_38 = !tmp_39;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_38);
    tmp_32 = tmp_38;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_32);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_30 = (!VSnil_ExceptionOutcome_6 || tmp_32);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_30);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_nvlist_ptr(return) */
  tmp_47 = is_nil_nvlist_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_47);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_nvlist_ptr(return) && cleanup_nvlist_ptr(return) */
  tmp_46 = tmp_47;
  if (tmp_47) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_nvlist_ptr(return) */
  tmp_50 = cleanup_nvlist_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_50);
    tmp_46 = tmp_50;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_46);
  groupExpr_53 = (tmp_46);
  tmp_44 = (groupExpr_53);
  tmp_43 = tmp_44;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_43 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_43);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_3 = calculate_ACF_result(VSnil_ACF_Result_3, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_3;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_4);
}


VSNVList_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_nvlist_ptr(return) && cleanup_nvlist_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_nvlist_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_nvlist_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSNVList_ptr *ADL__ACF_VSduplicate (VSNVList_ptr *o_73, VSEnvironment *ev_62){

VSNVList_ptr *VSduplicate_RtnVal_56;
  void *dummyVarName_432;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_75;
  int tmp_77;
  int tmp_78;
  VSEnvironment *ev_62_tmp_82;
    int tmp_83;
  int tmp_85;
  int tmp_86;
  VSEnvironment *ev_62_tmp_89;
    int tmp_90;
  int tmp_91;
  int groupExpr_102;
  int tmp_93;
  int tmp_94;
  VSNVList_ptr *o_73_tmp_98;
  int tmp_99;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_57, VSduplicate_ExceptionOutcome_58;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_59;
  VSEnvironment *ev_62_tmp_63;
    int tmp_64;
  int tmp_65;
  VSEnvironment *ev_62_tmp_68;
  int tmp_69;
  VSEnvironment *ev_62_tmp_72;
  enum ADL__ACF_result VSduplicate_ACF_Result_55 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_55))
  VSduplicate_ACF_Result_55 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_55 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_56 = ADL__VSduplicate_wrapper(o_73, ev_62);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_62_tmp_63 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_62_tmp_63);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_59 = no_exception(ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_59);
  VSduplicate_NormalOutcome_57 = (tmp_59);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_62_tmp_68 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_62_tmp_68);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_65 = system_exception(ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_65);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_64 = tmp_65;
  if (!tmp_65) {
      ev_62_tmp_72 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_62_tmp_72);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_69 = user_exception(ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_69);
    tmp_64 = tmp_69;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_64);

  VSduplicate_ExceptionOutcome_58 = (tmp_64);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_58 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_58 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_57 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_57 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_55 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_55 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_58 && !VSduplicate_NormalOutcome_57) {
  VSduplicate_ACF_Result_55 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_58 && VSduplicate_NormalOutcome_57) {
  VSduplicate_ACF_Result_55 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_58);
  ev_62_tmp_82 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_62_tmp_82);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_78 = user_exception_is("NOT_IMPLEMENTED", ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_78);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_77 = !tmp_78;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_77);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_75 = (!VSduplicate_ExceptionOutcome_58 || tmp_77);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_75);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_58);
  ev_62_tmp_89 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&ev_62_tmp_89);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_86 = user_exception(ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_86);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_85 = !tmp_86;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_85);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_83 = (!VSduplicate_ExceptionOutcome_58 || tmp_85);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_83);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_57){
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&VSduplicate_RtnVal_56);
  o_73_tmp_98 = o_73;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&o_73_tmp_98);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate is_same_nvlist_ptr(return, o) */
  tmp_94 = is_same_nvlist_ptr(VSduplicate_RtnVal_56, o_73);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_94);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate is_same_nvlist_ptr(return, o) && cleanup_nvlist_ptr(return) */
  tmp_93 = tmp_94;
  if (tmp_94) {
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&VSduplicate_RtnVal_56);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate cleanup_nvlist_ptr(return) */
  tmp_99 = cleanup_nvlist_ptr(VSduplicate_RtnVal_56);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_99);
    tmp_93 = tmp_99;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 24, 25);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_93);
  groupExpr_102 = (tmp_93);
  tmp_91 = (groupExpr_102);
  tmp_90 = tmp_91;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 19, 25);
  tmp_90 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&tmp_90);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_55 = calculate_ACF_result(VSduplicate_ACF_Result_55, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_55;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_56);
}


VSNVList_ptr *(*ADL__VSduplicate_wrapper)(VSNVList_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_same_nvlist_ptr(return, o) && cleanup_nvlist_ptr(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_same_nvlist_ptr(return, o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {4, 23, 21, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {4, 24, 20, 0, 0, "cleanup_nvlist_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VScount
 *
 */
VSULong ADL__ACF_VScount (VSNVList_ptr *o_122, VSEnvironment *ev_111){

VSULong VScount_RtnVal_105;
  void *dummyVarName_432;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_124;
  int tmp_126;
  int tmp_127;
  VSEnvironment *ev_111_tmp_131;
    int tmp_132;
  int tmp_134;
  int tmp_135;
  VSEnvironment *ev_111_tmp_138;
    int tmp_140;
  int tmp_141;
  VSNVList_ptr *o_122_tmp_144;
  int tmp_146;
    int tmp_149;
  int tmp_150;
  int groupExpr_156;
  int tmp_152;
  VSNVList_ptr *o_122_tmp_155;

/* Declare vars for result of normal and exception bindings */
  int VScount_NormalOutcome_106, VScount_ExceptionOutcome_107;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_108;
  VSEnvironment *ev_111_tmp_112;
    int tmp_113;
  int tmp_114;
  VSEnvironment *ev_111_tmp_117;
  int tmp_118;
  VSEnvironment *ev_111_tmp_121;
  enum ADL__ACF_result VScount_ACF_Result_104 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VScount_InfoArray, 0, ADL__VScount_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VScount_assertionReport->setPhase(ADL__VScount_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScount_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VScount_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VScount_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VScount_InfoArray[forLoopIdx_1].error > VScount_ACF_Result_104))
  VScount_ACF_Result_104 = ADL__VScount_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VScount_ACF_Result_104 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VScount_assertionReport->setPhase(ADL__VScount_assertionReport, PH_call);
  ADL__release(ADL__VScount_assertionReport->parent, &this_seq);
  VScount_RtnVal_105 = ADL__VScount_wrapper(o_122, ev_111);
  ADL__recover(ADL__VScount_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VScount_assertionReport->setPhase(ADL__VScount_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_111_tmp_112 = ev_111;
  ADL__setResultAndError(ADL__VScount_InfoArray, 8,&ev_111_tmp_112);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_108 = no_exception(ev_111);
  ADL__setResultAndError(ADL__VScount_InfoArray, 7,&tmp_108);
  VScount_NormalOutcome_106 = (tmp_108);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_111_tmp_117 = ev_111;
  ADL__setResultAndError(ADL__VScount_InfoArray, 3,&ev_111_tmp_117);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_114 = system_exception(ev_111);
  ADL__setResultAndError(ADL__VScount_InfoArray, 2,&tmp_114);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_113 = tmp_114;
  if (!tmp_114) {
      ev_111_tmp_121 = ev_111;
  ADL__setResultAndError(ADL__VScount_InfoArray, 5,&ev_111_tmp_121);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_118 = user_exception(ev_111);
  ADL__setResultAndError(ADL__VScount_InfoArray, 4,&tmp_118);
    tmp_113 = tmp_118;
  }
  else {
  ADL__resetInfoStruct(ADL__VScount_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VScount_InfoArray, 1,&tmp_113);

  VScount_ExceptionOutcome_107 = (tmp_113);

/* Exception binding is the first assertion */
  if (ADL__VScount_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VScount_InfoArray[0].result = (VScount_ExceptionOutcome_107 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScount_InfoArray[0].evaluated = 1;
  ADL__VScount_InfoArray[0].value = (VScount_ExceptionOutcome_107 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VScount_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VScount_InfoArray[6].result = (VScount_NormalOutcome_106 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScount_InfoArray[6].evaluated = 1;
  ADL__VScount_InfoArray[6].value = (VScount_NormalOutcome_106 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VScount_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VScount_ACF_Result_104 = ADL__VScount_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VScount_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VScount_ACF_Result_104 = ADL__VScount_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VScount_ExceptionOutcome_107 && !VScount_NormalOutcome_106) {
  VScount_ACF_Result_104 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VScount_ExceptionOutcome_107 && VScount_NormalOutcome_106) {
  VScount_ACF_Result_104 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VScount_InfoArray, 10,&VScount_ExceptionOutcome_107);
  ev_111_tmp_131 = ev_111;
  ADL__setResultAndError(ADL__VScount_InfoArray, 13,&ev_111_tmp_131);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_127 = user_exception_is("NOT_IMPLEMENTED", ev_111);
  ADL__setResultAndError(ADL__VScount_InfoArray, 12,&tmp_127);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_126 = !tmp_127;
  ADL__setResultAndError(ADL__VScount_InfoArray, 11,&tmp_126);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_124 = (!VScount_ExceptionOutcome_107 || tmp_126);
  ADL__setResultAndError(ADL__VScount_InfoArray, 9,&tmp_124);
    ADL__setResultAndError(ADL__VScount_InfoArray, 15,&VScount_ExceptionOutcome_107);
  ev_111_tmp_138 = ev_111;
  ADL__setResultAndError(ADL__VScount_InfoArray, 18,&ev_111_tmp_138);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_135 = user_exception(ev_111);
  ADL__setResultAndError(ADL__VScount_InfoArray, 17,&tmp_135);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_134 = !tmp_135;
  ADL__setResultAndError(ADL__VScount_InfoArray, 16,&tmp_134);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_132 = (!VScount_ExceptionOutcome_107 || tmp_134);
  ADL__setResultAndError(ADL__VScount_InfoArray, 14,&tmp_132);
    o_122_tmp_144 = o_122;
  ADL__setResultAndError(ADL__VScount_InfoArray, 21,&o_122_tmp_144);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[20]);

/* Evaluate is_nil_nvlist_ptr(o) */
  tmp_141 = is_nil_nvlist_ptr(o_122);
  ADL__setResultAndError(ADL__VScount_InfoArray, 20,&tmp_141);
  ADL__setResultAndError(ADL__VScount_InfoArray, 23,&VScount_RtnVal_105);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[22]);

/* Evaluate return == 0 */
  tmp_146 = (VScount_RtnVal_105 == 0);
  ADL__setResultAndError(ADL__VScount_InfoArray, 22,&tmp_146);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[19]);

/* Evaluate is_nil_nvlist_ptr(o) --> (return == 0) */
  tmp_140 = (!tmp_141 || tmp_146);
  ADL__setResultAndError(ADL__VScount_InfoArray, 19,&tmp_140);
    ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VScount_NormalOutcome_106){
      o_122_tmp_155 = o_122;
  ADL__setResultAndError(ADL__VScount_InfoArray, 26,&o_122_tmp_155);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[25]);

/* Evaluate item_count_is_good(o) */
  tmp_152 = item_count_is_good(o_122);
  ADL__setResultAndError(ADL__VScount_InfoArray, 25,&tmp_152);
  groupExpr_156 = (tmp_152);
  tmp_150 = (groupExpr_156);
  tmp_149 = tmp_150;
  }
  else {
    ADL__resetInfoStruct(ADL__VScount_InfoArray, 24, 26);
  tmp_149 = 1;
}

  ADL__setResultAndError(ADL__VScount_InfoArray, 24,&tmp_149);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScount_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VScount_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VScount_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VScount_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VScount_InfoArray[forLoopIdx_1].level == 0))
        VScount_ACF_Result_104 = calculate_ACF_result(VScount_ACF_Result_104, ADL__VScount_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VScount_assertionReport->value = VScount_ACF_Result_104;
  ADL__VScount_assertionReport->parent->openReport(ADL__VScount_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScount_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VScount_assertionReport->emitTest(ADL__VScount_assertionReport, &ADL__VScount_InfoArray[forLoopIdx_1])) {
     ADL__VScount_assertionReport->exprStart(ADL__VScount_assertionReport, &ADL__VScount_InfoArray[forLoopIdx_1]);
      if(!ADL__VScount_InfoArray[forLoopIdx_1].testable || !ADL__VScount_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VScount_assertionReport->emitter);
      else if (ADL__VScount_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VScount_InfoArray[forLoopIdx_1].error, ADL__VScount_assertionReport->emitter);
      else
        ADL__VScount_InfoArray[forLoopIdx_1].emitFunc(ADL__VScount_InfoArray[forLoopIdx_1].value, ADL__VScount_assertionReport->emitter);
     ADL__VScount_assertionReport->exprEnd(ADL__VScount_assertionReport, &ADL__VScount_InfoArray[forLoopIdx_1]);
    }
  }

  return (VScount_RtnVal_105);
}


VSULong (*ADL__VScount_wrapper)(VSNVList_ptr*, VSEnvironment*) = VScount;

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VScount_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_nvlist_ptr(o) --> (return == 0)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_nvlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {3, 22, 19, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "item_count_is_good(o)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P }
};


unsigned int ADL__VScount_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VScount_assertionReport = 0;

/*
 *
 * ACF of VSadd
 *
 */
VSNamedValue_ptr *ADL__ACF_VSadd (VSNVList_ptr *o_176, VSFlags *f_177, VSEnvironment *ev_165){

VSNamedValue_ptr *VSadd_RtnVal_159;
  void *dummyVarName_432;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_179;
  int tmp_181;
  int tmp_182;
  VSEnvironment *ev_165_tmp_186;
    int tmp_187;
  int tmp_189;
  int tmp_190;
  VSEnvironment *ev_165_tmp_193;
    int tmp_195;
  int tmp_196;
  VSNVList_ptr *o_176_tmp_199;
  int tmp_201;
    int tmp_204;
  int tmp_205;
  int groupExpr_215;
  int groupExpr_216;
  int tmp_207;
  VSNVList_ptr *o_176_tmp_210;
  int tmp_212;

/* Declare vars for result of normal and exception bindings */
  int VSadd_NormalOutcome_160, VSadd_ExceptionOutcome_161;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_162;
  VSEnvironment *ev_165_tmp_166;
    int tmp_167;
  int tmp_168;
  VSEnvironment *ev_165_tmp_171;
  int tmp_172;
  VSEnvironment *ev_165_tmp_175;
  enum ADL__ACF_result VSadd_ACF_Result_158 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSadd_InfoArray, 0, ADL__VSadd_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSadd_assertionReport->setPhase(ADL__VSadd_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSadd_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSadd_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSadd_InfoArray[forLoopIdx_1].error > VSadd_ACF_Result_158))
  VSadd_ACF_Result_158 = ADL__VSadd_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSadd_ACF_Result_158 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSadd_assertionReport->setPhase(ADL__VSadd_assertionReport, PH_call);
  ADL__release(ADL__VSadd_assertionReport->parent, &this_seq);
  VSadd_RtnVal_159 = ADL__VSadd_wrapper(o_176, f_177, ev_165);
  ADL__recover(ADL__VSadd_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSadd_assertionReport->setPhase(ADL__VSadd_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_165_tmp_166 = ev_165;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 8,&ev_165_tmp_166);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_162 = no_exception(ev_165);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 7,&tmp_162);
  VSadd_NormalOutcome_160 = (tmp_162);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_165_tmp_171 = ev_165;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 3,&ev_165_tmp_171);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_168 = system_exception(ev_165);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 2,&tmp_168);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_167 = tmp_168;
  if (!tmp_168) {
      ev_165_tmp_175 = ev_165;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 5,&ev_165_tmp_175);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_172 = user_exception(ev_165);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 4,&tmp_172);
    tmp_167 = tmp_172;
  }
  else {
  ADL__resetInfoStruct(ADL__VSadd_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSadd_InfoArray, 1,&tmp_167);

  VSadd_ExceptionOutcome_161 = (tmp_167);

/* Exception binding is the first assertion */
  if (ADL__VSadd_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_InfoArray[0].result = (VSadd_ExceptionOutcome_161 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_InfoArray[0].evaluated = 1;
  ADL__VSadd_InfoArray[0].value = (VSadd_ExceptionOutcome_161 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSadd_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_InfoArray[6].result = (VSadd_NormalOutcome_160 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_InfoArray[6].evaluated = 1;
  ADL__VSadd_InfoArray[6].value = (VSadd_NormalOutcome_160 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSadd_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSadd_ACF_Result_158 = ADL__VSadd_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSadd_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSadd_ACF_Result_158 = ADL__VSadd_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSadd_ExceptionOutcome_161 && !VSadd_NormalOutcome_160) {
  VSadd_ACF_Result_158 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSadd_ExceptionOutcome_161 && VSadd_NormalOutcome_160) {
  VSadd_ACF_Result_158 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSadd_InfoArray, 10,&VSadd_ExceptionOutcome_161);
  ev_165_tmp_186 = ev_165;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 13,&ev_165_tmp_186);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_182 = user_exception_is("NOT_IMPLEMENTED", ev_165);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 12,&tmp_182);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_181 = !tmp_182;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 11,&tmp_181);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_179 = (!VSadd_ExceptionOutcome_161 || tmp_181);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 9,&tmp_179);
    ADL__setResultAndError(ADL__VSadd_InfoArray, 15,&VSadd_ExceptionOutcome_161);
  ev_165_tmp_193 = ev_165;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 18,&ev_165_tmp_193);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_190 = user_exception(ev_165);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 17,&tmp_190);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_189 = !tmp_190;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 16,&tmp_189);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_187 = (!VSadd_ExceptionOutcome_161 || tmp_189);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 14,&tmp_187);
    o_176_tmp_199 = o_176;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 21,&o_176_tmp_199);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[20]);

/* Evaluate is_nil_nvlist_ptr(o) */
  tmp_196 = is_nil_nvlist_ptr(o_176);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 20,&tmp_196);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 23,&VSadd_RtnVal_159);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[22]);

/* Evaluate return == 0 */
  tmp_201 = (VSadd_RtnVal_159 == 0);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 22,&tmp_201);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[19]);

/* Evaluate is_nil_nvlist_ptr(o) --> (return == 0) */
  tmp_195 = (!tmp_196 || tmp_201);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 19,&tmp_195);
    ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VSadd_NormalOutcome_160){
      o_176_tmp_210 = o_176;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 26,&o_176_tmp_210);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[25]);

/* Evaluate count_is_good(o) */
  tmp_207 = count_is_good(o_176);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 25,&tmp_207);
  groupExpr_215 = (tmp_207);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 28,&VSadd_RtnVal_159);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[27]);

/* Evaluate flags_are_good(return) */
  tmp_212 = flags_are_good(VSadd_RtnVal_159);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 27,&tmp_212);
  groupExpr_216 = (tmp_212);
  tmp_205 = (groupExpr_215 && groupExpr_216);
  tmp_204 = tmp_205;
  }
  else {
    ADL__resetInfoStruct(ADL__VSadd_InfoArray, 24, 28);
  tmp_204 = 1;
}

  ADL__setResultAndError(ADL__VSadd_InfoArray, 24,&tmp_204);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSadd_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSadd_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSadd_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSadd_InfoArray[forLoopIdx_1].level == 0))
        VSadd_ACF_Result_158 = calculate_ACF_result(VSadd_ACF_Result_158, ADL__VSadd_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSadd_assertionReport->value = VSadd_ACF_Result_158;
  ADL__VSadd_assertionReport->parent->openReport(ADL__VSadd_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSadd_assertionReport->emitTest(ADL__VSadd_assertionReport, &ADL__VSadd_InfoArray[forLoopIdx_1])) {
     ADL__VSadd_assertionReport->exprStart(ADL__VSadd_assertionReport, &ADL__VSadd_InfoArray[forLoopIdx_1]);
      if(!ADL__VSadd_InfoArray[forLoopIdx_1].testable || !ADL__VSadd_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSadd_assertionReport->emitter);
      else if (ADL__VSadd_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSadd_InfoArray[forLoopIdx_1].error, ADL__VSadd_assertionReport->emitter);
      else
        ADL__VSadd_InfoArray[forLoopIdx_1].emitFunc(ADL__VSadd_InfoArray[forLoopIdx_1].value, ADL__VSadd_assertionReport->emitter);
     ADL__VSadd_assertionReport->exprEnd(ADL__VSadd_assertionReport, &ADL__VSadd_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSadd_RtnVal_159);
}


VSNamedValue_ptr *(*ADL__VSadd_wrapper)(VSNVList_ptr*, VSFlags*, VSEnvironment*) = VSadd;

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSFlags_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSadd_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_nvlist_ptr(o) --> (return == 0)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_nvlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {3, 22, 19, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "count_is_good(o)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {6, 27, 24, 0, 0, "flags_are_good(return)", 27, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P }
};


unsigned int ADL__VSadd_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSadd_assertionReport = 0;

/*
 *
 * ACF of VSadd_item
 *
 */
VSNamedValue_ptr *ADL__ACF_VSadd_item (VSNVList_ptr *o_236, VSString str_237, VSFlags *f_238, VSEnvironment *ev_225){

VSNamedValue_ptr *VSadd_item_RtnVal_219;
  void *dummyVarName_432;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_240;
  int tmp_242;
  int tmp_243;
  VSEnvironment *ev_225_tmp_247;
    int tmp_248;
  int tmp_250;
  int tmp_251;
  VSEnvironment *ev_225_tmp_254;
    int tmp_256;
  int tmp_257;
  VSNVList_ptr *o_236_tmp_260;
  int tmp_262;
    int tmp_265;
  int tmp_266;
  int groupExpr_280;
  int groupExpr_281;
  int groupExpr_282;
  int tmp_268;
  VSNVList_ptr *o_236_tmp_271;
  int tmp_273;
  int tmp_277;

/* Declare vars for result of normal and exception bindings */
  int VSadd_item_NormalOutcome_220, VSadd_item_ExceptionOutcome_221;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_222;
  VSEnvironment *ev_225_tmp_226;
    int tmp_227;
  int tmp_228;
  VSEnvironment *ev_225_tmp_231;
  int tmp_232;
  VSEnvironment *ev_225_tmp_235;
  enum ADL__ACF_result VSadd_item_ACF_Result_218 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSadd_item_InfoArray, 0, ADL__VSadd_item_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSadd_item_assertionReport->setPhase(ADL__VSadd_item_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_item_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSadd_item_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSadd_item_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSadd_item_InfoArray[forLoopIdx_1].error > VSadd_item_ACF_Result_218))
  VSadd_item_ACF_Result_218 = ADL__VSadd_item_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSadd_item_ACF_Result_218 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSadd_item_assertionReport->setPhase(ADL__VSadd_item_assertionReport, PH_call);
  ADL__release(ADL__VSadd_item_assertionReport->parent, &this_seq);
  VSadd_item_RtnVal_219 = ADL__VSadd_item_wrapper(o_236, str_237, f_238, ev_225);
  ADL__recover(ADL__VSadd_item_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSadd_item_assertionReport->setPhase(ADL__VSadd_item_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_225_tmp_226 = ev_225;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 8,&ev_225_tmp_226);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_222 = no_exception(ev_225);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 7,&tmp_222);
  VSadd_item_NormalOutcome_220 = (tmp_222);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_225_tmp_231 = ev_225;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 3,&ev_225_tmp_231);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_228 = system_exception(ev_225);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 2,&tmp_228);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_227 = tmp_228;
  if (!tmp_228) {
      ev_225_tmp_235 = ev_225;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 5,&ev_225_tmp_235);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_232 = user_exception(ev_225);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 4,&tmp_232);
    tmp_227 = tmp_232;
  }
  else {
  ADL__resetInfoStruct(ADL__VSadd_item_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 1,&tmp_227);

  VSadd_item_ExceptionOutcome_221 = (tmp_227);

/* Exception binding is the first assertion */
  if (ADL__VSadd_item_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_item_InfoArray[0].result = (VSadd_item_ExceptionOutcome_221 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_item_InfoArray[0].evaluated = 1;
  ADL__VSadd_item_InfoArray[0].value = (VSadd_item_ExceptionOutcome_221 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSadd_item_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_item_InfoArray[6].result = (VSadd_item_NormalOutcome_220 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_item_InfoArray[6].evaluated = 1;
  ADL__VSadd_item_InfoArray[6].value = (VSadd_item_NormalOutcome_220 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSadd_item_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSadd_item_ACF_Result_218 = ADL__VSadd_item_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSadd_item_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSadd_item_ACF_Result_218 = ADL__VSadd_item_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSadd_item_ExceptionOutcome_221 && !VSadd_item_NormalOutcome_220) {
  VSadd_item_ACF_Result_218 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSadd_item_ExceptionOutcome_221 && VSadd_item_NormalOutcome_220) {
  VSadd_item_ACF_Result_218 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSadd_item_InfoArray, 10,&VSadd_item_ExceptionOutcome_221);
  ev_225_tmp_247 = ev_225;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 13,&ev_225_tmp_247);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_243 = user_exception_is("NOT_IMPLEMENTED", ev_225);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 12,&tmp_243);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_242 = !tmp_243;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 11,&tmp_242);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_240 = (!VSadd_item_ExceptionOutcome_221 || tmp_242);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 9,&tmp_240);
    ADL__setResultAndError(ADL__VSadd_item_InfoArray, 15,&VSadd_item_ExceptionOutcome_221);
  ev_225_tmp_254 = ev_225;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 18,&ev_225_tmp_254);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_251 = user_exception(ev_225);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 17,&tmp_251);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_250 = !tmp_251;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 16,&tmp_250);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_248 = (!VSadd_item_ExceptionOutcome_221 || tmp_250);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 14,&tmp_248);
    o_236_tmp_260 = o_236;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 21,&o_236_tmp_260);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[20]);

/* Evaluate is_nil_nvlist_ptr(o) */
  tmp_257 = is_nil_nvlist_ptr(o_236);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 20,&tmp_257);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 23,&VSadd_item_RtnVal_219);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[22]);

/* Evaluate return == 0 */
  tmp_262 = (VSadd_item_RtnVal_219 == 0);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 22,&tmp_262);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[19]);

/* Evaluate is_nil_nvlist_ptr(o) --> (return == 0) */
  tmp_256 = (!tmp_257 || tmp_262);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 19,&tmp_256);
    ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VSadd_item_NormalOutcome_220){
      o_236_tmp_271 = o_236;
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 26,&o_236_tmp_271);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[25]);

/* Evaluate count_is_good(o) */
  tmp_268 = count_is_good(o_236);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 25,&tmp_268);
  groupExpr_280 = (tmp_268);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 28,&VSadd_item_RtnVal_219);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[27]);

/* Evaluate name_is_good(return) */
  tmp_273 = name_is_good(VSadd_item_RtnVal_219);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 27,&tmp_273);
  groupExpr_281 = (tmp_273);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 30,&VSadd_item_RtnVal_219);
  ADL__VSadd_item_assertionReport->exprMark(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_assertionReport->assrt_info[29]);

/* Evaluate flags_are_good(return) */
  tmp_277 = flags_are_good(VSadd_item_RtnVal_219);
  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 29,&tmp_277);
  groupExpr_282 = (tmp_277);
  tmp_266 = (groupExpr_280 && groupExpr_281 && groupExpr_282);
  tmp_265 = tmp_266;
  }
  else {
    ADL__resetInfoStruct(ADL__VSadd_item_InfoArray, 24, 30);
  tmp_265 = 1;
}

  ADL__setResultAndError(ADL__VSadd_item_InfoArray, 24,&tmp_265);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_item_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSadd_item_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSadd_item_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSadd_item_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSadd_item_InfoArray[forLoopIdx_1].level == 0))
        VSadd_item_ACF_Result_218 = calculate_ACF_result(VSadd_item_ACF_Result_218, ADL__VSadd_item_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSadd_item_assertionReport->value = VSadd_item_ACF_Result_218;
  ADL__VSadd_item_assertionReport->parent->openReport(ADL__VSadd_item_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_item_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSadd_item_assertionReport->emitTest(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_InfoArray[forLoopIdx_1])) {
     ADL__VSadd_item_assertionReport->exprStart(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_InfoArray[forLoopIdx_1]);
      if(!ADL__VSadd_item_InfoArray[forLoopIdx_1].testable || !ADL__VSadd_item_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSadd_item_assertionReport->emitter);
      else if (ADL__VSadd_item_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSadd_item_InfoArray[forLoopIdx_1].error, ADL__VSadd_item_assertionReport->emitter);
      else
        ADL__VSadd_item_InfoArray[forLoopIdx_1].emitFunc(ADL__VSadd_item_InfoArray[forLoopIdx_1].value, ADL__VSadd_item_assertionReport->emitter);
     ADL__VSadd_item_assertionReport->exprEnd(ADL__VSadd_item_assertionReport, &ADL__VSadd_item_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSadd_item_RtnVal_219);
}


VSNamedValue_ptr *(*ADL__VSadd_item_wrapper)(VSNVList_ptr*, VSString, VSFlags*, VSEnvironment*) = VSadd_item;

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSString (void* val, emitter_t emitter);
void ADL__emit_VSFlags_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSadd_item_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_nvlist_ptr(o) --> (return == 0)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_nvlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {3, 22, 19, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "count_is_good(o)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {6, 27, 24, 0, 0, "name_is_good(return)", 27, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P },
  {7, 29, 24, 0, 0, "flags_are_good(return)", 29, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {7, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P }
};


unsigned int ADL__VSadd_item_InfoArrayIdx = 31;

struct ADL__reportAssertion *ADL__VSadd_item_assertionReport = 0;

/*
 *
 * ACF of VSadd_item_consume
 *
 */
VSNamedValue_ptr *ADL__ACF_VSadd_item_consume (VSNVList_ptr *o_302, VSString str_303, VSFlags *f_304, VSEnvironment *ev_291){

VSNamedValue_ptr *VSadd_item_consume_RtnVal_285;
  void *dummyVarName_432;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_306;
  int tmp_308;
  int tmp_309;
  VSEnvironment *ev_291_tmp_313;
    int tmp_314;
  int tmp_316;
  int tmp_317;
  VSEnvironment *ev_291_tmp_320;
    int tmp_322;
  int tmp_323;
  VSNVList_ptr *o_302_tmp_326;
  int tmp_328;
    int tmp_331;
  int tmp_332;
  int groupExpr_346;
  int groupExpr_347;
  int groupExpr_348;
  int tmp_334;
  VSNVList_ptr *o_302_tmp_337;
  int tmp_339;
  int tmp_343;

/* Declare vars for result of normal and exception bindings */
  int VSadd_item_consume_NormalOutcome_286, VSadd_item_consume_ExceptionOutcome_287;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_288;
  VSEnvironment *ev_291_tmp_292;
    int tmp_293;
  int tmp_294;
  VSEnvironment *ev_291_tmp_297;
  int tmp_298;
  VSEnvironment *ev_291_tmp_301;
  enum ADL__ACF_result VSadd_item_consume_ACF_Result_284 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSadd_item_consume_InfoArray, 0, ADL__VSadd_item_consume_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSadd_item_consume_assertionReport->setPhase(ADL__VSadd_item_consume_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_item_consume_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].error > VSadd_item_consume_ACF_Result_284))
  VSadd_item_consume_ACF_Result_284 = ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSadd_item_consume_ACF_Result_284 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSadd_item_consume_assertionReport->setPhase(ADL__VSadd_item_consume_assertionReport, PH_call);
  ADL__release(ADL__VSadd_item_consume_assertionReport->parent, &this_seq);
  VSadd_item_consume_RtnVal_285 = ADL__VSadd_item_consume_wrapper(o_302, str_303, f_304, ev_291);
  ADL__recover(ADL__VSadd_item_consume_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSadd_item_consume_assertionReport->setPhase(ADL__VSadd_item_consume_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_291_tmp_292 = ev_291;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 8,&ev_291_tmp_292);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_288 = no_exception(ev_291);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 7,&tmp_288);
  VSadd_item_consume_NormalOutcome_286 = (tmp_288);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_291_tmp_297 = ev_291;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 3,&ev_291_tmp_297);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_294 = system_exception(ev_291);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 2,&tmp_294);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_293 = tmp_294;
  if (!tmp_294) {
      ev_291_tmp_301 = ev_291;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 5,&ev_291_tmp_301);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_298 = user_exception(ev_291);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 4,&tmp_298);
    tmp_293 = tmp_298;
  }
  else {
  ADL__resetInfoStruct(ADL__VSadd_item_consume_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 1,&tmp_293);

  VSadd_item_consume_ExceptionOutcome_287 = (tmp_293);

/* Exception binding is the first assertion */
  if (ADL__VSadd_item_consume_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_item_consume_InfoArray[0].result = (VSadd_item_consume_ExceptionOutcome_287 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_item_consume_InfoArray[0].evaluated = 1;
  ADL__VSadd_item_consume_InfoArray[0].value = (VSadd_item_consume_ExceptionOutcome_287 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSadd_item_consume_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_item_consume_InfoArray[6].result = (VSadd_item_consume_NormalOutcome_286 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_item_consume_InfoArray[6].evaluated = 1;
  ADL__VSadd_item_consume_InfoArray[6].value = (VSadd_item_consume_NormalOutcome_286 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSadd_item_consume_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSadd_item_consume_ACF_Result_284 = ADL__VSadd_item_consume_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSadd_item_consume_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSadd_item_consume_ACF_Result_284 = ADL__VSadd_item_consume_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSadd_item_consume_ExceptionOutcome_287 && !VSadd_item_consume_NormalOutcome_286) {
  VSadd_item_consume_ACF_Result_284 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSadd_item_consume_ExceptionOutcome_287 && VSadd_item_consume_NormalOutcome_286) {
  VSadd_item_consume_ACF_Result_284 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 10,&VSadd_item_consume_ExceptionOutcome_287);
  ev_291_tmp_313 = ev_291;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 13,&ev_291_tmp_313);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_309 = user_exception_is("NOT_IMPLEMENTED", ev_291);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 12,&tmp_309);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_308 = !tmp_309;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 11,&tmp_308);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_306 = (!VSadd_item_consume_ExceptionOutcome_287 || tmp_308);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 9,&tmp_306);
    ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 15,&VSadd_item_consume_ExceptionOutcome_287);
  ev_291_tmp_320 = ev_291;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 18,&ev_291_tmp_320);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_317 = user_exception(ev_291);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 17,&tmp_317);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_316 = !tmp_317;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 16,&tmp_316);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_314 = (!VSadd_item_consume_ExceptionOutcome_287 || tmp_316);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 14,&tmp_314);
    o_302_tmp_326 = o_302;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 21,&o_302_tmp_326);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[20]);

/* Evaluate is_nil_nvlist_ptr(o) */
  tmp_323 = is_nil_nvlist_ptr(o_302);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 20,&tmp_323);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 23,&VSadd_item_consume_RtnVal_285);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[22]);

/* Evaluate return == 0 */
  tmp_328 = (VSadd_item_consume_RtnVal_285 == 0);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 22,&tmp_328);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[19]);

/* Evaluate is_nil_nvlist_ptr(o) --> (return == 0) */
  tmp_322 = (!tmp_323 || tmp_328);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 19,&tmp_322);
    ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VSadd_item_consume_NormalOutcome_286){
      o_302_tmp_337 = o_302;
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 26,&o_302_tmp_337);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[25]);

/* Evaluate count_is_good(o) */
  tmp_334 = count_is_good(o_302);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 25,&tmp_334);
  groupExpr_346 = (tmp_334);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 28,&VSadd_item_consume_RtnVal_285);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[27]);

/* Evaluate name_is_good(return) */
  tmp_339 = name_is_good(VSadd_item_consume_RtnVal_285);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 27,&tmp_339);
  groupExpr_347 = (tmp_339);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 30,&VSadd_item_consume_RtnVal_285);
  ADL__VSadd_item_consume_assertionReport->exprMark(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_assertionReport->assrt_info[29]);

/* Evaluate flags_are_good(return) */
  tmp_343 = flags_are_good(VSadd_item_consume_RtnVal_285);
  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 29,&tmp_343);
  groupExpr_348 = (tmp_343);
  tmp_332 = (groupExpr_346 && groupExpr_347 && groupExpr_348);
  tmp_331 = tmp_332;
  }
  else {
    ADL__resetInfoStruct(ADL__VSadd_item_consume_InfoArray, 24, 30);
  tmp_331 = 1;
}

  ADL__setResultAndError(ADL__VSadd_item_consume_InfoArray, 24,&tmp_331);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_item_consume_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].level == 0))
        VSadd_item_consume_ACF_Result_284 = calculate_ACF_result(VSadd_item_consume_ACF_Result_284, ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSadd_item_consume_assertionReport->value = VSadd_item_consume_ACF_Result_284;
  ADL__VSadd_item_consume_assertionReport->parent->openReport(ADL__VSadd_item_consume_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_item_consume_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSadd_item_consume_assertionReport->emitTest(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_InfoArray[forLoopIdx_1])) {
     ADL__VSadd_item_consume_assertionReport->exprStart(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_InfoArray[forLoopIdx_1]);
      if(!ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].testable || !ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSadd_item_consume_assertionReport->emitter);
      else if (ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].error, ADL__VSadd_item_consume_assertionReport->emitter);
      else
        ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].emitFunc(ADL__VSadd_item_consume_InfoArray[forLoopIdx_1].value, ADL__VSadd_item_consume_assertionReport->emitter);
     ADL__VSadd_item_consume_assertionReport->exprEnd(ADL__VSadd_item_consume_assertionReport, &ADL__VSadd_item_consume_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSadd_item_consume_RtnVal_285);
}


VSNamedValue_ptr *(*ADL__VSadd_item_consume_wrapper)(VSNVList_ptr*, VSString, VSFlags*, VSEnvironment*) = VSadd_item_consume;

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSString (void* val, emitter_t emitter);
void ADL__emit_VSFlags_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSadd_item_consume_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_nvlist_ptr(o) --> (return == 0)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_nvlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {3, 22, 19, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "count_is_good(o)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {6, 27, 24, 0, 0, "name_is_good(return)", 27, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P },
  {7, 29, 24, 0, 0, "flags_are_good(return)", 29, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {7, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P }
};


unsigned int ADL__VSadd_item_consume_InfoArrayIdx = 31;

struct ADL__reportAssertion *ADL__VSadd_item_consume_assertionReport = 0;

/*
 *
 * ACF of VSitem
 *
 */
VSNamedValue_ptr *ADL__ACF_VSitem (VSNVList_ptr *o_368, VSULong ind_369, VSEnvironment *ev_357){

VSNamedValue_ptr *VSitem_RtnVal_351;
  void *dummyVarName_432;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_371;
  int tmp_373;
  int tmp_374;
  VSEnvironment *ev_357_tmp_378;
    int tmp_380;
  int tmp_381;
  VSNVList_ptr *o_368_tmp_384;
  int tmp_386;
    int tmp_390;
  int tmp_391;
  VSNVList_ptr *o_368_tmp_394;
  VSULong ind_369_tmp_396;
  int tmp_397;
  VSEnvironment *ev_357_tmp_401;
    int tmp_403;
  int tmp_404;
  VSNVList_ptr *o_368_tmp_407;
  VSULong ind_369_tmp_409;
  int tmp_411;
    int tmp_414;
  int tmp_415;
  int groupExpr_430;
  int groupExpr_431;
  int tmp_417;
  unsigned long int tmp_418;
  VSNVList_ptr *o_368_tmp_421;
  unsigned long int tmp_422;
  VSNVList_ptr *o_368_tmp_425;
  int tmp_427;

/* Declare vars for result of normal and exception bindings */
  int VSitem_NormalOutcome_352, VSitem_ExceptionOutcome_353;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_354;
  VSEnvironment *ev_357_tmp_358;
    int tmp_359;
  int tmp_360;
  VSEnvironment *ev_357_tmp_363;
  int tmp_364;
  VSEnvironment *ev_357_tmp_367;
  enum ADL__ACF_result VSitem_ACF_Result_350 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSitem_InfoArray, 0, ADL__VSitem_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSitem_assertionReport->setPhase(ADL__VSitem_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
          
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSitem_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSitem_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSitem_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSitem_InfoArray[forLoopIdx_1].error > VSitem_ACF_Result_350))
  VSitem_ACF_Result_350 = ADL__VSitem_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSitem_ACF_Result_350 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSitem_assertionReport->setPhase(ADL__VSitem_assertionReport, PH_call);
  ADL__release(ADL__VSitem_assertionReport->parent, &this_seq);
  VSitem_RtnVal_351 = ADL__VSitem_wrapper(o_368, ind_369, ev_357);
  ADL__recover(ADL__VSitem_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSitem_assertionReport->setPhase(ADL__VSitem_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_357_tmp_358 = ev_357;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 8,&ev_357_tmp_358);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_354 = no_exception(ev_357);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 7,&tmp_354);
  VSitem_NormalOutcome_352 = (tmp_354);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_357_tmp_363 = ev_357;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 3,&ev_357_tmp_363);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_360 = system_exception(ev_357);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 2,&tmp_360);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_359 = tmp_360;
  if (!tmp_360) {
      ev_357_tmp_367 = ev_357;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 5,&ev_357_tmp_367);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_364 = user_exception(ev_357);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 4,&tmp_364);
    tmp_359 = tmp_364;
  }
  else {
  ADL__resetInfoStruct(ADL__VSitem_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSitem_InfoArray, 1,&tmp_359);

  VSitem_ExceptionOutcome_353 = (tmp_359);

/* Exception binding is the first assertion */
  if (ADL__VSitem_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSitem_InfoArray[0].result = (VSitem_ExceptionOutcome_353 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSitem_InfoArray[0].evaluated = 1;
  ADL__VSitem_InfoArray[0].value = (VSitem_ExceptionOutcome_353 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSitem_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSitem_InfoArray[6].result = (VSitem_NormalOutcome_352 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSitem_InfoArray[6].evaluated = 1;
  ADL__VSitem_InfoArray[6].value = (VSitem_NormalOutcome_352 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSitem_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSitem_ACF_Result_350 = ADL__VSitem_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSitem_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSitem_ACF_Result_350 = ADL__VSitem_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSitem_ExceptionOutcome_353 && !VSitem_NormalOutcome_352) {
  VSitem_ACF_Result_350 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSitem_ExceptionOutcome_353 && VSitem_NormalOutcome_352) {
  VSitem_ACF_Result_350 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSitem_InfoArray, 10,&VSitem_ExceptionOutcome_353);
  ev_357_tmp_378 = ev_357;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 13,&ev_357_tmp_378);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_374 = user_exception_is("NOT_IMPLEMENTED", ev_357);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 12,&tmp_374);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_373 = !tmp_374;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 11,&tmp_373);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_371 = (!VSitem_ExceptionOutcome_353 || tmp_373);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 9,&tmp_371);
    o_368_tmp_384 = o_368;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 16,&o_368_tmp_384);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[15]);

/* Evaluate is_nil_nvlist_ptr(o) */
  tmp_381 = is_nil_nvlist_ptr(o_368);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 15,&tmp_381);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 18,&VSitem_RtnVal_351);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[17]);

/* Evaluate return == 0 */
  tmp_386 = (VSitem_RtnVal_351 == 0);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 17,&tmp_386);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[14]);

/* Evaluate is_nil_nvlist_ptr(o) --> (return == 0) */
  tmp_380 = (!tmp_381 || tmp_386);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 14,&tmp_380);
    o_368_tmp_394 = o_368;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 21,&o_368_tmp_394);
  ind_369_tmp_396 = ind_369;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 22,&ind_369_tmp_396);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[20]);

/* Evaluate out_of_bounds(o, ind) */
  tmp_391 = out_of_bounds(o_368, ind_369);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 20,&tmp_391);
  ev_357_tmp_401 = ev_357;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 24,&ev_357_tmp_401);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[23]);

/* Evaluate user_exception_is("CORBA::Bounds", ev) */
  tmp_397 = user_exception_is("CORBA::Bounds", ev_357);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 23,&tmp_397);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[19]);

/* Evaluate out_of_bounds(o, ind) --> user_exception_is("CORBA::Bounds", ev) */
  tmp_390 = (!tmp_391 || tmp_397);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 19,&tmp_390);
    o_368_tmp_407 = o_368;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 27,&o_368_tmp_407);
  ind_369_tmp_409 = ind_369;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 28,&ind_369_tmp_409);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[26]);

/* Evaluate out_of_bounds(o, ind) */
  tmp_404 = out_of_bounds(o_368, ind_369);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 26,&tmp_404);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 30,&VSitem_RtnVal_351);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[29]);

/* Evaluate return == 0 */
  tmp_411 = (VSitem_RtnVal_351 == 0);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 29,&tmp_411);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[25]);

/* Evaluate out_of_bounds(o, ind) --> (return == 0) */
  tmp_403 = (!tmp_404 || tmp_411);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 25,&tmp_403);
    ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[31]);

/* Evaluate normally { ... } */
  if(VSitem_NormalOutcome_352){
      o_368_tmp_421 = o_368;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 34,&o_368_tmp_421);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[33]);

/* Evaluate count(o) */
  tmp_418 = count(o_368);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 33,&tmp_418);
  o_368_tmp_425 = o_368;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 36,&o_368_tmp_425);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[35]);

/* Evaluate count(o) */
  tmp_422 = count(o_368);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 35,&tmp_422);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[32]);

/* Evaluate count(o) == count(o) */
  tmp_417 = (tmp_418 == tmp_422);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 32,&tmp_417);
  groupExpr_430 = (tmp_417);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 38,&VSitem_RtnVal_351);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[37]);

/* Evaluate nvalue_is_good(return) */
  tmp_427 = nvalue_is_good(VSitem_RtnVal_351);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 37,&tmp_427);
  groupExpr_431 = (tmp_427);
  tmp_415 = (groupExpr_430 && groupExpr_431);
  tmp_414 = tmp_415;
  }
  else {
    ADL__resetInfoStruct(ADL__VSitem_InfoArray, 31, 38);
  tmp_414 = 1;
}

  ADL__setResultAndError(ADL__VSitem_InfoArray, 31,&tmp_414);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSitem_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSitem_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSitem_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSitem_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSitem_InfoArray[forLoopIdx_1].level == 0))
        VSitem_ACF_Result_350 = calculate_ACF_result(VSitem_ACF_Result_350, ADL__VSitem_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSitem_assertionReport->value = VSitem_ACF_Result_350;
  ADL__VSitem_assertionReport->parent->openReport(ADL__VSitem_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSitem_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSitem_assertionReport->emitTest(ADL__VSitem_assertionReport, &ADL__VSitem_InfoArray[forLoopIdx_1])) {
     ADL__VSitem_assertionReport->exprStart(ADL__VSitem_assertionReport, &ADL__VSitem_InfoArray[forLoopIdx_1]);
      if(!ADL__VSitem_InfoArray[forLoopIdx_1].testable || !ADL__VSitem_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSitem_assertionReport->emitter);
      else if (ADL__VSitem_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSitem_InfoArray[forLoopIdx_1].error, ADL__VSitem_assertionReport->emitter);
      else
        ADL__VSitem_InfoArray[forLoopIdx_1].emitFunc(ADL__VSitem_InfoArray[forLoopIdx_1].value, ADL__VSitem_assertionReport->emitter);
     ADL__VSitem_assertionReport->exprEnd(ADL__VSitem_assertionReport, &ADL__VSitem_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSitem_RtnVal_351);
}


VSNamedValue_ptr *(*ADL__VSitem_wrapper)(VSNVList_ptr*, VSULong, VSEnvironment*) = VSitem;

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSitem_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "is_nil_nvlist_ptr(o) --> (return == 0)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "is_nil_nvlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {2, 17, 14, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P },
  {3, 19, 19, 0, 0, "out_of_bounds(o, ind) --> user_exception_is(\"CORBA::Bounds\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "out_of_bounds(o, ind)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {3, 22, 20, 0, 0, "ind", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {3, 23, 19, 0, 0, "user_exception_is(\"CORBA::Bounds\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 24, 23, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 25, 25, 0, 0, "out_of_bounds(o, ind) --> (return == 0)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "out_of_bounds(o, ind)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 27, 26, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {4, 28, 26, 0, 0, "ind", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {4, 29, 25, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P },
  {5, 31, 31, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {6, 32, 31, 0, 0, "count(o) == count(o)", 32, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 33, 32, 0, 0, "count(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_unsigned_long_int },
  {6, 34, 33, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {6, 35, 32, 0, 0, "count(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_unsigned_long_int },
  {6, 36, 35, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {7, 37, 31, 0, 0, "nvalue_is_good(return)", 37, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {7, 38, 37, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNamedValue_ptr_P }
};


unsigned int ADL__VSitem_InfoArrayIdx = 39;

struct ADL__reportAssertion *ADL__VSitem_assertionReport = 0;

/*
 *
 * ACF of VSremove
 *
 */
VSStatus ADL__ACF_VSremove (VSNVList_ptr *o_451, VSULong ind_452, VSEnvironment *ev_440){

VSStatus VSremove_RtnVal_434;
  void *dummyVarName_432;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_454;
  int tmp_456;
  int tmp_457;
  VSEnvironment *ev_440_tmp_461;
    int tmp_463;
  int tmp_464;
  VSNVList_ptr *o_451_tmp_467;
  int tmp_469;
    int tmp_473;
  int tmp_474;
  VSNVList_ptr *o_451_tmp_477;
  VSULong ind_452_tmp_479;
  int tmp_480;
  VSEnvironment *ev_440_tmp_484;
    int tmp_486;
  int tmp_487;
  VSNVList_ptr *o_451_tmp_490;
  VSULong ind_452_tmp_492;
  int tmp_494;
    int tmp_497;
  int tmp_498;
  int groupExpr_504;
  int tmp_500;
  VSNVList_ptr *o_451_tmp_503;

/* Declare vars for result of normal and exception bindings */
  int VSremove_NormalOutcome_435, VSremove_ExceptionOutcome_436;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_437;
  VSEnvironment *ev_440_tmp_441;
    int tmp_442;
  int tmp_443;
  VSEnvironment *ev_440_tmp_446;
  int tmp_447;
  VSEnvironment *ev_440_tmp_450;
  enum ADL__ACF_result VSremove_ACF_Result_433 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSremove_InfoArray, 0, ADL__VSremove_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSremove_assertionReport->setPhase(ADL__VSremove_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
          
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSremove_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSremove_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSremove_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSremove_InfoArray[forLoopIdx_1].error > VSremove_ACF_Result_433))
  VSremove_ACF_Result_433 = ADL__VSremove_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSremove_ACF_Result_433 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSremove_assertionReport->setPhase(ADL__VSremove_assertionReport, PH_call);
  ADL__release(ADL__VSremove_assertionReport->parent, &this_seq);
  VSremove_RtnVal_434 = ADL__VSremove_wrapper(o_451, ind_452, ev_440);
  ADL__recover(ADL__VSremove_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSremove_assertionReport->setPhase(ADL__VSremove_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_440_tmp_441 = ev_440;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 8,&ev_440_tmp_441);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_437 = no_exception(ev_440);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 7,&tmp_437);
  VSremove_NormalOutcome_435 = (tmp_437);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_440_tmp_446 = ev_440;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 3,&ev_440_tmp_446);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_443 = system_exception(ev_440);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 2,&tmp_443);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_442 = tmp_443;
  if (!tmp_443) {
      ev_440_tmp_450 = ev_440;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 5,&ev_440_tmp_450);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_447 = user_exception(ev_440);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 4,&tmp_447);
    tmp_442 = tmp_447;
  }
  else {
  ADL__resetInfoStruct(ADL__VSremove_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSremove_InfoArray, 1,&tmp_442);

  VSremove_ExceptionOutcome_436 = (tmp_442);

/* Exception binding is the first assertion */
  if (ADL__VSremove_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSremove_InfoArray[0].result = (VSremove_ExceptionOutcome_436 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSremove_InfoArray[0].evaluated = 1;
  ADL__VSremove_InfoArray[0].value = (VSremove_ExceptionOutcome_436 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSremove_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSremove_InfoArray[6].result = (VSremove_NormalOutcome_435 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSremove_InfoArray[6].evaluated = 1;
  ADL__VSremove_InfoArray[6].value = (VSremove_NormalOutcome_435 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSremove_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSremove_ACF_Result_433 = ADL__VSremove_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSremove_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSremove_ACF_Result_433 = ADL__VSremove_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSremove_ExceptionOutcome_436 && !VSremove_NormalOutcome_435) {
  VSremove_ACF_Result_433 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSremove_ExceptionOutcome_436 && VSremove_NormalOutcome_435) {
  VSremove_ACF_Result_433 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSremove_InfoArray, 10,&VSremove_ExceptionOutcome_436);
  ev_440_tmp_461 = ev_440;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 13,&ev_440_tmp_461);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_457 = user_exception_is("NOT_IMPLEMENTED", ev_440);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 12,&tmp_457);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_456 = !tmp_457;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 11,&tmp_456);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_454 = (!VSremove_ExceptionOutcome_436 || tmp_456);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 9,&tmp_454);
    o_451_tmp_467 = o_451;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 16,&o_451_tmp_467);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[15]);

/* Evaluate is_nil_nvlist_ptr(o) */
  tmp_464 = is_nil_nvlist_ptr(o_451);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 15,&tmp_464);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 18,&VSremove_RtnVal_434);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[17]);

/* Evaluate return == 0 */
  tmp_469 = (VSremove_RtnVal_434 == 0);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 17,&tmp_469);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[14]);

/* Evaluate is_nil_nvlist_ptr(o) --> (return == 0) */
  tmp_463 = (!tmp_464 || tmp_469);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 14,&tmp_463);
    o_451_tmp_477 = o_451;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 21,&o_451_tmp_477);
  ind_452_tmp_479 = ind_452;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 22,&ind_452_tmp_479);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[20]);

/* Evaluate out_of_bounds_for_remove(o, ind) */
  tmp_474 = out_of_bounds_for_remove(o_451, ind_452);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 20,&tmp_474);
  ev_440_tmp_484 = ev_440;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 24,&ev_440_tmp_484);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[23]);

/* Evaluate user_exception_is("CORBA::Bounds", ev) */
  tmp_480 = user_exception_is("CORBA::Bounds", ev_440);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 23,&tmp_480);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[19]);

/* Evaluate out_of_bounds_for_remove(o, ind) --> user_exception_is("CORBA::Bounds", ev) */
  tmp_473 = (!tmp_474 || tmp_480);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 19,&tmp_473);
    o_451_tmp_490 = o_451;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 27,&o_451_tmp_490);
  ind_452_tmp_492 = ind_452;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 28,&ind_452_tmp_492);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[26]);

/* Evaluate out_of_bounds_for_remove(o, ind) */
  tmp_487 = out_of_bounds_for_remove(o_451, ind_452);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 26,&tmp_487);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 30,&VSremove_RtnVal_434);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[29]);

/* Evaluate return == 0 */
  tmp_494 = (VSremove_RtnVal_434 == 0);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 29,&tmp_494);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[25]);

/* Evaluate out_of_bounds_for_remove(o, ind) --> (return == 0) */
  tmp_486 = (!tmp_487 || tmp_494);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 25,&tmp_486);
    ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[31]);

/* Evaluate normally { ... } */
  if(VSremove_NormalOutcome_435){
      o_451_tmp_503 = o_451;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 33,&o_451_tmp_503);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[32]);

/* Evaluate has_been_removed(o) */
  tmp_500 = has_been_removed(o_451);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 32,&tmp_500);
  groupExpr_504 = (tmp_500);
  tmp_498 = (groupExpr_504);
  tmp_497 = tmp_498;
  }
  else {
    ADL__resetInfoStruct(ADL__VSremove_InfoArray, 31, 33);
  tmp_497 = 1;
}

  ADL__setResultAndError(ADL__VSremove_InfoArray, 31,&tmp_497);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSremove_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSremove_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSremove_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSremove_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSremove_InfoArray[forLoopIdx_1].level == 0))
        VSremove_ACF_Result_433 = calculate_ACF_result(VSremove_ACF_Result_433, ADL__VSremove_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSremove_assertionReport->value = VSremove_ACF_Result_433;
  ADL__VSremove_assertionReport->parent->openReport(ADL__VSremove_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSremove_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSremove_assertionReport->emitTest(ADL__VSremove_assertionReport, &ADL__VSremove_InfoArray[forLoopIdx_1])) {
     ADL__VSremove_assertionReport->exprStart(ADL__VSremove_assertionReport, &ADL__VSremove_InfoArray[forLoopIdx_1]);
      if(!ADL__VSremove_InfoArray[forLoopIdx_1].testable || !ADL__VSremove_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSremove_assertionReport->emitter);
      else if (ADL__VSremove_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSremove_InfoArray[forLoopIdx_1].error, ADL__VSremove_assertionReport->emitter);
      else
        ADL__VSremove_InfoArray[forLoopIdx_1].emitFunc(ADL__VSremove_InfoArray[forLoopIdx_1].value, ADL__VSremove_assertionReport->emitter);
     ADL__VSremove_assertionReport->exprEnd(ADL__VSremove_assertionReport, &ADL__VSremove_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSremove_RtnVal_434);
}


VSStatus (*ADL__VSremove_wrapper)(VSNVList_ptr*, VSULong, VSEnvironment*) = VSremove;

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSStatus (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSremove_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "is_nil_nvlist_ptr(o) --> (return == 0)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "is_nil_nvlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {2, 17, 14, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStatus },
  {3, 19, 19, 0, 0, "out_of_bounds_for_remove(o, ind) --> user_exception_is(\"CORBA::Bounds\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "out_of_bounds_for_remove(o, ind)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {3, 22, 20, 0, 0, "ind", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {3, 23, 19, 0, 0, "user_exception_is(\"CORBA::Bounds\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 24, 23, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 25, 25, 0, 0, "out_of_bounds_for_remove(o, ind) --> (return == 0)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "out_of_bounds_for_remove(o, ind)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 27, 26, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P },
  {4, 28, 26, 0, 0, "ind", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {4, 29, 25, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStatus },
  {5, 31, 31, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {6, 32, 31, 0, 0, "has_been_removed(o)", 32, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 33, 32, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNVList_ptr_P }
};


unsigned int ADL__VSremove_InfoArrayIdx = 34;

struct ADL__reportAssertion *ADL__VSremove_assertionReport = 0;
