/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_same_nvlist_ptr(VSNVList_ptr *, VSNVList_ptr *);

extern int cleanup_nvlist_ptr(VSNVList_ptr *);

extern int out_of_bounds(VSNVList_ptr *, VSULong);

extern int out_of_bounds_for_remove(VSNVList_ptr *, VSULong);

extern int has_been_removed(VSNVList_ptr *);

extern unsigned long count(VSNVList_ptr *);

extern int item_count_is_good(VSNVList_ptr *);

extern int count_is_good(VSNVList_ptr *);

extern int name_is_good(VSNamedValue_ptr *);

extern int flags_are_good(VSNamedValue_ptr *);

extern int nvalue_is_good(VSNamedValue_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSNVList_ptr_P)(VSNVList_ptr*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSFlags_P)(VSFlags*, emitter_t);
extern void (*ADL__print_VSNamedValue_ptr_P)(VSNamedValue_ptr*, emitter_t);
extern void (*ADL__print_VSString)(VSString, emitter_t);
extern void (*ADL__print_VSStatus)(VSStatus, emitter_t);

/* Declarations of wrapper of FUT */
extern VSNVList_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSNVList_ptr *(*ADL__VSduplicate_wrapper)(VSNVList_ptr*, VSEnvironment*);
extern VSULong (*ADL__VScount_wrapper)(VSNVList_ptr*, VSEnvironment*);
extern VSNamedValue_ptr *(*ADL__VSadd_wrapper)(VSNVList_ptr*, VSFlags*, VSEnvironment*);
extern VSNamedValue_ptr *(*ADL__VSadd_item_wrapper)(VSNVList_ptr*, VSString, VSFlags*, VSEnvironment*);
extern VSNamedValue_ptr *(*ADL__VSadd_item_consume_wrapper)(VSNVList_ptr*, VSString, VSFlags*, VSEnvironment*);
extern VSNamedValue_ptr *(*ADL__VSitem_wrapper)(VSNVList_ptr*, VSULong, VSEnvironment*);
extern VSStatus (*ADL__VSremove_wrapper)(VSNVList_ptr*, VSULong, VSEnvironment*);

#endif
