/* ADL test driver from t1.tdr
 *
 * test VScreate_request(object_ptr, context_ptr, operation, nvlist_ptr, nvalue_ptr, req_ptr, flags, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_53[] = {
    {"valid", Pobject_ptr_v_valid, 0},
    {"nil", Pobject_ptr_v_nil, 0},
    {"invalid", Pobject_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_54[] = {
    {"valid", Pcontext_ptr_v_valid, 0},
    {"nil", Pcontext_ptr_v_nil, 0},
    {"null", Pcontext_ptr_v_null, 0},
    {"invalid", Pcontext_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_55[] = {
    {"valid", Pnvlist_ptr_v_valid, 0},
    {"valid1", Pnvlist_ptr_v_valid1, 0},
    {"nil", Pnvlist_ptr_v_nil, 0},
    {"null", Pnvlist_ptr_v_null, 0},
    {"invalid", Pnvlist_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_56[] = {
    {"valid", Pnvalue_ptr_v_valid, 0},
    {"nil", Pnvalue_ptr_v_nil, 0},
    {"null", Pnvalue_ptr_v_null, 0},
    {"invalid", Pnvalue_ptr_v_invalid, 0},
    {0, 0, 0}
};

/* values for literal variable operation */
static VSChar* ADL__litvar_val_58[] = {
    "increment",
};

static struct ADL__propertyValue ADL__litvar_info_57[] = {
    {"\"increment\"", 0, ADL__litvar_val_58},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_59[] = {
    {"v", "prop", ADL__prop_values_53, 3},
    {"v", "prop", ADL__prop_values_54, 4},
    {"operation", "litvar", ADL__litvar_info_57, 1},
    {"v", "prop", ADL__prop_values_55, 5},
    {"v", "prop", ADL__prop_values_56, 4},
    {0, 0, 0}
};
#define TVEC_SIZE 5

static struct ADL__variableInfo ADL__var_info_68[9] = {
    {"object_ptr", "VSObject_ptr *", ADL__prop_info_59, 0, 1},
    {"context_ptr", "VSContext_ptr *", ADL__prop_info_59, 1, 1},
    {"operation", "VSChar *", ADL__prop_info_59, 2, 1},
    {"nvlist_ptr", "VSNVList_ptr *", ADL__prop_info_59, 3, 1},
    {"nvalue_ptr", "VSNamedValue_ptr *", ADL__prop_info_59, 4, 1},
    {"req_ptr", "VSRequest_ptr *", ADL__prop_info_59, 5, 0},
    {"flags", "VSFlags *", ADL__prop_info_59, 5, 0},
    {"env", "VSEnvironment *", ADL__prop_info_59, 5, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 8


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScreate_request_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSCONTEXT_PTR_P
#define ADL__PRINT_VSCONTEXT_PTR_P
void (*ADL__print_VSContext_ptr_P)(VSContext_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTEXT_PTR_P */
#ifndef ADL__PRINT_VSCHAR_P
#define ADL__PRINT_VSCHAR_P
void (*ADL__print_VSChar_P)(VSChar*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCHAR_P */
#ifndef ADL__PRINT_VSNVLIST_PTR_P
#define ADL__PRINT_VSNVLIST_PTR_P
void (*ADL__print_VSNVList_ptr_P)(VSNVList_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSNVLIST_PTR_P */
#ifndef ADL__PRINT_VSNAMEDVALUE_PTR_P
#define ADL__PRINT_VSNAMEDVALUE_PTR_P
void (*ADL__print_VSNamedValue_ptr_P)(VSNamedValue_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSNAMEDVALUE_PTR_P */
#ifndef ADL__PRINT_VSREQUEST_PTR_P
#define ADL__PRINT_VSREQUEST_PTR_P
void (*ADL__print_VSRequest_ptr_P)(VSRequest_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSREQUEST_PTR_P */
#ifndef ADL__PRINT_VSFLAGS_P
#define ADL__PRINT_VSFLAGS_P
void (*ADL__print_VSFlags_P)(VSFlags*, emitter_t) = 0;

#endif /* ADL__PRINT_VSFLAGS_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContext_ptr_P (void* val, emitter_t emitter)
{
  VSContext_ptr *tmp;

  if (ADL__print_VSContext_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSContext_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSChar_P (void* val, emitter_t emitter)
{
  VSChar *tmp;

  if (ADL__print_VSChar_P != 0) {
    tmp = *(VSChar**) val;
    ADL__print_VSChar_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter)
{
  VSNVList_ptr *tmp;

  if (ADL__print_VSNVList_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSNVList_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t emitter)
{
  VSNamedValue_ptr *tmp;

  if (ADL__print_VSNamedValue_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSNamedValue_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter)
{
  VSRequest_ptr *tmp;

  if (ADL__print_VSRequest_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSRequest_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSFlags_P (void* val, emitter_t emitter)
{
  VSFlags *tmp;

  if (ADL__print_VSFlags_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSFlags_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {3, 4, 1, 5, 4};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSObject_ptr *object_ptr_60;
    VSContext_ptr *context_ptr_61;
    VSChar *operation_62;
    VSNVList_ptr *nvlist_ptr_63;
    VSNamedValue_ptr *nvalue_ptr_64;
    VSRequest_ptr *req_ptr_65;
    VSFlags *flags_66;
    VSEnvironment *env_67;
    VSStatus fut_return_52;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScreate_request_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScreate_request_InfoArrayIdx,
        ADL__VScreate_request_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_object_ptr(&object_ptr_60, ADL__prop_values_53[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSObject_ptr_P(&object_ptr_60, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_context_ptr(&context_ptr_61, ADL__prop_values_54[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSContext_ptr_P(&context_ptr_61, rf->variableReport->emitVariable);

       operation_62 = ADL__litvar_val_58[tvec[2]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 2, tvec + 2, 1);
       ADL__emit_VSChar_P(&operation_62, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_nvlist_ptr(&nvlist_ptr_63, ADL__prop_values_55[tvec[3]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 1);
       ADL__emit_VSNVList_ptr_P(&nvlist_ptr_63, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(4);
       if (!provide_nvalue_ptr(&nvalue_ptr_64, ADL__prop_values_56[tvec[4]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 4, tvec + 4, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_4;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 4, tvec + 4, 1);
       ADL__emit_VSNamedValue_ptr_P(&nvalue_ptr_64, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(5);
       if (!provide_req_ptr(&req_ptr_65)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 5, tvec + 5, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_5;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 5, tvec + 5, 0);
       ADL__emit_VSRequest_ptr_P(&req_ptr_65, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(5);
       if (!provide_flags(&flags_66)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 6, tvec + 5, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_6;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 6, tvec + 5, 0);
       ADL__emit_VSFlags_P(&flags_66, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(5);
       if (!provide_env(&env_67)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 7, tvec + 5, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_7;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 7, tvec + 5, 0);
       ADL__emit_VSEnvironment_P(&env_67, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScreate_request_assertionReport = rf->assertionReport;
       fut_return_52 = ADL__ACF_VScreate_request(object_ptr_60, context_ptr_61, operation_62, nvlist_ptr_63, nvalue_ptr_64, req_ptr_65, flags_66, env_67);
       test_value = ADL__VScreate_request_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(5);
       relvec[7] = relinquish_env(&env_67);
SKIP_7:
      ADL__set_TDDVarNum(5);
       relvec[6] = relinquish_flags(&flags_66);
SKIP_6:
      ADL__set_TDDVarNum(5);
       relvec[5] = relinquish_req_ptr(&req_ptr_65);
SKIP_5:
      ADL__set_TDDVarNum(4);
       relvec[4] = relinquish_nvalue_ptr(&nvalue_ptr_64, ADL__prop_values_56[tvec[4]].propValCode);
SKIP_4:
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_nvlist_ptr(&nvlist_ptr_63, ADL__prop_values_55[tvec[3]].propValCode);
SKIP_3:
       relvec[2] = 1;	/* relinquish succeeds for operation_62 */
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_context_ptr(&context_ptr_61, ADL__prop_values_54[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_object_ptr(&object_ptr_60, ADL__prop_values_53[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_68,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScreate_request_head);

    return 0;
}


struct ADL__Directive_info VScreate_request1_info = {
    N_VARS,
    ADL__var_info_68
};

struct ADL__TDD_info ADL__test_info = {
    240,
    &ADL__VScreate_request_InfoArrayIdx,
    ADL__VScreate_request_InfoArray,
    ADL__test_driver,
    "VScreate_request",
    "VScreate_request1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScreate_request1",
    "t1_tr.rif",
    &VScreate_request1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

