/* ADL test driver from t1.tdr
 *
 * test VSsend_deferred(ts_send_deferred_req_ptr, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop ops */
static struct ADL__propertyValue ADL__prop_values_505[] = {
    {"CharOp", Pops_CharOp, 0},
    {"OctetOp", Pops_OctetOp, 0},
    {"BooleanOp", Pops_BooleanOp, 0},
    {"ShortOp", Pops_ShortOp, 0},
    {"LongOp", Pops_LongOp, 0},
    {"FloatOp", Pops_FloatOp, 0},
    {"DoubleOp", Pops_DoubleOp, 0},
    {"StringOp", Pops_StringOp, 0},
    {"UShortOp", Pops_UShortOp, 0},
    {"ULongOp", Pops_ULongOp, 0},
    {"Invalid", Pops_Invalid, 0},
    {0, 0, 0}
};

/* values for prop flags */
static struct ADL__propertyValue ADL__prop_values_506[] = {
    {"NoOutListMemory", Pflags_NoOutListMemory, 0},
    {"OutListMemory", Pflags_OutListMemory, 0},
    {0, 0, 0}
};

/* values for prop action%action */
static struct ADL__propertyValue ADL__prop_values_507[] = {
    {"SendDeferred", Paction_SendDeferred, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_508[] = {
    {"=ops", "prop", ADL__prop_values_505, 11},
    {"=flags", "prop", ADL__prop_values_506, 2},
    {"action%action", "prop", ADL__prop_values_507, 1},
    {0, 0, 0}
};
#define TVEC_SIZE 3

static struct ADL__variableInfo ADL__var_info_511[3] = {
    {"ts_send_deferred_req_ptr", "VSRequest_ptr *", ADL__prop_info_508, 0, 3},
    {"env", "VSEnvironment *", ADL__prop_info_508, 3, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSsend_deferred_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSREQUEST_PTR_P
#define ADL__PRINT_VSREQUEST_PTR_P
void (*ADL__print_VSRequest_ptr_P)(VSRequest_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSREQUEST_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSREQUESTSEQ_P
#define ADL__PRINT_VSREQUESTSEQ_P
void (*ADL__print_VSRequestSeq_P)(VSRequestSeq*, emitter_t) = 0;

#endif /* ADL__PRINT_VSREQUESTSEQ_P */

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter)
{
  VSRequest_ptr *tmp;

  if (ADL__print_VSRequest_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSRequest_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRequestSeq_P (void* val, emitter_t emitter)
{
  VSRequestSeq *tmp;

  if (ADL__print_VSRequestSeq_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSRequestSeq_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {11, 2, 1};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSRequest_ptr *ts_send_deferred_req_ptr_509;
    VSEnvironment *env_510;
    VSRequest_ptr *fut_return_504;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSsend_deferred_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSsend_deferred_InfoArrayIdx,
        ADL__VSsend_deferred_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_ts_req_ptr(&ts_send_deferred_req_ptr_509, ADL__prop_values_505[tvec[0]].propValCode, ADL__prop_values_506[tvec[1]].propValCode, ADL__prop_values_507[tvec[2]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 3);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 3);
       ADL__emit_VSRequest_ptr_P(&ts_send_deferred_req_ptr_509, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_env(&env_510)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 3, 0);
       ADL__emit_VSEnvironment_P(&env_510, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSsend_deferred_assertionReport = rf->assertionReport;
       fut_return_504 = ADL__ACF_VSsend_deferred(ts_send_deferred_req_ptr_509, env_510);
       test_value = ADL__VSsend_deferred_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(3);
       relvec[1] = relinquish_env(&env_510);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_ts_req_ptr(&ts_send_deferred_req_ptr_509, ADL__prop_values_505[tvec[0]].propValCode, ADL__prop_values_506[tvec[1]].propValCode, ADL__prop_values_507[tvec[2]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_511,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSsend_deferred_head);

    return 0;
}


struct ADL__Directive_info VSsend_deferred1_info = {
    N_VARS,
    ADL__var_info_511
};

struct ADL__TDD_info ADL__test_info = {
    22,
    &ADL__VSsend_deferred_InfoArrayIdx,
    ADL__VSsend_deferred_InfoArray,
    ADL__test_driver,
    "VSsend_deferred",
    "VSsend_deferred1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSsend_deferred1",
    "t1_tr.rif",
    &VSsend_deferred1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

