/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSadd_arg
 *
 */
VSRequest_ptr *ADL__ACF_VSadd_arg (VSRequest_ptr *req_21, VSEnvironment *ev_10){

VSRequest_ptr *VSadd_arg_RtnVal_4;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_23;
  int tmp_25;
  int tmp_26;
  VSEnvironment *ev_10_tmp_30;
    int tmp_31;
  int tmp_32;
  int groupExpr_41;
  int groupExpr_42;
  int tmp_33;
  VSRequest_ptr *req_21_tmp_36;
  int tmp_37;
  VSRequest_ptr *req_21_tmp_40;

/* Declare vars for result of normal and exception bindings */
  int VSadd_arg_NormalOutcome_5, VSadd_arg_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSadd_arg_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSadd_arg_InfoArray, 0, ADL__VSadd_arg_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSadd_arg_assertionReport->setPhase(ADL__VSadd_arg_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_arg_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSadd_arg_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSadd_arg_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSadd_arg_InfoArray[forLoopIdx_1].error > VSadd_arg_ACF_Result_3))
  VSadd_arg_ACF_Result_3 = ADL__VSadd_arg_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSadd_arg_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSadd_arg_assertionReport->setPhase(ADL__VSadd_arg_assertionReport, PH_call);
  ADL__release(ADL__VSadd_arg_assertionReport->parent, &this_seq);
  VSadd_arg_RtnVal_4 = ADL__VSadd_arg_wrapper(req_21, ev_10);
  ADL__recover(ADL__VSadd_arg_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSadd_arg_assertionReport->setPhase(ADL__VSadd_arg_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 7,&tmp_7);
  VSadd_arg_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 2,&tmp_13);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSadd_arg_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 1,&tmp_12);

  VSadd_arg_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSadd_arg_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_arg_InfoArray[0].result = (VSadd_arg_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_arg_InfoArray[0].evaluated = 1;
  ADL__VSadd_arg_InfoArray[0].value = (VSadd_arg_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSadd_arg_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_arg_InfoArray[6].result = (VSadd_arg_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_arg_InfoArray[6].evaluated = 1;
  ADL__VSadd_arg_InfoArray[6].value = (VSadd_arg_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSadd_arg_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSadd_arg_ACF_Result_3 = ADL__VSadd_arg_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSadd_arg_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSadd_arg_ACF_Result_3 = ADL__VSadd_arg_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSadd_arg_ExceptionOutcome_6 && !VSadd_arg_NormalOutcome_5) {
  VSadd_arg_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSadd_arg_ExceptionOutcome_6 && VSadd_arg_NormalOutcome_5) {
  VSadd_arg_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 10,&VSadd_arg_ExceptionOutcome_6);
  ev_10_tmp_30 = ev_10;
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 13,&ev_10_tmp_30);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_26 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 12,&tmp_26);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = !tmp_26;
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 11,&tmp_25);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = (!VSadd_arg_ExceptionOutcome_6 || tmp_25);
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 9,&tmp_23);
    ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSadd_arg_NormalOutcome_5){
      req_21_tmp_36 = req_21;
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 16,&req_21_tmp_36);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[15]);

/* Evaluate execute_request(req) */
  tmp_33 = execute_request(req_21);
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 15,&tmp_33);
  groupExpr_41 = (tmp_33);
  req_21_tmp_40 = req_21;
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 18,&req_21_tmp_40);
  ADL__VSadd_arg_assertionReport->exprMark(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_assertionReport->assrt_info[17]);

/* Evaluate check_request_executed(req) */
  tmp_37 = check_request_executed(req_21);
  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 17,&tmp_37);
  groupExpr_42 = (tmp_37);
  tmp_32 = (groupExpr_41 && groupExpr_42);
  tmp_31 = tmp_32;
  }
  else {
    ADL__resetInfoStruct(ADL__VSadd_arg_InfoArray, 14, 18);
  tmp_31 = 1;
}

  ADL__setResultAndError(ADL__VSadd_arg_InfoArray, 14,&tmp_31);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_arg_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSadd_arg_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSadd_arg_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSadd_arg_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSadd_arg_InfoArray[forLoopIdx_1].level == 0))
        VSadd_arg_ACF_Result_3 = calculate_ACF_result(VSadd_arg_ACF_Result_3, ADL__VSadd_arg_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSadd_arg_assertionReport->value = VSadd_arg_ACF_Result_3;
  ADL__VSadd_arg_assertionReport->parent->openReport(ADL__VSadd_arg_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_arg_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSadd_arg_assertionReport->emitTest(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_InfoArray[forLoopIdx_1])) {
     ADL__VSadd_arg_assertionReport->exprStart(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_InfoArray[forLoopIdx_1]);
      if(!ADL__VSadd_arg_InfoArray[forLoopIdx_1].testable || !ADL__VSadd_arg_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSadd_arg_assertionReport->emitter);
      else if (ADL__VSadd_arg_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSadd_arg_InfoArray[forLoopIdx_1].error, ADL__VSadd_arg_assertionReport->emitter);
      else
        ADL__VSadd_arg_InfoArray[forLoopIdx_1].emitFunc(ADL__VSadd_arg_InfoArray[forLoopIdx_1].value, ADL__VSadd_arg_assertionReport->emitter);
     ADL__VSadd_arg_assertionReport->exprEnd(ADL__VSadd_arg_assertionReport, &ADL__VSadd_arg_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSadd_arg_RtnVal_4);
}


VSRequest_ptr *(*ADL__VSadd_arg_wrapper)(VSRequest_ptr*, VSEnvironment*) = VSadd_arg;

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSadd_arg_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "execute_request(req)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {4, 17, 14, 0, 0, "check_request_executed(req)", 17, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 18, 17, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VSadd_arg_InfoArrayIdx = 19;

struct ADL__reportAssertion *ADL__VSadd_arg_assertionReport = 0;

/*
 *
 * ACF of VSinvoke
 *
 */
VSStatus ADL__ACF_VSinvoke (VSRequest_ptr *req_62, VSEnvironment *ev_51){

VSStatus VSinvoke_RtnVal_45;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_64;
  int tmp_66;
  int tmp_67;
  VSEnvironment *ev_51_tmp_71;
    int tmp_72;
  int tmp_74;
  int tmp_75;
  VSEnvironment *ev_51_tmp_78;
    int tmp_80;
  int tmp_81;
  VSRequest_ptr *req_62_tmp_84;
  int tmp_85;
  VSEnvironment *ev_51_tmp_89;
    int tmp_90;
  int tmp_91;
  int groupExpr_96;
  int tmp_92;
  VSRequest_ptr *req_62_tmp_95;

/* Declare vars for result of normal and exception bindings */
  int VSinvoke_NormalOutcome_46, VSinvoke_ExceptionOutcome_47;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_48;
  VSEnvironment *ev_51_tmp_52;
    int tmp_53;
  int tmp_54;
  VSEnvironment *ev_51_tmp_57;
  int tmp_58;
  VSEnvironment *ev_51_tmp_61;
  enum ADL__ACF_result VSinvoke_ACF_Result_44 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSinvoke_InfoArray, 0, ADL__VSinvoke_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSinvoke_assertionReport->setPhase(ADL__VSinvoke_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSinvoke_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSinvoke_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSinvoke_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSinvoke_InfoArray[forLoopIdx_1].error > VSinvoke_ACF_Result_44))
  VSinvoke_ACF_Result_44 = ADL__VSinvoke_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSinvoke_ACF_Result_44 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSinvoke_assertionReport->setPhase(ADL__VSinvoke_assertionReport, PH_call);
  ADL__release(ADL__VSinvoke_assertionReport->parent, &this_seq);
  VSinvoke_RtnVal_45 = ADL__VSinvoke_wrapper(req_62, ev_51);
  ADL__recover(ADL__VSinvoke_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSinvoke_assertionReport->setPhase(ADL__VSinvoke_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_51_tmp_52 = ev_51;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 8,&ev_51_tmp_52);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_48 = no_exception(ev_51);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 7,&tmp_48);
  VSinvoke_NormalOutcome_46 = (tmp_48);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_51_tmp_57 = ev_51;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 3,&ev_51_tmp_57);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_54 = system_exception(ev_51);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 2,&tmp_54);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_53 = tmp_54;
  if (!tmp_54) {
      ev_51_tmp_61 = ev_51;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 5,&ev_51_tmp_61);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_58 = user_exception(ev_51);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 4,&tmp_58);
    tmp_53 = tmp_58;
  }
  else {
  ADL__resetInfoStruct(ADL__VSinvoke_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 1,&tmp_53);

  VSinvoke_ExceptionOutcome_47 = (tmp_53);

/* Exception binding is the first assertion */
  if (ADL__VSinvoke_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSinvoke_InfoArray[0].result = (VSinvoke_ExceptionOutcome_47 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSinvoke_InfoArray[0].evaluated = 1;
  ADL__VSinvoke_InfoArray[0].value = (VSinvoke_ExceptionOutcome_47 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSinvoke_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSinvoke_InfoArray[6].result = (VSinvoke_NormalOutcome_46 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSinvoke_InfoArray[6].evaluated = 1;
  ADL__VSinvoke_InfoArray[6].value = (VSinvoke_NormalOutcome_46 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSinvoke_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSinvoke_ACF_Result_44 = ADL__VSinvoke_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSinvoke_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSinvoke_ACF_Result_44 = ADL__VSinvoke_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSinvoke_ExceptionOutcome_47 && !VSinvoke_NormalOutcome_46) {
  VSinvoke_ACF_Result_44 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSinvoke_ExceptionOutcome_47 && VSinvoke_NormalOutcome_46) {
  VSinvoke_ACF_Result_44 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSinvoke_InfoArray, 10,&VSinvoke_ExceptionOutcome_47);
  ev_51_tmp_71 = ev_51;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 13,&ev_51_tmp_71);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_67 = user_exception_is("NOT_IMPLEMENTED", ev_51);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 12,&tmp_67);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_66 = !tmp_67;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 11,&tmp_66);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_64 = (!VSinvoke_ExceptionOutcome_47 || tmp_66);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 9,&tmp_64);
    ADL__setResultAndError(ADL__VSinvoke_InfoArray, 15,&VSinvoke_ExceptionOutcome_47);
  ev_51_tmp_78 = ev_51;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 18,&ev_51_tmp_78);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_75 = user_exception(ev_51);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 17,&tmp_75);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_74 = !tmp_75;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 16,&tmp_74);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_72 = (!VSinvoke_ExceptionOutcome_47 || tmp_74);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 14,&tmp_72);
    req_62_tmp_84 = req_62;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 21,&req_62_tmp_84);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[20]);

/* Evaluate is_nil_request_ptr(req) */
  tmp_81 = is_nil_request_ptr(req_62);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 20,&tmp_81);
  ev_51_tmp_89 = ev_51;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 23,&ev_51_tmp_89);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[22]);

/* Evaluate system_exception_is("BAD_PARAM", ev) */
  tmp_85 = system_exception_is("BAD_PARAM", ev_51);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 22,&tmp_85);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[19]);

/* Evaluate is_nil_request_ptr(req) --> system_exception_is("BAD_PARAM", ev) */
  tmp_80 = (!tmp_81 || tmp_85);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 19,&tmp_80);
    ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VSinvoke_NormalOutcome_46){
      req_62_tmp_95 = req_62;
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 26,&req_62_tmp_95);
  ADL__VSinvoke_assertionReport->exprMark(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_assertionReport->assrt_info[25]);

/* Evaluate check_request_executed(req) */
  tmp_92 = check_request_executed(req_62);
  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 25,&tmp_92);
  groupExpr_96 = (tmp_92);
  tmp_91 = (groupExpr_96);
  tmp_90 = tmp_91;
  }
  else {
    ADL__resetInfoStruct(ADL__VSinvoke_InfoArray, 24, 26);
  tmp_90 = 1;
}

  ADL__setResultAndError(ADL__VSinvoke_InfoArray, 24,&tmp_90);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSinvoke_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSinvoke_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSinvoke_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSinvoke_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSinvoke_InfoArray[forLoopIdx_1].level == 0))
        VSinvoke_ACF_Result_44 = calculate_ACF_result(VSinvoke_ACF_Result_44, ADL__VSinvoke_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSinvoke_assertionReport->value = VSinvoke_ACF_Result_44;
  ADL__VSinvoke_assertionReport->parent->openReport(ADL__VSinvoke_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSinvoke_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSinvoke_assertionReport->emitTest(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_InfoArray[forLoopIdx_1])) {
     ADL__VSinvoke_assertionReport->exprStart(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_InfoArray[forLoopIdx_1]);
      if(!ADL__VSinvoke_InfoArray[forLoopIdx_1].testable || !ADL__VSinvoke_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSinvoke_assertionReport->emitter);
      else if (ADL__VSinvoke_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSinvoke_InfoArray[forLoopIdx_1].error, ADL__VSinvoke_assertionReport->emitter);
      else
        ADL__VSinvoke_InfoArray[forLoopIdx_1].emitFunc(ADL__VSinvoke_InfoArray[forLoopIdx_1].value, ADL__VSinvoke_assertionReport->emitter);
     ADL__VSinvoke_assertionReport->exprEnd(ADL__VSinvoke_assertionReport, &ADL__VSinvoke_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSinvoke_RtnVal_45);
}


VSStatus (*ADL__VSinvoke_wrapper)(VSRequest_ptr*, VSEnvironment*) = VSinvoke;

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSinvoke_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_request_ptr(req) --> system_exception_is(\"BAD_PARAM\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_request_ptr(req)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {3, 22, 19, 0, 0, "system_exception_is(\"BAD_PARAM\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "check_request_executed(req)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VSinvoke_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VSinvoke_assertionReport = 0;

/*
 *
 * ACF of VSsend_deferred
 *
 */
VSRequest_ptr *ADL__ACF_VSsend_deferred (VSRequest_ptr *req_116, VSEnvironment *ev_105){

VSRequest_ptr *VSsend_deferred_RtnVal_99;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_118;
  int tmp_120;
  int tmp_121;
  VSEnvironment *ev_105_tmp_125;
    int tmp_126;
  int tmp_128;
  int tmp_129;
  VSEnvironment *ev_105_tmp_132;
    int tmp_134;
  int tmp_135;
  VSRequest_ptr *req_116_tmp_138;
  int tmp_139;
  VSEnvironment *ev_105_tmp_143;
    int tmp_144;
  int tmp_145;
  int groupExpr_154;
  int groupExpr_155;
  int tmp_146;
  VSRequest_ptr *req_116_tmp_149;
  int tmp_150;
  VSRequest_ptr *req_116_tmp_153;

/* Declare vars for result of normal and exception bindings */
  int VSsend_deferred_NormalOutcome_100, VSsend_deferred_ExceptionOutcome_101;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_102;
  VSEnvironment *ev_105_tmp_106;
    int tmp_107;
  int tmp_108;
  VSEnvironment *ev_105_tmp_111;
  int tmp_112;
  VSEnvironment *ev_105_tmp_115;
  enum ADL__ACF_result VSsend_deferred_ACF_Result_98 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSsend_deferred_InfoArray, 0, ADL__VSsend_deferred_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSsend_deferred_assertionReport->setPhase(ADL__VSsend_deferred_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_deferred_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSsend_deferred_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSsend_deferred_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSsend_deferred_InfoArray[forLoopIdx_1].error > VSsend_deferred_ACF_Result_98))
  VSsend_deferred_ACF_Result_98 = ADL__VSsend_deferred_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSsend_deferred_ACF_Result_98 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSsend_deferred_assertionReport->setPhase(ADL__VSsend_deferred_assertionReport, PH_call);
  ADL__release(ADL__VSsend_deferred_assertionReport->parent, &this_seq);
  VSsend_deferred_RtnVal_99 = ADL__VSsend_deferred_wrapper(req_116, ev_105);
  ADL__recover(ADL__VSsend_deferred_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSsend_deferred_assertionReport->setPhase(ADL__VSsend_deferred_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_105_tmp_106 = ev_105;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 8,&ev_105_tmp_106);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_102 = no_exception(ev_105);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 7,&tmp_102);
  VSsend_deferred_NormalOutcome_100 = (tmp_102);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_105_tmp_111 = ev_105;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 3,&ev_105_tmp_111);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_108 = system_exception(ev_105);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 2,&tmp_108);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_107 = tmp_108;
  if (!tmp_108) {
      ev_105_tmp_115 = ev_105;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 5,&ev_105_tmp_115);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_112 = user_exception(ev_105);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 4,&tmp_112);
    tmp_107 = tmp_112;
  }
  else {
  ADL__resetInfoStruct(ADL__VSsend_deferred_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 1,&tmp_107);

  VSsend_deferred_ExceptionOutcome_101 = (tmp_107);

/* Exception binding is the first assertion */
  if (ADL__VSsend_deferred_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSsend_deferred_InfoArray[0].result = (VSsend_deferred_ExceptionOutcome_101 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSsend_deferred_InfoArray[0].evaluated = 1;
  ADL__VSsend_deferred_InfoArray[0].value = (VSsend_deferred_ExceptionOutcome_101 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSsend_deferred_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSsend_deferred_InfoArray[6].result = (VSsend_deferred_NormalOutcome_100 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSsend_deferred_InfoArray[6].evaluated = 1;
  ADL__VSsend_deferred_InfoArray[6].value = (VSsend_deferred_NormalOutcome_100 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSsend_deferred_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSsend_deferred_ACF_Result_98 = ADL__VSsend_deferred_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSsend_deferred_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSsend_deferred_ACF_Result_98 = ADL__VSsend_deferred_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSsend_deferred_ExceptionOutcome_101 && !VSsend_deferred_NormalOutcome_100) {
  VSsend_deferred_ACF_Result_98 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSsend_deferred_ExceptionOutcome_101 && VSsend_deferred_NormalOutcome_100) {
  VSsend_deferred_ACF_Result_98 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 10,&VSsend_deferred_ExceptionOutcome_101);
  ev_105_tmp_125 = ev_105;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 13,&ev_105_tmp_125);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_121 = user_exception_is("NOT_IMPLEMENTED", ev_105);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 12,&tmp_121);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_120 = !tmp_121;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 11,&tmp_120);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_118 = (!VSsend_deferred_ExceptionOutcome_101 || tmp_120);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 9,&tmp_118);
    ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 15,&VSsend_deferred_ExceptionOutcome_101);
  ev_105_tmp_132 = ev_105;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 18,&ev_105_tmp_132);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_129 = user_exception(ev_105);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 17,&tmp_129);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_128 = !tmp_129;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 16,&tmp_128);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_126 = (!VSsend_deferred_ExceptionOutcome_101 || tmp_128);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 14,&tmp_126);
    req_116_tmp_138 = req_116;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 21,&req_116_tmp_138);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[20]);

/* Evaluate is_nil_request_ptr(req) */
  tmp_135 = is_nil_request_ptr(req_116);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 20,&tmp_135);
  ev_105_tmp_143 = ev_105;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 23,&ev_105_tmp_143);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[22]);

/* Evaluate system_exception_is("BAD_PARAM", ev) */
  tmp_139 = system_exception_is("BAD_PARAM", ev_105);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 22,&tmp_139);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[19]);

/* Evaluate is_nil_request_ptr(req) --> system_exception_is("BAD_PARAM", ev) */
  tmp_134 = (!tmp_135 || tmp_139);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 19,&tmp_134);
    ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VSsend_deferred_NormalOutcome_100){
      req_116_tmp_149 = req_116;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 26,&req_116_tmp_149);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[25]);

/* Evaluate check_request_sent(req) */
  tmp_146 = check_request_sent(req_116);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 25,&tmp_146);
  groupExpr_154 = (tmp_146);
  req_116_tmp_153 = req_116;
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 28,&req_116_tmp_153);
  ADL__VSsend_deferred_assertionReport->exprMark(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_assertionReport->assrt_info[27]);

/* Evaluate check_request_executed(req) */
  tmp_150 = check_request_executed(req_116);
  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 27,&tmp_150);
  groupExpr_155 = (tmp_150);
  tmp_145 = (groupExpr_154 && groupExpr_155);
  tmp_144 = tmp_145;
  }
  else {
    ADL__resetInfoStruct(ADL__VSsend_deferred_InfoArray, 24, 28);
  tmp_144 = 1;
}

  ADL__setResultAndError(ADL__VSsend_deferred_InfoArray, 24,&tmp_144);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_deferred_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSsend_deferred_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSsend_deferred_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSsend_deferred_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSsend_deferred_InfoArray[forLoopIdx_1].level == 0))
        VSsend_deferred_ACF_Result_98 = calculate_ACF_result(VSsend_deferred_ACF_Result_98, ADL__VSsend_deferred_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSsend_deferred_assertionReport->value = VSsend_deferred_ACF_Result_98;
  ADL__VSsend_deferred_assertionReport->parent->openReport(ADL__VSsend_deferred_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_deferred_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSsend_deferred_assertionReport->emitTest(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_InfoArray[forLoopIdx_1])) {
     ADL__VSsend_deferred_assertionReport->exprStart(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_InfoArray[forLoopIdx_1]);
      if(!ADL__VSsend_deferred_InfoArray[forLoopIdx_1].testable || !ADL__VSsend_deferred_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSsend_deferred_assertionReport->emitter);
      else if (ADL__VSsend_deferred_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSsend_deferred_InfoArray[forLoopIdx_1].error, ADL__VSsend_deferred_assertionReport->emitter);
      else
        ADL__VSsend_deferred_InfoArray[forLoopIdx_1].emitFunc(ADL__VSsend_deferred_InfoArray[forLoopIdx_1].value, ADL__VSsend_deferred_assertionReport->emitter);
     ADL__VSsend_deferred_assertionReport->exprEnd(ADL__VSsend_deferred_assertionReport, &ADL__VSsend_deferred_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSsend_deferred_RtnVal_99);
}


VSRequest_ptr *(*ADL__VSsend_deferred_wrapper)(VSRequest_ptr*, VSEnvironment*) = VSsend_deferred;

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSsend_deferred_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_request_ptr(req) --> system_exception_is(\"BAD_PARAM\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_request_ptr(req)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {3, 22, 19, 0, 0, "system_exception_is(\"BAD_PARAM\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "check_request_sent(req)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {6, 27, 24, 0, 0, "check_request_executed(req)", 27, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 28, 27, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VSsend_deferred_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSsend_deferred_assertionReport = 0;

/*
 *
 * ACF of VSsend_oneway
 *
 */
VSRequest_ptr *ADL__ACF_VSsend_oneway (VSRequest_ptr *req_175, VSEnvironment *ev_164){

VSRequest_ptr *VSsend_oneway_RtnVal_158;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_177;
  int tmp_179;
  int tmp_180;
  VSEnvironment *ev_164_tmp_184;
    int tmp_185;
  int tmp_187;
  int tmp_188;
  VSEnvironment *ev_164_tmp_191;
    int tmp_193;
  int tmp_194;
  VSRequest_ptr *req_175_tmp_197;
  int tmp_198;
  VSEnvironment *ev_164_tmp_202;
    int tmp_204;
  int tmp_205;
  VSRequest_ptr *req_175_tmp_208;
  int tmp_209;
  VSEnvironment *ev_164_tmp_213;
    int tmp_214;
  int tmp_215;
  int groupExpr_220;

/* Declare vars for result of normal and exception bindings */
  int VSsend_oneway_NormalOutcome_159, VSsend_oneway_ExceptionOutcome_160;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_161;
  VSEnvironment *ev_164_tmp_165;
    int tmp_166;
  int tmp_167;
  VSEnvironment *ev_164_tmp_170;
  int tmp_171;
  VSEnvironment *ev_164_tmp_174;
  enum ADL__ACF_result VSsend_oneway_ACF_Result_157 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSsend_oneway_InfoArray, 0, ADL__VSsend_oneway_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSsend_oneway_assertionReport->setPhase(ADL__VSsend_oneway_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
          
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_oneway_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSsend_oneway_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSsend_oneway_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSsend_oneway_InfoArray[forLoopIdx_1].error > VSsend_oneway_ACF_Result_157))
  VSsend_oneway_ACF_Result_157 = ADL__VSsend_oneway_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSsend_oneway_ACF_Result_157 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSsend_oneway_assertionReport->setPhase(ADL__VSsend_oneway_assertionReport, PH_call);
  ADL__release(ADL__VSsend_oneway_assertionReport->parent, &this_seq);
  VSsend_oneway_RtnVal_158 = ADL__VSsend_oneway_wrapper(req_175, ev_164);
  ADL__recover(ADL__VSsend_oneway_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSsend_oneway_assertionReport->setPhase(ADL__VSsend_oneway_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_164_tmp_165 = ev_164;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 8,&ev_164_tmp_165);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_161 = no_exception(ev_164);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 7,&tmp_161);
  VSsend_oneway_NormalOutcome_159 = (tmp_161);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_164_tmp_170 = ev_164;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 3,&ev_164_tmp_170);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_167 = system_exception(ev_164);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 2,&tmp_167);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_166 = tmp_167;
  if (!tmp_167) {
      ev_164_tmp_174 = ev_164;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 5,&ev_164_tmp_174);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_171 = user_exception(ev_164);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 4,&tmp_171);
    tmp_166 = tmp_171;
  }
  else {
  ADL__resetInfoStruct(ADL__VSsend_oneway_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 1,&tmp_166);

  VSsend_oneway_ExceptionOutcome_160 = (tmp_166);

/* Exception binding is the first assertion */
  if (ADL__VSsend_oneway_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSsend_oneway_InfoArray[0].result = (VSsend_oneway_ExceptionOutcome_160 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSsend_oneway_InfoArray[0].evaluated = 1;
  ADL__VSsend_oneway_InfoArray[0].value = (VSsend_oneway_ExceptionOutcome_160 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSsend_oneway_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSsend_oneway_InfoArray[6].result = (VSsend_oneway_NormalOutcome_159 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSsend_oneway_InfoArray[6].evaluated = 1;
  ADL__VSsend_oneway_InfoArray[6].value = (VSsend_oneway_NormalOutcome_159 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSsend_oneway_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSsend_oneway_ACF_Result_157 = ADL__VSsend_oneway_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSsend_oneway_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSsend_oneway_ACF_Result_157 = ADL__VSsend_oneway_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSsend_oneway_ExceptionOutcome_160 && !VSsend_oneway_NormalOutcome_159) {
  VSsend_oneway_ACF_Result_157 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSsend_oneway_ExceptionOutcome_160 && VSsend_oneway_NormalOutcome_159) {
  VSsend_oneway_ACF_Result_157 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 10,&VSsend_oneway_ExceptionOutcome_160);
  ev_164_tmp_184 = ev_164;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 13,&ev_164_tmp_184);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_180 = user_exception_is("NOT_IMPLEMENTED", ev_164);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 12,&tmp_180);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_179 = !tmp_180;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 11,&tmp_179);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_177 = (!VSsend_oneway_ExceptionOutcome_160 || tmp_179);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 9,&tmp_177);
    ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 15,&VSsend_oneway_ExceptionOutcome_160);
  ev_164_tmp_191 = ev_164;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 18,&ev_164_tmp_191);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_188 = user_exception(ev_164);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 17,&tmp_188);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_187 = !tmp_188;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 16,&tmp_187);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_185 = (!VSsend_oneway_ExceptionOutcome_160 || tmp_187);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 14,&tmp_185);
    req_175_tmp_197 = req_175;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 21,&req_175_tmp_197);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[20]);

/* Evaluate is_nil_request_ptr(req) */
  tmp_194 = is_nil_request_ptr(req_175);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 20,&tmp_194);
  ev_164_tmp_202 = ev_164;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 23,&ev_164_tmp_202);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[22]);

/* Evaluate system_exception_is("BAD_PARAM", ev) */
  tmp_198 = system_exception_is("BAD_PARAM", ev_164);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 22,&tmp_198);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[19]);

/* Evaluate is_nil_request_ptr(req) --> system_exception_is("BAD_PARAM", ev) */
  tmp_193 = (!tmp_194 || tmp_198);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 19,&tmp_193);
    req_175_tmp_208 = req_175;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 26,&req_175_tmp_208);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[25]);

/* Evaluate is_invalid_request(req) */
  tmp_205 = is_invalid_request(req_175);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 25,&tmp_205);
  ev_164_tmp_213 = ev_164;
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 28,&ev_164_tmp_213);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[27]);

/* Evaluate system_exception_is("BAD_OPERATION", ev) */
  tmp_209 = system_exception_is("BAD_OPERATION", ev_164);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 27,&tmp_209);
  ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[24]);

/* Evaluate is_invalid_request(req) --> system_exception_is("BAD_OPERATION", ev) */
  tmp_204 = (!tmp_205 || tmp_209);
  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 24,&tmp_204);
    ADL__VSsend_oneway_assertionReport->exprMark(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_assertionReport->assrt_info[29]);

/* Evaluate normally { ... } */
  if(VSsend_oneway_NormalOutcome_159){
      tmp_215 = (groupExpr_220);
  tmp_214 = tmp_215;
  }
  else {
    ADL__resetInfoStruct(ADL__VSsend_oneway_InfoArray, 29, 31);
  tmp_214 = 1;
}

  ADL__setResultAndError(ADL__VSsend_oneway_InfoArray, 29,&tmp_214);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_oneway_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSsend_oneway_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSsend_oneway_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSsend_oneway_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSsend_oneway_InfoArray[forLoopIdx_1].level == 0))
        VSsend_oneway_ACF_Result_157 = calculate_ACF_result(VSsend_oneway_ACF_Result_157, ADL__VSsend_oneway_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSsend_oneway_assertionReport->value = VSsend_oneway_ACF_Result_157;
  ADL__VSsend_oneway_assertionReport->parent->openReport(ADL__VSsend_oneway_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_oneway_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSsend_oneway_assertionReport->emitTest(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_InfoArray[forLoopIdx_1])) {
     ADL__VSsend_oneway_assertionReport->exprStart(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_InfoArray[forLoopIdx_1]);
      if(!ADL__VSsend_oneway_InfoArray[forLoopIdx_1].testable || !ADL__VSsend_oneway_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSsend_oneway_assertionReport->emitter);
      else if (ADL__VSsend_oneway_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSsend_oneway_InfoArray[forLoopIdx_1].error, ADL__VSsend_oneway_assertionReport->emitter);
      else
        ADL__VSsend_oneway_InfoArray[forLoopIdx_1].emitFunc(ADL__VSsend_oneway_InfoArray[forLoopIdx_1].value, ADL__VSsend_oneway_assertionReport->emitter);
     ADL__VSsend_oneway_assertionReport->exprEnd(ADL__VSsend_oneway_assertionReport, &ADL__VSsend_oneway_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSsend_oneway_RtnVal_158);
}


VSRequest_ptr *(*ADL__VSsend_oneway_wrapper)(VSRequest_ptr*, VSEnvironment*) = VSsend_oneway;

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
static char *ADL__VSsend_oneway_assertionTag_30[] = { "U", 0 };

struct ADL__assertionReportStruct ADL__VSsend_oneway_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_request_ptr(req) --> system_exception_is(\"BAD_PARAM\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_request_ptr(req)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {3, 22, 19, 0, 0, "system_exception_is(\"BAD_PARAM\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 24, 24, 0, 0, "is_invalid_request(req) --> system_exception_is(\"BAD_OPERATION\", ev)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_invalid_request(req)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {4, 27, 24, 0, 0, "system_exception_is(\"BAD_OPERATION\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {5, 29, 29, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {6, 30, 29, 0, ADL__VSsend_oneway_assertionTag_30, "check_request_sent(req)", 30, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 0, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 31, 30, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 0, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VSsend_oneway_InfoArrayIdx = 32;

struct ADL__reportAssertion *ADL__VSsend_oneway_assertionReport = 0;

/*
 *
 * ACF of VSget_response
 *
 */
VSRequest_ptr *ADL__ACF_VSget_response (VSRequest_ptr *req_240, VSEnvironment *ev_229){

VSRequest_ptr *VSget_response_RtnVal_223;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_242;
  int tmp_244;
  int tmp_245;
  VSEnvironment *ev_229_tmp_249;
    int tmp_250;
  int tmp_252;
  int tmp_253;
  VSEnvironment *ev_229_tmp_256;
    int tmp_258;
  int tmp_259;
  VSRequest_ptr *req_240_tmp_262;
  int tmp_263;
  VSEnvironment *ev_229_tmp_267;
    int tmp_268;
  int tmp_269;
  int groupExpr_274;
  int tmp_270;
  VSRequest_ptr *req_240_tmp_273;

/* Declare vars for result of normal and exception bindings */
  int VSget_response_NormalOutcome_224, VSget_response_ExceptionOutcome_225;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_226;
  VSEnvironment *ev_229_tmp_230;
    int tmp_231;
  int tmp_232;
  VSEnvironment *ev_229_tmp_235;
  int tmp_236;
  VSEnvironment *ev_229_tmp_239;
  enum ADL__ACF_result VSget_response_ACF_Result_222 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSget_response_InfoArray, 0, ADL__VSget_response_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSget_response_assertionReport->setPhase(ADL__VSget_response_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_response_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSget_response_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSget_response_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSget_response_InfoArray[forLoopIdx_1].error > VSget_response_ACF_Result_222))
  VSget_response_ACF_Result_222 = ADL__VSget_response_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSget_response_ACF_Result_222 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSget_response_assertionReport->setPhase(ADL__VSget_response_assertionReport, PH_call);
  ADL__release(ADL__VSget_response_assertionReport->parent, &this_seq);
  VSget_response_RtnVal_223 = ADL__VSget_response_wrapper(req_240, ev_229);
  ADL__recover(ADL__VSget_response_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSget_response_assertionReport->setPhase(ADL__VSget_response_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_229_tmp_230 = ev_229;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 8,&ev_229_tmp_230);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_226 = no_exception(ev_229);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 7,&tmp_226);
  VSget_response_NormalOutcome_224 = (tmp_226);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_229_tmp_235 = ev_229;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 3,&ev_229_tmp_235);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_232 = system_exception(ev_229);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 2,&tmp_232);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_231 = tmp_232;
  if (!tmp_232) {
      ev_229_tmp_239 = ev_229;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 5,&ev_229_tmp_239);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_236 = user_exception(ev_229);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 4,&tmp_236);
    tmp_231 = tmp_236;
  }
  else {
  ADL__resetInfoStruct(ADL__VSget_response_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 1,&tmp_231);

  VSget_response_ExceptionOutcome_225 = (tmp_231);

/* Exception binding is the first assertion */
  if (ADL__VSget_response_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSget_response_InfoArray[0].result = (VSget_response_ExceptionOutcome_225 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_response_InfoArray[0].evaluated = 1;
  ADL__VSget_response_InfoArray[0].value = (VSget_response_ExceptionOutcome_225 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSget_response_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSget_response_InfoArray[6].result = (VSget_response_NormalOutcome_224 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_response_InfoArray[6].evaluated = 1;
  ADL__VSget_response_InfoArray[6].value = (VSget_response_NormalOutcome_224 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSget_response_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSget_response_ACF_Result_222 = ADL__VSget_response_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSget_response_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSget_response_ACF_Result_222 = ADL__VSget_response_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSget_response_ExceptionOutcome_225 && !VSget_response_NormalOutcome_224) {
  VSget_response_ACF_Result_222 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSget_response_ExceptionOutcome_225 && VSget_response_NormalOutcome_224) {
  VSget_response_ACF_Result_222 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSget_response_InfoArray, 10,&VSget_response_ExceptionOutcome_225);
  ev_229_tmp_249 = ev_229;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 13,&ev_229_tmp_249);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_245 = user_exception_is("NOT_IMPLEMENTED", ev_229);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 12,&tmp_245);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_244 = !tmp_245;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 11,&tmp_244);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_242 = (!VSget_response_ExceptionOutcome_225 || tmp_244);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 9,&tmp_242);
    ADL__setResultAndError(ADL__VSget_response_InfoArray, 15,&VSget_response_ExceptionOutcome_225);
  ev_229_tmp_256 = ev_229;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 18,&ev_229_tmp_256);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_253 = user_exception(ev_229);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 17,&tmp_253);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_252 = !tmp_253;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 16,&tmp_252);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_250 = (!VSget_response_ExceptionOutcome_225 || tmp_252);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 14,&tmp_250);
    req_240_tmp_262 = req_240;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 21,&req_240_tmp_262);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[20]);

/* Evaluate is_nil_request_ptr(req) */
  tmp_259 = is_nil_request_ptr(req_240);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 20,&tmp_259);
  ev_229_tmp_267 = ev_229;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 23,&ev_229_tmp_267);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[22]);

/* Evaluate system_exception_is("BAD_PARAM", ev) */
  tmp_263 = system_exception_is("BAD_PARAM", ev_229);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 22,&tmp_263);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[19]);

/* Evaluate is_nil_request_ptr(req) --> system_exception_is("BAD_PARAM", ev) */
  tmp_258 = (!tmp_259 || tmp_263);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 19,&tmp_258);
    ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VSget_response_NormalOutcome_224){
      req_240_tmp_273 = req_240;
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 26,&req_240_tmp_273);
  ADL__VSget_response_assertionReport->exprMark(ADL__VSget_response_assertionReport, &ADL__VSget_response_assertionReport->assrt_info[25]);

/* Evaluate check_request_executed(req) */
  tmp_270 = check_request_executed(req_240);
  ADL__setResultAndError(ADL__VSget_response_InfoArray, 25,&tmp_270);
  groupExpr_274 = (tmp_270);
  tmp_269 = (groupExpr_274);
  tmp_268 = tmp_269;
  }
  else {
    ADL__resetInfoStruct(ADL__VSget_response_InfoArray, 24, 26);
  tmp_268 = 1;
}

  ADL__setResultAndError(ADL__VSget_response_InfoArray, 24,&tmp_268);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_response_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSget_response_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSget_response_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSget_response_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSget_response_InfoArray[forLoopIdx_1].level == 0))
        VSget_response_ACF_Result_222 = calculate_ACF_result(VSget_response_ACF_Result_222, ADL__VSget_response_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSget_response_assertionReport->value = VSget_response_ACF_Result_222;
  ADL__VSget_response_assertionReport->parent->openReport(ADL__VSget_response_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_response_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSget_response_assertionReport->emitTest(ADL__VSget_response_assertionReport, &ADL__VSget_response_InfoArray[forLoopIdx_1])) {
     ADL__VSget_response_assertionReport->exprStart(ADL__VSget_response_assertionReport, &ADL__VSget_response_InfoArray[forLoopIdx_1]);
      if(!ADL__VSget_response_InfoArray[forLoopIdx_1].testable || !ADL__VSget_response_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSget_response_assertionReport->emitter);
      else if (ADL__VSget_response_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSget_response_InfoArray[forLoopIdx_1].error, ADL__VSget_response_assertionReport->emitter);
      else
        ADL__VSget_response_InfoArray[forLoopIdx_1].emitFunc(ADL__VSget_response_InfoArray[forLoopIdx_1].value, ADL__VSget_response_assertionReport->emitter);
     ADL__VSget_response_assertionReport->exprEnd(ADL__VSget_response_assertionReport, &ADL__VSget_response_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSget_response_RtnVal_223);
}


VSRequest_ptr *(*ADL__VSget_response_wrapper)(VSRequest_ptr*, VSEnvironment*) = VSget_response;

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSget_response_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_request_ptr(req) --> system_exception_is(\"BAD_PARAM\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_request_ptr(req)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {3, 22, 19, 0, 0, "system_exception_is(\"BAD_PARAM\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "check_request_executed(req)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VSget_response_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VSget_response_assertionReport = 0;

/*
 *
 * ACF of VSpoll_response
 *
 */
VSRequest_ptr *ADL__ACF_VSpoll_response (VSRequest_ptr *req_294, VSEnvironment *ev_283){

VSRequest_ptr *VSpoll_response_RtnVal_277;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_296;
  int tmp_298;
  int tmp_299;
  VSEnvironment *ev_283_tmp_303;
    int tmp_304;
  int tmp_306;
  int tmp_307;
  VSEnvironment *ev_283_tmp_310;
    int tmp_312;
  int tmp_313;
  VSRequest_ptr *req_294_tmp_316;
  int tmp_317;
  VSEnvironment *ev_283_tmp_321;
    int tmp_322;
  int tmp_323;
  int groupExpr_332;
  int groupExpr_333;
  int tmp_324;
  VSRequest_ptr *req_294_tmp_327;
  int tmp_328;
  VSRequest_ptr *req_294_tmp_331;

/* Declare vars for result of normal and exception bindings */
  int VSpoll_response_NormalOutcome_278, VSpoll_response_ExceptionOutcome_279;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_280;
  VSEnvironment *ev_283_tmp_284;
    int tmp_285;
  int tmp_286;
  VSEnvironment *ev_283_tmp_289;
  int tmp_290;
  VSEnvironment *ev_283_tmp_293;
  enum ADL__ACF_result VSpoll_response_ACF_Result_276 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSpoll_response_InfoArray, 0, ADL__VSpoll_response_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSpoll_response_assertionReport->setPhase(ADL__VSpoll_response_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSpoll_response_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSpoll_response_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSpoll_response_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSpoll_response_InfoArray[forLoopIdx_1].error > VSpoll_response_ACF_Result_276))
  VSpoll_response_ACF_Result_276 = ADL__VSpoll_response_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSpoll_response_ACF_Result_276 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSpoll_response_assertionReport->setPhase(ADL__VSpoll_response_assertionReport, PH_call);
  ADL__release(ADL__VSpoll_response_assertionReport->parent, &this_seq);
  VSpoll_response_RtnVal_277 = ADL__VSpoll_response_wrapper(req_294, ev_283);
  ADL__recover(ADL__VSpoll_response_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSpoll_response_assertionReport->setPhase(ADL__VSpoll_response_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_283_tmp_284 = ev_283;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 8,&ev_283_tmp_284);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_280 = no_exception(ev_283);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 7,&tmp_280);
  VSpoll_response_NormalOutcome_278 = (tmp_280);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_283_tmp_289 = ev_283;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 3,&ev_283_tmp_289);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_286 = system_exception(ev_283);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 2,&tmp_286);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_285 = tmp_286;
  if (!tmp_286) {
      ev_283_tmp_293 = ev_283;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 5,&ev_283_tmp_293);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_290 = user_exception(ev_283);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 4,&tmp_290);
    tmp_285 = tmp_290;
  }
  else {
  ADL__resetInfoStruct(ADL__VSpoll_response_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 1,&tmp_285);

  VSpoll_response_ExceptionOutcome_279 = (tmp_285);

/* Exception binding is the first assertion */
  if (ADL__VSpoll_response_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSpoll_response_InfoArray[0].result = (VSpoll_response_ExceptionOutcome_279 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSpoll_response_InfoArray[0].evaluated = 1;
  ADL__VSpoll_response_InfoArray[0].value = (VSpoll_response_ExceptionOutcome_279 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSpoll_response_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSpoll_response_InfoArray[6].result = (VSpoll_response_NormalOutcome_278 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSpoll_response_InfoArray[6].evaluated = 1;
  ADL__VSpoll_response_InfoArray[6].value = (VSpoll_response_NormalOutcome_278 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSpoll_response_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSpoll_response_ACF_Result_276 = ADL__VSpoll_response_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSpoll_response_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSpoll_response_ACF_Result_276 = ADL__VSpoll_response_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSpoll_response_ExceptionOutcome_279 && !VSpoll_response_NormalOutcome_278) {
  VSpoll_response_ACF_Result_276 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSpoll_response_ExceptionOutcome_279 && VSpoll_response_NormalOutcome_278) {
  VSpoll_response_ACF_Result_276 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 10,&VSpoll_response_ExceptionOutcome_279);
  ev_283_tmp_303 = ev_283;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 13,&ev_283_tmp_303);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_299 = user_exception_is("NOT_IMPLEMENTED", ev_283);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 12,&tmp_299);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_298 = !tmp_299;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 11,&tmp_298);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_296 = (!VSpoll_response_ExceptionOutcome_279 || tmp_298);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 9,&tmp_296);
    ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 15,&VSpoll_response_ExceptionOutcome_279);
  ev_283_tmp_310 = ev_283;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 18,&ev_283_tmp_310);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_307 = user_exception(ev_283);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 17,&tmp_307);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_306 = !tmp_307;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 16,&tmp_306);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_304 = (!VSpoll_response_ExceptionOutcome_279 || tmp_306);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 14,&tmp_304);
    req_294_tmp_316 = req_294;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 21,&req_294_tmp_316);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[20]);

/* Evaluate is_nil_request_ptr(req) */
  tmp_313 = is_nil_request_ptr(req_294);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 20,&tmp_313);
  ev_283_tmp_321 = ev_283;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 23,&ev_283_tmp_321);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[22]);

/* Evaluate system_exception_is("BAD_PARAM", ev) */
  tmp_317 = system_exception_is("BAD_PARAM", ev_283);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 22,&tmp_317);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[19]);

/* Evaluate is_nil_request_ptr(req) --> system_exception_is("BAD_PARAM", ev) */
  tmp_312 = (!tmp_313 || tmp_317);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 19,&tmp_312);
    ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VSpoll_response_NormalOutcome_278){
      req_294_tmp_327 = req_294;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 26,&req_294_tmp_327);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[25]);

/* Evaluate get_response(req) */
  tmp_324 = get_response(req_294);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 25,&tmp_324);
  groupExpr_332 = (tmp_324);
  req_294_tmp_331 = req_294;
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 28,&req_294_tmp_331);
  ADL__VSpoll_response_assertionReport->exprMark(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_assertionReport->assrt_info[27]);

/* Evaluate check_request_executed(req) */
  tmp_328 = check_request_executed(req_294);
  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 27,&tmp_328);
  groupExpr_333 = (tmp_328);
  tmp_323 = (groupExpr_332 && groupExpr_333);
  tmp_322 = tmp_323;
  }
  else {
    ADL__resetInfoStruct(ADL__VSpoll_response_InfoArray, 24, 28);
  tmp_322 = 1;
}

  ADL__setResultAndError(ADL__VSpoll_response_InfoArray, 24,&tmp_322);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSpoll_response_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSpoll_response_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSpoll_response_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSpoll_response_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSpoll_response_InfoArray[forLoopIdx_1].level == 0))
        VSpoll_response_ACF_Result_276 = calculate_ACF_result(VSpoll_response_ACF_Result_276, ADL__VSpoll_response_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSpoll_response_assertionReport->value = VSpoll_response_ACF_Result_276;
  ADL__VSpoll_response_assertionReport->parent->openReport(ADL__VSpoll_response_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSpoll_response_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSpoll_response_assertionReport->emitTest(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_InfoArray[forLoopIdx_1])) {
     ADL__VSpoll_response_assertionReport->exprStart(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_InfoArray[forLoopIdx_1]);
      if(!ADL__VSpoll_response_InfoArray[forLoopIdx_1].testable || !ADL__VSpoll_response_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSpoll_response_assertionReport->emitter);
      else if (ADL__VSpoll_response_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSpoll_response_InfoArray[forLoopIdx_1].error, ADL__VSpoll_response_assertionReport->emitter);
      else
        ADL__VSpoll_response_InfoArray[forLoopIdx_1].emitFunc(ADL__VSpoll_response_InfoArray[forLoopIdx_1].value, ADL__VSpoll_response_assertionReport->emitter);
     ADL__VSpoll_response_assertionReport->exprEnd(ADL__VSpoll_response_assertionReport, &ADL__VSpoll_response_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSpoll_response_RtnVal_277);
}


VSRequest_ptr *(*ADL__VSpoll_response_wrapper)(VSRequest_ptr*, VSEnvironment*) = VSpoll_response;

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSpoll_response_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_request_ptr(req) --> system_exception_is(\"BAD_PARAM\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_request_ptr(req)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {3, 22, 19, 0, 0, "system_exception_is(\"BAD_PARAM\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "get_response(req)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {6, 27, 24, 0, 0, "check_request_executed(req)", 27, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 28, 27, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VSpoll_response_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSpoll_response_assertionReport = 0;

/*
 *
 * ACF of VSsend_multiple_oneway
 *
 */
void* ADL__ACF_VSsend_multiple_oneway (VSRequestSeq *reqs_353, VSEnvironment *ev_342){

void* VSsend_multiple_oneway_RtnVal_336;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_355;
  int tmp_357;
  int tmp_358;
  VSEnvironment *ev_342_tmp_362;
    int tmp_363;
  int tmp_365;
  int tmp_366;
  VSEnvironment *ev_342_tmp_369;
    int tmp_370;
  int tmp_371;
  int groupExpr_376;
  int tmp_372;
  VSRequestSeq *reqs_353_tmp_375;

/* Declare vars for result of normal and exception bindings */
  int VSsend_multiple_oneway_NormalOutcome_337, VSsend_multiple_oneway_ExceptionOutcome_338;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_339;
  VSEnvironment *ev_342_tmp_343;
    int tmp_344;
  int tmp_345;
  VSEnvironment *ev_342_tmp_348;
  int tmp_349;
  VSEnvironment *ev_342_tmp_352;
  enum ADL__ACF_result VSsend_multiple_oneway_ACF_Result_335 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSsend_multiple_oneway_InfoArray, 0, ADL__VSsend_multiple_oneway_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSsend_multiple_oneway_assertionReport->setPhase(ADL__VSsend_multiple_oneway_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_multiple_oneway_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].error > VSsend_multiple_oneway_ACF_Result_335))
  VSsend_multiple_oneway_ACF_Result_335 = ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSsend_multiple_oneway_ACF_Result_335 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSsend_multiple_oneway_assertionReport->setPhase(ADL__VSsend_multiple_oneway_assertionReport, PH_call);
  ADL__release(ADL__VSsend_multiple_oneway_assertionReport->parent, &this_seq);
  VSsend_multiple_oneway_RtnVal_336 = ADL__VSsend_multiple_oneway_wrapper(reqs_353, ev_342);
  ADL__recover(ADL__VSsend_multiple_oneway_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSsend_multiple_oneway_assertionReport->setPhase(ADL__VSsend_multiple_oneway_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_342_tmp_343 = ev_342;
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 8,&ev_342_tmp_343);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_339 = no_exception(ev_342);
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 7,&tmp_339);
  VSsend_multiple_oneway_NormalOutcome_337 = (tmp_339);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_342_tmp_348 = ev_342;
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 3,&ev_342_tmp_348);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_345 = system_exception(ev_342);
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 2,&tmp_345);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_344 = tmp_345;
  if (!tmp_345) {
      ev_342_tmp_352 = ev_342;
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 5,&ev_342_tmp_352);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_349 = user_exception(ev_342);
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 4,&tmp_349);
    tmp_344 = tmp_349;
  }
  else {
  ADL__resetInfoStruct(ADL__VSsend_multiple_oneway_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 1,&tmp_344);

  VSsend_multiple_oneway_ExceptionOutcome_338 = (tmp_344);

/* Exception binding is the first assertion */
  if (ADL__VSsend_multiple_oneway_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSsend_multiple_oneway_InfoArray[0].result = (VSsend_multiple_oneway_ExceptionOutcome_338 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSsend_multiple_oneway_InfoArray[0].evaluated = 1;
  ADL__VSsend_multiple_oneway_InfoArray[0].value = (VSsend_multiple_oneway_ExceptionOutcome_338 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSsend_multiple_oneway_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSsend_multiple_oneway_InfoArray[6].result = (VSsend_multiple_oneway_NormalOutcome_337 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSsend_multiple_oneway_InfoArray[6].evaluated = 1;
  ADL__VSsend_multiple_oneway_InfoArray[6].value = (VSsend_multiple_oneway_NormalOutcome_337 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSsend_multiple_oneway_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSsend_multiple_oneway_ACF_Result_335 = ADL__VSsend_multiple_oneway_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSsend_multiple_oneway_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSsend_multiple_oneway_ACF_Result_335 = ADL__VSsend_multiple_oneway_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSsend_multiple_oneway_ExceptionOutcome_338 && !VSsend_multiple_oneway_NormalOutcome_337) {
  VSsend_multiple_oneway_ACF_Result_335 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSsend_multiple_oneway_ExceptionOutcome_338 && VSsend_multiple_oneway_NormalOutcome_337) {
  VSsend_multiple_oneway_ACF_Result_335 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 10,&VSsend_multiple_oneway_ExceptionOutcome_338);
  ev_342_tmp_362 = ev_342;
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 13,&ev_342_tmp_362);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_358 = user_exception_is("NOT_IMPLEMENTED", ev_342);
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 12,&tmp_358);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_357 = !tmp_358;
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 11,&tmp_357);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_355 = (!VSsend_multiple_oneway_ExceptionOutcome_338 || tmp_357);
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 9,&tmp_355);
    ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 15,&VSsend_multiple_oneway_ExceptionOutcome_338);
  ev_342_tmp_369 = ev_342;
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 18,&ev_342_tmp_369);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_366 = user_exception(ev_342);
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 17,&tmp_366);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_365 = !tmp_366;
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 16,&tmp_365);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_363 = (!VSsend_multiple_oneway_ExceptionOutcome_338 || tmp_365);
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 14,&tmp_363);
    ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSsend_multiple_oneway_NormalOutcome_337){
      reqs_353_tmp_375 = reqs_353;
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 21,&reqs_353_tmp_375);
  ADL__VSsend_multiple_oneway_assertionReport->exprMark(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_assertionReport->assrt_info[20]);

/* Evaluate check_requests_sent(reqs) */
  tmp_372 = check_requests_sent(reqs_353);
  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 20,&tmp_372);
  groupExpr_376 = (tmp_372);
  tmp_371 = (groupExpr_376);
  tmp_370 = tmp_371;
  }
  else {
    ADL__resetInfoStruct(ADL__VSsend_multiple_oneway_InfoArray, 19, 21);
  tmp_370 = 1;
}

  ADL__setResultAndError(ADL__VSsend_multiple_oneway_InfoArray, 19,&tmp_370);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_multiple_oneway_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].level == 0))
        VSsend_multiple_oneway_ACF_Result_335 = calculate_ACF_result(VSsend_multiple_oneway_ACF_Result_335, ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSsend_multiple_oneway_assertionReport->value = VSsend_multiple_oneway_ACF_Result_335;
  ADL__VSsend_multiple_oneway_assertionReport->parent->openReport(ADL__VSsend_multiple_oneway_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSsend_multiple_oneway_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSsend_multiple_oneway_assertionReport->emitTest(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1])) {
     ADL__VSsend_multiple_oneway_assertionReport->exprStart(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1]);
      if(!ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].testable || !ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSsend_multiple_oneway_assertionReport->emitter);
      else if (ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].error, ADL__VSsend_multiple_oneway_assertionReport->emitter);
      else
        ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].emitFunc(ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1].value, ADL__VSsend_multiple_oneway_assertionReport->emitter);
     ADL__VSsend_multiple_oneway_assertionReport->exprEnd(ADL__VSsend_multiple_oneway_assertionReport, &ADL__VSsend_multiple_oneway_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSsend_multiple_oneway_RtnVal_336);
}


void* (*ADL__VSsend_multiple_oneway_wrapper)(VSRequestSeq*, VSEnvironment*) = VSsend_multiple_oneway;

void ADL__emit_VSRequestSeq_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSsend_multiple_oneway_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "check_requests_sent(reqs)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "reqs", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequestSeq_P }
};


unsigned int ADL__VSsend_multiple_oneway_InfoArrayIdx = 22;

struct ADL__reportAssertion *ADL__VSsend_multiple_oneway_assertionReport = 0;

/*
 *
 * ACF of VSnil
 *
 */
VSRequest_ptr *ADL__ACF_VSnil (VSEnvironment *ev_385){

VSRequest_ptr *VSnil_RtnVal_379;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_397;
  int tmp_399;
  int tmp_400;
  VSEnvironment *ev_385_tmp_404;
    int tmp_405;
  int tmp_407;
  int tmp_408;
  int tmp_409;
  VSEnvironment *ev_385_tmp_412;
  int tmp_413;
  int tmp_414;
  VSEnvironment *ev_385_tmp_417;
    int tmp_418;
  int tmp_419;
  int groupExpr_428;
  int tmp_421;
  int tmp_422;
  int tmp_425;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_380, VSnil_ExceptionOutcome_381;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_382;
  VSEnvironment *ev_385_tmp_386;
    int tmp_387;
  int tmp_388;
  VSEnvironment *ev_385_tmp_391;
  int tmp_392;
  VSEnvironment *ev_385_tmp_395;
  enum ADL__ACF_result VSnil_ACF_Result_378 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_378))
  VSnil_ACF_Result_378 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_378 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_379 = ADL__VSnil_wrapper(ev_385);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_385_tmp_386 = ev_385;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_385_tmp_386);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_382 = no_exception(ev_385);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_382);
  VSnil_NormalOutcome_380 = (tmp_382);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_385_tmp_391 = ev_385;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_385_tmp_391);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_388 = system_exception(ev_385);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_388);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_387 = tmp_388;
  if (!tmp_388) {
      ev_385_tmp_395 = ev_385;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_385_tmp_395);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_392 = user_exception(ev_385);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_392);
    tmp_387 = tmp_392;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_387);

  VSnil_ExceptionOutcome_381 = (tmp_387);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_381 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_381 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_380 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_380 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_378 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_378 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_381 && !VSnil_NormalOutcome_380) {
  VSnil_ACF_Result_378 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_381 && VSnil_NormalOutcome_380) {
  VSnil_ACF_Result_378 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_381);
  ev_385_tmp_404 = ev_385;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_385_tmp_404);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_400 = user_exception_is("NOT_IMPLEMENTED", ev_385);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_400);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_399 = !tmp_400;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_399);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_397 = (!VSnil_ExceptionOutcome_381 || tmp_399);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_397);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_381);
  ev_385_tmp_412 = ev_385;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_385_tmp_412);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_409 = system_exception(ev_385);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_409);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_408 = !tmp_409;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_408);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_407 = tmp_408;
  if (tmp_408) {
      ev_385_tmp_417 = ev_385;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_385_tmp_417);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_414 = user_exception(ev_385);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_414);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_413 = !tmp_414;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_413);
    tmp_407 = tmp_413;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_407);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_405 = (!VSnil_ExceptionOutcome_381 || tmp_407);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_405);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_380){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_379);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_request_ptr(return) */
  tmp_422 = is_nil_request_ptr(VSnil_RtnVal_379);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_422);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_request_ptr(return) && cleanup_request_ptr(return) */
  tmp_421 = tmp_422;
  if (tmp_422) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_379);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_request_ptr(return) */
  tmp_425 = cleanup_request_ptr(VSnil_RtnVal_379);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_425);
    tmp_421 = tmp_425;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_421);
  groupExpr_428 = (tmp_421);
  tmp_419 = (groupExpr_428);
  tmp_418 = tmp_419;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_418 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_418);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_378 = calculate_ACF_result(VSnil_ACF_Result_378, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_378;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_379);
}


VSRequest_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_request_ptr(return) && cleanup_request_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_request_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_request_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSRequest_ptr *ADL__ACF_VSduplicate (VSRequest_ptr *o_448, VSEnvironment *ev_437){

VSRequest_ptr *VSduplicate_RtnVal_431;
  void *dummyVarName_429;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_450;
  int tmp_452;
  int tmp_453;
  VSEnvironment *ev_437_tmp_457;
    int tmp_458;
  int tmp_460;
  int tmp_461;
  VSEnvironment *ev_437_tmp_464;
    int tmp_465;
  int tmp_466;
  int groupExpr_477;
  int tmp_468;
  int tmp_469;
  VSRequest_ptr *o_448_tmp_473;
  int tmp_474;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_432, VSduplicate_ExceptionOutcome_433;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_434;
  VSEnvironment *ev_437_tmp_438;
    int tmp_439;
  int tmp_440;
  VSEnvironment *ev_437_tmp_443;
  int tmp_444;
  VSEnvironment *ev_437_tmp_447;
  enum ADL__ACF_result VSduplicate_ACF_Result_430 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_430))
  VSduplicate_ACF_Result_430 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_430 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_431 = ADL__VSduplicate_wrapper(o_448, ev_437);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_437_tmp_438 = ev_437;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_437_tmp_438);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_434 = no_exception(ev_437);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_434);
  VSduplicate_NormalOutcome_432 = (tmp_434);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_437_tmp_443 = ev_437;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_437_tmp_443);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_440 = system_exception(ev_437);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_440);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_439 = tmp_440;
  if (!tmp_440) {
      ev_437_tmp_447 = ev_437;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_437_tmp_447);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_444 = user_exception(ev_437);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_444);
    tmp_439 = tmp_444;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_439);

  VSduplicate_ExceptionOutcome_433 = (tmp_439);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_433 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_433 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_432 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_432 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_430 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_430 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_433 && !VSduplicate_NormalOutcome_432) {
  VSduplicate_ACF_Result_430 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_433 && VSduplicate_NormalOutcome_432) {
  VSduplicate_ACF_Result_430 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_433);
  ev_437_tmp_457 = ev_437;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_437_tmp_457);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_453 = user_exception_is("NOT_IMPLEMENTED", ev_437);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_453);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_452 = !tmp_453;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_452);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_450 = (!VSduplicate_ExceptionOutcome_433 || tmp_452);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_450);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_433);
  ev_437_tmp_464 = ev_437;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&ev_437_tmp_464);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_461 = user_exception(ev_437);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_461);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_460 = !tmp_461;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_460);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_458 = (!VSduplicate_ExceptionOutcome_433 || tmp_460);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_458);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_432){
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&VSduplicate_RtnVal_431);
  o_448_tmp_473 = o_448;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&o_448_tmp_473);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate is_same_request_ptr(return, o) */
  tmp_469 = is_same_request_ptr(VSduplicate_RtnVal_431, o_448);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_469);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate is_same_request_ptr(return, o) && cleanup_request_ptr(return) */
  tmp_468 = tmp_469;
  if (tmp_469) {
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&VSduplicate_RtnVal_431);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate cleanup_request_ptr(return) */
  tmp_474 = cleanup_request_ptr(VSduplicate_RtnVal_431);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_474);
    tmp_468 = tmp_474;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 24, 25);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_468);
  groupExpr_477 = (tmp_468);
  tmp_466 = (groupExpr_477);
  tmp_465 = tmp_466;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 19, 25);
  tmp_465 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&tmp_465);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_430 = calculate_ACF_result(VSduplicate_ACF_Result_430, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_430;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_431);
}


VSRequest_ptr *(*ADL__VSduplicate_wrapper)(VSRequest_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_same_request_ptr(return, o) && cleanup_request_ptr(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_same_request_ptr(return, o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {4, 23, 21, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P },
  {4, 24, 20, 0, 0, "cleanup_request_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;
