/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/AliasDef/t1.h
  
   Purpose:
  
   Modifications:
	 $Log: t1.h,v $
	 Revision 1.1.1.1  2000/02/09 17:13:44  mli
	 Imported TOG's VSOrb 1.1.1
	
	 Revision 1.4  1997/11/26 14:54:54  kevin
	 Added write tests and update CORBA scoping.

	 Revision 1.3  1997/10/24 14:14:11  kevin
	 *** empty log message ***


*/

#include <corba_defs.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/
VSIDLType_ptr
VSoriginal_type_def_read(VSEnvironment *ev);

/*------------------------------------------------------*/
VSAliasDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSAliasDef_ptr*
VSduplicate(VSAliasDef_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSAliasDef_ptr*
VSnil(VSEnvironment *ev);

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/
 
void
VSoriginal_type_def_write(const VSIDLType_ptr vs_idltype_ptr, 
													VSEnvironment *ev);

/*------------------------------------------------------*/
/* REDEFINED INTERFACE */
/*------------------------------------------------------*/

VSDefinitionKind 
VSdef_kind(VSEnvironment *ev);

/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev);

