/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/AttributeDef/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:13:54  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.3  1997/11/26 14:55:45  kevin
   Added write tests and update CORBA scoping.

   Revision 1.2  1997/10/03 12:03:09  kevin
   *** empty log message ***

   Revision 1.1  1997/09/18 17:25:56  kevin
   Tested read funcs under ORBIX

   Revision 1.1  1997/08/21 14:37:03  kevin


*/

#include <corba_defs.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

 VSTypeCode_ptr*
 VStype(VSEnvironment *ev);


/*------------------------------------------------------*/
 VSIDLType_ptr
 VStype_def_read(VSEnvironment *ev);

/*------------------------------------------------------*/
 VSAttributeMode
 VSmode_read(VSEnvironment *ev, VSAttributeDef_ptr vs_calling_att_ptr);

/*------------------------------------------------------*/
VSAttributeDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSAttributeDef_ptr*
VSduplicate(VSAttributeDef_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSAttributeDef_ptr*
VSnil(VSEnvironment *ev);

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/
void
VStype_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev);

/*------------------------------------------------------*/
void
VSmode_write(VSAttributeMode vs_att_mode, VSEnvironment *ev);

/*------------------------------------------------------*/
/* REDEFINED INTERFACE */
/*------------------------------------------------------*/

VSDefinitionKind 
VSdef_kind(VSEnvironment *ev);

/*------------------------------------------------------*/
VSDescription_ptr
VSdescribe(VSEnvironment *ev);

