/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/EnumDef/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:06  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.2  1997/11/26 14:56:34  kevin
   Added write tests and update CORBA scoping.

   Revision 1.1  1997/09/18 17:21:14  kevin
   Tested read funcs under ORBIX

   Revision 1.1  1997/08/21 14:37:03  kevin


*/

#include <corba_defs.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSEnumMemberSeq_ptr
VSmembers_read(VSEnvironment *ev);

/*------------------------------------------------------*/
VSEnumDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSEnumDef_ptr*
VSduplicate(VSEnumDef_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSEnumDef_ptr*
VSnil(VSEnvironment *ev);

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/
void
VSmembers_write(const VSEnumMemberSeq_ptr vs_members, VSEnvironment *ev);

/*------------------------------------------------------*/
/* REDEFINED INTERFACE */
/*------------------------------------------------------*/

VSDefinitionKind 
VSdef_kind(VSEnvironment *ev);

/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev);

