/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSnil
 *
 */
VSNativeDef_ptr *ADL__ACF_VSnil (VSEnvironment *ev_10){

VSNativeDef_ptr *VSnil_RtnVal_4;
  void *dummyVarName_202;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_21;
  int tmp_23;
  int tmp_24;
  VSEnvironment *ev_10_tmp_28;
    int tmp_29;
  int tmp_31;
  int tmp_32;
  int tmp_33;
  VSEnvironment *ev_10_tmp_36;
  int tmp_37;
  int tmp_38;
  VSEnvironment *ev_10_tmp_41;
    int tmp_42;
  int tmp_43;
  int groupExpr_52;
  int tmp_45;
  int tmp_46;
  int tmp_49;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_5, VSnil_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSnil_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_3))
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_4 = ADL__VSnil_wrapper(ev_10);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_7);
  VSnil_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_13);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_12);

  VSnil_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_6 && !VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_6 && VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_28 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_10_tmp_28);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_24);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = !tmp_24;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_23);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_21 = (!VSnil_ExceptionOutcome_6 || tmp_23);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_21);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_36 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_10_tmp_36);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_33 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_33);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_32);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_31 = tmp_32;
  if (tmp_32) {
      ev_10_tmp_41 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_10_tmp_41);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_38 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_38);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_37 = !tmp_38;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_37);
    tmp_31 = tmp_37;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_31);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_29 = (!VSnil_ExceptionOutcome_6 || tmp_31);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_29);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_nativedef_ptr(return) */
  tmp_46 = is_nil_nativedef_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_46);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_nativedef_ptr(return) && cleanup_nativedef_ptr(return) */
  tmp_45 = tmp_46;
  if (tmp_46) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_nativedef_ptr(return) */
  tmp_49 = cleanup_nativedef_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_49);
    tmp_45 = tmp_49;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_45);
  groupExpr_52 = (tmp_45);
  tmp_43 = (groupExpr_52);
  tmp_42 = tmp_43;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_42 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_42);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_3 = calculate_ACF_result(VSnil_ACF_Result_3, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_3;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_4);
}


VSNativeDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSNativeDef_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_nativedef_ptr(return) && cleanup_nativedef_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_nativedef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNativeDef_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_nativedef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNativeDef_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSNativeDef_ptr *ADL__ACF_VSduplicate (VSNativeDef_ptr *o_72, VSEnvironment *ev_61){

VSNativeDef_ptr *VSduplicate_RtnVal_55;
  void *dummyVarName_202;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_73;
  int tmp_75;
  int tmp_76;
  VSEnvironment *ev_61_tmp_80;
    int tmp_81;
  int tmp_83;
  int tmp_84;
  VSEnvironment *ev_61_tmp_87;
    int tmp_88;
  int tmp_89;
  int groupExpr_101;
  int groupExpr_102;
  int tmp_90;
  int tmp_91;
  VSNativeDef_ptr *o_72_tmp_94;
  int tmp_95;
  int tmp_98;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_56, VSduplicate_ExceptionOutcome_57;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_58;
  VSEnvironment *ev_61_tmp_62;
    int tmp_63;
  int tmp_64;
  VSEnvironment *ev_61_tmp_67;
  int tmp_68;
  VSEnvironment *ev_61_tmp_71;
  enum ADL__ACF_result VSduplicate_ACF_Result_54 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_54))
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_54 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_55 = ADL__VSduplicate_wrapper(o_72, ev_61);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_61_tmp_62 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_61_tmp_62);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_58 = no_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_58);
  VSduplicate_NormalOutcome_56 = (tmp_58);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_61_tmp_67 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_61_tmp_67);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_64 = system_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_64);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_63 = tmp_64;
  if (!tmp_64) {
      ev_61_tmp_71 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_61_tmp_71);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_68 = user_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_68);
    tmp_63 = tmp_68;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_63);

  VSduplicate_ExceptionOutcome_57 = (tmp_63);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_57 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_57 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_56 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_56 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_57 && !VSduplicate_NormalOutcome_56) {
  VSduplicate_ACF_Result_54 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_57 && VSduplicate_NormalOutcome_56) {
  VSduplicate_ACF_Result_54 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_57);
  ev_61_tmp_80 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_61_tmp_80);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_76 = user_exception_is("NOT_IMPLEMENTED", ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_76);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_75 = !tmp_76;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_75);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_73 = (!VSduplicate_ExceptionOutcome_57 || tmp_75);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_73);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_57);
  ev_61_tmp_87 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&ev_61_tmp_87);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_84 = user_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_84);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_83 = !tmp_84;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_83);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_81 = (!VSduplicate_ExceptionOutcome_57 || tmp_83);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_81);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_56){
      o_72_tmp_94 = o_72;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&o_72_tmp_94);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate is_nil_nativedef_ptr(o) */
  tmp_91 = is_nil_nativedef_ptr(o_72);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_91);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&VSduplicate_RtnVal_55);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[23]);

/* Evaluate is_nil_nativedef_ptr(return) */
  tmp_95 = is_nil_nativedef_ptr(VSduplicate_RtnVal_55);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&tmp_95);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate is_nil_nativedef_ptr(o) --> is_nil_nativedef_ptr(return) */
  tmp_90 = (!tmp_91 || tmp_95);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_90);
  groupExpr_101 = (tmp_90);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 26,&VSduplicate_RtnVal_55);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[25]);

/* Evaluate cleanup_nativedef_ptr(return) */
  tmp_98 = cleanup_nativedef_ptr(VSduplicate_RtnVal_55);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&tmp_98);
  groupExpr_102 = (tmp_98);
  tmp_89 = (groupExpr_101 && groupExpr_102);
  tmp_88 = tmp_89;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 19, 26);
  tmp_88 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&tmp_88);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_54 = calculate_ACF_result(VSduplicate_ACF_Result_54, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_54;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_55);
}


VSNativeDef_ptr *(*ADL__VSduplicate_wrapper)(VSNativeDef_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSNativeDef_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_nil_nativedef_ptr(o) --> is_nil_nativedef_ptr(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_nil_nativedef_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNativeDef_ptr_P },
  {4, 23, 20, 0, 0, "is_nil_nativedef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNativeDef_ptr_P },
  {5, 25, 19, 0, 0, "cleanup_nativedef_ptr(return)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNativeDef_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSnarrow
 *
 */
VSNativeDef_ptr *ADL__ACF_VSnarrow (VSObject_ptr *o_122, VSEnvironment *ev_111){

VSNativeDef_ptr *VSnarrow_RtnVal_105;
  void *dummyVarName_202;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_123;
  int tmp_125;
  int tmp_126;
  VSEnvironment *ev_111_tmp_130;
    int tmp_131;
  int tmp_133;
  int tmp_134;
  VSEnvironment *ev_111_tmp_137;
    int tmp_138;
  int tmp_139;
  int groupExpr_154;
  int groupExpr_155;
  int tmp_141;
  int tmp_142;
  int tmp_145;
  VSObject_ptr tmp_147;
  VSObject_ptr *o_122_tmp_149;
  int tmp_151;

/* Declare vars for result of normal and exception bindings */
  int VSnarrow_NormalOutcome_106, VSnarrow_ExceptionOutcome_107;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_108;
  VSEnvironment *ev_111_tmp_112;
    int tmp_113;
  int tmp_114;
  VSEnvironment *ev_111_tmp_117;
  int tmp_118;
  VSEnvironment *ev_111_tmp_121;
  enum ADL__ACF_result VSnarrow_ACF_Result_104 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 0, ADL__VSnarrow_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnarrow_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnarrow_InfoArray[forLoopIdx_1].error > VSnarrow_ACF_Result_104))
  VSnarrow_ACF_Result_104 = ADL__VSnarrow_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnarrow_ACF_Result_104 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_call);
  ADL__release(ADL__VSnarrow_assertionReport->parent, &this_seq);
  VSnarrow_RtnVal_105 = ADL__VSnarrow_wrapper(o_122, ev_111);
  ADL__recover(ADL__VSnarrow_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_111_tmp_112 = ev_111;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 8,&ev_111_tmp_112);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_108 = no_exception(ev_111);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 7,&tmp_108);
  VSnarrow_NormalOutcome_106 = (tmp_108);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_111_tmp_117 = ev_111;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 3,&ev_111_tmp_117);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_114 = system_exception(ev_111);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 2,&tmp_114);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_113 = tmp_114;
  if (!tmp_114) {
      ev_111_tmp_121 = ev_111;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 5,&ev_111_tmp_121);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_118 = user_exception(ev_111);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 4,&tmp_118);
    tmp_113 = tmp_118;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 1,&tmp_113);

  VSnarrow_ExceptionOutcome_107 = (tmp_113);

/* Exception binding is the first assertion */
  if (ADL__VSnarrow_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[0].result = (VSnarrow_ExceptionOutcome_107 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[0].evaluated = 1;
  ADL__VSnarrow_InfoArray[0].value = (VSnarrow_ExceptionOutcome_107 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnarrow_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[6].result = (VSnarrow_NormalOutcome_106 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[6].evaluated = 1;
  ADL__VSnarrow_InfoArray[6].value = (VSnarrow_NormalOutcome_106 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnarrow_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_104 = ADL__VSnarrow_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnarrow_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_104 = ADL__VSnarrow_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnarrow_ExceptionOutcome_107 && !VSnarrow_NormalOutcome_106) {
  VSnarrow_ACF_Result_104 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnarrow_ExceptionOutcome_107 && VSnarrow_NormalOutcome_106) {
  VSnarrow_ACF_Result_104 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 10,&VSnarrow_ExceptionOutcome_107);
  ev_111_tmp_130 = ev_111;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 13,&ev_111_tmp_130);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_126 = user_exception_is("NOT_IMPLEMENTED", ev_111);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 12,&tmp_126);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_125 = !tmp_126;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 11,&tmp_125);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_123 = (!VSnarrow_ExceptionOutcome_107 || tmp_125);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 9,&tmp_123);
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 15,&VSnarrow_ExceptionOutcome_107);
  ev_111_tmp_137 = ev_111;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 18,&ev_111_tmp_137);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_134 = user_exception(ev_111);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 17,&tmp_134);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_133 = !tmp_134;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 16,&tmp_133);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_131 = (!VSnarrow_ExceptionOutcome_107 || tmp_133);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 14,&tmp_131);
    ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSnarrow_NormalOutcome_106){
      ADL__setResultAndError(ADL__VSnarrow_InfoArray, 22,&VSnarrow_RtnVal_105);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[21]);

/* Evaluate is_nil_nativedef_ptr(return) */
  tmp_142 = is_nil_nativedef_ptr(VSnarrow_RtnVal_105);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 21,&tmp_142);
  o_122_tmp_149 = o_122;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 25,&o_122_tmp_149);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[24]);

/* Evaluate *o */
  if (ADL__badPtrDeref("*o",(unsigned int) o_122)) { /* check for invalid ptr reference */
     VSnarrow_ACF_Result_104 = ADL__ACF_ERROR;
     goto REPORT_RESULT;
  };
  tmp_147 = *o_122;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 24,&tmp_147);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[23]);

/* Evaluate is_nil_object(*o) */
  tmp_145 = is_nil_object(tmp_147);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 23,&tmp_145);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[20]);

/* Evaluate is_nil_nativedef_ptr(return) <-> is_nil_object(*o) */
  tmp_141 = ((tmp_142? 1 : 0) == (tmp_145? 1 : 0));
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 20,&tmp_141);
  groupExpr_154 = (tmp_141);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 27,&VSnarrow_RtnVal_105);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[26]);

/* Evaluate cleanup_nativedef_ptr(return) */
  tmp_151 = cleanup_nativedef_ptr(VSnarrow_RtnVal_105);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 26,&tmp_151);
  groupExpr_155 = (tmp_151);
  tmp_139 = (groupExpr_154 && groupExpr_155);
  tmp_138 = tmp_139;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 19, 27);
  tmp_138 = 1;
}

  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 19,&tmp_138);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnarrow_InfoArray[forLoopIdx_1].level == 0))
        VSnarrow_ACF_Result_104 = calculate_ACF_result(VSnarrow_ACF_Result_104, ADL__VSnarrow_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnarrow_assertionReport->value = VSnarrow_ACF_Result_104;
  ADL__VSnarrow_assertionReport->parent->openReport(ADL__VSnarrow_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnarrow_assertionReport->emitTest(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1])) {
     ADL__VSnarrow_assertionReport->exprStart(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnarrow_InfoArray[forLoopIdx_1].testable || !ADL__VSnarrow_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnarrow_assertionReport->emitter);
      else if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].error, ADL__VSnarrow_assertionReport->emitter);
      else
        ADL__VSnarrow_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].value, ADL__VSnarrow_assertionReport->emitter);
     ADL__VSnarrow_assertionReport->exprEnd(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnarrow_RtnVal_105);
}


VSNativeDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*) = VSnarrow;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSNativeDef_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSObject_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_nil_nativedef_ptr(return) <-> is_nil_object(*o)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_nil_nativedef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNativeDef_ptr_P },
  {4, 23, 20, 0, 0, "is_nil_object(*o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "*o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr },
  {4, 25, 24, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {5, 26, 19, 0, 0, "cleanup_nativedef_ptr(return)", 26, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 27, 26, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSNativeDef_ptr_P }
};


unsigned int ADL__VSnarrow_InfoArrayIdx = 28;

struct ADL__reportAssertion *ADL__VSnarrow_assertionReport = 0;

/*
 *
 * ACF of VSdef_kind
 *
 */
VSDefinitionKind ADL__ACF_VSdef_kind (VSEnvironment *ev_164){

VSDefinitionKind VSdef_kind_RtnVal_158;
  void *dummyVarName_202;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_175;
  int tmp_177;
  int tmp_178;
  VSEnvironment *ev_164_tmp_182;
    int tmp_183;
  int tmp_185;
  int tmp_186;
  int tmp_187;
  VSEnvironment *ev_164_tmp_190;
  int tmp_191;
  int tmp_192;
  VSEnvironment *ev_164_tmp_195;
    int tmp_196;
  int tmp_197;
  int groupExpr_201;
  int tmp_198;

/* Declare vars for result of normal and exception bindings */
  int VSdef_kind_NormalOutcome_159, VSdef_kind_ExceptionOutcome_160;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_161;
  VSEnvironment *ev_164_tmp_165;
    int tmp_166;
  int tmp_167;
  VSEnvironment *ev_164_tmp_170;
  int tmp_171;
  VSEnvironment *ev_164_tmp_174;
  enum ADL__ACF_result VSdef_kind_ACF_Result_157 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 0, ADL__VSdef_kind_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > VSdef_kind_ACF_Result_157))
  VSdef_kind_ACF_Result_157 = ADL__VSdef_kind_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSdef_kind_ACF_Result_157 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_call);
  ADL__release(ADL__VSdef_kind_assertionReport->parent, &this_seq);
  VSdef_kind_RtnVal_158 = ADL__VSdef_kind_wrapper(ev_164);
  ADL__recover(ADL__VSdef_kind_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_164_tmp_165 = ev_164;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 8,&ev_164_tmp_165);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_161 = no_exception(ev_164);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 7,&tmp_161);
  VSdef_kind_NormalOutcome_159 = (tmp_161);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_164_tmp_170 = ev_164;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 3,&ev_164_tmp_170);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_167 = system_exception(ev_164);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 2,&tmp_167);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_166 = tmp_167;
  if (!tmp_167) {
      ev_164_tmp_174 = ev_164;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 5,&ev_164_tmp_174);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_171 = user_exception(ev_164);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 4,&tmp_171);
    tmp_166 = tmp_171;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 1,&tmp_166);

  VSdef_kind_ExceptionOutcome_160 = (tmp_166);

/* Exception binding is the first assertion */
  if (ADL__VSdef_kind_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[0].result = (VSdef_kind_ExceptionOutcome_160 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[0].evaluated = 1;
  ADL__VSdef_kind_InfoArray[0].value = (VSdef_kind_ExceptionOutcome_160 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSdef_kind_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[6].result = (VSdef_kind_NormalOutcome_159 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[6].evaluated = 1;
  ADL__VSdef_kind_InfoArray[6].value = (VSdef_kind_NormalOutcome_159 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSdef_kind_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_157 = ADL__VSdef_kind_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSdef_kind_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_157 = ADL__VSdef_kind_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSdef_kind_ExceptionOutcome_160 && !VSdef_kind_NormalOutcome_159) {
  VSdef_kind_ACF_Result_157 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSdef_kind_ExceptionOutcome_160 && VSdef_kind_NormalOutcome_159) {
  VSdef_kind_ACF_Result_157 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 10,&VSdef_kind_ExceptionOutcome_160);
  ev_164_tmp_182 = ev_164;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 13,&ev_164_tmp_182);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_178 = user_exception_is("NOT_IMPLEMENTED", ev_164);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 12,&tmp_178);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_177 = !tmp_178;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 11,&tmp_177);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_175 = (!VSdef_kind_ExceptionOutcome_160 || tmp_177);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 9,&tmp_175);
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 15,&VSdef_kind_ExceptionOutcome_160);
  ev_164_tmp_190 = ev_164;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 19,&ev_164_tmp_190);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_187 = system_exception(ev_164);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 18,&tmp_187);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_186 = !tmp_187;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 17,&tmp_186);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_185 = tmp_186;
  if (tmp_186) {
      ev_164_tmp_195 = ev_164;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 22,&ev_164_tmp_195);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_192 = user_exception(ev_164);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 21,&tmp_192);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_191 = !tmp_192;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 20,&tmp_191);
    tmp_185 = tmp_191;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 16,&tmp_185);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_183 = (!VSdef_kind_ExceptionOutcome_160 || tmp_185);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 14,&tmp_183);
    ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSdef_kind_NormalOutcome_159){
      ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 25,&VSdef_kind_RtnVal_158);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[24]);

/* Evaluate is_correct_def_kind(return) */
  tmp_198 = is_correct_def_kind(VSdef_kind_RtnVal_158);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 24,&tmp_198);
  groupExpr_201 = (tmp_198);
  tmp_197 = (groupExpr_201);
  tmp_196 = tmp_197;
  }
  else {
    ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 23, 25);
  tmp_196 = 1;
}

  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 23,&tmp_196);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSdef_kind_InfoArray[forLoopIdx_1].level == 0))
        VSdef_kind_ACF_Result_157 = calculate_ACF_result(VSdef_kind_ACF_Result_157, ADL__VSdef_kind_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSdef_kind_assertionReport->value = VSdef_kind_ACF_Result_157;
  ADL__VSdef_kind_assertionReport->parent->openReport(ADL__VSdef_kind_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSdef_kind_assertionReport->emitTest(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1])) {
     ADL__VSdef_kind_assertionReport->exprStart(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
      if(!ADL__VSdef_kind_InfoArray[forLoopIdx_1].testable || !ADL__VSdef_kind_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSdef_kind_assertionReport->emitter);
      else if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].error, ADL__VSdef_kind_assertionReport->emitter);
      else
        ADL__VSdef_kind_InfoArray[forLoopIdx_1].emitFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].value, ADL__VSdef_kind_assertionReport->emitter);
     ADL__VSdef_kind_assertionReport->exprEnd(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSdef_kind_RtnVal_158);
}


VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*) = VSdef_kind;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSdef_kind_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_def_kind(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDefinitionKind }
};


unsigned int ADL__VSdef_kind_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSdef_kind_assertionReport = 0;

/*
 *
 * ACF of VStype
 *
 */
VSTypeCode_ptr *ADL__ACF_VStype (VSEnvironment *ev_210){

VSTypeCode_ptr *VStype_RtnVal_204;
  void *dummyVarName_202;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_221;
  int tmp_223;
  int tmp_224;
  VSEnvironment *ev_210_tmp_228;
    int tmp_229;
  int tmp_231;
  int tmp_232;
  int tmp_233;
  VSEnvironment *ev_210_tmp_236;
  int tmp_237;
  int tmp_238;
  VSEnvironment *ev_210_tmp_241;
    int tmp_242;
  int tmp_243;
  int groupExpr_247;
  int tmp_244;

/* Declare vars for result of normal and exception bindings */
  int VStype_NormalOutcome_205, VStype_ExceptionOutcome_206;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_207;
  VSEnvironment *ev_210_tmp_211;
    int tmp_212;
  int tmp_213;
  VSEnvironment *ev_210_tmp_216;
  int tmp_217;
  VSEnvironment *ev_210_tmp_220;
  enum ADL__ACF_result VStype_ACF_Result_203 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 0, ADL__VStype_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VStype_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VStype_InfoArray[forLoopIdx_1].error > VStype_ACF_Result_203))
  VStype_ACF_Result_203 = ADL__VStype_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VStype_ACF_Result_203 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_call);
  ADL__release(ADL__VStype_assertionReport->parent, &this_seq);
  VStype_RtnVal_204 = ADL__VStype_wrapper(ev_210);
  ADL__recover(ADL__VStype_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_210_tmp_211 = ev_210;
  ADL__setResultAndError(ADL__VStype_InfoArray, 8,&ev_210_tmp_211);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_207 = no_exception(ev_210);
  ADL__setResultAndError(ADL__VStype_InfoArray, 7,&tmp_207);
  VStype_NormalOutcome_205 = (tmp_207);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_210_tmp_216 = ev_210;
  ADL__setResultAndError(ADL__VStype_InfoArray, 3,&ev_210_tmp_216);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_213 = system_exception(ev_210);
  ADL__setResultAndError(ADL__VStype_InfoArray, 2,&tmp_213);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_212 = tmp_213;
  if (!tmp_213) {
      ev_210_tmp_220 = ev_210;
  ADL__setResultAndError(ADL__VStype_InfoArray, 5,&ev_210_tmp_220);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_217 = user_exception(ev_210);
  ADL__setResultAndError(ADL__VStype_InfoArray, 4,&tmp_217);
    tmp_212 = tmp_217;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 1,&tmp_212);

  VStype_ExceptionOutcome_206 = (tmp_212);

/* Exception binding is the first assertion */
  if (ADL__VStype_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[0].result = (VStype_ExceptionOutcome_206 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[0].evaluated = 1;
  ADL__VStype_InfoArray[0].value = (VStype_ExceptionOutcome_206 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VStype_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[6].result = (VStype_NormalOutcome_205 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[6].evaluated = 1;
  ADL__VStype_InfoArray[6].value = (VStype_NormalOutcome_205 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VStype_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_203 = ADL__VStype_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VStype_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_203 = ADL__VStype_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VStype_ExceptionOutcome_206 && !VStype_NormalOutcome_205) {
  VStype_ACF_Result_203 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VStype_ExceptionOutcome_206 && VStype_NormalOutcome_205) {
  VStype_ACF_Result_203 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VStype_InfoArray, 10,&VStype_ExceptionOutcome_206);
  ev_210_tmp_228 = ev_210;
  ADL__setResultAndError(ADL__VStype_InfoArray, 13,&ev_210_tmp_228);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_224 = user_exception_is("NOT_IMPLEMENTED", ev_210);
  ADL__setResultAndError(ADL__VStype_InfoArray, 12,&tmp_224);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_223 = !tmp_224;
  ADL__setResultAndError(ADL__VStype_InfoArray, 11,&tmp_223);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_221 = (!VStype_ExceptionOutcome_206 || tmp_223);
  ADL__setResultAndError(ADL__VStype_InfoArray, 9,&tmp_221);
    ADL__setResultAndError(ADL__VStype_InfoArray, 15,&VStype_ExceptionOutcome_206);
  ev_210_tmp_236 = ev_210;
  ADL__setResultAndError(ADL__VStype_InfoArray, 19,&ev_210_tmp_236);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_233 = system_exception(ev_210);
  ADL__setResultAndError(ADL__VStype_InfoArray, 18,&tmp_233);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_232 = !tmp_233;
  ADL__setResultAndError(ADL__VStype_InfoArray, 17,&tmp_232);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_231 = tmp_232;
  if (tmp_232) {
      ev_210_tmp_241 = ev_210;
  ADL__setResultAndError(ADL__VStype_InfoArray, 22,&ev_210_tmp_241);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_238 = user_exception(ev_210);
  ADL__setResultAndError(ADL__VStype_InfoArray, 21,&tmp_238);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_237 = !tmp_238;
  ADL__setResultAndError(ADL__VStype_InfoArray, 20,&tmp_237);
    tmp_231 = tmp_237;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 16,&tmp_231);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_229 = (!VStype_ExceptionOutcome_206 || tmp_231);
  ADL__setResultAndError(ADL__VStype_InfoArray, 14,&tmp_229);
    ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VStype_NormalOutcome_205){
      ADL__setResultAndError(ADL__VStype_InfoArray, 25,&VStype_RtnVal_204);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[24]);

/* Evaluate is_correct_typecode(return) */
  tmp_244 = is_correct_typecode(VStype_RtnVal_204);
  ADL__setResultAndError(ADL__VStype_InfoArray, 24,&tmp_244);
  groupExpr_247 = (tmp_244);
  tmp_243 = (groupExpr_247);
  tmp_242 = tmp_243;
  }
  else {
    ADL__resetInfoStruct(ADL__VStype_InfoArray, 23, 25);
  tmp_242 = 1;
}

  ADL__setResultAndError(ADL__VStype_InfoArray, 23,&tmp_242);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VStype_InfoArray[forLoopIdx_1].level == 0))
        VStype_ACF_Result_203 = calculate_ACF_result(VStype_ACF_Result_203, ADL__VStype_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VStype_assertionReport->value = VStype_ACF_Result_203;
  ADL__VStype_assertionReport->parent->openReport(ADL__VStype_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VStype_assertionReport->emitTest(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1])) {
     ADL__VStype_assertionReport->exprStart(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
      if(!ADL__VStype_InfoArray[forLoopIdx_1].testable || !ADL__VStype_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VStype_assertionReport->emitter);
      else if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VStype_InfoArray[forLoopIdx_1].error, ADL__VStype_assertionReport->emitter);
      else
        ADL__VStype_InfoArray[forLoopIdx_1].emitFunc(ADL__VStype_InfoArray[forLoopIdx_1].value, ADL__VStype_assertionReport->emitter);
     ADL__VStype_assertionReport->exprEnd(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
    }
  }

  return (VStype_RtnVal_204);
}


VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*) = VStype;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VStype_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_typecode(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P }
};


unsigned int ADL__VStype_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VStype_assertionReport = 0;
