/* ADL test driver from t1.tdr
 *
 * test VSexceptions_write(exceptions, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


static struct ADL__propertyInfo ADL__prop_info_841[] = {
    {0, 0, 0}
};
#define TVEC_SIZE 0

static struct ADL__variableInfo ADL__var_info_844[3] = {
    {"exceptions", "VSExceptionDefSeq_ptr", ADL__prop_info_841, 0, 0},
    {"env", "VSEnvironment *", ADL__prop_info_841, 0, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSexceptions_write_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSTYPECODE_PTR_P
#define ADL__PRINT_VSTYPECODE_PTR_P
void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR_P */
#ifndef ADL__PRINT_VSIDLTYPE_PTR
#define ADL__PRINT_VSIDLTYPE_PTR
void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDLTYPE_PTR */
#ifndef ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR
#define ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR
void (*ADL__print_VSParDescriptionSeq_ptr)(VSParDescriptionSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR */
#ifndef ADL__PRINT_VSOPERATIONDEF_PTR
#define ADL__PRINT_VSOPERATIONDEF_PTR
void (*ADL__print_VSOperationDef_ptr)(VSOperationDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOPERATIONDEF_PTR */
#ifndef ADL__PRINT_VSOPERATIONMODE
#define ADL__PRINT_VSOPERATIONMODE
void (*ADL__print_VSOperationMode)(VSOperationMode, emitter_t) = 0;

#endif /* ADL__PRINT_VSOPERATIONMODE */
#ifndef ADL__PRINT_VSCONTEXTIDSEQ_PTR
#define ADL__PRINT_VSCONTEXTIDSEQ_PTR
void (*ADL__print_VSContextIdSeq_ptr)(VSContextIdSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTEXTIDSEQ_PTR */
#ifndef ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR
#define ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR
void (*ADL__print_VSExceptionDefSeq_ptr)(VSExceptionDefSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR */
#ifndef ADL__PRINT_VSOPERATIONDEF_PTR_P
#define ADL__PRINT_VSOPERATIONDEF_PTR_P
void (*ADL__print_VSOperationDef_ptr_P)(VSOperationDef_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOPERATIONDEF_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */
#ifndef ADL__PRINT_VSDEFINITIONKIND
#define ADL__PRINT_VSDEFINITIONKIND
void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSDEFINITIONKIND */
#ifndef ADL__PRINT_VSDESCRIPTION_PTR
#define ADL__PRINT_VSDESCRIPTION_PTR
void (*ADL__print_VSDescription_ptr)(VSDescription_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSDESCRIPTION_PTR */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter)
{
  VSTypeCode_ptr *tmp;

  if (ADL__print_VSTypeCode_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSTypeCode_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter)
{
  VSIDLType_ptr tmp;

  if (ADL__print_VSIDLType_ptr != 0) {
    tmp = *(VSIDLType_ptr*) val;
    ADL__print_VSIDLType_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSParDescriptionSeq_ptr (void* val, emitter_t emitter)
{
  VSParDescriptionSeq_ptr tmp;

  if (ADL__print_VSParDescriptionSeq_ptr != 0) {
    tmp = *(VSParDescriptionSeq_ptr*) val;
    ADL__print_VSParDescriptionSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSOperationDef_ptr (void* val, emitter_t emitter)
{
  VSOperationDef_ptr tmp;

  if (ADL__print_VSOperationDef_ptr != 0) {
    tmp = *(VSOperationDef_ptr*) val;
    ADL__print_VSOperationDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSOperationMode (void* val, emitter_t emitter)
{
  VSOperationMode tmp;

  if (ADL__print_VSOperationMode != 0) {
    tmp = *(VSOperationMode*) val;
    ADL__print_VSOperationMode(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSContextIdSeq_ptr (void* val, emitter_t emitter)
{
  VSContextIdSeq_ptr tmp;

  if (ADL__print_VSContextIdSeq_ptr != 0) {
    tmp = *(VSContextIdSeq_ptr*) val;
    ADL__print_VSContextIdSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSExceptionDefSeq_ptr (void* val, emitter_t emitter)
{
  VSExceptionDefSeq_ptr tmp;

  if (ADL__print_VSExceptionDefSeq_ptr != 0) {
    tmp = *(VSExceptionDefSeq_ptr*) val;
    ADL__print_VSExceptionDefSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSOperationDef_ptr_P (void* val, emitter_t emitter)
{
  VSOperationDef_ptr *tmp;

  if (ADL__print_VSOperationDef_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSOperationDef_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter)
{
  VSDefinitionKind tmp;

  if (ADL__print_VSDefinitionKind != 0) {
    tmp = *(VSDefinitionKind*) val;
    ADL__print_VSDefinitionKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSDescription_ptr (void* val, emitter_t emitter)
{
  VSDescription_ptr tmp;

  if (ADL__print_VSDescription_ptr != 0) {
    tmp = *(VSDescription_ptr*) val;
    ADL__print_VSDescription_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[1];
    enum ADL__ACF_result test_value;
    VSExceptionDefSeq_ptr exceptions_842;
    VSEnvironment *env_843;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    tvec[0] = 0;
    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSexceptions_write_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSexceptions_write_InfoArrayIdx,
        ADL__VSexceptions_write_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_exceptions(&exceptions_842)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
       ADL__emit_VSExceptionDefSeq_ptr(&exceptions_842, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(0);
       if (!provide_env(&env_843)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 0);
       ADL__emit_VSEnvironment_P(&env_843, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSexceptions_write_assertionReport = rf->assertionReport;
       ADL__ACF_VSexceptions_write(exceptions_842, env_843);
       test_value = ADL__VSexceptions_write_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(0);
       relvec[1] = relinquish_env(&env_843);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_exceptions(&exceptions_842);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSexceptions_write_head);

    return 0;
}


struct ADL__Directive_info VSexceptions_write1_info = {
    N_VARS,
    ADL__var_info_844
};

struct ADL__TDD_info ADL__test_info = {
    1,
    &ADL__VSexceptions_write_InfoArrayIdx,
    ADL__VSexceptions_write_InfoArray,
    ADL__test_driver,
    "VSexceptions_write",
    "VSexceptions_write1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSexceptions_write1",
    "t1_tr.rif",
    &VSexceptions_write1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

