/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_operationdef_ptr(VSOperationDef_ptr *);

extern int is_nil_operationdef_ptr(VSOperationDef_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int is_correct_mode(VSOperationMode, VSOperationDef_ptr);

extern int is_correct_result(VSTypeCode_ptr *);

extern int is_correct_result_def(VSIDLType_ptr);

extern int is_correct_param_sequence(VSParDescriptionSeq_ptr);

extern int is_correct_param_modes(VSParDescriptionSeq_ptr);

extern int is_correct_exception_set(VSExceptionDefSeq_ptr);

extern int exception_seq_contains(VSExceptionDefSeq_ptr, char *);

extern int is_correct_contexts(VSContextIdSeq_ptr);

extern int is_same_type_def(VSIDLType_ptr, VSIDLType_ptr);

extern int is_same_params(VSParDescriptionSeq_ptr, VSParDescriptionSeq_ptr);

extern int is_same_mode(VSOperationMode, VSOperationMode);

extern int is_same_contexts(VSContextIdSeq_ptr, VSContextIdSeq_ptr);

extern int is_invalid_op(VSOperationDef_ptr);

extern int is_same_exceptions(VSExceptionDefSeq_ptr, VSExceptionDefSeq_ptr);

extern int is_correct_def_kind(VSDefinitionKind);

extern int is_correct_description(VSDescription_ptr);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSParDescriptionSeq_ptr)(VSParDescriptionSeq_ptr, emitter_t);
extern void (*ADL__print_VSOperationDef_ptr)(VSOperationDef_ptr, emitter_t);
extern void (*ADL__print_VSOperationMode)(VSOperationMode, emitter_t);
extern void (*ADL__print_VSContextIdSeq_ptr)(VSContextIdSeq_ptr, emitter_t);
extern void (*ADL__print_VSExceptionDefSeq_ptr)(VSExceptionDefSeq_ptr, emitter_t);
extern void (*ADL__print_VSOperationDef_ptr_P)(VSOperationDef_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);
extern void (*ADL__print_VSDescription_ptr)(VSDescription_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSTypeCode_ptr *(*ADL__VSresult_wrapper)(VSEnvironment*);
extern VSIDLType_ptr (*ADL__VSresult_def_read_wrapper)(VSEnvironment*);
extern VSParDescriptionSeq_ptr (*ADL__VSparams_read_wrapper)(VSEnvironment*);
extern VSOperationMode (*ADL__VSmode_read_wrapper)(VSEnvironment*, VSOperationDef_ptr);
extern VSContextIdSeq_ptr (*ADL__VScontexts_read_wrapper)(VSEnvironment*);
extern VSExceptionDefSeq_ptr (*ADL__VSexceptions_read_wrapper)(VSEnvironment*);
extern VSOperationDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSOperationDef_ptr *(*ADL__VSduplicate_wrapper)(VSOperationDef_ptr*, VSEnvironment*);
extern VSOperationDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern void (*ADL__VSresult_def_write_wrapper)(VSIDLType_ptr const, VSEnvironment*);
extern void (*ADL__VSparams_write_wrapper)(VSParDescriptionSeq_ptr const, VSEnvironment*);
extern void (*ADL__VSmode_write_wrapper)(VSOperationMode, VSEnvironment*, VSOperationDef_ptr);
extern void (*ADL__VScontexts_write_wrapper)(VSContextIdSeq_ptr const, VSEnvironment*);
extern void (*ADL__VSexceptions_write_wrapper)(VSExceptionDefSeq_ptr const, VSEnvironment*);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);
extern VSDescription_ptr (*ADL__VSdescribe_wrapper)(VSEnvironment*);

#endif
