/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSkind
 *
 */
VSPrimitiveKind ADL__ACF_VSkind (VSEnvironment *ev_10){

VSPrimitiveKind VSkind_RtnVal_4;
  void *dummyVarName_246;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_22;
  int tmp_24;
  int tmp_25;
  VSEnvironment *ev_10_tmp_29;
    int tmp_30;
  int tmp_32;
  int tmp_33;
  VSEnvironment *ev_10_tmp_36;
    int tmp_37;
  int tmp_38;
  int groupExpr_42;
  int tmp_39;

/* Declare vars for result of normal and exception bindings */
  int VSkind_NormalOutcome_5, VSkind_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSkind_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSkind_InfoArray, 0, ADL__VSkind_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSkind_assertionReport->setPhase(ADL__VSkind_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSkind_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSkind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSkind_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSkind_InfoArray[forLoopIdx_1].error > VSkind_ACF_Result_3))
  VSkind_ACF_Result_3 = ADL__VSkind_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSkind_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSkind_assertionReport->setPhase(ADL__VSkind_assertionReport, PH_call);
  ADL__release(ADL__VSkind_assertionReport->parent, &this_seq);
  VSkind_RtnVal_4 = ADL__VSkind_wrapper(ev_10);
  ADL__recover(ADL__VSkind_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSkind_assertionReport->setPhase(ADL__VSkind_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSkind_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSkind_InfoArray, 7,&tmp_7);
  VSkind_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSkind_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSkind_InfoArray, 2,&tmp_13);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSkind_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSkind_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSkind_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSkind_InfoArray, 1,&tmp_12);

  VSkind_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSkind_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSkind_InfoArray[0].result = (VSkind_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSkind_InfoArray[0].evaluated = 1;
  ADL__VSkind_InfoArray[0].value = (VSkind_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSkind_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSkind_InfoArray[6].result = (VSkind_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSkind_InfoArray[6].evaluated = 1;
  ADL__VSkind_InfoArray[6].value = (VSkind_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSkind_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSkind_ACF_Result_3 = ADL__VSkind_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSkind_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSkind_ACF_Result_3 = ADL__VSkind_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSkind_ExceptionOutcome_6 && !VSkind_NormalOutcome_5) {
  VSkind_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSkind_ExceptionOutcome_6 && VSkind_NormalOutcome_5) {
  VSkind_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSkind_InfoArray, 10,&VSkind_ExceptionOutcome_6);
  ev_10_tmp_29 = ev_10;
  ADL__setResultAndError(ADL__VSkind_InfoArray, 13,&ev_10_tmp_29);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSkind_InfoArray, 12,&tmp_25);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = !tmp_25;
  ADL__setResultAndError(ADL__VSkind_InfoArray, 11,&tmp_24);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_22 = (!VSkind_ExceptionOutcome_6 || tmp_24);
  ADL__setResultAndError(ADL__VSkind_InfoArray, 9,&tmp_22);
    ADL__setResultAndError(ADL__VSkind_InfoArray, 15,&VSkind_ExceptionOutcome_6);
  ev_10_tmp_36 = ev_10;
  ADL__setResultAndError(ADL__VSkind_InfoArray, 18,&ev_10_tmp_36);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_33 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSkind_InfoArray, 17,&tmp_33);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VSkind_InfoArray, 16,&tmp_32);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_30 = (!VSkind_ExceptionOutcome_6 || tmp_32);
  ADL__setResultAndError(ADL__VSkind_InfoArray, 14,&tmp_30);
    ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSkind_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSkind_InfoArray, 21,&VSkind_RtnVal_4);
  ADL__VSkind_assertionReport->exprMark(ADL__VSkind_assertionReport, &ADL__VSkind_assertionReport->assrt_info[20]);

/* Evaluate is_correct_kind(return) */
  tmp_39 = is_correct_kind(VSkind_RtnVal_4);
  ADL__setResultAndError(ADL__VSkind_InfoArray, 20,&tmp_39);
  groupExpr_42 = (tmp_39);
  tmp_38 = (groupExpr_42);
  tmp_37 = tmp_38;
  }
  else {
    ADL__resetInfoStruct(ADL__VSkind_InfoArray, 19, 21);
  tmp_37 = 1;
}

  ADL__setResultAndError(ADL__VSkind_InfoArray, 19,&tmp_37);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSkind_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSkind_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSkind_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSkind_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSkind_InfoArray[forLoopIdx_1].level == 0))
        VSkind_ACF_Result_3 = calculate_ACF_result(VSkind_ACF_Result_3, ADL__VSkind_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSkind_assertionReport->value = VSkind_ACF_Result_3;
  ADL__VSkind_assertionReport->parent->openReport(ADL__VSkind_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSkind_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSkind_assertionReport->emitTest(ADL__VSkind_assertionReport, &ADL__VSkind_InfoArray[forLoopIdx_1])) {
     ADL__VSkind_assertionReport->exprStart(ADL__VSkind_assertionReport, &ADL__VSkind_InfoArray[forLoopIdx_1]);
      if(!ADL__VSkind_InfoArray[forLoopIdx_1].testable || !ADL__VSkind_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSkind_assertionReport->emitter);
      else if (ADL__VSkind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSkind_InfoArray[forLoopIdx_1].error, ADL__VSkind_assertionReport->emitter);
      else
        ADL__VSkind_InfoArray[forLoopIdx_1].emitFunc(ADL__VSkind_InfoArray[forLoopIdx_1].value, ADL__VSkind_assertionReport->emitter);
     ADL__VSkind_assertionReport->exprEnd(ADL__VSkind_assertionReport, &ADL__VSkind_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSkind_RtnVal_4);
}


VSPrimitiveKind (*ADL__VSkind_wrapper)(VSEnvironment*) = VSkind;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSPrimitiveKind (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSkind_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_correct_kind(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPrimitiveKind }
};


unsigned int ADL__VSkind_InfoArrayIdx = 22;

struct ADL__reportAssertion *ADL__VSkind_assertionReport = 0;

/*
 *
 * ACF of VSnil
 *
 */
VSPrimtiveDef_ptr *ADL__ACF_VSnil (VSEnvironment *ev_51){

VSPrimtiveDef_ptr *VSnil_RtnVal_45;
  void *dummyVarName_246;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_63;
  int tmp_65;
  int tmp_66;
  VSEnvironment *ev_51_tmp_70;
    int tmp_71;
  int tmp_73;
  int tmp_74;
  int tmp_75;
  VSEnvironment *ev_51_tmp_78;
  int tmp_79;
  int tmp_80;
  VSEnvironment *ev_51_tmp_83;
    int tmp_84;
  int tmp_85;
  int groupExpr_94;
  int tmp_87;
  int tmp_88;
  int tmp_91;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_46, VSnil_ExceptionOutcome_47;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_48;
  VSEnvironment *ev_51_tmp_52;
    int tmp_53;
  int tmp_54;
  VSEnvironment *ev_51_tmp_57;
  int tmp_58;
  VSEnvironment *ev_51_tmp_61;
  enum ADL__ACF_result VSnil_ACF_Result_44 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_44))
  VSnil_ACF_Result_44 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_44 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_45 = ADL__VSnil_wrapper(ev_51);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_51_tmp_52 = ev_51;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_51_tmp_52);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_48 = no_exception(ev_51);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_48);
  VSnil_NormalOutcome_46 = (tmp_48);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_51_tmp_57 = ev_51;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_51_tmp_57);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_54 = system_exception(ev_51);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_54);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_53 = tmp_54;
  if (!tmp_54) {
      ev_51_tmp_61 = ev_51;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_51_tmp_61);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_58 = user_exception(ev_51);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_58);
    tmp_53 = tmp_58;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_53);

  VSnil_ExceptionOutcome_47 = (tmp_53);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_47 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_47 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_46 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_46 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_44 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_44 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_47 && !VSnil_NormalOutcome_46) {
  VSnil_ACF_Result_44 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_47 && VSnil_NormalOutcome_46) {
  VSnil_ACF_Result_44 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_47);
  ev_51_tmp_70 = ev_51;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_51_tmp_70);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_66 = user_exception_is("NOT_IMPLEMENTED", ev_51);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_66);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_65 = !tmp_66;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_65);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_63 = (!VSnil_ExceptionOutcome_47 || tmp_65);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_63);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_47);
  ev_51_tmp_78 = ev_51;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_51_tmp_78);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_75 = system_exception(ev_51);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_75);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_74 = !tmp_75;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_74);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_73 = tmp_74;
  if (tmp_74) {
      ev_51_tmp_83 = ev_51;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_51_tmp_83);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_80 = user_exception(ev_51);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_80);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_79 = !tmp_80;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_79);
    tmp_73 = tmp_79;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_73);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_71 = (!VSnil_ExceptionOutcome_47 || tmp_73);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_71);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_46){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_45);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_primtivedef_ptr(return) */
  tmp_88 = is_nil_primtivedef_ptr(VSnil_RtnVal_45);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_88);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_primtivedef_ptr(return) && cleanup_primtivedef_ptr(return) */
  tmp_87 = tmp_88;
  if (tmp_88) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_45);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_primtivedef_ptr(return) */
  tmp_91 = cleanup_primtivedef_ptr(VSnil_RtnVal_45);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_91);
    tmp_87 = tmp_91;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_87);
  groupExpr_94 = (tmp_87);
  tmp_85 = (groupExpr_94);
  tmp_84 = tmp_85;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_84 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_84);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_44 = calculate_ACF_result(VSnil_ACF_Result_44, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_44;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_45);
}


VSPrimtiveDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSPrimtiveDef_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_primtivedef_ptr(return) && cleanup_primtivedef_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_primtivedef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPrimtiveDef_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_primtivedef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPrimtiveDef_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSPrimtiveDef_ptr *ADL__ACF_VSduplicate (VSPrimtiveDef_ptr *o_114, VSEnvironment *ev_103){

VSPrimtiveDef_ptr *VSduplicate_RtnVal_97;
  void *dummyVarName_246;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_116;
  int tmp_118;
  int tmp_119;
  VSEnvironment *ev_103_tmp_123;
    int tmp_124;
  int tmp_126;
  int tmp_127;
  VSEnvironment *ev_103_tmp_130;
    int tmp_131;
  int tmp_132;
  int groupExpr_144;
  int groupExpr_145;
  int tmp_133;
  int tmp_134;
  VSPrimtiveDef_ptr *o_114_tmp_137;
  int tmp_138;
  int tmp_141;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_98, VSduplicate_ExceptionOutcome_99;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_100;
  VSEnvironment *ev_103_tmp_104;
    int tmp_105;
  int tmp_106;
  VSEnvironment *ev_103_tmp_109;
  int tmp_110;
  VSEnvironment *ev_103_tmp_113;
  enum ADL__ACF_result VSduplicate_ACF_Result_96 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_96))
  VSduplicate_ACF_Result_96 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_96 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_97 = ADL__VSduplicate_wrapper(o_114, ev_103);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_103_tmp_104 = ev_103;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_103_tmp_104);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_100 = no_exception(ev_103);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_100);
  VSduplicate_NormalOutcome_98 = (tmp_100);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_103_tmp_109 = ev_103;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_103_tmp_109);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_106 = system_exception(ev_103);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_106);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_105 = tmp_106;
  if (!tmp_106) {
      ev_103_tmp_113 = ev_103;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_103_tmp_113);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_110 = user_exception(ev_103);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_110);
    tmp_105 = tmp_110;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_105);

  VSduplicate_ExceptionOutcome_99 = (tmp_105);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_99 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_99 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_98 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_98 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_96 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_96 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_99 && !VSduplicate_NormalOutcome_98) {
  VSduplicate_ACF_Result_96 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_99 && VSduplicate_NormalOutcome_98) {
  VSduplicate_ACF_Result_96 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_99);
  ev_103_tmp_123 = ev_103;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_103_tmp_123);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_119 = user_exception_is("NOT_IMPLEMENTED", ev_103);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_119);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_118 = !tmp_119;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_118);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_116 = (!VSduplicate_ExceptionOutcome_99 || tmp_118);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_116);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_99);
  ev_103_tmp_130 = ev_103;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&ev_103_tmp_130);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_127 = user_exception(ev_103);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_127);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_126 = !tmp_127;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_126);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_124 = (!VSduplicate_ExceptionOutcome_99 || tmp_126);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_124);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_98){
      o_114_tmp_137 = o_114;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&o_114_tmp_137);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate is_nil_primtivedef_ptr(o) */
  tmp_134 = is_nil_primtivedef_ptr(o_114);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_134);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&VSduplicate_RtnVal_97);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[23]);

/* Evaluate is_nil_primtivedef_ptr(return) */
  tmp_138 = is_nil_primtivedef_ptr(VSduplicate_RtnVal_97);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&tmp_138);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate is_nil_primtivedef_ptr(o) --> is_nil_primtivedef_ptr(return) */
  tmp_133 = (!tmp_134 || tmp_138);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_133);
  groupExpr_144 = (tmp_133);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 26,&VSduplicate_RtnVal_97);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[25]);

/* Evaluate cleanup_primtivedef_ptr(return) */
  tmp_141 = cleanup_primtivedef_ptr(VSduplicate_RtnVal_97);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&tmp_141);
  groupExpr_145 = (tmp_141);
  tmp_132 = (groupExpr_144 && groupExpr_145);
  tmp_131 = tmp_132;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 19, 26);
  tmp_131 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&tmp_131);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_96 = calculate_ACF_result(VSduplicate_ACF_Result_96, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_96;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_97);
}


VSPrimtiveDef_ptr *(*ADL__VSduplicate_wrapper)(VSPrimtiveDef_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSPrimtiveDef_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_nil_primtivedef_ptr(o) --> is_nil_primtivedef_ptr(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_nil_primtivedef_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPrimtiveDef_ptr_P },
  {4, 23, 20, 0, 0, "is_nil_primtivedef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPrimtiveDef_ptr_P },
  {5, 25, 19, 0, 0, "cleanup_primtivedef_ptr(return)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPrimtiveDef_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSnarrow
 *
 */
VSPrimtiveDef_ptr *ADL__ACF_VSnarrow (VSObject_ptr *o_165, VSEnvironment *ev_154){

VSPrimtiveDef_ptr *VSnarrow_RtnVal_148;
  void *dummyVarName_246;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_167;
  int tmp_169;
  int tmp_170;
  VSEnvironment *ev_154_tmp_174;
    int tmp_175;
  int tmp_177;
  int tmp_178;
  VSEnvironment *ev_154_tmp_181;
    int tmp_182;
  int tmp_183;
  int groupExpr_198;
  int groupExpr_199;
  int tmp_185;
  int tmp_186;
  int tmp_189;
  VSObject_ptr tmp_191;
  VSObject_ptr *o_165_tmp_193;
  int tmp_195;

/* Declare vars for result of normal and exception bindings */
  int VSnarrow_NormalOutcome_149, VSnarrow_ExceptionOutcome_150;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_151;
  VSEnvironment *ev_154_tmp_155;
    int tmp_156;
  int tmp_157;
  VSEnvironment *ev_154_tmp_160;
  int tmp_161;
  VSEnvironment *ev_154_tmp_164;
  enum ADL__ACF_result VSnarrow_ACF_Result_147 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 0, ADL__VSnarrow_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnarrow_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnarrow_InfoArray[forLoopIdx_1].error > VSnarrow_ACF_Result_147))
  VSnarrow_ACF_Result_147 = ADL__VSnarrow_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnarrow_ACF_Result_147 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_call);
  ADL__release(ADL__VSnarrow_assertionReport->parent, &this_seq);
  VSnarrow_RtnVal_148 = ADL__VSnarrow_wrapper(o_165, ev_154);
  ADL__recover(ADL__VSnarrow_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_154_tmp_155 = ev_154;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 8,&ev_154_tmp_155);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_151 = no_exception(ev_154);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 7,&tmp_151);
  VSnarrow_NormalOutcome_149 = (tmp_151);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_154_tmp_160 = ev_154;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 3,&ev_154_tmp_160);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_157 = system_exception(ev_154);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 2,&tmp_157);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_156 = tmp_157;
  if (!tmp_157) {
      ev_154_tmp_164 = ev_154;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 5,&ev_154_tmp_164);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_161 = user_exception(ev_154);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 4,&tmp_161);
    tmp_156 = tmp_161;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 1,&tmp_156);

  VSnarrow_ExceptionOutcome_150 = (tmp_156);

/* Exception binding is the first assertion */
  if (ADL__VSnarrow_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[0].result = (VSnarrow_ExceptionOutcome_150 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[0].evaluated = 1;
  ADL__VSnarrow_InfoArray[0].value = (VSnarrow_ExceptionOutcome_150 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnarrow_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[6].result = (VSnarrow_NormalOutcome_149 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[6].evaluated = 1;
  ADL__VSnarrow_InfoArray[6].value = (VSnarrow_NormalOutcome_149 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnarrow_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_147 = ADL__VSnarrow_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnarrow_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_147 = ADL__VSnarrow_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnarrow_ExceptionOutcome_150 && !VSnarrow_NormalOutcome_149) {
  VSnarrow_ACF_Result_147 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnarrow_ExceptionOutcome_150 && VSnarrow_NormalOutcome_149) {
  VSnarrow_ACF_Result_147 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 10,&VSnarrow_ExceptionOutcome_150);
  ev_154_tmp_174 = ev_154;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 13,&ev_154_tmp_174);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_170 = user_exception_is("NOT_IMPLEMENTED", ev_154);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 12,&tmp_170);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_169 = !tmp_170;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 11,&tmp_169);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_167 = (!VSnarrow_ExceptionOutcome_150 || tmp_169);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 9,&tmp_167);
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 15,&VSnarrow_ExceptionOutcome_150);
  ev_154_tmp_181 = ev_154;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 18,&ev_154_tmp_181);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_178 = user_exception(ev_154);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 17,&tmp_178);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_177 = !tmp_178;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 16,&tmp_177);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_175 = (!VSnarrow_ExceptionOutcome_150 || tmp_177);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 14,&tmp_175);
    ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSnarrow_NormalOutcome_149){
      ADL__setResultAndError(ADL__VSnarrow_InfoArray, 22,&VSnarrow_RtnVal_148);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[21]);

/* Evaluate is_nil_primtivedef_ptr(return) */
  tmp_186 = is_nil_primtivedef_ptr(VSnarrow_RtnVal_148);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 21,&tmp_186);
  o_165_tmp_193 = o_165;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 25,&o_165_tmp_193);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[24]);

/* Evaluate *o */
  if (ADL__badPtrDeref("*o",(unsigned int) o_165)) { /* check for invalid ptr reference */
     VSnarrow_ACF_Result_147 = ADL__ACF_ERROR;
     goto REPORT_RESULT;
  };
  tmp_191 = *o_165;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 24,&tmp_191);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[23]);

/* Evaluate is_nil_object(*o) */
  tmp_189 = is_nil_object(tmp_191);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 23,&tmp_189);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[20]);

/* Evaluate is_nil_primtivedef_ptr(return) <-> is_nil_object(*o) */
  tmp_185 = ((tmp_186? 1 : 0) == (tmp_189? 1 : 0));
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 20,&tmp_185);
  groupExpr_198 = (tmp_185);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 27,&VSnarrow_RtnVal_148);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[26]);

/* Evaluate cleanup_primtivedef_ptr(return) */
  tmp_195 = cleanup_primtivedef_ptr(VSnarrow_RtnVal_148);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 26,&tmp_195);
  groupExpr_199 = (tmp_195);
  tmp_183 = (groupExpr_198 && groupExpr_199);
  tmp_182 = tmp_183;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 19, 27);
  tmp_182 = 1;
}

  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 19,&tmp_182);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnarrow_InfoArray[forLoopIdx_1].level == 0))
        VSnarrow_ACF_Result_147 = calculate_ACF_result(VSnarrow_ACF_Result_147, ADL__VSnarrow_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnarrow_assertionReport->value = VSnarrow_ACF_Result_147;
  ADL__VSnarrow_assertionReport->parent->openReport(ADL__VSnarrow_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnarrow_assertionReport->emitTest(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1])) {
     ADL__VSnarrow_assertionReport->exprStart(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnarrow_InfoArray[forLoopIdx_1].testable || !ADL__VSnarrow_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnarrow_assertionReport->emitter);
      else if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].error, ADL__VSnarrow_assertionReport->emitter);
      else
        ADL__VSnarrow_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].value, ADL__VSnarrow_assertionReport->emitter);
     ADL__VSnarrow_assertionReport->exprEnd(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnarrow_RtnVal_148);
}


VSPrimtiveDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*) = VSnarrow;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSPrimtiveDef_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSObject_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_nil_primtivedef_ptr(return) <-> is_nil_object(*o)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_nil_primtivedef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPrimtiveDef_ptr_P },
  {4, 23, 20, 0, 0, "is_nil_object(*o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "*o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr },
  {4, 25, 24, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {5, 26, 19, 0, 0, "cleanup_primtivedef_ptr(return)", 26, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 27, 26, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPrimtiveDef_ptr_P }
};


unsigned int ADL__VSnarrow_InfoArrayIdx = 28;

struct ADL__reportAssertion *ADL__VSnarrow_assertionReport = 0;

/*
 *
 * ACF of VSdef_kind
 *
 */
VSDefinitionKind ADL__ACF_VSdef_kind (VSEnvironment *ev_208){

VSDefinitionKind VSdef_kind_RtnVal_202;
  void *dummyVarName_246;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_219;
  int tmp_221;
  int tmp_222;
  VSEnvironment *ev_208_tmp_226;
    int tmp_227;
  int tmp_229;
  int tmp_230;
  int tmp_231;
  VSEnvironment *ev_208_tmp_234;
  int tmp_235;
  int tmp_236;
  VSEnvironment *ev_208_tmp_239;
    int tmp_240;
  int tmp_241;
  int groupExpr_245;
  int tmp_242;

/* Declare vars for result of normal and exception bindings */
  int VSdef_kind_NormalOutcome_203, VSdef_kind_ExceptionOutcome_204;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_205;
  VSEnvironment *ev_208_tmp_209;
    int tmp_210;
  int tmp_211;
  VSEnvironment *ev_208_tmp_214;
  int tmp_215;
  VSEnvironment *ev_208_tmp_218;
  enum ADL__ACF_result VSdef_kind_ACF_Result_201 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 0, ADL__VSdef_kind_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > VSdef_kind_ACF_Result_201))
  VSdef_kind_ACF_Result_201 = ADL__VSdef_kind_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSdef_kind_ACF_Result_201 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_call);
  ADL__release(ADL__VSdef_kind_assertionReport->parent, &this_seq);
  VSdef_kind_RtnVal_202 = ADL__VSdef_kind_wrapper(ev_208);
  ADL__recover(ADL__VSdef_kind_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_208_tmp_209 = ev_208;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 8,&ev_208_tmp_209);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_205 = no_exception(ev_208);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 7,&tmp_205);
  VSdef_kind_NormalOutcome_203 = (tmp_205);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_208_tmp_214 = ev_208;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 3,&ev_208_tmp_214);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_211 = system_exception(ev_208);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 2,&tmp_211);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_210 = tmp_211;
  if (!tmp_211) {
      ev_208_tmp_218 = ev_208;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 5,&ev_208_tmp_218);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_215 = user_exception(ev_208);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 4,&tmp_215);
    tmp_210 = tmp_215;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 1,&tmp_210);

  VSdef_kind_ExceptionOutcome_204 = (tmp_210);

/* Exception binding is the first assertion */
  if (ADL__VSdef_kind_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[0].result = (VSdef_kind_ExceptionOutcome_204 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[0].evaluated = 1;
  ADL__VSdef_kind_InfoArray[0].value = (VSdef_kind_ExceptionOutcome_204 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSdef_kind_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[6].result = (VSdef_kind_NormalOutcome_203 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[6].evaluated = 1;
  ADL__VSdef_kind_InfoArray[6].value = (VSdef_kind_NormalOutcome_203 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSdef_kind_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_201 = ADL__VSdef_kind_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSdef_kind_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_201 = ADL__VSdef_kind_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSdef_kind_ExceptionOutcome_204 && !VSdef_kind_NormalOutcome_203) {
  VSdef_kind_ACF_Result_201 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSdef_kind_ExceptionOutcome_204 && VSdef_kind_NormalOutcome_203) {
  VSdef_kind_ACF_Result_201 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 10,&VSdef_kind_ExceptionOutcome_204);
  ev_208_tmp_226 = ev_208;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 13,&ev_208_tmp_226);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_222 = user_exception_is("NOT_IMPLEMENTED", ev_208);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 12,&tmp_222);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_221 = !tmp_222;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 11,&tmp_221);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_219 = (!VSdef_kind_ExceptionOutcome_204 || tmp_221);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 9,&tmp_219);
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 15,&VSdef_kind_ExceptionOutcome_204);
  ev_208_tmp_234 = ev_208;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 19,&ev_208_tmp_234);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_231 = system_exception(ev_208);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 18,&tmp_231);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_230 = !tmp_231;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 17,&tmp_230);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_229 = tmp_230;
  if (tmp_230) {
      ev_208_tmp_239 = ev_208;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 22,&ev_208_tmp_239);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_236 = user_exception(ev_208);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 21,&tmp_236);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_235 = !tmp_236;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 20,&tmp_235);
    tmp_229 = tmp_235;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 16,&tmp_229);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_227 = (!VSdef_kind_ExceptionOutcome_204 || tmp_229);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 14,&tmp_227);
    ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSdef_kind_NormalOutcome_203){
      ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 25,&VSdef_kind_RtnVal_202);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[24]);

/* Evaluate is_correct_def_kind(return) */
  tmp_242 = is_correct_def_kind(VSdef_kind_RtnVal_202);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 24,&tmp_242);
  groupExpr_245 = (tmp_242);
  tmp_241 = (groupExpr_245);
  tmp_240 = tmp_241;
  }
  else {
    ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 23, 25);
  tmp_240 = 1;
}

  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 23,&tmp_240);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSdef_kind_InfoArray[forLoopIdx_1].level == 0))
        VSdef_kind_ACF_Result_201 = calculate_ACF_result(VSdef_kind_ACF_Result_201, ADL__VSdef_kind_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSdef_kind_assertionReport->value = VSdef_kind_ACF_Result_201;
  ADL__VSdef_kind_assertionReport->parent->openReport(ADL__VSdef_kind_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSdef_kind_assertionReport->emitTest(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1])) {
     ADL__VSdef_kind_assertionReport->exprStart(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
      if(!ADL__VSdef_kind_InfoArray[forLoopIdx_1].testable || !ADL__VSdef_kind_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSdef_kind_assertionReport->emitter);
      else if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].error, ADL__VSdef_kind_assertionReport->emitter);
      else
        ADL__VSdef_kind_InfoArray[forLoopIdx_1].emitFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].value, ADL__VSdef_kind_assertionReport->emitter);
     ADL__VSdef_kind_assertionReport->exprEnd(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSdef_kind_RtnVal_202);
}


VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*) = VSdef_kind;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSdef_kind_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_def_kind(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDefinitionKind }
};


unsigned int ADL__VSdef_kind_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSdef_kind_assertionReport = 0;

/*
 *
 * ACF of VStype
 *
 */
VSTypeCode_ptr *ADL__ACF_VStype (VSEnvironment *ev_254){

VSTypeCode_ptr *VStype_RtnVal_248;
  void *dummyVarName_246;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_265;
  int tmp_267;
  int tmp_268;
  VSEnvironment *ev_254_tmp_272;
    int tmp_273;
  int tmp_275;
  int tmp_276;
  int tmp_277;
  VSEnvironment *ev_254_tmp_280;
  int tmp_281;
  int tmp_282;
  VSEnvironment *ev_254_tmp_285;
    int tmp_286;
  int tmp_287;
  int groupExpr_291;
  int tmp_288;

/* Declare vars for result of normal and exception bindings */
  int VStype_NormalOutcome_249, VStype_ExceptionOutcome_250;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_251;
  VSEnvironment *ev_254_tmp_255;
    int tmp_256;
  int tmp_257;
  VSEnvironment *ev_254_tmp_260;
  int tmp_261;
  VSEnvironment *ev_254_tmp_264;
  enum ADL__ACF_result VStype_ACF_Result_247 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 0, ADL__VStype_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VStype_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VStype_InfoArray[forLoopIdx_1].error > VStype_ACF_Result_247))
  VStype_ACF_Result_247 = ADL__VStype_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VStype_ACF_Result_247 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_call);
  ADL__release(ADL__VStype_assertionReport->parent, &this_seq);
  VStype_RtnVal_248 = ADL__VStype_wrapper(ev_254);
  ADL__recover(ADL__VStype_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_254_tmp_255 = ev_254;
  ADL__setResultAndError(ADL__VStype_InfoArray, 8,&ev_254_tmp_255);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_251 = no_exception(ev_254);
  ADL__setResultAndError(ADL__VStype_InfoArray, 7,&tmp_251);
  VStype_NormalOutcome_249 = (tmp_251);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_254_tmp_260 = ev_254;
  ADL__setResultAndError(ADL__VStype_InfoArray, 3,&ev_254_tmp_260);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_257 = system_exception(ev_254);
  ADL__setResultAndError(ADL__VStype_InfoArray, 2,&tmp_257);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_256 = tmp_257;
  if (!tmp_257) {
      ev_254_tmp_264 = ev_254;
  ADL__setResultAndError(ADL__VStype_InfoArray, 5,&ev_254_tmp_264);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_261 = user_exception(ev_254);
  ADL__setResultAndError(ADL__VStype_InfoArray, 4,&tmp_261);
    tmp_256 = tmp_261;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 1,&tmp_256);

  VStype_ExceptionOutcome_250 = (tmp_256);

/* Exception binding is the first assertion */
  if (ADL__VStype_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[0].result = (VStype_ExceptionOutcome_250 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[0].evaluated = 1;
  ADL__VStype_InfoArray[0].value = (VStype_ExceptionOutcome_250 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VStype_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[6].result = (VStype_NormalOutcome_249 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[6].evaluated = 1;
  ADL__VStype_InfoArray[6].value = (VStype_NormalOutcome_249 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VStype_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_247 = ADL__VStype_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VStype_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_247 = ADL__VStype_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VStype_ExceptionOutcome_250 && !VStype_NormalOutcome_249) {
  VStype_ACF_Result_247 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VStype_ExceptionOutcome_250 && VStype_NormalOutcome_249) {
  VStype_ACF_Result_247 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VStype_InfoArray, 10,&VStype_ExceptionOutcome_250);
  ev_254_tmp_272 = ev_254;
  ADL__setResultAndError(ADL__VStype_InfoArray, 13,&ev_254_tmp_272);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_268 = user_exception_is("NOT_IMPLEMENTED", ev_254);
  ADL__setResultAndError(ADL__VStype_InfoArray, 12,&tmp_268);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_267 = !tmp_268;
  ADL__setResultAndError(ADL__VStype_InfoArray, 11,&tmp_267);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_265 = (!VStype_ExceptionOutcome_250 || tmp_267);
  ADL__setResultAndError(ADL__VStype_InfoArray, 9,&tmp_265);
    ADL__setResultAndError(ADL__VStype_InfoArray, 15,&VStype_ExceptionOutcome_250);
  ev_254_tmp_280 = ev_254;
  ADL__setResultAndError(ADL__VStype_InfoArray, 19,&ev_254_tmp_280);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_277 = system_exception(ev_254);
  ADL__setResultAndError(ADL__VStype_InfoArray, 18,&tmp_277);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_276 = !tmp_277;
  ADL__setResultAndError(ADL__VStype_InfoArray, 17,&tmp_276);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_275 = tmp_276;
  if (tmp_276) {
      ev_254_tmp_285 = ev_254;
  ADL__setResultAndError(ADL__VStype_InfoArray, 22,&ev_254_tmp_285);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_282 = user_exception(ev_254);
  ADL__setResultAndError(ADL__VStype_InfoArray, 21,&tmp_282);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_281 = !tmp_282;
  ADL__setResultAndError(ADL__VStype_InfoArray, 20,&tmp_281);
    tmp_275 = tmp_281;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 16,&tmp_275);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_273 = (!VStype_ExceptionOutcome_250 || tmp_275);
  ADL__setResultAndError(ADL__VStype_InfoArray, 14,&tmp_273);
    ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VStype_NormalOutcome_249){
      ADL__setResultAndError(ADL__VStype_InfoArray, 25,&VStype_RtnVal_248);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[24]);

/* Evaluate is_correct_typecode(return) */
  tmp_288 = is_correct_typecode(VStype_RtnVal_248);
  ADL__setResultAndError(ADL__VStype_InfoArray, 24,&tmp_288);
  groupExpr_291 = (tmp_288);
  tmp_287 = (groupExpr_291);
  tmp_286 = tmp_287;
  }
  else {
    ADL__resetInfoStruct(ADL__VStype_InfoArray, 23, 25);
  tmp_286 = 1;
}

  ADL__setResultAndError(ADL__VStype_InfoArray, 23,&tmp_286);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VStype_InfoArray[forLoopIdx_1].level == 0))
        VStype_ACF_Result_247 = calculate_ACF_result(VStype_ACF_Result_247, ADL__VStype_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VStype_assertionReport->value = VStype_ACF_Result_247;
  ADL__VStype_assertionReport->parent->openReport(ADL__VStype_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VStype_assertionReport->emitTest(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1])) {
     ADL__VStype_assertionReport->exprStart(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
      if(!ADL__VStype_InfoArray[forLoopIdx_1].testable || !ADL__VStype_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VStype_assertionReport->emitter);
      else if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VStype_InfoArray[forLoopIdx_1].error, ADL__VStype_assertionReport->emitter);
      else
        ADL__VStype_InfoArray[forLoopIdx_1].emitFunc(ADL__VStype_InfoArray[forLoopIdx_1].value, ADL__VStype_assertionReport->emitter);
     ADL__VStype_assertionReport->exprEnd(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
    }
  }

  return (VStype_RtnVal_248);
}


VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*) = VStype;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VStype_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_typecode(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P }
};


unsigned int ADL__VStype_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VStype_assertionReport = 0;
