/* ADL test driver from t1.tdr
 *
 * test VScreate_array(bound, el_type, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for literal variable bound */
static VSULong ADL__litvar_val_525[] = {
    5,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_524[] = {
    {"5", 0, ADL__litvar_val_525},
    {"0", 1, ADL__litvar_val_525},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_537[] = {
    {"bound", "litvar", ADL__litvar_info_524, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_541[4] = {
    {"bound", "VSULong", ADL__prop_info_537, 0, 1},
    {"el_type", "VSIDLType_ptr", ADL__prop_info_537, 1, 0},
    {"env", "VSEnvironment *", ADL__prop_info_537, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScreate_array_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSREPOSITORYID
#define ADL__PRINT_VSREPOSITORYID
void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t) = 0;

#endif /* ADL__PRINT_VSREPOSITORYID */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSCONTAINED_PTR
#define ADL__PRINT_VSCONTAINED_PTR
void (*ADL__print_VSContained_ptr)(VSContained_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTAINED_PTR */
#ifndef ADL__PRINT_VSPRIMITIVEKIND
#define ADL__PRINT_VSPRIMITIVEKIND
void (*ADL__print_VSPrimitiveKind)(VSPrimitiveKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSPRIMITIVEKIND */
#ifndef ADL__PRINT_VSPRIMITIVEDEF_PTR
#define ADL__PRINT_VSPRIMITIVEDEF_PTR
void (*ADL__print_VSPrimitiveDef_ptr)(VSPrimitiveDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSPRIMITIVEDEF_PTR */
#ifndef ADL__PRINT_VSREPOSITORY_PTR_P
#define ADL__PRINT_VSREPOSITORY_PTR_P
void (*ADL__print_VSRepository_ptr_P)(VSRepository_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSREPOSITORY_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSCONTAINED_PTR_P
#define ADL__PRINT_VSCONTAINED_PTR_P
void (*ADL__print_VSContained_ptr_P)(VSContained_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTAINED_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSSTRINGDEF_PTR
#define ADL__PRINT_VSSTRINGDEF_PTR
void (*ADL__print_VSStringDef_ptr)(VSStringDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRINGDEF_PTR */
#ifndef ADL__PRINT_VSIDLTYPE_PTR
#define ADL__PRINT_VSIDLTYPE_PTR
void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDLTYPE_PTR */
#ifndef ADL__PRINT_VSSEQUENCEDEF_PTR
#define ADL__PRINT_VSSEQUENCEDEF_PTR
void (*ADL__print_VSSequenceDef_ptr)(VSSequenceDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSSEQUENCEDEF_PTR */
#ifndef ADL__PRINT_VSARRAYDEF_PTR
#define ADL__PRINT_VSARRAYDEF_PTR
void (*ADL__print_VSArrayDef_ptr)(VSArrayDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSARRAYDEF_PTR */
#ifndef ADL__PRINT_VSDEFINITIONKIND
#define ADL__PRINT_VSDEFINITIONKIND
void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSDEFINITIONKIND */
#ifndef ADL__PRINT_VSTYPECODE_PTR
#define ADL__PRINT_VSTYPECODE_PTR
void (*ADL__print_VSTypeCode_ptr)(VSTypeCode_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR */
#ifndef ADL__PRINT_VSWSTRINGDEF_PTR
#define ADL__PRINT_VSWSTRINGDEF_PTR
void (*ADL__print_VSWstringDef_ptr)(VSWstringDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSWSTRINGDEF_PTR */

void ADL__emit_VSRepositoryId (void* val, emitter_t emitter)
{
  VSRepositoryId tmp;

  if (ADL__print_VSRepositoryId != 0) {
    tmp = *(VSRepositoryId*) val;
    ADL__print_VSRepositoryId(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContained_ptr (void* val, emitter_t emitter)
{
  VSContained_ptr tmp;

  if (ADL__print_VSContained_ptr != 0) {
    tmp = *(VSContained_ptr*) val;
    ADL__print_VSContained_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPrimitiveKind (void* val, emitter_t emitter)
{
  VSPrimitiveKind tmp;

  if (ADL__print_VSPrimitiveKind != 0) {
    tmp = *(VSPrimitiveKind*) val;
    ADL__print_VSPrimitiveKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSPrimitiveDef_ptr (void* val, emitter_t emitter)
{
  VSPrimitiveDef_ptr tmp;

  if (ADL__print_VSPrimitiveDef_ptr != 0) {
    tmp = *(VSPrimitiveDef_ptr*) val;
    ADL__print_VSPrimitiveDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRepository_ptr_P (void* val, emitter_t emitter)
{
  VSRepository_ptr *tmp;

  if (ADL__print_VSRepository_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSRepository_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContained_ptr_P (void* val, emitter_t emitter)
{
  VSContained_ptr *tmp;

  if (ADL__print_VSContained_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSContained_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSStringDef_ptr (void* val, emitter_t emitter)
{
  VSStringDef_ptr tmp;

  if (ADL__print_VSStringDef_ptr != 0) {
    tmp = *(VSStringDef_ptr*) val;
    ADL__print_VSStringDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter)
{
  VSIDLType_ptr tmp;

  if (ADL__print_VSIDLType_ptr != 0) {
    tmp = *(VSIDLType_ptr*) val;
    ADL__print_VSIDLType_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSSequenceDef_ptr (void* val, emitter_t emitter)
{
  VSSequenceDef_ptr tmp;

  if (ADL__print_VSSequenceDef_ptr != 0) {
    tmp = *(VSSequenceDef_ptr*) val;
    ADL__print_VSSequenceDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSArrayDef_ptr (void* val, emitter_t emitter)
{
  VSArrayDef_ptr tmp;

  if (ADL__print_VSArrayDef_ptr != 0) {
    tmp = *(VSArrayDef_ptr*) val;
    ADL__print_VSArrayDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter)
{
  VSDefinitionKind tmp;

  if (ADL__print_VSDefinitionKind != 0) {
    tmp = *(VSDefinitionKind*) val;
    ADL__print_VSDefinitionKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSTypeCode_ptr (void* val, emitter_t emitter)
{
  VSTypeCode_ptr tmp;

  if (ADL__print_VSTypeCode_ptr != 0) {
    tmp = *(VSTypeCode_ptr*) val;
    ADL__print_VSTypeCode_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSWstringDef_ptr (void* val, emitter_t emitter)
{
  VSWstringDef_ptr tmp;

  if (ADL__print_VSWstringDef_ptr != 0) {
    tmp = *(VSWstringDef_ptr*) val;
    ADL__print_VSWstringDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSULong bound_538;
    VSIDLType_ptr el_type_539;
    VSEnvironment *env_540;
    VSArrayDef_ptr fut_return_536;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScreate_array_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScreate_array_InfoArrayIdx,
        ADL__VScreate_array_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       bound_538 = ADL__litvar_val_525[tvec[0]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 0, tvec + 0, 1);
       ADL__emit_VSULong(&bound_538, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_el_type(&el_type_539)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSIDLType_ptr(&el_type_539, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_540)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_540, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScreate_array_assertionReport = rf->assertionReport;
       fut_return_536 = ADL__ACF_VScreate_array(bound_538, el_type_539, env_540);
       test_value = ADL__VScreate_array_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[2] = relinquish_env(&env_540);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_el_type(&el_type_539);
SKIP_1:
       relvec[0] = 1;	/* relinquish succeeds for bound_538 */
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_541,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScreate_array_head);

    return 0;
}


struct ADL__Directive_info VScreate_array1_info = {
    N_VARS,
    ADL__var_info_541
};

struct ADL__TDD_info ADL__test_info = {
    2,
    &ADL__VScreate_array_InfoArrayIdx,
    ADL__VScreate_array_InfoArray,
    ADL__test_driver,
    "VScreate_array",
    "VScreate_array1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScreate_array1",
    "t1_tr.rif",
    &VScreate_array1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

