/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/StringDef/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:28  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.4  1997/11/26 14:58:15  kevin
   Added write tests and update CORBA scoping.

   Revision 1.3  1997/10/24 14:15:29  kevin
   *** empty log message ***



*/

#include <corba_defs.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSULong
VSbound_read(VSEnvironment *ev);

/*------------------------------------------------------*/
VSStringDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSStringDef_ptr*
VSduplicate(VSStringDef_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSStringDef_ptr*
VSnil(VSEnvironment *ev);

/*------------------------------------------------------*/
void
VSbound_write(VSULong vs_new_bound, VSEnvironment *ev);

/*------------------------------------------------------*/
/* REDEFINED INTERFACE */
/*------------------------------------------------------*/

VSDefinitionKind 
VSdef_kind(VSEnvironment *ev);

/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev);

