/*
 * ./t1i_tdi.h
 * generated from t1i.tdi by ADLT
 */
#ifndef T1I_TDI_H
#define T1I_TDI_H 1

#include <adl_reporting.h>
#include "t1_aux.h"

/* ---- global property declarations ---- */
/* ---- test variables and local properties ---- */
enum prop_object_ptr_objValue {Pobject_ptr_objValue_valid, Pobject_ptr_objValue_null};
#define PROP_OBJECT_PTR_OBJVALUE_SZ 2

/* test variable VSObject_ptr object_ptr(prop objValue) */
int provide_object_ptr (VSObject_ptr *testvar, enum prop_object_ptr_objValue objValue);
int relinquish_object_ptr (VSObject_ptr *testvar, enum prop_object_ptr_objValue objValue);

/* test variable VSValueDef_ptr c_vdef() */
int provide_c_vdef (VSValueDef_ptr *testvar);
int relinquish_c_vdef (VSValueDef_ptr *testvar);

enum prop_c_id_a {Pc_id_a_derived, Pc_id_a_not_derived};
#define PROP_C_ID_A_SZ 2

/* test variable VSRepositoryId c_id(prop a) */
int provide_c_id (VSRepositoryId *testvar, enum prop_c_id_a a);
int relinquish_c_id (VSRepositoryId *testvar, enum prop_c_id_a a);

/* test variable VSValueDef_ptr s_vdef() */
int provide_s_vdef (VSValueDef_ptr *testvar);
int relinquish_s_vdef (VSValueDef_ptr *testvar);

/* test variable VSValueDefSeq_ptr s_vdef_seq() */
int provide_s_vdef_seq (VSValueDefSeq_ptr *testvar);
int relinquish_s_vdef_seq (VSValueDefSeq_ptr *testvar);

/* test variable VSInterfaceDefSeq_ptr s_intf_def_seq() */
int provide_s_intf_def_seq (VSInterfaceDefSeq_ptr *testvar);
int relinquish_s_intf_def_seq (VSInterfaceDefSeq_ptr *testvar);

/* test variable VSInitializerSeq_ptr s_initializer_seq() */
int provide_s_initializer_seq (VSInitializerSeq_ptr *testvar);
int relinquish_s_initializer_seq (VSInitializerSeq_ptr *testvar);

enum prop_vl_id_a {Pvl_id_a_exist, Pvl_id_a_non_exist};
#define PROP_VL_ID_A_SZ 2

/* test variable VSRepositoryId vl_id(prop a) */
int provide_vl_id (VSRepositoryId *testvar, enum prop_vl_id_a a);
int relinquish_vl_id (VSRepositoryId *testvar, enum prop_vl_id_a a);

enum prop_vl_name_b {Pvl_name_b_exist, Pvl_name_b_non_exist};
#define PROP_VL_NAME_B_SZ 2

/* test variable VSIdentifier vl_name(prop b) */
int provide_vl_name (VSIdentifier *testvar, enum prop_vl_name_b b);
int relinquish_vl_name (VSIdentifier *testvar, enum prop_vl_name_b b);

/* test variable VSIDLType_ptr vl_type() */
int provide_vl_type (VSIDLType_ptr *testvar);
int relinquish_vl_type (VSIDLType_ptr *testvar);

enum prop_at_id_a {Pat_id_a_exist, Pat_id_a_non_exist};
#define PROP_AT_ID_A_SZ 2

/* test variable VSRepositoryId at_id(prop a) */
int provide_at_id (VSRepositoryId *testvar, enum prop_at_id_a a);
int relinquish_at_id (VSRepositoryId *testvar, enum prop_at_id_a a);

enum prop_at_name_b {Pat_name_b_exist, Pat_name_b_non_exist};
#define PROP_AT_NAME_B_SZ 2

/* test variable VSIdentifier at_name(prop b) */
int provide_at_name (VSIdentifier *testvar, enum prop_at_name_b b);
int relinquish_at_name (VSIdentifier *testvar, enum prop_at_name_b b);

/* test variable VSIDLType_ptr at_type() */
int provide_at_type (VSIDLType_ptr *testvar);
int relinquish_at_type (VSIDLType_ptr *testvar);

enum prop_at_mode_c {Pat_mode_c_normal, Pat_mode_c_readonly};
#define PROP_AT_MODE_C_SZ 2

/* test variable VSAttributeMode at_mode(prop c) */
int provide_at_mode (VSAttributeMode *testvar, enum prop_at_mode_c c);
int relinquish_at_mode (VSAttributeMode *testvar, enum prop_at_mode_c c);

enum prop_op_id_a {Pop_id_a_exist, Pop_id_a_non_exist};
#define PROP_OP_ID_A_SZ 2

/* test variable VSRepositoryId op_id(prop a) */
int provide_op_id (VSRepositoryId *testvar, enum prop_op_id_a a);
int relinquish_op_id (VSRepositoryId *testvar, enum prop_op_id_a a);

enum prop_op_name_b {Pop_name_b_exist, Pop_name_b_non_exist};
#define PROP_OP_NAME_B_SZ 2

/* test variable VSIdentifier op_name(prop b) */
int provide_op_name (VSIdentifier *testvar, enum prop_op_name_b b);
int relinquish_op_name (VSIdentifier *testvar, enum prop_op_name_b b);

/* test variable VSIDLType_ptr op_result() */
int provide_op_result (VSIDLType_ptr *testvar);
int relinquish_op_result (VSIDLType_ptr *testvar);

enum prop_op_mode_c {Pop_mode_c_normal, Pop_mode_c_oneway};
#define PROP_OP_MODE_C_SZ 2

/* test variable VSOperationMode op_mode(prop c) */
int provide_op_mode (VSOperationMode *testvar, enum prop_op_mode_c c);
int relinquish_op_mode (VSOperationMode *testvar, enum prop_op_mode_c c);

/* test variable VSParDescriptionSeq_ptr op_params() */
int provide_op_params (VSParDescriptionSeq_ptr *testvar);
int relinquish_op_params (VSParDescriptionSeq_ptr *testvar);

/* test variable VSExceptionDefSeq_ptr op_exceptions() */
int provide_op_exceptions (VSExceptionDefSeq_ptr *testvar);
int relinquish_op_exceptions (VSExceptionDefSeq_ptr *testvar);

/* test variable VSContextIdSeq_ptr op_contexts() */
int provide_op_contexts (VSContextIdSeq_ptr *testvar);
int relinquish_op_contexts (VSContextIdSeq_ptr *testvar);

#endif
