/* ADL test driver from t1.tdr
 *
 * test VSaccess_write(env, c_vmdef, s_access)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for literal variable s_access */
static VSVisibility ADL__litvar_val_433[] = {
    0,
    1,
};

static struct ADL__propertyValue ADL__litvar_info_432[] = {
    {"0", 0, ADL__litvar_val_433},
    {"1", 1, ADL__litvar_val_433},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_434[] = {
    {"s_access", "litvar", ADL__litvar_info_432, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_438[4] = {
    {"env", "VSEnvironment *", ADL__prop_info_434, 0, 0},
    {"c_vmdef", "VSValueMemberDef_ptr", ADL__prop_info_434, 0, 0},
    {"s_access", "VSVisibility", ADL__prop_info_434, 0, 1},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSaccess_write_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSVALUEMEMBERDEF_PTR
#define ADL__PRINT_VSVALUEMEMBERDEF_PTR
void (*ADL__print_VSValueMemberDef_ptr)(VSValueMemberDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEMEMBERDEF_PTR */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */
#ifndef ADL__PRINT_VSTYPECODE_PTR
#define ADL__PRINT_VSTYPECODE_PTR
void (*ADL__print_VSTypeCode_ptr)(VSTypeCode_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR */
#ifndef ADL__PRINT_VSIDLTYPE_PTR
#define ADL__PRINT_VSIDLTYPE_PTR
void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDLTYPE_PTR */
#ifndef ADL__PRINT_VSVISIBILITY
#define ADL__PRINT_VSVISIBILITY
void (*ADL__print_VSVisibility)(VSVisibility, emitter_t) = 0;

#endif /* ADL__PRINT_VSVISIBILITY */
#ifndef ADL__PRINT_VSDEFINITIONKIND
#define ADL__PRINT_VSDEFINITIONKIND
void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSDEFINITIONKIND */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter)
{
  VSValueMemberDef_ptr tmp;

  if (ADL__print_VSValueMemberDef_ptr != 0) {
    tmp = *(VSValueMemberDef_ptr*) val;
    ADL__print_VSValueMemberDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSTypeCode_ptr (void* val, emitter_t emitter)
{
  VSTypeCode_ptr tmp;

  if (ADL__print_VSTypeCode_ptr != 0) {
    tmp = *(VSTypeCode_ptr*) val;
    ADL__print_VSTypeCode_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter)
{
  VSIDLType_ptr tmp;

  if (ADL__print_VSIDLType_ptr != 0) {
    tmp = *(VSIDLType_ptr*) val;
    ADL__print_VSIDLType_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSVisibility (void* val, emitter_t emitter)
{
  VSVisibility tmp;

  if (ADL__print_VSVisibility != 0) {
    tmp = *(VSVisibility*) val;
    ADL__print_VSVisibility(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter)
{
  VSDefinitionKind tmp;

  if (ADL__print_VSDefinitionKind != 0) {
    tmp = *(VSDefinitionKind*) val;
    ADL__print_VSDefinitionKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSEnvironment *env_435;
    VSValueMemberDef_ptr c_vmdef_436;
    VSVisibility s_access_437;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSaccess_write_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSaccess_write_InfoArrayIdx,
        ADL__VSaccess_write_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_env(&env_435)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
       ADL__emit_VSEnvironment_P(&env_435, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(0);
       if (!provide_c_vmdef(&c_vmdef_436)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 0);
       ADL__emit_VSValueMemberDef_ptr(&c_vmdef_436, rf->variableReport->emitVariable);

       s_access_437 = ADL__litvar_val_433[tvec[0]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 2, tvec + 0, 1);
       ADL__emit_VSVisibility(&s_access_437, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSaccess_write_assertionReport = rf->assertionReport;
       ADL__ACF_VSaccess_write(env_435, c_vmdef_436, s_access_437);
       test_value = ADL__VSaccess_write_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
       relvec[2] = 1;	/* relinquish succeeds for s_access_437 */
      ADL__set_TDDVarNum(0);
       relvec[1] = relinquish_c_vmdef(&c_vmdef_436);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_env(&env_435);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_438,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSaccess_write_head);

    return 0;
}


struct ADL__Directive_info VSaccess_write1_info = {
    N_VARS,
    ADL__var_info_438
};

struct ADL__TDD_info ADL__test_info = {
    2,
    &ADL__VSaccess_write_InfoArrayIdx,
    ADL__VSaccess_write_InfoArray,
    ADL__test_driver,
    "VSaccess_write",
    "VSaccess_write1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSaccess_write1",
    "t1_tr.rif",
    &VSaccess_write1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

