/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_valuememdef_ptr(VSValueMemberDef_ptr);

extern int is_nil_valuememdef_ptr(VSValueMemberDef_ptr);

extern int is_nil_object(VSObject_ptr);

extern int correct_type(VSTypeCode_ptr);

extern int correct_type_def(VSIDLType_ptr);

extern int correct_type_def_set(VSIDLType_ptr, VSValueMemberDef_ptr);

extern int correct_access(VSVisibility);

extern int correct_access_set(VSVisibility, VSValueMemberDef_ptr);

extern int is_correct_def_kind(VSDefinitionKind);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSValueMemberDef_ptr)(VSValueMemberDef_ptr, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr)(VSTypeCode_ptr, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSVisibility)(VSVisibility, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);

/* Declarations of wrapper of FUT */
extern VSValueMemberDef_ptr (*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSValueMemberDef_ptr (*ADL__VSduplicate_wrapper)(VSValueMemberDef_ptr, VSEnvironment*);
extern VSValueMemberDef_ptr (*ADL__VSnarrow_wrapper)(VSObject_ptr, VSEnvironment*);
extern VSTypeCode_ptr (*ADL__VStype_wrapper)(VSEnvironment*, VSValueMemberDef_ptr);
extern VSIDLType_ptr (*ADL__VStype_def_read_wrapper)(VSEnvironment*, VSValueMemberDef_ptr);
extern void (*ADL__VStype_def_write_wrapper)(VSEnvironment*, VSValueMemberDef_ptr, VSIDLType_ptr);
extern VSVisibility (*ADL__VSaccess_read_wrapper)(VSEnvironment*, VSValueMemberDef_ptr);
extern void (*ADL__VSaccess_write_wrapper)(VSEnvironment*, VSValueMemberDef_ptr, VSVisibility);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*, VSValueMemberDef_ptr);

#endif
