/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_wstringdef_ptr(VSWstringDef_ptr *);

extern int is_nil_wstringdef_ptr(VSWstringDef_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int is_correct_bound(VSULong);

extern int is_zero_bound(VSULong);

extern int is_correct_new_bound(VSULong, VSULong);

extern int is_correct_def_kind(VSDefinitionKind);

extern int is_correct_typecode(VSTypeCode_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSWstringDef_ptr_P)(VSWstringDef_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSWstringDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSWstringDef_ptr *(*ADL__VSduplicate_wrapper)(VSWstringDef_ptr*, VSEnvironment*);
extern VSWstringDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSULong (*ADL__VSbound_read_wrapper)(VSEnvironment*);
extern void (*ADL__VSbound_write_wrapper)(VSULong, VSEnvironment*);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*);

#endif
