/* ADL test driver from t1.tdr
 *
 * test VSread_the_children(env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


static struct ADL__propertyInfo ADL__prop_info_226[] = {
    {0, 0, 0}
};
#define TVEC_SIZE 0

static struct ADL__variableInfo ADL__var_info_228[2] = {
    {"env", "VSEnvironment *", ADL__prop_info_226, 0, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 1


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSread_the_children_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSPOA_PTR_P
#define ADL__PRINT_VSPOA_PTR_P
void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOA_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */
#ifndef ADL__PRINT_VSPOAMANAGER_PTR_P
#define ADL__PRINT_VSPOAMANAGER_PTR_P
void (*ADL__print_VSPOAManager_ptr_P)(VSPOAManager_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOAMANAGER_PTR_P */
#ifndef ADL__PRINT_VSPOALIST_P
#define ADL__PRINT_VSPOALIST_P
void (*ADL__print_VSPOAList_P)(VSPOAList*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOALIST_P */
#ifndef ADL__PRINT_VSADAPTERACTIVATOR_PTR_P
#define ADL__PRINT_VSADAPTERACTIVATOR_PTR_P
void (*ADL__print_VSAdapterActivator_ptr_P)(VSAdapterActivator_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSADAPTERACTIVATOR_PTR_P */

void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter)
{
  VSPOA_ptr *tmp;

  if (ADL__print_VSPOA_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOA_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOAManager_ptr_P (void* val, emitter_t emitter)
{
  VSPOAManager_ptr *tmp;

  if (ADL__print_VSPOAManager_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOAManager_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOAList_P (void* val, emitter_t emitter)
{
  VSPOAList *tmp;

  if (ADL__print_VSPOAList_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOAList_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAdapterActivator_ptr_P (void* val, emitter_t emitter)
{
  VSAdapterActivator_ptr *tmp;

  if (ADL__print_VSAdapterActivator_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSAdapterActivator_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[1];
    enum ADL__ACF_result test_value;
    VSEnvironment *env_227;
    VSPOAList *fut_return_225;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    tvec[0] = 0;
    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSread_the_children_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSread_the_children_InfoArrayIdx,
        ADL__VSread_the_children_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_env(&env_227)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
       ADL__emit_VSEnvironment_P(&env_227, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSread_the_children_assertionReport = rf->assertionReport;
       fut_return_225 = ADL__ACF_VSread_the_children(env_227);
       test_value = ADL__VSread_the_children_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_env(&env_227);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSread_the_children_head);

    return 0;
}


struct ADL__Directive_info VSread_the_children1_info = {
    N_VARS,
    ADL__var_info_228
};

struct ADL__TDD_info ADL__test_info = {
    1,
    &ADL__VSread_the_children_InfoArrayIdx,
    ADL__VSread_the_children_InfoArray,
    ADL__test_driver,
    "VSread_the_children",
    "VSread_the_children1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSread_the_children1",
    "t1_tr.rif",
    &VSread_the_children1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

