/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_return_servant(VSServant *);

extern int is_return_obj(VSObject_ptr *);

extern int poa_with_pol(VSPOA_ptr *, VSString);

extern int objRef_created_bythePOA(VSString, VSString);

extern int is_svt_inAOM(VSULong);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSString)(VSString, emitter_t);
extern void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSServant_P)(VSServant*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSServant *(*ADL__VSreference_to_servant_wrapper)(VSString, VSPOA_ptr*, VSEnvironment*);
extern VSObject_ptr *(*ADL__VSservant_to_reference_wrapper)(VSULong, VSPOA_ptr*, VSEnvironment*);

#endif
