/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSid_to_servant
 *
 */
VSServant *ADL__ACF_VSid_to_servant (VSObjectId_var *oid_21, VSPOA_ptr *poa_22, VSEnvironment *ev_10){

VSServant *VSid_to_servant_RtnVal_4;
  void *dummyVarName_88;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_23;
  int tmp_25;
  int tmp_26;
  VSEnvironment *ev_10_tmp_30;
    int tmp_31;
  int tmp_32;
  VSPOA_ptr *poa_22_tmp_35;
  int tmp_37;
  VSEnvironment *ev_10_tmp_41;
    int tmp_42;
  int tmp_44;
  int tmp_45;
  VSPOA_ptr *poa_22_tmp_48;
  int tmp_50;
  int tmp_51;
  VSObjectId_var *oid_21_tmp_54;
  int tmp_55;
  VSEnvironment *ev_10_tmp_59;
    int tmp_60;
  int tmp_61;
  int groupExpr_86;
  int groupExpr_87;
  int tmp_62;
  int tmp_64;
  int tmp_65;
  VSPOA_ptr *poa_22_tmp_68;
  int tmp_70;
  VSObjectId_var *oid_21_tmp_73;
  int tmp_74;
  int tmp_77;
  int tmp_78;
  VSPOA_ptr *poa_22_tmp_81;
  int tmp_83;

/* Declare vars for result of normal and exception bindings */
  int VSid_to_servant_NormalOutcome_5, VSid_to_servant_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSid_to_servant_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSid_to_servant_InfoArray, 0, ADL__VSid_to_servant_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSid_to_servant_assertionReport->setPhase(ADL__VSid_to_servant_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSid_to_servant_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSid_to_servant_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSid_to_servant_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSid_to_servant_InfoArray[forLoopIdx_1].error > VSid_to_servant_ACF_Result_3))
  VSid_to_servant_ACF_Result_3 = ADL__VSid_to_servant_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSid_to_servant_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSid_to_servant_assertionReport->setPhase(ADL__VSid_to_servant_assertionReport, PH_call);
  ADL__release(ADL__VSid_to_servant_assertionReport->parent, &this_seq);
  VSid_to_servant_RtnVal_4 = ADL__VSid_to_servant_wrapper(oid_21, poa_22, ev_10);
  ADL__recover(ADL__VSid_to_servant_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSid_to_servant_assertionReport->setPhase(ADL__VSid_to_servant_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 7,&tmp_7);
  VSid_to_servant_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 2,&tmp_13);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSid_to_servant_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 1,&tmp_12);

  VSid_to_servant_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSid_to_servant_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSid_to_servant_InfoArray[0].result = (VSid_to_servant_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSid_to_servant_InfoArray[0].evaluated = 1;
  ADL__VSid_to_servant_InfoArray[0].value = (VSid_to_servant_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSid_to_servant_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSid_to_servant_InfoArray[6].result = (VSid_to_servant_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSid_to_servant_InfoArray[6].evaluated = 1;
  ADL__VSid_to_servant_InfoArray[6].value = (VSid_to_servant_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSid_to_servant_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSid_to_servant_ACF_Result_3 = ADL__VSid_to_servant_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSid_to_servant_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSid_to_servant_ACF_Result_3 = ADL__VSid_to_servant_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSid_to_servant_ExceptionOutcome_6 && !VSid_to_servant_NormalOutcome_5) {
  VSid_to_servant_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSid_to_servant_ExceptionOutcome_6 && VSid_to_servant_NormalOutcome_5) {
  VSid_to_servant_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 10,&VSid_to_servant_ExceptionOutcome_6);
  ev_10_tmp_30 = ev_10;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 13,&ev_10_tmp_30);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_26 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 12,&tmp_26);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = !tmp_26;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 11,&tmp_25);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = (!VSid_to_servant_ExceptionOutcome_6 || tmp_25);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 9,&tmp_23);
    poa_22_tmp_35 = poa_22;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 16,&poa_22_tmp_35);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[15]);

/* Evaluate poa_with_pol(poa, "poaSvtMgr") */
  tmp_32 = poa_with_pol(poa_22, "poaSvtMgr");
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 15,&tmp_32);
  ev_10_tmp_41 = ev_10;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 18,&ev_10_tmp_41);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[17]);

/* Evaluate POA_user_exception_is("WrongPolicy", ev) */
  tmp_37 = POA_user_exception_is("WrongPolicy", ev_10);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 17,&tmp_37);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[14]);

/* Evaluate poa_with_pol(poa, "poaSvtMgr") --> POA_user_exception_is("WrongPolicy", ev) */
  tmp_31 = (!tmp_32 || tmp_37);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 14,&tmp_31);
    poa_22_tmp_48 = poa_22;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 22,&poa_22_tmp_48);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[21]);

/* Evaluate poa_with_pol(poa, "poaRetain") */
  tmp_45 = poa_with_pol(poa_22, "poaRetain");
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 21,&tmp_45);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[20]);

/* Evaluate poa_with_pol(poa, "poaRetain") && !is_oid_inAOM(oid) */
  tmp_44 = tmp_45;
  if (tmp_45) {
      oid_21_tmp_54 = oid_21;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 25,&oid_21_tmp_54);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[24]);

/* Evaluate is_oid_inAOM(oid) */
  tmp_51 = is_oid_inAOM(oid_21);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 24,&tmp_51);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[23]);

/* Evaluate !is_oid_inAOM(oid) */
  tmp_50 = !tmp_51;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 23,&tmp_50);
    tmp_44 = tmp_50;
  }
  else {
  ADL__resetInfoStruct(ADL__VSid_to_servant_InfoArray, 23, 25);
  }
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 20,&tmp_44);
  ev_10_tmp_59 = ev_10;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 27,&ev_10_tmp_59);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[26]);

/* Evaluate POA_user_exception_is("ObjectNotActive", ev) */
  tmp_55 = POA_user_exception_is("ObjectNotActive", ev_10);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 26,&tmp_55);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[19]);

/* Evaluate (poa_with_pol(poa, "poaRetain") && !is_oid_inAOM(oid)) --> POA_user_exception_is("ObjectNotActive", ev) */
  tmp_42 = (!tmp_44 || tmp_55);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 19,&tmp_42);
    ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[28]);

/* Evaluate normally { ... } */
  if(VSid_to_servant_NormalOutcome_5){
      poa_22_tmp_68 = poa_22;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 32,&poa_22_tmp_68);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[31]);

/* Evaluate poa_with_pol(poa, "poaRetain") */
  tmp_65 = poa_with_pol(poa_22, "poaRetain");
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 31,&tmp_65);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[30]);

/* Evaluate poa_with_pol(poa, "poaRetain") && is_oid_inAOM(oid) */
  tmp_64 = tmp_65;
  if (tmp_65) {
      oid_21_tmp_73 = oid_21;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 34,&oid_21_tmp_73);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[33]);

/* Evaluate is_oid_inAOM(oid) */
  tmp_70 = is_oid_inAOM(oid_21);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 33,&tmp_70);
    tmp_64 = tmp_70;
  }
  else {
  ADL__resetInfoStruct(ADL__VSid_to_servant_InfoArray, 33, 34);
  }
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 30,&tmp_64);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 36,&VSid_to_servant_RtnVal_4);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[35]);

/* Evaluate is_return_servant(return) */
  tmp_74 = is_return_servant(VSid_to_servant_RtnVal_4);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 35,&tmp_74);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[29]);

/* Evaluate (poa_with_pol(poa, "poaRetain") && is_oid_inAOM(oid)) --> is_return_servant(return) */
  tmp_62 = (!tmp_64 || tmp_74);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 29,&tmp_62);
  groupExpr_86 = (tmp_62);
  poa_22_tmp_81 = poa_22;
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 39,&poa_22_tmp_81);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[38]);

/* Evaluate poa_with_pol(poa, "poaDefaultSvt") */
  tmp_78 = poa_with_pol(poa_22, "poaDefaultSvt");
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 38,&tmp_78);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 41,&VSid_to_servant_RtnVal_4);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[40]);

/* Evaluate is_return_servant(return) */
  tmp_83 = is_return_servant(VSid_to_servant_RtnVal_4);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 40,&tmp_83);
  ADL__VSid_to_servant_assertionReport->exprMark(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_assertionReport->assrt_info[37]);

/* Evaluate poa_with_pol(poa, "poaDefaultSvt") --> is_return_servant(return) */
  tmp_77 = (!tmp_78 || tmp_83);
  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 37,&tmp_77);
  groupExpr_87 = (tmp_77);
  tmp_61 = (groupExpr_86 && groupExpr_87);
  tmp_60 = tmp_61;
  }
  else {
    ADL__resetInfoStruct(ADL__VSid_to_servant_InfoArray, 28, 41);
  tmp_60 = 1;
}

  ADL__setResultAndError(ADL__VSid_to_servant_InfoArray, 28,&tmp_60);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSid_to_servant_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSid_to_servant_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSid_to_servant_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSid_to_servant_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSid_to_servant_InfoArray[forLoopIdx_1].level == 0))
        VSid_to_servant_ACF_Result_3 = calculate_ACF_result(VSid_to_servant_ACF_Result_3, ADL__VSid_to_servant_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSid_to_servant_assertionReport->value = VSid_to_servant_ACF_Result_3;
  ADL__VSid_to_servant_assertionReport->parent->openReport(ADL__VSid_to_servant_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSid_to_servant_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSid_to_servant_assertionReport->emitTest(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_InfoArray[forLoopIdx_1])) {
     ADL__VSid_to_servant_assertionReport->exprStart(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_InfoArray[forLoopIdx_1]);
      if(!ADL__VSid_to_servant_InfoArray[forLoopIdx_1].testable || !ADL__VSid_to_servant_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSid_to_servant_assertionReport->emitter);
      else if (ADL__VSid_to_servant_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSid_to_servant_InfoArray[forLoopIdx_1].error, ADL__VSid_to_servant_assertionReport->emitter);
      else
        ADL__VSid_to_servant_InfoArray[forLoopIdx_1].emitFunc(ADL__VSid_to_servant_InfoArray[forLoopIdx_1].value, ADL__VSid_to_servant_assertionReport->emitter);
     ADL__VSid_to_servant_assertionReport->exprEnd(ADL__VSid_to_servant_assertionReport, &ADL__VSid_to_servant_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSid_to_servant_RtnVal_4);
}


VSServant *(*ADL__VSid_to_servant_wrapper)(VSObjectId_var*, VSPOA_ptr*, VSEnvironment*) = VSid_to_servant;

void ADL__emit_VSObjectId_var_P (void* val, emitter_t emitter);
void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSServant_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSid_to_servant_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "poa_with_pol(poa, \"poaSvtMgr\") --> POA_user_exception_is(\"WrongPolicy\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "poa_with_pol(poa, \"poaSvtMgr\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {2, 17, 14, 0, 0, "POA_user_exception_is(\"WrongPolicy\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "(poa_with_pol(poa, \"poaRetain\") && !is_oid_inAOM(oid)) --> POA_user_exception_is(\"ObjectNotActive\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "poa_with_pol(poa, \"poaRetain\") && !is_oid_inAOM(oid)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "poa_with_pol(poa, \"poaRetain\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 22, 21, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {3, 23, 20, 0, 0, "!is_oid_inAOM(oid)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 24, 23, 0, 0, "is_oid_inAOM(oid)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 25, 24, 0, 0, "oid", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObjectId_var_P },
  {3, 26, 19, 0, 0, "POA_user_exception_is(\"ObjectNotActive\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 27, 26, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 28, 28, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 29, 28, 0, 0, "(poa_with_pol(poa, \"poaRetain\") && is_oid_inAOM(oid)) --> is_return_servant(return)", 29, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 30, 29, 0, 0, "poa_with_pol(poa, \"poaRetain\") && is_oid_inAOM(oid)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 31, 30, 0, 0, "poa_with_pol(poa, \"poaRetain\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 32, 31, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {5, 33, 30, 0, 0, "is_oid_inAOM(oid)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 34, 33, 0, 0, "oid", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObjectId_var_P },
  {5, 35, 29, 0, 0, "is_return_servant(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 36, 35, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSServant_P },
  {6, 37, 28, 0, 0, "poa_with_pol(poa, \"poaDefaultSvt\") --> is_return_servant(return)", 37, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 38, 37, 0, 0, "poa_with_pol(poa, \"poaDefaultSvt\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 39, 38, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {6, 40, 37, 0, 0, "is_return_servant(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 41, 40, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSServant_P }
};


unsigned int ADL__VSid_to_servant_InfoArrayIdx = 42;

struct ADL__reportAssertion *ADL__VSid_to_servant_assertionReport = 0;

/*
 *
 * ACF of VSservant_to_id
 *
 */
VSObjectId_var *ADL__ACF_VSservant_to_id (VSULong svt_107, VSPOA_ptr *poa_108, VSEnvironment *ev_96){

VSObjectId_var *VSservant_to_id_RtnVal_90;
  void *dummyVarName_88;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_109;
  int tmp_111;
  int tmp_112;
  VSEnvironment *ev_96_tmp_116;
    int tmp_117;
  int tmp_118;
  VSPOA_ptr *poa_108_tmp_121;
  int tmp_123;
  VSEnvironment *ev_96_tmp_127;
    int tmp_128;
  int tmp_130;
  int tmp_131;
  VSPOA_ptr *poa_108_tmp_134;
  int tmp_136;
  int tmp_137;
  VSULong svt_107_tmp_140;
  int tmp_141;
  VSEnvironment *ev_96_tmp_145;
    int tmp_146;
  int tmp_147;
  int groupExpr_197;
  int groupExpr_198;
  int groupExpr_199;
  int groupExpr_200;
  int tmp_148;
  int tmp_150;
  int tmp_151;
  VSPOA_ptr *poa_108_tmp_154;
  int tmp_156;
  VSULong svt_107_tmp_159;
  int tmp_160;
  int tmp_163;
  int tmp_164;
  VSPOA_ptr *poa_108_tmp_167;
  int tmp_169;
  int tmp_172;
  int tmp_174;
  int tmp_175;
  VSPOA_ptr *poa_108_tmp_178;
  int tmp_180;
  int tmp_181;
  VSULong svt_107_tmp_184;
  int tmp_185;
  int tmp_188;
  int tmp_189;
  VSPOA_ptr *poa_108_tmp_192;
  int tmp_194;

/* Declare vars for result of normal and exception bindings */
  int VSservant_to_id_NormalOutcome_91, VSservant_to_id_ExceptionOutcome_92;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_93;
  VSEnvironment *ev_96_tmp_97;
    int tmp_98;
  int tmp_99;
  VSEnvironment *ev_96_tmp_102;
  int tmp_103;
  VSEnvironment *ev_96_tmp_106;
  enum ADL__ACF_result VSservant_to_id_ACF_Result_89 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSservant_to_id_InfoArray, 0, ADL__VSservant_to_id_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSservant_to_id_assertionReport->setPhase(ADL__VSservant_to_id_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSservant_to_id_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSservant_to_id_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSservant_to_id_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSservant_to_id_InfoArray[forLoopIdx_1].error > VSservant_to_id_ACF_Result_89))
  VSservant_to_id_ACF_Result_89 = ADL__VSservant_to_id_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSservant_to_id_ACF_Result_89 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSservant_to_id_assertionReport->setPhase(ADL__VSservant_to_id_assertionReport, PH_call);
  ADL__release(ADL__VSservant_to_id_assertionReport->parent, &this_seq);
  VSservant_to_id_RtnVal_90 = ADL__VSservant_to_id_wrapper(svt_107, poa_108, ev_96);
  ADL__recover(ADL__VSservant_to_id_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSservant_to_id_assertionReport->setPhase(ADL__VSservant_to_id_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_96_tmp_97 = ev_96;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 8,&ev_96_tmp_97);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_93 = no_exception(ev_96);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 7,&tmp_93);
  VSservant_to_id_NormalOutcome_91 = (tmp_93);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_96_tmp_102 = ev_96;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 3,&ev_96_tmp_102);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_99 = system_exception(ev_96);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 2,&tmp_99);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_98 = tmp_99;
  if (!tmp_99) {
      ev_96_tmp_106 = ev_96;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 5,&ev_96_tmp_106);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_103 = user_exception(ev_96);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 4,&tmp_103);
    tmp_98 = tmp_103;
  }
  else {
  ADL__resetInfoStruct(ADL__VSservant_to_id_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 1,&tmp_98);

  VSservant_to_id_ExceptionOutcome_92 = (tmp_98);

/* Exception binding is the first assertion */
  if (ADL__VSservant_to_id_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSservant_to_id_InfoArray[0].result = (VSservant_to_id_ExceptionOutcome_92 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSservant_to_id_InfoArray[0].evaluated = 1;
  ADL__VSservant_to_id_InfoArray[0].value = (VSservant_to_id_ExceptionOutcome_92 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSservant_to_id_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSservant_to_id_InfoArray[6].result = (VSservant_to_id_NormalOutcome_91 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSservant_to_id_InfoArray[6].evaluated = 1;
  ADL__VSservant_to_id_InfoArray[6].value = (VSservant_to_id_NormalOutcome_91 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSservant_to_id_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSservant_to_id_ACF_Result_89 = ADL__VSservant_to_id_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSservant_to_id_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSservant_to_id_ACF_Result_89 = ADL__VSservant_to_id_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSservant_to_id_ExceptionOutcome_92 && !VSservant_to_id_NormalOutcome_91) {
  VSservant_to_id_ACF_Result_89 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSservant_to_id_ExceptionOutcome_92 && VSservant_to_id_NormalOutcome_91) {
  VSservant_to_id_ACF_Result_89 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 10,&VSservant_to_id_ExceptionOutcome_92);
  ev_96_tmp_116 = ev_96;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 13,&ev_96_tmp_116);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_112 = user_exception_is("NOT_IMPLEMENTED", ev_96);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 12,&tmp_112);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_111 = !tmp_112;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 11,&tmp_111);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_109 = (!VSservant_to_id_ExceptionOutcome_92 || tmp_111);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 9,&tmp_109);
    poa_108_tmp_121 = poa_108;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 16,&poa_108_tmp_121);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[15]);

/* Evaluate poa_with_pol(poa, "poaOther") */
  tmp_118 = poa_with_pol(poa_108, "poaOther");
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 15,&tmp_118);
  ev_96_tmp_127 = ev_96;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 18,&ev_96_tmp_127);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[17]);

/* Evaluate POA_user_exception_is("WrongPolicy", ev) */
  tmp_123 = POA_user_exception_is("WrongPolicy", ev_96);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 17,&tmp_123);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[14]);

/* Evaluate poa_with_pol(poa, "poaOther") --> POA_user_exception_is("WrongPolicy", ev) */
  tmp_117 = (!tmp_118 || tmp_123);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 14,&tmp_117);
    poa_108_tmp_134 = poa_108;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 22,&poa_108_tmp_134);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[21]);

/* Evaluate poa_with_pol(poa, "poaRetain") */
  tmp_131 = poa_with_pol(poa_108, "poaRetain");
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 21,&tmp_131);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[20]);

/* Evaluate poa_with_pol(poa, "poaRetain") && !is_svt_inAOM(svt) */
  tmp_130 = tmp_131;
  if (tmp_131) {
      svt_107_tmp_140 = svt_107;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 25,&svt_107_tmp_140);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[24]);

/* Evaluate is_svt_inAOM(svt) */
  tmp_137 = is_svt_inAOM(svt_107);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 24,&tmp_137);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[23]);

/* Evaluate !is_svt_inAOM(svt) */
  tmp_136 = !tmp_137;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 23,&tmp_136);
    tmp_130 = tmp_136;
  }
  else {
  ADL__resetInfoStruct(ADL__VSservant_to_id_InfoArray, 23, 25);
  }
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 20,&tmp_130);
  ev_96_tmp_145 = ev_96;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 27,&ev_96_tmp_145);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[26]);

/* Evaluate POA_user_exception_is("ServantNotActive", ev) */
  tmp_141 = POA_user_exception_is("ServantNotActive", ev_96);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 26,&tmp_141);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[19]);

/* Evaluate (poa_with_pol(poa, "poaRetain") && !is_svt_inAOM(svt)) --> POA_user_exception_is("ServantNotActive", ev) */
  tmp_128 = (!tmp_130 || tmp_141);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 19,&tmp_128);
    ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[28]);

/* Evaluate normally { ... } */
  if(VSservant_to_id_NormalOutcome_91){
      poa_108_tmp_154 = poa_108;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 32,&poa_108_tmp_154);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[31]);

/* Evaluate poa_with_pol(poa, "poaUniqueId") */
  tmp_151 = poa_with_pol(poa_108, "poaUniqueId");
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 31,&tmp_151);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[30]);

/* Evaluate poa_with_pol(poa, "poaUniqueId") && is_svt_inAOM(svt) */
  tmp_150 = tmp_151;
  if (tmp_151) {
      svt_107_tmp_159 = svt_107;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 34,&svt_107_tmp_159);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[33]);

/* Evaluate is_svt_inAOM(svt) */
  tmp_156 = is_svt_inAOM(svt_107);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 33,&tmp_156);
    tmp_150 = tmp_156;
  }
  else {
  ADL__resetInfoStruct(ADL__VSservant_to_id_InfoArray, 33, 34);
  }
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 30,&tmp_150);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 36,&VSservant_to_id_RtnVal_90);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[35]);

/* Evaluate is_return_oid(return) */
  tmp_160 = is_return_oid(VSservant_to_id_RtnVal_90);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 35,&tmp_160);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[29]);

/* Evaluate (poa_with_pol(poa, "poaUniqueId") && is_svt_inAOM(svt)) --> is_return_oid(return) */
  tmp_148 = (!tmp_150 || tmp_160);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 29,&tmp_148);
  groupExpr_197 = (tmp_148);
  poa_108_tmp_167 = poa_108;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 39,&poa_108_tmp_167);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[38]);

/* Evaluate poa_with_pol(poa, "poaMultId") */
  tmp_164 = poa_with_pol(poa_108, "poaMultId");
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 38,&tmp_164);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 41,&VSservant_to_id_RtnVal_90);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[40]);

/* Evaluate is_return_oid(return) */
  tmp_169 = is_return_oid(VSservant_to_id_RtnVal_90);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 40,&tmp_169);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[37]);

/* Evaluate poa_with_pol(poa, "poaMultId") --> is_return_oid(return) */
  tmp_163 = (!tmp_164 || tmp_169);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 37,&tmp_163);
  groupExpr_198 = (tmp_163);
  poa_108_tmp_178 = poa_108;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 45,&poa_108_tmp_178);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[44]);

/* Evaluate poa_with_pol(poa, "poaImplictAct") */
  tmp_175 = poa_with_pol(poa_108, "poaImplictAct");
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 44,&tmp_175);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[43]);

/* Evaluate poa_with_pol(poa, "poaImplictAct") && !is_svt_inAOM(svt) */
  tmp_174 = tmp_175;
  if (tmp_175) {
      svt_107_tmp_184 = svt_107;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 48,&svt_107_tmp_184);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[47]);

/* Evaluate is_svt_inAOM(svt) */
  tmp_181 = is_svt_inAOM(svt_107);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 47,&tmp_181);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[46]);

/* Evaluate !is_svt_inAOM(svt) */
  tmp_180 = !tmp_181;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 46,&tmp_180);
    tmp_174 = tmp_180;
  }
  else {
  ADL__resetInfoStruct(ADL__VSservant_to_id_InfoArray, 46, 48);
  }
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 43,&tmp_174);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 50,&VSservant_to_id_RtnVal_90);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[49]);

/* Evaluate is_return_oid(return) */
  tmp_185 = is_return_oid(VSservant_to_id_RtnVal_90);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 49,&tmp_185);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[42]);

/* Evaluate (poa_with_pol(poa, "poaImplictAct") && !is_svt_inAOM(svt)) --> is_return_oid(return) */
  tmp_172 = (!tmp_174 || tmp_185);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 42,&tmp_172);
  groupExpr_199 = (tmp_172);
  poa_108_tmp_192 = poa_108;
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 53,&poa_108_tmp_192);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[52]);

/* Evaluate poa_with_pol(poa, "poaDefaultSvt") */
  tmp_189 = poa_with_pol(poa_108, "poaDefaultSvt");
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 52,&tmp_189);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 55,&VSservant_to_id_RtnVal_90);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[54]);

/* Evaluate is_return_oid(return) */
  tmp_194 = is_return_oid(VSservant_to_id_RtnVal_90);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 54,&tmp_194);
  ADL__VSservant_to_id_assertionReport->exprMark(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_assertionReport->assrt_info[51]);

/* Evaluate poa_with_pol(poa, "poaDefaultSvt") --> is_return_oid(return) */
  tmp_188 = (!tmp_189 || tmp_194);
  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 51,&tmp_188);
  groupExpr_200 = (tmp_188);
  tmp_147 = (groupExpr_197 && groupExpr_198 && groupExpr_199 && groupExpr_200);
  tmp_146 = tmp_147;
  }
  else {
    ADL__resetInfoStruct(ADL__VSservant_to_id_InfoArray, 28, 55);
  tmp_146 = 1;
}

  ADL__setResultAndError(ADL__VSservant_to_id_InfoArray, 28,&tmp_146);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSservant_to_id_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSservant_to_id_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSservant_to_id_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSservant_to_id_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSservant_to_id_InfoArray[forLoopIdx_1].level == 0))
        VSservant_to_id_ACF_Result_89 = calculate_ACF_result(VSservant_to_id_ACF_Result_89, ADL__VSservant_to_id_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSservant_to_id_assertionReport->value = VSservant_to_id_ACF_Result_89;
  ADL__VSservant_to_id_assertionReport->parent->openReport(ADL__VSservant_to_id_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSservant_to_id_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSservant_to_id_assertionReport->emitTest(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_InfoArray[forLoopIdx_1])) {
     ADL__VSservant_to_id_assertionReport->exprStart(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_InfoArray[forLoopIdx_1]);
      if(!ADL__VSservant_to_id_InfoArray[forLoopIdx_1].testable || !ADL__VSservant_to_id_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSservant_to_id_assertionReport->emitter);
      else if (ADL__VSservant_to_id_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSservant_to_id_InfoArray[forLoopIdx_1].error, ADL__VSservant_to_id_assertionReport->emitter);
      else
        ADL__VSservant_to_id_InfoArray[forLoopIdx_1].emitFunc(ADL__VSservant_to_id_InfoArray[forLoopIdx_1].value, ADL__VSservant_to_id_assertionReport->emitter);
     ADL__VSservant_to_id_assertionReport->exprEnd(ADL__VSservant_to_id_assertionReport, &ADL__VSservant_to_id_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSservant_to_id_RtnVal_90);
}


VSObjectId_var *(*ADL__VSservant_to_id_wrapper)(VSULong, VSPOA_ptr*, VSEnvironment*) = VSservant_to_id;

void ADL__emit_VSULong (void* val, emitter_t emitter);
void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSObjectId_var_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSservant_to_id_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "poa_with_pol(poa, \"poaOther\") --> POA_user_exception_is(\"WrongPolicy\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "poa_with_pol(poa, \"poaOther\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {2, 17, 14, 0, 0, "POA_user_exception_is(\"WrongPolicy\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "(poa_with_pol(poa, \"poaRetain\") && !is_svt_inAOM(svt)) --> POA_user_exception_is(\"ServantNotActive\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "poa_with_pol(poa, \"poaRetain\") && !is_svt_inAOM(svt)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "poa_with_pol(poa, \"poaRetain\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 22, 21, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {3, 23, 20, 0, 0, "!is_svt_inAOM(svt)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 24, 23, 0, 0, "is_svt_inAOM(svt)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 25, 24, 0, 0, "svt", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {3, 26, 19, 0, 0, "POA_user_exception_is(\"ServantNotActive\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 27, 26, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 28, 28, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 29, 28, 0, 0, "(poa_with_pol(poa, \"poaUniqueId\") && is_svt_inAOM(svt)) --> is_return_oid(return)", 29, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 30, 29, 0, 0, "poa_with_pol(poa, \"poaUniqueId\") && is_svt_inAOM(svt)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 31, 30, 0, 0, "poa_with_pol(poa, \"poaUniqueId\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 32, 31, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {5, 33, 30, 0, 0, "is_svt_inAOM(svt)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 34, 33, 0, 0, "svt", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {5, 35, 29, 0, 0, "is_return_oid(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 36, 35, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObjectId_var_P },
  {6, 37, 28, 0, 0, "poa_with_pol(poa, \"poaMultId\") --> is_return_oid(return)", 37, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 38, 37, 0, 0, "poa_with_pol(poa, \"poaMultId\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 39, 38, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {6, 40, 37, 0, 0, "is_return_oid(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 41, 40, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObjectId_var_P },
  {7, 42, 28, 0, 0, "(poa_with_pol(poa, \"poaImplictAct\") && !is_svt_inAOM(svt)) --> is_return_oid(return)", 42, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {7, 43, 42, 0, 0, "poa_with_pol(poa, \"poaImplictAct\") && !is_svt_inAOM(svt)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 44, 43, 0, 0, "poa_with_pol(poa, \"poaImplictAct\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 45, 44, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {7, 46, 43, 0, 0, "!is_svt_inAOM(svt)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 47, 46, 0, 0, "is_svt_inAOM(svt)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 48, 47, 0, 0, "svt", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 5, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {7, 49, 42, 0, 0, "is_return_oid(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 50, 49, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObjectId_var_P },
  {8, 51, 28, 0, 0, "poa_with_pol(poa, \"poaDefaultSvt\") --> is_return_oid(return)", 51, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {8, 52, 51, 0, 0, "poa_with_pol(poa, \"poaDefaultSvt\")", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {8, 53, 52, 0, 0, "poa", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSPOA_ptr_P },
  {8, 54, 51, 0, 0, "is_return_oid(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {8, 55, 54, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObjectId_var_P }
};


unsigned int ADL__VSservant_to_id_InfoArrayIdx = 56;

struct ADL__reportAssertion *ADL__VSservant_to_id_assertionReport = 0;
