/* ADL test driver from t1.tdr
 *
 * test VScreate_POA(adapter, POAmgr, policy, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop Name */
static struct ADL__propertyValue ADL__prop_values_240[] = {
    {"nil", Padapter_Name_nil, 0},
    {"exist", Padapter_Name_exist, 0},
    {0, 0, 0}
};

/* values for prop Value */
static struct ADL__propertyValue ADL__prop_values_241[] = {
    {"nil", PPOAmgr_Value_nil, 0},
    {"same", PPOAmgr_Value_same, 0},
    {0, 0, 0}
};

/* values for literal variable policy */
static VSULong ADL__litvar_val_243[] = {
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_242[] = {
    {"1", 0, ADL__litvar_val_243},
    {"0", 1, ADL__litvar_val_243},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_244[] = {
    {"Name", "prop", ADL__prop_values_240, 2},
    {"Value", "prop", ADL__prop_values_241, 2},
    {"policy", "litvar", ADL__litvar_info_242, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 3

static struct ADL__variableInfo ADL__var_info_249[5] = {
    {"adapter", "VSAdapter", ADL__prop_info_244, 0, 1},
    {"POAmgr", "VSPOAManager_ptr *", ADL__prop_info_244, 1, 1},
    {"policy", "VSULong", ADL__prop_info_244, 2, 1},
    {"env", "VSEnvironment *", ADL__prop_info_244, 3, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 4


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScreate_POA_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSADAPTER
#define ADL__PRINT_VSADAPTER
void (*ADL__print_VSAdapter)(VSAdapter, emitter_t) = 0;

#endif /* ADL__PRINT_VSADAPTER */
#ifndef ADL__PRINT_VSPOAMANAGER_PTR_P
#define ADL__PRINT_VSPOAMANAGER_PTR_P
void (*ADL__print_VSPOAManager_ptr_P)(VSPOAManager_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOAMANAGER_PTR_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSPOA_PTR_P
#define ADL__PRINT_VSPOA_PTR_P
void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOA_PTR_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */

void ADL__emit_VSAdapter (void* val, emitter_t emitter)
{
  VSAdapter tmp;

  if (ADL__print_VSAdapter != 0) {
    tmp = *(VSAdapter*) val;
    ADL__print_VSAdapter(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOAManager_ptr_P (void* val, emitter_t emitter)
{
  VSPOAManager_ptr *tmp;

  if (ADL__print_VSPOAManager_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOAManager_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter)
{
  VSPOA_ptr *tmp;

  if (ADL__print_VSPOA_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOA_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 2, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSAdapter adapter_245;
    VSPOAManager_ptr *POAmgr_246;
    VSULong policy_247;
    VSEnvironment *env_248;
    VSPOA_ptr *fut_return_239;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScreate_POA_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScreate_POA_InfoArrayIdx,
        ADL__VScreate_POA_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_adapter(&adapter_245, ADL__prop_values_240[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSAdapter(&adapter_245, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_POAmgr(&POAmgr_246, ADL__prop_values_241[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSPOAManager_ptr_P(&POAmgr_246, rf->variableReport->emitVariable);

       policy_247 = ADL__litvar_val_243[tvec[2]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 2, tvec + 2, 1);
       ADL__emit_VSULong(&policy_247, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_env(&env_248)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
       ADL__emit_VSEnvironment_P(&env_248, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScreate_POA_assertionReport = rf->assertionReport;
       fut_return_239 = ADL__ACF_VScreate_POA(adapter_245, POAmgr_246, policy_247, env_248);
       test_value = ADL__VScreate_POA_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_env(&env_248);
SKIP_3:
       relvec[2] = 1;	/* relinquish succeeds for policy_247 */
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_POAmgr(&POAmgr_246, ADL__prop_values_241[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_adapter(&adapter_245, ADL__prop_values_240[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_249,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScreate_POA_head);

    return 0;
}


struct ADL__Directive_info VScreate_POA1_info = {
    N_VARS,
    ADL__var_info_249
};

struct ADL__TDD_info ADL__test_info = {
    8,
    &ADL__VScreate_POA_InfoArrayIdx,
    ADL__VScreate_POA_InfoArray,
    ADL__test_driver,
    "VScreate_POA",
    "VScreate_POA1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScreate_POA1",
    "t1_tr.rif",
    &VScreate_POA1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

