/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_valid_policy(VSULong);

extern int is_nil_poamanager(VSPOAManager_ptr *);

extern int childPOA_with_newPOAmgr(VSPOA_ptr *);

extern int is_exist_adapter(VSAdapter);

extern int is_the_childpoa(VSPOA_ptr *);

extern int is_return_poa(VSPOA_ptr *);

extern int is_destroy_poa(VSPOA_ptr *);

extern int poa_with_pol(VSPOA_ptr *, VSString);

extern int is_childPOA_name(VSString, VSString);

extern int is_actParameter_true(VSBoolean);

extern int is_return_findPOA(VSPOA_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSAdapter)(VSAdapter, emitter_t);
extern void (*ADL__print_VSPOAManager_ptr_P)(VSPOAManager_ptr*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSString)(VSString, emitter_t);

/* Declarations of wrapper of FUT */
extern VSPOA_ptr *(*ADL__VScreate_POA_wrapper)(VSAdapter, VSPOAManager_ptr*, VSULong, VSEnvironment*);
extern VSBoolean (*ADL__VSdestroy_wrapper)(VSPOA_ptr*, VSBoolean, VSBoolean, VSEnvironment*);
extern VSPOA_ptr *(*ADL__VSfind_POA_wrapper)(VSString, VSBoolean, VSPOA_ptr*, VSEnvironment*);

#endif
