/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int correct_Thread_policy(VSThreadPolicy_var *, VSThreadPolicyValue);

extern int destroy_Thread_policy(VSThreadPolicy_var *);

extern int correct_Thread_value(VSThreadPolicyValue);

extern int correct_Lifespan_policy(VSLifespanPolicy_var *, VSLifespanPolicyValue);

extern int destroy_Lifespan_policy(VSLifespanPolicy_var *);

extern int correct_Lifespan_value(VSLifespanPolicyValue);

extern int correct_IdUniqueness_policy(VSIdUniquenessPolicy_var *, VSIdUniquenessPolicyValue);

extern int destroy_IdUniqueness_policy(VSIdUniquenessPolicy_var *);

extern int correct_IdUniqueness_value(VSIdUniquenessPolicyValue);

extern int correct_IdAssignment_policy(VSIdAssignmentPolicy_var *, VSIdAssignmentPolicyValue);

extern int destroy_IdAssignment_policy(VSIdAssignmentPolicy_var *);

extern int correct_IdAssignment_value(VSIdAssignmentPolicyValue);

extern int correct_ImplicitActivation_policy(VSImplicitActivationPolicy_var *, VSImplicitActivationPolicyValue);

extern int destroy_ImplicitActivation_policy(VSImplicitActivationPolicy_var *);

extern int correct_ImplicitActivation_value(VSImplicitActivationPolicyValue);

extern int correct_ServantRetention_policy(VSServantRetentionPolicy_var *, VSServantRetentionPolicyValue);

extern int destroy_ServantRetention_policy(VSServantRetentionPolicy_var *);

extern int correct_ServantRetention_value(VSServantRetentionPolicyValue);

extern int correct_RequestProcessing_policy(VSRequestProcessingPolicy_var *, VSRequestProcessingPolicyValue);

extern int destroy_RequestProcessing_policy(VSRequestProcessingPolicy_var *);

extern int correct_RequestProcessing_value(VSRequestProcessingPolicyValue);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSThreadPolicyValue)(VSThreadPolicyValue, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSThreadPolicy_var_P)(VSThreadPolicy_var*, emitter_t);
extern void (*ADL__print_VSLifespanPolicyValue)(VSLifespanPolicyValue, emitter_t);
extern void (*ADL__print_VSLifespanPolicy_var_P)(VSLifespanPolicy_var*, emitter_t);
extern void (*ADL__print_VSIdUniquenessPolicyValue)(VSIdUniquenessPolicyValue, emitter_t);
extern void (*ADL__print_VSIdUniquenessPolicy_var_P)(VSIdUniquenessPolicy_var*, emitter_t);
extern void (*ADL__print_VSIdAssignmentPolicyValue)(VSIdAssignmentPolicyValue, emitter_t);
extern void (*ADL__print_VSIdAssignmentPolicy_var_P)(VSIdAssignmentPolicy_var*, emitter_t);
extern void (*ADL__print_VSImplicitActivationPolicyValue)(VSImplicitActivationPolicyValue, emitter_t);
extern void (*ADL__print_VSImplicitActivationPolicy_var_P)(VSImplicitActivationPolicy_var*, emitter_t);
extern void (*ADL__print_VSServantRetentionPolicyValue)(VSServantRetentionPolicyValue, emitter_t);
extern void (*ADL__print_VSServantRetentionPolicy_var_P)(VSServantRetentionPolicy_var*, emitter_t);
extern void (*ADL__print_VSRequestProcessingPolicyValue)(VSRequestProcessingPolicyValue, emitter_t);
extern void (*ADL__print_VSRequestProcessingPolicy_var_P)(VSRequestProcessingPolicy_var*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSThreadPolicy_var *(*ADL__VScreate_thread_policy_wrapper)(VSThreadPolicyValue, VSEnvironment*);
extern VSThreadPolicyValue (*ADL__VSThread_value_wrapper)(VSEnvironment*);
extern VSLifespanPolicy_var *(*ADL__VScreate_lifespan_policy_wrapper)(VSLifespanPolicyValue, VSEnvironment*);
extern VSLifespanPolicyValue (*ADL__VSLifespan_value_wrapper)(VSEnvironment*);
extern VSIdUniquenessPolicy_var *(*ADL__VScreate_id_uniqueness_policy_wrapper)(VSIdUniquenessPolicyValue, VSEnvironment*);
extern VSIdUniquenessPolicyValue (*ADL__VSIdUniqueness_value_wrapper)(VSEnvironment*);
extern VSIdAssignmentPolicy_var *(*ADL__VScreate_id_assignment_policy_wrapper)(VSIdAssignmentPolicyValue, VSEnvironment*);
extern VSIdAssignmentPolicyValue (*ADL__VSIdAssignment_value_wrapper)(VSEnvironment*);
extern VSImplicitActivationPolicy_var *(*ADL__VScreate_implicit_activation_policy_wrapper)(VSImplicitActivationPolicyValue, VSEnvironment*);
extern VSImplicitActivationPolicyValue (*ADL__VSImplicitActivation_value_wrapper)(VSEnvironment*);
extern VSServantRetentionPolicy_var *(*ADL__VScreate_servant_retention_policy_wrapper)(VSServantRetentionPolicyValue, VSEnvironment*);
extern VSServantRetentionPolicyValue (*ADL__VSServantRetention_value_wrapper)(VSEnvironment*);
extern VSRequestProcessingPolicy_var *(*ADL__VScreate_request_processing_policy_wrapper)(VSRequestProcessingPolicyValue, VSEnvironment*);
extern VSRequestProcessingPolicyValue (*ADL__VSRequestProcessing_value_wrapper)(VSEnvironment*);

#endif
