/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_active_state(VSPOAManager_ptr *);

extern int is_inactive_state(VSPOAManager_ptr *);

extern int is_hold_state(VSPOAManager_ptr *);

extern int is_discard_state(VSPOAManager_ptr *);

extern int correct_poaMgr_state(VSState);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSPOAManager_ptr_P)(VSPOAManager_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSState)(VSState, emitter_t);

/* Declarations of wrapper of FUT */
extern VSBoolean (*ADL__VSactivate_wrapper)(VSPOAManager_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VShold_requests_wrapper)(VSPOAManager_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSdiscard_requests_wrapper)(VSPOAManager_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSdeactivate_wrapper)(VSPOAManager_ptr*, VSBoolean, VSBoolean, VSEnvironment*);
extern VSState (*ADL__VSget_state_wrapper)(VSEnvironment*);

#endif
