/*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Developed for X/Open by ApTest Ireland Limited.
*
* Project: VSORB
*
* File: tset/c++/api/basicTypes/Any/t1.h
*
* Modifications:
* $Log: t1.h,v $
* Revision 1.1.1.1  2000/02/09 17:14:36  mli
* Imported TOG's VSOrb 1.1.1
*
* Revision 1.1  1997/10/04 10:34:24  ian
* Initial version.
*
*/

#include <corba_defs.h>

VSAny *VSShortToAny(VSShort s, VSEnvironment *ev);
VSAny *VSUShortToAny(VSUShort us, VSEnvironment *ev);
VSAny *VSLongToAny(VSLong l, VSEnvironment *ev);
VSAny *VSULongToAny(VSULong us, VSEnvironment *ev);
VSAny *VSFloatToAny(VSFloat f, VSEnvironment *ev);
VSAny *VSDoubleToAny(VSDouble d, VSEnvironment *ev);
VSAny *VSUnboundStringToAny(VSString ustr, VSEnvironment *ev);
VSAny *VSBooleanToAny(VSBoolean b, VSEnvironment *ev);
VSAny *VSOctetToAny(VSOctet b, VSEnvironment *ev);
VSAny *VSCharToAny(VSChar b, VSEnvironment *ev);



