/*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Developed for X/Open by ApTest Ireland Limited.
*
* Project: VSORB
*
* File: tset/c++/api/basicTypes/Any/t1i_tdi.cpp
*
* Modifications:
* $Log: t1i_tdi.cpp,v $
* Revision 1.1.1.1  2000/02/09 17:14:36  mli
* Imported TOG's VSOrb 1.1.1
*
* Revision 1.4  1999/05/10 13:52:34  cwatson
* Corrected the method signatures.
*
* Revision 1.3  1997/12/05 16:28:16  cwatson
* Now uses .hh for c++ include files.
*
* Revision 1.2  1997/10/09 11:09:17  ian
* Changed corba_defs to corba_supp.
*
* Revision 1.1  1997/10/04 10:34:25  ian
* Initial version.
*
*/


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1i_tdi.h>
#include <corba_defs.h>

int provide_b (VSBoolean* testvar, enum prop_boolean_values prop_1)
{
	switch (prop_1)
	{
		case Pboolean_values_true:
			*testvar = TRUE;
			break;
		case Pboolean_values_false:
			*testvar = FALSE;
			break;
	}
		
	return TRUE;
}

int relinquish_b (VSBoolean*, enum prop_boolean_values)
{
	return TRUE;
}

}
																														


