//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/corba/common/adlinit.cpp
//
// Purpose:
//
// Modifications:
// $Log: adlinit.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:14:38  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.9  1997/12/05 16:28:17  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.8  1997/11/27 12:07:38  cwatson
// Removed Orbix specific code.
//
// Revision 1.7  1997/10/09 10:53:20  tet
// Removed undeeded #define.
//
// Revision 1.6  1997/10/04 16:43:01  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.5  1997/10/01 15:35:25  cwatson
// Makefile changes.
//
// Revision 1.4  1997/09/12 13:02:18  cwatson
// Moved all _ptr provide and relinquish functions to corba/common/ptr_prov.cpp.
//
// Revision 1.3  1997/08/26 13:20:56  cwatson
// Cleared up memory leaks.
// Made changes for _var types for DAIS 3.2.
//
// Revision 1.2  1997/08/20 11:14:18  cwatson
// Removed printf() statements.
//
// Revision 1.1  1997/08/06 14:38:11  cwatson
// *** empty log message ***
//
//

#include	<corba_supp.hh>
#include	<tserver.hh>

extern "C" {

void ADL__initiate_test_run()
{
    glob_TS.initialise();
}

void ADL__terminate_test_run()
{
}

}

