/*
 *
 * corba_defs_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "corba_defs"
 *
 */

#ifndef CORBA_DEFS_AUX_H
#define CORBA_DEFS_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs.h"

extern int no_exception(VSEnvironment *);

extern int user_exception(VSEnvironment *);

extern int system_exception(VSEnvironment *);

extern int system_exception_is(VSString, VSEnvironment *);

extern int user_exception_is(VSString, VSEnvironment *);

extern VSString exception_to_string(VSException *);

extern int is_nil_object_ptr(VSObject_ptr *);

extern int is_invalid_object_ptr(VSObject_ptr *);

extern int is_nil_nvalue_ptr(VSNamedValue_ptr *);

extern int is_invalid_nvalue_ptr(VSNamedValue_ptr *);

extern int is_nil_typecode_ptr(VSTypeCode_ptr *);

extern int is_invalid_typecode_ptr(VSTypeCode_ptr *);

extern int is_nil_env_ptr(VSEnvironment_ptr *);

extern int is_invalid_env_ptr(VSEnvironment_ptr *);

extern int is_nil_nvlist_ptr(VSNVList_ptr *);

extern int is_invalid_nvlist_ptr(VSNVList_ptr *);

extern int is_nil_request_ptr(VSRequest_ptr *);

extern int is_invalid_request_ptr(VSRequest_ptr *);

extern int is_nil_context_ptr(VSContext_ptr *);

extern int is_invalid_context_ptr(VSContext_ptr *);

extern int is_nil_orb_ptr(VSORB_ptr *);

extern int is_invalid_orb_ptr(VSORB_ptr *);

extern int is_nil_ctxlist_ptr(VSContextList_ptr *);

extern int is_invalid_ctxlist_ptr(VSContextList_ptr *);

extern int is_nil_exlist_ptr(VSExceptionList_ptr *);

extern int is_invalid_exlist_ptr(VSExceptionList_ptr *);

extern int POA_user_exception_is(VSString str, VSEnvironment *ev);

extern int DAny_user_exception_is(VSString str, VSEnvironment *ev);

/* Declarations of User-Defined-Print-Function-Pointer */

/* Declarations of wrapper of FUT */

#endif
