/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/corba/release/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:42  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.1  1997/09/09 11:54:49  cwatson
   The tests for the release(_ptr) functions.

*/

#include <corba_defs.h>

extern void VSobj_release(VSObject_ptr *o, VSEnvironment *env);
extern void VSnvalue_release(VSNamedValue_ptr *o, VSEnvironment *env);
extern void VStypecode_release(VSTypeCode_ptr *o, VSEnvironment *env);
extern void VSenv_release(VSEnvironment_ptr *o, VSEnvironment *env);
extern void VSnvlist_release(VSNVList_ptr *o, VSEnvironment *env);
extern void VSrequest_release(VSRequest_ptr *o, VSEnvironment *env);
extern void VScontext_release(VSContext_ptr *o, VSEnvironment *env);
extern void VSorb_release(VSORB_ptr *o, VSEnvironment *env);

