/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int object_is_released(VSObject_ptr *);

extern int nvalue_is_released(VSNamedValue_ptr *);

extern int typecode_is_released(VSTypeCode_ptr *);

extern int env_is_released(VSEnvironment_ptr *);

extern int nvlist_is_released(VSNVList_ptr *);

extern int request_is_released(VSRequest_ptr *);

extern int context_is_released(VSContext_ptr *);

extern int orb_is_released(VSORB_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSNamedValue_ptr_P)(VSNamedValue_ptr*, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_ptr_P)(VSEnvironment_ptr*, emitter_t);
extern void (*ADL__print_VSNVList_ptr_P)(VSNVList_ptr*, emitter_t);
extern void (*ADL__print_VSRequest_ptr_P)(VSRequest_ptr*, emitter_t);
extern void (*ADL__print_VSContext_ptr_P)(VSContext_ptr*, emitter_t);
extern void (*ADL__print_VSORB_ptr_P)(VSORB_ptr*, emitter_t);

/* Declarations of wrapper of FUT */
extern void (*ADL__VSobj_release_wrapper)(VSObject_ptr*, VSEnvironment*);
extern void (*ADL__VSnvalue_release_wrapper)(VSNamedValue_ptr*, VSEnvironment*);
extern void (*ADL__VStypecode_release_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern void (*ADL__VSenv_release_wrapper)(VSEnvironment_ptr*, VSEnvironment*);
extern void (*ADL__VSnvlist_release_wrapper)(VSNVList_ptr*, VSEnvironment*);
extern void (*ADL__VSrequest_release_wrapper)(VSRequest_ptr*, VSEnvironment*);
extern void (*ADL__VScontext_release_wrapper)(VSContext_ptr*, VSEnvironment*);
extern void (*ADL__VSorb_release_wrapper)(VSORB_ptr*, VSEnvironment*);

#endif
