/* ADL test driver from t1.tdr
 *
 * test VScreate_sequence_tc(bound, typecode, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_1440[] = {
    {"tvoid", Ptypecode_v_tvoid, 0},
    {"tshort", Ptypecode_v_tshort, 0},
    {"tlong", Ptypecode_v_tlong, 0},
    {"tushort", Ptypecode_v_tushort, 0},
    {"tulong", Ptypecode_v_tulong, 0},
    {"tfloat", Ptypecode_v_tfloat, 0},
    {"tdouble", Ptypecode_v_tdouble, 0},
    {"tboolean", Ptypecode_v_tboolean, 0},
    {"tchar", Ptypecode_v_tchar, 0},
    {"toctet", Ptypecode_v_toctet, 0},
    {"tany", Ptypecode_v_tany, 0},
    {"tTypeCode", Ptypecode_v_tTypeCode, 0},
    {"tPrincipal", Ptypecode_v_tPrincipal, 0},
    {"tobjref", Ptypecode_v_tobjref, 0},
    {"tstruct", Ptypecode_v_tstruct, 0},
    {"tunion", Ptypecode_v_tunion, 0},
    {"tenum", Ptypecode_v_tenum, 0},
    {"tstring", Ptypecode_v_tstring, 0},
    {"tsequence", Ptypecode_v_tsequence, 0},
    {"tarray", Ptypecode_v_tarray, 0},
    {"talias", Ptypecode_v_talias, 0},
    {"texcept", Ptypecode_v_texcept, 0},
    {0, 0, 0}
};

/* values for literal variable bound */
static VSULong ADL__litvar_val_1434[] = {
    0,
    1,
    2,
    99,
};

static struct ADL__propertyValue ADL__litvar_info_1433[] = {
    {"0", 0, ADL__litvar_val_1434},
    {"1", 1, ADL__litvar_val_1434},
    {"2", 2, ADL__litvar_val_1434},
    {"99", 3, ADL__litvar_val_1434},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_1441[] = {
    {"bound", "litvar", ADL__litvar_info_1433, 4},
    {"v", "prop", ADL__prop_values_1440, 22},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_1445[4] = {
    {"bound", "VSULong", ADL__prop_info_1441, 0, 1},
    {"typecode", "VSTypeCode_ptr *", ADL__prop_info_1441, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_1441, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScreate_sequence_tc_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */
#ifndef ADL__PRINT_VSORB_PTR_P
#define ADL__PRINT_VSORB_PTR_P
void (*ADL__print_VSORB_ptr_P)(VSORB_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSORB_PTR_P */
#ifndef ADL__PRINT_VSOBJECTIDLIST_P
#define ADL__PRINT_VSOBJECTIDLIST_P
void (*ADL__print_VSObjectIdList_P)(VSObjectIdList*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECTIDLIST_P */
#ifndef ADL__PRINT_VSOBJECTID_P
#define ADL__PRINT_VSOBJECTID_P
void (*ADL__print_VSObjectId_P)(VSObjectId*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECTID_P */
#ifndef ADL__PRINT_VSREPOSITORYID
#define ADL__PRINT_VSREPOSITORYID
void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t) = 0;

#endif /* ADL__PRINT_VSREPOSITORYID */
#ifndef ADL__PRINT_VSIDENTIFIER
#define ADL__PRINT_VSIDENTIFIER
void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDENTIFIER */
#ifndef ADL__PRINT_VSSTRUCTMEMBERSEQ_P
#define ADL__PRINT_VSSTRUCTMEMBERSEQ_P
void (*ADL__print_VSStructMemberSeq_P)(VSStructMemberSeq*, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRUCTMEMBERSEQ_P */
#ifndef ADL__PRINT_VSTYPECODE_PTR_P
#define ADL__PRINT_VSTYPECODE_PTR_P
void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR_P */
#ifndef ADL__PRINT_VSUNIONMEMBERSEQ_P
#define ADL__PRINT_VSUNIONMEMBERSEQ_P
void (*ADL__print_VSUnionMemberSeq_P)(VSUnionMemberSeq*, emitter_t) = 0;

#endif /* ADL__PRINT_VSUNIONMEMBERSEQ_P */
#ifndef ADL__PRINT_VSENUMMEMBERSEQ_P
#define ADL__PRINT_VSENUMMEMBERSEQ_P
void (*ADL__print_VSEnumMemberSeq_P)(VSEnumMemberSeq*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENUMMEMBERSEQ_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSVALUEFACTORY
#define ADL__PRINT_VSVALUEFACTORY
void (*ADL__print_VSValueFactory)(VSValueFactory, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEFACTORY */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSPOLICYTYPE
#define ADL__PRINT_VSPOLICYTYPE
void (*ADL__print_VSPolicyType)(VSPolicyType, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOLICYTYPE */
#ifndef ADL__PRINT_VSANY
#define ADL__PRINT_VSANY
void (*ADL__print_VSAny)(VSAny, emitter_t) = 0;

#endif /* ADL__PRINT_VSANY */
#ifndef ADL__PRINT_VSPOLICY_PTR_P
#define ADL__PRINT_VSPOLICY_PTR_P
void (*ADL__print_VSPolicy_ptr_P)(VSPolicy_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOLICY_PTR_P */

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSORB_ptr_P (void* val, emitter_t emitter)
{
  VSORB_ptr *tmp;

  if (ADL__print_VSORB_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSORB_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObjectIdList_P (void* val, emitter_t emitter)
{
  VSObjectIdList *tmp;

  if (ADL__print_VSObjectIdList_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObjectIdList_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObjectId_P (void* val, emitter_t emitter)
{
  VSObjectId *tmp;

  if (ADL__print_VSObjectId_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObjectId_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRepositoryId (void* val, emitter_t emitter)
{
  VSRepositoryId tmp;

  if (ADL__print_VSRepositoryId != 0) {
    tmp = *(VSRepositoryId*) val;
    ADL__print_VSRepositoryId(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIdentifier (void* val, emitter_t emitter)
{
  VSIdentifier tmp;

  if (ADL__print_VSIdentifier != 0) {
    tmp = *(VSIdentifier*) val;
    ADL__print_VSIdentifier(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSStructMemberSeq_P (void* val, emitter_t emitter)
{
  VSStructMemberSeq *tmp;

  if (ADL__print_VSStructMemberSeq_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSStructMemberSeq_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter)
{
  VSTypeCode_ptr *tmp;

  if (ADL__print_VSTypeCode_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSTypeCode_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSUnionMemberSeq_P (void* val, emitter_t emitter)
{
  VSUnionMemberSeq *tmp;

  if (ADL__print_VSUnionMemberSeq_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSUnionMemberSeq_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnumMemberSeq_P (void* val, emitter_t emitter)
{
  VSEnumMemberSeq *tmp;

  if (ADL__print_VSEnumMemberSeq_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnumMemberSeq_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSValueFactory (void* val, emitter_t emitter)
{
  VSValueFactory tmp;

  if (ADL__print_VSValueFactory != 0) {
    tmp = *(VSValueFactory*) val;
    ADL__print_VSValueFactory(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSPolicyType (void* val, emitter_t emitter)
{
  VSPolicyType tmp;

  if (ADL__print_VSPolicyType != 0) {
    tmp = *(VSPolicyType*) val;
    ADL__print_VSPolicyType(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSAny (void* val, emitter_t emitter)
{
  VSAny tmp;

  if (ADL__print_VSAny != 0) {
    tmp = *(VSAny*) val;
    ADL__print_VSAny(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPolicy_ptr_P (void* val, emitter_t emitter)
{
  VSPolicy_ptr *tmp;

  if (ADL__print_VSPolicy_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPolicy_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {4, 22};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSULong bound_1442;
    VSTypeCode_ptr *typecode_1443;
    VSEnvironment *env_1444;
    VSTypeCode_ptr *fut_return_1439;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScreate_sequence_tc_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScreate_sequence_tc_InfoArrayIdx,
        ADL__VScreate_sequence_tc_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       bound_1442 = ADL__litvar_val_1434[tvec[0]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 0, tvec + 0, 1);
       ADL__emit_VSULong(&bound_1442, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_typecode(&typecode_1443, ADL__prop_values_1440[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSTypeCode_ptr_P(&typecode_1443, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_1444)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_1444, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScreate_sequence_tc_assertionReport = rf->assertionReport;
       fut_return_1439 = ADL__ACF_VScreate_sequence_tc(bound_1442, typecode_1443, env_1444);
       test_value = ADL__VScreate_sequence_tc_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_1444);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_typecode(&typecode_1443, ADL__prop_values_1440[tvec[1]].propValCode);
SKIP_1:
       relvec[0] = 1;	/* relinquish succeeds for bound_1442 */
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_1445,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScreate_sequence_tc_head);

    return 0;
}


struct ADL__Directive_info VScreate_sequence_tc1_info = {
    N_VARS,
    ADL__var_info_1445
};

struct ADL__TDD_info ADL__test_info = {
    88,
    &ADL__VScreate_sequence_tc_InfoArrayIdx,
    ADL__VScreate_sequence_tc_InfoArray,
    ADL__test_driver,
    "VScreate_sequence_tc",
    "VScreate_sequence_tc1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScreate_sequence_tc1",
    "t1_tr.rif",
    &VScreate_sequence_tc1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

