/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/pObjects/Object/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:50  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.2  1997/09/08 11:40:31  cwatson
   Added _get_interface(), is_a(), is_equivalent(), non_existent() and hash() tests.

   Revision 1.1  1997/08/20 11:43:41  cwatson
   *** empty log message ***

   Revision 1.1  1997/08/06 14:39:59  cwatson
   *** empty log message ***

*/

#include <corba_defs.h>

extern VSObject_ptr *VSnil(VSEnvironment *env);
extern VSObject_ptr *VSduplicate(VSObject_ptr *o, VSEnvironment *env);

extern VSInterfaceDef_ptr *VSget_interface(VSObject_ptr *o, VSEnvironment *env);
extern VSBoolean VSis_a(VSObject_ptr *o, VSChar* lid, VSEnvironment *ev);
extern VSBoolean VSis_equivalent(VSObject_ptr *o1, VSObject_ptr *o2, VSEnvironment *ev);
extern VSBoolean VSnon_existent(VSObject_ptr *o, VSEnvironment *ev);
extern VSULong VShash(VSObject_ptr *o, VSULong mx, VSEnvironment *ev);

