/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSnil
 *
 */
VSObject_ptr *ADL__ACF_VSnil (VSEnvironment *ev_10){

VSObject_ptr *VSnil_RtnVal_4;
  void *dummyVarName_379;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_21;
  int tmp_23;
  int tmp_24;
  VSEnvironment *ev_10_tmp_28;
    int tmp_29;
  int tmp_31;
  int tmp_32;
  int tmp_33;
  VSEnvironment *ev_10_tmp_36;
  int tmp_37;
  int tmp_38;
  VSEnvironment *ev_10_tmp_41;
    int tmp_42;
  int tmp_43;
  int groupExpr_52;
  int tmp_45;
  int tmp_46;
  int tmp_49;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_5, VSnil_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSnil_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_3))
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_4 = ADL__VSnil_wrapper(ev_10);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_7);
  VSnil_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_13);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_12);

  VSnil_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_6 && !VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_6 && VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_28 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_10_tmp_28);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_24);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = !tmp_24;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_23);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_21 = (!VSnil_ExceptionOutcome_6 || tmp_23);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_21);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_36 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_10_tmp_36);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_33 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_33);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_32);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_31 = tmp_32;
  if (tmp_32) {
      ev_10_tmp_41 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_10_tmp_41);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_38 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_38);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_37 = !tmp_38;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_37);
    tmp_31 = tmp_37;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_31);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_29 = (!VSnil_ExceptionOutcome_6 || tmp_31);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_29);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_object_ptr(return) */
  tmp_46 = is_nil_object_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_46);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_object_ptr(return) && cleanup_object_ptr(return) */
  tmp_45 = tmp_46;
  if (tmp_46) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_object_ptr(return) */
  tmp_49 = cleanup_object_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_49);
    tmp_45 = tmp_49;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_45);
  groupExpr_52 = (tmp_45);
  tmp_43 = (groupExpr_52);
  tmp_42 = tmp_43;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_42 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_42);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_3 = calculate_ACF_result(VSnil_ACF_Result_3, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_3;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_4);
}


VSObject_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_object_ptr(return) && cleanup_object_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_object_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_object_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSObject_ptr *ADL__ACF_VSduplicate (VSObject_ptr *o_72, VSEnvironment *ev_61){

VSObject_ptr *VSduplicate_RtnVal_55;
  void *dummyVarName_379;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_73;
  int tmp_75;
  int tmp_76;
  VSEnvironment *ev_61_tmp_80;
    int tmp_81;
  int tmp_83;
  int tmp_84;
  VSEnvironment *ev_61_tmp_87;
    int tmp_88;
  int tmp_89;
  int groupExpr_106;
  int tmp_90;
  int tmp_92;
  int tmp_93;
  VSObject_ptr *o_72_tmp_96;
  int tmp_97;
  VSObject_ptr *o_72_tmp_100;
  int tmp_101;
  VSObject_ptr *o_72_tmp_105;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_56, VSduplicate_ExceptionOutcome_57;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_58;
  VSEnvironment *ev_61_tmp_62;
    int tmp_63;
  int tmp_64;
  VSEnvironment *ev_61_tmp_67;
  int tmp_68;
  VSEnvironment *ev_61_tmp_71;
  enum ADL__ACF_result VSduplicate_ACF_Result_54 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_54))
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_54 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_55 = ADL__VSduplicate_wrapper(o_72, ev_61);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_61_tmp_62 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_61_tmp_62);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_58 = no_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_58);
  VSduplicate_NormalOutcome_56 = (tmp_58);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_61_tmp_67 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_61_tmp_67);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_64 = system_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_64);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_63 = tmp_64;
  if (!tmp_64) {
      ev_61_tmp_71 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_61_tmp_71);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_68 = user_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_68);
    tmp_63 = tmp_68;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_63);

  VSduplicate_ExceptionOutcome_57 = (tmp_63);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_57 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_57 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_56 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_56 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_57 && !VSduplicate_NormalOutcome_56) {
  VSduplicate_ACF_Result_54 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_57 && VSduplicate_NormalOutcome_56) {
  VSduplicate_ACF_Result_54 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_57);
  ev_61_tmp_80 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_61_tmp_80);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_76 = user_exception_is("NOT_IMPLEMENTED", ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_76);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_75 = !tmp_76;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_75);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_73 = (!VSduplicate_ExceptionOutcome_57 || tmp_75);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_73);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_57);
  ev_61_tmp_87 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&ev_61_tmp_87);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_84 = user_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_84);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_83 = !tmp_84;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_83);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_81 = (!VSduplicate_ExceptionOutcome_57 || tmp_83);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_81);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_56){
      o_72_tmp_96 = o_72;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&o_72_tmp_96);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[22]);

/* Evaluate is_valid_object_ptr(o) */
  tmp_93 = is_valid_object_ptr(o_72);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&tmp_93);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate is_valid_object_ptr(o) || is_nil_object_ptr(o) */
  tmp_92 = tmp_93;
  if (!tmp_93) {
      o_72_tmp_100 = o_72;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&o_72_tmp_100);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate is_nil_object_ptr(o) */
  tmp_97 = is_nil_object_ptr(o_72);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_97);
    tmp_92 = tmp_97;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 24, 25);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_92);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 27,&VSduplicate_RtnVal_55);
  o_72_tmp_105 = o_72;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 28,&o_72_tmp_105);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[26]);

/* Evaluate is_same_object_ptr(return, o) */
  tmp_101 = is_same_object_ptr(VSduplicate_RtnVal_55, o_72);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 26,&tmp_101);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate (is_valid_object_ptr(o) || is_nil_object_ptr(o)) --> is_same_object_ptr(return, o) */
  tmp_90 = (!tmp_92 || tmp_101);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_90);
  groupExpr_106 = (tmp_90);
  tmp_89 = (groupExpr_106);
  tmp_88 = tmp_89;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 19, 28);
  tmp_88 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&tmp_88);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_54 = calculate_ACF_result(VSduplicate_ACF_Result_54, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_54;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_55);
}


VSObject_ptr *(*ADL__VSduplicate_wrapper)(VSObject_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "(is_valid_object_ptr(o) || is_nil_object_ptr(o)) --> is_same_object_ptr(return, o)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_valid_object_ptr(o) || is_nil_object_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "is_valid_object_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 23, 22, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {4, 24, 21, 0, 0, "is_nil_object_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {4, 26, 20, 0, 0, "is_same_object_ptr(return, o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 27, 26, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {4, 28, 26, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSget_interface
 *
 */
VSInterfaceDef_ptr *ADL__ACF_VSget_interface (VSObject_ptr *o_126, VSEnvironment *ev_115){

VSInterfaceDef_ptr *VSget_interface_RtnVal_109;
  void *dummyVarName_379;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_127;
  int tmp_129;
  int tmp_130;
  VSEnvironment *ev_115_tmp_134;
    int tmp_135;
  int tmp_137;
  int tmp_138;
  VSEnvironment *ev_115_tmp_141;
    int tmp_142;
  int tmp_143;
  int groupExpr_153;
  int tmp_145;
  int tmp_146;
  VSObject_ptr *o_126_tmp_149;
  int tmp_150;

/* Declare vars for result of normal and exception bindings */
  int VSget_interface_NormalOutcome_110, VSget_interface_ExceptionOutcome_111;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_112;
  VSEnvironment *ev_115_tmp_116;
    int tmp_117;
  int tmp_118;
  VSEnvironment *ev_115_tmp_121;
  int tmp_122;
  VSEnvironment *ev_115_tmp_125;
  enum ADL__ACF_result VSget_interface_ACF_Result_108 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSget_interface_InfoArray, 0, ADL__VSget_interface_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSget_interface_assertionReport->setPhase(ADL__VSget_interface_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_interface_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSget_interface_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSget_interface_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSget_interface_InfoArray[forLoopIdx_1].error > VSget_interface_ACF_Result_108))
  VSget_interface_ACF_Result_108 = ADL__VSget_interface_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSget_interface_ACF_Result_108 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSget_interface_assertionReport->setPhase(ADL__VSget_interface_assertionReport, PH_call);
  ADL__release(ADL__VSget_interface_assertionReport->parent, &this_seq);
  VSget_interface_RtnVal_109 = ADL__VSget_interface_wrapper(o_126, ev_115);
  ADL__recover(ADL__VSget_interface_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSget_interface_assertionReport->setPhase(ADL__VSget_interface_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_115_tmp_116 = ev_115;
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 8,&ev_115_tmp_116);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_112 = no_exception(ev_115);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 7,&tmp_112);
  VSget_interface_NormalOutcome_110 = (tmp_112);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_115_tmp_121 = ev_115;
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 3,&ev_115_tmp_121);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_118 = system_exception(ev_115);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 2,&tmp_118);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_117 = tmp_118;
  if (!tmp_118) {
      ev_115_tmp_125 = ev_115;
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 5,&ev_115_tmp_125);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_122 = user_exception(ev_115);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 4,&tmp_122);
    tmp_117 = tmp_122;
  }
  else {
  ADL__resetInfoStruct(ADL__VSget_interface_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 1,&tmp_117);

  VSget_interface_ExceptionOutcome_111 = (tmp_117);

/* Exception binding is the first assertion */
  if (ADL__VSget_interface_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSget_interface_InfoArray[0].result = (VSget_interface_ExceptionOutcome_111 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_interface_InfoArray[0].evaluated = 1;
  ADL__VSget_interface_InfoArray[0].value = (VSget_interface_ExceptionOutcome_111 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSget_interface_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSget_interface_InfoArray[6].result = (VSget_interface_NormalOutcome_110 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_interface_InfoArray[6].evaluated = 1;
  ADL__VSget_interface_InfoArray[6].value = (VSget_interface_NormalOutcome_110 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSget_interface_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSget_interface_ACF_Result_108 = ADL__VSget_interface_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSget_interface_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSget_interface_ACF_Result_108 = ADL__VSget_interface_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSget_interface_ExceptionOutcome_111 && !VSget_interface_NormalOutcome_110) {
  VSget_interface_ACF_Result_108 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSget_interface_ExceptionOutcome_111 && VSget_interface_NormalOutcome_110) {
  VSget_interface_ACF_Result_108 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSget_interface_InfoArray, 10,&VSget_interface_ExceptionOutcome_111);
  ev_115_tmp_134 = ev_115;
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 13,&ev_115_tmp_134);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_130 = user_exception_is("NOT_IMPLEMENTED", ev_115);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 12,&tmp_130);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_129 = !tmp_130;
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 11,&tmp_129);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_127 = (!VSget_interface_ExceptionOutcome_111 || tmp_129);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 9,&tmp_127);
    ADL__setResultAndError(ADL__VSget_interface_InfoArray, 15,&VSget_interface_ExceptionOutcome_111);
  ev_115_tmp_141 = ev_115;
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 18,&ev_115_tmp_141);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_138 = user_exception(ev_115);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 17,&tmp_138);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_137 = !tmp_138;
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 16,&tmp_137);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_135 = (!VSget_interface_ExceptionOutcome_111 || tmp_137);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 14,&tmp_135);
    ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSget_interface_NormalOutcome_110){
      o_126_tmp_149 = o_126;
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 22,&o_126_tmp_149);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[21]);

/* Evaluate is_valid_object_ptr(o) */
  tmp_146 = is_valid_object_ptr(o_126);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 21,&tmp_146);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 24,&VSget_interface_RtnVal_109);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[23]);

/* Evaluate is_valid_intdef(return) */
  tmp_150 = is_valid_intdef(VSget_interface_RtnVal_109);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 23,&tmp_150);
  ADL__VSget_interface_assertionReport->exprMark(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_assertionReport->assrt_info[20]);

/* Evaluate is_valid_object_ptr(o) --> is_valid_intdef(return) */
  tmp_145 = (!tmp_146 || tmp_150);
  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 20,&tmp_145);
  groupExpr_153 = (tmp_145);
  tmp_143 = (groupExpr_153);
  tmp_142 = tmp_143;
  }
  else {
    ADL__resetInfoStruct(ADL__VSget_interface_InfoArray, 19, 24);
  tmp_142 = 1;
}

  ADL__setResultAndError(ADL__VSget_interface_InfoArray, 19,&tmp_142);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_interface_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSget_interface_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSget_interface_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSget_interface_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSget_interface_InfoArray[forLoopIdx_1].level == 0))
        VSget_interface_ACF_Result_108 = calculate_ACF_result(VSget_interface_ACF_Result_108, ADL__VSget_interface_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSget_interface_assertionReport->value = VSget_interface_ACF_Result_108;
  ADL__VSget_interface_assertionReport->parent->openReport(ADL__VSget_interface_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_interface_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSget_interface_assertionReport->emitTest(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_InfoArray[forLoopIdx_1])) {
     ADL__VSget_interface_assertionReport->exprStart(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_InfoArray[forLoopIdx_1]);
      if(!ADL__VSget_interface_InfoArray[forLoopIdx_1].testable || !ADL__VSget_interface_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSget_interface_assertionReport->emitter);
      else if (ADL__VSget_interface_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSget_interface_InfoArray[forLoopIdx_1].error, ADL__VSget_interface_assertionReport->emitter);
      else
        ADL__VSget_interface_InfoArray[forLoopIdx_1].emitFunc(ADL__VSget_interface_InfoArray[forLoopIdx_1].value, ADL__VSget_interface_assertionReport->emitter);
     ADL__VSget_interface_assertionReport->exprEnd(ADL__VSget_interface_assertionReport, &ADL__VSget_interface_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSget_interface_RtnVal_109);
}


VSInterfaceDef_ptr *(*ADL__VSget_interface_wrapper)(VSObject_ptr*, VSEnvironment*) = VSget_interface;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSInterfaceDef_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSget_interface_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_valid_object_ptr(o) --> is_valid_intdef(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_valid_object_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {4, 23, 20, 0, 0, "is_valid_intdef(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSInterfaceDef_ptr_P }
};


unsigned int ADL__VSget_interface_InfoArrayIdx = 25;

struct ADL__reportAssertion *ADL__VSget_interface_assertionReport = 0;

/*
 *
 * ACF of VSis_a
 *
 */
VSBoolean ADL__ACF_VSis_a (VSObject_ptr *o_173, VSChar *lid_174, VSEnvironment *ev_162){

VSBoolean VSis_a_RtnVal_156;
  void *dummyVarName_379;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_175;
  int tmp_177;
  int tmp_178;
  VSEnvironment *ev_162_tmp_182;
    int tmp_183;
  int tmp_185;
  int tmp_186;
  VSEnvironment *ev_162_tmp_189;
    int tmp_190;
  int tmp_191;
  int groupExpr_202;
  int tmp_193;
  int tmp_195;
  int tmp_199;

/* Declare vars for result of normal and exception bindings */
  int VSis_a_NormalOutcome_157, VSis_a_ExceptionOutcome_158;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_159;
  VSEnvironment *ev_162_tmp_163;
    int tmp_164;
  int tmp_165;
  VSEnvironment *ev_162_tmp_168;
  int tmp_169;
  VSEnvironment *ev_162_tmp_172;
  enum ADL__ACF_result VSis_a_ACF_Result_155 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSis_a_InfoArray, 0, ADL__VSis_a_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSis_a_assertionReport->setPhase(ADL__VSis_a_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        ADL__setResultAndError(ADL__VSis_a_InfoArray, 23,&ADL__TRUE_CONST);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 26,&ADL__FALSE_CONST);

/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSis_a_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSis_a_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSis_a_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSis_a_InfoArray[forLoopIdx_1].error > VSis_a_ACF_Result_155))
  VSis_a_ACF_Result_155 = ADL__VSis_a_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSis_a_ACF_Result_155 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSis_a_assertionReport->setPhase(ADL__VSis_a_assertionReport, PH_call);
  ADL__release(ADL__VSis_a_assertionReport->parent, &this_seq);
  VSis_a_RtnVal_156 = ADL__VSis_a_wrapper(o_173, lid_174, ev_162);
  ADL__recover(ADL__VSis_a_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSis_a_assertionReport->setPhase(ADL__VSis_a_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_162_tmp_163 = ev_162;
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 8,&ev_162_tmp_163);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_159 = no_exception(ev_162);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 7,&tmp_159);
  VSis_a_NormalOutcome_157 = (tmp_159);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_162_tmp_168 = ev_162;
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 3,&ev_162_tmp_168);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_165 = system_exception(ev_162);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 2,&tmp_165);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_164 = tmp_165;
  if (!tmp_165) {
      ev_162_tmp_172 = ev_162;
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 5,&ev_162_tmp_172);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_169 = user_exception(ev_162);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 4,&tmp_169);
    tmp_164 = tmp_169;
  }
  else {
  ADL__resetInfoStruct(ADL__VSis_a_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 1,&tmp_164);

  VSis_a_ExceptionOutcome_158 = (tmp_164);

/* Exception binding is the first assertion */
  if (ADL__VSis_a_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSis_a_InfoArray[0].result = (VSis_a_ExceptionOutcome_158 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSis_a_InfoArray[0].evaluated = 1;
  ADL__VSis_a_InfoArray[0].value = (VSis_a_ExceptionOutcome_158 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSis_a_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSis_a_InfoArray[6].result = (VSis_a_NormalOutcome_157 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSis_a_InfoArray[6].evaluated = 1;
  ADL__VSis_a_InfoArray[6].value = (VSis_a_NormalOutcome_157 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSis_a_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSis_a_ACF_Result_155 = ADL__VSis_a_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSis_a_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSis_a_ACF_Result_155 = ADL__VSis_a_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSis_a_ExceptionOutcome_158 && !VSis_a_NormalOutcome_157) {
  VSis_a_ACF_Result_155 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSis_a_ExceptionOutcome_158 && VSis_a_NormalOutcome_157) {
  VSis_a_ACF_Result_155 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSis_a_InfoArray, 10,&VSis_a_ExceptionOutcome_158);
  ev_162_tmp_182 = ev_162;
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 13,&ev_162_tmp_182);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_178 = user_exception_is("NOT_IMPLEMENTED", ev_162);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 12,&tmp_178);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_177 = !tmp_178;
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 11,&tmp_177);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_175 = (!VSis_a_ExceptionOutcome_158 || tmp_177);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 9,&tmp_175);
    ADL__setResultAndError(ADL__VSis_a_InfoArray, 15,&VSis_a_ExceptionOutcome_158);
  ev_162_tmp_189 = ev_162;
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 18,&ev_162_tmp_189);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_186 = user_exception(ev_162);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 17,&tmp_186);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_185 = !tmp_186;
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 16,&tmp_185);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_183 = (!VSis_a_ExceptionOutcome_158 || tmp_185);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 14,&tmp_183);
    ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSis_a_NormalOutcome_157){
      ADL__setResultAndError(ADL__VSis_a_InfoArray, 22,&VSis_a_RtnVal_156);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 23,&ADL__TRUE_CONST);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[21]);

/* Evaluate return == true */
  tmp_195 = ((VSis_a_RtnVal_156 ? 1 : 0)==(ADL__TRUE_CONST ? 1 : 0));
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 21,&tmp_195);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[20]);

/* Evaluate (return == true) || (return == false) */
  tmp_193 = tmp_195;
  if (!tmp_195) {
      ADL__setResultAndError(ADL__VSis_a_InfoArray, 25,&VSis_a_RtnVal_156);
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 26,&ADL__FALSE_CONST);
  ADL__VSis_a_assertionReport->exprMark(ADL__VSis_a_assertionReport, &ADL__VSis_a_assertionReport->assrt_info[24]);

/* Evaluate return == false */
  tmp_199 = ((VSis_a_RtnVal_156 ? 1 : 0)==(ADL__FALSE_CONST ? 1 : 0));
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 24,&tmp_199);
    tmp_193 = tmp_199;
  }
  else {
  ADL__resetInfoStruct(ADL__VSis_a_InfoArray, 24, 26);
  }
  ADL__setResultAndError(ADL__VSis_a_InfoArray, 20,&tmp_193);
  groupExpr_202 = (tmp_193);
  tmp_191 = (groupExpr_202);
  tmp_190 = tmp_191;
  }
  else {
    ADL__resetInfoStruct(ADL__VSis_a_InfoArray, 19, 26);
  tmp_190 = 1;
}

  ADL__setResultAndError(ADL__VSis_a_InfoArray, 19,&tmp_190);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSis_a_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSis_a_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSis_a_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSis_a_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSis_a_InfoArray[forLoopIdx_1].level == 0))
        VSis_a_ACF_Result_155 = calculate_ACF_result(VSis_a_ACF_Result_155, ADL__VSis_a_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSis_a_assertionReport->value = VSis_a_ACF_Result_155;
  ADL__VSis_a_assertionReport->parent->openReport(ADL__VSis_a_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSis_a_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSis_a_assertionReport->emitTest(ADL__VSis_a_assertionReport, &ADL__VSis_a_InfoArray[forLoopIdx_1])) {
     ADL__VSis_a_assertionReport->exprStart(ADL__VSis_a_assertionReport, &ADL__VSis_a_InfoArray[forLoopIdx_1]);
      if(!ADL__VSis_a_InfoArray[forLoopIdx_1].testable || !ADL__VSis_a_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSis_a_assertionReport->emitter);
      else if (ADL__VSis_a_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSis_a_InfoArray[forLoopIdx_1].error, ADL__VSis_a_assertionReport->emitter);
      else
        ADL__VSis_a_InfoArray[forLoopIdx_1].emitFunc(ADL__VSis_a_InfoArray[forLoopIdx_1].value, ADL__VSis_a_assertionReport->emitter);
     ADL__VSis_a_assertionReport->exprEnd(ADL__VSis_a_assertionReport, &ADL__VSis_a_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSis_a_RtnVal_156);
}


VSBoolean (*ADL__VSis_a_wrapper)(VSObject_ptr*, VSChar*, VSEnvironment*) = VSis_a;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSChar_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSBoolean (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSis_a_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "(return == true) || (return == false)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "return == true", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean },
  {4, 23, 21, 0, 0, "true", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 24, 20, 0, 0, "return == false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean },
  {4, 26, 24, 0, 0, "false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean }
};


unsigned int ADL__VSis_a_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VSis_a_assertionReport = 0;

/*
 *
 * ACF of VSis_equivalent
 *
 */
VSBoolean ADL__ACF_VSis_equivalent (VSObject_ptr *o1_222, VSObject_ptr *o2_223, VSEnvironment *ev_211){

VSBoolean VSis_equivalent_RtnVal_205;
  void *dummyVarName_379;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_224;
  int tmp_226;
  int tmp_227;
  VSEnvironment *ev_211_tmp_231;
    int tmp_232;
  int tmp_234;
  int tmp_235;
  VSEnvironment *ev_211_tmp_238;
    int tmp_240;
  int tmp_242;
  int tmp_243;
  int tmp_244;
  VSObject_ptr *o1_222_tmp_247;
  int tmp_248;
  VSObject_ptr *o2_223_tmp_251;
  int tmp_253;
  int tmp_254;
  VSEnvironment *ev_211_tmp_258;
  int tmp_260;
    int tmp_263;
  int tmp_264;
  int groupExpr_313;
  int groupExpr_314;
  int groupExpr_315;
  int tmp_266;
  int tmp_268;
  int tmp_269;
  VSObject_ptr *o1_222_tmp_272;
  int tmp_273;
  VSObject_ptr *o2_223_tmp_276;
  int tmp_278;
  int tmp_282;
  int tmp_284;
  int tmp_285;
  VSObject_ptr *o1_222_tmp_288;
  int tmp_289;
  VSObject_ptr *o2_223_tmp_292;
  int tmp_294;
  int tmp_298;
  int tmp_300;
  int tmp_301;
  VSObject_ptr *o1_222_tmp_304;
  int tmp_305;
  VSObject_ptr *o2_223_tmp_308;
  int tmp_310;

/* Declare vars for result of normal and exception bindings */
  int VSis_equivalent_NormalOutcome_206, VSis_equivalent_ExceptionOutcome_207;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_208;
  VSEnvironment *ev_211_tmp_212;
    int tmp_213;
  int tmp_214;
  VSEnvironment *ev_211_tmp_217;
  int tmp_218;
  VSEnvironment *ev_211_tmp_221;
  enum ADL__ACF_result VSis_equivalent_ACF_Result_204 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSis_equivalent_InfoArray, 0, ADL__VSis_equivalent_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSis_equivalent_assertionReport->setPhase(ADL__VSis_equivalent_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 31,&ADL__FALSE_CONST);
    ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 41,&ADL__TRUE_CONST);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 50,&ADL__FALSE_CONST);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 59,&ADL__FALSE_CONST);

/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSis_equivalent_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSis_equivalent_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSis_equivalent_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSis_equivalent_InfoArray[forLoopIdx_1].error > VSis_equivalent_ACF_Result_204))
  VSis_equivalent_ACF_Result_204 = ADL__VSis_equivalent_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSis_equivalent_ACF_Result_204 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSis_equivalent_assertionReport->setPhase(ADL__VSis_equivalent_assertionReport, PH_call);
  ADL__release(ADL__VSis_equivalent_assertionReport->parent, &this_seq);
  VSis_equivalent_RtnVal_205 = ADL__VSis_equivalent_wrapper(o1_222, o2_223, ev_211);
  ADL__recover(ADL__VSis_equivalent_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSis_equivalent_assertionReport->setPhase(ADL__VSis_equivalent_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_211_tmp_212 = ev_211;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 8,&ev_211_tmp_212);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_208 = no_exception(ev_211);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 7,&tmp_208);
  VSis_equivalent_NormalOutcome_206 = (tmp_208);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_211_tmp_217 = ev_211;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 3,&ev_211_tmp_217);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_214 = system_exception(ev_211);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 2,&tmp_214);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_213 = tmp_214;
  if (!tmp_214) {
      ev_211_tmp_221 = ev_211;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 5,&ev_211_tmp_221);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_218 = user_exception(ev_211);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 4,&tmp_218);
    tmp_213 = tmp_218;
  }
  else {
  ADL__resetInfoStruct(ADL__VSis_equivalent_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 1,&tmp_213);

  VSis_equivalent_ExceptionOutcome_207 = (tmp_213);

/* Exception binding is the first assertion */
  if (ADL__VSis_equivalent_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSis_equivalent_InfoArray[0].result = (VSis_equivalent_ExceptionOutcome_207 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSis_equivalent_InfoArray[0].evaluated = 1;
  ADL__VSis_equivalent_InfoArray[0].value = (VSis_equivalent_ExceptionOutcome_207 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSis_equivalent_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSis_equivalent_InfoArray[6].result = (VSis_equivalent_NormalOutcome_206 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSis_equivalent_InfoArray[6].evaluated = 1;
  ADL__VSis_equivalent_InfoArray[6].value = (VSis_equivalent_NormalOutcome_206 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSis_equivalent_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSis_equivalent_ACF_Result_204 = ADL__VSis_equivalent_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSis_equivalent_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSis_equivalent_ACF_Result_204 = ADL__VSis_equivalent_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSis_equivalent_ExceptionOutcome_207 && !VSis_equivalent_NormalOutcome_206) {
  VSis_equivalent_ACF_Result_204 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSis_equivalent_ExceptionOutcome_207 && VSis_equivalent_NormalOutcome_206) {
  VSis_equivalent_ACF_Result_204 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 10,&VSis_equivalent_ExceptionOutcome_207);
  ev_211_tmp_231 = ev_211;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 13,&ev_211_tmp_231);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_227 = user_exception_is("NOT_IMPLEMENTED", ev_211);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 12,&tmp_227);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_226 = !tmp_227;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 11,&tmp_226);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_224 = (!VSis_equivalent_ExceptionOutcome_207 || tmp_226);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 9,&tmp_224);
    ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 15,&VSis_equivalent_ExceptionOutcome_207);
  ev_211_tmp_238 = ev_211;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 18,&ev_211_tmp_238);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_235 = user_exception(ev_211);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 17,&tmp_235);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_234 = !tmp_235;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 16,&tmp_234);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_232 = (!VSis_equivalent_ExceptionOutcome_207 || tmp_234);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 14,&tmp_232);
    o1_222_tmp_247 = o1_222;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 23,&o1_222_tmp_247);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[22]);

/* Evaluate is_invalid_object_ptr(o1) */
  tmp_244 = is_invalid_object_ptr(o1_222);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 22,&tmp_244);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[21]);

/* Evaluate !is_invalid_object_ptr(o1) */
  tmp_243 = !tmp_244;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 21,&tmp_243);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[20]);

/* Evaluate !is_invalid_object_ptr(o1) && is_invalid_object_ptr(o2) */
  tmp_242 = tmp_243;
  if (tmp_243) {
      o2_223_tmp_251 = o2_223;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 25,&o2_223_tmp_251);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[24]);

/* Evaluate is_invalid_object_ptr(o2) */
  tmp_248 = is_invalid_object_ptr(o2_223);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 24,&tmp_248);
    tmp_242 = tmp_248;
  }
  else {
  ADL__resetInfoStruct(ADL__VSis_equivalent_InfoArray, 24, 25);
  }
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 20,&tmp_242);
  ev_211_tmp_258 = ev_211;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 28,&ev_211_tmp_258);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[27]);

/* Evaluate system_exception_is("OBJECT_NOT_EXIST", ev) */
  tmp_254 = system_exception_is("OBJECT_NOT_EXIST", ev_211);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 27,&tmp_254);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[26]);

/* Evaluate system_exception_is("OBJECT_NOT_EXIST", ev) && (return == false) */
  tmp_253 = tmp_254;
  if (tmp_254) {
      ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 30,&VSis_equivalent_RtnVal_205);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 31,&ADL__FALSE_CONST);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[29]);

/* Evaluate return == false */
  tmp_260 = ((VSis_equivalent_RtnVal_205 ? 1 : 0)==(ADL__FALSE_CONST ? 1 : 0));
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 29,&tmp_260);
    tmp_253 = tmp_260;
  }
  else {
  ADL__resetInfoStruct(ADL__VSis_equivalent_InfoArray, 29, 31);
  }
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 26,&tmp_253);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[19]);

/* Evaluate (!is_invalid_object_ptr(o1) && is_invalid_object_ptr(o2)) --> (system_exception_is("OBJECT_NOT_EXIST", ev) && (return == false)) */
  tmp_240 = (!tmp_242 || tmp_253);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 19,&tmp_240);
    ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[32]);

/* Evaluate normally { ... } */
  if(VSis_equivalent_NormalOutcome_206){
      o1_222_tmp_272 = o1_222;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 36,&o1_222_tmp_272);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[35]);

/* Evaluate is_valid_object_ptr(o1) */
  tmp_269 = is_valid_object_ptr(o1_222);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 35,&tmp_269);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[34]);

/* Evaluate is_valid_object_ptr(o1) && is_valid_object_ptr(o2) */
  tmp_268 = tmp_269;
  if (tmp_269) {
      o2_223_tmp_276 = o2_223;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 38,&o2_223_tmp_276);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[37]);

/* Evaluate is_valid_object_ptr(o2) */
  tmp_273 = is_valid_object_ptr(o2_223);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 37,&tmp_273);
    tmp_268 = tmp_273;
  }
  else {
  ADL__resetInfoStruct(ADL__VSis_equivalent_InfoArray, 37, 38);
  }
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 34,&tmp_268);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 40,&VSis_equivalent_RtnVal_205);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 41,&ADL__TRUE_CONST);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[39]);

/* Evaluate return == true */
  tmp_278 = ((VSis_equivalent_RtnVal_205 ? 1 : 0)==(ADL__TRUE_CONST ? 1 : 0));
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 39,&tmp_278);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[33]);

/* Evaluate (is_valid_object_ptr(o1) && is_valid_object_ptr(o2)) --> (return == true) */
  tmp_266 = (!tmp_268 || tmp_278);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 33,&tmp_266);
  groupExpr_313 = (tmp_266);
  o1_222_tmp_288 = o1_222;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 45,&o1_222_tmp_288);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[44]);

/* Evaluate is_nil_object_ptr(o1) */
  tmp_285 = is_nil_object_ptr(o1_222);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 44,&tmp_285);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[43]);

/* Evaluate is_nil_object_ptr(o1) && is_valid_object_ptr(o2) */
  tmp_284 = tmp_285;
  if (tmp_285) {
      o2_223_tmp_292 = o2_223;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 47,&o2_223_tmp_292);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[46]);

/* Evaluate is_valid_object_ptr(o2) */
  tmp_289 = is_valid_object_ptr(o2_223);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 46,&tmp_289);
    tmp_284 = tmp_289;
  }
  else {
  ADL__resetInfoStruct(ADL__VSis_equivalent_InfoArray, 46, 47);
  }
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 43,&tmp_284);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 49,&VSis_equivalent_RtnVal_205);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 50,&ADL__FALSE_CONST);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[48]);

/* Evaluate return == false */
  tmp_294 = ((VSis_equivalent_RtnVal_205 ? 1 : 0)==(ADL__FALSE_CONST ? 1 : 0));
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 48,&tmp_294);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[42]);

/* Evaluate (is_nil_object_ptr(o1) && is_valid_object_ptr(o2)) --> (return == false) */
  tmp_282 = (!tmp_284 || tmp_294);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 42,&tmp_282);
  groupExpr_314 = (tmp_282);
  o1_222_tmp_304 = o1_222;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 54,&o1_222_tmp_304);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[53]);

/* Evaluate is_valid_object_ptr(o1) */
  tmp_301 = is_valid_object_ptr(o1_222);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 53,&tmp_301);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[52]);

/* Evaluate is_valid_object_ptr(o1) && is_nil_object_ptr(o2) */
  tmp_300 = tmp_301;
  if (tmp_301) {
      o2_223_tmp_308 = o2_223;
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 56,&o2_223_tmp_308);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[55]);

/* Evaluate is_nil_object_ptr(o2) */
  tmp_305 = is_nil_object_ptr(o2_223);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 55,&tmp_305);
    tmp_300 = tmp_305;
  }
  else {
  ADL__resetInfoStruct(ADL__VSis_equivalent_InfoArray, 55, 56);
  }
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 52,&tmp_300);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 58,&VSis_equivalent_RtnVal_205);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 59,&ADL__FALSE_CONST);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[57]);

/* Evaluate return == false */
  tmp_310 = ((VSis_equivalent_RtnVal_205 ? 1 : 0)==(ADL__FALSE_CONST ? 1 : 0));
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 57,&tmp_310);
  ADL__VSis_equivalent_assertionReport->exprMark(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_assertionReport->assrt_info[51]);

/* Evaluate (is_valid_object_ptr(o1) && is_nil_object_ptr(o2)) --> (return == false) */
  tmp_298 = (!tmp_300 || tmp_310);
  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 51,&tmp_298);
  groupExpr_315 = (tmp_298);
  tmp_264 = (groupExpr_313 && groupExpr_314 && groupExpr_315);
  tmp_263 = tmp_264;
  }
  else {
    ADL__resetInfoStruct(ADL__VSis_equivalent_InfoArray, 32, 59);
  tmp_263 = 1;
}

  ADL__setResultAndError(ADL__VSis_equivalent_InfoArray, 32,&tmp_263);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSis_equivalent_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSis_equivalent_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSis_equivalent_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSis_equivalent_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSis_equivalent_InfoArray[forLoopIdx_1].level == 0))
        VSis_equivalent_ACF_Result_204 = calculate_ACF_result(VSis_equivalent_ACF_Result_204, ADL__VSis_equivalent_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSis_equivalent_assertionReport->value = VSis_equivalent_ACF_Result_204;
  ADL__VSis_equivalent_assertionReport->parent->openReport(ADL__VSis_equivalent_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSis_equivalent_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSis_equivalent_assertionReport->emitTest(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_InfoArray[forLoopIdx_1])) {
     ADL__VSis_equivalent_assertionReport->exprStart(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_InfoArray[forLoopIdx_1]);
      if(!ADL__VSis_equivalent_InfoArray[forLoopIdx_1].testable || !ADL__VSis_equivalent_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSis_equivalent_assertionReport->emitter);
      else if (ADL__VSis_equivalent_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSis_equivalent_InfoArray[forLoopIdx_1].error, ADL__VSis_equivalent_assertionReport->emitter);
      else
        ADL__VSis_equivalent_InfoArray[forLoopIdx_1].emitFunc(ADL__VSis_equivalent_InfoArray[forLoopIdx_1].value, ADL__VSis_equivalent_assertionReport->emitter);
     ADL__VSis_equivalent_assertionReport->exprEnd(ADL__VSis_equivalent_assertionReport, &ADL__VSis_equivalent_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSis_equivalent_RtnVal_205);
}


VSBoolean (*ADL__VSis_equivalent_wrapper)(VSObject_ptr*, VSObject_ptr*, VSEnvironment*) = VSis_equivalent;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSBoolean (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSis_equivalent_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "(!is_invalid_object_ptr(o1) && is_invalid_object_ptr(o2)) --> (system_exception_is(\"OBJECT_NOT_EXIST\", ev) && (return == false))", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "!is_invalid_object_ptr(o1) && is_invalid_object_ptr(o2)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "!is_invalid_object_ptr(o1)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 22, 21, 0, 0, "is_invalid_object_ptr(o1)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "o1", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {3, 24, 20, 0, 0, "is_invalid_object_ptr(o2)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 25, 24, 0, 0, "o2", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {3, 26, 19, 0, 0, "system_exception_is(\"OBJECT_NOT_EXIST\", ev) && (return == false)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 27, 26, 0, 0, "system_exception_is(\"OBJECT_NOT_EXIST\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 28, 27, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 29, 26, 0, 0, "return == false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean },
  {3, 31, 29, 0, 0, "false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 32, 32, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 33, 32, 0, 0, "(is_valid_object_ptr(o1) && is_valid_object_ptr(o2)) --> (return == true)", 33, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 34, 33, 0, 0, "is_valid_object_ptr(o1) && is_valid_object_ptr(o2)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 35, 34, 0, 0, "is_valid_object_ptr(o1)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 36, 35, 0, 0, "o1", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {5, 37, 34, 0, 0, "is_valid_object_ptr(o2)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 38, 37, 0, 0, "o2", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {5, 39, 33, 0, 0, "return == true", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 40, 39, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean },
  {5, 41, 39, 0, 0, "true", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 42, 32, 0, 0, "(is_nil_object_ptr(o1) && is_valid_object_ptr(o2)) --> (return == false)", 42, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 43, 42, 0, 0, "is_nil_object_ptr(o1) && is_valid_object_ptr(o2)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 44, 43, 0, 0, "is_nil_object_ptr(o1)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 45, 44, 0, 0, "o1", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {6, 46, 43, 0, 0, "is_valid_object_ptr(o2)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 47, 46, 0, 0, "o2", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {6, 48, 42, 0, 0, "return == false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 49, 48, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean },
  {6, 50, 48, 0, 0, "false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 51, 32, 0, 0, "(is_valid_object_ptr(o1) && is_nil_object_ptr(o2)) --> (return == false)", 51, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {7, 52, 51, 0, 0, "is_valid_object_ptr(o1) && is_nil_object_ptr(o2)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 53, 52, 0, 0, "is_valid_object_ptr(o1)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 54, 53, 0, 0, "o1", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {7, 55, 52, 0, 0, "is_nil_object_ptr(o2)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 56, 55, 0, 0, "o2", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {7, 57, 51, 0, 0, "return == false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {7, 58, 57, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean },
  {7, 59, 57, 0, 0, "false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean }
};


unsigned int ADL__VSis_equivalent_InfoArrayIdx = 60;

struct ADL__reportAssertion *ADL__VSis_equivalent_assertionReport = 0;

/*
 *
 * ACF of VSnon_existent
 *
 */
VSBoolean ADL__ACF_VSnon_existent (VSObject_ptr *o_335, VSEnvironment *ev_324){

VSBoolean VSnon_existent_RtnVal_318;
  void *dummyVarName_379;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_336;
  int tmp_338;
  int tmp_339;
  VSEnvironment *ev_324_tmp_343;
    int tmp_344;
  int tmp_346;
  int tmp_347;
  VSEnvironment *ev_324_tmp_350;
    int tmp_352;
  int tmp_353;
  VSObject_ptr *o_335_tmp_356;
  int tmp_358;
  int tmp_359;
  int tmp_360;
  VSEnvironment *ev_324_tmp_363;
  int tmp_365;
    int tmp_368;
  int tmp_369;
  int groupExpr_378;
  int tmp_371;
  int tmp_373;
  int tmp_374;
  VSObject_ptr *o_335_tmp_377;

/* Declare vars for result of normal and exception bindings */
  int VSnon_existent_NormalOutcome_319, VSnon_existent_ExceptionOutcome_320;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_321;
  VSEnvironment *ev_324_tmp_325;
    int tmp_326;
  int tmp_327;
  VSEnvironment *ev_324_tmp_330;
  int tmp_331;
  VSEnvironment *ev_324_tmp_334;
  enum ADL__ACF_result VSnon_existent_ACF_Result_317 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnon_existent_InfoArray, 0, ADL__VSnon_existent_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnon_existent_assertionReport->setPhase(ADL__VSnon_existent_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 28,&ADL__FALSE_CONST);
  
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnon_existent_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnon_existent_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnon_existent_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnon_existent_InfoArray[forLoopIdx_1].error > VSnon_existent_ACF_Result_317))
  VSnon_existent_ACF_Result_317 = ADL__VSnon_existent_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnon_existent_ACF_Result_317 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnon_existent_assertionReport->setPhase(ADL__VSnon_existent_assertionReport, PH_call);
  ADL__release(ADL__VSnon_existent_assertionReport->parent, &this_seq);
  VSnon_existent_RtnVal_318 = ADL__VSnon_existent_wrapper(o_335, ev_324);
  ADL__recover(ADL__VSnon_existent_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnon_existent_assertionReport->setPhase(ADL__VSnon_existent_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_324_tmp_325 = ev_324;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 8,&ev_324_tmp_325);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_321 = no_exception(ev_324);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 7,&tmp_321);
  VSnon_existent_NormalOutcome_319 = (tmp_321);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_324_tmp_330 = ev_324;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 3,&ev_324_tmp_330);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_327 = system_exception(ev_324);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 2,&tmp_327);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_326 = tmp_327;
  if (!tmp_327) {
      ev_324_tmp_334 = ev_324;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 5,&ev_324_tmp_334);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_331 = user_exception(ev_324);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 4,&tmp_331);
    tmp_326 = tmp_331;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnon_existent_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 1,&tmp_326);

  VSnon_existent_ExceptionOutcome_320 = (tmp_326);

/* Exception binding is the first assertion */
  if (ADL__VSnon_existent_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnon_existent_InfoArray[0].result = (VSnon_existent_ExceptionOutcome_320 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnon_existent_InfoArray[0].evaluated = 1;
  ADL__VSnon_existent_InfoArray[0].value = (VSnon_existent_ExceptionOutcome_320 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnon_existent_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnon_existent_InfoArray[6].result = (VSnon_existent_NormalOutcome_319 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnon_existent_InfoArray[6].evaluated = 1;
  ADL__VSnon_existent_InfoArray[6].value = (VSnon_existent_NormalOutcome_319 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnon_existent_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnon_existent_ACF_Result_317 = ADL__VSnon_existent_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnon_existent_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnon_existent_ACF_Result_317 = ADL__VSnon_existent_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnon_existent_ExceptionOutcome_320 && !VSnon_existent_NormalOutcome_319) {
  VSnon_existent_ACF_Result_317 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnon_existent_ExceptionOutcome_320 && VSnon_existent_NormalOutcome_319) {
  VSnon_existent_ACF_Result_317 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 10,&VSnon_existent_ExceptionOutcome_320);
  ev_324_tmp_343 = ev_324;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 13,&ev_324_tmp_343);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_339 = user_exception_is("NOT_IMPLEMENTED", ev_324);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 12,&tmp_339);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_338 = !tmp_339;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 11,&tmp_338);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_336 = (!VSnon_existent_ExceptionOutcome_320 || tmp_338);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 9,&tmp_336);
    ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 15,&VSnon_existent_ExceptionOutcome_320);
  ev_324_tmp_350 = ev_324;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 18,&ev_324_tmp_350);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_347 = user_exception(ev_324);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 17,&tmp_347);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_346 = !tmp_347;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 16,&tmp_346);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_344 = (!VSnon_existent_ExceptionOutcome_320 || tmp_346);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 14,&tmp_344);
    o_335_tmp_356 = o_335;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 21,&o_335_tmp_356);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[20]);

/* Evaluate is_valid_object_ptr(o) */
  tmp_353 = is_valid_object_ptr(o_335);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 20,&tmp_353);
  ev_324_tmp_363 = ev_324;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 25,&ev_324_tmp_363);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[24]);

/* Evaluate system_exception(ev) */
  tmp_360 = system_exception(ev_324);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 24,&tmp_360);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[23]);

/* Evaluate !system_exception(ev) */
  tmp_359 = !tmp_360;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 23,&tmp_359);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[22]);

/* Evaluate !system_exception(ev) && (return == false) */
  tmp_358 = tmp_359;
  if (tmp_359) {
      ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 27,&VSnon_existent_RtnVal_318);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 28,&ADL__FALSE_CONST);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[26]);

/* Evaluate return == false */
  tmp_365 = ((VSnon_existent_RtnVal_318 ? 1 : 0)==(ADL__FALSE_CONST ? 1 : 0));
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 26,&tmp_365);
    tmp_358 = tmp_365;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnon_existent_InfoArray, 26, 28);
  }
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 22,&tmp_358);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[19]);

/* Evaluate is_valid_object_ptr(o) --> (!system_exception(ev) && (return == false)) */
  tmp_352 = (!tmp_353 || tmp_358);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 19,&tmp_352);
    ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[29]);

/* Evaluate normally { ... } */
  if(VSnon_existent_NormalOutcome_319){
      ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 31,&VSnon_existent_RtnVal_318);
  o_335_tmp_377 = o_335;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 34,&o_335_tmp_377);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[33]);

/* Evaluate is_valid_object_ptr(o) */
  tmp_374 = is_valid_object_ptr(o_335);
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 33,&tmp_374);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[32]);

/* Evaluate !is_valid_object_ptr(o) */
  tmp_373 = !tmp_374;
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 32,&tmp_373);
  ADL__VSnon_existent_assertionReport->exprMark(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_assertionReport->assrt_info[30]);

/* Evaluate return == !is_valid_object_ptr(o) */
  tmp_371 = ((VSnon_existent_RtnVal_318 ? 1 : 0)==(tmp_373 ? 1 : 0));
  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 30,&tmp_371);
  groupExpr_378 = (tmp_371);
  tmp_369 = (groupExpr_378);
  tmp_368 = tmp_369;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnon_existent_InfoArray, 29, 34);
  tmp_368 = 1;
}

  ADL__setResultAndError(ADL__VSnon_existent_InfoArray, 29,&tmp_368);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnon_existent_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnon_existent_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnon_existent_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnon_existent_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnon_existent_InfoArray[forLoopIdx_1].level == 0))
        VSnon_existent_ACF_Result_317 = calculate_ACF_result(VSnon_existent_ACF_Result_317, ADL__VSnon_existent_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnon_existent_assertionReport->value = VSnon_existent_ACF_Result_317;
  ADL__VSnon_existent_assertionReport->parent->openReport(ADL__VSnon_existent_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnon_existent_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnon_existent_assertionReport->emitTest(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_InfoArray[forLoopIdx_1])) {
     ADL__VSnon_existent_assertionReport->exprStart(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnon_existent_InfoArray[forLoopIdx_1].testable || !ADL__VSnon_existent_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnon_existent_assertionReport->emitter);
      else if (ADL__VSnon_existent_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnon_existent_InfoArray[forLoopIdx_1].error, ADL__VSnon_existent_assertionReport->emitter);
      else
        ADL__VSnon_existent_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnon_existent_InfoArray[forLoopIdx_1].value, ADL__VSnon_existent_assertionReport->emitter);
     ADL__VSnon_existent_assertionReport->exprEnd(ADL__VSnon_existent_assertionReport, &ADL__VSnon_existent_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnon_existent_RtnVal_318);
}


VSBoolean (*ADL__VSnon_existent_wrapper)(VSObject_ptr*, VSEnvironment*) = VSnon_existent;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSBoolean (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnon_existent_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_valid_object_ptr(o) --> (!system_exception(ev) && (return == false))", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_valid_object_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {3, 22, 19, 0, 0, "!system_exception(ev) && (return == false)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 24, 23, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 25, 24, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 26, 22, 0, 0, "return == false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 27, 26, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean },
  {3, 28, 26, 0, 0, "false", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 29, 29, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 30, 29, 0, 0, "return == !is_valid_object_ptr(o)", 30, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 31, 30, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean },
  {5, 32, 30, 0, 0, "!is_valid_object_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 33, 32, 0, 0, "is_valid_object_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 34, 33, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P }
};


unsigned int ADL__VSnon_existent_InfoArrayIdx = 35;

struct ADL__reportAssertion *ADL__VSnon_existent_assertionReport = 0;

/*
 *
 * ACF of VShash
 *
 */
VSULong ADL__ACF_VShash (VSObject_ptr *o_398, VSULong mx_399, VSEnvironment *ev_387){

VSULong VShash_RtnVal_381;
  void *dummyVarName_379;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_400;
  int tmp_402;
  int tmp_403;
  VSEnvironment *ev_387_tmp_407;
    int tmp_408;
  int tmp_410;
  int tmp_411;
  VSEnvironment *ev_387_tmp_414;
    int tmp_415;
  int tmp_416;
  int groupExpr_423;
  int tmp_418;
  VSULong mx_399_tmp_422;

/* Declare vars for result of normal and exception bindings */
  int VShash_NormalOutcome_382, VShash_ExceptionOutcome_383;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_384;
  VSEnvironment *ev_387_tmp_388;
    int tmp_389;
  int tmp_390;
  VSEnvironment *ev_387_tmp_393;
  int tmp_394;
  VSEnvironment *ev_387_tmp_397;
  enum ADL__ACF_result VShash_ACF_Result_380 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VShash_InfoArray, 0, ADL__VShash_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VShash_assertionReport->setPhase(ADL__VShash_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VShash_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VShash_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VShash_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VShash_InfoArray[forLoopIdx_1].error > VShash_ACF_Result_380))
  VShash_ACF_Result_380 = ADL__VShash_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VShash_ACF_Result_380 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VShash_assertionReport->setPhase(ADL__VShash_assertionReport, PH_call);
  ADL__release(ADL__VShash_assertionReport->parent, &this_seq);
  VShash_RtnVal_381 = ADL__VShash_wrapper(o_398, mx_399, ev_387);
  ADL__recover(ADL__VShash_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VShash_assertionReport->setPhase(ADL__VShash_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_387_tmp_388 = ev_387;
  ADL__setResultAndError(ADL__VShash_InfoArray, 8,&ev_387_tmp_388);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_384 = no_exception(ev_387);
  ADL__setResultAndError(ADL__VShash_InfoArray, 7,&tmp_384);
  VShash_NormalOutcome_382 = (tmp_384);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_387_tmp_393 = ev_387;
  ADL__setResultAndError(ADL__VShash_InfoArray, 3,&ev_387_tmp_393);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_390 = system_exception(ev_387);
  ADL__setResultAndError(ADL__VShash_InfoArray, 2,&tmp_390);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_389 = tmp_390;
  if (!tmp_390) {
      ev_387_tmp_397 = ev_387;
  ADL__setResultAndError(ADL__VShash_InfoArray, 5,&ev_387_tmp_397);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_394 = user_exception(ev_387);
  ADL__setResultAndError(ADL__VShash_InfoArray, 4,&tmp_394);
    tmp_389 = tmp_394;
  }
  else {
  ADL__resetInfoStruct(ADL__VShash_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VShash_InfoArray, 1,&tmp_389);

  VShash_ExceptionOutcome_383 = (tmp_389);

/* Exception binding is the first assertion */
  if (ADL__VShash_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VShash_InfoArray[0].result = (VShash_ExceptionOutcome_383 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VShash_InfoArray[0].evaluated = 1;
  ADL__VShash_InfoArray[0].value = (VShash_ExceptionOutcome_383 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VShash_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VShash_InfoArray[6].result = (VShash_NormalOutcome_382 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VShash_InfoArray[6].evaluated = 1;
  ADL__VShash_InfoArray[6].value = (VShash_NormalOutcome_382 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VShash_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VShash_ACF_Result_380 = ADL__VShash_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VShash_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VShash_ACF_Result_380 = ADL__VShash_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VShash_ExceptionOutcome_383 && !VShash_NormalOutcome_382) {
  VShash_ACF_Result_380 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VShash_ExceptionOutcome_383 && VShash_NormalOutcome_382) {
  VShash_ACF_Result_380 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VShash_InfoArray, 10,&VShash_ExceptionOutcome_383);
  ev_387_tmp_407 = ev_387;
  ADL__setResultAndError(ADL__VShash_InfoArray, 13,&ev_387_tmp_407);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_403 = user_exception_is("NOT_IMPLEMENTED", ev_387);
  ADL__setResultAndError(ADL__VShash_InfoArray, 12,&tmp_403);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_402 = !tmp_403;
  ADL__setResultAndError(ADL__VShash_InfoArray, 11,&tmp_402);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_400 = (!VShash_ExceptionOutcome_383 || tmp_402);
  ADL__setResultAndError(ADL__VShash_InfoArray, 9,&tmp_400);
    ADL__setResultAndError(ADL__VShash_InfoArray, 15,&VShash_ExceptionOutcome_383);
  ev_387_tmp_414 = ev_387;
  ADL__setResultAndError(ADL__VShash_InfoArray, 18,&ev_387_tmp_414);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_411 = user_exception(ev_387);
  ADL__setResultAndError(ADL__VShash_InfoArray, 17,&tmp_411);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_410 = !tmp_411;
  ADL__setResultAndError(ADL__VShash_InfoArray, 16,&tmp_410);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_408 = (!VShash_ExceptionOutcome_383 || tmp_410);
  ADL__setResultAndError(ADL__VShash_InfoArray, 14,&tmp_408);
    ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VShash_NormalOutcome_382){
      ADL__setResultAndError(ADL__VShash_InfoArray, 21,&VShash_RtnVal_381);
  mx_399_tmp_422 = mx_399;
  ADL__setResultAndError(ADL__VShash_InfoArray, 22,&mx_399_tmp_422);
  ADL__VShash_assertionReport->exprMark(ADL__VShash_assertionReport, &ADL__VShash_assertionReport->assrt_info[20]);

/* Evaluate hash_value_is_good(return, mx) */
  tmp_418 = hash_value_is_good(VShash_RtnVal_381, mx_399);
  ADL__setResultAndError(ADL__VShash_InfoArray, 20,&tmp_418);
  groupExpr_423 = (tmp_418);
  tmp_416 = (groupExpr_423);
  tmp_415 = tmp_416;
  }
  else {
    ADL__resetInfoStruct(ADL__VShash_InfoArray, 19, 22);
  tmp_415 = 1;
}

  ADL__setResultAndError(ADL__VShash_InfoArray, 19,&tmp_415);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VShash_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VShash_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VShash_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VShash_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VShash_InfoArray[forLoopIdx_1].level == 0))
        VShash_ACF_Result_380 = calculate_ACF_result(VShash_ACF_Result_380, ADL__VShash_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VShash_assertionReport->value = VShash_ACF_Result_380;
  ADL__VShash_assertionReport->parent->openReport(ADL__VShash_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VShash_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VShash_assertionReport->emitTest(ADL__VShash_assertionReport, &ADL__VShash_InfoArray[forLoopIdx_1])) {
     ADL__VShash_assertionReport->exprStart(ADL__VShash_assertionReport, &ADL__VShash_InfoArray[forLoopIdx_1]);
      if(!ADL__VShash_InfoArray[forLoopIdx_1].testable || !ADL__VShash_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VShash_assertionReport->emitter);
      else if (ADL__VShash_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VShash_InfoArray[forLoopIdx_1].error, ADL__VShash_assertionReport->emitter);
      else
        ADL__VShash_InfoArray[forLoopIdx_1].emitFunc(ADL__VShash_InfoArray[forLoopIdx_1].value, ADL__VShash_assertionReport->emitter);
     ADL__VShash_assertionReport->exprEnd(ADL__VShash_assertionReport, &ADL__VShash_InfoArray[forLoopIdx_1]);
    }
  }

  return (VShash_RtnVal_381);
}


VSULong (*ADL__VShash_wrapper)(VSObject_ptr*, VSULong, VSEnvironment*) = VShash;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VShash_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "hash_value_is_good(return, mx)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {4, 22, 20, 0, 0, "mx", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong }
};


unsigned int ADL__VShash_InfoArrayIdx = 23;

struct ADL__reportAssertion *ADL__VShash_assertionReport = 0;
