/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_valid_object_ptr(VSObject_ptr *);

extern int is_same_object_ptr(VSObject_ptr *, VSObject_ptr *);

extern int cleanup_object_ptr(VSObject_ptr *);

extern int hash_value_is_good(VSULong, VSULong);

extern int is_valid_intdef(VSInterfaceDef_ptr *);

extern int strcmp(const char *, const char *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSInterfaceDef_ptr_P)(VSInterfaceDef_ptr*, emitter_t);
extern void (*ADL__print_VSChar_P)(VSChar*, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);

/* Declarations of wrapper of FUT */
extern VSObject_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSObject_ptr *(*ADL__VSduplicate_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSInterfaceDef_ptr *(*ADL__VSget_interface_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSis_a_wrapper)(VSObject_ptr*, VSChar*, VSEnvironment*);
extern VSBoolean (*ADL__VSis_equivalent_wrapper)(VSObject_ptr*, VSObject_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSnon_existent_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSULong (*ADL__VShash_wrapper)(VSObject_ptr*, VSULong, VSEnvironment*);

#endif
