/* ADL test driver from t1.tdr
 *
 * test VSmember_name(member_count, typecode, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_1016[] = {
    {"tvoid", Ptypecode_v_tvoid, 0},
    {"tshort", Ptypecode_v_tshort, 0},
    {"tlong", Ptypecode_v_tlong, 0},
    {"tushort", Ptypecode_v_tushort, 0},
    {"tulong", Ptypecode_v_tulong, 0},
    {"tfloat", Ptypecode_v_tfloat, 0},
    {"tdouble", Ptypecode_v_tdouble, 0},
    {"tboolean", Ptypecode_v_tboolean, 0},
    {"tchar", Ptypecode_v_tchar, 0},
    {"toctet", Ptypecode_v_toctet, 0},
    {"tany", Ptypecode_v_tany, 0},
    {"tTypeCode", Ptypecode_v_tTypeCode, 0},
    {"tPrincipal", Ptypecode_v_tPrincipal, 0},
    {"tobjref", Ptypecode_v_tobjref, 0},
    {"tstruct", Ptypecode_v_tstruct, 0},
    {"tunion", Ptypecode_v_tunion, 0},
    {"tenum", Ptypecode_v_tenum, 0},
    {"tstring", Ptypecode_v_tstring, 0},
    {"tsequence", Ptypecode_v_tsequence, 0},
    {"tarray", Ptypecode_v_tarray, 0},
    {"talias", Ptypecode_v_talias, 0},
    {"texcept", Ptypecode_v_texcept, 0},
    {0, 0, 0}
};

/* values for literal variable member_count */
static VSULong ADL__litvar_val_1018[] = {
    0,
    1,
};

static struct ADL__propertyValue ADL__litvar_info_1017[] = {
    {"0", 0, ADL__litvar_val_1018},
    {"1", 1, ADL__litvar_val_1018},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_1019[] = {
    {"member_count", "litvar", ADL__litvar_info_1017, 2},
    {"v", "prop", ADL__prop_values_1016, 22},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_1023[4] = {
    {"member_count", "VSULong", ADL__prop_info_1019, 0, 1},
    {"typecode", "VSTypeCode_ptr *", ADL__prop_info_1019, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_1019, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSmember_name_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSTYPECODE_PTR_P
#define ADL__PRINT_VSTYPECODE_PTR_P
void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSTCKIND
#define ADL__PRINT_VSTCKIND
void (*ADL__print_VSTCKind)(VSTCKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSTCKIND */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSCHAR_P
#define ADL__PRINT_VSCHAR_P
void (*ADL__print_VSChar_P)(VSChar*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCHAR_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSANY_P
#define ADL__PRINT_VSANY_P
void (*ADL__print_VSAny_P)(VSAny*, emitter_t) = 0;

#endif /* ADL__PRINT_VSANY_P */
#ifndef ADL__PRINT_VSLONG
#define ADL__PRINT_VSLONG
void (*ADL__print_VSLong)(VSLong, emitter_t) = 0;

#endif /* ADL__PRINT_VSLONG */

void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter)
{
  VSTypeCode_ptr *tmp;

  if (ADL__print_VSTypeCode_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSTypeCode_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSTCKind (void* val, emitter_t emitter)
{
  VSTCKind tmp;

  if (ADL__print_VSTCKind != 0) {
    tmp = *(VSTCKind*) val;
    ADL__print_VSTCKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSChar_P (void* val, emitter_t emitter)
{
  VSChar *tmp;

  if (ADL__print_VSChar_P != 0) {
    tmp = *(VSChar**) val;
    ADL__print_VSChar_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSAny_P (void* val, emitter_t emitter)
{
  VSAny *tmp;

  if (ADL__print_VSAny_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSAny_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSLong (void* val, emitter_t emitter)
{
  VSLong tmp;

  if (ADL__print_VSLong != 0) {
    tmp = *(VSLong*) val;
    ADL__print_VSLong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 22};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSULong member_count_1020;
    VSTypeCode_ptr *typecode_1021;
    VSEnvironment *env_1022;
    VSChar *fut_return_1015;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSmember_name_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSmember_name_InfoArrayIdx,
        ADL__VSmember_name_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       member_count_1020 = ADL__litvar_val_1018[tvec[0]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 0, tvec + 0, 1);
       ADL__emit_VSULong(&member_count_1020, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_typecode(&typecode_1021, ADL__prop_values_1016[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSTypeCode_ptr_P(&typecode_1021, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_1022)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_1022, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSmember_name_assertionReport = rf->assertionReport;
       fut_return_1015 = ADL__ACF_VSmember_name(member_count_1020, typecode_1021, env_1022);
       test_value = ADL__VSmember_name_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_1022);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_typecode(&typecode_1021, ADL__prop_values_1016[tvec[1]].propValCode);
SKIP_1:
       relvec[0] = 1;	/* relinquish succeeds for member_count_1020 */
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_1023,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSmember_name_head);

    return 0;
}


struct ADL__Directive_info VSmember_name1_info = {
    N_VARS,
    ADL__var_info_1023
};

struct ADL__TDD_info ADL__test_info = {
    44,
    &ADL__VSmember_name_InfoArrayIdx,
    ADL__VSmember_name_InfoArray,
    ADL__test_driver,
    "VSmember_name",
    "VSmember_name1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSmember_name1",
    "t1_tr.rif",
    &VSmember_name1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

