/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/pObjects/TypeCode/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:52  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.5  1997/09/08 11:39:17  cwatson
   Added the remaining TypeCode tests.

   Revision 1.4  1997/08/20 09:12:46  cwatson
   Added _nil and _duplicate tests.

   Revision 1.1  1997/08/06 14:39:59  cwatson
   *** empty log message ***

*/

#include <corba_defs.h>

extern VSTCKind VSkind(VSTypeCode_ptr *t, VSEnvironment *env);
extern VSBoolean VSequal(VSTypeCode_ptr *t1,VSTypeCode_ptr *t2, VSEnvironment *env);
extern VSChar *VSid(VSTypeCode_ptr *t, VSEnvironment *env);
extern VSChar *VSname(VSTypeCode_ptr *t, VSEnvironment *env);
extern VSULong VSmember_count(VSTypeCode_ptr *t, VSEnvironment *env);
extern VSChar *VSmember_name(VSULong i, VSTypeCode_ptr *t, VSEnvironment *env);
extern VSTypeCode_ptr *VSmember_type(VSULong i, VSTypeCode_ptr *t, VSEnvironment *env);

extern VSAny *VSmember_label(VSULong i, VSTypeCode_ptr *t, VSEnvironment *env);
extern VSTypeCode_ptr *VSdiscriminator_type(VSTypeCode_ptr *t, VSEnvironment *env);

extern VSLong VSdefault_index(VSTypeCode_ptr *t, VSEnvironment *env);
extern VSULong VSlength(VSTypeCode_ptr *t, VSEnvironment *env);
extern VSTypeCode_ptr *VScontent_type(VSTypeCode_ptr *t, VSEnvironment *env);

extern VSTypeCode_ptr *VSnil(VSEnvironment *env);
extern VSTypeCode_ptr *VSduplicate(VSTypeCode_ptr *o, VSEnvironment *env);

