/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSORB_init
 *
 */
VSORB_ptr ADL__ACF_VSORB_init (int* argc_26, char** argv_27, VSORBid oid_28, VSEnvironment *ev_14){

VSORB_ptr VSORB_init_RtnVal_3;
  void *dummyVarName_1;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_25;


/* Declare vars for tmp vars for assertions */
    int tmp_30;
  int tmp_32;
  int tmp_33;
  VSEnvironment *ev_14_tmp_37;
    int tmp_38;
  int tmp_39;
  int groupExpr_46;
  int groupExpr_47;
  int tmp_40;
  int tmp_43;

/* Declare vars for result of normal and exception bindings */
  int VSORB_init_NormalOutcome_4, VSORB_init_ExceptionOutcome_5;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_6;
  int tmp_8;
  int tmp_11;
  VSEnvironment *ev_14_tmp_15;
    int tmp_16;
  int tmp_18;
  int tmp_21;
  VSEnvironment *ev_14_tmp_24;
  enum ADL__ACF_result VSORB_init_ACF_Result_2 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSORB_init_InfoArray, 0, ADL__VSORB_init_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSORB_init_assertionReport->setPhase(ADL__VSORB_init_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_25 = 0; forLoopIdx_25 < ADL__VSORB_init_InfoArrayIdx; forLoopIdx_25++) {
  if (ADL__VSORB_init_InfoArray[forLoopIdx_25].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSORB_init_InfoArray[forLoopIdx_25].error > 1) && 
      (ADL__VSORB_init_InfoArray[forLoopIdx_25].error > VSORB_init_ACF_Result_2))
  VSORB_init_ACF_Result_2 = ADL__VSORB_init_InfoArray[forLoopIdx_25].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSORB_init_ACF_Result_2 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSORB_init_assertionReport->setPhase(ADL__VSORB_init_assertionReport, PH_call);
  ADL__release(ADL__VSORB_init_assertionReport->parent, &this_seq);
  VSORB_init_RtnVal_3 = ADL__VSORB_init_wrapper(argc_26, argv_27, oid_28, ev_14);
  ADL__recover(ADL__VSORB_init_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSORB_init_assertionReport->setPhase(ADL__VSORB_init_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ADL__setResultAndError(ADL__VSORB_init_InfoArray, 9,&VSORB_init_RtnVal_3);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[8]);

/* Evaluate return != 0 */
  tmp_8 = (VSORB_init_RtnVal_3 != 0);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 8,&tmp_8);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[7]);

/* Evaluate (return != 0) && no_exception(ev) */
  tmp_6 = tmp_8;
  if (tmp_8) {
      ev_14_tmp_15 = ev_14;
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 11,&ev_14_tmp_15);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[10]);

/* Evaluate no_exception(ev) */
  tmp_11 = no_exception(ev_14);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 10,&tmp_11);
    tmp_6 = tmp_11;
  }
  else {
  ADL__resetInfoStruct(ADL__VSORB_init_InfoArray, 10, 11);
  }
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 7,&tmp_6);
  VSORB_init_NormalOutcome_4 = (tmp_6);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ADL__setResultAndError(ADL__VSORB_init_InfoArray, 3,&VSORB_init_RtnVal_3);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[2]);

/* Evaluate return == 0 */
  tmp_18 = (VSORB_init_RtnVal_3 == 0);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 2,&tmp_18);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[1]);

/* Evaluate (return == 0) && system_exception(ev) */
  tmp_16 = tmp_18;
  if (tmp_18) {
      ev_14_tmp_24 = ev_14;
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 5,&ev_14_tmp_24);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[4]);

/* Evaluate system_exception(ev) */
  tmp_21 = system_exception(ev_14);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 4,&tmp_21);
    tmp_16 = tmp_21;
  }
  else {
  ADL__resetInfoStruct(ADL__VSORB_init_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 1,&tmp_16);

  VSORB_init_ExceptionOutcome_5 = (tmp_16);

/* Exception binding is the first assertion */
  if (ADL__VSORB_init_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSORB_init_InfoArray[0].result = (VSORB_init_ExceptionOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSORB_init_InfoArray[0].evaluated = 1;
  ADL__VSORB_init_InfoArray[0].value = (VSORB_init_ExceptionOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSORB_init_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSORB_init_InfoArray[6].result = (VSORB_init_NormalOutcome_4 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSORB_init_InfoArray[6].evaluated = 1;
  ADL__VSORB_init_InfoArray[6].value = (VSORB_init_NormalOutcome_4 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSORB_init_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSORB_init_ACF_Result_2 = ADL__VSORB_init_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSORB_init_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSORB_init_ACF_Result_2 = ADL__VSORB_init_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSORB_init_ExceptionOutcome_5 && !VSORB_init_NormalOutcome_4) {
  VSORB_init_ACF_Result_2 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSORB_init_ExceptionOutcome_5 && VSORB_init_NormalOutcome_4) {
  VSORB_init_ACF_Result_2 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSORB_init_InfoArray, 13,&VSORB_init_ExceptionOutcome_5);
  ev_14_tmp_37 = ev_14;
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 16,&ev_14_tmp_37);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[15]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_33 = user_exception_is("NOT_IMPLEMENTED", ev_14);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 15,&tmp_33);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[14]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 14,&tmp_32);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[12]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_30 = (!VSORB_init_ExceptionOutcome_5 || tmp_32);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 12,&tmp_30);
    ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[17]);

/* Evaluate normally { ... } */
  if(VSORB_init_NormalOutcome_4){
      ADL__setResultAndError(ADL__VSORB_init_InfoArray, 19,&VSORB_init_RtnVal_3);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[18]);

/* Evaluate test_orb_ptr(return) */
  tmp_40 = test_orb_ptr(VSORB_init_RtnVal_3);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 18,&tmp_40);
  groupExpr_46 = (tmp_40);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 21,&VSORB_init_RtnVal_3);
  ADL__VSORB_init_assertionReport->exprMark(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_assertionReport->assrt_info[20]);

/* Evaluate release_orb(return) */
  tmp_43 = release_orb(VSORB_init_RtnVal_3);
  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 20,&tmp_43);
  groupExpr_47 = (tmp_43);
  tmp_39 = (groupExpr_46 && groupExpr_47);
  tmp_38 = tmp_39;
  }
  else {
    ADL__resetInfoStruct(ADL__VSORB_init_InfoArray, 17, 21);
  tmp_38 = 1;
}

  ADL__setResultAndError(ADL__VSORB_init_InfoArray, 17,&tmp_38);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_25 = 0; forLoopIdx_25 < ADL__VSORB_init_InfoArrayIdx; forLoopIdx_25++) {

/* Calculate ACF result */
      if (ADL__VSORB_init_InfoArray[forLoopIdx_25].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSORB_init_InfoArray[forLoopIdx_25].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSORB_init_InfoArray[forLoopIdx_25].kind == ADL__CONSTANT && ADL__VSORB_init_InfoArray[forLoopIdx_25].level == 0))
        VSORB_init_ACF_Result_2 = calculate_ACF_result(VSORB_init_ACF_Result_2, ADL__VSORB_init_InfoArray[forLoopIdx_25].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSORB_init_assertionReport->value = VSORB_init_ACF_Result_2;
  ADL__VSORB_init_assertionReport->parent->openReport(ADL__VSORB_init_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_25 = 0; forLoopIdx_25 < ADL__VSORB_init_InfoArrayIdx; forLoopIdx_25++) {
    if(ADL__VSORB_init_assertionReport->emitTest(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_InfoArray[forLoopIdx_25])) {
     ADL__VSORB_init_assertionReport->exprStart(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_InfoArray[forLoopIdx_25]);
      if(!ADL__VSORB_init_InfoArray[forLoopIdx_25].testable || !ADL__VSORB_init_InfoArray[forLoopIdx_25].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSORB_init_assertionReport->emitter);
      else if (ADL__VSORB_init_InfoArray[forLoopIdx_25].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSORB_init_InfoArray[forLoopIdx_25].error, ADL__VSORB_init_assertionReport->emitter);
      else
        ADL__VSORB_init_InfoArray[forLoopIdx_25].emitFunc(ADL__VSORB_init_InfoArray[forLoopIdx_25].value, ADL__VSORB_init_assertionReport->emitter);
     ADL__VSORB_init_assertionReport->exprEnd(ADL__VSORB_init_assertionReport, &ADL__VSORB_init_InfoArray[forLoopIdx_25]);
    }
  }

  return (VSORB_init_RtnVal_3);
}


VSORB_ptr (*ADL__VSORB_init_wrapper)(int*, char**, VSORBid, VSEnvironment*) = VSORB_init;

void ADL__emit_int_P (void* val, emitter_t *emitter);
void ADL__emit_char_P_P (void* val, emitter_t *emitter);
void ADL__emit_VSORBid (void* val, emitter_t *emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t *emitter);
void ADL__emit_VSORB_ptr (void* val, emitter_t *emitter);

struct ADL__assertionReportStruct ADL__VSORB_init_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := (return == 0) && system_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "(return == 0) && system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSORB_ptr },
  {0, 4, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := (return != 0) && no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "(return != 0) && no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "return != 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 9, 8, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSORB_ptr },
  {0, 10, 7, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 11, 10, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 12, 12, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 12, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 14, 12, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 15, 14, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 16, 15, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 17, 17, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 18, 17, 0, 0, "test_orb_ptr(return)", 18, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 19, 18, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSORB_ptr },
  {4, 20, 17, 0, 0, "release_orb(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSORB_ptr }
};


unsigned int ADL__VSORB_init_InfoArrayIdx = 22;

struct ADL__reportAssertion *ADL__VSORB_init_assertionReport = 0;
