//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::AbstractBase has been defined");

  if (always_ret_0())
	{
		CORBA::AbstractBase& myClass();

		(void *)&myClass;
	}


  ::tet_infoline("The class CORBA::AbstractBase shall have a member ");
  ::tet_infoline("static AbstractBase_ptr _duplicate(CORBA::AbstractBase_ptr) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::AbstractBase_ptr myClass1;
		CORBA::AbstractBase_ptr p1_in;
		CORBA::AbstractBase_ptr ret1;
		ret1 = (myClass1->_duplicate)(p1_in);
	}  

  ::tet_infoline("The class CORBA::AbstractBase shall have a member ");
  ::tet_infoline("static AbstractBase_ptr _narrow(CORBA::AbstractBase_ptr) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::AbstractBase_ptr myClass2;
		CORBA::AbstractBase_ptr p2_in;
		CORBA::AbstractBase_ptr ret2;
		ret2 = (myClass2->_narrow)(p2_in);
	}


  ::tet_infoline("The class CORBA::AbstractBase shall have a member ");
  ::tet_infoline("static AbstractBase_ptr _nil() defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::AbstractBase_ptr myClass3;
		CORBA::AbstractBase_ptr ret3;
		ret3 = (myClass3->_nil)();
	}



    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
