//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/hdr/DII/NamedValue/name.cpp
//
// Purpose: Header file test for the attribute CORBA::NamedValue::name
//
// Modifications:
// $Log: name.cpp,v $
// Revision 1.2  2000/05/24 16:22:25  mli
//   o   void (*tet_startup)(void) -> void (*tet_startup)()
//   o   void (*tet_cleanup)(void) -> void (*tet_cleanup)()
//
// Revision 1.1.1.1  2000/02/09 17:15:01  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1997/11/20 14:43:38  ian
// Removed function ptr assignment.
//
//

#include <corba_supp.hh>
#include <tet_api.h>
 
volatile int vol = 0;
 
static int always_ret_0()
{
	return vol;
}

static void test1A()
{
	::tet_infoline("The read access function const char * name();");

	::tet_infoline("shall be defined for class CORBA::NamedValue.");

	if (always_ret_0())
	{
 		CORBA::NamedValue_var myObjRef;
 		const char * ret;

		ret = myObjRef->name();
	}


  ::tet_result(TET_PASS);
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

