//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{
  ::tet_infoline("The class DynamicAny::DynAny shall be defined.");

	DynamicAny::DynAny_var myInterface_var;
	(void *)&myInterface_var;

  ::tet_infoline("TEST: Assignment");

	if (always_ret_0())
	{
    DynamicAny::DynAny_var  myInterface_var1;
    DynamicAny::DynAny_var  myInterface_var2;

		myInterface_var1 = myInterface_var2;
	}

	::tet_infoline("TEST: Pointer construction");

  if (always_ret_0())
  {
    DynamicAny::DynAny *pmyInterface;

    DynamicAny::DynAny_var myInterface_var3(pmyInterface);
    (void *)&myInterface_var3;
  }

  ::tet_infoline("TEST: Pointer assignment");

  if (always_ret_0())
  {
    DynamicAny::DynAny *pmyInterface;

    DynamicAny::DynAny_var myInterface_var3 = pmyInterface;
    (void *)&myInterface_var3;
  }

  ::tet_infoline("TEST: Copy constructor");

  if (always_ret_0())
  {
    DynamicAny::DynAny_var  myInterface_var1;
    DynamicAny::DynAny_var  myInterface_var2(myInterface_var1);
		
		(void *)&myInterface_var2;
  }

	::tet_infoline("TEST: operator->");

	if (always_ret_0())
	{
    DynamicAny::DynAny_var myInterface_var;

		DynamicAny::DynAny *pc = myInterface_var.operator->();
	}

  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}

