//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

extern "C" {
static void test1A()
{
	::tet_infoline("The constant CORBA::PUBLIC_MEMBER");
	::tet_infoline("shall be defined to be of type CORBA::Visibility.");

	CORBA::Visibility c = CORBA::PUBLIC_MEMBER;



	CORBA::Visibility compare = (CORBA::Visibility)1;

  ::tet_infoline("TEST: value");
  if (CORBA::PUBLIC_MEMBER != compare)
  {
    ::tet_printf("ERROR: Expected value of CORBA::PUBLIC_MEMBER to be %d, is %d.", compare, CORBA::PUBLIC_MEMBER);

    ::tet_result(TET_FAIL);
    return;
  }



	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

