//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by GMD Fokus, Berlin.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	CORBA::ValueDef_var myObjRef;

	// declare an instance of the return type 
	CORBA::ContainedSeq *ret;

	// declare an instance of each parameter 
	const char * search_name = (const char *)0; // in 
	CORBA::Long levels_to_search = (CORBA::Long)0; // in 
	CORBA::DefinitionKind limit_type = (CORBA::DefinitionKind)0; // in 
	CORBA::Boolean exclude_inherited = (CORBA::Boolean)0; // in 

	::tet_infoline("The function CORBA::ValueDef::lookup_name");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("CORBA::ContainedSeq *CORBA::ValueDef::lookup_name(");
	::tet_infoline("const char *,");
	::tet_infoline("CORBA::Long,");
	::tet_infoline("CORBA::DefinitionKind,");
	::tet_infoline("CORBA::Boolean");
	::tet_infoline(");");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
		ret = 

			myObjRef->lookup_name(search_name, levels_to_search, limit_type, exclude_inherited );

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

