//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::ValueFactoryBase_var has been defined");

  if (always_ret_0())
	{
		CORBA::ValueFactoryBase_var myValueFactoryBase;

		(void *)&myValueFactoryBase;
	}


  ::tet_infoline("The class CORBA::ValueFactoryBase_var shall have a copy constructor.");

  if (always_ret_0())
	{
		CORBA::ValueFactoryBase_var myValueFactoryBase_var1;
		CORBA::ValueFactoryBase_var myValueFactoryBase_var2(myValueFactoryBase_var1);

		(void *)&myValueFactoryBase_var2;
	}

  ::tet_infoline("The class CORBA::ValueFactoryBase_var has an assignment operator of the form");
  ::tet_infoline(" ValueFactoryBase_var& operator=(ValueFactoryBase* p).");

	CORBA::ValueFactoryBase_var& (CORBA::ValueFactoryBase_var::*pf)(CORBA::ValueFactoryBase *) = NULL;

	pf = &CORBA::ValueFactoryBase_var::operator=;


  ::tet_infoline("The class CORBA::ValueFactoryBase_var has an assignment operator of the form");
  ::tet_infoline(" ValueFactoryBase_var& operator=(const CORBA::ValueFactoryBase_var&).");

	CORBA::ValueFactoryBase_var& (CORBA::ValueFactoryBase_var::*pf2)(const CORBA::ValueFactoryBase_var&) = NULL;

	pf2 = &CORBA::ValueFactoryBase_var::operator=;



    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
