//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class PortableServer::ValueRefCountBase has been defined");

  if (always_ret_0())
	{
		PortableServer::ValueRefCountBase& myValueRefCountBase();

		(void *)&myValueRefCountBase;
	}


  ::tet_infoline("The class PortableServer::ValueRefCountBase shall have a member ");
  ::tet_infoline("CORBA::ValueBase* _add_ref() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
// 	CORBA::ValueBase* (PortableServer::ValueRefCountBase::*pf5)() = NULL;
	CORBA::ValueBase* (PortableServer::ValueRefCountBase::ValueBase::*pf5)() = NULL;
// 	pf5 = &PortableServer::ValueRefCountBase::_add_ref;
	pf5 = &PortableServer::ValueRefCountBase::ValueBase::_add_ref;
  // There are no tests on the compatibility with a "_var" class!




  ::tet_infoline("The class PortableServer::ValueRefCountBase shall have a member ");
  ::tet_infoline("void _remove_ref() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (PortableServer::ValueRefCountBase::*pf6)() = NULL;
	pf6 = &PortableServer::ValueRefCountBase::_remove_ref;
  // There are no tests on the compatibility with a "_var" class!



  ::tet_infoline("The class PortableServer::ValueRefCountBase shall have a member ");
  ::tet_infoline("CORBA::ULong _ref_value() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::ULong (PortableServer::ValueRefCountBase::*pf7)() = NULL;
	pf7 = &PortableServer::ValueRefCountBase::_refcount_value;
  // There are no tests on the compatibility with a "_var" class!


    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
