//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::CustomMarshal has a constructor of the form");
  ::tet_infoline("CustomMarshal_var().");

  if (always_ret_0())
	{
		CORBA::CustomMarshal_var myCustomMarshal_var();

		(void *)&myCustomMarshal_var;
	}


  ::tet_infoline("The class CORBA::CustomMarshal shall have a member ");
  ::tet_infoline("void marshal( CORBA::DataOutputStream*) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::CustomMarshal::*pf)(CORBA::DataOutputStream*) = NULL;
	pf = &CORBA::CustomMarshal::marshal;

	if (always_ret_0())
	{
		CORBA::CustomMarshal_var myCustomMarshal1=NULL;
		CORBA::DataOutputStream_var p1;
		(void) (myCustomMarshal1->*pf)(p1);
	}
  

  ::tet_infoline("The class CORBA::CustomMarshal shall have a member ");
  ::tet_infoline("void unmarshal( CORBA::DataInputStream*) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::CustomMarshal::*pf2)(CORBA::DataInputStream*) = NULL;
	pf2 = &CORBA::CustomMarshal::unmarshal;

	if (always_ret_0())
	{
		CORBA::CustomMarshal_var myCustomMarshal1=NULL;
		CORBA::DataInputStream_var p2;
		(void) (myCustomMarshal1->*pf2)(p2);
	}
  

  ::tet_infoline("The class CORBA::CustomMarshal shall have a member ");
  ::tet_infoline("static CustomMarshal* _downcast(ValueBase* base) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::CustomMarshal_var myCustomMarshal3;
		CORBA::ValueBase* p3;
		CORBA::CustomMarshal* ret3;
		ret3 = (myCustomMarshal3->_downcast)(p3);
	}
  

    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
