//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::DataOutputStream has a constructor of the form");
  ::tet_infoline("DataOutputStream_var().");

  if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream_var();

		(void *)&myDataOutputStream_var;
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_any(any value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf)(const CORBA::Any &) = NULL;
	pf = &CORBA::DataOutputStream::write_any;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Any p1;
		(void)(myDataOutputStream1->*pf)(p1);
	}
  


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_boolean(boolean value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf2)(CORBA::Boolean) = NULL;
	pf2 = &CORBA::DataOutputStream::write_boolean;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Boolean p2;
		(void)(myDataOutputStream1->*pf2)(p2);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_char(CORBA::Char value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf3)(CORBA::Char) = NULL;
	pf3 = &CORBA::DataOutputStream::write_char;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Char p3;
		(void)(myDataOutputStream1->*pf3)(p3);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_wchar(CORBA::WChar value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf4)(CORBA::WChar) = NULL;
	pf4 = &CORBA::DataOutputStream::write_wchar;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::WChar p4;
		(void)(myDataOutputStream1->*pf4)(p4);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_octet(CORBA::Octet value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf5)(CORBA::Octet) = NULL;
	pf5 = &CORBA::DataOutputStream::write_octet;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Octet p5;
		(void)(myDataOutputStream1->*pf5)(p5);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_short(CORBA::Short value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf6)(CORBA::Short) = NULL;
	pf6 = &CORBA::DataOutputStream::write_short;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Short p6;
		(void)(myDataOutputStream1->*pf6)(p6);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_short(CORBA::UShort value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf7)(CORBA::UShort) = NULL;
	pf7 = &CORBA::DataOutputStream::write_ushort;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::UShort p7;
		(void)(myDataOutputStream1->*pf7)(p7);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_long(CORBA::Long value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf8)(CORBA::Long) = NULL;
	pf8 = &CORBA::DataOutputStream::write_long;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Long p8;
		(void)(myDataOutputStream1->*pf8)(p8);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_ulong(CORBA::ULong value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf9)(CORBA::ULong) = NULL;
	pf9 = &CORBA::DataOutputStream::write_ulong;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::ULong p9;
		(void)(myDataOutputStream1->*pf9)(p9);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_longlong(CORBA::LongLong value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf10)(CORBA::LongLong) = NULL;
	pf10 = &CORBA::DataOutputStream::write_longlong;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::LongLong p10;
		(void)(myDataOutputStream1->*pf10)(p10);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_ulonglong(CORBA::ULongLong value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf11)(CORBA::ULongLong) = NULL;
	pf11 = &CORBA::DataOutputStream::write_ulonglong;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::ULongLong p11;
		(void)(myDataOutputStream1->*pf11)(p11);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_float(CORBA::Float value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf12)(CORBA::Float) = NULL;
	pf12 = &CORBA::DataOutputStream::write_float;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Float p12;
		(void)(myDataOutputStream1->*pf12)(p12);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_double(CORBA::Double value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf13)(CORBA::Double) = NULL;
	pf13 = &CORBA::DataOutputStream::write_double;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Double p13;
		(void)(myDataOutputStream1->*pf13)(p13);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_longdouble(CORBA::LongDouble value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf14)(CORBA::LongDouble) = NULL;
	pf14 = &CORBA::DataOutputStream::write_longdouble;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::LongDouble p14;
		(void)(myDataOutputStream1->*pf14)(p14);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_string(const char* value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf15)(const char*) = NULL;
	pf15 = &CORBA::DataOutputStream::write_string;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		const char* p15;
		(void)(myDataOutputStream1->*pf15)(p15);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_wstring(const CORBA::WChar* value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf16)(const CORBA::WChar*) = NULL;
	pf16 = &CORBA::DataOutputStream::write_wstring;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		const CORBA::WChar* p16;
		(void)(myDataOutputStream1->*pf16)(p16);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_Object( CORBA::Object_ptr value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf17)( CORBA::Object_ptr) = NULL;
	pf17 = &CORBA::DataOutputStream::write_Object;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::Object_ptr p17;
		(void)(myDataOutputStream1->*pf17)(p17);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_Abstract( CORBA::AbstractBase_ptr value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf18)( CORBA::AbstractBase_ptr) = NULL;
	pf18 = &CORBA::DataOutputStream::write_Abstract;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::AbstractBase_ptr p18;
		(void)(myDataOutputStream1->*pf18)(p18);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_Value( CORBA::ValueBase* value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf19)( CORBA::ValueBase*) = NULL;
	pf19 = &CORBA::DataOutputStream::write_Value;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::ValueBase* p19;
		(void)(myDataOutputStream1->*pf19)(p19);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_TypeCode( CORBA::TypeCode_ptr value) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf20)( CORBA::TypeCode_ptr) = NULL;
	pf20 = &CORBA::DataOutputStream::write_TypeCode;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::TypeCode_ptr p20;
		(void)(myDataOutputStream1->*pf20)(p20);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_any_array(const CORBA::AnySeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf21)(const CORBA::AnySeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf21 = &CORBA::DataOutputStream::write_any_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::AnySeq p21;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf21)(p21,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_boolean_array(const CORBA::BooleanSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf22)(const CORBA::BooleanSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf22 = &CORBA::DataOutputStream::write_boolean_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::BooleanSeq p22;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf22)(p22,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_char_array(const CORBA::CharSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf23)(const CORBA::CharSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf23 = &CORBA::DataOutputStream::write_char_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::CharSeq p23;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf23)(p23,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_wchar_array(const CORBA::WCharSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf24)(const CORBA::WCharSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf24 = &CORBA::DataOutputStream::write_wchar_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::WCharSeq p24;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf24)(p24,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_octet_array(const CORBA::OctetSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf25)(const CORBA::OctetSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf25 = &CORBA::DataOutputStream::write_octet_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::OctetSeq p25;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf25)(p25,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_short_array(const CORBA::ShortSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf26)(const CORBA::ShortSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf26 = &CORBA::DataOutputStream::write_short_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::ShortSeq p26;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf26)(p26,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_ushort_array(const CORBA::UShortSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf27)(const CORBA::UShortSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf27 = &CORBA::DataOutputStream::write_ushort_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::UShortSeq p27;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf27)(p27,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_long_array(const CORBA::LongSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf28)(const CORBA::LongSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf28 = &CORBA::DataOutputStream::write_long_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::LongSeq p28;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf28)(p28,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_ulong_array(const CORBA::ULongSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf29)(const CORBA::ULongSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf29 = &CORBA::DataOutputStream::write_ulong_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::ULongSeq p29;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf29)(p29,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_ulonglong_array(const CORBA::ULongLongSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf30)(const CORBA::ULongLongSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf30 = &CORBA::DataOutputStream::write_ulonglong_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::ULongLongSeq p30;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf30)(p30,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_longlong_array(const CORBA::LongLongSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf31)(const CORBA::LongLongSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf31 = &CORBA::DataOutputStream::write_longlong_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::LongLongSeq p31;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf31)(p31,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_float_array(const CORBA::FloatSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf32)(const CORBA::FloatSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf32 = &CORBA::DataOutputStream::write_float_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::FloatSeq p32;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf32)(p32,index,index);
	}


  ::tet_infoline("The class CORBA::DataOutputStream shall have a member ");
  ::tet_infoline("void write_double_array(const CORBA::DoubleSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataOutputStream::*pf33)(const CORBA::DoubleSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf33 = &CORBA::DataOutputStream::write_double_array;

	if (always_ret_0())
	{
		CORBA::DataOutputStream_var myDataOutputStream1=NULL;
		CORBA::DoubleSeq p33;
		CORBA::ULong index;
		(void)(myDataOutputStream1->*pf33)(p33,index,index);
	}



    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
