/*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Developed for X/Open by ApTest Ireland Limited.
*
* Project: CORVAL2
*
*/

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; 

static int always_ret_0()
{
   return vol;
}

extern "C" {
static void test1A(void)
{
  ::tet_infoline("The class CORBA::Any shall have a constructor of the form");
  ::tet_infoline("Any( TypeCode_ptr tc, void *value, Boolean release = FALSE).");

  if (always_ret_0())
	{
		CORBA::Any myAny1(CORBA::TypeCode_ptr(NULL), (void *)NULL);
		CORBA::Any myAny2(CORBA::TypeCode_ptr(NULL), (void *)NULL, CORBA::Boolean(1));
		
		(void *)&myAny1;
		(void *)&myAny2;
	}
  
  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
