//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
// Purpose: Header file test for the type CORBA::Boolean
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

extern "C" {
static void test1A(void)
{
    CORBA::Boolean myboolean;

    ::tet_infoline("The type CORBA::Boolean shall be defined");
		::tet_infoline(" and shall hold the vales 0 and 1.");

    myboolean = (CORBA::Boolean)1;
		myboolean = (CORBA::Boolean)0;

    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
