//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//
// Purpose: Header file test for the function CORBA::string_dup
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

/*error messages formatted here*/
char ebuf[4096];

volatile int vol = 0; static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{
    char *mystring;

		char *(*func1)(const char *);

    tet_infoline("The function CORBA::string_dup shall be defined to be ");
    tet_infoline("char *string_dup(const char *);");

    
		func1 = CORBA::string_dup;

		if (always_ret_0())
			mystring = CORBA::string_dup("Hello World");
    
    tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
