//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

extern "C" {
static void test1A()
{
	CORBA::ORBid myORBid;
	char *BaseType;
	char **pBaseType;

	::tet_infoline("The type CORBA::ORBid shall be defined ");
	::tet_infoline("to be of type char *.");

	myORBid = 0;
	BaseType = 0;

	::tet_infoline("TEST: size");

	if (sizeof(CORBA::ORBid) != sizeof(char *)) {
		::tet_printf("ERROR: Expected size of CORBA::ORBid to be %d, is %d", 
			sizeof(char *), sizeof(CORBA::ORBid));

		::tet_result(TET_FAIL);
		return;
	}

	if (myORBid == BaseType)
		pBaseType = &myORBid;

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

