//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class siiServer_imp : public virtual POA_siiServer
{
  CORBA::Float Cucumber( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Cucumber(CORBA::Float _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Double Ginger( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Ginger(CORBA::Double _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Long Apricots( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Apricots(CORBA::Long _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::ULong BlackEyedBeans( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void BlackEyedBeans(CORBA::ULong _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Short Leek( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Leek(CORBA::Short _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::UShort Mint( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Mint(CORBA::UShort _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Char GardenPeas( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void GardenPeas(CORBA::Char _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Boolean Fig( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Fig(CORBA::Boolean _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Octet Asparagus( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Asparagus(CORBA::Octet _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  char * GaliaMelon( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void GaliaMelon(const char * _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  char * Sultana( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Sultana(const char * _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Object_ptr Turnip( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Turnip(CORBA::Object_ptr _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Any* Orange( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Orange(const CORBA::Any &_attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::TypeCode_ptr LoganBerry( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void LoganBerry(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Float Parsnip( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Double Celery( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Long WhiteCabbage( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::ULong Aniseed( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Short Bayleaf( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::UShort Dill( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Char Oregano( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Boolean Beansprout( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Octet Almonds( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  char * Guava( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  char * Mushroom( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Object_ptr Runnerbean( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Any* Tofu( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Prunes( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  ::EggPlant GrannySmith( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void GrannySmith(::EggPlant _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::Plum_slice * SweetPotato( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void SweetPotato(const ::Plum _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::Zucchini Billberries( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Billberries(const ::Zucchini &_attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::Avocado LolloRossa( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void LolloRossa(const ::Avocado &_attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::Lentil Sweetcorn( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Sweetcorn(const ::Lentil &_attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::EggPlant Shallots( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  ::Plum_slice * KidneyBean( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  ::Zucchini ButterBean( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  ::Avocado GoldenDelicous( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  ::Lentil CrabApple( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  CORBA::Long RedOnion( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void RedOnion(CORBA::Long _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Long HazelNut( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void HazelNut(CORBA::Long _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Long Cinnamon( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Cinnamon(CORBA::Long _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  CORBA::Long GooseBerry( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void GooseBerry(CORBA::Long _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::EggPlant JuniperBerries( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void JuniperBerries(::EggPlant _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::EggPlant Cloves( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Cloves(::EggPlant _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::EggPlant Daikan( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Daikan(::EggPlant _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
  ::EggPlant Mustard( VSORB_SRC_ENV2)
      throw(CORBA::SystemException);
  void Mustard(::EggPlant _attr VSORB_SRC_ENV)
      throw(CORBA::SystemException);
};

