//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Beansprout* BeansproutAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BeansproutAttr(const ::Beansprout &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Beansprout* BeansproutOp(const ::Beansprout &p1,::Beansprout_out p2,::Beansprout &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Almonds_slice * AlmondsAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void AlmondsAttr(const ::Almonds _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Almonds_slice * AlmondsOp(const ::Almonds p1,::Almonds_out p2,::Almonds p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Guava* GuavaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GuavaAttr(const ::Guava &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Guava* GuavaOp(const ::Guava &p1,::Guava_out p2,::Guava &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mushroom_slice * MushroomAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void MushroomAttr(const ::Mushroom _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mushroom_slice * MushroomOp(const ::Mushroom p1,::Mushroom_out p2,::Mushroom p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Runnerbean* RunnerbeanAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RunnerbeanAttr(const ::Runnerbean &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Runnerbean* RunnerbeanOp(const ::Runnerbean &p1,::Runnerbean_out p2,::Runnerbean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Tofu_slice * TofuAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void TofuAttr(const ::Tofu _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Tofu_slice * TofuOp(const ::Tofu p1,::Tofu_out p2,::Tofu p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Prunes* PrunesAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void PrunesAttr(const ::Prunes &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Prunes* PrunesOp(const ::Prunes &p1,::Prunes_out p2,::Prunes &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Brocoli_slice * BrocoliAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BrocoliAttr(const ::Brocoli _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Brocoli_slice * BrocoliOp(const ::Brocoli p1,::Brocoli_out p2,::Brocoli p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

