//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Scallion* ScallionAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ScallionAttr(const ::Scallion &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Scallion* ScallionOp(const ::Scallion &p1,::Scallion_out p2,::Scallion &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KiwanoMelon_slice * KiwanoMelonAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void KiwanoMelonAttr(const ::KiwanoMelon _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KiwanoMelon_slice * KiwanoMelonOp(const ::KiwanoMelon p1,::KiwanoMelon_out p2,::KiwanoMelon p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Celeriac* CeleriacAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void CeleriacAttr(const ::Celeriac &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Celeriac* CeleriacOp(const ::Celeriac &p1,::Celeriac_out p2,::Celeriac &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Clementine_slice * ClementineAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ClementineAttr(const ::Clementine _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Clementine_slice * ClementineOp(const ::Clementine p1,::Clementine_out p2,::Clementine p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Record* RecordAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RecordAttr(const ::Record &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Record* RecordOp(const ::Record &p1,::Record_out p2,::Record &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KerrsPinks_slice * KerrsPinksAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void KerrsPinksAttr(const ::KerrsPinks _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KerrsPinks_slice * KerrsPinksOp(const ::KerrsPinks p1,::KerrsPinks_out p2,::KerrsPinks p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::MarisPiper* MarisPiperAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void MarisPiperAttr(const ::MarisPiper &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::MarisPiper* MarisPiperOp(const ::MarisPiper &p1,::MarisPiper_out p2,::MarisPiper &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Banana1_slice * Banana1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Banana1Attr(const ::Banana1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Banana1_slice * Banana1Op(const ::Banana1 p1,::Banana1_out p2,::Banana1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

