//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Zucchini1_slice * Zucchini1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Zucchini1Attr(const ::Zucchini1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Zucchini1_slice * Zucchini1Op(const ::Zucchini1 p1,::Zucchini1_out p2,::Zucchini1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedOnion1* RedOnion1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RedOnion1Attr(const ::RedOnion1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedOnion1* RedOnion1Op(const ::RedOnion1 &p1,::RedOnion1_out p2,::RedOnion1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::JuniperBerries1_slice * JuniperBerries1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void JuniperBerries1Attr(const ::JuniperBerries1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::JuniperBerries1_slice * JuniperBerries1Op(const ::JuniperBerries1 p1,::JuniperBerries1_out p2,::JuniperBerries1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Tarragon1* Tarragon1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Tarragon1Attr(const ::Tarragon1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Tarragon1* Tarragon1Op(const ::Tarragon1 &p1,::Tarragon1_out p2,::Tarragon1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Elderberry1_slice * Elderberry1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Elderberry1Attr(const ::Elderberry1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Elderberry1_slice * Elderberry1Op(const ::Elderberry1 p1,::Elderberry1_out p2,::Elderberry1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Plantain1* Plantain1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Plantain1Attr(const ::Plantain1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Plantain1* Plantain1Op(const ::Plantain1 &p1,::Plantain1_out p2,::Plantain1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sharanfruit1_slice * Sharanfruit1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Sharanfruit1Attr(const ::Sharanfruit1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sharanfruit1_slice * Sharanfruit1Op(const ::Sharanfruit1 p1,::Sharanfruit1_out p2,::Sharanfruit1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Damsons1* Damsons1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Damsons1Attr(const ::Damsons1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Damsons1* Damsons1Op(const ::Damsons1 &p1,::Damsons1_out p2,::Damsons1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Eddo1_slice * Eddo1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Eddo1Attr(const ::Eddo1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Eddo1_slice * Eddo1Op(const ::Eddo1 p1,::Eddo1_out p2,::Eddo1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::CoxPippin1* CoxPippin1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void CoxPippin1Attr(const ::CoxPippin1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::CoxPippin1* CoxPippin1Op(const ::CoxPippin1 &p1,::CoxPippin1_out p2,::CoxPippin1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KiwanoMelon1_slice * KiwanoMelon1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void KiwanoMelon1Attr(const ::KiwanoMelon1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KiwanoMelon1_slice * KiwanoMelon1Op(const ::KiwanoMelon1 p1,::KiwanoMelon1_out p2,::KiwanoMelon1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedCabbage1* RedCabbage1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RedCabbage1Attr(const ::RedCabbage1 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedCabbage1* RedCabbage1Op(const ::RedCabbage1 &p1,::RedCabbage1_out p2,::RedCabbage1 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Pimpernel1_slice * Pimpernel1Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Pimpernel1Attr(const ::Pimpernel1 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Pimpernel1_slice * Pimpernel1Op(const ::Pimpernel1 p1,::Pimpernel1_out p2,::Pimpernel1 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BlackCherry2* BlackCherry2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BlackCherry2Attr(const ::BlackCherry2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BlackCherry2* BlackCherry2Op(const ::BlackCherry2 &p1,::BlackCherry2_out p2,::BlackCherry2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Cucumber2* Cucumber2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Cucumber2Attr(const ::Cucumber2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Cucumber2* Cucumber2Op(const ::Cucumber2 &p1,::Cucumber2_out p2,::Cucumber2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

