//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:29  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1999/05/04 12:06:59  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.4  1997/12/09 11:27:23  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetParsnip2(::Parsnip2 );
int CheckParsnip2(const ::Parsnip2 );
void GetPrunes2(::Prunes2 &);
int CheckPrunes2(const ::Prunes2 &);
void GetPlum2(::Plum2 );
int CheckPlum2(const ::Plum2 );
void GetEggPlant2(::EggPlant2 &);
int CheckEggPlant2(const ::EggPlant2 &);
void GetMustard2(::Mustard2 &);
int CheckMustard2(const ::Mustard2 &);
void GetElderberry2(::Elderberry2 );
int CheckElderberry2(const ::Elderberry2 );
void GetRedPepper2(::RedPepper2 &);
int CheckRedPepper2(const ::RedPepper2 &);
void GetArtichokes2(::Artichokes2 );
int CheckArtichokes2(const ::Artichokes2 );
void GetKiwanoMelon2(::KiwanoMelon2 );
int CheckKiwanoMelon2(const ::KiwanoMelon2 );
void GetBritishQueens2(::BritishQueens2 &);
int CheckBritishQueens2(const ::BritishQueens2 &);
void GetStarfruit3(::Starfruit3 );
int CheckStarfruit3(const ::Starfruit3 );
void GetParsnip3(::Parsnip3 );
int CheckParsnip3(const ::Parsnip3 );
void GetBillberries3(::Billberries3 &);
int CheckBillberries3(const ::Billberries3 &);
void GetGooseBerry3(::GooseBerry3 );
int CheckGooseBerry3(const ::GooseBerry3 );
void GetElderberry3(::Elderberry3 );
int CheckElderberry3(const ::Elderberry3 );
void GetidlServerParsnip2Excpt(::idlServer::Parsnip2Excpt &);
int CheckidlServerParsnip2Excpt(const ::idlServer::Parsnip2Excpt &);
void GetidlServerPrunes2Excpt(::idlServer::Prunes2Excpt &);
int CheckidlServerPrunes2Excpt(const ::idlServer::Prunes2Excpt &);
void GetidlServerPlum2Excpt(::idlServer::Plum2Excpt &);
int CheckidlServerPlum2Excpt(const ::idlServer::Plum2Excpt &);
void GetidlServerEggPlant2Excpt(::idlServer::EggPlant2Excpt &);
int CheckidlServerEggPlant2Excpt(const ::idlServer::EggPlant2Excpt &);
void GetidlServerMustard2Excpt(::idlServer::Mustard2Excpt &);
int CheckidlServerMustard2Excpt(const ::idlServer::Mustard2Excpt &);
void GetidlServerElderberry2Excpt(::idlServer::Elderberry2Excpt &);
int CheckidlServerElderberry2Excpt(const ::idlServer::Elderberry2Excpt &);
void GetidlServerRedPepper2Excpt(::idlServer::RedPepper2Excpt &);
int CheckidlServerRedPepper2Excpt(const ::idlServer::RedPepper2Excpt &);
void GetidlServerArtichokes2Excpt(::idlServer::Artichokes2Excpt &);
int CheckidlServerArtichokes2Excpt(const ::idlServer::Artichokes2Excpt &);
void GetidlServerKiwanoMelon2Excpt(::idlServer::KiwanoMelon2Excpt &);
int CheckidlServerKiwanoMelon2Excpt(const ::idlServer::KiwanoMelon2Excpt &);
void GetidlServerBritishQueens2Excpt(::idlServer::BritishQueens2Excpt &);
int CheckidlServerBritishQueens2Excpt(const ::idlServer::BritishQueens2Excpt &);
void GetidlServerStarfruit3Excpt(::idlServer::Starfruit3Excpt &);
int CheckidlServerStarfruit3Excpt(const ::idlServer::Starfruit3Excpt &);
void GetidlServerParsnip3Excpt(::idlServer::Parsnip3Excpt &);
int CheckidlServerParsnip3Excpt(const ::idlServer::Parsnip3Excpt &);
void GetidlServerBillberries3Excpt(::idlServer::Billberries3Excpt &);
int CheckidlServerBillberries3Excpt(const ::idlServer::Billberries3Excpt &);
void GetidlServerGooseBerry3Excpt(::idlServer::GooseBerry3Excpt &);
int CheckidlServerGooseBerry3Excpt(const ::idlServer::GooseBerry3Excpt &);
void GetidlServerElderberry3Excpt(::idlServer::Elderberry3Excpt &);
int CheckidlServerElderberry3Excpt(const ::idlServer::Elderberry3Excpt &);



