//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class TestServer_imp : public virtual POA_TestServer
{
  ::LoganBerry19 LoganBerry19Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void LoganBerry19Attr(const ::LoganBerry19 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::LoganBerry19 LoganBerry19Op(const ::LoganBerry19 &p1,::LoganBerry19_out p2,::LoganBerry19 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Orange19 Orange19Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Orange19Attr(const ::Orange19 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Orange19 Orange19Op(const ::Orange19 &p1,::Orange19_out p2,::Orange19 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BlackCherry20 BlackCherry20Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BlackCherry20Attr(const ::BlackCherry20 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BlackCherry20 BlackCherry20Op(const ::BlackCherry20 &p1,::BlackCherry20_out p2,::BlackCherry20 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lemon20 Lemon20Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Lemon20Attr(const ::Lemon20 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lemon20 Lemon20Op(const ::Lemon20 &p1,::Lemon20_out p2,::Lemon20 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Coconut6_slice * Coconut6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Coconut6Attr(const ::Coconut6 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Coconut6_slice * Coconut6Op(const ::Coconut6 p1,::Coconut6_out p2,::Coconut6 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lime6 Lime6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Lime6Attr(const ::Lime6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lime6 Lime6Op(const ::Lime6 &p1,::Lime6 &p2,::Lime6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mint6_slice * Mint6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Mint6Attr(const ::Mint6 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mint6_slice * Mint6Op(const ::Mint6 p1,::Mint6_out p2,::Mint6 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BlackEyedBeans6* BlackEyedBeans6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BlackEyedBeans6Attr(const ::BlackEyedBeans6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BlackEyedBeans6* BlackEyedBeans6Op(const ::BlackEyedBeans6 &p1,::BlackEyedBeans6_out p2,::BlackEyedBeans6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mangetout6* Mangetout6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Mangetout6Attr(const ::Mangetout6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mangetout6* Mangetout6Op(const ::Mangetout6 &p1,::Mangetout6_out p2,::Mangetout6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lettuce6* Lettuce6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Lettuce6Attr(const ::Lettuce6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lettuce6* Lettuce6Op(const ::Lettuce6 &p1,::Lettuce6_out p2,::Lettuce6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chervil6_slice * Chervil6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Chervil6Attr(const ::Chervil6 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chervil6_slice * Chervil6Op(const ::Chervil6 p1,::Chervil6_out p2,::Chervil6 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Blueberry6* Blueberry6Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Blueberry6Attr(const ::Blueberry6 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Blueberry6* Blueberry6Op(const ::Blueberry6 &p1,::Blueberry6_out p2,::Blueberry6 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Turnip7* Turnip7Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Turnip7Attr(const ::Turnip7 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Turnip7* Turnip7Op(const ::Turnip7 &p1,::Turnip7_out p2,::Turnip7 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sultana7* Sultana7Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Sultana7Attr(const ::Sultana7 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sultana7* Sultana7Op(const ::Sultana7 &p1,::Sultana7_out p2,::Sultana7 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

