//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:31  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/05/04 12:07:01  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 08:51:05  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetLoganBerry19(::LoganBerry19 &);
int CheckLoganBerry19(const ::LoganBerry19 &);
void GetOrange19(::Orange19 &);
int CheckOrange19(const ::Orange19 &);
void GetBlackCherry20(::BlackCherry20 &);
int CheckBlackCherry20(const ::BlackCherry20 &);
void GetLemon20(::Lemon20 &);
int CheckLemon20(const ::Lemon20 &);
void GetCoconut6(::Coconut6 );
int CheckCoconut6(const ::Coconut6 );
void GetLime6(::Lime6 &);
int CheckLime6(const ::Lime6 &);
void GetMint6(::Mint6 );
int CheckMint6(const ::Mint6 );
void GetBlackEyedBeans6(::BlackEyedBeans6 &);
int CheckBlackEyedBeans6(const ::BlackEyedBeans6 &);
void GetMangetout6(::Mangetout6 &);
int CheckMangetout6(const ::Mangetout6 &);
void GetLettuce6(::Lettuce6 &);
int CheckLettuce6(const ::Lettuce6 &);
void GetChervil6(::Chervil6 );
int CheckChervil6(const ::Chervil6 );
void GetBlueberry6(::Blueberry6 &);
int CheckBlueberry6(const ::Blueberry6 &);
void GetTurnip7(::Turnip7 &);
int CheckTurnip7(const ::Turnip7 &);
void GetSultana7(::Sultana7 &);
int CheckSultana7(const ::Sultana7 &);
void GetTestServerLoganBerry19Excpt(::TestServer::LoganBerry19Excpt &);
int CheckTestServerLoganBerry19Excpt(const ::TestServer::LoganBerry19Excpt &);
void GetTestServerOrange19Excpt(::TestServer::Orange19Excpt &);
int CheckTestServerOrange19Excpt(const ::TestServer::Orange19Excpt &);
void GetTestServerBlackCherry20Excpt(::TestServer::BlackCherry20Excpt &);
int CheckTestServerBlackCherry20Excpt(const ::TestServer::BlackCherry20Excpt &);
void GetTestServerLemon20Excpt(::TestServer::Lemon20Excpt &);
int CheckTestServerLemon20Excpt(const ::TestServer::Lemon20Excpt &);
void GetTestServerCoconut6Excpt(::TestServer::Coconut6Excpt &);
int CheckTestServerCoconut6Excpt(const ::TestServer::Coconut6Excpt &);
void GetTestServerLime6Excpt(::TestServer::Lime6Excpt &);
int CheckTestServerLime6Excpt(const ::TestServer::Lime6Excpt &);
void GetTestServerMint6Excpt(::TestServer::Mint6Excpt &);
int CheckTestServerMint6Excpt(const ::TestServer::Mint6Excpt &);
void GetTestServerBlackEyedBeans6Excpt(::TestServer::BlackEyedBeans6Excpt &);
int CheckTestServerBlackEyedBeans6Excpt(const ::TestServer::BlackEyedBeans6Excpt &);
void GetTestServerMangetout6Excpt(::TestServer::Mangetout6Excpt &);
int CheckTestServerMangetout6Excpt(const ::TestServer::Mangetout6Excpt &);
void GetTestServerLettuce6Excpt(::TestServer::Lettuce6Excpt &);
int CheckTestServerLettuce6Excpt(const ::TestServer::Lettuce6Excpt &);
void GetTestServerChervil6Excpt(::TestServer::Chervil6Excpt &);
int CheckTestServerChervil6Excpt(const ::TestServer::Chervil6Excpt &);
void GetTestServerBlueberry6Excpt(::TestServer::Blueberry6Excpt &);
int CheckTestServerBlueberry6Excpt(const ::TestServer::Blueberry6Excpt &);
void GetTestServerTurnip7Excpt(::TestServer::Turnip7Excpt &);
int CheckTestServerTurnip7Excpt(const ::TestServer::Turnip7Excpt &);
void GetTestServerSultana7Excpt(::TestServer::Sultana7Excpt &);
int CheckTestServerSultana7Excpt(const ::TestServer::Sultana7Excpt &);



