//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:33  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.7  1999/05/04 12:07:04  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.6  1998/08/24 11:46:43  james
// ENV updates
//
// Revision 1.5  1997/12/12 08:58:04  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetRadish22(::Radish22 &);
int CheckRadish22(const ::Radish22 &);
void GetSharanfruit22(::Sharanfruit22 &);
int CheckSharanfruit22(const ::Sharanfruit22 &);
void GetTarragon23(::Tarragon23 );
int CheckTarragon23(const ::Tarragon23 );
void GetButterBean24(::ButterBean24 &);
int CheckButterBean24(const ::ButterBean24 &);
void GetZucchini24(::Zucchini24 &);
int CheckZucchini24(const ::Zucchini24 &);
void GetZucchini24Plum24(::Zucchini24::Plum24 &);
int CheckZucchini24Plum24(const ::Zucchini24::Plum24 &);
void GetDill25(::Dill25 &);
int CheckDill25(const ::Dill25 &);
void GetBayleaf25(::Bayleaf25 &);
int CheckBayleaf25(const ::Bayleaf25 &);
void GetBayleaf25WhiteCabbage25(::Bayleaf25::WhiteCabbage25 &);
int CheckBayleaf25WhiteCabbage25(const ::Bayleaf25::WhiteCabbage25 &);
void GetWaterMelon26(::WaterMelon26 &);
int CheckWaterMelon26(const ::WaterMelon26 &);
void GetMango26(::Mango26 &);
int CheckMango26(const ::Mango26 &);
void GetMango26PassionFruit26(::Mango26::PassionFruit26 &);
int CheckMango26PassionFruit26(const ::Mango26::PassionFruit26 &);
void GetRecord26(::Record26 &);
int CheckRecord26(const ::Record26 &);
void GetPotato26(::Potato26 &);
int CheckPotato26(const ::Potato26 &);
void GetPotato26ChineseLeaves26(::Potato26::ChineseLeaves26 &);
int CheckPotato26ChineseLeaves26(const ::Potato26::ChineseLeaves26 &);
void GetBlackberry27(::Blackberry27 &);
int CheckBlackberry27(const ::Blackberry27 &);
void GetBlueberry27(::Blueberry27 &);
int CheckBlueberry27(const ::Blueberry27 &);
void GetBlueberry27Basil27(::Blueberry27::Basil27 &);
int CheckBlueberry27Basil27(const ::Blueberry27::Basil27 &);
void GetGrapefruit28(::Grapefruit28 &);
int CheckGrapefruit28(const ::Grapefruit28 &);
void GetRaspberry28(::Raspberry28 &);
int CheckRaspberry28(const ::Raspberry28 &);
void GetRaspberry28Peppercorn28(::Raspberry28::Peppercorn28 &);
int CheckRaspberry28Peppercorn28(const ::Raspberry28::Peppercorn28 &);
void GetKumquats29(::Kumquats29 &);
int CheckKumquats29(const ::Kumquats29 &);
void GetElderberry29(::Elderberry29 &);
int CheckElderberry29(const ::Elderberry29 &);
void GetElderberry29RedGrapes29(::Elderberry29::RedGrapes29 &);
int CheckElderberry29RedGrapes29(const ::Elderberry29::RedGrapes29 &);
void GetRedOnion30(::RedOnion30 &);
int CheckRedOnion30(const ::RedOnion30 &);
void GetCrabApple30(::CrabApple30 &);
int CheckCrabApple30(const ::CrabApple30 &);
void GetCrabApple30Lentil30(::CrabApple30::Lentil30 &);
int CheckCrabApple30Lentil30(const ::CrabApple30::Lentil30 &);
void GetRunnerbean31(::Runnerbean31 &);
int CheckRunnerbean31(const ::Runnerbean31 &);
void GetMushroom31(::Mushroom31 &);
int CheckMushroom31(const ::Mushroom31 &);
void GetMushroom31Almonds31(::Mushroom31::Almonds31 &);
int CheckMushroom31Almonds31(const ::Mushroom31::Almonds31 &);
void GetCucumber32(::Cucumber32 &);
int CheckCucumber32(const ::Cucumber32 &);
void GetCabbage32(::Cabbage32 &);
int CheckCabbage32(const ::Cabbage32 &);
void GetCabbage32Coconut32(::Cabbage32::Coconut32 &);
int CheckCabbage32Coconut32(const ::Cabbage32::Coconut32 &);
void GetGoldenWonder32(::GoldenWonder32 &);
int CheckGoldenWonder32(const ::GoldenWonder32 &);
void GetKerrsPinks32(::KerrsPinks32 &);
int CheckKerrsPinks32(const ::KerrsPinks32 &);
void GetKerrsPinks32Wilja32(::KerrsPinks32::Wilja32 &);
int CheckKerrsPinks32Wilja32(const ::KerrsPinks32::Wilja32 &);
void GetCurrant33(::Currant33 &);
int CheckCurrant33(const ::Currant33 &);
void GetPricklyPear33(::PricklyPear33 &);
int CheckPricklyPear33(const ::PricklyPear33 &);
void GetPricklyPear33VineTomatoes33(::PricklyPear33::VineTomatoes33 &);
int CheckPricklyPear33VineTomatoes33(const ::PricklyPear33::VineTomatoes33 &);
void GetGreenGrapes34(::GreenGrapes34 &);
int CheckGreenGrapes34(const ::GreenGrapes34 &);
void GetArtichokes34(::Artichokes34 &);
int CheckArtichokes34(const ::Artichokes34 &);
void GetArtichokes34Peanutsquash34(::Artichokes34::Peanutsquash34 &);
int CheckArtichokes34Peanutsquash34(const ::Artichokes34::Peanutsquash34 &);
void GetBeetroot35(::Beetroot35 &);
int CheckBeetroot35(const ::Beetroot35 &);
void GetChickpea35(::Chickpea35 &);
int CheckChickpea35(const ::Chickpea35 &);
void GetChickpea35Uglifruit35(::Chickpea35::Uglifruit35 &);
int CheckChickpea35Uglifruit35(const ::Chickpea35::Uglifruit35 &);
void GetCloves36(::Cloves36 &);
int CheckCloves36(const ::Cloves36 &);
void GetJuniperBerries36(::JuniperBerries36 &);
int CheckJuniperBerries36(const ::JuniperBerries36 &);
void GetJuniperBerries36GooseBerry36(::JuniperBerries36::GooseBerry36 &);
int CheckJuniperBerries36GooseBerry36(const ::JuniperBerries36::GooseBerry36 &);
void GetSweetPotato37(::SweetPotato37 &);
int CheckSweetPotato37(const ::SweetPotato37 &);
void GetBrazilNut37(::BrazilNut37 &);
int CheckBrazilNut37(const ::BrazilNut37 &);
void GetBrazilNut37Brocoli37(::BrazilNut37::Brocoli37 &);
int CheckBrazilNut37Brocoli37(const ::BrazilNut37::Brocoli37 &);
void GetGardenPeas38(::GardenPeas38 &);
int CheckGardenPeas38(const ::GardenPeas38 &);
void GetMint38(::Mint38 &);
int CheckMint38(const ::Mint38 &);
void GetMint38BlackEyedBeans38(::Mint38::BlackEyedBeans38 &);
int CheckMint38BlackEyedBeans38(const ::Mint38::BlackEyedBeans38 &);
void GetKingEdward38(::KingEdward38 &);
int CheckKingEdward38(const ::KingEdward38 &);
void GetCara38(::Cara38 &);
int CheckCara38(const ::Cara38 &);
void GetCara38Rooster38(::Cara38::Rooster38 &);
int CheckCara38Rooster38(const ::Cara38::Rooster38 &);
void GetPippinApple39(::PippinApple39 &);
int CheckPippinApple39(const ::PippinApple39 &);
void GetChayato39(::Chayato39 &);
int CheckChayato39(const ::Chayato39 &);
void GetChayato39KiwanoMelon39(::Chayato39::KiwanoMelon39 &);
int CheckChayato39KiwanoMelon39(const ::Chayato39::KiwanoMelon39 &);
void GetYam40(::Yam40 &);
int CheckYam40(const ::Yam40 &);
void GetEddo40(::Eddo40 &);
int CheckEddo40(const ::Eddo40 &);
void GetEddo40Chives40(::Eddo40::Chives40 &);
int CheckEddo40Chives40(const ::Eddo40::Chives40 &);
void GetMangosteen41(::Mangosteen41 &);
int CheckMangosteen41(const ::Mangosteen41 &);
void GetLimaBean41(::LimaBean41 &);
int CheckLimaBean41(const ::LimaBean41 &);
void GetLimaBean41Blackcurrant41(::LimaBean41::Blackcurrant41 &);
int CheckLimaBean41Blackcurrant41(const ::LimaBean41::Blackcurrant41 &);
void GetSweedes42(::Sweedes42 &);
int CheckSweedes42(const ::Sweedes42 &);
void GetThyme42(::Thyme42 &);
int CheckThyme42(const ::Thyme42 &);
void GetThyme42Strawberry42(::Thyme42::Strawberry42 &);
int CheckThyme42Strawberry42(const ::Thyme42::Strawberry42 &);
void GetSweetcorn43(::Sweetcorn43 &);
int CheckSweetcorn43(const ::Sweetcorn43 &);
void GetRowanBerry43(::RowanBerry43 &);
int CheckRowanBerry43(const ::RowanBerry43 &);
void GetRowanBerry43CantelopeMelon43(::RowanBerry43::CantelopeMelon43 &);
int CheckRowanBerry43CantelopeMelon43(const ::RowanBerry43::CantelopeMelon43 &);
void GetidlServerRadish22Excpt(::idlServer::Radish22Excpt &);
int CheckidlServerRadish22Excpt(const ::idlServer::Radish22Excpt &);
void GetidlServerSharanfruit22Excpt(::idlServer::Sharanfruit22Excpt &);
int CheckidlServerSharanfruit22Excpt(const ::idlServer::Sharanfruit22Excpt &);
void GetidlServerTarragon23Excpt(::idlServer::Tarragon23Excpt &);
int CheckidlServerTarragon23Excpt(const ::idlServer::Tarragon23Excpt &);
void GetidlServerButterBean24Excpt(::idlServer::ButterBean24Excpt &);
int CheckidlServerButterBean24Excpt(const ::idlServer::ButterBean24Excpt &);
void GetidlServerZucchini24Excpt(::idlServer::Zucchini24Excpt &);
int CheckidlServerZucchini24Excpt(const ::idlServer::Zucchini24Excpt &);
void GetidlServerPlum24Excpt(::idlServer::Plum24Excpt &);
int CheckidlServerPlum24Excpt(const ::idlServer::Plum24Excpt &);
void GetidlServerDill25Excpt(::idlServer::Dill25Excpt &);
int CheckidlServerDill25Excpt(const ::idlServer::Dill25Excpt &);
void GetidlServerBayleaf25Excpt(::idlServer::Bayleaf25Excpt &);
int CheckidlServerBayleaf25Excpt(const ::idlServer::Bayleaf25Excpt &);
void GetidlServerWhiteCabbage25Excpt(::idlServer::WhiteCabbage25Excpt &);
int CheckidlServerWhiteCabbage25Excpt(const ::idlServer::WhiteCabbage25Excpt &);



