//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::LoganBerry44* LoganBerry44Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void LoganBerry44Attr(const ::LoganBerry44 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::LoganBerry44* LoganBerry44Op(const ::LoganBerry44 &p1,::LoganBerry44_out p2,::LoganBerry44 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Orange44* Orange44Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Orange44Attr(const ::Orange44 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Orange44* Orange44Op(const ::Orange44 &p1,::Orange44_out p2,::Orange44 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Orange44::Sultana44* Sultana44Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Sultana44Attr(const ::Orange44::Sultana44 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Orange44::Sultana44* Sultana44Op(const ::Orange44::Sultana44 &p1,::Orange44::Sultana44_out p2,::Orange44::Sultana44 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BlackCherry45* BlackCherry45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BlackCherry45Attr(const ::BlackCherry45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BlackCherry45* BlackCherry45Op(const ::BlackCherry45 &p1,::BlackCherry45_out p2,::BlackCherry45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lemon45* Lemon45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Lemon45Attr(const ::Lemon45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lemon45* Lemon45Op(const ::Lemon45 &p1,::Lemon45_out p2,::Lemon45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lemon45::Banana45* Banana45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Banana45Attr(const ::Lemon45::Banana45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lemon45::Banana45* Banana45Op(const ::Lemon45::Banana45 &p1,::Lemon45::Banana45_out p2,::Lemon45::Banana45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Corriander45* Corriander45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Corriander45Attr(const ::Corriander45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Corriander45* Corriander45Op(const ::Corriander45 &p1,::Corriander45_out p2,::Corriander45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Kiwi45* Kiwi45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Kiwi45Attr(const ::Kiwi45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Kiwi45* Kiwi45Op(const ::Kiwi45 &p1,::Kiwi45_out p2,::Kiwi45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Kiwi45::GalaApple45* GalaApple45Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GalaApple45Attr(const ::Kiwi45::GalaApple45 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Kiwi45::GalaApple45* GalaApple45Op(const ::Kiwi45::GalaApple45 &p1,::Kiwi45::GalaApple45_out p2,::Kiwi45::GalaApple45 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::YellowPepper46* YellowPepper46Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void YellowPepper46Attr(const ::YellowPepper46 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::YellowPepper46* YellowPepper46Op(const ::YellowPepper46 &p1,::YellowPepper46_out p2,::YellowPepper46 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsley46* Parsley46Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Parsley46Attr(const ::Parsley46 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsley46* Parsley46Op(const ::Parsley46 &p1,::Parsley46_out p2,::Parsley46 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsley46::Peach46* Peach46Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Peach46Attr(const ::Parsley46::Peach46 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsley46::Peach46* Peach46Op(const ::Parsley46::Peach46 &p1,::Parsley46::Peach46_out p2,::Parsley46::Peach46 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Radish47* Radish47Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Radish47Attr(const ::Radish47 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Radish47* Radish47Op(const ::Radish47 &p1,::Radish47_out p2,::Radish47 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sharanfruit47* Sharanfruit47Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Sharanfruit47Attr(const ::Sharanfruit47 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sharanfruit47* Sharanfruit47Op(const ::Sharanfruit47 &p1,::Sharanfruit47_out p2,::Sharanfruit47 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sharanfruit47::BeefTomatoes47* BeefTomatoes47Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BeefTomatoes47Attr(const ::Sharanfruit47::BeefTomatoes47 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sharanfruit47::BeefTomatoes47* BeefTomatoes47Op(const ::Sharanfruit47::BeefTomatoes47 &p1,::Sharanfruit47::BeefTomatoes47_out p2,::Sharanfruit47::BeefTomatoes47 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BambooShoot48* BambooShoot48Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BambooShoot48Attr(const ::BambooShoot48 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BambooShoot48* BambooShoot48Op(const ::BambooShoot48 &p1,::BambooShoot48_out p2,::BambooShoot48 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

