//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:36  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/05/04 12:07:07  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 08:59:40  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetLoganBerry44(::LoganBerry44 &);
int CheckLoganBerry44(const ::LoganBerry44 &);
void GetOrange44(::Orange44 &);
int CheckOrange44(const ::Orange44 &);
void GetOrange44Sultana44(::Orange44::Sultana44 &);
int CheckOrange44Sultana44(const ::Orange44::Sultana44 &);
void GetBlackCherry45(::BlackCherry45 &);
int CheckBlackCherry45(const ::BlackCherry45 &);
void GetLemon45(::Lemon45 &);
int CheckLemon45(const ::Lemon45 &);
void GetLemon45Banana45(::Lemon45::Banana45 &);
int CheckLemon45Banana45(const ::Lemon45::Banana45 &);
void GetCorriander45(::Corriander45 &);
int CheckCorriander45(const ::Corriander45 &);
void GetKiwi45(::Kiwi45 &);
int CheckKiwi45(const ::Kiwi45 &);
void GetKiwi45GalaApple45(::Kiwi45::GalaApple45 &);
int CheckKiwi45GalaApple45(const ::Kiwi45::GalaApple45 &);
void GetYellowPepper46(::YellowPepper46 &);
int CheckYellowPepper46(const ::YellowPepper46 &);
void GetParsley46(::Parsley46 &);
int CheckParsley46(const ::Parsley46 &);
void GetParsley46Peach46(::Parsley46::Peach46 &);
int CheckParsley46Peach46(const ::Parsley46::Peach46 &);
void GetRadish47(::Radish47 &);
int CheckRadish47(const ::Radish47 &);
void GetSharanfruit47(::Sharanfruit47 &);
int CheckSharanfruit47(const ::Sharanfruit47 &);
void GetSharanfruit47BeefTomatoes47(::Sharanfruit47::BeefTomatoes47 &);
int CheckSharanfruit47BeefTomatoes47(const ::Sharanfruit47::BeefTomatoes47 &);
void GetBambooShoot48(::BambooShoot48 &);
int CheckBambooShoot48(const ::BambooShoot48 &);
void GetCress48(::Cress48 &);
int CheckCress48(const ::Cress48 &);
void GetCress48Lettuce48(::Cress48::Lettuce48 &);
int CheckCress48Lettuce48(const ::Cress48::Lettuce48 &);
void GetButterBean49(::ButterBean49 &);
int CheckButterBean49(const ::ButterBean49 &);
void GetZucchini49(::Zucchini49 &);
int CheckZucchini49(const ::Zucchini49 &);
void GetZucchini49Plum49(::Zucchini49::Plum49 &);
int CheckZucchini49Plum49(const ::Zucchini49::Plum49 &);
void GetDill50(::Dill50 &);
int CheckDill50(const ::Dill50 &);
void GetBayleaf50(::Bayleaf50 &);
int CheckBayleaf50(const ::Bayleaf50 &);
void GetBayleaf50WhiteCabbage50(::Bayleaf50::WhiteCabbage50 &);
int CheckBayleaf50WhiteCabbage50(const ::Bayleaf50::WhiteCabbage50 &);
void GetWaterMelon51(::WaterMelon51 &);
int CheckWaterMelon51(const ::WaterMelon51 &);
void GetMango51(::Mango51 &);
int CheckMango51(const ::Mango51 &);
void GetMango51PassionFruit51(::Mango51::PassionFruit51 &);
int CheckMango51PassionFruit51(const ::Mango51::PassionFruit51 &);
void GetRecord51(::Record51 &);
int CheckRecord51(const ::Record51 &);
void GetPotato51(::Potato51 &);
int CheckPotato51(const ::Potato51 &);
void GetPotato51ChineseLeaves51(::Potato51::ChineseLeaves51 &);
int CheckPotato51ChineseLeaves51(const ::Potato51::ChineseLeaves51 &);
void GetBlackberry52(::Blackberry52 &);
int CheckBlackberry52(const ::Blackberry52 &);
void GetBlueberry52(::Blueberry52 &);
int CheckBlueberry52(const ::Blueberry52 &);
void GetBlueberry52Basil52(::Blueberry52::Basil52 &);
int CheckBlueberry52Basil52(const ::Blueberry52::Basil52 &);
void GetCookingApple53(::CookingApple53 &);
int CheckCookingApple53(const ::CookingApple53 &);
void GetRasin53(::Rasin53 &);
int CheckRasin53(const ::Rasin53 &);
void GetRasin53Artichokes53(::Rasin53::Artichokes53 &);
int CheckRasin53Artichokes53(const ::Rasin53::Artichokes53 &);
void GetRasin53Artichokes53Peanutsquash53(::Rasin53::Artichokes53::Peanutsquash53 &);
int CheckRasin53Artichokes53Peanutsquash53(const ::Rasin53::Artichokes53::Peanutsquash53 &);
void GetSusander54(::Susander54 &);
int CheckSusander54(const ::Susander54 &);
void GetPeppercorn54(::Peppercorn54 &);
int CheckPeppercorn54(const ::Peppercorn54 &);
void GetPeppercorn54Cherry54(::Peppercorn54::Cherry54 &);
int CheckPeppercorn54Cherry54(const ::Peppercorn54::Cherry54 &);
void GetPeppercorn54Cherry54Okra54(::Peppercorn54::Cherry54::Okra54 &);
int CheckPeppercorn54Cherry54Okra54(const ::Peppercorn54::Cherry54::Okra54 &);
void GetRedPepper55(::RedPepper55 &);
int CheckRedPepper55(const ::RedPepper55 &);
void GetPear55(::Pear55 &);
int CheckPear55(const ::Pear55 &);
void GetPear55LimaBean55(::Pear55::LimaBean55 &);
int CheckPear55LimaBean55(const ::Pear55::LimaBean55 &);
void GetPear55LimaBean55Blackcurrant55(::Pear55::LimaBean55::Blackcurrant55 &);
int CheckPear55LimaBean55Blackcurrant55(const ::Pear55::LimaBean55::Blackcurrant55 &);
void GetWaterchestnut56(::Waterchestnut56 &);
int CheckWaterchestnut56(const ::Waterchestnut56 &);
void GetUglifruit56(::Uglifruit56 &);
int CheckUglifruit56(const ::Uglifruit56 &);
void GetUglifruit56Walnuts56(::Uglifruit56::Walnuts56 &);
int CheckUglifruit56Walnuts56(const ::Uglifruit56::Walnuts56 &);
void GetUglifruit56Walnuts56Pomegranate56(::Uglifruit56::Walnuts56::Pomegranate56 &);
int CheckUglifruit56Walnuts56Pomegranate56(const ::Uglifruit56::Walnuts56::Pomegranate56 &);
void GetMelon57(::Melon57 &);
int CheckMelon57(const ::Melon57 &);
void GetCassava57(::Cassava57 &);
int CheckCassava57(const ::Cassava57 &);
void GetCassava57Cress57(::Cassava57::Cress57 &);
int CheckCassava57Cress57(const ::Cassava57::Cress57 &);
void GetCassava57Cress57Lettuce57(::Cassava57::Cress57::Lettuce57 &);
int CheckCassava57Cress57Lettuce57(const ::Cassava57::Cress57::Lettuce57 &);
void GetBreadFruit58(::BreadFruit58 &);
int CheckBreadFruit58(const ::BreadFruit58 &);
void GetStrawberry58(::Strawberry58 &);
int CheckStrawberry58(const ::Strawberry58 &);
void GetStrawberry58Daikan58(::Strawberry58::Daikan58 &);
int CheckStrawberry58Daikan58(const ::Strawberry58::Daikan58 &);
void GetStrawberry58Daikan58Avocado58(::Strawberry58::Daikan58::Avocado58 &);
int CheckStrawberry58Daikan58Avocado58(const ::Strawberry58::Daikan58::Avocado58 &);
void GetCinnamon59(::Cinnamon59 &);
int CheckCinnamon59(const ::Cinnamon59 &);
void GetHazelNut59(::HazelNut59 &);
int CheckHazelNut59(const ::HazelNut59 &);
void GetHazelNut59CrabApple59(::HazelNut59::CrabApple59 &);
int CheckHazelNut59CrabApple59(const ::HazelNut59::CrabApple59 &);
void GetHazelNut59CrabApple59Lentil59(::HazelNut59::CrabApple59::Lentil59 &);
int CheckHazelNut59CrabApple59Lentil59(const ::HazelNut59::CrabApple59::Lentil59 &);
void GetKidneyBean60(::KidneyBean60 &);
int CheckKidneyBean60(const ::KidneyBean60 &);
void GetPlum60(::Plum60 &);
int CheckPlum60(const ::Plum60 &);
void GetPlum60Onion60(::Plum60::Onion60 &);
int CheckPlum60Onion60(const ::Plum60::Onion60 &);
void GetPlum60Onion60Tofu60(::Plum60::Onion60::Tofu60 &);
int CheckPlum60Onion60Tofu60(const ::Plum60::Onion60::Tofu60 &);
void GetBillberries61(::Billberries61 &);
int CheckBillberries61(const ::Billberries61 &);
void GetTangarine61(::Tangarine61 &);
int CheckTangarine61(const ::Tangarine61 &);
void GetTangarine61BrazilNut61(::Tangarine61::BrazilNut61 &);
int CheckTangarine61BrazilNut61(const ::Tangarine61::BrazilNut61 &);
void GetTangarine61BrazilNut61Brocoli61(::Tangarine61::BrazilNut61::Brocoli61 &);
int CheckTangarine61BrazilNut61Brocoli61(const ::Tangarine61::BrazilNut61::Brocoli61 &);
void GetGuava62(::Guava62 &);
int CheckGuava62(const ::Guava62 &);
void GetAlmonds62(::Almonds62 &);
int CheckAlmonds62(const ::Almonds62 &);
void GetAlmonds62Oregano62(::Almonds62::Oregano62 &);
int CheckAlmonds62Oregano62(const ::Almonds62::Oregano62 &);
void GetAlmonds62Oregano62Asparagus62(::Almonds62::Oregano62::Asparagus62 &);
int CheckAlmonds62Oregano62Asparagus62(const ::Almonds62::Oregano62::Asparagus62 &);
void GetCelery63(::Celery63 &);
int CheckCelery63(const ::Celery63 &);
void GetParsnip63(::Parsnip63 &);
int CheckParsnip63(const ::Parsnip63 &);
void GetParsnip63Orange63(::Parsnip63::Orange63 &);
int CheckParsnip63Orange63(const ::Parsnip63::Orange63 &);
void GetParsnip63Orange63Sultana63(::Parsnip63::Orange63::Sultana63 &);
int CheckParsnip63Orange63Sultana63(const ::Parsnip63::Orange63::Sultana63 &);
void GetLeek64(::Leek64 &);
int CheckLeek64(const ::Leek64 &);
void GetBlackEyedBeans64(::BlackEyedBeans64 &);
int CheckBlackEyedBeans64(const ::BlackEyedBeans64 &);
void GetBlackEyedBeans64Ginger64(::BlackEyedBeans64::Ginger64 &);
int CheckBlackEyedBeans64Ginger64(const ::BlackEyedBeans64::Ginger64 &);
void GetBlackEyedBeans64Ginger64Starfruit64(::BlackEyedBeans64::Ginger64::Starfruit64 &);
int CheckBlackEyedBeans64Ginger64Starfruit64(const ::BlackEyedBeans64::Ginger64::Starfruit64 &);
void GetDates65(::Dates65 &);
int CheckDates65(const ::Dates65 &);
void GetLime65(::Lime65 &);
int CheckLime65(const ::Lime65 &);
void GetLime65Mango65(::Lime65::Mango65 &);
int CheckLime65Mango65(const ::Lime65::Mango65 &);
void GetLime65Mango65PassionFruit65(::Lime65::Mango65::PassionFruit65 &);
int CheckLime65Mango65PassionFruit65(const ::Lime65::Mango65::PassionFruit65 &);
void GetCarrots66(::Carrots66 &);
int CheckCarrots66(const ::Carrots66 &);
void GetBanana66(::Banana66 &);
int CheckBanana66(const ::Banana66 &);
void GetBanana66PentlandDell65(::Banana66::PentlandDell65 &);
int CheckBanana66PentlandDell65(const ::Banana66::PentlandDell65 &);
void GetBanana66PentlandDell65Homeguard65(::Banana66::PentlandDell65::Homeguard65 &);
int CheckBanana66PentlandDell65Homeguard65(const ::Banana66::PentlandDell65::Homeguard65 &);
void GetidlServerLoganBerry44Excpt(::idlServer::LoganBerry44Excpt &);
int CheckidlServerLoganBerry44Excpt(const ::idlServer::LoganBerry44Excpt &);
void GetidlServerOrange44Excpt(::idlServer::Orange44Excpt &);
int CheckidlServerOrange44Excpt(const ::idlServer::Orange44Excpt &);
void GetidlServerSultana44Excpt(::idlServer::Sultana44Excpt &);
int CheckidlServerSultana44Excpt(const ::idlServer::Sultana44Excpt &);
void GetidlServerBlackCherry45Excpt(::idlServer::BlackCherry45Excpt &);
int CheckidlServerBlackCherry45Excpt(const ::idlServer::BlackCherry45Excpt &);
void GetidlServerLemon45Excpt(::idlServer::Lemon45Excpt &);
int CheckidlServerLemon45Excpt(const ::idlServer::Lemon45Excpt &);
void GetidlServerBanana45Excpt(::idlServer::Banana45Excpt &);
int CheckidlServerBanana45Excpt(const ::idlServer::Banana45Excpt &);
void GetidlServerCorriander45Excpt(::idlServer::Corriander45Excpt &);
int CheckidlServerCorriander45Excpt(const ::idlServer::Corriander45Excpt &);
void GetidlServerKiwi45Excpt(::idlServer::Kiwi45Excpt &);
int CheckidlServerKiwi45Excpt(const ::idlServer::Kiwi45Excpt &);
void GetidlServerGalaApple45Excpt(::idlServer::GalaApple45Excpt &);
int CheckidlServerGalaApple45Excpt(const ::idlServer::GalaApple45Excpt &);
void GetidlServerYellowPepper46Excpt(::idlServer::YellowPepper46Excpt &);
int CheckidlServerYellowPepper46Excpt(const ::idlServer::YellowPepper46Excpt &);
void GetidlServerParsley46Excpt(::idlServer::Parsley46Excpt &);
int CheckidlServerParsley46Excpt(const ::idlServer::Parsley46Excpt &);
void GetidlServerPeach46Excpt(::idlServer::Peach46Excpt &);
int CheckidlServerPeach46Excpt(const ::idlServer::Peach46Excpt &);
void GetidlServerRadish47Excpt(::idlServer::Radish47Excpt &);
int CheckidlServerRadish47Excpt(const ::idlServer::Radish47Excpt &);
void GetidlServerSharanfruit47Excpt(::idlServer::Sharanfruit47Excpt &);
int CheckidlServerSharanfruit47Excpt(const ::idlServer::Sharanfruit47Excpt &);
void GetidlServerBeefTomatoes47Excpt(::idlServer::BeefTomatoes47Excpt &);
int CheckidlServerBeefTomatoes47Excpt(const ::idlServer::BeefTomatoes47Excpt &);
void GetidlServerBambooShoot48Excpt(::idlServer::BambooShoot48Excpt &);
int CheckidlServerBambooShoot48Excpt(const ::idlServer::BambooShoot48Excpt &);



