//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:40  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/05/04 12:07:12  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:01:45  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetCherryTomatoes90(::CherryTomatoes90 &);
int CheckCherryTomatoes90(const ::CherryTomatoes90 &);
void GetPeanutsquash90(::Peanutsquash90 &);
int CheckPeanutsquash90(const ::Peanutsquash90 &);
void GetPeanutsquash90PepinoMelon90(::Peanutsquash90::PepinoMelon90 &);
int CheckPeanutsquash90PepinoMelon90(const ::Peanutsquash90::PepinoMelon90 &);
void GetPeanutsquash90PepinoMelon90Pear90(::Peanutsquash90::PepinoMelon90::Pear90 &);
int CheckPeanutsquash90PepinoMelon90Pear90(const ::Peanutsquash90::PepinoMelon90::Pear90 &);
void GetPapaya91(::Papaya91 &);
int CheckPapaya91(const ::Papaya91 &);
void GetCherry91(::Cherry91 &);
int CheckCherry91(const ::Cherry91 &);
void GetCherry91Sharanfruit91(::Cherry91::Sharanfruit91 &);
int CheckCherry91Sharanfruit91(const ::Cherry91::Sharanfruit91 &);
void GetCherry91Sharanfruit91BeefTomatoes91(::Cherry91::Sharanfruit91::BeefTomatoes91 &);
int CheckCherry91Sharanfruit91BeefTomatoes91(const ::Cherry91::Sharanfruit91::BeefTomatoes91 &);
void GetPineapple92(::Pineapple92 &);
int CheckPineapple92(const ::Pineapple92 &);
void GetBlackcurrant92(::Blackcurrant92 &);
int CheckBlackcurrant92(const ::Blackcurrant92 &);
void GetBlackcurrant92Okra92(::Blackcurrant92::Okra92 &);
int CheckBlackcurrant92Okra92(const ::Blackcurrant92::Okra92 &);
void GetBlackcurrant92Okra92Cassava92(::Blackcurrant92::Okra92::Cassava92 &);
int CheckBlackcurrant92Okra92Cassava92(const ::Blackcurrant92::Okra92::Cassava92 &);
void GetFennell93(::Fennell93 &);
int CheckFennell93(const ::Fennell93 &);
void GetWalnuts93(::Walnuts93 &);
int CheckWalnuts93(const ::Walnuts93 &);
void GetWalnuts93Elderberry93(::Walnuts93::Elderberry93 &);
int CheckWalnuts93Elderberry93(const ::Walnuts93::Elderberry93 &);
void GetWalnuts93Elderberry93RedGrapes93(::Walnuts93::Elderberry93::RedGrapes93 &);
int CheckWalnuts93Elderberry93RedGrapes93(const ::Walnuts93::Elderberry93::RedGrapes93 &);
void GetMangetout94(::Mangetout94 &);
int CheckMangetout94(const ::Mangetout94 &);
void GetLettuce94(::Lettuce94 &);
int CheckLettuce94(const ::Lettuce94 &);
void GetLettuce94Pomegranate94(::Lettuce94::Pomegranate94 &);
int CheckLettuce94Pomegranate94(const ::Lettuce94::Pomegranate94 &);
void GetLettuce94Pomegranate94HazelNut94(::Lettuce94::Pomegranate94::HazelNut94 &);
int CheckLettuce94Pomegranate94HazelNut94(const ::Lettuce94::Pomegranate94::HazelNut94 &);
void GetMustard95(::Mustard95 &);
int CheckMustard95(const ::Mustard95 &);
void GetDaikan95(::Daikan95 &);
int CheckDaikan95(const ::Daikan95 &);
void GetDaikan95JuniperBerries95(::Daikan95::JuniperBerries95 &);
int CheckDaikan95JuniperBerries95(const ::Daikan95::JuniperBerries95 &);
void GetDaikan95JuniperBerries95GooseBerry95(::Daikan95::JuniperBerries95::GooseBerry95 &);
int CheckDaikan95JuniperBerries95GooseBerry95(const ::Daikan95::JuniperBerries95::GooseBerry95 &);
void GetFig96(::Fig96 &);
int CheckFig96(const ::Fig96 &);
void GetLentil96(::Lentil96 &);
int CheckLentil96(const ::Lentil96 &);
void GetLentil96Avocado96(::Lentil96::Avocado96 &);
int CheckLentil96Avocado96(const ::Lentil96::Avocado96 &);
void GetLentil96Avocado96Tangarine96(::Lentil96::Avocado96::Tangarine96 &);
int CheckLentil96Avocado96Tangarine96(const ::Lentil96::Avocado96::Tangarine96 &);
void GetShallots97(::Shallots97 &);
int CheckShallots97(const ::Shallots97 &);
void GetOnion97(::Onion97 &);
int CheckOnion97(const ::Onion97 &);
void GetOnion97RowanBerry97(::Onion97::RowanBerry97 &);
int CheckOnion97RowanBerry97(const ::Onion97::RowanBerry97 &);
void GetOnion97RowanBerry97CantelopeMelon97(::Onion97::RowanBerry97::CantelopeMelon97 &);
int CheckOnion97RowanBerry97CantelopeMelon97(const ::Onion97::RowanBerry97::CantelopeMelon97 &);
void GetGrannySmith98(::GrannySmith98 &);
int CheckGrannySmith98(const ::GrannySmith98 &);
void GetBrocoli98(::Brocoli98 &);
int CheckBrocoli98(const ::Brocoli98 &);
void GetBrocoli98Tofu98(::Brocoli98::Tofu98 &);
int CheckBrocoli98Tofu98(const ::Brocoli98::Tofu98 &);
void GetBrocoli98Tofu98Parsnip98(::Brocoli98::Tofu98::Parsnip98 &);
int CheckBrocoli98Tofu98Parsnip98(const ::Brocoli98::Tofu98::Parsnip98 &);
void GetBeansprout99(::Beansprout99 &);
int CheckBeansprout99(const ::Beansprout99 &);
void GetOregano99(::Oregano99 &);
int CheckOregano99(const ::Oregano99 &);
void GetOregano99Bayleaf99(::Oregano99::Bayleaf99 &);
int CheckOregano99Bayleaf99(const ::Oregano99::Bayleaf99 &);
void GetOregano99Bayleaf99WhiteCabbage99(::Oregano99::Bayleaf99::WhiteCabbage99 &);
int CheckOregano99Bayleaf99WhiteCabbage99(const ::Oregano99::Bayleaf99::WhiteCabbage99 &);
void GetidlServerCherryTomatoes90Excpt(::idlServer::CherryTomatoes90Excpt &);
int CheckidlServerCherryTomatoes90Excpt(const ::idlServer::CherryTomatoes90Excpt &);
void GetidlServerPeanutsquash90Excpt(::idlServer::Peanutsquash90Excpt &);
int CheckidlServerPeanutsquash90Excpt(const ::idlServer::Peanutsquash90Excpt &);
void GetidlServerPepinoMelon90Excpt(::idlServer::PepinoMelon90Excpt &);
int CheckidlServerPepinoMelon90Excpt(const ::idlServer::PepinoMelon90Excpt &);
void GetidlServerPear90Excpt(::idlServer::Pear90Excpt &);
int CheckidlServerPear90Excpt(const ::idlServer::Pear90Excpt &);
void GetidlServerPapaya91Excpt(::idlServer::Papaya91Excpt &);
int CheckidlServerPapaya91Excpt(const ::idlServer::Papaya91Excpt &);
void GetidlServerCherry91Excpt(::idlServer::Cherry91Excpt &);
int CheckidlServerCherry91Excpt(const ::idlServer::Cherry91Excpt &);
void GetidlServerSharanfruit91Excpt(::idlServer::Sharanfruit91Excpt &);
int CheckidlServerSharanfruit91Excpt(const ::idlServer::Sharanfruit91Excpt &);
void GetidlServerBeefTomatoes91Excpt(::idlServer::BeefTomatoes91Excpt &);
int CheckidlServerBeefTomatoes91Excpt(const ::idlServer::BeefTomatoes91Excpt &);



