//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Apple AppleAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void AppleAttr(const ::Apple &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Apple AppleOp(const ::Apple &p1,::Apple &p2,::Apple &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado AvocadoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void AvocadoAttr(const ::Avocado &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado AvocadoOp(const ::Avocado &p1,::Avocado &p2,::Avocado &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Peanut PeanutAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void PeanutAttr(const ::Peanut &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Peanut PeanutOp(const ::Peanut &p1,::Peanut &p2,::Peanut &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Satsuma_slice * SatsumaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void SatsumaAttr(const ::Satsuma _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Satsuma_slice * SatsumaOp(const ::Satsuma p1,::Satsuma p2,::Satsuma p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedChilly RedChillyAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RedChillyAttr(const ::RedChilly &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedChilly RedChillyOp(const ::RedChilly &p1,::RedChilly &p2,::RedChilly &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Celeriac CeleriacAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void CeleriacAttr(const ::Celeriac &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Celeriac CeleriacOp(const ::Celeriac &p1,::Celeriac &p2,::Celeriac &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Banana BananaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BananaAttr(const ::Banana &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Banana BananaOp(const ::Banana &p1,::Banana &p2,::Banana &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

