//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Banana BananaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BananaAttr(const ::Banana &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Banana BananaOp(const ::Banana &p1,::Banana &p2,::Banana &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado AvocadoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void AvocadoAttr(const ::Avocado &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado AvocadoOp(const ::Avocado &p1,::Avocado &p2,::Avocado &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango MangoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void MangoAttr(const ::Avocado::Mango &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango MangoOp(const ::Avocado::Mango &p1,::Avocado::Mango &p2,::Avocado::Mango &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit StarfruitAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void StarfruitAttr(const ::Avocado::Mango::Starfruit &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit StarfruitOp(const ::Avocado::Mango::Starfruit &p1,::Avocado::Mango::Starfruit &p2,::Avocado::Mango::Starfruit &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates DatesAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void DatesAttr(const ::Avocado::Mango::Starfruit::Dates &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates DatesOp(const ::Avocado::Mango::Starfruit::Dates &p1,::Avocado::Mango::Starfruit::Dates &p2,::Avocado::Mango::Starfruit::Dates &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime LimeAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void LimeAttr(const ::Avocado::Mango::Starfruit::Dates::Lime &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime LimeOp(const ::Avocado::Mango::Starfruit::Dates::Lime &p1,::Avocado::Mango::Starfruit::Dates::Lime &p2,::Avocado::Mango::Starfruit::Dates::Lime &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek LeekAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void LeekAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek LeekOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger GingerAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GingerAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger GingerOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint MintAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void MintAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint MintOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas GardenPeasAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GardenPeasAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas GardenPeasOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana SultanaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void SultanaAttr(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana SultanaOp(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &p1,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &p2,::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

