/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing advanced features of the valuetype construct 
// Test subgroup description: Testing scope of typedef declarations with the valuetype inheritance 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Value forward declaration 
// Directory: va_f01 


extern "C"
void test1(void)
{
   /* Public Accessor in valuetype AVal for member of valuetype BVal */

  tet_printf("TC: Value forward declaration\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Public Modifier in valuetype AVal for member of valuetype BVal */

  tet_printf("TC: Value forward declaration\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Public Accessor in valuetype BVal for member of valuetype AVal */

  tet_printf("TC: Value forward declaration\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Public Modifier in valuetype BVal for member of valuetype AVal */

  tet_printf("TC: Value forward declaration\n");
  tp4.run();
}
