/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing advanced features of the valuetype construct 
// Test subgroup description: Testing scope of typedef declarations with the valuetype inheritance 

// Test case Nr. 5 
// Name: tc01 
// Testcase goal: Valuetype inheritance in modules with typedef 
// Directory: va_t04 


extern "C"
void test1(void)
{
   /* Public Member in  valuetype ValA (in module M) for operation op1 with result of type string and with in parameter of type long (types defined as typedefs) */

  tet_printf("TC: Valuetype inheritance in modules with typedef\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Public Member in  valuetype ValB (in module M) for operation op1 with result of type long and with in parameter of type long (types defined as typedefs) */

  tet_printf("TC: Valuetype inheritance in modules with typedef\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Public Member in  valuetype ValC (in module N) derived from ValA (in module M) for operation op2 with  in parameter of type string (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance in modules with typedef\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Public Member in  valuetype ValD (in module N) derived from ValB (in module M) for operation op2 with  in parameter of type char (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance in modules with typedef\n");
  tp4.run();
}
