/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the value box construct 
// Test subgroup description: Testing usage of the value box construct as parameter and attribute 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Value Box basic features 
// Directory: vb_b01 


extern "C"
void test1(void)
{
   /* Existence of Class ShortValue for value box ShortValue */

  tet_printf("TC: Value Box basic features\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Class ShortValue for value box ShortValue derived from CORBA::DefaultValueRefCountBase */

  tet_printf("TC: Value Box basic features\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Existence of ShortValue_var for value box ShortValue */

  tet_printf("TC: Value Box basic features\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Existence of ShortValue_out for value box ShortValue */

  tet_printf("TC: Value Box basic features\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Definition of public static _downcast() in class ShortValue */

  tet_printf("TC: Value Box basic features\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Existence of conversion functions _boxed_in, _boxed_inout, _boxed_out in class ShortValue */

  tet_printf("TC: Value Box basic features\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* Extraction and insertion from/to Any */

  tet_printf("TC: Value Box basic features\n");
  tp7.run();
}

// Test case Nr. 2 
// Name: tc02 
// Testcase goal: Features of the class ShortValue_out for value box ShortValue (server side) 
// Directory: vb_b01 


extern "C"
void test8(void)
{
   /* Existence of public constructors in the  class ShortValue_out for the value box ShortValue */

  tet_printf("TC: Features of the class ShortValue_out for value box ShortValue (server side)\n");
  tp8.run();
}

extern "C"
void test9(void)
{
   /* Possible assignment between ShortValue_out and ShortValue* */

  tet_printf("TC: Features of the class ShortValue_out for value box ShortValue (server side)\n");
  tp9.run();
}

extern "C"
void test10(void)
{
   /* Existence of ptr() function in the  class ShortValue_out for the value box ShortValue */

  tet_printf("TC: Features of the class ShortValue_out for value box ShortValue (server side)\n");
  tp10.run();
}
