/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the value box construct 
// Test subgroup description: Testing usage of the value box construct as parameter and attribute 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Value Box for basic types and enums 
// Directory: vb_d01 


extern "C"
void test1(void)
{
   /* Public constructors (underlying type) in class created for a valuebox */

  tet_printf("TC: Value Box for basic types and enums\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Public assignment operator (underlying type) in class created for a valuebox */

  tet_printf("TC: Value Box for basic types and enums\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Accessor functions for boxed value in class created for a valuebox */

  tet_printf("TC: Value Box for basic types and enums\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Modifier functions for boxed value in class created for a valuebox */

  tet_printf("TC: Value Box for basic types and enums\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox */

  tet_printf("TC: Value Box for basic types and enums\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Extraction and insertion from/to any for a valuebox */

  tet_printf("TC: Value Box for basic types and enums\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* Existence of private default assignment operator in class created for a valuebox */

  tet_printf("TC: Value Box for basic types and enums\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp7.run(1);
}
