/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <tp.hh>

testpurp tp1("vb_d05_0101","Public constructors in class created for a valuebox with fix union");
testpurp tp2("vb_d05_0102","Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuebox with fix union");
testpurp tp3("vb_d05_0103","Public accessor function _value() for underlying boxed fix union type in class created for a valuebox with fix union");
testpurp tp4("vb_d05_0104","Public modifier function _value for underlying boxed fix union type in class created for a valuebox with fix union");
testpurp tp5("vb_d05_0105","Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with fix union");
testpurp tp6("vb_d05_0106","Existence of public static _downcast in class created for a valuebox with fix union");
testpurp tp7("vb_d05_0107","Extraction and insertion from/to any for a valuebox with fix union");
testpurp tp8("vb_d05_0108","Existence of private default assignment operator in class created for a valuebox with fix union");
testpurp tp9("vb_d05_0201","Public constructors in class created for a valuebox with Sequence");
testpurp tp10("vb_d05_0202","Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuebox with Sequence");
testpurp tp11("vb_d05_0203","Public accessor function _value() for underlying boxed sequence-of-long in class created for a valuebox with Sequence");
testpurp tp12("vb_d05_0204","Public modifier function  _value for underlying boxed sequence of long type in class created for a valuebox with Sequence");
testpurp tp13("vb_d05_0205","Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with Sequence");
testpurp tp14("vb_d05_0206","Existence of public static _downcast in class created for a valuebox with Sequence");
testpurp tp15("vb_d05_0207","Existence of subscript operator ([])  in class created for a valuebox with Sequence");
testpurp tp16("vb_d05_0208","Existence of functions maximum and length  in class created for a valuebox with Sequence");
testpurp tp17("vb_d05_0209","Extraction and insertion from/to any for a valuebox with Sequence");
testpurp tp18("vb_d05_0210","Existence of private default assignment operator in class created for a valuebox with Sequence");
testpurp tp19("vb_d05_0301","Public constructors in class created for a value box with Any");
testpurp tp20("vb_d05_0302","Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuetype with Any");
testpurp tp21("vb_d05_0303","Public accessor function _value() for underlying boxed any type in class created for a valuetype with Any");
testpurp tp22("vb_d05_0304","Public modifier function _value for underlying boxed any type in class created for a valuetype with Any");
testpurp tp23("vb_d05_0305","Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuetype with Any");
testpurp tp24("vb_d05_0306","Existence of public static _downcast in class created for a valuetype with Any");
testpurp tp25("vb_d05_0307"," Valuetype with Any _ possible usage with insertion/extraction operators");
testpurp tp26("vb_d05_0308","Existence of private default assignment operator in class created for a valuetype");
testpurp tp27("vb_d05_0401","Public constructors in class created for a valuebox with Sequence");
testpurp tp28("vb_d05_0402","Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuebox with Sequence");
testpurp tp29("vb_d05_0403","Public accessor function _value() for underlying boxed string sequence type in class created for a valuebox with Sequence");
testpurp tp30("vb_d05_0404","Public modifier function  _value for underlying boxed string sequence type in class created for a valuebox with Sequence");
testpurp tp31("vb_d05_0405","Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with Sequence");
testpurp tp32("vb_d05_0406","Existence of public static _downcast in class created for a valuebox with Sequence");
testpurp tp33("vb_d05_0407","Existence of subscript operator ([])  in class created for a valuebox with Sequence");
testpurp tp34("vb_d05_0408","Existence of functions maximum and length  in class created for a valuebox with Sequence");
testpurp tp35("vb_d05_0409","Extraction and insertion from/to any for a valuebox with Sequence");
testpurp tp36("vb_d05_0410","Existence of private default assignment operator in class created for a valuebox with Sequence");
testpurp tp37("vb_d05_0501","Public constructors in class created for a valuebox with var union");
testpurp tp38("vb_d05_0502","Public assignment operator  (with an argument _ underlying boxed type) in class created for a valuebox with var union");
testpurp tp39("vb_d05_0503","Public accessor function _value() for underlying boxed union type in class created for a valuebox with var union");
testpurp tp40("vb_d05_0504","Public modifier function _value for underlying boxed union type in class created for a valuebox with var union");
testpurp tp41("vb_d05_0505","Existence of explicit conversion functions _boxed_in, _boxed_inout, _boxed_out in class created for a valuebox with var union");
testpurp tp42("vb_d05_0506","Existence of public static _downcast in class created for a valuebox with var union");
testpurp tp43("vb_d05_0507","Extraction and insertion from/to any for a valuebox with var union");
testpurp tp44("vb_d05_0508","Existence of private default assignment operator in class created for a valuebox with var union");
