/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the value box construct 
// Test subgroup description: Testing usage of the value box construct as parameter and attribute 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Value Box of Short as attribute and as operation parameter 
// Directory: vb_p01 


extern "C"
void test1(void)
{
   /* Accessor function  for an attribute of the value box ShortValue */

  tet_printf("TC: Value Box of Short as attribute and as operation parameter\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Modifier function  for an attribute of the value box ShortValue */

  tet_printf("TC: Value Box of Short as attribute and as operation parameter\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Value box ShortValue used as in/out/inout parameter of an operation in an interface - actual parameter types */

  tet_printf("TC: Value Box of Short as attribute and as operation parameter\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Existence of ShortValue_out for value box ShortValue */

  tet_printf("TC: Value Box of Short as attribute and as operation parameter\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Base Class for Server Implementation, Value box ShortValue used as in/out/inout parameter of an operation in an interface - formal parameter types (server side)  */

  tet_printf("TC: Value Box of Short as attribute and as operation parameter\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Value box ShortValue used as in/out/inout parameter of an operation in an interface - formal parameter types (server side) */

  tet_printf("TC: Value Box of Short as attribute and as operation parameter\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp6.run(1);
}
