/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the valuetype construct 
// Test subgroup description: Testing the valuetype as operation parameter 

// Test case Nr. 4 
// Name: tc01 
// Testcase goal:  Valuetype in an exception - features of the exception class ValExcpt 
// Directory: vt_e01 


extern "C"
void test1(void)
{
   /* Class ValExcpt for exception ValExcpt exists */

  tet_printf("TC:  Valuetype in an exception - features of the exception class ValExcpt\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Class ValExcpt for exception ValExcpt derives from UserException */

  tet_printf("TC:  Valuetype in an exception - features of the exception class ValExcpt\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Class ValExcpt has constructor for valuetype member Val */

  tet_printf("TC:  Valuetype in an exception - features of the exception class ValExcpt\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Class ValExcpt  has valuetype member Val */

  tet_printf("TC:  Valuetype in an exception - features of the exception class ValExcpt\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Definition of public static _downcast() in class ValExcpt for exception with valuetype member Val */

  tet_printf("TC:  Valuetype in an exception - features of the exception class ValExcpt\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Extraction/insertion from/to any */

  tet_printf("TC:  Valuetype in an exception - features of the exception class ValExcpt\n");
  tp6.run();
}

// Test case Nr. 5 
// Name: tc02 
// Testcase goal:  Valuetype in an exception - the exception class ValExcpt used in operation of valuetype/interface 
// Directory: vt_e01 


extern "C"
void test7(void)
{
   /* Exception (catch) used in valuetype operation */

  tet_printf("TC:  Valuetype in an exception - the exception class ValExcpt used in operation of valuetype/interface\n");
  tp7.run();
}

extern "C"
void test8(void)
{
   /* Exception (catch) used in interface operation */

  tet_printf("TC:  Valuetype in an exception - the exception class ValExcpt used in operation of valuetype/interface\n");
  tp8.run();
}
