/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the valuetype construct 
// Test subgroup description: Testing the valuetype as operation parameter 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Data member in a valuetype 
// Directory: vt_m01 


extern "C"
void test1(void)
{
   /* Accessor function  in class Val for private short data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Modifier function  in class Val for private short data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Accessor function  in class Val for public unsigned short data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Modifier function  in class Val for public unsigned short data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Accessor function  in class Val for public long data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Modifier function  in class Val for public long data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* Accessor function  in class Val for private unsigned long data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp7.run();
}

extern "C"
void test8(void)
{
   /* Modifier function  in class Val for private unsigned long data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp8.run();
}

extern "C"
void test9(void)
{
   /* Accessor function  in class Val for private long long data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp9.run();
}

extern "C"
void test10(void)
{
   /* Modifier function  in class Val for private long long data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp10.run();
}

extern "C"
void test11(void)
{
   /* Accessor function  in class Val for public unsigned long long data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp11.run();
}

extern "C"
void test12(void)
{
   /* Modifier function  in class Val for public unsigned long long data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp12.run();
}

extern "C"
void test13(void)
{
   /* Accessor function  in class Val for public boolean data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp13.run();
}

extern "C"
void test14(void)
{
   /* Modifier function  in class Val for public boolean data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp14.run();
}

extern "C"
void test15(void)
{
   /* Accessor function  in class Val for private octet data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp15.run();
}

extern "C"
void test16(void)
{
   /* Modifier function  in class Val for private octet data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp16.run();
}

extern "C"
void test17(void)
{
   /* Accessor function  in class Val for public char data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp17.run();
}

extern "C"
void test18(void)
{
   /* Modifier function  in class Val for public char data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp18.run();
}

extern "C"
void test19(void)
{
   /* Accessor function  in class Val for private wchar data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp19.run();
}

extern "C"
void test20(void)
{
   /* Modifier function  in class Val for private wchar data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp20.run();
}

extern "C"
void test21(void)
{
   /* Accessor function  in class Val for public float data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp21.run();
}

extern "C"
void test22(void)
{
   /* Modifier function  in class Val for public float data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp22.run();
}

extern "C"
void test23(void)
{
   /* Accessor function  in class Val for private double data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp23.run();
}

extern "C"
void test24(void)
{
   /* Modifier function  in class Val for private double data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp24.run();
}

extern "C"
void test25(void)
{
   /* Accessor function  in class Val for public string data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp25.run();
}

extern "C"
void test26(void)
{
   /* Modifier function  in class Val for public string data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp26.run();
}

extern "C"
void test27(void)
{
   /* Accessor function  in class Val for private wstring data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp27.run();
}

extern "C"
void test28(void)
{
   /* Modifier function  in class Val for private wstring data member for valuetype Val */

  tet_printf("TC: Data member in a valuetype\n");
  tp28.run();
}

// Test case Nr. 2 
// Name: tc02 
// Testcase goal: Features of the class Val_init for valuetype Val 
// Directory: vt_m01 


extern "C"
void test29(void)
{
   /* Initializer operation for public members in the factory class Val_init for valuetype Val */

  tet_printf("TC: Features of the class Val_init for valuetype Val\n");
  tp29.run();
}

extern "C"
void test30(void)
{
   /* Initializer operation for private members in the factory class Val_init for valuetype Val */

  tet_printf("TC: Features of the class Val_init for valuetype Val\n");
  tp30.run();
}
