//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the valuetype construct 
// Test subgroup description: Testing the valuetype as operation parameter 

// Test case Nr. 3 
// Name: 03 
// Testcase goal: Member of type 'any' in valuetype 
// Directory: vt_m02 

extern "C"
void test1(void)
{
   /* Accessor function  in class Val for 'Any'_type member valuetype Val */

  tet_printf("TC: Member of type 'any' in valuetype\n");
  tp1.run();
}
extern "C"
void test2(void)
{
   /* Modifier function  in class Val for 'Any'_type member valuetype Val */

  tet_printf("TC: Member of type 'any' in valuetype\n");
  tp2.run();
}

// Test case Nr. 4 
// Name: 04 
// Testcase goal: Member of type 'interface' in valuetype 
// Directory: vt_m02 

extern "C"
void test3(void)
{
   /* Accessor function in class Val for 'Interface'_type member valuetype Val */

  tet_printf("TC: Member of type 'interface' in valuetype\n");
  tp3.run();
}
extern "C"
void test4(void)
{
   /* Modifier function in class Val for 'Interface'_type member valuetype Val */

  tet_printf("TC: Member of type 'interface' in valuetype\n");
  tp4.run();
}

// Test case Nr. 5 
// Name: 05 
// Testcase goal: Member of type 'array' in valuetype 
// Directory: vt_m02 

extern "C"
void test5(void)
{
   /* Accessor functions for array member of valuetype Val */

  tet_printf("TC: Member of type 'array' in valuetype\n");
  tp5.run();
}
extern "C"
void test6(void)
{
   /* Modifier function for array member of valuetype Val */

  tet_printf("TC: Member of type 'array' in valuetype\n");
  tp6.run();
}

// Test case Nr. 6 
// Name: 06 
// Testcase goal: Member of type fix 'struct' in valuetype 
// Directory: vt_m02 

extern "C"
void test7(void)
{
   /* Accessor functions for fix struct member of valuetype Val */

  tet_printf("TC: Member of type fix 'struct' in valuetype\n");
  tp7.run();
}
extern "C"
void test8(void)
{
   /* Modifier function for fix struct member of valuetype Val */

  tet_printf("TC: Member of type fix 'struct' in valuetype\n");
  tp8.run();
}

// Test case Nr. 7 
// Name: 07 
// Testcase goal: Member of type var 'struct' in valuetype 
// Directory: vt_m02 

extern "C"
void test9(void)
{
   /* Accessor functions for var struct member of valuetype Val */

  tet_printf("TC: Member of type var 'struct' in valuetype\n");
  tp9.run();
}
extern "C"
void test10(void)
{
   /* Modifier function for var struct member of valuetype Val */

  tet_printf("TC: Member of type var 'struct' in valuetype\n");
  tp10.run();
}

// Test case Nr. 8 
// Name: 08 
// Testcase goal: Member of type fix 'union' in valuetype 
// Directory: vt_m02 

extern "C"
void test11(void)
{
   /* Accessor functions for fix union member of valuetype Val */

  tet_printf("TC: Member of type fix 'union' in valuetype\n");
  tp11.run();
}
extern "C"
void test12(void)
{
   /* Modifier function for fix union member of valuetype Val */

  tet_printf("TC: Member of type fix 'union' in valuetype\n");
  tp12.run();
}

// Test case Nr. 9 
// Name: 09 
// Testcase goal: Member of type var 'union' in valuetype 
// Directory: vt_m02 

extern "C"
void test13(void)
{
   /* Accessor functions for var union member of valuetype Val */

  tet_printf("TC: Member of type var 'union' in valuetype\n");
  tp13.run();
}
extern "C"
void test14(void)
{
   /* Modifier function for var union member of valuetype Val */

  tet_printf("TC: Member of type var 'union' in valuetype\n");
  tp14.run();
}
