/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing Valuetype inheritance 
// Test subgroup description: Testing  a  (abstract) valuetype supporting an (abstract) interface 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Valuetype supporting interface 
// Directory: vti_si01 


extern "C"
void test1(void)
{
   /* Operations of an  interface in the class for a valuetype supporting the interface */

  tet_printf("TC: Valuetype supporting interface\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Existence of POA_ skeleton class POA_Val for valuetype Val (server side) */

  tet_printf("TC: Valuetype supporting interface\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* POA_Val inheritance from class Val and from class POA_Itf for the valuetype Val supporting the interface Itf (server side) */

  tet_printf("TC: Valuetype supporting interface\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Existence of class OBV_Val for valuetype Val */

  tet_printf("TC: Valuetype supporting interface\n");
  tp4.run();
}
