//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
// Copyright (c) 2001 Object Oriented Concepts GmbH.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include "idlmacros.hh"

class siiServer_imp : public virtual POA_siiServer
{
  void Prunes1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Float Brocoli1(CORBA::Float p1,CORBA::Float &p2,CORBA::Float &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Double GrannySmith1(CORBA::Double p1,CORBA::Double &p2,CORBA::Double &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Long BrazilNut1(CORBA::Long p1,CORBA::Long &p2,CORBA::Long &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Short SweetPotato1(CORBA::Short p1,CORBA::Short &p2,CORBA::Short &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::ULong Tangarine1(CORBA::ULong p1,CORBA::ULong &p2,CORBA::ULong &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort Billberries1(CORBA::UShort p1,CORBA::UShort &p2,CORBA::UShort &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Char CantelopeMelon1(CORBA::Char p1,CORBA::Char &p2,CORBA::Char &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Boolean LolloRossa1(CORBA::Boolean p1,CORBA::Boolean &p2,CORBA::Boolean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Octet RowanBerry1(CORBA::Octet p1,CORBA::Octet &p2,CORBA::Octet &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Object_ptr Sweetcorn1(CORBA::Object_ptr p1,CORBA::Object_out p2,CORBA::Object_ptr &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * Onion1(const char * p1,CORBA::String_out p2,char * &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * Shallots1(const char * p1,CORBA::String_out p2,char * &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Long Plum1(CORBA::Boolean &p1,CORBA::Octet p2,CORBA::UShort p3,CORBA::Boolean &p4 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort KidneyBean1(CORBA::ULong &p1,const char * p2,CORBA::Double &p3,CORBA::String_out p4,CORBA::Boolean &p5,CORBA::Char &p6,CORBA::Short &p7,CORBA::Octet &p8,const char * p9,CORBA::Octet p10,CORBA::Short &p11,CORBA::UShort &p12,CORBA::Float &p13,CORBA::UShort &p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort Zucchini1(CORBA::Long &p1,char * &p2,const char * p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * ButterBean1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Octet Avocado1(CORBA::Boolean &p1,CORBA::Char p2,CORBA::Char &p3,CORBA::Octet &p4,CORBA::Char p5,CORBA::Boolean &p6,CORBA::Double p7,CORBA::Boolean &p8,const char * p9,CORBA::Long &p10,CORBA::UShort &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * GoldenDelicous1(CORBA::Boolean p1,CORBA::Long p2,CORBA::Octet p3,CORBA::Boolean &p4,CORBA::Long &p5,CORBA::UShort &p6,CORBA::Short p7,CORBA::Float p8,CORBA::Boolean &p9,CORBA::ULong &p10,char * &p11,CORBA::ULong &p12,CORBA::Double p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * Lentil1(char * &p1,CORBA::Float p2,CORBA::Boolean &p3,CORBA::Long &p4,CORBA::Octet &p5,CORBA::ULong &p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort Fig1(CORBA::Float &p1,CORBA::Float &p2,CORBA::Float p3,CORBA::Double p4,CORBA::Char &p5,CORBA::Short &p6,CORBA::ULong p7,CORBA::Double &p8,CORBA::UShort &p9,CORBA::Char &p10,CORBA::ULong &p11,CORBA::UShort p12,char * &p13,CORBA::Float p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Char CrabApple1(CORBA::Double p1,CORBA::Octet &p2,CORBA::Boolean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * RedOnion1(CORBA::ULong &p1,CORBA::Short &p2,CORBA::Double &p3,CORBA::Short &p4,CORBA::Boolean &p5,CORBA::Float p6,CORBA::Char p7,CORBA::Octet p8,CORBA::Double &p9,CORBA::Octet &p10,CORBA::Long &p11,CORBA::Float p12,CORBA::UShort &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Octet HazelNut1(CORBA::Short &p1,CORBA::Octet &p2,CORBA::Double p3,const char * p4,CORBA::Short p5,CORBA::Double &p6,CORBA::Double &p7,CORBA::ULong p8,CORBA::Boolean &p9,CORBA::ULong &p10,CORBA::Float &p11,CORBA::Float &p12,CORBA::UShort &p13,CORBA::Octet &p14,CORBA::UShort p15,CORBA::Long &p16,CORBA::Short p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Short Cinnamon1(CORBA::Long &p1,CORBA::Short &p2,CORBA::Octet p3,CORBA::ULong p4,CORBA::ULong &p5,CORBA::Double p6,CORBA::Char &p7,CORBA::Short &p8,CORBA::Char p9,CORBA::UShort &p10,CORBA::Char &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Long GooseBerry1(CORBA::Boolean &p1,CORBA::ULong p2,CORBA::Double &p3,CORBA::UShort &p4,const char * p5,CORBA::Float &p6,CORBA::UShort p7,CORBA::Long &p8,CORBA::UShort p9,CORBA::Long &p10,CORBA::Boolean &p11,CORBA::Octet &p12,CORBA::Short &p13,CORBA::Char p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Double EggPlant1(CORBA::Long &p1,CORBA::UShort &p2,CORBA::Short &p3,CORBA::Short p4,CORBA::UShort &p5,CORBA::Double &p6,CORBA::Float &p7,CORBA::Octet p8,CORBA::String_out p9,CORBA::Char &p10,CORBA::Short &p11,CORBA::ULong p12,CORBA::Short &p13,CORBA::ULong &p14,CORBA::Long &p15,CORBA::Char &p16,CORBA::ULong p17,CORBA::Float &p18 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Short JuniperBerries1(CORBA::Double &p1,CORBA::Boolean &p2,CORBA::Octet &p3,CORBA::Float &p4,CORBA::Short &p5,CORBA::UShort &p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort Cloves1(CORBA::Double p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * Daikan1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Float Mustard1(CORBA::Octet p1,CORBA::Boolean p2,const char * p3,CORBA::Double p4,CORBA::Float &p5,CORBA::Char p6,CORBA::Char &p7,CORBA::Octet p8,CORBA::Long &p9,CORBA::UShort &p10 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort Strawberry1(CORBA::Long p1,CORBA::Char &p2,CORBA::Double p3,const char * p4,CORBA::Long &p5,CORBA::Boolean &p6,CORBA::Octet &p7,CORBA::Long &p8,CORBA::ULong p9,CORBA::Float &p10,CORBA::UShort &p11,CORBA::Short &p12 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * BreadFruit1(CORBA::Char p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort Thyme1(CORBA::Long &p1,CORBA::Float &p2,char * &p3,CORBA::Short &p4,CORBA::Double p5,CORBA::Octet &p6,const char * p7,CORBA::Char &p8,CORBA::Long p9,CORBA::Octet p10,CORBA::Long &p11,CORBA::Boolean p12,CORBA::ULong &p13,CORBA::ULong &p14,CORBA::Long &p15 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * Sweedes1(CORBA::Float &p1,CORBA::Short p2,CORBA::Char p3,CORBA::Octet &p4,CORBA::Short p5,CORBA::Float &p6,CORBA::Long p7,CORBA::Short &p8,CORBA::Float &p9,CORBA::Boolean &p10,CORBA::Char p11,CORBA::Boolean &p12,CORBA::Short p13,CORBA::Char &p14,CORBA::Long &p15,CORBA::Float p16,CORBA::Long &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Double Pomegranate1(CORBA::UShort &p1,CORBA::Boolean &p2,const char * p3,CORBA::Double p4,CORBA::Long &p5,CORBA::ULong &p6,CORBA::Char &p7,CORBA::Short &p8,CORBA::String_out p9,CORBA::Long p10,CORBA::ULong p11,CORBA::Float &p12,CORBA::Double &p13,CORBA::Octet &p14,CORBA::Long &p15,CORBA::Boolean p16,CORBA::ULong p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::ULong Tarragon1(CORBA::Long p1,CORBA::Octet p2,CORBA::Octet p3,CORBA::Long p4,CORBA::Octet &p5,CORBA::ULong p6,CORBA::UShort &p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Char Lettuce1(CORBA::Char &p1,CORBA::ULong p2,CORBA::Double p3,CORBA::Char &p4,CORBA::Octet p5,CORBA::Char &p6,CORBA::String_out p7,CORBA::Float p8,CORBA::Octet p9,CORBA::Boolean p10,CORBA::Boolean &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort Mangetout1(CORBA::Float &p1,CORBA::Float &p2,CORBA::UShort &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Double Cress1(CORBA::String_out p1,CORBA::Char &p2,CORBA::Double &p3,CORBA::Char &p4,CORBA::Long p5,CORBA::Double &p6,CORBA::Long p7,CORBA::ULong p8 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Short BambooShoot1(const char * p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Octet Cassava1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Float Melon1(CORBA::UShort &p1,CORBA::Boolean &p2,CORBA::UShort &p3,CORBA::Long p4,CORBA::Short p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Float RedGrapes1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RedGrapes1(CORBA::Float _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Double BeechNut1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BeechNut1(CORBA::Double _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Long Elderberry1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Elderberry1(CORBA::Long _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Short Kumquats1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Kumquats1(CORBA::Short _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::ULong Walnuts1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Walnuts1(CORBA::ULong _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort Fennell1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Fennell1(CORBA::UShort _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Char Uglifruit1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Uglifruit1(CORBA::Char _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Boolean Waterchestnut1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Waterchestnut1(CORBA::Boolean _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Octet Chickpea1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Chickpea1(CORBA::Octet _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Object_ptr Beetroot1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Beetroot1(CORBA::Object_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * Okra1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Okra1(const char * _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * Plantain1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Plantain1(const char * _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Float Blackcurrant1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Double Pineapple1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Long LimaBean1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Short Mangosteen1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::ULong Pear1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::UShort RedPepper1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Char BeefTomatoes1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Boolean FrenchBeans1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Octet Sharanfruit1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Object_ptr Radish1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  char * Cherry1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  char * Papaya1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::Record2_slice * Susander1(CORBA::String_out p1,const ::Radish &p2,const ::GaliaMelon3 &p3,::Rasin2 &p4 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Raspberry1_slice * Grapefruit1(::Fig_out p1,const ::Chestnut1 p2,::Squash2_out p3,::GoldenDelicous3_out p4,::Fig_out p5,::Peppercorn &p6,CORBA::UShort &p7,::Cauliflower2_out p8,const ::BlackEyedBeans &p9,const ::WaterMelon3 p10,::Turnip3_out p11,::Fig &p12,::Cauliflower2_out p13,::Radish &p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::UShort PepinoMelon1(CORBA::Long &p1,::Tomato2 &p2,const ::Fig &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Cauliflower2* Peanutsquash1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::Tomato2* Artichokes1(::Squash1_out p1,CORBA::ULong p2,CORBA::ULong &p3,::GardenPeas1 &p4,const ::Tomato2 &p5,::YellowPepper2 &p6,const ::Dates3 &p7,::Radish &p8,const ::Blackberry2 &p9,::Rasin2_out p10,::Mangosteen3_out p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Damsons2_slice * Rasin1(const ::Raspberry1 p1,const ::Mangosteen3 &p2,const ::Fig &p3,::Lychees3_out p4,::Carrots p5,::Rasin2_out p6,const ::GoldenDelicous3 &p7,const ::Mullberry1 p8,::Squash1 &p9,::YellowPepper2 &p10,::YellowPepper2 &p11,::GardenPeas3 &p12,const ::Tomato2 &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chives2* Chives1(::Tomato &p1,::Peanuts1 p2,::Clementine2 &p3,::Squash1_out p4,::Squash2_out p5,::Oregano3_out p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mullberry1_slice * Eddo1(::Chestnut1 p1,::Dates3 &p2,const ::Oregano3 &p3,const ::Rasin2 &p4,::Mangosteen3 &p5,::Squash2 &p6,const ::Oregano3 &p7,::Tomato2_out p8,::BambooShoot3_out p9,::Turnip3_out p10,::Rasin2 &p11,const ::Fennell3 &p12,::GoldenDelicous3 &p13,const ::Mullberry1 p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chives2* GreenChilly1(const ::Chestnut1 p1,::Carrots p2,::Dates3_out p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Corn1_slice * Peach1(CORBA::Long &p1,::Tomato2 &p2,::Tomato_out p3,::Asparagus_out p4,::Cauliflower2_out p5,const ::Raspberry1 p6,const ::Peppercorn &p7,const ::WaterMelon &p8,::Cauliflower2_out p9,::Chives2_out p10,::Mullberry1 p11,const ::Blackberry2 &p12,::Fennell3_out p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Squash1* Parsley1(::GardenPeas3 &p1,::Squash2 &p2,const ::Dates3 &p3,::Peanuts1 p4,CORBA::Long p5,::Grapefruit2 &p6,::WaterMelon3 p7,CORBA::ULong p8,::WaterMelon3 p9,::Squash2 &p10,::Radish_out p11,::Mangosteen3 &p12,::BlackEyedBeans &p13,CORBA::UShort &p14,const ::BritishQueens1 &p15,::YellowPepper2_out p16,CORBA::UShort p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GaliaMelon3* Satsuma1(::Pumpkin p1,CORBA::Short &p2,const ::Mullberry1 p3,const ::Clementine2 &p4,::BambooShoot3_out p5,const ::BlackEyedBeans &p6,::Raspberry1 p7,::Oregano3_out p8,const ::Record2 p9,::Celeriac2 &p10,::Grapefruit2 &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Peanuts1 Basil1(::Mullberry1 p1,const ::Dates3 &p2,::Blackberry2 &p3,::Squash2_out p4,const ::Damsons2 p5,::Corn1 p6,const ::Oregano3 &p7,::Turnip3 &p8,const ::Mullberry1 p9,::Clementine2 &p10,::Grapefruit2_out p11,::Peanuts1 &p12,::Tomato2 &p13,const ::Dates3 &p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Octet CoxPippin1(::YellowPepper2 &p1,::BrazilNut3 &p2,::Grapefruit2_out p3,CORBA::Double p4,::Corn1 p5,::Fig_out p6,::Susander2 &p7,::Peanuts1 p8,::Mullberry1 p9,::Celeriac2_out p10,::Cauliflower2_out p11,const ::Beetroot2 &p12,::Clementine2 &p13,::WaterMelon3 p14,::Dates3 &p15,::Squash2_out p16,CORBA::ULong p17,::Damsons2 p18 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chives2* Blackberry1(::Rasin2_out p1,::Squash1_out p2,::BritishQueens1 &p3,::Fennell3 &p4,::Tomato2_out p5,::Blackberry2 &p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Tomato2* GreenPepper1(const ::Mullberry1 p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chives2* Scallion1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::YellowPepper2* Currant1(const ::Asparagus &p1,const ::LoganBerry &p2,const ::Squash2 &p3,const ::Lychees3 &p4,CORBA::ULong &p5,const ::Corn1 p6,::BlackEyedBeans_out p7,const ::GardenPeas3 &p8,::Dates3_out p9,CORBA::Float &p10 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chestnut1_slice * IcebergLettuce1(const ::Susander2 &p1,::Squash2_out p2,CORBA::Boolean p3,const ::Fig &p4,CORBA::Long &p5,CORBA::Double &p6,::Dates3 &p7,::Oregano3_out p8,const ::BritishQueens1 &p9,::Tomato2_out p10,::Squash2_out p11,::Peanuts1 &p12 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Fennell3* Tomato1(const ::Squash2 &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Celeriac2* PippinApple1(::BambooShoot3 &p1,::BeechNut2 &p2,CORBA::Float &p3,::Chestnut1 p4,const ::BambooShoot3 &p5,::Corn1 p6,CORBA::Long p7,::Blackberry2_out p8,const ::Tomato2 &p9,const ::Fig &p10,::Squash1 &p11,const ::Clementine2 &p12,::Squash1_out p13,::GaliaMelon3_out p14,::Fig &p15 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Rasin2* Celeriac1(::Corn1 p1,const ::Dates3 &p2,const ::Squash2 &p3,::Fig_out p4,const ::LoganBerry &p5,::BritishQueens1_out p6,const ::Record2 p7,::Mullberry1 p8,::YellowPepper2 &p9,::GaliaMelon3 &p10,const ::BrazilNut3 &p11,CORBA::UShort &p12,const ::Fig &p13,::BeechNut2 &p14,CORBA::Float &p15,const ::Grapefruit2 &p16,CORBA::Long &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Tomato2* Cauliflower1(::Dates3_out p1,::LoganBerry_out p2,const ::Lychees3 &p3,const ::Celeriac2 &p4,::BambooShoot3 &p5,::Susander2_out p6,::Peanuts1 &p7,CORBA::Double &p8,::Currant2_out p9,const ::Tomato2 &p10,const ::BeechNut2 &p11,CORBA::UShort &p12,::YellowPepper2 &p13,::GaliaMelon3 &p14,CORBA::ULong &p15,const ::GaliaMelon3 &p16,const ::Beetroot2 &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lychees3* Corriander1(const ::Record2 p1,const ::BambooShoot3 &p2,const ::Oregano3 &p3,CORBA::ULong p4,::Chives2 &p5,const ::Turnip3 &p6,::Cauliflower2_out p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BrazilNut3* RedCabbage1(::BritishQueens1_out p1,const ::Celeriac2 &p2,const ::Squash2 &p3,CORBA::Octet &p4,const ::Fig &p5,::Record2 p6,::Turnip3_out p7,CORBA::Float p8,const ::BritishQueens1 &p9,const ::YellowPepper2 &p10,::Cauliflower2 &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Radish* ChineseLeaves1(::BritishQueens1_out p1,::GaliaMelon3 &p2,::Mangosteen3 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Squash2* Potato1(::Squash2_out p1,::Lychees3 &p2,::Turnip3_out p3,::Mangosteen3 &p4,const ::Currant2 &p5,::WaterMelon3 p6,const ::Lychees3 &p7,const ::BritishQueens1 &p8 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BrazilNut3* Homeguard1(const ::Chives2 &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BritishQueens1* Wilja1( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::Grapefruit2* KerrsPinks1(::Dates3_out p1,char * &p2,::Squash1 &p3,const ::Clementine2 &p4,const ::Cauliflower2 &p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr GoldenWonder1(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_ptr p9,CORBA::TypeCode_ptr p10,CORBA::TypeCode_out p11,CORBA::TypeCode_out p12,CORBA::TypeCode_ptr p13,CORBA::TypeCode_ptr &p14,CORBA::TypeCode_out p15,CORBA::TypeCode_ptr p16,CORBA::TypeCode_ptr &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Pimpernel1(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Cultra1(CORBA::TypeCode_ptr &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Rooster1(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_out p7,CORBA::TypeCode_out p8,CORBA::TypeCode_ptr &p9,CORBA::TypeCode_out p10,CORBA::TypeCode_ptr &p11,CORBA::TypeCode_out p12 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr MarisPiper1(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_out p4,CORBA::TypeCode_out p5,CORBA::TypeCode_out p6,CORBA::TypeCode_ptr &p7,CORBA::TypeCode_out p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr p10,CORBA::TypeCode_ptr &p11,CORBA::TypeCode_out p12,CORBA::TypeCode_ptr &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Cara1(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4,CORBA::TypeCode_ptr p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr KingEdward1(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_ptr &p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_out p9,CORBA::TypeCode_out p10,CORBA::TypeCode_ptr &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr PentlandDell1(CORBA::TypeCode_out p1,CORBA::TypeCode_out p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_ptr p8 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Apple2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_out p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr &p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_ptr &p9,CORBA::TypeCode_out p10,CORBA::TypeCode_ptr p11,CORBA::TypeCode_ptr p12,CORBA::TypeCode_ptr &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Banana2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_out p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Carrots2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_out p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_out p5,CORBA::TypeCode_out p6,CORBA::TypeCode_ptr &p7,CORBA::TypeCode_ptr &p8,CORBA::TypeCode_out p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Lemon2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_out p7,CORBA::TypeCode_out p8,CORBA::TypeCode_ptr p9,CORBA::TypeCode_ptr p10 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr BlackCherry2(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_out p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_ptr &p8,CORBA::TypeCode_out p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Starfruit2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6,CORBA::TypeCode_out p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr p10,CORBA::TypeCode_ptr &p11,CORBA::TypeCode_ptr &p12 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Rhubarb2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6,CORBA::TypeCode_out p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr PassionFruit2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Pumpkin2(CORBA::TypeCode_out p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr &p10,CORBA::TypeCode_ptr p11,CORBA::TypeCode_ptr p12,CORBA::TypeCode_out p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Mango2(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4,CORBA::TypeCode_out p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_out p7,CORBA::TypeCode_ptr p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr &p10,CORBA::TypeCode_ptr &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr WaterMelon2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_out p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr p10,CORBA::TypeCode_ptr p11,CORBA::TypeCode_ptr &p12,CORBA::TypeCode_ptr &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Lime2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_ptr &p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Dates2(CORBA::TypeCode_out p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_out p5,CORBA::TypeCode_ptr &p6,CORBA::TypeCode_out p7,CORBA::TypeCode_ptr p8 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Coconut2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Lychees2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_ptr &p4,CORBA::TypeCode_ptr &p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Cabbage2(CORBA::TypeCode_ptr &p1,CORBA::TypeCode_ptr &p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr &p5,CORBA::TypeCode_out p6,CORBA::TypeCode_ptr p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Cucumber2(CORBA::TypeCode_out p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Ginger2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Apricots2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_ptr p3,CORBA::TypeCode_out p4,CORBA::TypeCode_out p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_ptr p7,CORBA::TypeCode_out p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr &p10,CORBA::TypeCode_ptr &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr BlackEyedBeans2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_out p2,CORBA::TypeCode_out p3,CORBA::TypeCode_ptr p4,CORBA::TypeCode_ptr p5,CORBA::TypeCode_ptr p6,CORBA::TypeCode_out p7,CORBA::TypeCode_out p8,CORBA::TypeCode_out p9,CORBA::TypeCode_ptr p10 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Leek2(CORBA::TypeCode_ptr p1,CORBA::TypeCode_ptr p2,CORBA::TypeCode_ptr &p3,CORBA::TypeCode_out p4 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Mint2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr GardenPeas2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GardenPeas2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Asparagus2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Asparagus2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr GaliaMelon2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GaliaMelon2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Sultana2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Sultana2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Turnip2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Turnip2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Orange2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Orange2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr LoganBerry2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void LoganBerry2(CORBA::TypeCode_ptr _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Parsnip2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Celery2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr WhiteCabbage2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Aniseed2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Bayleaf2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Dill2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Oregano2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Any* Beansprout2(const CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Almonds2(CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any_out p3,const CORBA::Any &p4,CORBA::Any &p5,const CORBA::Any &p6,const CORBA::Any &p7,const CORBA::Any &p8,CORBA::Any_out p9,const CORBA::Any &p10,const CORBA::Any &p11,CORBA::Any &p12,const CORBA::Any &p13,const CORBA::Any &p14,const CORBA::Any &p15 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Guava2(const CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any_out p5,CORBA::Any_out p6,CORBA::Any_out p7,CORBA::Any &p8,CORBA::Any_out p9,CORBA::Any_out p10,const CORBA::Any &p11,CORBA::Any &p12,CORBA::Any_out p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Mushroom2(CORBA::Any &p1,const CORBA::Any &p2,CORBA::Any &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Runnerbean2(CORBA::Any_out p1,CORBA::Any_out p2,const CORBA::Any &p3,CORBA::Any &p4,const CORBA::Any &p5,const CORBA::Any &p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Tofu2(CORBA::Any &p1,const CORBA::Any &p2,const CORBA::Any &p3,CORBA::Any &p4,CORBA::Any &p5,const CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any &p8,const CORBA::Any &p9,CORBA::Any &p10,CORBA::Any_out p11,CORBA::Any_out p12,const CORBA::Any &p13,CORBA::Any_out p14,CORBA::Any_out p15,const CORBA::Any &p16,const CORBA::Any &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Prunes2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any_out p3,CORBA::Any &p4,CORBA::Any &p5,CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any_out p8,CORBA::Any &p9,CORBA::Any_out p10 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Brocoli2(CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any_out p5,CORBA::Any_out p6,const CORBA::Any &p7,const CORBA::Any &p8,CORBA::Any &p9,CORBA::Any_out p10,CORBA::Any_out p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* GrannySmith2(const CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any_out p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* BrazilNut2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any &p3,CORBA::Any &p4,CORBA::Any &p5,CORBA::Any &p6,const CORBA::Any &p7,const CORBA::Any &p8 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* SweetPotato2(CORBA::Any_out p1,CORBA::Any &p2,CORBA::Any_out p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any_out p6,const CORBA::Any &p7,CORBA::Any_out p8,CORBA::Any_out p9,CORBA::Any_out p10,CORBA::Any_out p11,CORBA::Any_out p12,const CORBA::Any &p13,CORBA::Any &p14,CORBA::Any &p15 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Tangarine2(const CORBA::Any &p1,const CORBA::Any &p2,const CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any &p5,const CORBA::Any &p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Billberries2(const CORBA::Any &p1,const CORBA::Any &p2,CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any &p5,const CORBA::Any &p6,CORBA::Any_out p7,const CORBA::Any &p8,CORBA::Any &p9,const CORBA::Any &p10,CORBA::Any &p11,CORBA::Any_out p12,CORBA::Any &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* CantelopeMelon2(CORBA::Any &p1,const CORBA::Any &p2,CORBA::Any_out p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any &p6,CORBA::Any_out p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* LolloRossa2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Any* RowanBerry2(CORBA::Any &p1,CORBA::Any &p2,CORBA::Any_out p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any_out p8,const CORBA::Any &p9,const CORBA::Any &p10,CORBA::Any_out p11,CORBA::Any &p12,CORBA::Any_out p13,CORBA::Any_out p14,CORBA::Any &p15,CORBA::Any &p16,CORBA::Any_out p17,const CORBA::Any &p18 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Sweetcorn2(CORBA::Any_out p1,const CORBA::Any &p2,CORBA::Any_out p3,CORBA::Any_out p4,CORBA::Any &p5,CORBA::Any_out p6,const CORBA::Any &p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Onion2(const CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any_out p5,CORBA::Any_out p6,const CORBA::Any &p7,CORBA::Any &p8,CORBA::Any &p9,CORBA::Any_out p10,CORBA::Any_out p11,const CORBA::Any &p12,CORBA::Any &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Shallots2(CORBA::Any &p1,CORBA::Any &p2,CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any_out p5,CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any_out p8,CORBA::Any_out p9,const CORBA::Any &p10,const CORBA::Any &p11,CORBA::Any &p12,const CORBA::Any &p13,CORBA::Any &p14,const CORBA::Any &p15,CORBA::Any_out p16,CORBA::Any_out p17,const CORBA::Any &p18 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Plum2(CORBA::Any &p1,CORBA::Any_out p2,const CORBA::Any &p3,const CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any_out p6,CORBA::Any_out p7,const CORBA::Any &p8,CORBA::Any_out p9,const CORBA::Any &p10,const CORBA::Any &p11,const CORBA::Any &p12,const CORBA::Any &p13,CORBA::Any &p14,CORBA::Any &p15,CORBA::Any_out p16 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* KidneyBean2(CORBA::Any &p1,const CORBA::Any &p2,const CORBA::Any &p3,CORBA::Any_out p4,CORBA::Any_out p5,const CORBA::Any &p6,CORBA::Any &p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Zucchini2(CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any_out p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* ButterBean2(CORBA::Any &p1,CORBA::Any_out p2,CORBA::Any_out p3,CORBA::Any &p4,CORBA::Any_out p5,CORBA::Any_out p6,const CORBA::Any &p7,CORBA::Any_out p8,CORBA::Any &p9,CORBA::Any &p10,const CORBA::Any &p11,const CORBA::Any &p12,CORBA::Any &p13,CORBA::Any_out p14,const CORBA::Any &p15,CORBA::Any_out p16,const CORBA::Any &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Avocado2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any_out p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any &p6,CORBA::Any &p7,const CORBA::Any &p8,const CORBA::Any &p9,CORBA::Any_out p10,CORBA::Any_out p11,const CORBA::Any &p12,CORBA::Any &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* GoldenDelicous2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any_out p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Lentil2(CORBA::Any &p1,CORBA::Any &p2,const CORBA::Any &p3,const CORBA::Any &p4,CORBA::Any &p5,CORBA::Any &p6,CORBA::Any &p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Fig2(CORBA::Any_out p1,const CORBA::Any &p2,CORBA::Any &p3,CORBA::Any_out p4,const CORBA::Any &p5,CORBA::Any &p6,CORBA::Any_out p7,CORBA::Any_out p8,const CORBA::Any &p9,const CORBA::Any &p10,CORBA::Any &p11,CORBA::Any_out p12,CORBA::Any &p13,const CORBA::Any &p14,CORBA::Any &p15,const CORBA::Any &p16,CORBA::Any &p17,CORBA::Any &p18,CORBA::Any_out p19 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* CrabApple2(CORBA::Any_out p1,CORBA::Any_out p2,CORBA::Any &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* RedOnion2(CORBA::Any_out p1,CORBA::Any &p2,CORBA::Any_out p3,const CORBA::Any &p4,CORBA::Any &p5,const CORBA::Any &p6,CORBA::Any &p7,CORBA::Any &p8,CORBA::Any_out p9,CORBA::Any &p10,const CORBA::Any &p11,CORBA::Any &p12,CORBA::Any &p13,const CORBA::Any &p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* HazelNut2(const CORBA::Any &p1,CORBA::Any &p2,CORBA::Any &p3,CORBA::Any &p4,const CORBA::Any &p5,CORBA::Any_out p6,CORBA::Any_out p7,const CORBA::Any &p8,CORBA::Any &p9,const CORBA::Any &p10,CORBA::Any_out p11,CORBA::Any &p12,CORBA::Any_out p13,CORBA::Any_out p14,CORBA::Any_out p15,CORBA::Any_out p16,CORBA::Any_out p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Cinnamon2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Cinnamon2(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* GooseBerry2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GooseBerry2(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* EggPlant2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void EggPlant2(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* JuniperBerries2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void JuniperBerries2(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Cloves2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Cloves2(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Daikan2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Daikan2(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Mustard2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Mustard2(const CORBA::Any &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Strawberry2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Any* BreadFruit2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Any* Thyme2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Any* Sweedes2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Any* Pomegranate2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Any* Tarragon2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Any* Lettuce2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Mangetout2(::YellowPepper2_out p1,const ::Dates3 &p2,const ::Pumpkin p3,::Record2 p4 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Turnip3* BambooShoot2(::Currant2_out p1,const ::Fennell3 &p2,::Peanuts1 &p3,::GardenPeas3_out p4,::Squash2_out p5,::BritishQueens1_out p6,::Celeriac2_out p7,::Rasin2_out p8,::Peanuts1 p9,const ::Fennell3 &p10,::Dates3_out p11,::Squash1 &p12,CORBA::UShort &p13,::Dates3 &p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Squash2* Melon2(::Asparagus &p1,::Peanuts1 &p2,const ::Fennell3 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  char * RedGrapes2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::BeechNut2* Elderberry2(::Oregano3_out p1,const ::Squash2 &p2,CORBA::TypeCode_out p3,::GoldenDelicous3 &p4,const ::Corn1 p5,::GardenPeas3 &p6,const ::Chives2 &p7,::Squash2 &p8,CORBA::Long p9,::Raspberry1 p10,::Corn1 p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Char Kumquats2(const ::Rasin2 &p1,const ::Squash2 &p2,const ::Mullberry1 p3,CORBA::Double &p4,::GaliaMelon3_out p5,CORBA::Double &p6,const ::Pumpkin p7,::Peanuts1 p8,CORBA::Any &p9,::Oregano3 &p10,::GaliaMelon3 &p11,CORBA::UShort &p12,CORBA::Float p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Cauliflower2* Fennell2(::Beetroot2 &p1,const ::Mullberry1 p2,::Carrots p3,CORBA::TypeCode_out p4,::BeechNut2_out p5,CORBA::Long &p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Uglifruit2(CORBA::String_out p1,::Turnip3 &p2,const ::Peppercorn &p3,CORBA::ULong p4,::GardenPeas1 &p5,::Squash2 &p6,const ::Raspberry1 p7,::Susander2_out p8,CORBA::Object_out p9,::BrazilNut3_out p10,::Corn1 p11,const ::GaliaMelon3 &p12,::BritishQueens1 &p13,const ::BritishQueens1 &p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Dates3* Chickpea2(const ::Squash1 &p1,::Tomato2_out p2,CORBA::String_out p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Beetroot2* Okra2(::Squash1 &p1,CORBA::Float &p2,::Tomato2_out p3,::Chives2_out p4,::GaliaMelon3_out p5,CORBA::Object_ptr p6,const ::Blackberry2 &p7,const ::Rasin2 &p8,::Fennell3_out p9,CORBA::String_out p10,::Oregano3 &p11,const ::GaliaMelon3 &p12,::Peanuts1 &p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Float Plantain2(CORBA::Long &p1,::Susander2 &p2,const ::Fig &p3,const ::Tomato2 &p4,const ::Cauliflower2 &p5,::Oregano3 &p6,::Mangosteen3 &p7,const ::Squash1 &p8,::LoganBerry_out p9,::Squash2 &p10,::Tomato_out p11,::LoganBerry &p12,::Tomato2 &p13,::GaliaMelon3_out p14,CORBA::TypeCode_ptr p15,::BritishQueens1_out p16,const ::Susander2 &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Blackcurrant2(::Susander2_out p1,::Chives2 &p2,const ::Damsons2 p3,const ::GardenPeas1 &p4,::Tomato_out p5,const ::WaterMelon3 p6,::Susander2_out p7,CORBA::TypeCode_out p8,const ::Damsons2 p9,::Currant2 &p10,CORBA::Boolean &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Object_ptr Pineapple2(::Fennell3_out p1,const ::Carrots p2,::Chestnut1 p3,::GardenPeas1_out p4,CORBA::Float p5,CORBA::TypeCode_ptr &p6,const ::Dates3 &p7,::BeechNut2 &p8,CORBA::Float p9,::Rasin2 &p10,CORBA::Char &p11,::Mullberry1 p12,::BlackEyedBeans &p13,const ::Squash2 &p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Cauliflower2* Mangosteen2(CORBA::Octet &p1,CORBA::Any &p2,::Fig_out p3,const ::Damsons2 p4,CORBA::Double &p5,::GaliaMelon3_out p6,CORBA::Object_ptr &p7,CORBA::Short p8,::WaterMelon3 p9,::Currant2_out p10,::Peanuts1 &p11,CORBA::Float p12,::BrazilNut3 &p13,::WaterMelon3 p14,::Susander2 &p15,::Tomato2_out p16,const ::GaliaMelon3 &p17,::Fennell3_out p18 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Pear2(::Squash1_out p1,::Fig_out p2,CORBA::TypeCode_ptr &p3,CORBA::Octet &p4,::BritishQueens1_out p5,::Dates3 &p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Celeriac2* BeefTomatoes2(const ::Fig &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Fennell3* Sharanfruit2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::Cauliflower2* Cherry2(const ::GoldenDelicous3 &p1,CORBA::Object_ptr p2,const ::Susander2 &p3,CORBA::TypeCode_ptr p4,::Cauliflower2 &p5,const ::Fig &p6,::Fennell3_out p7,const ::Rasin2 &p8,::Currant2_out p9,CORBA::Boolean &p10 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Oregano3* Peppercorn2(const ::GoldenDelicous3 &p1,::Dates3_out p2,const ::Tomato2 &p3,const ::Fennell3 &p4,CORBA::Octet &p5,::Peanuts1 &p6,::Raspberry1 p7,CORBA::Short &p8,const ::WaterMelon &p9,CORBA::Any_out p10,::Fennell3_out p11,::Fennell3 &p12 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Susander2* Raspberry2(const ::Mullberry1 p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Grapefruit2* PepinoMelon2(::Dates3 &p1,::Peppercorn &p2,::Fig &p3,::Tomato2_out p4,const ::Cauliflower2 &p5,::BritishQueens1_out p6,CORBA::ULong p7,::Mullberry1 p8,const ::Cauliflower2 &p9,const ::Squash2 &p10,::Asparagus &p11,const ::Squash2 &p12,::Beetroot2_out p13,CORBA::Object_out p14,::Rasin2 &p15 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Damsons2_slice * Peanutsquash2(::Rasin2 &p1,CORBA::ULong p2,const ::Mangosteen3 &p3,::Chestnut1 p4,const ::Dates3 &p5,CORBA::ULong &p6,const ::Squash2 &p7,::Susander2 &p8,::Fig &p9,::Grapefruit2 &p10,CORBA::Object_ptr p11,::Turnip3_out p12,const ::Peppercorn &p13,::Squash2 &p14,::Dates3_out p15,const ::Rasin2 &p16,::Tomato_out p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GaliaMelon3* Artichokes2(::Blackberry2_out p1,::Dates3_out p2,const ::Tomato2 &p3,const ::Squash1 &p4,::Mangosteen3 &p5,::WaterMelon_out p6,CORBA::Octet &p7,::Susander2 &p8,CORBA::UShort &p9,CORBA::TypeCode_ptr p10,const ::Grapefruit2 &p11,::Cauliflower2 &p12,::Currant2 &p13,::Fig &p14,CORBA::TypeCode_out p15,const ::Chestnut1 p16,const ::Corn1 p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr GreenGrapes2(const ::WaterMelon &p1,const ::Fig &p2,const ::Celeriac2 &p3,const ::Corn1 p4,char * &p5,const ::GoldenDelicous3 &p6,::GaliaMelon3_out p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Rasin2* CookingApple2(CORBA::Long &p1,const ::Cauliflower2 &p2,const ::Tomato2 &p3,::Tomato2_out p4,const ::Celeriac2 &p5,::BambooShoot3_out p6,::Currant2_out p7,const ::Cauliflower2 &p8,const ::BlackEyedBeans &p9,const ::BlackEyedBeans &p10,::Dates3 &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chives2* Mullberry2(CORBA::Object_out p1,::Cauliflower2 &p2,::Tomato2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GoldenDelicous3* Yam2(::WaterMelon3 p1,CORBA::Any &p2,CORBA::String_out p3,::IcebergLettuce2 &p4,CORBA::UShort p5,::Dates3 &p6,CORBA::Boolean p7,const ::GaliaMelon3 &p8 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Short GreenChilly2(const ::Mullberry1 p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Corn2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  CORBA::Char Peach2(CORBA::Double &p1,::Asparagus &p2,::Carrots p3,::Peanuts1 p4,const ::GaliaMelon3 &p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Squash2* Parsley2(const ::Pumpkin p1,const ::LoganBerry &p2,const ::Cauliflower2 &p3,::YellowPepper2_out p4,const ::Mangosteen3 &p5,::Susander2 &p6,::Asparagus &p7,CORBA::Float &p8,CORBA::Octet &p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::YellowPepper2* Satsuma2(const ::Susander2 &p1,const ::Squash1 &p2,::GardenPeas3_out p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BambooShoot3* Basil2(::Peppercorn &p1,::Oregano3 &p2,::Fig &p3,::Dates3 &p4,const ::Clementine2 &p5,CORBA::Boolean p6,::Carrots p7,::Raspberry1 p8,::Rasin2 &p9,::Clementine2 &p10,::Mangosteen3_out p11,::Pumpkin p12,CORBA::Float &p13,::Chestnut1 p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Record2_slice * Blueberry2(const ::Cauliflower2 &p1,::Asparagus &p2,::WaterMelon3 p3,::WaterMelon3 p4,::Dates3_out p5,::Lychees3_out p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Blackberry2* Chervil2(CORBA::Long &p1,const ::Susander2 &p2,CORBA::TypeCode_ptr &p3,const ::Peppercorn &p4,const ::Cauliflower2 &p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Boolean GreenPepper2(::Lychees3 &p1,CORBA::Float &p2,const ::BambooShoot3 &p3,::Record2 p4,const char * p5,::Tomato_out p6,::LoganBerry &p7,CORBA::Long &p8,const ::Corn1 p9,CORBA::Float &p10,CORBA::Long &p11,CORBA::Float &p12,const ::GardenPeas3 &p13,::BambooShoot3_out p14,CORBA::ULong &p15,const ::Squash1 &p16,::BrazilNut3_out p17,::Cauliflower2_out p18,const ::GardenPeas3 &p19 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mangosteen3* Scallion2(::Squash1 &p1,::Chestnut1 p2,::Raspberry1 p3,::Cauliflower2_out p4,::Oregano3_out p5,const ::Dates3 &p6,CORBA::Boolean p7 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Char PricklyPear2(::Asparagus &p1,const ::Fig &p2,::Fig &p3,const ::Beetroot2 &p4,::GoldenDelicous3 &p5,::GaliaMelon3_out p6,::Squash2 &p7,::Beetroot2 &p8,::Clementine2 &p9,::Tomato &p10,const ::GoldenDelicous3 &p11,::BeechNut2_out p12 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Currant2* Chestnut2(::Carrots p1,const ::Grapefruit2 &p2,CORBA::Boolean p3,const ::Fig &p4,::Fennell3_out p5,const ::Cauliflower2 &p6,CORBA::Any &p7,::GaliaMelon3 &p8,::Turnip3_out p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::IcebergLettuce2* KiwanoMelon2(::Asparagus_out p1,const ::Corn1 p2,::Peppercorn &p3,::Peppercorn &p4,::Fennell3 &p5,::Peanuts1 &p6,::Squash1 &p7,const ::Turnip3 &p8,CORBA::Any &p9,const ::BambooShoot3 &p10,::Lychees3_out p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Tomato2* Chayato2(::Beetroot2 &p1,::BambooShoot3_out p2,::BlackEyedBeans_out p3,const ::Squash2 &p4,::Turnip3 &p5,CORBA::TypeCode_ptr &p6,::Chestnut1 p7,char * &p8,::Record2 p9,::Tomato_out p10,const ::IcebergLettuce2 &p11,::Squash1 &p12,const ::Fennell3 &p13,const ::Pumpkin p14,CORBA::Char &p15,CORBA::TypeCode_ptr &p16,::BritishQueens1 &p17,::Turnip3_out p18 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GaliaMelon3* RedChilly2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::Celeriac2* GalaApple2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::Cauliflower2* Kiwi2(const ::Record2 p1,CORBA::Short p2,const ::Mullberry1 p3,::Susander2 &p4,const ::Tomato &p5,::Squash2_out p6,::Cauliflower2 &p7,::Carrots p8,::Record2 p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::ULong Corriander2(::Peppercorn &p1,const ::Susander2 &p2 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Clementine2* RedCabbage2(::Peanuts1 &p1,::Tomato2_out p2,CORBA::Object_ptr &p3,const ::Cauliflower2 &p4,::Asparagus_out p5,::Raspberry1 p6,::Record2 p7,::Susander2 &p8,const ::Asparagus &p9,::Rasin2_out p10,const ::Mangosteen3 &p11,const ::Chives2 &p12,::GaliaMelon3_out p13,const ::Grapefruit2 &p14,const ::Dates3 &p15,::BlackEyedBeans_out p16,::WaterMelon3 p17,CORBA::Object_ptr &p18,const ::WaterMelon3 p19 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Dates3* Broadbeans2(::WaterMelon_out p1,::Fennell3 &p2,::Oregano3 &p3,const ::Squash2 &p4,::Fig_out p5,::Grapefruit2_out p6,const ::WaterMelon &p7,::Fig &p8 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::ULong Potato2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  ::Record2_slice * Homeguard2(CORBA::Boolean &p1,::Lychees3 &p2,::Susander2 &p3,::Grapefruit2_out p4,CORBA::Char &p5,const ::Dates3 &p6,CORBA::Double p7,::GaliaMelon3 &p8,::Grapefruit2 &p9,const ::GardenPeas1 &p10,::Mullberry1 p11,CORBA::Long &p12,const CORBA::Any &p13,CORBA::ULong &p14,::Peanuts1 p15 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::WaterMelon3_slice * Wilja2(::Fig &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Balmoral2(const ::Currant2 &p1,const ::Turnip3 &p2,const ::BlackEyedBeans &p3,CORBA::Double p4,const ::Dates3 &p5,const ::Tomato2 &p6,const ::Raspberry1 p7,::Peanuts1 p8,CORBA::TypeCode_ptr p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void KerrsPinks2(const ::WaterMelon3 p1,const ::GaliaMelon3 &p2 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void GoldenWonder2( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Pimpernel2(const ::Tomato &p1,const ::Clementine2 &p2 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Cultra2(const ::Chestnut1 p1,CORBA::Char p2,CORBA::ULong p3,const ::IcebergLettuce2 &p4,CORBA::Short p5,const ::WaterMelon &p6,const ::Cauliflower2 &p7,const ::GardenPeas1 &p8,const ::Cauliflower2 &p9,const ::Corn1 p10,const ::Corn1 p11,CORBA::TypeCode_ptr p12,const ::WaterMelon3 p13,const ::Lychees3 &p14 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Rooster2(const ::GaliaMelon3 &p1,const ::Celeriac2 &p2,const CORBA::Any &p3,const ::BeechNut2 &p4,const ::BeechNut2 &p5,const ::Fennell3 &p6,const ::Dates3 &p7,const ::Blackberry2 &p8,const ::Fennell3 &p9,CORBA::UShort p10,const ::Cauliflower2 &p11,const ::WaterMelon3 p12,const ::Rasin2 &p13,const ::Dates3 &p14,const ::Fig &p15,const ::GaliaMelon3 &p16,const ::BritishQueens1 &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void MarisPiper2(const ::BeechNut2 &p1,const ::Pumpkin p2,CORBA::Double p3,const ::Tomato2 &p4,CORBA::Octet p5,const ::Record2 p6,CORBA::Double p7,const ::WaterMelon3 p8,const ::Squash2 &p9,const ::Record2 p10 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Cara2(CORBA::Short p1,const ::BrazilNut3 &p2,CORBA::Char p3,const ::GardenPeas3 &p4,const ::Fennell3 &p5,CORBA::Boolean p6,const ::Mullberry1 p7,const ::Susander2 &p8,CORBA::UShort p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void KingEdward2(const ::Squash2 &p1,CORBA::Float p2,const ::Cauliflower2 &p3,const ::Chives2 &p4,const ::Turnip3 &p5,const ::Squash2 &p6,const ::Tomato &p7,const ::Fig &p8,CORBA::Char p9,const ::GaliaMelon3 &p10,const ::Carrots p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void PentlandDell2(const char * p1,const ::Tomato2 &p2,const ::Asparagus &p3,const ::Dates3 &p4,const ::Tomato2 &p5,const ::Tomato2 &p6,CORBA::Octet p7,const ::Peppercorn &p8,const ::IcebergLettuce2 &p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Apple3(const ::Oregano3 &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Banana3(const ::Rasin2 &p1,CORBA::Double p2,const ::Fennell3 &p3,const ::IcebergLettuce2 &p4 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Carrots3(CORBA::Boolean p1,const ::Damsons2 p2,const ::Corn1 p3,::Peanuts1 p4,const ::Rasin2 &p5,const ::Chestnut1 p6,const ::WaterMelon3 p7,CORBA::Long p8 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Lemon3(const ::Fennell3 &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void BlackCherry3(const ::IcebergLettuce2 &p1,const ::Squash2 &p2,const ::Raspberry1 p3,const ::Susander2 &p4,const ::IcebergLettuce2 &p5,const ::Tomato2 &p6,const ::Mangosteen3 &p7,const ::BlackEyedBeans &p8,const ::Tomato2 &p9,const ::Record2 p10,CORBA::TypeCode_ptr p11,const ::Tomato2 &p12,const ::Fennell3 &p13,const ::Tomato2 &p14,const ::Tomato2 &p15,const ::Tomato2 &p16 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Starfruit3(const ::Asparagus &p1,const ::Squash2 &p2,const ::Tomato2 &p3,const ::Turnip3 &p4 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Rhubarb3(const ::IcebergLettuce2 &p1 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void PassionFruit3(const ::Cauliflower2 &p1,const ::WaterMelon &p2,::Peanuts1 p3,const ::GoldenDelicous3 &p4,CORBA::Long p5,const ::Oregano3 &p6,const ::Record2 p7,const ::Squash1 &p8,const ::Asparagus &p9,const ::Chives2 &p10,CORBA::Boolean p11,const ::BrazilNut3 &p12,const ::Susander2 &p13,CORBA::ULong p14,const ::Chives2 &p15 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  void Pumpkin3(const ::Turnip3 &p1,const ::Tomato2 &p2,const ::Cauliflower2 &p3,const ::Chives2 &p4,const ::Susander2 &p5,const ::Pumpkin p6,const ::Tomato &p7,const ::Mullberry1 p8,const ::Tomato2 &p9,const ::LoganBerry &p10,const ::GaliaMelon3 &p11,const ::Grapefruit2 &p12,const ::Record2 p13,const ::GaliaMelon3 &p14,const ::Cauliflower2 &p15,const ::Rasin2 &p16,const ::IcebergLettuce2 &p17,const ::Cauliflower2 &p18 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Double Mango3(::LoganBerry_out p1,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::WaterMelon3_slice * Lime3(CORBA::ULong p1,::Grapefruit2 &p2,const ::GaliaMelon3 &p3,CORBA::Any &p4,const CORBA::Any &p5,::LoganBerry_out p6,::Cauliflower2_out p7,CORBA::Float p8,const ::Currant2 &p9,::BritishQueens1_out p10,const char * p11,::Corn1 p12,const ::Mangosteen3 &p13,::Fig_out p14,::Pumpkin p15,const ::Chives2 &p16,::Fennell3_out p17,::Fig &p18,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Dates3* Coconut3(CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Lychees3* Cabbage3(const ::IcebergLettuce2 &p1,::Cauliflower2_out p2,::Rasin2 &p3,::Susander2 &p4,::Currant2 &p5,::Squash2 &p6,const ::Fennell3 &p7,::Record2 p8,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GaliaMelon3* Ginger3(const ::Squash2 &p1,const char * p2,::BrazilNut3_out p3,::Cauliflower2_out p4,::BlackEyedBeans_out p5,::BambooShoot3_out p6,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mangosteen3* BlackEyedBeans3(const ::WaterMelon3 p1,const ::Dates3 &p2,::Dates3 &p3,const ::Squash2 &p4,const ::Pumpkin p5,CORBA::Boolean &p6,::Beetroot2 &p7,::BritishQueens1 &p8,const ::Fig &p9,CORBA::Long p10,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Fig* Leek3(::Corn1 p1,::Chives2 &p2,::Fennell3 &p3,::Cauliflower2_out p4,CORBA::Long &p5,const ::Damsons2 p6,::BritishQueens1_out p7,const ::Chestnut1 p8,::GaliaMelon3 &p9,::WaterMelon3 p10,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::TypeCode_ptr Mint3(::Chestnut1 p1,::Dates3 &p2,const ::Chives2 &p3,const ::GoldenDelicous3 &p4,::Oregano3_out p5,const ::Mullberry1 p6,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GardenPeas3* Asparagus3(::Raspberry1 p1,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GaliaMelon3* Sultana3(const ::GaliaMelon3 &p1,const ::Pumpkin p2,CORBA::Long &p3,::Fig &p4,::Beetroot2_out p5,const ::Chives2 &p6,::Squash1_out p7,::Tomato2_out p8,::Celeriac2 &p9,const ::Rasin2 &p10,CORBA::UShort p11,::GaliaMelon3 &p12,::Raspberry1 p13,::Mullberry1 p14,::Squash2 &p15,::Rasin2_out p16,CORBA::Context_ptr ctx VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Turnip3* Orange3(const ::Lychees3 &p1,const ::Rasin2 &p2,::Grapefruit2_out p3,::GaliaMelon3 &p4,const ::Fennell3 &p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Oregano3* Beansprout3(::Rasin2_out p1,CORBA::Octet &p2,const ::Oregano3 &p3,::Rasin2_out p4,const ::BlackEyedBeans &p5,::GaliaMelon3 &p6,::Squash2_out p7,const ::GoldenDelicous3 &p8,::Peanuts1 &p9,const ::Squash1 &p10,CORBA::Long &p11 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BrazilNut3* SweetPotato3(::Oregano3 &p1,::Tomato_out p2,const ::Cauliflower2 &p3,const ::YellowPepper2 &p4,::GardenPeas3_out p5,::Chives2_out p6 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::ULong KidneyBean3(::GoldenDelicous3_out p1,const ::Rasin2 &p2,::Cauliflower2 &p3,const ::Dates3 &p4,const ::Pumpkin p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GoldenDelicous3* Lentil3(char * &p1,const ::Squash2 &p2,const CORBA::Any &p3,::WaterMelon3 p4,::Fig_out p5,::WaterMelon &p6,::Celeriac2 &p7,CORBA::Octet &p8,::Fig_out p9,::Blackberry2 &p10,::Rasin2 &p11,const ::Squash2 &p12,::Pumpkin p13 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Short Daikan3(CORBA::TypeCode_ptr &p1,CORBA::Octet &p2,::Chestnut1 p3,::Asparagus &p4,::GaliaMelon3 &p5 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BambooShoot3* Cassava3(CORBA::TypeCode_ptr p1,const ::Chives2 &p2,CORBA::UShort &p3,const ::Squash1 &p4,::LoganBerry_out p5,::Chestnut1 p6,::Tomato2 &p7,::Tomato2 &p8,const CORBA::Any &p9,::Oregano3 &p10,const ::Asparagus &p11,const ::Rasin2 &p12 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Fennell3* Uglifruit3(CORBA::Long &p1,::BlackEyedBeans &p2,CORBA::UShort &p3,const ::IcebergLettuce2 &p4,::Asparagus &p5,::Rasin2 &p6,::Oregano3_out p7,::Squash1_out p8,::Fennell3 &p9 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mangosteen3* Pear3(const ::Raspberry1 p1,::BeechNut2_out p2,::Tomato2 &p3,::Cauliflower2_out p4,::Blackberry2 &p5,::Oregano3_out p6,::Chives2 &p7,::GaliaMelon3 &p8,CORBA::Octet &p9,const ::Corn1 p10,const ::Cauliflower2 &p11,::BritishQueens1 &p12,const ::BeechNut2 &p13,::Rasin2 &p14,::GaliaMelon3 &p15,const ::LoganBerry &p16,::GaliaMelon3 &p17 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  CORBA::Any* Susander3(::BambooShoot3_out p1,::Turnip3 &p2,::Beetroot2 &p3,::Turnip3_out p4,const ::BambooShoot3 &p5,::BlackEyedBeans &p6,::Fennell3 &p7,::Cauliflower2_out p8,::Dates3 &p9,::Squash2 &p10,const ::Cauliflower2 &p11,::LoganBerry &p12,::BeechNut2 &p13,::Dates3_out p14,::GardenPeas3_out p15,::Asparagus_out p16,const ::Currant2 &p17,const ::Raspberry1 p18,::BrazilNut3 &p19 VSORB_SRC_ENV)
    throw(CORBA::SystemException);

};
