// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef HELLO_IMPL_H
#define HELLO_IMPL_H

#define TRUE 1
#define FALSE 0
#include <Hello_skel.h>
short returnValue();
class Hello_impl : public POA_Hello,
		   public PortableServer::RefCountServantBase
{


  
public:

    virtual void say_hello()
      throw(CORBA::SystemException);

    virtual void lookForValue()
      throw(Hello::NoValid, CORBA::SystemException);

    virtual double returnDouble ()
      throw(CORBA::SystemException);

    virtual long returnLong ()
      throw(CORBA::SystemException);
    
    virtual unsigned long returnUlong ()
      throw(CORBA::SystemException);
    
    virtual float returnFloat ()
      throw(CORBA::SystemException);
    
    virtual long long returnLonglong ()
      throw(CORBA::SystemException);
    
    virtual unsigned long long returnUlonglong ()
      throw(CORBA::SystemException);
    
    virtual CORBA::Char returnChar ()
      throw(CORBA::SystemException);
    
    virtual bool returnBoolean ()
      throw(CORBA::SystemException);
    
    virtual shortType returnShort ()
      throw(CORBA::SystemException);
    
    virtual unsigned short returnUshort ()
      throw(CORBA::SystemException);
    
    virtual unsigned char returnOctet ()
      throw(CORBA::SystemException);
    
    virtual zahl returnStruct ()
      throw(CORBA::SystemException);
    
    virtual size returnEnum()
      throw(CORBA::SystemException);
    
    virtual char * returnString()
      throw(CORBA::SystemException);
    
    virtual wchar_t* returnWstring()
      throw(CORBA::SystemException);
    
    virtual  Hello::longSeq * returnSequence()
      throw(CORBA::SystemException);
    
    virtual  Hello::U * returnUnion()
      throw(CORBA::SystemException);
    
    virtual  Hello::LongArray_slice * returnArray()
      throw(CORBA::SystemException);
    
    virtual CORBA::Any * returnTKWstring()
      throw(CORBA::SystemException);
    
    virtual CORBA::Any * returnTKStruct()
      throw(CORBA::SystemException);
    
    virtual CORBA::Any * returnTKUnion()
      throw(CORBA::SystemException);
    
    virtual CORBA::Any * returnTKEnum()
      throw(CORBA::SystemException);
    
    virtual CORBA::Any * returnTKSequence()
      throw(CORBA::SystemException);
    
    virtual CORBA::Any * returnTKArray()
      throw(CORBA::SystemException);
    
    
};



#endif
