/*---------------------------------------------------------------------------
 * 
 *    File Name: define4tsp1.h
 *    Author:    Theofanis Vassiliou-Gioles
 *    Revision:  $Id: defines4tsp1.h,v 1.1 2001/01/31 17:20:53 mli Exp $
 *
 *    Some definitions for the Concurrent TTCN test suite simulator TSsim 
 * 	in conjunction with the TSP1/TPI-protocol
 *   
 */

#ifndef _DEFINE_4_TSP1_H
#define _DEFINE_4_TSP1_H

/* Defintions for the FIFOS */
# define PERMS 0666
# define LOCATION "/tmp/TSP1"

/* Definition of BufferSizes */
# define MAX_STR_LEN 255 /* Max. length for FIFO-Names */

typedef struct FIFO_t FIFO_t;
struct FIFO_t {
	char		myTcoId[MAX_STR_LEN];	/* my ass. TCO */
	char 		fifo_out[MAX_STR_LEN];	/* name of FIFO-writing */
	char		fifo_in[MAX_STR_LEN];	/* name of FIFO-reading */
	int		writefd;		/* for tpi */
	int             readfd;			/* for tpi */
	int		read_hd; 		/* for tpi */
};

#define TRUE 1
#define FALSE 0
#include "udp_defines.h"
#endif /* _DEFINE_4_TSP1_H */
