//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/inc/Environment.hh
//
// Modifications:
// $Log: Environment.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:08  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:50  stephen
// Initial vsOrb code base
//
//

class Environment
{

public:

    void exception( Exception* VSORB_ENV);
    Exception *exception(VSORB_ENV2) const;
    void clear(VSORB_ENV2);
    
    static Environment_ptr _duplicate(VSORB_ENV2);
    static Environment_ptr _nil(VSORB_ENV2);
};

typedef T_var<Environment> Environment_var;

