//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/inc/NamedValue.hh
//
// Modifications:
// $Log: NamedValue.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:50  stephen
// Initial vsOrb code base
//
//

class NamedValue
{
public:
    const char *name(VSORB_ENV2) const;
    Any *value(VSORB_ENV2) const;
    Flags flags(VSORB_ENV2) const;

    static NamedValue_ptr _duplicate(VSORB_ENV2);
    static NamedValue_ptr _nil(VSORB_ENV2);
};

typedef T_var<NamedValue> NamedValue_var;

