//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/inc/Object.hh
//
// Modifications:
// $Log: Object.hh,v $
// Revision 1.1.1.1  2000/02/09 17:07:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:50  stephen
// Initial vsOrb code base
//
//

class Object
{

public:
    static Object_ptr _duplicate(Object_ptr obj VSORB_ENV);
    static Object_ptr _is_nil(VSORB_ENV2);

    ImplementationDef_ptr _get_implementation(VSORB_ENV2);
    InterfaceDef_ptr _get_interface(VSORB_ENV2);
    
    Status _create_request(
	Context_ptr ctx,
	const char *operation,
	NVList_ptr arg_list,
	NamedValue_ptr result,
	Request_ptr &request,
	Flags req_flags VSORB_ENV);
    
    Status _create_request(
	Context_ptr ctx,
	const char *operation,
	NVList_ptr arg_list,
	NamedValue_ptr result,
	ExceptionList_ptr exclist,
	ContextList_ptr ctxlist,
	Request_ptr &request,
	Flags req_flags VSORB_ENV);

};

typedef T_var<Object> Object_var;

