//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/c++/lib/Any.cpp
//
// Modifications:
// $Log: Any.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:07:09  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1.1.1  1997/07/21 12:26:51  stephen
// Initial vsOrb code base
//
//

#include <vsorbref.hh>

CORBA::Any::Any(VSORB_ENV2) { }

CORBA::Any::Any( const CORBA::Any& VSORB_ENV) {}

CORBA::Any::Any( CORBA::TypeCode_ptr,
		void *,
		CORBA::Boolean  VSORB_ENV) {}

CORBA::Any::~Any(VSORB_ENV2) {}

CORBA::Any &
CORBA::Any::operator=( const CORBA::Any&)
{
    static CORBA::Any t;
    return t;
}

void
CORBA::Any::operator<<=( CORBA::Short) {}

void
CORBA::Any::operator<<=( CORBA::UShort) {}

void
CORBA::Any::operator<<=( CORBA::Long) {}

void
CORBA::Any::operator<<=( CORBA::ULong) {}

void
CORBA::Any::operator<<=( CORBA::Float) {}

void
CORBA::Any::operator<<=( CORBA::Double) {}

void
CORBA::Any::operator<<=( const CORBA::Any&) {}

void
CORBA::Any::operator<<=( const char*) {}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Short&) const {return 0;}


CORBA::Boolean
CORBA::Any::operator>>=( CORBA::UShort&) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Long&) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::ULong&) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Float&) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Double&) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Any&) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( char*&) const {return 0;}


CORBA::Any::from_boolean::from_boolean(CORBA::Boolean b) : val(b)  {}

CORBA::Any::from_octet::from_octet(CORBA::Octet o) : val(o)  {}

CORBA::Any::from_char::from_char(CORBA::Char c) : val(c)  {}

CORBA::Any::from_string::from_string(
    char* s,
    CORBA::ULong b) : val(s), bound(b)  {}

void CORBA::Any::operator<<=( CORBA::Any::from_boolean) {}
void CORBA::Any::operator<<=( CORBA::Any::from_char) {}
void CORBA::Any::operator<<=( CORBA::Any::from_octet) {}
void CORBA::Any::operator<<=( CORBA::Any::from_string) {}

CORBA::Any::to_boolean::to_boolean(CORBA::Boolean &b) : ref(b)  {}

CORBA::Any::to_char::to_char(CORBA::Char &c) : ref(c)  {}

CORBA::Any::to_octet::to_octet(CORBA::Octet &o) : ref(o)  {}

CORBA::Any::to_object::to_object(CORBA::Object_ptr &obj) : ref(obj)  {}

CORBA::Any::to_string::to_string(
    char *& s,
    CORBA::ULong b) : val(s), bound(b)  {}


CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Any::to_boolean) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Any::to_char) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Any::to_octet) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Any::to_object) const {return 0;}

CORBA::Boolean
CORBA::Any::operator>>=( CORBA::Any::to_string) const {return 0;}

void
CORBA::Any::replace( CORBA::TypeCode_ptr, void *,
		    CORBA::Boolean  VSORB_ENV) {}
	     
CORBA::TypeCode_ptr
CORBA::Any::type(VSORB_ENV2) const { return 0;}

const void *
CORBA::Any::value(VSORB_ENV2) const { return 0;}

void
CORBA::Any::operator<<=( unsigned char) {}

CORBA::Boolean
CORBA::Any::operator>>=( unsigned char&) const
{
    return 0;
}


//
// Any_var class
//

CORBA::Any_var::Any_var(VSORB_ENV2) { };

CORBA::Any_var::Any_var( CORBA::Any *){ };

CORBA::Any_var::Any_var( const CORBA::Any_var &){ };

CORBA::Any_var::~Any_var(VSORB_ENV2){ };

CORBA::Any_var &
CORBA::Any_var::operator=( CORBA::Any *)
{
    static CORBA::Any_var t;
    return t;
}

CORBA::Any_var &
CORBA::Any_var::operator=( const CORBA::Any_var &)
{
    static CORBA::Any_var t;
    return t;
}


CORBA::Any *
CORBA::Any_var::operator->() { return 0; }

void
CORBA::Any_var::operator<<=( CORBA::Short) {}

void
CORBA::Any_var::operator<<=( CORBA::UShort ) {}

void
CORBA::Any_var::operator<<=( CORBA::Long ) {}

void
CORBA::Any_var::operator<<=( CORBA::ULong ) {}

void
CORBA::Any_var::operator<<=( CORBA::Float ) {}

void
CORBA::Any_var::operator<<=( CORBA::Double ) {}

void
CORBA::Any_var::operator<<=( const CORBA::Any& ) {}

void
CORBA::Any_var::operator<<=( const char* ) {}

void
CORBA::Any_var::operator<<=( CORBA::Any::from_boolean ) {}

void
CORBA::Any_var::operator<<=( CORBA::Any::from_char ) {}

void
CORBA::Any_var::operator<<=( CORBA::Any::from_octet ) {}

void
CORBA::Any_var::operator<<=( CORBA::Any::from_string ) {}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Short&) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::UShort&) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Long&) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::ULong&) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Float&) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Double&) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Any&) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( char*&) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Any::to_boolean) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Any::to_char) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Any::to_octet) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Any::to_object) const { return 0;}

CORBA::Boolean
CORBA::Any_var::operator>>=( CORBA::Any::to_string) const { return 0;}
