/*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Developed for X/Open by ApTest Ireland Limited.
*
* Project: VSORB
*
* File: src/c++/vsorb.hh
*
* Modifications:
* $Log: vsorb.hh,v $
* Revision 1.1.1.1  2000/02/09 17:07:08  mli
* Imported TOG's VSOrb 1.1.1
*
* Revision 1.1.1.1  1997/07/21 12:26:50  stephen
* Initial vsOrb code base
*
*/

#ifdef VSORB_REF
#include <vsorbref.hh>
#endif

#ifdef VSORB_ORBIX
#include <CORBA.h>
#include <ifr.hh>
#endif

#ifdef VSORB_DAIS_C
#include <daislib.h>
#endif
 
#ifdef VSORB_DAIS_CPP
#include <daislib.hpp>
#endif

#if VSORB_NON_EH
 
#define VSORB_ENV , Environment &env
#define VSORB_SRC_ENV , CORBA::Environment &env
 
#define VSORB_ENV2  Environment &env
#define VSORB_SRC_ENV2  CORBA::Environment &env
 
#else
 
#define VSORB_ENV
#define VSORB_SRC_ENV
 
#define VSORB_ENV2
#define VSORB_SRC_ENV2
 
#endif


