#include <stdio.h>
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
#ifndef __cplusplus
# define output(c) (void)putc(c,yyout)
#else
# define lex_output(c) (void)putc(c,yyout)
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
	int yyback(int *, int);
	int yyinput(void);
	int yylook(void);
	void yyoutput(int);
	int yyracc(int);
	int yyreject(void);
	void yyunput(int);
	int yylex(void);
#ifdef YYLEX_E
	void yywoutput(wchar_t);
	wchar_t yywinput(void);
#endif
#ifndef yyless
	int yyless(int);
#endif
#ifndef yywrap
	int yywrap(void);
#endif
#ifdef LEXDEBUG
	void allprint(char);
	void sprint(char *);
#endif
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
#ifndef __cplusplus
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#else
# define lex_input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif
#define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
char yytext[YYLMAX];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/utils/nodes/src/analyser.l
//
// Modifications:
// $Log: analyser.cpp,v $
// Revision 1.3  2000/11/14 09:30:40  uwes
// Removed obsolete define
//
// Revision 1.2  2000/02/11 16:06:59  mli
// yylex -> int yylex
//
// Revision 1.8  1997/11/27 10:52:32  james
// Fixed comment handling
//
// Revision 1.4  1997/11/26 20:00:59  james
// added \?
//
// Revision 1.3  1997/10/14 10:24:05  james
// Extended types removed
//
// Revision 1.2  1997/10/08 13:00:44  james
// Changed yyerror prototype
//
// Revision 1.1  1997/10/06 11:35:56  james
// Initial Sources
//
//

#include <stdlib.h>
#include <string.h>
#include <grammar.hh>
#include <constexpr.hh>
#include <literals.hh>
#include "y.tab.h"

long lineNumber=1;

# define YYNEWLINE 10

int yylex(){
int nstr; extern int yyprevious;
#ifdef __cplusplus
/* to avoid CC and lint complaining yyfussy not being used ...*/
static int __lex_hack = 0;
if (__lex_hack) goto yyfussy;
#endif
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:

		{ /* Preprocessor directives are igored */
						lineNumber++;
					}
break;
case 2:

		{ /* C++ comment */
						int c;
						do
						{
							if((c=yyinput()) == '\n')
								lineNumber++;
						} while(c != '\n' && c != EOF);
					}
break;
case 3:

		{ /* C comment */
						int c;
						char next;

						while(1)
			    	{
							if((c = yyinput()) == '\n')
				    		lineNumber++;
							else if(c == '*')
							{
				    		if((next = yyinput()) == '/')
									break;
				    		else
									unput(next);
							}
			    	}
					}
break;
case 4:

           { return ANY; }
break;
case 5:

     { return ATTRIBUTE; }
break;
case 6:

       { return BOOLEAN; }
break;
case 7:

          { return CASE; }
break;
case 8:

          { return CHAR; }
break;
case 9:

         { return CONST; }
break;
case 10:

       { return CONTEXT; }
break;
case 11:

       { return DEFAULT; }
break;
case 12:

        { return DOUBLE; }
break;
case 13:

          { return ENUM; }
break;
case 14:

     { return EXCEPTION; }
break;
case 15:

         { yylval.string = strdup(yytext);
									 return BOOLEAN_LITERAL; }
break;
case 16:

         { return FLOAT; }
break;
case 17:

            { return IN; }
break;
case 18:

         { return INOUT; }
break;
case 19:

     { return INTERFACE; }
break;
case 20:

          { return LONG; }
break;
case 21:

        { return MODULE; }
break;
case 22:

        { return OBJECT; }
break;
case 23:

         { return OCTET; }
break;
case 24:

        { return ONEWAY; }
break;
case 25:

           { return OUT; }
break;
case 26:

        { return RAISES; }
break;
case 27:

      { return READONLY; }
break;
case 28:

      { return SEQUENCE; }
break;
case 29:

         { return SHORT; }
break;
case 30:

        { return STRING; }
break;
case 31:

        { return STRUCT; }
break;
case 32:

        { return SWITCH; }
break;
case 33:

          { yylval.string = strdup(yytext);
									 return BOOLEAN_LITERAL; }
break;
case 34:

       { return TYPEDEF; }
break;
case 35:

      { return UNSIGNED; }
break;
case 36:

         { return UNION; }
break;
case 37:

          { return VOID; }
break;
case 38:

			       { return SEMI_COLON; }
break;
case 39:

			       { return LEFT_CURLY_BRACKET; }
break;
case 40:

			       { return RIGHT_CURLY_BRACKET; }
break;
case 41:

			       { return COLON; }
break;
case 42:

			       { return COMMA; }
break;
case 43:

			       { return EQUALS_SIGN; }
break;
case 44:

			       { return PLUS_SIGN; }
break;
case 45:

			       { return MINUS_SIGN; }
break;
case 46:

			       { return LEFT_PARENTHESIS; }
break;
case 47:

			       { return RIGHT_PARENTHESIS; }
break;
case 48:

			       { return LESS_THAN_SIGN; }
break;
case 49:

			       { return GREATER_THAN_SIGN; }
break;
case 50:

			       { return LEFT_SQUARE_BRACKET; }
break;
case 51:

			       { return RIGHT_SQUARE_BRACKET; }
break;
case 52:

			       { return APOSTROPHE; }
break;
case 53:

			       { return DOUBLE_QUOTE; }
break;
case 54:

			       { return REVERSE_SOLIDUS; }
break;
case 55:

			       { return VERTICAL_LINE; }
break;
case 56:

			       { return CIRCUMFLEX; }
break;
case 57:

			       { return AMPERSAND; }
break;
case 58:

			       { return ASTERISK; }
break;
case 59:

			       { return SOLIDUS; }
break;
case 60:

			       { return PERCENT_SIGN; }
break;
case 61:

			       { return TILDA; }
break;
case 62:

					 { return SHIFT_LEFT; }
break;
case 63:

					 { return SHIFT_RIGHT; }
break;
case 64:

					 { return SCOPE_DELIMITOR; }
break;
case 65:

          { yylval.string = strdup(yytext);
                          return IDENTIFIER;
		        						}
break;
case 66:

						{ yylval.string = strdup(yytext);
                          return INTEGER_LITERAL;
                        }
break;
case 67:

									{ yylval.string = strdup(yytext);
                          return INTEGER_LITERAL;
												}
break;
case 68:

{ for(int i = 0 ; yytext[i] ; i++)
														if(yytext[i] == '\n')
				    									lineNumber++; 
													yylval.string = strdup(yytext);
	                    		return STRING_LITERAL;
												}
break;
case 69:

	{ yylval.string = strdup(yytext);
                          return CHARACTER_LITERAL;
												}
break;
case 70:

	{ yylval.string = strdup(yytext);
                          return CHARACTER_LITERAL;
												}
break;
case 71:

					{ yylval.string = strdup(yytext);
                          return CHARACTER_LITERAL;
												}
break;
case 72:

								{ yylval.string = strdup(yytext);
                          return CHARACTER_LITERAL;
												}
break;
case 73:

		{ yylval.string = strdup(yytext);
                          return FLOATING_PT_LITERAL;
												}
break;
case 74:

 		{ yylval.string = strdup(yytext);
                          return FLOATING_PT_LITERAL;
												}
break;
case 75:

							{ yylval.string = strdup(yytext);
                          return FLOATING_PT_LITERAL;
												}
break;
case 76:

   	      				{
			    								if(yytext[0] == '\n')
														lineNumber++;
												}
break;
case 77:

              				{ printf("Unexpected character '%c'\n",yytext[0]);
													return yytext[0]; }
break;
case -1:
break;
default:
(void)fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }

/* end of yylex */

int yywrap()
{
	return 1;
}

void yyerror(const char *s)
{
	printf("%s: At Line %d\n",s,lineNumber);
}

int yyvstop[] = {
0,

77,
0,

76,
77,
0,

76,
0,

53,
77,
0,

1,
77,
0,

60,
77,
0,

57,
77,
0,

52,
77,
0,

46,
77,
0,

47,
77,
0,

58,
77,
0,

44,
77,
0,

42,
77,
0,

45,
77,
0,

77,
0,

59,
77,
0,

67,
77,
0,

67,
77,
0,

41,
77,
0,

38,
77,
0,

48,
77,
0,

43,
77,
0,

49,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

50,
77,
0,

54,
77,
0,

51,
77,
0,

56,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

65,
77,
0,

39,
77,
0,

55,
77,
0,

40,
77,
0,

61,
77,
0,

68,
0,

1,
0,

74,
0,

3,
0,

2,
0,

73,
0,

67,
0,

64,
0,

62,
0,

63,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

17,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

68,
0,

72,
0,

72,
0,

73,
74,
0,

75,
0,

66,
0,

65,
0,

65,
0,

65,
0,

4,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

25,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

71,
0,

69,
0,

74,
0,

73,
0,

65,
0,

65,
0,

33,
65,
0,

65,
0,

65,
0,

7,
65,
0,

8,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

13,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

20,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

37,
65,
0,

70,
0,

73,
74,
0,

15,
65,
0,

65,
0,

65,
0,

65,
0,

9,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

16,
65,
0,

18,
65,
0,

65,
0,

65,
0,

23,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

29,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

36,
65,
0,

65,
0,

22,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

12,
65,
0,

65,
0,

65,
0,

21,
65,
0,

24,
65,
0,

26,
65,
0,

65,
0,

65,
0,

30,
65,
0,

31,
65,
0,

32,
65,
0,

65,
0,

65,
0,

65,
0,

6,
65,
0,

10,
65,
0,

11,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

34,
65,
0,

65,
0,

65,
0,

65,
0,

65,
0,

27,
65,
0,

28,
65,
0,

35,
65,
0,

5,
65,
0,

14,
65,
0,

19,
65,
0,
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
56,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	1,6,	
1,7,	0,0,	1,8,	1,9,	
1,10,	1,11,	1,12,	1,13,	
1,14,	1,15,	1,16,	1,17,	
1,18,	1,19,	1,20,	1,20,	
1,20,	1,20,	1,20,	1,20,	
1,20,	1,20,	57,100,	1,21,	
1,22,	1,23,	1,24,	1,25,	
1,3,	21,66,	1,26,	23,67,	
18,60,	25,68,	1,26,	1,27,	
1,26,	18,61,	27,70,	59,105,	
101,142,	113,153,	70,111,	0,0,	
1,28,	0,0,	0,0,	0,0,	
29,72,	1,29,	111,151,	72,113,	
0,0,	1,26,	0,0,	0,0,	
1,30,	1,31,	1,32,	1,33,	
53,55,	99,55,	1,34,	1,35,	
1,36,	1,37,	1,38,	1,39,	
28,71,	77,118,	1,40,	59,105,	
71,112,	1,41,	1,42,	1,26,	
1,43,	35,75,	34,73,	1,44,	
1,45,	1,46,	1,47,	1,48,	
34,74,	39,83,	36,76,	40,84,	
1,49,	1,50,	1,51,	1,52,	
2,7,	36,77,	2,8,	2,9,	
41,85,	2,11,	2,12,	2,13,	
36,78,	2,15,	2,16,	2,17,	
2,18,	42,86,	2,20,	2,20,	
2,20,	2,20,	2,20,	2,20,	
2,20,	37,79,	38,81,	2,21,	
2,22,	2,23,	2,24,	2,25,	
2,3,	43,87,	44,90,	37,80,	
38,82,	45,92,	44,91,	2,27,	
45,93,	46,96,	47,97,	48,98,	
43,88,	55,99,	73,114,	74,115,	
2,28,	75,116,	76,117,	43,89,	
45,94,	2,29,	78,119,	45,95,	
79,120,	80,121,	81,122,	82,123,	
2,30,	2,31,	2,32,	2,33,	
6,53,	83,124,	85,127,	2,35,	
2,36,	2,37,	2,38,	2,39,	
6,53,	6,53,	2,40,	86,128,	
84,125,	2,41,	2,42,	87,129,	
2,43,	84,126,	7,56,	2,44,	
2,45,	2,46,	2,47,	2,48,	
88,130,	89,131,	7,56,	7,0,	
2,49,	2,50,	2,51,	2,52,	
90,132,	6,54,	91,133,	92,134,	
93,135,	94,136,	6,53,	55,55,	
95,137,	96,138,	6,53,	97,139,	
98,141,	106,148,	112,152,	6,53,	
115,154,	116,155,	117,156,	7,56,	
118,157,	97,140,	120,160,	6,53,	
7,56,	119,158,	119,159,	121,161,	
7,56,	122,162,	123,163,	124,164,	
6,53,	7,56,	10,57,	125,165,	
6,53,	126,166,	6,53,	127,167,	
128,168,	7,56,	10,57,	10,0,	
129,169,	106,148,	130,170,	132,171,	
133,172,	134,173,	7,56,	135,174,	
137,177,	136,175,	7,56,	6,53,	
7,56,	138,178,	139,179,	6,55,	
140,180,	141,181,	151,187,	152,188,	
6,53,	136,176,	154,189,	10,57,	
155,190,	158,191,	159,192,	160,193,	
10,57,	7,56,	161,194,	163,195,	
10,57,	6,53,	164,196,	165,197,	
166,198,	10,57,	7,56,	168,199,	
169,200,	170,201,	171,202,	172,203,	
173,204,	10,57,	174,205,	175,206,	
176,207,	177,208,	178,209,	7,56,	
179,210,	180,211,	10,57,	182,143,	
184,183,	188,212,	10,57,	189,213,	
10,57,	17,59,	17,59,	17,59,	
17,59,	17,59,	17,59,	17,59,	
17,59,	17,59,	17,59,	190,214,	
192,215,	193,216,	194,217,	195,218,	
198,219,	10,57,	199,220,	201,221,	
202,222,	10,58,	203,223,	204,224,	
206,225,	19,62,	10,57,	19,63,	
19,63,	19,63,	19,63,	19,63,	
19,63,	19,63,	19,63,	19,63,	
19,63,	207,226,	208,227,	10,57,	
209,228,	211,229,	213,230,	214,231,	
215,232,	216,233,	218,234,	20,62,	
19,64,	20,63,	20,63,	20,63,	
20,63,	20,63,	20,63,	20,63,	
20,63,	20,63,	20,63,	219,235,	
223,236,	224,237,	103,143,	228,238,	
229,239,	230,240,	234,241,	19,65,	
235,242,	236,243,	20,64,	103,144,	
103,144,	103,144,	103,144,	103,144,	
103,144,	103,144,	103,144,	237,244,	
19,64,	239,245,	240,246,	241,247,	
242,248,	0,0,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
0,0,	0,0,	0,0,	19,65,	
0,0,	0,0,	20,64,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	0,0,	0,0,	0,0,	
0,0,	26,69,	0,0,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	26,69,	26,69,	26,69,	
26,69,	58,101,	0,0,	0,0,	
0,0,	0,0,	58,102,	144,182,	
144,182,	144,182,	144,182,	144,182,	
144,182,	144,182,	144,182,	58,103,	
58,103,	58,103,	58,103,	58,103,	
58,103,	58,103,	58,103,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	58,101,	62,106,	
62,106,	62,106,	62,106,	62,106,	
62,106,	62,106,	62,106,	62,106,	
62,106,	108,109,	108,109,	108,109,	
108,109,	108,109,	108,109,	108,109,	
108,109,	108,109,	108,109,	0,0,	
62,107,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	58,101,	
0,0,	0,0,	0,0,	0,0,	
58,101,	58,101,	0,0,	0,0,	
0,0,	58,101,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	58,101,	0,0,	0,0,	
0,0,	58,101,	0,0,	58,101,	
62,107,	58,101,	64,108,	58,104,	
64,108,	0,0,	0,0,	64,109,	
64,109,	64,109,	64,109,	64,109,	
64,109,	64,109,	64,109,	64,109,	
64,109,	65,110,	65,110,	65,110,	
65,110,	65,110,	65,110,	65,110,	
65,110,	65,110,	65,110,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	65,110,	65,110,	
65,110,	65,110,	65,110,	65,110,	
104,145,	104,145,	104,145,	104,145,	
104,145,	104,145,	104,145,	104,145,	
104,145,	104,145,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	104,145,	104,145,	104,145,	
104,145,	104,145,	104,145,	0,0,	
0,0,	0,0,	65,110,	65,110,	
65,110,	65,110,	65,110,	65,110,	
105,146,	0,0,	105,146,	0,0,	
0,0,	105,147,	105,147,	105,147,	
105,147,	105,147,	105,147,	105,147,	
105,147,	105,147,	105,147,	0,0,	
0,0,	104,145,	104,145,	104,145,	
104,145,	104,145,	104,145,	107,149,	
0,0,	107,149,	0,0,	0,0,	
107,150,	107,150,	107,150,	107,150,	
107,150,	107,150,	107,150,	107,150,	
107,150,	107,150,	145,183,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	145,184,	
145,184,	145,184,	145,184,	145,184,	
145,184,	145,184,	145,184,	145,184,	
145,184,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
145,184,	145,184,	145,184,	145,184,	
145,184,	145,184,	146,147,	146,147,	
146,147,	146,147,	146,147,	146,147,	
146,147,	146,147,	146,147,	146,147,	
148,185,	0,0,	148,185,	0,0,	
0,0,	148,186,	148,186,	148,186,	
148,186,	148,186,	148,186,	148,186,	
148,186,	148,186,	148,186,	0,0,	
145,184,	145,184,	145,184,	145,184,	
145,184,	145,184,	149,150,	149,150,	
149,150,	149,150,	149,150,	149,150,	
149,150,	149,150,	149,150,	149,150,	
185,186,	185,186,	185,186,	185,186,	
185,186,	185,186,	185,186,	185,186,	
185,186,	185,186,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-93,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+-187,	0,		yyvstop+8,
yycrank+-205,	0,		yyvstop+11,
yycrank+0,	0,		yyvstop+14,
yycrank+0,	0,		yyvstop+17,
yycrank+-253,	0,		yyvstop+20,
yycrank+0,	0,		yyvstop+23,
yycrank+0,	0,		yyvstop+26,
yycrank+0,	0,		yyvstop+29,
yycrank+0,	0,		yyvstop+32,
yycrank+0,	0,		yyvstop+35,
yycrank+0,	0,		yyvstop+38,
yycrank+277,	0,		yyvstop+41,
yycrank+26,	0,		yyvstop+43,
yycrank+303,	0,		yyvstop+46,
yycrank+325,	0,		yyvstop+49,
yycrank+7,	0,		yyvstop+52,
yycrank+0,	0,		yyvstop+55,
yycrank+7,	0,		yyvstop+58,
yycrank+0,	0,		yyvstop+61,
yycrank+7,	0,		yyvstop+64,
yycrank+362,	0,		yyvstop+67,
yycrank+9,	yysvec+26,	yyvstop+70,
yycrank+6,	yysvec+26,	yyvstop+73,
yycrank+2,	yysvec+26,	yyvstop+76,
yycrank+0,	0,		yyvstop+79,
yycrank+0,	0,		yyvstop+82,
yycrank+0,	0,		yyvstop+85,
yycrank+0,	0,		yyvstop+88,
yycrank+4,	yysvec+26,	yyvstop+91,
yycrank+2,	yysvec+26,	yyvstop+94,
yycrank+25,	yysvec+26,	yyvstop+97,
yycrank+48,	yysvec+26,	yyvstop+100,
yycrank+40,	yysvec+26,	yyvstop+103,
yycrank+13,	yysvec+26,	yyvstop+106,
yycrank+13,	yysvec+26,	yyvstop+109,
yycrank+21,	yysvec+26,	yyvstop+112,
yycrank+30,	yysvec+26,	yyvstop+115,
yycrank+58,	yysvec+26,	yyvstop+118,
yycrank+61,	yysvec+26,	yyvstop+121,
yycrank+60,	yysvec+26,	yyvstop+124,
yycrank+44,	yysvec+26,	yyvstop+127,
yycrank+56,	yysvec+26,	yyvstop+130,
yycrank+56,	yysvec+26,	yyvstop+133,
yycrank+0,	0,		yyvstop+136,
yycrank+0,	0,		yyvstop+139,
yycrank+0,	0,		yyvstop+142,
yycrank+0,	0,		yyvstop+145,
yycrank+-4,	yysvec+6,	0,	
yycrank+0,	0,		yyvstop+148,
yycrank+-135,	yysvec+6,	0,	
yycrank+-2,	yysvec+7,	yyvstop+150,
yycrank+19,	0,		0,	
yycrank+451,	0,		0,	
yycrank+6,	yysvec+17,	yyvstop+152,
yycrank+0,	0,		yyvstop+154,
yycrank+0,	0,		yyvstop+156,
yycrank+467,	0,		yyvstop+158,
yycrank+0,	yysvec+20,	yyvstop+160,
yycrank+527,	0,		0,	
yycrank+537,	0,		0,	
yycrank+0,	0,		yyvstop+162,
yycrank+0,	0,		yyvstop+164,
yycrank+0,	0,		yyvstop+166,
yycrank+0,	yysvec+26,	yyvstop+168,
yycrank+2,	yysvec+26,	yyvstop+170,
yycrank+2,	yysvec+26,	yyvstop+172,
yycrank+2,	yysvec+26,	yyvstop+174,
yycrank+49,	yysvec+26,	yyvstop+176,
yycrank+55,	yysvec+26,	yyvstop+178,
yycrank+62,	yysvec+26,	yyvstop+180,
yycrank+59,	yysvec+26,	yyvstop+182,
yycrank+8,	yysvec+26,	yyvstop+184,
yycrank+68,	yysvec+26,	yyvstop+186,
yycrank+78,	yysvec+26,	yyvstop+188,
yycrank+64,	yysvec+26,	yyvstop+190,
yycrank+65,	yysvec+26,	yyvstop+192,
yycrank+84,	yysvec+26,	yyvstop+194,
yycrank+78,	yysvec+26,	yyvstop+196,
yycrank+89,	yysvec+26,	yyvstop+198,
yycrank+80,	yysvec+26,	yyvstop+201,
yycrank+99,	yysvec+26,	yyvstop+203,
yycrank+87,	yysvec+26,	yyvstop+205,
yycrank+111,	yysvec+26,	yyvstop+207,
yycrank+97,	yysvec+26,	yyvstop+209,
yycrank+115,	yysvec+26,	yyvstop+211,
yycrank+125,	yysvec+26,	yyvstop+213,
yycrank+110,	yysvec+26,	yyvstop+215,
yycrank+113,	yysvec+26,	yyvstop+217,
yycrank+111,	yysvec+26,	yyvstop+219,
yycrank+123,	yysvec+26,	yyvstop+221,
yycrank+117,	yysvec+26,	yyvstop+223,
yycrank+126,	yysvec+26,	yyvstop+225,
yycrank+127,	yysvec+26,	yyvstop+227,
yycrank+-5,	yysvec+6,	yyvstop+229,
yycrank+0,	0,		yyvstop+231,
yycrank+37,	0,		0,	
yycrank+0,	yysvec+101,	yyvstop+233,
yycrank+347,	0,		0,	
yycrank+560,	0,		0,	
yycrank+597,	0,		0,	
yycrank+164,	yysvec+62,	yyvstop+235,
yycrank+620,	0,		0,	
yycrank+477,	0,		0,	
yycrank+0,	yysvec+108,	yyvstop+238,
yycrank+0,	yysvec+65,	yyvstop+240,
yycrank+3,	yysvec+26,	yyvstop+242,
yycrank+133,	yysvec+26,	yyvstop+244,
yycrank+8,	yysvec+26,	yyvstop+246,
yycrank+0,	yysvec+26,	yyvstop+248,
yycrank+122,	yysvec+26,	yyvstop+251,
yycrank+129,	yysvec+26,	yyvstop+253,
yycrank+137,	yysvec+26,	yyvstop+255,
yycrank+126,	yysvec+26,	yyvstop+257,
yycrank+130,	yysvec+26,	yyvstop+259,
yycrank+145,	yysvec+26,	yyvstop+261,
yycrank+149,	yysvec+26,	yyvstop+263,
yycrank+140,	yysvec+26,	yyvstop+265,
yycrank+149,	yysvec+26,	yyvstop+267,
yycrank+154,	yysvec+26,	yyvstop+269,
yycrank+138,	yysvec+26,	yyvstop+271,
yycrank+156,	yysvec+26,	yyvstop+273,
yycrank+156,	yysvec+26,	yyvstop+275,
yycrank+143,	yysvec+26,	yyvstop+277,
yycrank+163,	yysvec+26,	yyvstop+279,
yycrank+147,	yysvec+26,	yyvstop+281,
yycrank+0,	yysvec+26,	yyvstop+283,
yycrank+152,	yysvec+26,	yyvstop+286,
yycrank+168,	yysvec+26,	yyvstop+288,
yycrank+152,	yysvec+26,	yyvstop+290,
yycrank+157,	yysvec+26,	yyvstop+292,
yycrank+168,	yysvec+26,	yyvstop+294,
yycrank+156,	yysvec+26,	yyvstop+296,
yycrank+176,	yysvec+26,	yyvstop+298,
yycrank+167,	yysvec+26,	yyvstop+300,
yycrank+175,	yysvec+26,	yyvstop+302,
yycrank+181,	yysvec+26,	yyvstop+304,
yycrank+0,	0,		yyvstop+306,
yycrank+0,	0,		yyvstop+308,
yycrank+443,	yysvec+103,	0,	
yycrank+639,	0,		0,	
yycrank+662,	0,		0,	
yycrank+0,	yysvec+146,	yyvstop+310,
yycrank+677,	0,		0,	
yycrank+694,	0,		0,	
yycrank+0,	yysvec+149,	yyvstop+312,
yycrank+213,	yysvec+26,	yyvstop+314,
yycrank+184,	yysvec+26,	yyvstop+316,
yycrank+0,	yysvec+26,	yyvstop+318,
yycrank+181,	yysvec+26,	yyvstop+321,
yycrank+187,	yysvec+26,	yyvstop+323,
yycrank+0,	yysvec+26,	yyvstop+325,
yycrank+0,	yysvec+26,	yyvstop+328,
yycrank+173,	yysvec+26,	yyvstop+331,
yycrank+189,	yysvec+26,	yyvstop+333,
yycrank+174,	yysvec+26,	yyvstop+335,
yycrank+186,	yysvec+26,	yyvstop+337,
yycrank+0,	yysvec+26,	yyvstop+339,
yycrank+183,	yysvec+26,	yyvstop+342,
yycrank+182,	yysvec+26,	yyvstop+344,
yycrank+183,	yysvec+26,	yyvstop+346,
yycrank+186,	yysvec+26,	yyvstop+348,
yycrank+0,	yysvec+26,	yyvstop+350,
yycrank+195,	yysvec+26,	yyvstop+353,
yycrank+188,	yysvec+26,	yyvstop+355,
yycrank+208,	yysvec+26,	yyvstop+357,
yycrank+205,	yysvec+26,	yyvstop+359,
yycrank+196,	yysvec+26,	yyvstop+361,
yycrank+207,	yysvec+26,	yyvstop+363,
yycrank+194,	yysvec+26,	yyvstop+365,
yycrank+201,	yysvec+26,	yyvstop+367,
yycrank+213,	yysvec+26,	yyvstop+369,
yycrank+214,	yysvec+26,	yyvstop+371,
yycrank+214,	yysvec+26,	yyvstop+373,
yycrank+206,	yysvec+26,	yyvstop+375,
yycrank+214,	yysvec+26,	yyvstop+377,
yycrank+0,	yysvec+26,	yyvstop+379,
yycrank+280,	0,		0,	
yycrank+0,	0,		yyvstop+382,
yycrank+281,	0,		0,	
yycrank+704,	0,		0,	
yycrank+0,	yysvec+185,	yyvstop+384,
yycrank+0,	yysvec+26,	yyvstop+387,
yycrank+205,	yysvec+26,	yyvstop+390,
yycrank+225,	yysvec+26,	yyvstop+392,
yycrank+238,	yysvec+26,	yyvstop+394,
yycrank+0,	yysvec+26,	yyvstop+396,
yycrank+216,	yysvec+26,	yyvstop+399,
yycrank+229,	yysvec+26,	yyvstop+401,
yycrank+237,	yysvec+26,	yyvstop+403,
yycrank+223,	yysvec+26,	yyvstop+405,
yycrank+0,	yysvec+26,	yyvstop+407,
yycrank+0,	yysvec+26,	yyvstop+410,
yycrank+238,	yysvec+26,	yyvstop+413,
yycrank+241,	yysvec+26,	yyvstop+415,
yycrank+0,	yysvec+26,	yyvstop+417,
yycrank+222,	yysvec+26,	yyvstop+420,
yycrank+229,	yysvec+26,	yyvstop+422,
yycrank+236,	yysvec+26,	yyvstop+424,
yycrank+237,	yysvec+26,	yyvstop+426,
yycrank+0,	yysvec+26,	yyvstop+428,
yycrank+245,	yysvec+26,	yyvstop+431,
yycrank+245,	yysvec+26,	yyvstop+433,
yycrank+258,	yysvec+26,	yyvstop+435,
yycrank+263,	yysvec+26,	yyvstop+437,
yycrank+0,	yysvec+26,	yyvstop+439,
yycrank+255,	yysvec+26,	yyvstop+442,
yycrank+0,	yysvec+26,	yyvstop+444,
yycrank+249,	yysvec+26,	yyvstop+447,
yycrank+257,	yysvec+26,	yyvstop+449,
yycrank+252,	yysvec+26,	yyvstop+451,
yycrank+253,	yysvec+26,	yyvstop+453,
yycrank+0,	yysvec+26,	yyvstop+455,
yycrank+265,	yysvec+26,	yyvstop+458,
yycrank+286,	yysvec+26,	yyvstop+460,
yycrank+0,	yysvec+26,	yyvstop+462,
yycrank+0,	yysvec+26,	yyvstop+465,
yycrank+0,	yysvec+26,	yyvstop+468,
yycrank+276,	yysvec+26,	yyvstop+471,
yycrank+286,	yysvec+26,	yyvstop+473,
yycrank+0,	yysvec+26,	yyvstop+475,
yycrank+0,	yysvec+26,	yyvstop+478,
yycrank+0,	yysvec+26,	yyvstop+481,
yycrank+285,	yysvec+26,	yyvstop+484,
yycrank+287,	yysvec+26,	yyvstop+486,
yycrank+273,	yysvec+26,	yyvstop+488,
yycrank+0,	yysvec+26,	yyvstop+490,
yycrank+0,	yysvec+26,	yyvstop+493,
yycrank+0,	yysvec+26,	yyvstop+496,
yycrank+279,	yysvec+26,	yyvstop+499,
yycrank+293,	yysvec+26,	yyvstop+501,
yycrank+272,	yysvec+26,	yyvstop+503,
yycrank+302,	yysvec+26,	yyvstop+505,
yycrank+0,	yysvec+26,	yyvstop+507,
yycrank+305,	yysvec+26,	yyvstop+510,
yycrank+305,	yysvec+26,	yyvstop+512,
yycrank+297,	yysvec+26,	yyvstop+514,
yycrank+307,	yysvec+26,	yyvstop+516,
yycrank+0,	yysvec+26,	yyvstop+518,
yycrank+0,	yysvec+26,	yyvstop+521,
yycrank+0,	yysvec+26,	yyvstop+524,
yycrank+0,	yysvec+26,	yyvstop+527,
yycrank+0,	yysvec+26,	yyvstop+530,
yycrank+0,	yysvec+26,	yyvstop+533,
0,	0,	0};
struct yywork *yytop = yycrank+761;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
  0,   1,   1,   1,   1,   1,   1,   1, 
  1,   9,  10,   9,   9,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  9,   1,  34,   1,   1,   1,   1,  39, 
  1,   1,   1,  43,   1,  43,   1,   1, 
 48,  48,  48,  48,  48,  48,  48,  48, 
 56,  56,   1,   1,   1,   1,   1,  39, 
  1,  65,  65,  65,  65,  69,  65,  71, 
 71,  71,  71,  71,  71,  71,  71,  71, 
 71,  71,  71,  71,  71,  71,  71,  71, 
 88,  71,  71,   1,  39,   1,   1,  71, 
  1,  97,  97,  65,  65,  69,  97,  71, 
 71,  71,  71,  71,  71,  71, 110,  71, 
 71,  71, 110,  71, 110,  71, 110,  71, 
 88,  71,  71,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
/*	Copyright (c) 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/


int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
#if defined(__cplusplus) || defined(__STDC__)
int yylook(void)
#else
yylook()
#endif
{
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
#ifndef __cplusplus
			*yylastch++ = yych = input();
#else
			*yylastch++ = yych = lex_input();
#endif
			if(yylastch > &yytext[YYLMAX]) {
				fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
				exit(1);
			}
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
#ifndef __cplusplus
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
#else
		yyprevious = yytext[0] = lex_input();
		if (yyprevious>0)
			lex_output(yyprevious);
#endif
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
#if defined(__cplusplus) || defined(__STDC__)
int yyback(int *p, int m)
#else
yyback(p, m)
	int *p;
#endif
{
	if (p==0) return(0);
	while (*p) {
		if (*p++ == m)
			return(1);
	}
	return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus) || defined(__STDC__)
int yyinput(void)
#else
yyinput()
#endif
{
#ifndef __cplusplus
	return(input());
#else
	return(lex_input());
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyoutput(int c)
#else
yyoutput(c)
  int c; 
#endif
{
#ifndef __cplusplus
	output(c);
#else
	lex_output(c);
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyunput(int c)
#else
yyunput(c)
   int c; 
#endif
{
	unput(c);
	}
