/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_valid_type(VSBoolean);

extern int is_correct_tc(VSDynAny_ptr *, VSString);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSDynAny_ptr_P)(VSDynAny_ptr*, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSBoolean (*ADL__VSinsert_boolean_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_boolean_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_long_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_long_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_short_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_short_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_ushort_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_ushort_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_longlong_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_longlong_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_ulonglong_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_ulonglong_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_ulong_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_ulong_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_double_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_double_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_longdouble_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_longdouble_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_float_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_float_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_char_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_char_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_wchar_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_wchar_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_string_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_string_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_wstring_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_wstring_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_reference_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_reference_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_val_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_val_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_any_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_any_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_octet_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_octet_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_typecode_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_typecode_wrapper)(VSDynAny_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSinsert_dyn_any_wrapper)(VSDynAny_ptr*, VSBoolean, VSEnvironment*);
extern VSBoolean (*ADL__VSget_dyn_any_wrapper)(VSDynAny_ptr*, VSEnvironment*);

#endif
