/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSset_as_string
 *
 */
VSBoolean ADL__ACF_VSset_as_string (VSDynEnum_ptr *de_21, VSString str_22, VSEnvironment *ev_10){

VSBoolean VSset_as_string_RtnVal_4;
  void *dummyVarName_128;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_23;
  int tmp_25;
  int tmp_26;
  VSEnvironment *ev_10_tmp_30;
    int tmp_31;
  int tmp_32;
  int tmp_33;
  VSString str_22_tmp_36;
  int tmp_37;
  VSEnvironment *ev_10_tmp_41;
    int tmp_42;
  int tmp_43;
  int groupExpr_47;
  int tmp_44;

/* Declare vars for result of normal and exception bindings */
  int VSset_as_string_NormalOutcome_5, VSset_as_string_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSset_as_string_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSset_as_string_InfoArray, 0, ADL__VSset_as_string_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSset_as_string_assertionReport->setPhase(ADL__VSset_as_string_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_as_string_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSset_as_string_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSset_as_string_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSset_as_string_InfoArray[forLoopIdx_1].error > VSset_as_string_ACF_Result_3))
  VSset_as_string_ACF_Result_3 = ADL__VSset_as_string_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSset_as_string_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSset_as_string_assertionReport->setPhase(ADL__VSset_as_string_assertionReport, PH_call);
  ADL__release(ADL__VSset_as_string_assertionReport->parent, &this_seq);
  VSset_as_string_RtnVal_4 = ADL__VSset_as_string_wrapper(de_21, str_22, ev_10);
  ADL__recover(ADL__VSset_as_string_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSset_as_string_assertionReport->setPhase(ADL__VSset_as_string_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 7,&tmp_7);
  VSset_as_string_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 2,&tmp_13);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_as_string_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 1,&tmp_12);

  VSset_as_string_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSset_as_string_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSset_as_string_InfoArray[0].result = (VSset_as_string_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_as_string_InfoArray[0].evaluated = 1;
  ADL__VSset_as_string_InfoArray[0].value = (VSset_as_string_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSset_as_string_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSset_as_string_InfoArray[6].result = (VSset_as_string_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_as_string_InfoArray[6].evaluated = 1;
  ADL__VSset_as_string_InfoArray[6].value = (VSset_as_string_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSset_as_string_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSset_as_string_ACF_Result_3 = ADL__VSset_as_string_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSset_as_string_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSset_as_string_ACF_Result_3 = ADL__VSset_as_string_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSset_as_string_ExceptionOutcome_6 && !VSset_as_string_NormalOutcome_5) {
  VSset_as_string_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSset_as_string_ExceptionOutcome_6 && VSset_as_string_NormalOutcome_5) {
  VSset_as_string_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 10,&VSset_as_string_ExceptionOutcome_6);
  ev_10_tmp_30 = ev_10;
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 13,&ev_10_tmp_30);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_26 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 12,&tmp_26);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = !tmp_26;
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 11,&tmp_25);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = (!VSset_as_string_ExceptionOutcome_6 || tmp_25);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 9,&tmp_23);
    str_22_tmp_36 = str_22;
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 17,&str_22_tmp_36);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[16]);

/* Evaluate valid_IDL_ID(str) */
  tmp_33 = valid_IDL_ID(str_22);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 16,&tmp_33);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[15]);

/* Evaluate !valid_IDL_ID(str) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 15,&tmp_32);
  ev_10_tmp_41 = ev_10;
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 19,&ev_10_tmp_41);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[18]);

/* Evaluate DAny_user_exception_is("InvalidValue", ev) */
  tmp_37 = DAny_user_exception_is("InvalidValue", ev_10);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 18,&tmp_37);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[14]);

/* Evaluate !valid_IDL_ID(str) --> DAny_user_exception_is("InvalidValue", ev) */
  tmp_31 = (!tmp_32 || tmp_37);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 14,&tmp_31);
    ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[20]);

/* Evaluate normally { ... } */
  if(VSset_as_string_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 22,&VSset_as_string_RtnVal_4);
  ADL__VSset_as_string_assertionReport->exprMark(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_assertionReport->assrt_info[21]);

/* Evaluate return == 1 */
  tmp_44 = (VSset_as_string_RtnVal_4 == 1);
  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 21,&tmp_44);
  groupExpr_47 = (tmp_44);
  tmp_43 = (groupExpr_47);
  tmp_42 = tmp_43;
  }
  else {
    ADL__resetInfoStruct(ADL__VSset_as_string_InfoArray, 20, 22);
  tmp_42 = 1;
}

  ADL__setResultAndError(ADL__VSset_as_string_InfoArray, 20,&tmp_42);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_as_string_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSset_as_string_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSset_as_string_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSset_as_string_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSset_as_string_InfoArray[forLoopIdx_1].level == 0))
        VSset_as_string_ACF_Result_3 = calculate_ACF_result(VSset_as_string_ACF_Result_3, ADL__VSset_as_string_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSset_as_string_assertionReport->value = VSset_as_string_ACF_Result_3;
  ADL__VSset_as_string_assertionReport->parent->openReport(ADL__VSset_as_string_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_as_string_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSset_as_string_assertionReport->emitTest(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_InfoArray[forLoopIdx_1])) {
     ADL__VSset_as_string_assertionReport->exprStart(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_InfoArray[forLoopIdx_1]);
      if(!ADL__VSset_as_string_InfoArray[forLoopIdx_1].testable || !ADL__VSset_as_string_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSset_as_string_assertionReport->emitter);
      else if (ADL__VSset_as_string_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSset_as_string_InfoArray[forLoopIdx_1].error, ADL__VSset_as_string_assertionReport->emitter);
      else
        ADL__VSset_as_string_InfoArray[forLoopIdx_1].emitFunc(ADL__VSset_as_string_InfoArray[forLoopIdx_1].value, ADL__VSset_as_string_assertionReport->emitter);
     ADL__VSset_as_string_assertionReport->exprEnd(ADL__VSset_as_string_assertionReport, &ADL__VSset_as_string_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSset_as_string_RtnVal_4);
}


VSBoolean (*ADL__VSset_as_string_wrapper)(VSDynEnum_ptr*, VSString, VSEnvironment*) = VSset_as_string;

void ADL__emit_VSDynEnum_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSString (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSBoolean (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSset_as_string_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "!valid_IDL_ID(str) --> DAny_user_exception_is(\"InvalidValue\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "!valid_IDL_ID(str)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "valid_IDL_ID(str)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "str", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSString },
  {2, 18, 14, 0, 0, "DAny_user_exception_is(\"InvalidValue\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 20, 20, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "return == 1", 21, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean }
};


unsigned int ADL__VSset_as_string_InfoArrayIdx = 23;

struct ADL__reportAssertion *ADL__VSset_as_string_assertionReport = 0;

/*
 *
 * ACF of VSget_as_string
 *
 */
VSString ADL__ACF_VSget_as_string (VSDynEnum_ptr *de_67, VSEnvironment *ev_56){

VSString VSget_as_string_RtnVal_50;
  void *dummyVarName_128;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_68;
  int tmp_70;
  int tmp_71;
  VSEnvironment *ev_56_tmp_75;
    int tmp_76;
  int tmp_77;
  int groupExpr_81;
  int tmp_78;

/* Declare vars for result of normal and exception bindings */
  int VSget_as_string_NormalOutcome_51, VSget_as_string_ExceptionOutcome_52;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_53;
  VSEnvironment *ev_56_tmp_57;
    int tmp_58;
  int tmp_59;
  VSEnvironment *ev_56_tmp_62;
  int tmp_63;
  VSEnvironment *ev_56_tmp_66;
  enum ADL__ACF_result VSget_as_string_ACF_Result_49 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSget_as_string_InfoArray, 0, ADL__VSget_as_string_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSget_as_string_assertionReport->setPhase(ADL__VSget_as_string_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_as_string_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSget_as_string_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSget_as_string_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSget_as_string_InfoArray[forLoopIdx_1].error > VSget_as_string_ACF_Result_49))
  VSget_as_string_ACF_Result_49 = ADL__VSget_as_string_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSget_as_string_ACF_Result_49 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSget_as_string_assertionReport->setPhase(ADL__VSget_as_string_assertionReport, PH_call);
  ADL__release(ADL__VSget_as_string_assertionReport->parent, &this_seq);
  VSget_as_string_RtnVal_50 = ADL__VSget_as_string_wrapper(de_67, ev_56);
  ADL__recover(ADL__VSget_as_string_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSget_as_string_assertionReport->setPhase(ADL__VSget_as_string_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_56_tmp_57 = ev_56;
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 8,&ev_56_tmp_57);
  ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_53 = no_exception(ev_56);
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 7,&tmp_53);
  VSget_as_string_NormalOutcome_51 = (tmp_53);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_56_tmp_62 = ev_56;
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 3,&ev_56_tmp_62);
  ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_59 = system_exception(ev_56);
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 2,&tmp_59);
  ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_58 = tmp_59;
  if (!tmp_59) {
      ev_56_tmp_66 = ev_56;
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 5,&ev_56_tmp_66);
  ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_63 = user_exception(ev_56);
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 4,&tmp_63);
    tmp_58 = tmp_63;
  }
  else {
  ADL__resetInfoStruct(ADL__VSget_as_string_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 1,&tmp_58);

  VSget_as_string_ExceptionOutcome_52 = (tmp_58);

/* Exception binding is the first assertion */
  if (ADL__VSget_as_string_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSget_as_string_InfoArray[0].result = (VSget_as_string_ExceptionOutcome_52 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_as_string_InfoArray[0].evaluated = 1;
  ADL__VSget_as_string_InfoArray[0].value = (VSget_as_string_ExceptionOutcome_52 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSget_as_string_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSget_as_string_InfoArray[6].result = (VSget_as_string_NormalOutcome_51 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_as_string_InfoArray[6].evaluated = 1;
  ADL__VSget_as_string_InfoArray[6].value = (VSget_as_string_NormalOutcome_51 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSget_as_string_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSget_as_string_ACF_Result_49 = ADL__VSget_as_string_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSget_as_string_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSget_as_string_ACF_Result_49 = ADL__VSget_as_string_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSget_as_string_ExceptionOutcome_52 && !VSget_as_string_NormalOutcome_51) {
  VSget_as_string_ACF_Result_49 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSget_as_string_ExceptionOutcome_52 && VSget_as_string_NormalOutcome_51) {
  VSget_as_string_ACF_Result_49 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 10,&VSget_as_string_ExceptionOutcome_52);
  ev_56_tmp_75 = ev_56;
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 13,&ev_56_tmp_75);
  ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_71 = user_exception_is("NOT_IMPLEMENTED", ev_56);
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 12,&tmp_71);
  ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_70 = !tmp_71;
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 11,&tmp_70);
  ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_68 = (!VSget_as_string_ExceptionOutcome_52 || tmp_70);
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 9,&tmp_68);
    ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSget_as_string_NormalOutcome_51){
      ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 16,&VSget_as_string_RtnVal_50);
  ADL__VSget_as_string_assertionReport->exprMark(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_assertionReport->assrt_info[15]);

/* Evaluate return_correct_string(return) */
  tmp_78 = return_correct_string(VSget_as_string_RtnVal_50);
  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 15,&tmp_78);
  groupExpr_81 = (tmp_78);
  tmp_77 = (groupExpr_81);
  tmp_76 = tmp_77;
  }
  else {
    ADL__resetInfoStruct(ADL__VSget_as_string_InfoArray, 14, 16);
  tmp_76 = 1;
}

  ADL__setResultAndError(ADL__VSget_as_string_InfoArray, 14,&tmp_76);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_as_string_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSget_as_string_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSget_as_string_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSget_as_string_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSget_as_string_InfoArray[forLoopIdx_1].level == 0))
        VSget_as_string_ACF_Result_49 = calculate_ACF_result(VSget_as_string_ACF_Result_49, ADL__VSget_as_string_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSget_as_string_assertionReport->value = VSget_as_string_ACF_Result_49;
  ADL__VSget_as_string_assertionReport->parent->openReport(ADL__VSget_as_string_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_as_string_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSget_as_string_assertionReport->emitTest(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_InfoArray[forLoopIdx_1])) {
     ADL__VSget_as_string_assertionReport->exprStart(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_InfoArray[forLoopIdx_1]);
      if(!ADL__VSget_as_string_InfoArray[forLoopIdx_1].testable || !ADL__VSget_as_string_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSget_as_string_assertionReport->emitter);
      else if (ADL__VSget_as_string_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSget_as_string_InfoArray[forLoopIdx_1].error, ADL__VSget_as_string_assertionReport->emitter);
      else
        ADL__VSget_as_string_InfoArray[forLoopIdx_1].emitFunc(ADL__VSget_as_string_InfoArray[forLoopIdx_1].value, ADL__VSget_as_string_assertionReport->emitter);
     ADL__VSget_as_string_assertionReport->exprEnd(ADL__VSget_as_string_assertionReport, &ADL__VSget_as_string_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSget_as_string_RtnVal_50);
}


VSString (*ADL__VSget_as_string_wrapper)(VSDynEnum_ptr*, VSEnvironment*) = VSget_as_string;

void ADL__emit_VSDynEnum_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSString (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSget_as_string_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "return_correct_string(return)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSString }
};


unsigned int ADL__VSget_as_string_InfoArrayIdx = 17;

struct ADL__reportAssertion *ADL__VSget_as_string_assertionReport = 0;

/*
 *
 * ACF of VSset_as_ulong
 *
 */
VSBoolean ADL__ACF_VSset_as_ulong (VSDynEnum_ptr *de_101, VSULong num_102, VSEnvironment *ev_90){

VSBoolean VSset_as_ulong_RtnVal_84;
  void *dummyVarName_128;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_103;
  int tmp_105;
  int tmp_106;
  VSEnvironment *ev_90_tmp_110;
    int tmp_111;
  int tmp_112;
  int tmp_113;
  VSULong num_102_tmp_116;
  int tmp_117;
  VSEnvironment *ev_90_tmp_121;
    int tmp_122;
  int tmp_123;
  int groupExpr_127;
  int tmp_124;

/* Declare vars for result of normal and exception bindings */
  int VSset_as_ulong_NormalOutcome_85, VSset_as_ulong_ExceptionOutcome_86;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_87;
  VSEnvironment *ev_90_tmp_91;
    int tmp_92;
  int tmp_93;
  VSEnvironment *ev_90_tmp_96;
  int tmp_97;
  VSEnvironment *ev_90_tmp_100;
  enum ADL__ACF_result VSset_as_ulong_ACF_Result_83 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSset_as_ulong_InfoArray, 0, ADL__VSset_as_ulong_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSset_as_ulong_assertionReport->setPhase(ADL__VSset_as_ulong_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_as_ulong_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].error > VSset_as_ulong_ACF_Result_83))
  VSset_as_ulong_ACF_Result_83 = ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSset_as_ulong_ACF_Result_83 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSset_as_ulong_assertionReport->setPhase(ADL__VSset_as_ulong_assertionReport, PH_call);
  ADL__release(ADL__VSset_as_ulong_assertionReport->parent, &this_seq);
  VSset_as_ulong_RtnVal_84 = ADL__VSset_as_ulong_wrapper(de_101, num_102, ev_90);
  ADL__recover(ADL__VSset_as_ulong_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSset_as_ulong_assertionReport->setPhase(ADL__VSset_as_ulong_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_90_tmp_91 = ev_90;
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 8,&ev_90_tmp_91);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_87 = no_exception(ev_90);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 7,&tmp_87);
  VSset_as_ulong_NormalOutcome_85 = (tmp_87);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_90_tmp_96 = ev_90;
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 3,&ev_90_tmp_96);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_93 = system_exception(ev_90);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 2,&tmp_93);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_92 = tmp_93;
  if (!tmp_93) {
      ev_90_tmp_100 = ev_90;
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 5,&ev_90_tmp_100);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_97 = user_exception(ev_90);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 4,&tmp_97);
    tmp_92 = tmp_97;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_as_ulong_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 1,&tmp_92);

  VSset_as_ulong_ExceptionOutcome_86 = (tmp_92);

/* Exception binding is the first assertion */
  if (ADL__VSset_as_ulong_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSset_as_ulong_InfoArray[0].result = (VSset_as_ulong_ExceptionOutcome_86 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_as_ulong_InfoArray[0].evaluated = 1;
  ADL__VSset_as_ulong_InfoArray[0].value = (VSset_as_ulong_ExceptionOutcome_86 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSset_as_ulong_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSset_as_ulong_InfoArray[6].result = (VSset_as_ulong_NormalOutcome_85 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_as_ulong_InfoArray[6].evaluated = 1;
  ADL__VSset_as_ulong_InfoArray[6].value = (VSset_as_ulong_NormalOutcome_85 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSset_as_ulong_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSset_as_ulong_ACF_Result_83 = ADL__VSset_as_ulong_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSset_as_ulong_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSset_as_ulong_ACF_Result_83 = ADL__VSset_as_ulong_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSset_as_ulong_ExceptionOutcome_86 && !VSset_as_ulong_NormalOutcome_85) {
  VSset_as_ulong_ACF_Result_83 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSset_as_ulong_ExceptionOutcome_86 && VSset_as_ulong_NormalOutcome_85) {
  VSset_as_ulong_ACF_Result_83 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 10,&VSset_as_ulong_ExceptionOutcome_86);
  ev_90_tmp_110 = ev_90;
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 13,&ev_90_tmp_110);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_106 = user_exception_is("NOT_IMPLEMENTED", ev_90);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 12,&tmp_106);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_105 = !tmp_106;
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 11,&tmp_105);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_103 = (!VSset_as_ulong_ExceptionOutcome_86 || tmp_105);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 9,&tmp_103);
    num_102_tmp_116 = num_102;
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 17,&num_102_tmp_116);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[16]);

/* Evaluate valid_input_value(num) */
  tmp_113 = valid_input_value(num_102);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 16,&tmp_113);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[15]);

/* Evaluate !valid_input_value(num) */
  tmp_112 = !tmp_113;
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 15,&tmp_112);
  ev_90_tmp_121 = ev_90;
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 19,&ev_90_tmp_121);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[18]);

/* Evaluate DAny_user_exception_is("InvalidValue", ev) */
  tmp_117 = DAny_user_exception_is("InvalidValue", ev_90);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 18,&tmp_117);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[14]);

/* Evaluate !valid_input_value(num) --> DAny_user_exception_is("InvalidValue", ev) */
  tmp_111 = (!tmp_112 || tmp_117);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 14,&tmp_111);
    ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[20]);

/* Evaluate normally { ... } */
  if(VSset_as_ulong_NormalOutcome_85){
      ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 22,&VSset_as_ulong_RtnVal_84);
  ADL__VSset_as_ulong_assertionReport->exprMark(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_assertionReport->assrt_info[21]);

/* Evaluate return == 1 */
  tmp_124 = (VSset_as_ulong_RtnVal_84 == 1);
  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 21,&tmp_124);
  groupExpr_127 = (tmp_124);
  tmp_123 = (groupExpr_127);
  tmp_122 = tmp_123;
  }
  else {
    ADL__resetInfoStruct(ADL__VSset_as_ulong_InfoArray, 20, 22);
  tmp_122 = 1;
}

  ADL__setResultAndError(ADL__VSset_as_ulong_InfoArray, 20,&tmp_122);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_as_ulong_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].level == 0))
        VSset_as_ulong_ACF_Result_83 = calculate_ACF_result(VSset_as_ulong_ACF_Result_83, ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSset_as_ulong_assertionReport->value = VSset_as_ulong_ACF_Result_83;
  ADL__VSset_as_ulong_assertionReport->parent->openReport(ADL__VSset_as_ulong_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_as_ulong_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSset_as_ulong_assertionReport->emitTest(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_InfoArray[forLoopIdx_1])) {
     ADL__VSset_as_ulong_assertionReport->exprStart(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_InfoArray[forLoopIdx_1]);
      if(!ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].testable || !ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSset_as_ulong_assertionReport->emitter);
      else if (ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].error, ADL__VSset_as_ulong_assertionReport->emitter);
      else
        ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].emitFunc(ADL__VSset_as_ulong_InfoArray[forLoopIdx_1].value, ADL__VSset_as_ulong_assertionReport->emitter);
     ADL__VSset_as_ulong_assertionReport->exprEnd(ADL__VSset_as_ulong_assertionReport, &ADL__VSset_as_ulong_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSset_as_ulong_RtnVal_84);
}


VSBoolean (*ADL__VSset_as_ulong_wrapper)(VSDynEnum_ptr*, VSULong, VSEnvironment*) = VSset_as_ulong;

void ADL__emit_VSDynEnum_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSBoolean (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSset_as_ulong_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "!valid_input_value(num) --> DAny_user_exception_is(\"InvalidValue\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "!valid_input_value(num)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "valid_input_value(num)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "num", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {2, 18, 14, 0, 0, "DAny_user_exception_is(\"InvalidValue\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 20, 20, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "return == 1", 21, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSBoolean }
};


unsigned int ADL__VSset_as_ulong_InfoArrayIdx = 23;

struct ADL__reportAssertion *ADL__VSset_as_ulong_assertionReport = 0;

/*
 *
 * ACF of VSget_as_ulong
 *
 */
VSULong ADL__ACF_VSget_as_ulong (VSDynEnum_ptr *de_147, VSEnvironment *ev_136){

VSULong VSget_as_ulong_RtnVal_130;
  void *dummyVarName_128;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_148;
  int tmp_150;
  int tmp_151;
  VSEnvironment *ev_136_tmp_155;
    int tmp_156;
  int tmp_157;
  int groupExpr_161;
  int tmp_158;

/* Declare vars for result of normal and exception bindings */
  int VSget_as_ulong_NormalOutcome_131, VSget_as_ulong_ExceptionOutcome_132;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_133;
  VSEnvironment *ev_136_tmp_137;
    int tmp_138;
  int tmp_139;
  VSEnvironment *ev_136_tmp_142;
  int tmp_143;
  VSEnvironment *ev_136_tmp_146;
  enum ADL__ACF_result VSget_as_ulong_ACF_Result_129 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSget_as_ulong_InfoArray, 0, ADL__VSget_as_ulong_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSget_as_ulong_assertionReport->setPhase(ADL__VSget_as_ulong_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_as_ulong_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].error > VSget_as_ulong_ACF_Result_129))
  VSget_as_ulong_ACF_Result_129 = ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSget_as_ulong_ACF_Result_129 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSget_as_ulong_assertionReport->setPhase(ADL__VSget_as_ulong_assertionReport, PH_call);
  ADL__release(ADL__VSget_as_ulong_assertionReport->parent, &this_seq);
  VSget_as_ulong_RtnVal_130 = ADL__VSget_as_ulong_wrapper(de_147, ev_136);
  ADL__recover(ADL__VSget_as_ulong_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSget_as_ulong_assertionReport->setPhase(ADL__VSget_as_ulong_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_136_tmp_137 = ev_136;
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 8,&ev_136_tmp_137);
  ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_133 = no_exception(ev_136);
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 7,&tmp_133);
  VSget_as_ulong_NormalOutcome_131 = (tmp_133);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_136_tmp_142 = ev_136;
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 3,&ev_136_tmp_142);
  ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_139 = system_exception(ev_136);
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 2,&tmp_139);
  ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_138 = tmp_139;
  if (!tmp_139) {
      ev_136_tmp_146 = ev_136;
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 5,&ev_136_tmp_146);
  ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_143 = user_exception(ev_136);
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 4,&tmp_143);
    tmp_138 = tmp_143;
  }
  else {
  ADL__resetInfoStruct(ADL__VSget_as_ulong_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 1,&tmp_138);

  VSget_as_ulong_ExceptionOutcome_132 = (tmp_138);

/* Exception binding is the first assertion */
  if (ADL__VSget_as_ulong_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSget_as_ulong_InfoArray[0].result = (VSget_as_ulong_ExceptionOutcome_132 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_as_ulong_InfoArray[0].evaluated = 1;
  ADL__VSget_as_ulong_InfoArray[0].value = (VSget_as_ulong_ExceptionOutcome_132 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSget_as_ulong_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSget_as_ulong_InfoArray[6].result = (VSget_as_ulong_NormalOutcome_131 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_as_ulong_InfoArray[6].evaluated = 1;
  ADL__VSget_as_ulong_InfoArray[6].value = (VSget_as_ulong_NormalOutcome_131 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSget_as_ulong_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSget_as_ulong_ACF_Result_129 = ADL__VSget_as_ulong_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSget_as_ulong_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSget_as_ulong_ACF_Result_129 = ADL__VSget_as_ulong_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSget_as_ulong_ExceptionOutcome_132 && !VSget_as_ulong_NormalOutcome_131) {
  VSget_as_ulong_ACF_Result_129 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSget_as_ulong_ExceptionOutcome_132 && VSget_as_ulong_NormalOutcome_131) {
  VSget_as_ulong_ACF_Result_129 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 10,&VSget_as_ulong_ExceptionOutcome_132);
  ev_136_tmp_155 = ev_136;
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 13,&ev_136_tmp_155);
  ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_151 = user_exception_is("NOT_IMPLEMENTED", ev_136);
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 12,&tmp_151);
  ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_150 = !tmp_151;
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 11,&tmp_150);
  ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_148 = (!VSget_as_ulong_ExceptionOutcome_132 || tmp_150);
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 9,&tmp_148);
    ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSget_as_ulong_NormalOutcome_131){
      ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 16,&VSget_as_ulong_RtnVal_130);
  ADL__VSget_as_ulong_assertionReport->exprMark(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_assertionReport->assrt_info[15]);

/* Evaluate return_correct_ULong(return) */
  tmp_158 = return_correct_ULong(VSget_as_ulong_RtnVal_130);
  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 15,&tmp_158);
  groupExpr_161 = (tmp_158);
  tmp_157 = (groupExpr_161);
  tmp_156 = tmp_157;
  }
  else {
    ADL__resetInfoStruct(ADL__VSget_as_ulong_InfoArray, 14, 16);
  tmp_156 = 1;
}

  ADL__setResultAndError(ADL__VSget_as_ulong_InfoArray, 14,&tmp_156);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_as_ulong_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].level == 0))
        VSget_as_ulong_ACF_Result_129 = calculate_ACF_result(VSget_as_ulong_ACF_Result_129, ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSget_as_ulong_assertionReport->value = VSget_as_ulong_ACF_Result_129;
  ADL__VSget_as_ulong_assertionReport->parent->openReport(ADL__VSget_as_ulong_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_as_ulong_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSget_as_ulong_assertionReport->emitTest(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_InfoArray[forLoopIdx_1])) {
     ADL__VSget_as_ulong_assertionReport->exprStart(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_InfoArray[forLoopIdx_1]);
      if(!ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].testable || !ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSget_as_ulong_assertionReport->emitter);
      else if (ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].error, ADL__VSget_as_ulong_assertionReport->emitter);
      else
        ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].emitFunc(ADL__VSget_as_ulong_InfoArray[forLoopIdx_1].value, ADL__VSget_as_ulong_assertionReport->emitter);
     ADL__VSget_as_ulong_assertionReport->exprEnd(ADL__VSget_as_ulong_assertionReport, &ADL__VSget_as_ulong_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSget_as_ulong_RtnVal_130);
}


VSULong (*ADL__VSget_as_ulong_wrapper)(VSDynEnum_ptr*, VSEnvironment*) = VSget_as_ulong;

void ADL__emit_VSDynEnum_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSget_as_ulong_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "return_correct_ULong(return)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong }
};


unsigned int ADL__VSget_as_ulong_InfoArrayIdx = 17;

struct ADL__reportAssertion *ADL__VSget_as_ulong_assertionReport = 0;
