/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             *
 * Project: CORVAL2
 *
 * Contact:
 * Aihong Yin
 * e-mail: yin@fokus.gmd.de
 *
 * Date: Oct. 2000
 ********************************************************************/

/***************************************************/
/* Interface DynEnum                               */
/***************************************************/

#include <corba_supp.hh>
#include <tserver.hh>
#include <DAny.h>
#include <DAny_impl.h>

extern "C" {
#include <t1_aux.h>

//-----------------------------------------------------------


int valid_IDL_ID(VSString p_str)
{
    char *str = (char *) p_str;

    if ((strcmp(str, "red") == 0) || (strcmp(str, "green") == 0) || (strcmp(str, "blue") == 0))
	return TRUE;
    else
	return FALSE;  
}

int return_correct_string(VSString p_str)
{
     char *str = (char *) p_str;

     if (strcmp(str, "red") == 0)
	 return TRUE;
     else
	 return FALSE;
}

int valid_input_value(VSULong p_num)
{    
    CORBA::ULong num = (CORBA::ULong) p_num;

    if (num < 3)
	return TRUE;
    else
	return FALSE;
}

int return_correct_ULong(VSULong p_num)
{
    CORBA::ULong num = (CORBA::ULong) p_num;
    
    return (num == 0);
}


} // end
