/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int len_exceed_boundSeq(VSDynSequence_ptr *, VSULong);

extern int return_correct_len(VSULong);

extern int valid_type_any_seq(VSDynSequence_ptr *, VSAnySeq_ptr);

extern int valid_value_any_seq(VSDynSequence_ptr *, VSAnySeq_ptr);

extern int is_correct_anyseq(VSDynSequence_ptr *, VSAnySeq_ptr);

extern int valid_value_dynany_seq(VSDynSequence_ptr *, VSDynAnySeq_ptr dseq);

extern int valid_type_dynany_seq(VSDynSequence_ptr *, VSDynAnySeq_ptr dseq);

extern int is_correct_DynAnySeq(VSDynSequence_ptr *, VSDynAnySeq_ptr dseq);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSDynSequence_ptr_P)(VSDynSequence_ptr*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSAnySeq_ptr)(VSAnySeq_ptr, emitter_t);
extern void (*ADL__print_VSDynAnySeq_ptr)(VSDynAnySeq_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSBoolean (*ADL__VSset_length_wrapper)(VSDynSequence_ptr*, VSULong, VSEnvironment*);
extern VSULong (*ADL__VSget_length_wrapper)(VSDynSequence_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSset_elements_wrapper)(VSDynSequence_ptr*, VSAnySeq_ptr, VSEnvironment*);
extern VSAnySeq_ptr (*ADL__VSget_elements_wrapper)(VSDynSequence_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSset_elements_as_dyn_any_wrapper)(VSDynSequence_ptr*, VSDynAnySeq_ptr, VSEnvironment*);
extern VSDynAnySeq_ptr (*ADL__VSget_elements_as_dyn_any_wrapper)(VSDynSequence_ptr*, VSEnvironment*);

#endif
