/* ADL test driver from t1.tdr
 *
 * test VSset_discriminator(DUnion, discriminator, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_432[] = {
    {"df_mb", PDUnion_prop_1_df_mb, 0},
    {"ndf_mb", PDUnion_prop_1_ndf_mb, 0},
    {0, 0, 0}
};

/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_433[] = {
    {"dEnum", Pdiscriminator_prop_1_dEnum, 0},
    {"dLong", Pdiscriminator_prop_1_dLong, 0},
    {"invalid", Pdiscriminator_prop_1_invalid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_434[] = {
    {"prop_1", "prop", ADL__prop_values_432, 2},
    {"prop_1", "prop", ADL__prop_values_433, 3},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_438[4] = {
    {"DUnion", "VSDynUnion_ptr *", ADL__prop_info_434, 0, 1},
    {"discriminator", "VSDynAny_ptr *", ADL__prop_info_434, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_434, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSset_discriminator_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSDYNUNION_PTR_P
#define ADL__PRINT_VSDYNUNION_PTR_P
void (*ADL__print_VSDynUnion_ptr_P)(VSDynUnion_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNUNION_PTR_P */
#ifndef ADL__PRINT_VSDYNANY_PTR_P
#define ADL__PRINT_VSDYNANY_PTR_P
void (*ADL__print_VSDynAny_ptr_P)(VSDynAny_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNANY_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSTCKIND
#define ADL__PRINT_VSTCKIND
void (*ADL__print_VSTCKind)(VSTCKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSTCKIND */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */

void ADL__emit_VSDynUnion_ptr_P (void* val, emitter_t emitter)
{
  VSDynUnion_ptr *tmp;

  if (ADL__print_VSDynUnion_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSDynUnion_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDynAny_ptr_P (void* val, emitter_t emitter)
{
  VSDynAny_ptr *tmp;

  if (ADL__print_VSDynAny_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSDynAny_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSTCKind (void* val, emitter_t emitter)
{
  VSTCKind tmp;

  if (ADL__print_VSTCKind != 0) {
    tmp = *(VSTCKind*) val;
    ADL__print_VSTCKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 3};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSDynUnion_ptr *DUnion_435;
    VSDynAny_ptr *discriminator_436;
    VSEnvironment *env_437;
    VSBoolean fut_return_431;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSset_discriminator_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSset_discriminator_InfoArrayIdx,
        ADL__VSset_discriminator_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_DUnion(&DUnion_435, ADL__prop_values_432[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSDynUnion_ptr_P(&DUnion_435, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_discriminator(&discriminator_436, ADL__prop_values_433[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSDynAny_ptr_P(&discriminator_436, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_437)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_437, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSset_discriminator_assertionReport = rf->assertionReport;
       fut_return_431 = ADL__ACF_VSset_discriminator(DUnion_435, discriminator_436, env_437);
       test_value = ADL__VSset_discriminator_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_437);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_discriminator(&discriminator_436, ADL__prop_values_433[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_DUnion(&DUnion_435, ADL__prop_values_432[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_438,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSset_discriminator_head);

    return 0;
}


struct ADL__Directive_info VSset_discriminator1_info = {
    N_VARS,
    ADL__var_info_438
};

struct ADL__TDD_info ADL__test_info = {
    6,
    &ADL__VSset_discriminator_InfoArrayIdx,
    ADL__VSset_discriminator_InfoArray,
    ADL__test_driver,
    "VSset_discriminator",
    "VSset_discriminator1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSset_discriminator1",
    "t1_tr.rif",
    &VSset_discriminator1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

