/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int valid_discriminator(VSDynUnion_ptr *, VSDynAny_ptr *);

extern int discriminator_consistent_Umember(VSDynAny_ptr *);

extern int no_active_member(VSDynUnion_ptr *);

extern int return_correct_discriminator(VSDynAny_ptr *);

extern int union_has_default_member(VSDynUnion_ptr *);

extern int comp_count(VSDynUnion_ptr *);

extern int return_correct_disTCKind(VSTCKind);

extern int return_correct_memTCKind(VSTCKind);

extern int valid_DynAny(VSDynAny_ptr *);

extern int valid_return_string(VSString);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSDynUnion_ptr_P)(VSDynUnion_ptr*, emitter_t);
extern void (*ADL__print_VSDynAny_ptr_P)(VSDynAny_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSTCKind)(VSTCKind, emitter_t);
extern void (*ADL__print_VSString)(VSString, emitter_t);

/* Declarations of wrapper of FUT */
extern VSBoolean (*ADL__VSset_discriminator_wrapper)(VSDynUnion_ptr*, VSDynAny_ptr*, VSEnvironment*);
extern VSDynAny_ptr *(*ADL__VSget_discriminator_wrapper)(VSDynUnion_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSset_to_default_member_wrapper)(VSDynUnion_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSset_to_no_active_member_wrapper)(VSDynUnion_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VShas_no_active_member_wrapper)(VSDynUnion_ptr*, VSEnvironment*);
extern VSTCKind (*ADL__VSdiscriminator_kind_wrapper)(VSDynUnion_ptr*, VSEnvironment*);
extern VSTCKind (*ADL__VSmember_kind_wrapper)(VSDynUnion_ptr*, VSEnvironment*);
extern VSDynAny_ptr *(*ADL__VSmember_wrapper)(VSDynUnion_ptr*, VSEnvironment*);
extern VSString (*ADL__VSmember_name_wrapper)(VSDynUnion_ptr*, VSEnvironment*);

#endif
