/* ADL test driver from t1.tdr
 *
 * test VScreate_dyn_any(dany_factory, inany, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_162[] = {
    {"valid", Pdany_factory_prop_1_valid, 0},
    {0, 0, 0}
};

/* values for prop prop_1 */
static struct ADL__propertyValue ADL__prop_values_163[] = {
    {"valid", Pinany_prop_1_valid, 0},
    {"invalid", Pinany_prop_1_invalid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_164[] = {
    {"prop_1", "prop", ADL__prop_values_162, 1},
    {"prop_1", "prop", ADL__prop_values_163, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_168[4] = {
    {"dany_factory", "VSDynAnyFactory_ptr *", ADL__prop_info_164, 0, 1},
    {"inany", "VSAny", ADL__prop_info_164, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_164, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScreate_dyn_any_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSOBJECTID_P
#define ADL__PRINT_VSOBJECTID_P
void (*ADL__print_VSObjectId_P)(VSObjectId*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECTID_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSDYNANYFACTORY_PTR_P
#define ADL__PRINT_VSDYNANYFACTORY_PTR_P
void (*ADL__print_VSDynAnyFactory_ptr_P)(VSDynAnyFactory_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNANYFACTORY_PTR_P */
#ifndef ADL__PRINT_VSANY
#define ADL__PRINT_VSANY
void (*ADL__print_VSAny)(VSAny, emitter_t) = 0;

#endif /* ADL__PRINT_VSANY */
#ifndef ADL__PRINT_VSDYNANY_PTR_P
#define ADL__PRINT_VSDYNANY_PTR_P
void (*ADL__print_VSDynAny_ptr_P)(VSDynAny_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSDYNANY_PTR_P */
#ifndef ADL__PRINT_VSTYPECODE_PTR_P
#define ADL__PRINT_VSTYPECODE_PTR_P
void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR_P */

void ADL__emit_VSObjectId_P (void* val, emitter_t emitter)
{
  VSObjectId *tmp;

  if (ADL__print_VSObjectId_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObjectId_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDynAnyFactory_ptr_P (void* val, emitter_t emitter)
{
  VSDynAnyFactory_ptr *tmp;

  if (ADL__print_VSDynAnyFactory_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSDynAnyFactory_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAny (void* val, emitter_t emitter)
{
  VSAny tmp;

  if (ADL__print_VSAny != 0) {
    tmp = *(VSAny*) val;
    ADL__print_VSAny(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDynAny_ptr_P (void* val, emitter_t emitter)
{
  VSDynAny_ptr *tmp;

  if (ADL__print_VSDynAny_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSDynAny_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter)
{
  VSTypeCode_ptr *tmp;

  if (ADL__print_VSTypeCode_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSTypeCode_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {1, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSDynAnyFactory_ptr *dany_factory_165;
    VSAny inany_166;
    VSEnvironment *env_167;
    VSDynAny_ptr *fut_return_161;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScreate_dyn_any_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScreate_dyn_any_InfoArrayIdx,
        ADL__VScreate_dyn_any_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_dany_factory(&dany_factory_165, ADL__prop_values_162[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSDynAnyFactory_ptr_P(&dany_factory_165, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_inany(&inany_166, ADL__prop_values_163[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSAny(&inany_166, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_167)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_167, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScreate_dyn_any_assertionReport = rf->assertionReport;
       fut_return_161 = ADL__ACF_VScreate_dyn_any(dany_factory_165, inany_166, env_167);
       test_value = ADL__VScreate_dyn_any_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_167);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_inany(&inany_166, ADL__prop_values_163[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_dany_factory(&dany_factory_165, ADL__prop_values_162[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_168,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScreate_dyn_any_head);

    return 0;
}


struct ADL__Directive_info VScreate_dyn_any1_info = {
    N_VARS,
    ADL__var_info_168
};

struct ADL__TDD_info ADL__test_info = {
    2,
    &ADL__VScreate_dyn_any_InfoArrayIdx,
    ADL__VScreate_dyn_any_InfoArray,
    ADL__test_driver,
    "VScreate_dyn_any",
    "VScreate_dyn_any1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScreate_dyn_any1",
    "t1_tr.rif",
    &VScreate_dyn_any1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

