/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSget_DynAnyFactory
 *
 */
VSDynAnyFactory_ptr *ADL__ACF_VSget_DynAnyFactory (VSObjectId *id_21, VSEnvironment *ev_10){

VSDynAnyFactory_ptr *VSget_DynAnyFactory_RtnVal_4;
  void *dummyVarName_89;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_22;
  int tmp_24;
  int tmp_25;
  VSEnvironment *ev_10_tmp_29;
    int tmp_30;
  int tmp_31;
  int groupExpr_35;
  int tmp_32;

/* Declare vars for result of normal and exception bindings */
  int VSget_DynAnyFactory_NormalOutcome_5, VSget_DynAnyFactory_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSget_DynAnyFactory_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSget_DynAnyFactory_InfoArray, 0, ADL__VSget_DynAnyFactory_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSget_DynAnyFactory_assertionReport->setPhase(ADL__VSget_DynAnyFactory_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_DynAnyFactory_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].error > VSget_DynAnyFactory_ACF_Result_3))
  VSget_DynAnyFactory_ACF_Result_3 = ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSget_DynAnyFactory_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSget_DynAnyFactory_assertionReport->setPhase(ADL__VSget_DynAnyFactory_assertionReport, PH_call);
  ADL__release(ADL__VSget_DynAnyFactory_assertionReport->parent, &this_seq);
  VSget_DynAnyFactory_RtnVal_4 = ADL__VSget_DynAnyFactory_wrapper(id_21, ev_10);
  ADL__recover(ADL__VSget_DynAnyFactory_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSget_DynAnyFactory_assertionReport->setPhase(ADL__VSget_DynAnyFactory_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 7,&tmp_7);
  VSget_DynAnyFactory_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 2,&tmp_13);
  ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSget_DynAnyFactory_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 1,&tmp_12);

  VSget_DynAnyFactory_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSget_DynAnyFactory_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSget_DynAnyFactory_InfoArray[0].result = (VSget_DynAnyFactory_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_DynAnyFactory_InfoArray[0].evaluated = 1;
  ADL__VSget_DynAnyFactory_InfoArray[0].value = (VSget_DynAnyFactory_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSget_DynAnyFactory_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSget_DynAnyFactory_InfoArray[6].result = (VSget_DynAnyFactory_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSget_DynAnyFactory_InfoArray[6].evaluated = 1;
  ADL__VSget_DynAnyFactory_InfoArray[6].value = (VSget_DynAnyFactory_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSget_DynAnyFactory_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSget_DynAnyFactory_ACF_Result_3 = ADL__VSget_DynAnyFactory_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSget_DynAnyFactory_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSget_DynAnyFactory_ACF_Result_3 = ADL__VSget_DynAnyFactory_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSget_DynAnyFactory_ExceptionOutcome_6 && !VSget_DynAnyFactory_NormalOutcome_5) {
  VSget_DynAnyFactory_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSget_DynAnyFactory_ExceptionOutcome_6 && VSget_DynAnyFactory_NormalOutcome_5) {
  VSget_DynAnyFactory_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 10,&VSget_DynAnyFactory_ExceptionOutcome_6);
  ev_10_tmp_29 = ev_10;
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 13,&ev_10_tmp_29);
  ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 12,&tmp_25);
  ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = !tmp_25;
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 11,&tmp_24);
  ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_22 = (!VSget_DynAnyFactory_ExceptionOutcome_6 || tmp_24);
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 9,&tmp_22);
    ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSget_DynAnyFactory_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 16,&VSget_DynAnyFactory_RtnVal_4);
  ADL__VSget_DynAnyFactory_assertionReport->exprMark(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_assertionReport->assrt_info[15]);

/* Evaluate is_DynAnyFactory(return) */
  tmp_32 = is_DynAnyFactory(VSget_DynAnyFactory_RtnVal_4);
  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 15,&tmp_32);
  groupExpr_35 = (tmp_32);
  tmp_31 = (groupExpr_35);
  tmp_30 = tmp_31;
  }
  else {
    ADL__resetInfoStruct(ADL__VSget_DynAnyFactory_InfoArray, 14, 16);
  tmp_30 = 1;
}

  ADL__setResultAndError(ADL__VSget_DynAnyFactory_InfoArray, 14,&tmp_30);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_DynAnyFactory_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].level == 0))
        VSget_DynAnyFactory_ACF_Result_3 = calculate_ACF_result(VSget_DynAnyFactory_ACF_Result_3, ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSget_DynAnyFactory_assertionReport->value = VSget_DynAnyFactory_ACF_Result_3;
  ADL__VSget_DynAnyFactory_assertionReport->parent->openReport(ADL__VSget_DynAnyFactory_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSget_DynAnyFactory_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSget_DynAnyFactory_assertionReport->emitTest(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1])) {
     ADL__VSget_DynAnyFactory_assertionReport->exprStart(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1]);
      if(!ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].testable || !ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSget_DynAnyFactory_assertionReport->emitter);
      else if (ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].error, ADL__VSget_DynAnyFactory_assertionReport->emitter);
      else
        ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].emitFunc(ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1].value, ADL__VSget_DynAnyFactory_assertionReport->emitter);
     ADL__VSget_DynAnyFactory_assertionReport->exprEnd(ADL__VSget_DynAnyFactory_assertionReport, &ADL__VSget_DynAnyFactory_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSget_DynAnyFactory_RtnVal_4);
}


VSDynAnyFactory_ptr *(*ADL__VSget_DynAnyFactory_wrapper)(VSObjectId*, VSEnvironment*) = VSget_DynAnyFactory;

void ADL__emit_VSObjectId_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDynAnyFactory_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSget_DynAnyFactory_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "is_DynAnyFactory(return)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynAnyFactory_ptr_P }
};


unsigned int ADL__VSget_DynAnyFactory_InfoArrayIdx = 17;

struct ADL__reportAssertion *ADL__VSget_DynAnyFactory_assertionReport = 0;

/*
 *
 * ACF of VScreate_dyn_any
 *
 */
VSDynAny_ptr *ADL__ACF_VScreate_dyn_any (VSDynAnyFactory_ptr *factory_55, VSAny inany_56, VSEnvironment *ev_44){

VSDynAny_ptr *VScreate_dyn_any_RtnVal_38;
  void *dummyVarName_89;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_57;
  int tmp_59;
  int tmp_60;
  VSEnvironment *ev_44_tmp_64;
    int tmp_65;
  int tmp_66;
  int tmp_67;
  VSAny inany_56_tmp_70;
  int tmp_71;
  VSEnvironment *ev_44_tmp_75;
    int tmp_76;
  int tmp_77;
  int groupExpr_88;
  int tmp_78;
  int tmp_79;
  VSAny inany_56_tmp_82;
  int tmp_83;
  VSAny inany_56_tmp_87;

/* Declare vars for result of normal and exception bindings */
  int VScreate_dyn_any_NormalOutcome_39, VScreate_dyn_any_ExceptionOutcome_40;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_41;
  VSEnvironment *ev_44_tmp_45;
    int tmp_46;
  int tmp_47;
  VSEnvironment *ev_44_tmp_50;
  int tmp_51;
  VSEnvironment *ev_44_tmp_54;
  enum ADL__ACF_result VScreate_dyn_any_ACF_Result_37 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VScreate_dyn_any_InfoArray, 0, ADL__VScreate_dyn_any_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VScreate_dyn_any_assertionReport->setPhase(ADL__VScreate_dyn_any_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScreate_dyn_any_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].error > VScreate_dyn_any_ACF_Result_37))
  VScreate_dyn_any_ACF_Result_37 = ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VScreate_dyn_any_ACF_Result_37 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VScreate_dyn_any_assertionReport->setPhase(ADL__VScreate_dyn_any_assertionReport, PH_call);
  ADL__release(ADL__VScreate_dyn_any_assertionReport->parent, &this_seq);
  VScreate_dyn_any_RtnVal_38 = ADL__VScreate_dyn_any_wrapper(factory_55, inany_56, ev_44);
  ADL__recover(ADL__VScreate_dyn_any_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VScreate_dyn_any_assertionReport->setPhase(ADL__VScreate_dyn_any_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_44_tmp_45 = ev_44;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 8,&ev_44_tmp_45);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_41 = no_exception(ev_44);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 7,&tmp_41);
  VScreate_dyn_any_NormalOutcome_39 = (tmp_41);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_44_tmp_50 = ev_44;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 3,&ev_44_tmp_50);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_47 = system_exception(ev_44);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 2,&tmp_47);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_46 = tmp_47;
  if (!tmp_47) {
      ev_44_tmp_54 = ev_44;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 5,&ev_44_tmp_54);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_51 = user_exception(ev_44);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 4,&tmp_51);
    tmp_46 = tmp_51;
  }
  else {
  ADL__resetInfoStruct(ADL__VScreate_dyn_any_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 1,&tmp_46);

  VScreate_dyn_any_ExceptionOutcome_40 = (tmp_46);

/* Exception binding is the first assertion */
  if (ADL__VScreate_dyn_any_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VScreate_dyn_any_InfoArray[0].result = (VScreate_dyn_any_ExceptionOutcome_40 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScreate_dyn_any_InfoArray[0].evaluated = 1;
  ADL__VScreate_dyn_any_InfoArray[0].value = (VScreate_dyn_any_ExceptionOutcome_40 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VScreate_dyn_any_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VScreate_dyn_any_InfoArray[6].result = (VScreate_dyn_any_NormalOutcome_39 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScreate_dyn_any_InfoArray[6].evaluated = 1;
  ADL__VScreate_dyn_any_InfoArray[6].value = (VScreate_dyn_any_NormalOutcome_39 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VScreate_dyn_any_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VScreate_dyn_any_ACF_Result_37 = ADL__VScreate_dyn_any_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VScreate_dyn_any_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VScreate_dyn_any_ACF_Result_37 = ADL__VScreate_dyn_any_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VScreate_dyn_any_ExceptionOutcome_40 && !VScreate_dyn_any_NormalOutcome_39) {
  VScreate_dyn_any_ACF_Result_37 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VScreate_dyn_any_ExceptionOutcome_40 && VScreate_dyn_any_NormalOutcome_39) {
  VScreate_dyn_any_ACF_Result_37 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 10,&VScreate_dyn_any_ExceptionOutcome_40);
  ev_44_tmp_64 = ev_44;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 13,&ev_44_tmp_64);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_60 = user_exception_is("NOT_IMPLEMENTED", ev_44);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 12,&tmp_60);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_59 = !tmp_60;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 11,&tmp_59);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_57 = (!VScreate_dyn_any_ExceptionOutcome_40 || tmp_59);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 9,&tmp_57);
    inany_56_tmp_70 = inany_56;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 17,&inany_56_tmp_70);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[16]);

/* Evaluate is_valid_input(inany) */
  tmp_67 = is_valid_input(inany_56);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 16,&tmp_67);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[15]);

/* Evaluate !is_valid_input(inany) */
  tmp_66 = !tmp_67;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 15,&tmp_66);
  ev_44_tmp_75 = ev_44;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 19,&ev_44_tmp_75);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[18]);

/* Evaluate DAny_user_exception_is("InconsistentTypeCode", ev) */
  tmp_71 = DAny_user_exception_is("InconsistentTypeCode", ev_44);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 18,&tmp_71);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[14]);

/* Evaluate !is_valid_input(inany) --> DAny_user_exception_is("InconsistentTypeCode", ev) */
  tmp_65 = (!tmp_66 || tmp_71);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 14,&tmp_65);
    ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[20]);

/* Evaluate normally { ... } */
  if(VScreate_dyn_any_NormalOutcome_39){
      inany_56_tmp_82 = inany_56;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 23,&inany_56_tmp_82);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[22]);

/* Evaluate is_valid_input(inany) */
  tmp_79 = is_valid_input(inany_56);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 22,&tmp_79);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 25,&VScreate_dyn_any_RtnVal_38);
  inany_56_tmp_87 = inany_56;
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 26,&inany_56_tmp_87);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[24]);

/* Evaluate equal_Any(return, inany) */
  tmp_83 = equal_Any(VScreate_dyn_any_RtnVal_38, inany_56);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 24,&tmp_83);
  ADL__VScreate_dyn_any_assertionReport->exprMark(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_assertionReport->assrt_info[21]);

/* Evaluate is_valid_input(inany) --> equal_Any(return, inany) */
  tmp_78 = (!tmp_79 || tmp_83);
  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 21,&tmp_78);
  groupExpr_88 = (tmp_78);
  tmp_77 = (groupExpr_88);
  tmp_76 = tmp_77;
  }
  else {
    ADL__resetInfoStruct(ADL__VScreate_dyn_any_InfoArray, 20, 26);
  tmp_76 = 1;
}

  ADL__setResultAndError(ADL__VScreate_dyn_any_InfoArray, 20,&tmp_76);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScreate_dyn_any_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].level == 0))
        VScreate_dyn_any_ACF_Result_37 = calculate_ACF_result(VScreate_dyn_any_ACF_Result_37, ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VScreate_dyn_any_assertionReport->value = VScreate_dyn_any_ACF_Result_37;
  ADL__VScreate_dyn_any_assertionReport->parent->openReport(ADL__VScreate_dyn_any_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScreate_dyn_any_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VScreate_dyn_any_assertionReport->emitTest(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1])) {
     ADL__VScreate_dyn_any_assertionReport->exprStart(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1]);
      if(!ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].testable || !ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VScreate_dyn_any_assertionReport->emitter);
      else if (ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].error, ADL__VScreate_dyn_any_assertionReport->emitter);
      else
        ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].emitFunc(ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1].value, ADL__VScreate_dyn_any_assertionReport->emitter);
     ADL__VScreate_dyn_any_assertionReport->exprEnd(ADL__VScreate_dyn_any_assertionReport, &ADL__VScreate_dyn_any_InfoArray[forLoopIdx_1]);
    }
  }

  return (VScreate_dyn_any_RtnVal_38);
}


VSDynAny_ptr *(*ADL__VScreate_dyn_any_wrapper)(VSDynAnyFactory_ptr*, VSAny, VSEnvironment*) = VScreate_dyn_any;

void ADL__emit_VSDynAnyFactory_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSAny (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDynAny_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VScreate_dyn_any_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "!is_valid_input(inany) --> DAny_user_exception_is(\"InconsistentTypeCode\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "!is_valid_input(inany)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "is_valid_input(inany)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "inany", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSAny },
  {2, 18, 14, 0, 0, "DAny_user_exception_is(\"InconsistentTypeCode\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 20, 20, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_valid_input(inany) --> equal_Any(return, inany)", 21, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "is_valid_input(inany)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 23, 22, 0, 0, "inany", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSAny },
  {4, 24, 21, 0, 0, "equal_Any(return, inany)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynAny_ptr_P },
  {4, 26, 24, 0, 0, "inany", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSAny }
};


unsigned int ADL__VScreate_dyn_any_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VScreate_dyn_any_assertionReport = 0;

/*
 *
 * ACF of VScreate_dyn_any_from_type_code
 *
 */
VSDynAny_ptr *ADL__ACF_VScreate_dyn_any_from_type_code (VSDynAnyFactory_ptr *factory_108, VSTypeCode_ptr *tc_109, VSEnvironment *ev_97){

VSDynAny_ptr *VScreate_dyn_any_from_type_code_RtnVal_91;
  void *dummyVarName_89;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_110;
  int tmp_112;
  int tmp_113;
  VSEnvironment *ev_97_tmp_117;
    int tmp_118;
  int tmp_119;
  int tmp_120;
  int tmp_121;
  VSTypeCode_ptr *tc_109_tmp_124;
  int tmp_125;
  int tmp_126;
  VSTypeCode_ptr *tc_109_tmp_129;
  int tmp_130;
  VSEnvironment *ev_97_tmp_134;
    int tmp_135;
  int tmp_136;
  int groupExpr_153;
  int groupExpr_154;
  int tmp_137;
  int tmp_138;
  VSTypeCode_ptr *tc_109_tmp_141;
  int tmp_142;
  int tmp_145;
  int tmp_146;
  VSTypeCode_ptr *tc_109_tmp_149;
  int tmp_150;

/* Declare vars for result of normal and exception bindings */
  int VScreate_dyn_any_from_type_code_NormalOutcome_92, VScreate_dyn_any_from_type_code_ExceptionOutcome_93;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_94;
  VSEnvironment *ev_97_tmp_98;
    int tmp_99;
  int tmp_100;
  VSEnvironment *ev_97_tmp_103;
  int tmp_104;
  VSEnvironment *ev_97_tmp_107;
  enum ADL__ACF_result VScreate_dyn_any_from_type_code_ACF_Result_90 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VScreate_dyn_any_from_type_code_InfoArray, 0, ADL__VScreate_dyn_any_from_type_code_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VScreate_dyn_any_from_type_code_assertionReport->setPhase(ADL__VScreate_dyn_any_from_type_code_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScreate_dyn_any_from_type_code_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].error > VScreate_dyn_any_from_type_code_ACF_Result_90))
  VScreate_dyn_any_from_type_code_ACF_Result_90 = ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VScreate_dyn_any_from_type_code_ACF_Result_90 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VScreate_dyn_any_from_type_code_assertionReport->setPhase(ADL__VScreate_dyn_any_from_type_code_assertionReport, PH_call);
  ADL__release(ADL__VScreate_dyn_any_from_type_code_assertionReport->parent, &this_seq);
  VScreate_dyn_any_from_type_code_RtnVal_91 = ADL__VScreate_dyn_any_from_type_code_wrapper(factory_108, tc_109, ev_97);
  ADL__recover(ADL__VScreate_dyn_any_from_type_code_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VScreate_dyn_any_from_type_code_assertionReport->setPhase(ADL__VScreate_dyn_any_from_type_code_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_97_tmp_98 = ev_97;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 8,&ev_97_tmp_98);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_94 = no_exception(ev_97);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 7,&tmp_94);
  VScreate_dyn_any_from_type_code_NormalOutcome_92 = (tmp_94);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_97_tmp_103 = ev_97;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 3,&ev_97_tmp_103);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_100 = system_exception(ev_97);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 2,&tmp_100);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_99 = tmp_100;
  if (!tmp_100) {
      ev_97_tmp_107 = ev_97;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 5,&ev_97_tmp_107);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_104 = user_exception(ev_97);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 4,&tmp_104);
    tmp_99 = tmp_104;
  }
  else {
  ADL__resetInfoStruct(ADL__VScreate_dyn_any_from_type_code_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 1,&tmp_99);

  VScreate_dyn_any_from_type_code_ExceptionOutcome_93 = (tmp_99);

/* Exception binding is the first assertion */
  if (ADL__VScreate_dyn_any_from_type_code_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VScreate_dyn_any_from_type_code_InfoArray[0].result = (VScreate_dyn_any_from_type_code_ExceptionOutcome_93 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScreate_dyn_any_from_type_code_InfoArray[0].evaluated = 1;
  ADL__VScreate_dyn_any_from_type_code_InfoArray[0].value = (VScreate_dyn_any_from_type_code_ExceptionOutcome_93 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VScreate_dyn_any_from_type_code_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VScreate_dyn_any_from_type_code_InfoArray[6].result = (VScreate_dyn_any_from_type_code_NormalOutcome_92 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScreate_dyn_any_from_type_code_InfoArray[6].evaluated = 1;
  ADL__VScreate_dyn_any_from_type_code_InfoArray[6].value = (VScreate_dyn_any_from_type_code_NormalOutcome_92 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VScreate_dyn_any_from_type_code_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VScreate_dyn_any_from_type_code_ACF_Result_90 = ADL__VScreate_dyn_any_from_type_code_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VScreate_dyn_any_from_type_code_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VScreate_dyn_any_from_type_code_ACF_Result_90 = ADL__VScreate_dyn_any_from_type_code_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VScreate_dyn_any_from_type_code_ExceptionOutcome_93 && !VScreate_dyn_any_from_type_code_NormalOutcome_92) {
  VScreate_dyn_any_from_type_code_ACF_Result_90 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VScreate_dyn_any_from_type_code_ExceptionOutcome_93 && VScreate_dyn_any_from_type_code_NormalOutcome_92) {
  VScreate_dyn_any_from_type_code_ACF_Result_90 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 10,&VScreate_dyn_any_from_type_code_ExceptionOutcome_93);
  ev_97_tmp_117 = ev_97;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 13,&ev_97_tmp_117);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_113 = user_exception_is("NOT_IMPLEMENTED", ev_97);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 12,&tmp_113);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_112 = !tmp_113;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 11,&tmp_112);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_110 = (!VScreate_dyn_any_from_type_code_ExceptionOutcome_93 || tmp_112);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 9,&tmp_110);
    tc_109_tmp_124 = tc_109;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 18,&tc_109_tmp_124);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[17]);

/* Evaluate is_short_tc(tc) */
  tmp_121 = is_short_tc(tc_109);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 17,&tmp_121);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[16]);

/* Evaluate !is_short_tc(tc) */
  tmp_120 = !tmp_121;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 16,&tmp_120);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[15]);

/* Evaluate !is_short_tc(tc) && !is_seq_tc(tc) */
  tmp_119 = tmp_120;
  if (tmp_120) {
      tc_109_tmp_129 = tc_109;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 21,&tc_109_tmp_129);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[20]);

/* Evaluate is_seq_tc(tc) */
  tmp_126 = is_seq_tc(tc_109);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 20,&tmp_126);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[19]);

/* Evaluate !is_seq_tc(tc) */
  tmp_125 = !tmp_126;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 19,&tmp_125);
    tmp_119 = tmp_125;
  }
  else {
  ADL__resetInfoStruct(ADL__VScreate_dyn_any_from_type_code_InfoArray, 19, 21);
  }
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 15,&tmp_119);
  ev_97_tmp_134 = ev_97;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 23,&ev_97_tmp_134);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[22]);

/* Evaluate DAny_user_exception_is("InconsistentTypeCode", ev) */
  tmp_130 = DAny_user_exception_is("InconsistentTypeCode", ev_97);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 22,&tmp_130);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[14]);

/* Evaluate !is_short_tc(tc) && !is_seq_tc(tc) --> DAny_user_exception_is("InconsistentTypeCode", ev) */
  tmp_118 = (!tmp_119 || tmp_130);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 14,&tmp_118);
    ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VScreate_dyn_any_from_type_code_NormalOutcome_92){
      tc_109_tmp_141 = tc_109;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 27,&tc_109_tmp_141);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[26]);

/* Evaluate is_short_tc(tc) */
  tmp_138 = is_short_tc(tc_109);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 26,&tmp_138);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 29,&VScreate_dyn_any_from_type_code_RtnVal_91);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[28]);

/* Evaluate is_DynAny(return) */
  tmp_142 = is_DynAny(VScreate_dyn_any_from_type_code_RtnVal_91);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 28,&tmp_142);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[25]);

/* Evaluate is_short_tc(tc) --> is_DynAny(return) */
  tmp_137 = (!tmp_138 || tmp_142);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 25,&tmp_137);
  groupExpr_153 = (tmp_137);
  tc_109_tmp_149 = tc_109;
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 32,&tc_109_tmp_149);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[31]);

/* Evaluate is_seq_tc(tc) */
  tmp_146 = is_seq_tc(tc_109);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 31,&tmp_146);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 34,&VScreate_dyn_any_from_type_code_RtnVal_91);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[33]);

/* Evaluate is_DynSeq(return) */
  tmp_150 = is_DynSeq(VScreate_dyn_any_from_type_code_RtnVal_91);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 33,&tmp_150);
  ADL__VScreate_dyn_any_from_type_code_assertionReport->exprMark(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_assertionReport->assrt_info[30]);

/* Evaluate is_seq_tc(tc) --> is_DynSeq(return) */
  tmp_145 = (!tmp_146 || tmp_150);
  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 30,&tmp_145);
  groupExpr_154 = (tmp_145);
  tmp_136 = (groupExpr_153 && groupExpr_154);
  tmp_135 = tmp_136;
  }
  else {
    ADL__resetInfoStruct(ADL__VScreate_dyn_any_from_type_code_InfoArray, 24, 34);
  tmp_135 = 1;
}

  ADL__setResultAndError(ADL__VScreate_dyn_any_from_type_code_InfoArray, 24,&tmp_135);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScreate_dyn_any_from_type_code_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].level == 0))
        VScreate_dyn_any_from_type_code_ACF_Result_90 = calculate_ACF_result(VScreate_dyn_any_from_type_code_ACF_Result_90, ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VScreate_dyn_any_from_type_code_assertionReport->value = VScreate_dyn_any_from_type_code_ACF_Result_90;
  ADL__VScreate_dyn_any_from_type_code_assertionReport->parent->openReport(ADL__VScreate_dyn_any_from_type_code_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScreate_dyn_any_from_type_code_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VScreate_dyn_any_from_type_code_assertionReport->emitTest(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1])) {
     ADL__VScreate_dyn_any_from_type_code_assertionReport->exprStart(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1]);
      if(!ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].testable || !ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VScreate_dyn_any_from_type_code_assertionReport->emitter);
      else if (ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].error, ADL__VScreate_dyn_any_from_type_code_assertionReport->emitter);
      else
        ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].emitFunc(ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1].value, ADL__VScreate_dyn_any_from_type_code_assertionReport->emitter);
     ADL__VScreate_dyn_any_from_type_code_assertionReport->exprEnd(ADL__VScreate_dyn_any_from_type_code_assertionReport, &ADL__VScreate_dyn_any_from_type_code_InfoArray[forLoopIdx_1]);
    }
  }

  return (VScreate_dyn_any_from_type_code_RtnVal_91);
}


VSDynAny_ptr *(*ADL__VScreate_dyn_any_from_type_code_wrapper)(VSDynAnyFactory_ptr*, VSTypeCode_ptr*, VSEnvironment*) = VScreate_dyn_any_from_type_code;

void ADL__emit_VSDynAnyFactory_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDynAny_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VScreate_dyn_any_from_type_code_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "!is_short_tc(tc) && !is_seq_tc(tc) --> DAny_user_exception_is(\"InconsistentTypeCode\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "!is_short_tc(tc) && !is_seq_tc(tc)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "!is_short_tc(tc)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "is_short_tc(tc)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "tc", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P },
  {2, 19, 15, 0, 0, "!is_seq_tc(tc)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 20, 19, 0, 0, "is_seq_tc(tc)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "tc", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P },
  {2, 22, 14, 0, 0, "DAny_user_exception_is(\"InconsistentTypeCode\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 23, 22, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_short_tc(tc) --> is_DynAny(return)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "is_short_tc(tc)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 27, 26, 0, 0, "tc", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P },
  {4, 28, 25, 0, 0, "is_DynAny(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 29, 28, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynAny_ptr_P },
  {5, 30, 24, 0, 0, "is_seq_tc(tc) --> is_DynSeq(return)", 30, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 31, 30, 0, 0, "is_seq_tc(tc)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 32, 31, 0, 0, "tc", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P },
  {5, 33, 30, 0, 0, "is_DynSeq(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {5, 34, 33, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDynAny_ptr_P }
};


unsigned int ADL__VScreate_dyn_any_from_type_code_InfoArrayIdx = 35;

struct ADL__reportAssertion *ADL__VScreate_dyn_any_from_type_code_assertionReport = 0;
