#include "DAny_impl.h"
 
//
//TestInterfaceA_impl
//

TestInterfaceA_impl::TestInterfaceA_impl()
{ 
}

TestInterfaceA_impl::~TestInterfaceA_impl()
{ 
}

void TestInterfaceA_impl::display(DAnyTest::TestAbstrInterface_ptr d)
    throw(CORBA::SystemException)
{
    CORBA::String_var desc = d -> get_description();

    DAnyTest::TestInterface_var tIntf = DAnyTest::TestInterface::_narrow(d);
    DAnyTest::TestValue* tVal = DAnyTest::TestValue::_downcast(d);

    if(!CORBA::is_nil(tIntf))
        cout << "Received an interface : " << desc << endl;
    else if(tVal != 0)
        cout << "Received a value type : " << desc << endl;
}

//
//TestInterface_impl
//

TestInterface_impl::TestInterface_impl()
{ 
}

TestInterface_impl::~TestInterface_impl()
{ 
}

char* TestInterface_impl::get_description()
    throw(CORBA::SystemException)
{
    return CORBA::string_dup("TestInterface");
}


//
// TestValue_impl
//

TestValue_impl::TestValue_impl()
{
}

TestValue_impl::~TestValue_impl()
{
}

CORBA::ValueBase* TestValue_impl::_copy_value()
{
    return new TestValue_impl();
}

char* TestValue_impl::get_description()
    throw(CORBA::SystemException)
{
    return CORBA::string_dup("TestValue");
}

//
//  TestValueFactory_impl
//

CORBA::ValueBase* TestValueFactory_impl::create_for_unmarshal()
{
  return new TestValue_impl();
}

TestValueFactory_impl::TestValueFactory_impl()
{
}

TestValueFactory_impl::~TestValueFactory_impl()
{
}

DAnyTest::TestValue* TestValueFactory_impl::create()
{
    return new TestValue_impl();
}


