/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSnil
 *
 */
VSContext_ptr *ADL__ACF_VSnil (VSEnvironment *ev_10){

VSContext_ptr *VSnil_RtnVal_4;
  void *dummyVarName_102;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_22;
  int tmp_24;
  int tmp_25;
  VSEnvironment *ev_10_tmp_29;
    int tmp_30;
  int tmp_32;
  int tmp_33;
  int tmp_34;
  VSEnvironment *ev_10_tmp_37;
  int tmp_38;
  int tmp_39;
  VSEnvironment *ev_10_tmp_42;
    int tmp_43;
  int tmp_44;
  int groupExpr_53;
  int tmp_46;
  int tmp_47;
  int tmp_50;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_5, VSnil_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSnil_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_3))
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_4 = ADL__VSnil_wrapper(ev_10);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_7);
  VSnil_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_13);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_12);

  VSnil_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_6 && !VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_6 && VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_29 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_10_tmp_29);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_25);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = !tmp_25;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_24);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_22 = (!VSnil_ExceptionOutcome_6 || tmp_24);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_22);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_37 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_10_tmp_37);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_34 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_34);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_33 = !tmp_34;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_33);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_32 = tmp_33;
  if (tmp_33) {
      ev_10_tmp_42 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_10_tmp_42);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_39 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_39);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_38 = !tmp_39;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_38);
    tmp_32 = tmp_38;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_32);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_30 = (!VSnil_ExceptionOutcome_6 || tmp_32);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_30);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_context_ptr(return) */
  tmp_47 = is_nil_context_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_47);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_context_ptr(return) && cleanup_context_ptr(return) */
  tmp_46 = tmp_47;
  if (tmp_47) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_context_ptr(return) */
  tmp_50 = cleanup_context_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_50);
    tmp_46 = tmp_50;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_46);
  groupExpr_53 = (tmp_46);
  tmp_44 = (groupExpr_53);
  tmp_43 = tmp_44;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_43 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_43);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_3 = calculate_ACF_result(VSnil_ACF_Result_3, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_3;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_4);
}


VSContext_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSContext_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_context_ptr(return) && cleanup_context_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_context_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_context_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSContext_ptr *ADL__ACF_VSduplicate (VSContext_ptr *o_73, VSEnvironment *ev_62){

VSContext_ptr *VSduplicate_RtnVal_56;
  void *dummyVarName_102;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_74;
  int tmp_76;
  int tmp_77;
  VSEnvironment *ev_62_tmp_81;
    int tmp_82;
  int tmp_84;
  int tmp_85;
  VSEnvironment *ev_62_tmp_88;
    int tmp_89;
  int tmp_90;
  int groupExpr_101;
  int tmp_92;
  int tmp_93;
  VSContext_ptr *o_73_tmp_97;
  int tmp_98;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_57, VSduplicate_ExceptionOutcome_58;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_59;
  VSEnvironment *ev_62_tmp_63;
    int tmp_64;
  int tmp_65;
  VSEnvironment *ev_62_tmp_68;
  int tmp_69;
  VSEnvironment *ev_62_tmp_72;
  enum ADL__ACF_result VSduplicate_ACF_Result_55 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_55))
  VSduplicate_ACF_Result_55 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_55 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_56 = ADL__VSduplicate_wrapper(o_73, ev_62);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_62_tmp_63 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_62_tmp_63);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_59 = no_exception(ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_59);
  VSduplicate_NormalOutcome_57 = (tmp_59);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_62_tmp_68 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_62_tmp_68);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_65 = system_exception(ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_65);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_64 = tmp_65;
  if (!tmp_65) {
      ev_62_tmp_72 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_62_tmp_72);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_69 = user_exception(ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_69);
    tmp_64 = tmp_69;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_64);

  VSduplicate_ExceptionOutcome_58 = (tmp_64);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_58 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_58 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_57 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_57 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_55 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_55 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_58 && !VSduplicate_NormalOutcome_57) {
  VSduplicate_ACF_Result_55 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_58 && VSduplicate_NormalOutcome_57) {
  VSduplicate_ACF_Result_55 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_58);
  ev_62_tmp_81 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_62_tmp_81);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_77 = user_exception_is("NOT_IMPLEMENTED", ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_77);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_76 = !tmp_77;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_76);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_74 = (!VSduplicate_ExceptionOutcome_58 || tmp_76);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_74);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_58);
  ev_62_tmp_88 = ev_62;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&ev_62_tmp_88);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_85 = user_exception(ev_62);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_85);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_84 = !tmp_85;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_84);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_82 = (!VSduplicate_ExceptionOutcome_58 || tmp_84);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_82);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_57){
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&VSduplicate_RtnVal_56);
  o_73_tmp_97 = o_73;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&o_73_tmp_97);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate is_same_context_ptr(return, o) */
  tmp_93 = is_same_context_ptr(VSduplicate_RtnVal_56, o_73);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_93);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate is_same_context_ptr(return, o) && cleanup_context_ptr(return) */
  tmp_92 = tmp_93;
  if (tmp_93) {
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&VSduplicate_RtnVal_56);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate cleanup_context_ptr(return) */
  tmp_98 = cleanup_context_ptr(VSduplicate_RtnVal_56);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_98);
    tmp_92 = tmp_98;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 24, 25);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_92);
  groupExpr_101 = (tmp_92);
  tmp_90 = (groupExpr_101);
  tmp_89 = tmp_90;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 19, 25);
  tmp_89 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&tmp_89);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_55 = calculate_ACF_result(VSduplicate_ACF_Result_55, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_55;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_56);
}


VSContext_ptr *(*ADL__VSduplicate_wrapper)(VSContext_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSContext_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_same_context_ptr(return, o) && cleanup_context_ptr(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_same_context_ptr(return, o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P },
  {4, 23, 21, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P },
  {4, 24, 20, 0, 0, "cleanup_context_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSset_one_value
 *
 */
VSStatus ADL__ACF_VSset_one_value (VSContext_ptr *ctx_121, VSIdentifier s_122, VSAny *any_123, VSEnvironment *ev_110){

VSStatus VSset_one_value_RtnVal_104;
  void *dummyVarName_102;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_125;
  int tmp_127;
  int tmp_128;
  VSEnvironment *ev_110_tmp_132;
    int tmp_133;
  int tmp_135;
  int tmp_136;
  VSEnvironment *ev_110_tmp_139;
    int tmp_141;
  int tmp_143;
  int tmp_144;
  VSContext_ptr *ctx_121_tmp_147;
  int tmp_148;
  VSIdentifier s_122_tmp_151;
  int tmp_152;
  VSEnvironment *ev_110_tmp_155;
    int tmp_157;
  int tmp_159;
  int tmp_160;
  VSContext_ptr *ctx_121_tmp_163;
  int tmp_164;
  VSAny *any_123_tmp_167;
  int tmp_168;
  VSEnvironment *ev_110_tmp_171;
    int tmp_172;
  int tmp_173;
  int groupExpr_183;
  int tmp_174;
  int tmp_175;
  VSContext_ptr *ctx_121_tmp_178;
  int tmp_179;
  VSContext_ptr *ctx_121_tmp_182;

/* Declare vars for result of normal and exception bindings */
  int VSset_one_value_NormalOutcome_105, VSset_one_value_ExceptionOutcome_106;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_107;
  VSEnvironment *ev_110_tmp_111;
    int tmp_112;
  int tmp_113;
  VSEnvironment *ev_110_tmp_116;
  int tmp_117;
  VSEnvironment *ev_110_tmp_120;
  enum ADL__ACF_result VSset_one_value_ACF_Result_103 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSset_one_value_InfoArray, 0, ADL__VSset_one_value_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSset_one_value_assertionReport->setPhase(ADL__VSset_one_value_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
          
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_one_value_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSset_one_value_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSset_one_value_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSset_one_value_InfoArray[forLoopIdx_1].error > VSset_one_value_ACF_Result_103))
  VSset_one_value_ACF_Result_103 = ADL__VSset_one_value_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSset_one_value_ACF_Result_103 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSset_one_value_assertionReport->setPhase(ADL__VSset_one_value_assertionReport, PH_call);
  ADL__release(ADL__VSset_one_value_assertionReport->parent, &this_seq);
  VSset_one_value_RtnVal_104 = ADL__VSset_one_value_wrapper(ctx_121, s_122, any_123, ev_110);
  ADL__recover(ADL__VSset_one_value_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSset_one_value_assertionReport->setPhase(ADL__VSset_one_value_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_110_tmp_111 = ev_110;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 8,&ev_110_tmp_111);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_107 = no_exception(ev_110);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 7,&tmp_107);
  VSset_one_value_NormalOutcome_105 = (tmp_107);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_110_tmp_116 = ev_110;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 3,&ev_110_tmp_116);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_113 = system_exception(ev_110);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 2,&tmp_113);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_112 = tmp_113;
  if (!tmp_113) {
      ev_110_tmp_120 = ev_110;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 5,&ev_110_tmp_120);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_117 = user_exception(ev_110);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 4,&tmp_117);
    tmp_112 = tmp_117;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_one_value_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 1,&tmp_112);

  VSset_one_value_ExceptionOutcome_106 = (tmp_112);

/* Exception binding is the first assertion */
  if (ADL__VSset_one_value_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSset_one_value_InfoArray[0].result = (VSset_one_value_ExceptionOutcome_106 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_one_value_InfoArray[0].evaluated = 1;
  ADL__VSset_one_value_InfoArray[0].value = (VSset_one_value_ExceptionOutcome_106 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSset_one_value_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSset_one_value_InfoArray[6].result = (VSset_one_value_NormalOutcome_105 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSset_one_value_InfoArray[6].evaluated = 1;
  ADL__VSset_one_value_InfoArray[6].value = (VSset_one_value_NormalOutcome_105 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSset_one_value_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSset_one_value_ACF_Result_103 = ADL__VSset_one_value_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSset_one_value_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSset_one_value_ACF_Result_103 = ADL__VSset_one_value_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSset_one_value_ExceptionOutcome_106 && !VSset_one_value_NormalOutcome_105) {
  VSset_one_value_ACF_Result_103 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSset_one_value_ExceptionOutcome_106 && VSset_one_value_NormalOutcome_105) {
  VSset_one_value_ACF_Result_103 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 10,&VSset_one_value_ExceptionOutcome_106);
  ev_110_tmp_132 = ev_110;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 13,&ev_110_tmp_132);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_128 = user_exception_is("NOT_IMPLEMENTED", ev_110);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 12,&tmp_128);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_127 = !tmp_128;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 11,&tmp_127);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_125 = (!VSset_one_value_ExceptionOutcome_106 || tmp_127);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 9,&tmp_125);
    ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 15,&VSset_one_value_ExceptionOutcome_106);
  ev_110_tmp_139 = ev_110;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 18,&ev_110_tmp_139);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_136 = user_exception(ev_110);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 17,&tmp_136);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_135 = !tmp_136;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 16,&tmp_135);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_133 = (!VSset_one_value_ExceptionOutcome_106 || tmp_135);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 14,&tmp_133);
    ctx_121_tmp_147 = ctx_121;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 22,&ctx_121_tmp_147);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[21]);

/* Evaluate is_good_context_ptr(ctx) */
  tmp_144 = is_good_context_ptr(ctx_121);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 21,&tmp_144);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[20]);

/* Evaluate is_good_context_ptr(ctx) && is_invalid_identifier(s) */
  tmp_143 = tmp_144;
  if (tmp_144) {
      s_122_tmp_151 = s_122;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 24,&s_122_tmp_151);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[23]);

/* Evaluate is_invalid_identifier(s) */
  tmp_148 = is_invalid_identifier(s_122);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 23,&tmp_148);
    tmp_143 = tmp_148;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_one_value_InfoArray, 23, 24);
  }
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 20,&tmp_143);
  ev_110_tmp_155 = ev_110;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 26,&ev_110_tmp_155);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[25]);

/* Evaluate system_exception(ev) */
  tmp_152 = system_exception(ev_110);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 25,&tmp_152);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[19]);

/* Evaluate (is_good_context_ptr(ctx) && is_invalid_identifier(s)) --> system_exception(ev) */
  tmp_141 = (!tmp_143 || tmp_152);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 19,&tmp_141);
    ctx_121_tmp_163 = ctx_121;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 30,&ctx_121_tmp_163);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[29]);

/* Evaluate is_good_context_ptr(ctx) */
  tmp_160 = is_good_context_ptr(ctx_121);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 29,&tmp_160);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[28]);

/* Evaluate is_good_context_ptr(ctx) && is_invalid_any(any) */
  tmp_159 = tmp_160;
  if (tmp_160) {
      any_123_tmp_167 = any_123;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 32,&any_123_tmp_167);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[31]);

/* Evaluate is_invalid_any(any) */
  tmp_164 = is_invalid_any(any_123);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 31,&tmp_164);
    tmp_159 = tmp_164;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_one_value_InfoArray, 31, 32);
  }
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 28,&tmp_159);
  ev_110_tmp_171 = ev_110;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 34,&ev_110_tmp_171);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[33]);

/* Evaluate system_exception(ev) */
  tmp_168 = system_exception(ev_110);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 33,&tmp_168);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[27]);

/* Evaluate (is_good_context_ptr(ctx) && is_invalid_any(any)) --> system_exception(ev) */
  tmp_157 = (!tmp_159 || tmp_168);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 27,&tmp_157);
    ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[35]);

/* Evaluate normally { ... } */
  if(VSset_one_value_NormalOutcome_105){
      ctx_121_tmp_178 = ctx_121;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 38,&ctx_121_tmp_178);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[37]);

/* Evaluate sets_single_value(ctx) */
  tmp_175 = sets_single_value(ctx_121);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 37,&tmp_175);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[36]);

/* Evaluate sets_single_value(ctx) && cleanup_context_ptr(ctx) */
  tmp_174 = tmp_175;
  if (tmp_175) {
      ctx_121_tmp_182 = ctx_121;
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 40,&ctx_121_tmp_182);
  ADL__VSset_one_value_assertionReport->exprMark(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_assertionReport->assrt_info[39]);

/* Evaluate cleanup_context_ptr(ctx) */
  tmp_179 = cleanup_context_ptr(ctx_121);
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 39,&tmp_179);
    tmp_174 = tmp_179;
  }
  else {
  ADL__resetInfoStruct(ADL__VSset_one_value_InfoArray, 39, 40);
  }
  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 36,&tmp_174);
  groupExpr_183 = (tmp_174);
  tmp_173 = (groupExpr_183);
  tmp_172 = tmp_173;
  }
  else {
    ADL__resetInfoStruct(ADL__VSset_one_value_InfoArray, 35, 40);
  tmp_172 = 1;
}

  ADL__setResultAndError(ADL__VSset_one_value_InfoArray, 35,&tmp_172);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_one_value_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSset_one_value_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSset_one_value_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSset_one_value_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSset_one_value_InfoArray[forLoopIdx_1].level == 0))
        VSset_one_value_ACF_Result_103 = calculate_ACF_result(VSset_one_value_ACF_Result_103, ADL__VSset_one_value_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSset_one_value_assertionReport->value = VSset_one_value_ACF_Result_103;
  ADL__VSset_one_value_assertionReport->parent->openReport(ADL__VSset_one_value_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSset_one_value_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSset_one_value_assertionReport->emitTest(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_InfoArray[forLoopIdx_1])) {
     ADL__VSset_one_value_assertionReport->exprStart(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_InfoArray[forLoopIdx_1]);
      if(!ADL__VSset_one_value_InfoArray[forLoopIdx_1].testable || !ADL__VSset_one_value_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSset_one_value_assertionReport->emitter);
      else if (ADL__VSset_one_value_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSset_one_value_InfoArray[forLoopIdx_1].error, ADL__VSset_one_value_assertionReport->emitter);
      else
        ADL__VSset_one_value_InfoArray[forLoopIdx_1].emitFunc(ADL__VSset_one_value_InfoArray[forLoopIdx_1].value, ADL__VSset_one_value_assertionReport->emitter);
     ADL__VSset_one_value_assertionReport->exprEnd(ADL__VSset_one_value_assertionReport, &ADL__VSset_one_value_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSset_one_value_RtnVal_104);
}


VSStatus (*ADL__VSset_one_value_wrapper)(VSContext_ptr*, VSIdentifier, VSAny*, VSEnvironment*) = VSset_one_value;

void ADL__emit_VSContext_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSIdentifier (void* val, emitter_t emitter);
void ADL__emit_VSAny_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSset_one_value_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "(is_good_context_ptr(ctx) && is_invalid_identifier(s)) --> system_exception(ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_good_context_ptr(ctx) && is_invalid_identifier(s)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "is_good_context_ptr(ctx)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 22, 21, 0, 0, "ctx", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P },
  {3, 23, 20, 0, 0, "is_invalid_identifier(s)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 24, 23, 0, 0, "s", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIdentifier },
  {3, 25, 19, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 26, 25, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 27, 27, 0, 0, "(is_good_context_ptr(ctx) && is_invalid_any(any)) --> system_exception(ev)", 27, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "is_good_context_ptr(ctx) && is_invalid_any(any)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 29, 28, 0, 0, "is_good_context_ptr(ctx)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 30, 29, 0, 0, "ctx", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P },
  {4, 31, 28, 0, 0, "is_invalid_any(any)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 32, 31, 0, 0, "any", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSAny_P },
  {4, 33, 27, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 34, 33, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {5, 35, 35, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {6, 36, 35, 0, 0, "sets_single_value(ctx) && cleanup_context_ptr(ctx)", 36, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 37, 36, 0, 0, "sets_single_value(ctx)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 38, 37, 0, 0, "ctx", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P },
  {6, 39, 36, 0, 0, "cleanup_context_ptr(ctx)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {6, 40, 39, 0, 0, "ctx", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSContext_ptr_P }
};


unsigned int ADL__VSset_one_value_InfoArrayIdx = 41;

struct ADL__reportAssertion *ADL__VSset_one_value_assertionReport = 0;
