/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_same_context_ptr(VSContext_ptr *, VSContext_ptr *);

extern int cleanup_context_ptr(VSContext_ptr *);

extern int sets_single_value(VSContext_ptr *);

extern int is_good_context_ptr(VSContext_ptr *);

extern int is_invalid_identifier(VSIdentifier);

extern int is_invalid_any(VSAny *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSContext_ptr_P)(VSContext_ptr*, emitter_t);
extern void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t);
extern void (*ADL__print_VSAny_P)(VSAny*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSContext_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSContext_ptr *(*ADL__VSduplicate_wrapper)(VSContext_ptr*, VSEnvironment*);
extern VSStatus (*ADL__VSset_one_value_wrapper)(VSContext_ptr*, VSIdentifier, VSAny*, VSEnvironment*);

#endif
