/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/DII/ContextList/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:13:11  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.2  1997/10/01 15:58:55  cwatson
   Added count(), item(), remove(), add() and add_consume() tests.
   Makefile changes.

   Revision 1.1  1997/08/19 14:47:37  cwatson
   *** empty log message ***

   Revision 1.2  1997/08/19 13:54:02  cwatson
   *** empty log message ***

*/

#include <corba_defs.h>

extern VSContextList_ptr *VSnil(VSEnvironment *env);
extern VSContextList_ptr *VSduplicate(VSContextList_ptr *o, VSEnvironment *env);

extern VSULong VScount(VSContextList_ptr *o, VSEnvironment *env);
extern void VSadd(VSContextList_ptr *o, VSString t, VSEnvironment *env);
extern void VSadd_consume(VSContextList_ptr *o, VSString t, VSEnvironment *env);
extern VSString VSitem(VSContextList_ptr *o,VSULong ind, VSEnvironment *env);
extern VSStatus VSremove(VSContextList_ptr *o,VSULong ind, VSEnvironment *env);

