/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VScount
 *
 */
VSULong ADL__ACF_VScount (VSExceptionList_ptr *o_21, VSEnvironment *ev_10){

VSULong VScount_RtnVal_4;
  void *dummyVarName_367;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_23;
  int tmp_25;
  int tmp_26;
  VSEnvironment *ev_10_tmp_30;
    int tmp_31;
  int tmp_33;
  int tmp_34;
  VSEnvironment *ev_10_tmp_37;
    int tmp_39;
  int tmp_40;
  VSExceptionList_ptr *o_21_tmp_43;
  int tmp_45;
    int tmp_48;
  int tmp_49;
  int groupExpr_55;
  int tmp_51;
  VSExceptionList_ptr *o_21_tmp_54;

/* Declare vars for result of normal and exception bindings */
  int VScount_NormalOutcome_5, VScount_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VScount_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VScount_InfoArray, 0, ADL__VScount_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VScount_assertionReport->setPhase(ADL__VScount_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
        
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScount_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VScount_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VScount_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VScount_InfoArray[forLoopIdx_1].error > VScount_ACF_Result_3))
  VScount_ACF_Result_3 = ADL__VScount_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VScount_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VScount_assertionReport->setPhase(ADL__VScount_assertionReport, PH_call);
  ADL__release(ADL__VScount_assertionReport->parent, &this_seq);
  VScount_RtnVal_4 = ADL__VScount_wrapper(o_21, ev_10);
  ADL__recover(ADL__VScount_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VScount_assertionReport->setPhase(ADL__VScount_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VScount_InfoArray, 8,&ev_10_tmp_11);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VScount_InfoArray, 7,&tmp_7);
  VScount_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VScount_InfoArray, 3,&ev_10_tmp_16);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VScount_InfoArray, 2,&tmp_13);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VScount_InfoArray, 5,&ev_10_tmp_20);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VScount_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VScount_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VScount_InfoArray, 1,&tmp_12);

  VScount_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VScount_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VScount_InfoArray[0].result = (VScount_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScount_InfoArray[0].evaluated = 1;
  ADL__VScount_InfoArray[0].value = (VScount_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VScount_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VScount_InfoArray[6].result = (VScount_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScount_InfoArray[6].evaluated = 1;
  ADL__VScount_InfoArray[6].value = (VScount_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VScount_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VScount_ACF_Result_3 = ADL__VScount_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VScount_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VScount_ACF_Result_3 = ADL__VScount_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VScount_ExceptionOutcome_6 && !VScount_NormalOutcome_5) {
  VScount_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VScount_ExceptionOutcome_6 && VScount_NormalOutcome_5) {
  VScount_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VScount_InfoArray, 10,&VScount_ExceptionOutcome_6);
  ev_10_tmp_30 = ev_10;
  ADL__setResultAndError(ADL__VScount_InfoArray, 13,&ev_10_tmp_30);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_26 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VScount_InfoArray, 12,&tmp_26);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = !tmp_26;
  ADL__setResultAndError(ADL__VScount_InfoArray, 11,&tmp_25);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = (!VScount_ExceptionOutcome_6 || tmp_25);
  ADL__setResultAndError(ADL__VScount_InfoArray, 9,&tmp_23);
    ADL__setResultAndError(ADL__VScount_InfoArray, 15,&VScount_ExceptionOutcome_6);
  ev_10_tmp_37 = ev_10;
  ADL__setResultAndError(ADL__VScount_InfoArray, 18,&ev_10_tmp_37);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_34 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VScount_InfoArray, 17,&tmp_34);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_33 = !tmp_34;
  ADL__setResultAndError(ADL__VScount_InfoArray, 16,&tmp_33);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_31 = (!VScount_ExceptionOutcome_6 || tmp_33);
  ADL__setResultAndError(ADL__VScount_InfoArray, 14,&tmp_31);
    o_21_tmp_43 = o_21;
  ADL__setResultAndError(ADL__VScount_InfoArray, 21,&o_21_tmp_43);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[20]);

/* Evaluate is_nil_exlist_ptr(o) */
  tmp_40 = is_nil_exlist_ptr(o_21);
  ADL__setResultAndError(ADL__VScount_InfoArray, 20,&tmp_40);
  ADL__setResultAndError(ADL__VScount_InfoArray, 23,&VScount_RtnVal_4);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[22]);

/* Evaluate return == 0 */
  tmp_45 = (VScount_RtnVal_4 == 0);
  ADL__setResultAndError(ADL__VScount_InfoArray, 22,&tmp_45);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[19]);

/* Evaluate is_nil_exlist_ptr(o) --> (return == 0) */
  tmp_39 = (!tmp_40 || tmp_45);
  ADL__setResultAndError(ADL__VScount_InfoArray, 19,&tmp_39);
    ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[24]);

/* Evaluate normally { ... } */
  if(VScount_NormalOutcome_5){
      o_21_tmp_54 = o_21;
  ADL__setResultAndError(ADL__VScount_InfoArray, 26,&o_21_tmp_54);
  ADL__VScount_assertionReport->exprMark(ADL__VScount_assertionReport, &ADL__VScount_assertionReport->assrt_info[25]);

/* Evaluate item_count_is_good(o) */
  tmp_51 = item_count_is_good(o_21);
  ADL__setResultAndError(ADL__VScount_InfoArray, 25,&tmp_51);
  groupExpr_55 = (tmp_51);
  tmp_49 = (groupExpr_55);
  tmp_48 = tmp_49;
  }
  else {
    ADL__resetInfoStruct(ADL__VScount_InfoArray, 24, 26);
  tmp_48 = 1;
}

  ADL__setResultAndError(ADL__VScount_InfoArray, 24,&tmp_48);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScount_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VScount_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VScount_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VScount_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VScount_InfoArray[forLoopIdx_1].level == 0))
        VScount_ACF_Result_3 = calculate_ACF_result(VScount_ACF_Result_3, ADL__VScount_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VScount_assertionReport->value = VScount_ACF_Result_3;
  ADL__VScount_assertionReport->parent->openReport(ADL__VScount_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VScount_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VScount_assertionReport->emitTest(ADL__VScount_assertionReport, &ADL__VScount_InfoArray[forLoopIdx_1])) {
     ADL__VScount_assertionReport->exprStart(ADL__VScount_assertionReport, &ADL__VScount_InfoArray[forLoopIdx_1]);
      if(!ADL__VScount_InfoArray[forLoopIdx_1].testable || !ADL__VScount_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VScount_assertionReport->emitter);
      else if (ADL__VScount_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VScount_InfoArray[forLoopIdx_1].error, ADL__VScount_assertionReport->emitter);
      else
        ADL__VScount_InfoArray[forLoopIdx_1].emitFunc(ADL__VScount_InfoArray[forLoopIdx_1].value, ADL__VScount_assertionReport->emitter);
     ADL__VScount_assertionReport->exprEnd(ADL__VScount_assertionReport, &ADL__VScount_InfoArray[forLoopIdx_1]);
    }
  }

  return (VScount_RtnVal_4);
}


VSULong (*ADL__VScount_wrapper)(VSExceptionList_ptr*, VSEnvironment*) = VScount;

void ADL__emit_VSExceptionList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VScount_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "is_nil_exlist_ptr(o) --> (return == 0)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "is_nil_exlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {3, 22, 19, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 23, 22, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {4, 24, 24, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {5, 25, 24, 0, 0, "item_count_is_good(o)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P }
};


unsigned int ADL__VScount_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VScount_assertionReport = 0;

/*
 *
 * ACF of VSadd
 *
 */
void ADL__ACF_VSadd (VSExceptionList_ptr *o_75, VSTypeCode_ptr *t_76, VSEnvironment *ev_64){

  void *dummyVarName_367;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_78;
  int tmp_80;
  int tmp_81;
  VSEnvironment *ev_64_tmp_85;
    int tmp_86;
  int tmp_88;
  int tmp_89;
  VSEnvironment *ev_64_tmp_92;
    int tmp_93;
  int tmp_94;
  int groupExpr_105;
  int groupExpr_106;
  int tmp_96;
  VSExceptionList_ptr *o_75_tmp_99;
  int tmp_101;
  VSExceptionList_ptr *o_75_tmp_104;

/* Declare vars for result of normal and exception bindings */
  int VSadd_NormalOutcome_59, VSadd_ExceptionOutcome_60;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_61;
  VSEnvironment *ev_64_tmp_65;
    int tmp_66;
  int tmp_67;
  VSEnvironment *ev_64_tmp_70;
  int tmp_71;
  VSEnvironment *ev_64_tmp_74;
  enum ADL__ACF_result VSadd_ACF_Result_57 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSadd_InfoArray, 0, ADL__VSadd_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSadd_assertionReport->setPhase(ADL__VSadd_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSadd_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSadd_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSadd_InfoArray[forLoopIdx_1].error > VSadd_ACF_Result_57))
  VSadd_ACF_Result_57 = ADL__VSadd_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSadd_ACF_Result_57 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSadd_assertionReport->setPhase(ADL__VSadd_assertionReport, PH_call);
  ADL__release(ADL__VSadd_assertionReport->parent, &this_seq);
  ADL__VSadd_wrapper(o_75, t_76, ev_64);
  ADL__recover(ADL__VSadd_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSadd_assertionReport->setPhase(ADL__VSadd_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_64_tmp_65 = ev_64;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 8,&ev_64_tmp_65);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_61 = no_exception(ev_64);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 7,&tmp_61);
  VSadd_NormalOutcome_59 = (tmp_61);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_64_tmp_70 = ev_64;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 3,&ev_64_tmp_70);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_67 = system_exception(ev_64);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 2,&tmp_67);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_66 = tmp_67;
  if (!tmp_67) {
      ev_64_tmp_74 = ev_64;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 5,&ev_64_tmp_74);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_71 = user_exception(ev_64);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 4,&tmp_71);
    tmp_66 = tmp_71;
  }
  else {
  ADL__resetInfoStruct(ADL__VSadd_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSadd_InfoArray, 1,&tmp_66);

  VSadd_ExceptionOutcome_60 = (tmp_66);

/* Exception binding is the first assertion */
  if (ADL__VSadd_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_InfoArray[0].result = (VSadd_ExceptionOutcome_60 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_InfoArray[0].evaluated = 1;
  ADL__VSadd_InfoArray[0].value = (VSadd_ExceptionOutcome_60 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSadd_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_InfoArray[6].result = (VSadd_NormalOutcome_59 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_InfoArray[6].evaluated = 1;
  ADL__VSadd_InfoArray[6].value = (VSadd_NormalOutcome_59 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSadd_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSadd_ACF_Result_57 = ADL__VSadd_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSadd_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSadd_ACF_Result_57 = ADL__VSadd_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSadd_ExceptionOutcome_60 && !VSadd_NormalOutcome_59) {
  VSadd_ACF_Result_57 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSadd_ExceptionOutcome_60 && VSadd_NormalOutcome_59) {
  VSadd_ACF_Result_57 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSadd_InfoArray, 10,&VSadd_ExceptionOutcome_60);
  ev_64_tmp_85 = ev_64;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 13,&ev_64_tmp_85);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_81 = user_exception_is("NOT_IMPLEMENTED", ev_64);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 12,&tmp_81);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_80 = !tmp_81;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 11,&tmp_80);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_78 = (!VSadd_ExceptionOutcome_60 || tmp_80);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 9,&tmp_78);
    ADL__setResultAndError(ADL__VSadd_InfoArray, 15,&VSadd_ExceptionOutcome_60);
  ev_64_tmp_92 = ev_64;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 18,&ev_64_tmp_92);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_89 = user_exception(ev_64);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 17,&tmp_89);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_88 = !tmp_89;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 16,&tmp_88);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_86 = (!VSadd_ExceptionOutcome_60 || tmp_88);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 14,&tmp_86);
    ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSadd_NormalOutcome_59){
      o_75_tmp_99 = o_75;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 21,&o_75_tmp_99);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[20]);

/* Evaluate count_is_good(o) */
  tmp_96 = count_is_good(o_75);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 20,&tmp_96);
  groupExpr_105 = (tmp_96);
  o_75_tmp_104 = o_75;
  ADL__setResultAndError(ADL__VSadd_InfoArray, 23,&o_75_tmp_104);
  ADL__VSadd_assertionReport->exprMark(ADL__VSadd_assertionReport, &ADL__VSadd_assertionReport->assrt_info[22]);

/* Evaluate exlist_is_good(o) */
  tmp_101 = exlist_is_good(o_75);
  ADL__setResultAndError(ADL__VSadd_InfoArray, 22,&tmp_101);
  groupExpr_106 = (tmp_101);
  tmp_94 = (groupExpr_105 && groupExpr_106);
  tmp_93 = tmp_94;
  }
  else {
    ADL__resetInfoStruct(ADL__VSadd_InfoArray, 19, 23);
  tmp_93 = 1;
}

  ADL__setResultAndError(ADL__VSadd_InfoArray, 19,&tmp_93);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSadd_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSadd_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSadd_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSadd_InfoArray[forLoopIdx_1].level == 0))
        VSadd_ACF_Result_57 = calculate_ACF_result(VSadd_ACF_Result_57, ADL__VSadd_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSadd_assertionReport->value = VSadd_ACF_Result_57;
  ADL__VSadd_assertionReport->parent->openReport(ADL__VSadd_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSadd_assertionReport->emitTest(ADL__VSadd_assertionReport, &ADL__VSadd_InfoArray[forLoopIdx_1])) {
     ADL__VSadd_assertionReport->exprStart(ADL__VSadd_assertionReport, &ADL__VSadd_InfoArray[forLoopIdx_1]);
      if(!ADL__VSadd_InfoArray[forLoopIdx_1].testable || !ADL__VSadd_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSadd_assertionReport->emitter);
      else if (ADL__VSadd_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSadd_InfoArray[forLoopIdx_1].error, ADL__VSadd_assertionReport->emitter);
      else
        ADL__VSadd_InfoArray[forLoopIdx_1].emitFunc(ADL__VSadd_InfoArray[forLoopIdx_1].value, ADL__VSadd_assertionReport->emitter);
     ADL__VSadd_assertionReport->exprEnd(ADL__VSadd_assertionReport, &ADL__VSadd_InfoArray[forLoopIdx_1]);
    }
  }

  return;
}


void (*ADL__VSadd_wrapper)(VSExceptionList_ptr*, VSTypeCode_ptr*, VSEnvironment*) = VSadd;

void ADL__emit_VSExceptionList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSadd_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "count_is_good(o)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {5, 22, 19, 0, 0, "exlist_is_good(o)", 22, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 23, 22, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P }
};


unsigned int ADL__VSadd_InfoArrayIdx = 24;

struct ADL__reportAssertion *ADL__VSadd_assertionReport = 0;

/*
 *
 * ACF of VSadd_consume
 *
 */
void ADL__ACF_VSadd_consume (VSExceptionList_ptr *o_126, VSTypeCode_ptr *t_127, VSEnvironment *ev_115){

  void *dummyVarName_367;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_129;
  int tmp_131;
  int tmp_132;
  VSEnvironment *ev_115_tmp_136;
    int tmp_137;
  int tmp_139;
  int tmp_140;
  VSEnvironment *ev_115_tmp_143;
    int tmp_144;
  int tmp_145;
  int groupExpr_156;
  int groupExpr_157;
  int tmp_147;
  VSExceptionList_ptr *o_126_tmp_150;
  int tmp_152;
  VSExceptionList_ptr *o_126_tmp_155;

/* Declare vars for result of normal and exception bindings */
  int VSadd_consume_NormalOutcome_110, VSadd_consume_ExceptionOutcome_111;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_112;
  VSEnvironment *ev_115_tmp_116;
    int tmp_117;
  int tmp_118;
  VSEnvironment *ev_115_tmp_121;
  int tmp_122;
  VSEnvironment *ev_115_tmp_125;
  enum ADL__ACF_result VSadd_consume_ACF_Result_108 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSadd_consume_InfoArray, 0, ADL__VSadd_consume_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSadd_consume_assertionReport->setPhase(ADL__VSadd_consume_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_consume_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSadd_consume_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSadd_consume_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSadd_consume_InfoArray[forLoopIdx_1].error > VSadd_consume_ACF_Result_108))
  VSadd_consume_ACF_Result_108 = ADL__VSadd_consume_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSadd_consume_ACF_Result_108 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSadd_consume_assertionReport->setPhase(ADL__VSadd_consume_assertionReport, PH_call);
  ADL__release(ADL__VSadd_consume_assertionReport->parent, &this_seq);
  ADL__VSadd_consume_wrapper(o_126, t_127, ev_115);
  ADL__recover(ADL__VSadd_consume_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSadd_consume_assertionReport->setPhase(ADL__VSadd_consume_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_115_tmp_116 = ev_115;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 8,&ev_115_tmp_116);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_112 = no_exception(ev_115);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 7,&tmp_112);
  VSadd_consume_NormalOutcome_110 = (tmp_112);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_115_tmp_121 = ev_115;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 3,&ev_115_tmp_121);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_118 = system_exception(ev_115);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 2,&tmp_118);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_117 = tmp_118;
  if (!tmp_118) {
      ev_115_tmp_125 = ev_115;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 5,&ev_115_tmp_125);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_122 = user_exception(ev_115);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 4,&tmp_122);
    tmp_117 = tmp_122;
  }
  else {
  ADL__resetInfoStruct(ADL__VSadd_consume_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 1,&tmp_117);

  VSadd_consume_ExceptionOutcome_111 = (tmp_117);

/* Exception binding is the first assertion */
  if (ADL__VSadd_consume_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_consume_InfoArray[0].result = (VSadd_consume_ExceptionOutcome_111 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_consume_InfoArray[0].evaluated = 1;
  ADL__VSadd_consume_InfoArray[0].value = (VSadd_consume_ExceptionOutcome_111 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSadd_consume_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSadd_consume_InfoArray[6].result = (VSadd_consume_NormalOutcome_110 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSadd_consume_InfoArray[6].evaluated = 1;
  ADL__VSadd_consume_InfoArray[6].value = (VSadd_consume_NormalOutcome_110 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSadd_consume_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSadd_consume_ACF_Result_108 = ADL__VSadd_consume_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSadd_consume_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSadd_consume_ACF_Result_108 = ADL__VSadd_consume_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSadd_consume_ExceptionOutcome_111 && !VSadd_consume_NormalOutcome_110) {
  VSadd_consume_ACF_Result_108 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSadd_consume_ExceptionOutcome_111 && VSadd_consume_NormalOutcome_110) {
  VSadd_consume_ACF_Result_108 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 10,&VSadd_consume_ExceptionOutcome_111);
  ev_115_tmp_136 = ev_115;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 13,&ev_115_tmp_136);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_132 = user_exception_is("NOT_IMPLEMENTED", ev_115);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 12,&tmp_132);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_131 = !tmp_132;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 11,&tmp_131);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_129 = (!VSadd_consume_ExceptionOutcome_111 || tmp_131);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 9,&tmp_129);
    ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 15,&VSadd_consume_ExceptionOutcome_111);
  ev_115_tmp_143 = ev_115;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 18,&ev_115_tmp_143);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_140 = user_exception(ev_115);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 17,&tmp_140);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_139 = !tmp_140;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 16,&tmp_139);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_137 = (!VSadd_consume_ExceptionOutcome_111 || tmp_139);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 14,&tmp_137);
    ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSadd_consume_NormalOutcome_110){
      o_126_tmp_150 = o_126;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 21,&o_126_tmp_150);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[20]);

/* Evaluate count_is_good(o) */
  tmp_147 = count_is_good(o_126);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 20,&tmp_147);
  groupExpr_156 = (tmp_147);
  o_126_tmp_155 = o_126;
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 23,&o_126_tmp_155);
  ADL__VSadd_consume_assertionReport->exprMark(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_assertionReport->assrt_info[22]);

/* Evaluate exlist_is_good(o) */
  tmp_152 = exlist_is_good(o_126);
  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 22,&tmp_152);
  groupExpr_157 = (tmp_152);
  tmp_145 = (groupExpr_156 && groupExpr_157);
  tmp_144 = tmp_145;
  }
  else {
    ADL__resetInfoStruct(ADL__VSadd_consume_InfoArray, 19, 23);
  tmp_144 = 1;
}

  ADL__setResultAndError(ADL__VSadd_consume_InfoArray, 19,&tmp_144);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_consume_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSadd_consume_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSadd_consume_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSadd_consume_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSadd_consume_InfoArray[forLoopIdx_1].level == 0))
        VSadd_consume_ACF_Result_108 = calculate_ACF_result(VSadd_consume_ACF_Result_108, ADL__VSadd_consume_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSadd_consume_assertionReport->value = VSadd_consume_ACF_Result_108;
  ADL__VSadd_consume_assertionReport->parent->openReport(ADL__VSadd_consume_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSadd_consume_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSadd_consume_assertionReport->emitTest(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_InfoArray[forLoopIdx_1])) {
     ADL__VSadd_consume_assertionReport->exprStart(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_InfoArray[forLoopIdx_1]);
      if(!ADL__VSadd_consume_InfoArray[forLoopIdx_1].testable || !ADL__VSadd_consume_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSadd_consume_assertionReport->emitter);
      else if (ADL__VSadd_consume_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSadd_consume_InfoArray[forLoopIdx_1].error, ADL__VSadd_consume_assertionReport->emitter);
      else
        ADL__VSadd_consume_InfoArray[forLoopIdx_1].emitFunc(ADL__VSadd_consume_InfoArray[forLoopIdx_1].value, ADL__VSadd_consume_assertionReport->emitter);
     ADL__VSadd_consume_assertionReport->exprEnd(ADL__VSadd_consume_assertionReport, &ADL__VSadd_consume_InfoArray[forLoopIdx_1]);
    }
  }

  return;
}


void (*ADL__VSadd_consume_wrapper)(VSExceptionList_ptr*, VSTypeCode_ptr*, VSEnvironment*) = VSadd_consume;

void ADL__emit_VSExceptionList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSadd_consume_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "count_is_good(o)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {5, 22, 19, 0, 0, "exlist_is_good(o)", 22, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 23, 22, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P }
};


unsigned int ADL__VSadd_consume_InfoArrayIdx = 24;

struct ADL__reportAssertion *ADL__VSadd_consume_assertionReport = 0;

/*
 *
 * ACF of VSitem
 *
 */
VSTypeCode_ptr *ADL__ACF_VSitem (VSExceptionList_ptr *o_177, VSULong ind_178, VSEnvironment *ev_166){

VSTypeCode_ptr *VSitem_RtnVal_160;
  void *dummyVarName_367;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_180;
  int tmp_182;
  int tmp_183;
  VSEnvironment *ev_166_tmp_187;
    int tmp_189;
  int tmp_190;
  VSExceptionList_ptr *o_177_tmp_193;
  int tmp_195;
    int tmp_199;
  int tmp_200;
  VSExceptionList_ptr *o_177_tmp_203;
  VSULong ind_178_tmp_205;
  int tmp_206;
  VSEnvironment *ev_166_tmp_210;
    int tmp_212;
  int tmp_213;
  VSExceptionList_ptr *o_177_tmp_216;
  VSULong ind_178_tmp_218;
  int tmp_220;
    int tmp_223;
  int tmp_224;
  int groupExpr_240;
  int groupExpr_241;
  int tmp_226;
  unsigned long int tmp_227;
  VSExceptionList_ptr *tmp_229;
  VSExceptionList_ptr *o_177_tmp_231;
  unsigned long int tmp_232;
  VSExceptionList_ptr *o_177_tmp_235;
  int tmp_237;

/* Declare vars for result of normal and exception bindings */
  int VSitem_NormalOutcome_161, VSitem_ExceptionOutcome_162;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_163;
  VSEnvironment *ev_166_tmp_167;
    int tmp_168;
  int tmp_169;
  VSEnvironment *ev_166_tmp_172;
  int tmp_173;
  VSEnvironment *ev_166_tmp_176;
  enum ADL__ACF_result VSitem_ACF_Result_159 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSitem_InfoArray, 0, ADL__VSitem_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSitem_assertionReport->setPhase(ADL__VSitem_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
            o_177_tmp_231 = o_177;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 35,&o_177_tmp_231);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[34]);

/* Evaluate @o */
  tmp_229 = o_177;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 34,&tmp_229);

/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSitem_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSitem_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSitem_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSitem_InfoArray[forLoopIdx_1].error > VSitem_ACF_Result_159))
  VSitem_ACF_Result_159 = ADL__VSitem_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSitem_ACF_Result_159 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSitem_assertionReport->setPhase(ADL__VSitem_assertionReport, PH_call);
  ADL__release(ADL__VSitem_assertionReport->parent, &this_seq);
  VSitem_RtnVal_160 = ADL__VSitem_wrapper(o_177, ind_178, ev_166);
  ADL__recover(ADL__VSitem_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSitem_assertionReport->setPhase(ADL__VSitem_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_166_tmp_167 = ev_166;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 8,&ev_166_tmp_167);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_163 = no_exception(ev_166);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 7,&tmp_163);
  VSitem_NormalOutcome_161 = (tmp_163);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_166_tmp_172 = ev_166;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 3,&ev_166_tmp_172);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_169 = system_exception(ev_166);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 2,&tmp_169);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_168 = tmp_169;
  if (!tmp_169) {
      ev_166_tmp_176 = ev_166;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 5,&ev_166_tmp_176);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_173 = user_exception(ev_166);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 4,&tmp_173);
    tmp_168 = tmp_173;
  }
  else {
  ADL__resetInfoStruct(ADL__VSitem_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSitem_InfoArray, 1,&tmp_168);

  VSitem_ExceptionOutcome_162 = (tmp_168);

/* Exception binding is the first assertion */
  if (ADL__VSitem_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSitem_InfoArray[0].result = (VSitem_ExceptionOutcome_162 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSitem_InfoArray[0].evaluated = 1;
  ADL__VSitem_InfoArray[0].value = (VSitem_ExceptionOutcome_162 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSitem_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSitem_InfoArray[6].result = (VSitem_NormalOutcome_161 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSitem_InfoArray[6].evaluated = 1;
  ADL__VSitem_InfoArray[6].value = (VSitem_NormalOutcome_161 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSitem_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSitem_ACF_Result_159 = ADL__VSitem_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSitem_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSitem_ACF_Result_159 = ADL__VSitem_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSitem_ExceptionOutcome_162 && !VSitem_NormalOutcome_161) {
  VSitem_ACF_Result_159 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSitem_ExceptionOutcome_162 && VSitem_NormalOutcome_161) {
  VSitem_ACF_Result_159 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSitem_InfoArray, 10,&VSitem_ExceptionOutcome_162);
  ev_166_tmp_187 = ev_166;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 13,&ev_166_tmp_187);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_183 = user_exception_is("NOT_IMPLEMENTED", ev_166);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 12,&tmp_183);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_182 = !tmp_183;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 11,&tmp_182);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_180 = (!VSitem_ExceptionOutcome_162 || tmp_182);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 9,&tmp_180);
    o_177_tmp_193 = o_177;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 16,&o_177_tmp_193);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[15]);

/* Evaluate is_nil_exlist_ptr(o) */
  tmp_190 = is_nil_exlist_ptr(o_177);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 15,&tmp_190);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 18,&VSitem_RtnVal_160);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[17]);

/* Evaluate return == 0 */
  tmp_195 = (VSitem_RtnVal_160 == 0);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 17,&tmp_195);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[14]);

/* Evaluate is_nil_exlist_ptr(o) --> (return == 0) */
  tmp_189 = (!tmp_190 || tmp_195);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 14,&tmp_189);
    o_177_tmp_203 = o_177;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 21,&o_177_tmp_203);
  ind_178_tmp_205 = ind_178;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 22,&ind_178_tmp_205);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[20]);

/* Evaluate out_of_bounds(o, ind) */
  tmp_200 = out_of_bounds(o_177, ind_178);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 20,&tmp_200);
  ev_166_tmp_210 = ev_166;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 24,&ev_166_tmp_210);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[23]);

/* Evaluate user_exception_is("CORBA::Bounds", ev) */
  tmp_206 = user_exception_is("CORBA::Bounds", ev_166);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 23,&tmp_206);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[19]);

/* Evaluate out_of_bounds(o, ind) --> user_exception_is("CORBA::Bounds", ev) */
  tmp_199 = (!tmp_200 || tmp_206);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 19,&tmp_199);
    o_177_tmp_216 = o_177;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 27,&o_177_tmp_216);
  ind_178_tmp_218 = ind_178;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 28,&ind_178_tmp_218);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[26]);

/* Evaluate out_of_bounds(o, ind) */
  tmp_213 = out_of_bounds(o_177, ind_178);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 26,&tmp_213);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 30,&VSitem_RtnVal_160);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[29]);

/* Evaluate return == 0 */
  tmp_220 = (VSitem_RtnVal_160 == 0);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 29,&tmp_220);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[25]);

/* Evaluate out_of_bounds(o, ind) --> (return == 0) */
  tmp_212 = (!tmp_213 || tmp_220);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 25,&tmp_212);
    ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[31]);

/* Evaluate normally { ... } */
  if(VSitem_NormalOutcome_161){
      ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[33]);

/* Evaluate count(@o) */
  tmp_227 = count(tmp_229);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 33,&tmp_227);
  o_177_tmp_235 = o_177;
  ADL__setResultAndError(ADL__VSitem_InfoArray, 37,&o_177_tmp_235);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[36]);

/* Evaluate count(o) */
  tmp_232 = count(o_177);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 36,&tmp_232);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[32]);

/* Evaluate count(@o) == count(o) */
  tmp_226 = (tmp_227 == tmp_232);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 32,&tmp_226);
  groupExpr_240 = (tmp_226);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 39,&VSitem_RtnVal_160);
  ADL__VSitem_assertionReport->exprMark(ADL__VSitem_assertionReport, &ADL__VSitem_assertionReport->assrt_info[38]);

/* Evaluate typecode_is_good(return) */
  tmp_237 = typecode_is_good(VSitem_RtnVal_160);
  ADL__setResultAndError(ADL__VSitem_InfoArray, 38,&tmp_237);
  groupExpr_241 = (tmp_237);
  tmp_224 = (groupExpr_240 && groupExpr_241);
  tmp_223 = tmp_224;
  }
  else {
    ADL__resetInfoStruct(ADL__VSitem_InfoArray, 31, 39);
  tmp_223 = 1;
}

  ADL__setResultAndError(ADL__VSitem_InfoArray, 31,&tmp_223);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSitem_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSitem_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSitem_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSitem_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSitem_InfoArray[forLoopIdx_1].level == 0))
        VSitem_ACF_Result_159 = calculate_ACF_result(VSitem_ACF_Result_159, ADL__VSitem_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSitem_assertionReport->value = VSitem_ACF_Result_159;
  ADL__VSitem_assertionReport->parent->openReport(ADL__VSitem_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSitem_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSitem_assertionReport->emitTest(ADL__VSitem_assertionReport, &ADL__VSitem_InfoArray[forLoopIdx_1])) {
     ADL__VSitem_assertionReport->exprStart(ADL__VSitem_assertionReport, &ADL__VSitem_InfoArray[forLoopIdx_1]);
      if(!ADL__VSitem_InfoArray[forLoopIdx_1].testable || !ADL__VSitem_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSitem_assertionReport->emitter);
      else if (ADL__VSitem_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSitem_InfoArray[forLoopIdx_1].error, ADL__VSitem_assertionReport->emitter);
      else
        ADL__VSitem_InfoArray[forLoopIdx_1].emitFunc(ADL__VSitem_InfoArray[forLoopIdx_1].value, ADL__VSitem_assertionReport->emitter);
     ADL__VSitem_assertionReport->exprEnd(ADL__VSitem_assertionReport, &ADL__VSitem_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSitem_RtnVal_160);
}


VSTypeCode_ptr *(*ADL__VSitem_wrapper)(VSExceptionList_ptr*, VSULong, VSEnvironment*) = VSitem;

void ADL__emit_VSExceptionList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSitem_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "is_nil_exlist_ptr(o) --> (return == 0)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "is_nil_exlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {2, 17, 14, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P },
  {3, 19, 19, 0, 0, "out_of_bounds(o, ind) --> user_exception_is(\"CORBA::Bounds\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "out_of_bounds(o, ind)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {3, 22, 20, 0, 0, "ind", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {3, 23, 19, 0, 0, "user_exception_is(\"CORBA::Bounds\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 24, 23, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 25, 25, 0, 0, "out_of_bounds(o, ind) --> (return == 0)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "out_of_bounds(o, ind)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 27, 26, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {4, 28, 26, 0, 0, "ind", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {4, 29, 25, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P },
  {5, 31, 31, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {6, 32, 31, 0, 0, "count(@o) == count(o)", 32, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 33, 32, 0, 0, "count(@o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_unsigned_long_int },
  {6, 34, 33, 0, 0, "@o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {6, 35, 34, 0, 0, "@(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {6, 36, 32, 0, 0, "count(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_unsigned_long_int },
  {6, 37, 36, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {7, 38, 31, 0, 0, "typecode_is_good(return)", 38, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {7, 39, 38, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P }
};


unsigned int ADL__VSitem_InfoArrayIdx = 40;

struct ADL__reportAssertion *ADL__VSitem_assertionReport = 0;

/*
 *
 * ACF of VSremove
 *
 */
VSStatus ADL__ACF_VSremove (VSExceptionList_ptr *o_261, VSULong ind_262, VSEnvironment *ev_250){

VSStatus VSremove_RtnVal_244;
  void *dummyVarName_367;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_264;
  int tmp_266;
  int tmp_267;
  VSEnvironment *ev_250_tmp_271;
    int tmp_273;
  int tmp_274;
  VSExceptionList_ptr *o_261_tmp_277;
  int tmp_279;
    int tmp_283;
  int tmp_284;
  VSExceptionList_ptr *o_261_tmp_287;
  VSULong ind_262_tmp_289;
  int tmp_290;
  VSEnvironment *ev_250_tmp_294;
    int tmp_296;
  int tmp_297;
  VSExceptionList_ptr *o_261_tmp_300;
  VSULong ind_262_tmp_302;
  int tmp_304;
    int tmp_307;
  int tmp_308;
  int groupExpr_314;
  int tmp_310;
  VSExceptionList_ptr *o_261_tmp_313;

/* Declare vars for result of normal and exception bindings */
  int VSremove_NormalOutcome_245, VSremove_ExceptionOutcome_246;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_247;
  VSEnvironment *ev_250_tmp_251;
    int tmp_252;
  int tmp_253;
  VSEnvironment *ev_250_tmp_256;
  int tmp_257;
  VSEnvironment *ev_250_tmp_260;
  enum ADL__ACF_result VSremove_ACF_Result_243 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSremove_InfoArray, 0, ADL__VSremove_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSremove_assertionReport->setPhase(ADL__VSremove_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
          
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSremove_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSremove_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSremove_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSremove_InfoArray[forLoopIdx_1].error > VSremove_ACF_Result_243))
  VSremove_ACF_Result_243 = ADL__VSremove_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSremove_ACF_Result_243 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSremove_assertionReport->setPhase(ADL__VSremove_assertionReport, PH_call);
  ADL__release(ADL__VSremove_assertionReport->parent, &this_seq);
  VSremove_RtnVal_244 = ADL__VSremove_wrapper(o_261, ind_262, ev_250);
  ADL__recover(ADL__VSremove_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSremove_assertionReport->setPhase(ADL__VSremove_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_250_tmp_251 = ev_250;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 8,&ev_250_tmp_251);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_247 = no_exception(ev_250);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 7,&tmp_247);
  VSremove_NormalOutcome_245 = (tmp_247);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_250_tmp_256 = ev_250;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 3,&ev_250_tmp_256);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_253 = system_exception(ev_250);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 2,&tmp_253);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_252 = tmp_253;
  if (!tmp_253) {
      ev_250_tmp_260 = ev_250;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 5,&ev_250_tmp_260);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_257 = user_exception(ev_250);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 4,&tmp_257);
    tmp_252 = tmp_257;
  }
  else {
  ADL__resetInfoStruct(ADL__VSremove_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSremove_InfoArray, 1,&tmp_252);

  VSremove_ExceptionOutcome_246 = (tmp_252);

/* Exception binding is the first assertion */
  if (ADL__VSremove_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSremove_InfoArray[0].result = (VSremove_ExceptionOutcome_246 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSremove_InfoArray[0].evaluated = 1;
  ADL__VSremove_InfoArray[0].value = (VSremove_ExceptionOutcome_246 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSremove_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSremove_InfoArray[6].result = (VSremove_NormalOutcome_245 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSremove_InfoArray[6].evaluated = 1;
  ADL__VSremove_InfoArray[6].value = (VSremove_NormalOutcome_245 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSremove_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSremove_ACF_Result_243 = ADL__VSremove_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSremove_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSremove_ACF_Result_243 = ADL__VSremove_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSremove_ExceptionOutcome_246 && !VSremove_NormalOutcome_245) {
  VSremove_ACF_Result_243 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSremove_ExceptionOutcome_246 && VSremove_NormalOutcome_245) {
  VSremove_ACF_Result_243 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSremove_InfoArray, 10,&VSremove_ExceptionOutcome_246);
  ev_250_tmp_271 = ev_250;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 13,&ev_250_tmp_271);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_267 = user_exception_is("NOT_IMPLEMENTED", ev_250);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 12,&tmp_267);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_266 = !tmp_267;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 11,&tmp_266);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_264 = (!VSremove_ExceptionOutcome_246 || tmp_266);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 9,&tmp_264);
    o_261_tmp_277 = o_261;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 16,&o_261_tmp_277);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[15]);

/* Evaluate is_nil_exlist_ptr(o) */
  tmp_274 = is_nil_exlist_ptr(o_261);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 15,&tmp_274);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 18,&VSremove_RtnVal_244);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[17]);

/* Evaluate return == 0 */
  tmp_279 = (VSremove_RtnVal_244 == 0);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 17,&tmp_279);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[14]);

/* Evaluate is_nil_exlist_ptr(o) --> (return == 0) */
  tmp_273 = (!tmp_274 || tmp_279);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 14,&tmp_273);
    o_261_tmp_287 = o_261;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 21,&o_261_tmp_287);
  ind_262_tmp_289 = ind_262;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 22,&ind_262_tmp_289);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[20]);

/* Evaluate out_of_bounds_for_remove(o, ind) */
  tmp_284 = out_of_bounds_for_remove(o_261, ind_262);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 20,&tmp_284);
  ev_250_tmp_294 = ev_250;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 24,&ev_250_tmp_294);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[23]);

/* Evaluate user_exception_is("CORBA::Bounds", ev) */
  tmp_290 = user_exception_is("CORBA::Bounds", ev_250);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 23,&tmp_290);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[19]);

/* Evaluate out_of_bounds_for_remove(o, ind) --> user_exception_is("CORBA::Bounds", ev) */
  tmp_283 = (!tmp_284 || tmp_290);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 19,&tmp_283);
    o_261_tmp_300 = o_261;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 27,&o_261_tmp_300);
  ind_262_tmp_302 = ind_262;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 28,&ind_262_tmp_302);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[26]);

/* Evaluate out_of_bounds_for_remove(o, ind) */
  tmp_297 = out_of_bounds_for_remove(o_261, ind_262);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 26,&tmp_297);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 30,&VSremove_RtnVal_244);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[29]);

/* Evaluate return == 0 */
  tmp_304 = (VSremove_RtnVal_244 == 0);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 29,&tmp_304);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[25]);

/* Evaluate out_of_bounds_for_remove(o, ind) --> (return == 0) */
  tmp_296 = (!tmp_297 || tmp_304);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 25,&tmp_296);
    ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[31]);

/* Evaluate normally { ... } */
  if(VSremove_NormalOutcome_245){
      o_261_tmp_313 = o_261;
  ADL__setResultAndError(ADL__VSremove_InfoArray, 33,&o_261_tmp_313);
  ADL__VSremove_assertionReport->exprMark(ADL__VSremove_assertionReport, &ADL__VSremove_assertionReport->assrt_info[32]);

/* Evaluate has_been_removed(o) */
  tmp_310 = has_been_removed(o_261);
  ADL__setResultAndError(ADL__VSremove_InfoArray, 32,&tmp_310);
  groupExpr_314 = (tmp_310);
  tmp_308 = (groupExpr_314);
  tmp_307 = tmp_308;
  }
  else {
    ADL__resetInfoStruct(ADL__VSremove_InfoArray, 31, 33);
  tmp_307 = 1;
}

  ADL__setResultAndError(ADL__VSremove_InfoArray, 31,&tmp_307);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSremove_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSremove_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSremove_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSremove_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSremove_InfoArray[forLoopIdx_1].level == 0))
        VSremove_ACF_Result_243 = calculate_ACF_result(VSremove_ACF_Result_243, ADL__VSremove_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSremove_assertionReport->value = VSremove_ACF_Result_243;
  ADL__VSremove_assertionReport->parent->openReport(ADL__VSremove_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSremove_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSremove_assertionReport->emitTest(ADL__VSremove_assertionReport, &ADL__VSremove_InfoArray[forLoopIdx_1])) {
     ADL__VSremove_assertionReport->exprStart(ADL__VSremove_assertionReport, &ADL__VSremove_InfoArray[forLoopIdx_1]);
      if(!ADL__VSremove_InfoArray[forLoopIdx_1].testable || !ADL__VSremove_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSremove_assertionReport->emitter);
      else if (ADL__VSremove_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSremove_InfoArray[forLoopIdx_1].error, ADL__VSremove_assertionReport->emitter);
      else
        ADL__VSremove_InfoArray[forLoopIdx_1].emitFunc(ADL__VSremove_InfoArray[forLoopIdx_1].value, ADL__VSremove_assertionReport->emitter);
     ADL__VSremove_assertionReport->exprEnd(ADL__VSremove_assertionReport, &ADL__VSremove_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSremove_RtnVal_244);
}


VSStatus (*ADL__VSremove_wrapper)(VSExceptionList_ptr*, VSULong, VSEnvironment*) = VSremove;

void ADL__emit_VSExceptionList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSStatus (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSremove_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "is_nil_exlist_ptr(o) --> (return == 0)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "is_nil_exlist_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 15, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {2, 17, 14, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStatus },
  {3, 19, 19, 0, 0, "out_of_bounds_for_remove(o, ind) --> user_exception_is(\"CORBA::Bounds\", ev)", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {3, 20, 19, 0, 0, "out_of_bounds_for_remove(o, ind)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 21, 20, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {3, 22, 20, 0, 0, "ind", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {3, 23, 19, 0, 0, "user_exception_is(\"CORBA::Bounds\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {3, 24, 23, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {4, 25, 25, 0, 0, "out_of_bounds_for_remove(o, ind) --> (return == 0)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "out_of_bounds_for_remove(o, ind)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 27, 26, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {4, 28, 26, 0, 0, "ind", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {4, 29, 25, 0, 0, "return == 0", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStatus },
  {5, 31, 31, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {6, 32, 31, 0, 0, "has_been_removed(o)", 32, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {6, 33, 32, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P }
};


unsigned int ADL__VSremove_InfoArrayIdx = 34;

struct ADL__reportAssertion *ADL__VSremove_assertionReport = 0;

/*
 *
 * ACF of VSnil
 *
 */
VSExceptionList_ptr *ADL__ACF_VSnil (VSEnvironment *ev_323){

VSExceptionList_ptr *VSnil_RtnVal_317;
  void *dummyVarName_367;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_335;
  int tmp_337;
  int tmp_338;
  VSEnvironment *ev_323_tmp_342;
    int tmp_343;
  int tmp_345;
  int tmp_346;
  int tmp_347;
  VSEnvironment *ev_323_tmp_350;
  int tmp_351;
  int tmp_352;
  VSEnvironment *ev_323_tmp_355;
    int tmp_356;
  int tmp_357;
  int groupExpr_366;
  int tmp_359;
  int tmp_360;
  int tmp_363;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_318, VSnil_ExceptionOutcome_319;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_320;
  VSEnvironment *ev_323_tmp_324;
    int tmp_325;
  int tmp_326;
  VSEnvironment *ev_323_tmp_329;
  int tmp_330;
  VSEnvironment *ev_323_tmp_333;
  enum ADL__ACF_result VSnil_ACF_Result_316 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_316))
  VSnil_ACF_Result_316 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_316 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_317 = ADL__VSnil_wrapper(ev_323);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_323_tmp_324 = ev_323;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_323_tmp_324);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_320 = no_exception(ev_323);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_320);
  VSnil_NormalOutcome_318 = (tmp_320);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_323_tmp_329 = ev_323;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_323_tmp_329);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_326 = system_exception(ev_323);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_326);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_325 = tmp_326;
  if (!tmp_326) {
      ev_323_tmp_333 = ev_323;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_323_tmp_333);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_330 = user_exception(ev_323);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_330);
    tmp_325 = tmp_330;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_325);

  VSnil_ExceptionOutcome_319 = (tmp_325);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_319 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_319 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_318 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_318 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_316 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_316 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_319 && !VSnil_NormalOutcome_318) {
  VSnil_ACF_Result_316 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_319 && VSnil_NormalOutcome_318) {
  VSnil_ACF_Result_316 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_319);
  ev_323_tmp_342 = ev_323;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_323_tmp_342);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_338 = user_exception_is("NOT_IMPLEMENTED", ev_323);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_338);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_337 = !tmp_338;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_337);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_335 = (!VSnil_ExceptionOutcome_319 || tmp_337);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_335);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_319);
  ev_323_tmp_350 = ev_323;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_323_tmp_350);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_347 = system_exception(ev_323);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_347);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_346 = !tmp_347;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_346);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_345 = tmp_346;
  if (tmp_346) {
      ev_323_tmp_355 = ev_323;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_323_tmp_355);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_352 = user_exception(ev_323);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_352);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_351 = !tmp_352;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_351);
    tmp_345 = tmp_351;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_345);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_343 = (!VSnil_ExceptionOutcome_319 || tmp_345);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_343);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_318){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_317);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_exlist_ptr(return) */
  tmp_360 = is_nil_exlist_ptr(VSnil_RtnVal_317);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_360);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_exlist_ptr(return) && cleanup_exlist_ptr(return) */
  tmp_359 = tmp_360;
  if (tmp_360) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_317);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_exlist_ptr(return) */
  tmp_363 = cleanup_exlist_ptr(VSnil_RtnVal_317);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_363);
    tmp_359 = tmp_363;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_359);
  groupExpr_366 = (tmp_359);
  tmp_357 = (groupExpr_366);
  tmp_356 = tmp_357;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_356 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_356);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_316 = calculate_ACF_result(VSnil_ACF_Result_316, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_316;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_317);
}


VSExceptionList_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSExceptionList_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_exlist_ptr(return) && cleanup_exlist_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_exlist_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_exlist_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSExceptionList_ptr *ADL__ACF_VSduplicate (VSExceptionList_ptr *o_386, VSEnvironment *ev_375){

VSExceptionList_ptr *VSduplicate_RtnVal_369;
  void *dummyVarName_367;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_388;
  int tmp_390;
  int tmp_391;
  VSEnvironment *ev_375_tmp_395;
    int tmp_396;
  int tmp_398;
  int tmp_399;
  VSEnvironment *ev_375_tmp_402;
    int tmp_403;
  int tmp_404;
  int groupExpr_415;
  int tmp_406;
  int tmp_407;
  VSExceptionList_ptr *o_386_tmp_411;
  int tmp_412;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_370, VSduplicate_ExceptionOutcome_371;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_372;
  VSEnvironment *ev_375_tmp_376;
    int tmp_377;
  int tmp_378;
  VSEnvironment *ev_375_tmp_381;
  int tmp_382;
  VSEnvironment *ev_375_tmp_385;
  enum ADL__ACF_result VSduplicate_ACF_Result_368 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_368))
  VSduplicate_ACF_Result_368 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_368 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_369 = ADL__VSduplicate_wrapper(o_386, ev_375);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_375_tmp_376 = ev_375;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_375_tmp_376);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_372 = no_exception(ev_375);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_372);
  VSduplicate_NormalOutcome_370 = (tmp_372);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_375_tmp_381 = ev_375;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_375_tmp_381);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_378 = system_exception(ev_375);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_378);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_377 = tmp_378;
  if (!tmp_378) {
      ev_375_tmp_385 = ev_375;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_375_tmp_385);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_382 = user_exception(ev_375);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_382);
    tmp_377 = tmp_382;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_377);

  VSduplicate_ExceptionOutcome_371 = (tmp_377);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_371 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_371 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_370 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_370 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_368 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_368 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_371 && !VSduplicate_NormalOutcome_370) {
  VSduplicate_ACF_Result_368 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_371 && VSduplicate_NormalOutcome_370) {
  VSduplicate_ACF_Result_368 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_371);
  ev_375_tmp_395 = ev_375;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_375_tmp_395);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_391 = user_exception_is("NOT_IMPLEMENTED", ev_375);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_391);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_390 = !tmp_391;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_390);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_388 = (!VSduplicate_ExceptionOutcome_371 || tmp_390);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_388);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_371);
  ev_375_tmp_402 = ev_375;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&ev_375_tmp_402);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_399 = user_exception(ev_375);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_399);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_398 = !tmp_399;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_398);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_396 = (!VSduplicate_ExceptionOutcome_371 || tmp_398);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_396);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_370){
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&VSduplicate_RtnVal_369);
  o_386_tmp_411 = o_386;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&o_386_tmp_411);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate is_same_exlist_ptr(return, o) */
  tmp_407 = is_same_exlist_ptr(VSduplicate_RtnVal_369, o_386);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_407);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate is_same_exlist_ptr(return, o) && cleanup_exlist_ptr(return) */
  tmp_406 = tmp_407;
  if (tmp_407) {
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&VSduplicate_RtnVal_369);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate cleanup_exlist_ptr(return) */
  tmp_412 = cleanup_exlist_ptr(VSduplicate_RtnVal_369);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_412);
    tmp_406 = tmp_412;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 24, 25);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_406);
  groupExpr_415 = (tmp_406);
  tmp_404 = (groupExpr_415);
  tmp_403 = tmp_404;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 19, 25);
  tmp_403 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&tmp_403);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_368 = calculate_ACF_result(VSduplicate_ACF_Result_368, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_368;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_369);
}


VSExceptionList_ptr *(*ADL__VSduplicate_wrapper)(VSExceptionList_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSExceptionList_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_same_exlist_ptr(return, o) && cleanup_exlist_ptr(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_same_exlist_ptr(return, o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {4, 23, 21, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P },
  {4, 24, 20, 0, 0, "cleanup_exlist_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionList_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;
