/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/DII/NVList/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:13:20  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.2  1997/10/01 16:00:59  cwatson
   Added count(), item(), remove(), add(), add_item() and add_item_consume() tests.
   Makefile changes.

   Revision 1.1  1997/08/19 14:53:54  cwatson
   *** empty log message ***

*/

#include <corba_defs.h>

extern VSNVList_ptr *VSnil(VSEnvironment *env);
extern VSNVList_ptr *VSduplicate(VSNVList_ptr *o, VSEnvironment *env);

extern VSNamedValue_ptr *VSitem(VSNVList_ptr *o, VSULong i, VSEnvironment *env);
extern VSStatus VSremove(VSNVList_ptr *o, VSULong i, VSEnvironment *env);
extern VSULong VScount(VSNVList_ptr *o, VSEnvironment *env);

extern VSNamedValue_ptr *VSadd(VSNVList_ptr *o, VSFlags *f, VSEnvironment *env);
extern VSNamedValue_ptr *VSadd_item(VSNVList_ptr *o, VSString str, VSFlags *f, VSEnvironment *env);
extern VSNamedValue_ptr *VSadd_item_consume(VSNVList_ptr *o, VSString str,
																						VSFlags *f, VSEnvironment *env);
