//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/api/DII/NamedValue/t1_aux.cpp
//
// Purpose:
//
// Modifications:
// $Log: t1_aux.cpp,v $
// Revision 1.1.1.1  2000/02/09 17:13:26  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1997/12/05 16:28:06  cwatson
// Now uses .hh for c++ include files.
//
// Revision 1.5  1997/10/09 10:52:47  tet
// Removed undeeded #define.
//
// Revision 1.4  1997/10/04 16:42:12  stephen
// Changed include to corba_supp.hh.
//
// Revision 1.3  1997/10/01 16:02:57  cwatson
// Makefile changes.
//
// Revision 1.2  1997/09/12 13:01:27  cwatson
// Moved all _ptr provide and relinquish functions to corba/common/ptr_prov.cpp.
//
// Revision 1.1  1997/08/19 14:57:29  cwatson
// *** empty log message ***
//
//
/*
 *
 * t1_aux.c -- 
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */


#include <corba_supp.hh>
#include <tserver.hh>

extern "C" {

#include <t1_aux.h>

//-----------------------------------------------------------
// General NamedValue.

int is_same_nvalue_ptr(VSNamedValue_ptr *o1, VSNamedValue_ptr *o2)
{
		if(is_nil_nvalue_ptr(o1) && is_nil_nvalue_ptr(o2))
				return TRUE;
		
		return TRUE;
}

int cleanup_nvalue_ptr(VSNamedValue_ptr *o1)
{
		CORBA::NamedValue_ptr *tc = (CORBA::NamedValue_ptr *) o1;
		if(!tc)
				return TRUE;

		delete tc;
		return TRUE;
}

}
