/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/DII/ORB/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:13:28  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.3  1997/09/12 13:01:40  cwatson
   Moved all _ptr provide and relinquish functions to corba/common/ptr_prov.cpp.

   Revision 1.2  1997/08/22 11:08:45  cwatson
   Changed VSEnvironment_ptr to VSEnvironment *.

   Revision 1.1  1997/08/06 14:36:35  cwatson
   *** empty log message ***

*/

#include <corba_defs.h>

extern VSStatus VScreate_list(VSLong count, VSNVList_ptr *n,
															VSEnvironment *env);
extern VSStatus VScreate_operation_list(VSOperationDef_ptr *o,VSNVList_ptr *n,
															VSEnvironment *env);
extern VSStatus VScreate_named_value(VSNamedValue_ptr *nv,
															VSEnvironment *env);
extern VSStatus VScreate_exception_list(VSExceptionList_ptr *el,
															VSEnvironment *env);
extern VSStatus VScreate_context_list(VSContextList_ptr *cl,
															VSEnvironment *env);
extern VSStatus VSget_default_context(VSContext_ptr *c, VSEnvironment *env);

