/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VScreate_request
 *
 */
VSStatus ADL__ACF_VScreate_request (VSObject_ptr *o_21, VSContext_ptr *c_22, VSChar *op_23, VSNVList_ptr *nl_24, VSNamedValue_ptr *r_25, VSRequest_ptr *req_26, VSFlags *f_27, VSEnvironment *ev_9){

VSStatus VScreate_request_RtnVal_3;
  void *dummyVarName_1;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_20;


/* Declare vars for tmp vars for assertions */
    int tmp_29;
  int tmp_31;
  int tmp_32;
  VSEnvironment *ev_9_tmp_36;
    int tmp_37;
  int tmp_39;
  int tmp_40;
  VSEnvironment *ev_9_tmp_43;
    int tmp_44;
  int tmp_45;
  int groupExpr_51;
  int tmp_47;
  VSRequest_ptr *req_26_tmp_50;

/* Declare vars for result of normal and exception bindings */
  int VScreate_request_NormalOutcome_4, VScreate_request_ExceptionOutcome_5;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_6;
  VSEnvironment *ev_9_tmp_10;
    int tmp_11;
  int tmp_12;
  VSEnvironment *ev_9_tmp_15;
  int tmp_16;
  VSEnvironment *ev_9_tmp_19;
  enum ADL__ACF_result VScreate_request_ACF_Result_2 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VScreate_request_InfoArray, 0, ADL__VScreate_request_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VScreate_request_assertionReport->setPhase(ADL__VScreate_request_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_20 = 0; forLoopIdx_20 < ADL__VScreate_request_InfoArrayIdx; forLoopIdx_20++) {
  if (ADL__VScreate_request_InfoArray[forLoopIdx_20].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VScreate_request_InfoArray[forLoopIdx_20].error > 1) && 
      (ADL__VScreate_request_InfoArray[forLoopIdx_20].error > VScreate_request_ACF_Result_2))
  VScreate_request_ACF_Result_2 = ADL__VScreate_request_InfoArray[forLoopIdx_20].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VScreate_request_ACF_Result_2 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VScreate_request_assertionReport->setPhase(ADL__VScreate_request_assertionReport, PH_call);
  ADL__release(ADL__VScreate_request_assertionReport->parent, &this_seq);
  VScreate_request_RtnVal_3 = ADL__VScreate_request_wrapper(o_21, c_22, op_23, nl_24, r_25, req_26, f_27, ev_9);
  ADL__recover(ADL__VScreate_request_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VScreate_request_assertionReport->setPhase(ADL__VScreate_request_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_9_tmp_10 = ev_9;
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 8,&ev_9_tmp_10);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_6 = no_exception(ev_9);
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 7,&tmp_6);
  VScreate_request_NormalOutcome_4 = (tmp_6);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_9_tmp_15 = ev_9;
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 3,&ev_9_tmp_15);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_12 = system_exception(ev_9);
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 2,&tmp_12);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_11 = tmp_12;
  if (!tmp_12) {
      ev_9_tmp_19 = ev_9;
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 5,&ev_9_tmp_19);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_16 = user_exception(ev_9);
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 4,&tmp_16);
    tmp_11 = tmp_16;
  }
  else {
  ADL__resetInfoStruct(ADL__VScreate_request_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 1,&tmp_11);

  VScreate_request_ExceptionOutcome_5 = (tmp_11);

/* Exception binding is the first assertion */
  if (ADL__VScreate_request_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VScreate_request_InfoArray[0].result = (VScreate_request_ExceptionOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScreate_request_InfoArray[0].evaluated = 1;
  ADL__VScreate_request_InfoArray[0].value = (VScreate_request_ExceptionOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VScreate_request_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VScreate_request_InfoArray[6].result = (VScreate_request_NormalOutcome_4 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VScreate_request_InfoArray[6].evaluated = 1;
  ADL__VScreate_request_InfoArray[6].value = (VScreate_request_NormalOutcome_4 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VScreate_request_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VScreate_request_ACF_Result_2 = ADL__VScreate_request_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VScreate_request_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VScreate_request_ACF_Result_2 = ADL__VScreate_request_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VScreate_request_ExceptionOutcome_5 && !VScreate_request_NormalOutcome_4) {
  VScreate_request_ACF_Result_2 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VScreate_request_ExceptionOutcome_5 && VScreate_request_NormalOutcome_4) {
  VScreate_request_ACF_Result_2 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VScreate_request_InfoArray, 10,&VScreate_request_ExceptionOutcome_5);
  ev_9_tmp_36 = ev_9;
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 13,&ev_9_tmp_36);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_32 = user_exception_is("NOT_IMPLEMENTED", ev_9);
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 12,&tmp_32);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_31 = !tmp_32;
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 11,&tmp_31);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_29 = (!VScreate_request_ExceptionOutcome_5 || tmp_31);
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 9,&tmp_29);
    ADL__setResultAndError(ADL__VScreate_request_InfoArray, 15,&VScreate_request_ExceptionOutcome_5);
  ev_9_tmp_43 = ev_9;
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 18,&ev_9_tmp_43);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_40 = user_exception(ev_9);
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 17,&tmp_40);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_39 = !tmp_40;
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 16,&tmp_39);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_37 = (!VScreate_request_ExceptionOutcome_5 || tmp_39);
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 14,&tmp_37);
    ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VScreate_request_NormalOutcome_4){
      req_26_tmp_50 = req_26;
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 21,&req_26_tmp_50);
  ADL__VScreate_request_assertionReport->exprMark(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_assertionReport->assrt_info[20]);

/* Evaluate request_is_ok(req) */
  tmp_47 = request_is_ok(req_26);
  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 20,&tmp_47);
  groupExpr_51 = (tmp_47);
  tmp_45 = (groupExpr_51);
  tmp_44 = tmp_45;
  }
  else {
    ADL__resetInfoStruct(ADL__VScreate_request_InfoArray, 19, 21);
  tmp_44 = 1;
}

  ADL__setResultAndError(ADL__VScreate_request_InfoArray, 19,&tmp_44);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_20 = 0; forLoopIdx_20 < ADL__VScreate_request_InfoArrayIdx; forLoopIdx_20++) {

/* Calculate ACF result */
      if (ADL__VScreate_request_InfoArray[forLoopIdx_20].kind == ADL__GENERAL_ASSERTION ||
       ADL__VScreate_request_InfoArray[forLoopIdx_20].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VScreate_request_InfoArray[forLoopIdx_20].kind == ADL__CONSTANT && ADL__VScreate_request_InfoArray[forLoopIdx_20].level == 0))
        VScreate_request_ACF_Result_2 = calculate_ACF_result(VScreate_request_ACF_Result_2, ADL__VScreate_request_InfoArray[forLoopIdx_20].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VScreate_request_assertionReport->value = VScreate_request_ACF_Result_2;
  ADL__VScreate_request_assertionReport->parent->openReport(ADL__VScreate_request_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_20 = 0; forLoopIdx_20 < ADL__VScreate_request_InfoArrayIdx; forLoopIdx_20++) {
    if(ADL__VScreate_request_assertionReport->emitTest(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_InfoArray[forLoopIdx_20])) {
     ADL__VScreate_request_assertionReport->exprStart(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_InfoArray[forLoopIdx_20]);
      if(!ADL__VScreate_request_InfoArray[forLoopIdx_20].testable || !ADL__VScreate_request_InfoArray[forLoopIdx_20].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VScreate_request_assertionReport->emitter);
      else if (ADL__VScreate_request_InfoArray[forLoopIdx_20].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VScreate_request_InfoArray[forLoopIdx_20].error, ADL__VScreate_request_assertionReport->emitter);
      else
        ADL__VScreate_request_InfoArray[forLoopIdx_20].emitFunc(ADL__VScreate_request_InfoArray[forLoopIdx_20].value, ADL__VScreate_request_assertionReport->emitter);
     ADL__VScreate_request_assertionReport->exprEnd(ADL__VScreate_request_assertionReport, &ADL__VScreate_request_InfoArray[forLoopIdx_20]);
    }
  }

  return (VScreate_request_RtnVal_3);
}


VSStatus (*ADL__VScreate_request_wrapper)(VSObject_ptr*, VSContext_ptr*, VSChar*, VSNVList_ptr*, VSNamedValue_ptr*, VSRequest_ptr*, VSFlags*, VSEnvironment*) = VScreate_request;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t *emitter);
void ADL__emit_VSContext_ptr_P (void* val, emitter_t *emitter);
void ADL__emit_VSChar_P (void* val, emitter_t *emitter);
void ADL__emit_VSNVList_ptr_P (void* val, emitter_t *emitter);
void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t *emitter);
void ADL__emit_VSRequest_ptr_P (void* val, emitter_t *emitter);
void ADL__emit_VSFlags_P (void* val, emitter_t *emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t *emitter);

struct ADL__assertionReportStruct ADL__VScreate_request_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "request_is_ok(req)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "req", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSRequest_ptr_P }
};


unsigned int ADL__VScreate_request_InfoArrayIdx = 22;

struct ADL__reportAssertion *ADL__VScreate_request_assertionReport = 0;
