/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/DII/Request/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:13:35  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.3  1997/10/22 14:25:57  ian
   Added tests for send_oneway, send_deferred, get_response, poll_response, send_multiple_oneway and add_arg.

   Revision 1.2  1997/10/06 17:57:07  kevin
   fixed Request() ..Result() is untestable with current ORBs

   Revision 1.1  1997/08/19 14:57:39  cwatson
   *** empty log message ***

*/

#include <corba_defs.h>

VSRequest_ptr *VSnil(VSEnvironment *);
VSRequest_ptr *VSduplicate(VSRequest_ptr *, VSEnvironment *);

VSRequest_ptr *VSadd_arg(VSRequest_ptr *, VSEnvironment *);
VSStatus VSinvoke(VSRequest_ptr *, VSEnvironment *);
VSRequest_ptr *VSsend_deferred(VSRequest_ptr *, VSEnvironment *);
VSRequest_ptr *VSsend_oneway(VSRequest_ptr *, VSEnvironment *);
VSRequest_ptr *VSget_response(VSRequest_ptr *, VSEnvironment *);
VSRequest_ptr *VSpoll_response(VSRequest_ptr *, VSEnvironment *);

VSORB_ptr *VSsend_multiple_oneway(VSRequestSeq *, VSEnvironment *);
VSORB_ptr *VSsend_multiple(VSRequestSeq *, VSEnvironment *);

