/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_same_request_ptr(VSRequest_ptr *, VSRequest_ptr *);

extern int cleanup_request_ptr(VSRequest_ptr *);

extern int check_request_sent(VSRequest_ptr *);

extern int is_invalid_request(VSRequest_ptr *);

extern int check_request_executed(VSRequest_ptr *preq);

extern int get_response(VSRequest_ptr *preq);

extern int execute_request(VSRequest_ptr *preq);

extern int check_requests_sent(VSRequestSeq *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSRequest_ptr_P)(VSRequest_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSRequestSeq_P)(VSRequestSeq*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSRequest_ptr *(*ADL__VSadd_arg_wrapper)(VSRequest_ptr*, VSEnvironment*);
extern VSStatus (*ADL__VSinvoke_wrapper)(VSRequest_ptr*, VSEnvironment*);
extern VSRequest_ptr *(*ADL__VSsend_deferred_wrapper)(VSRequest_ptr*, VSEnvironment*);
extern VSRequest_ptr *(*ADL__VSsend_oneway_wrapper)(VSRequest_ptr*, VSEnvironment*);
extern VSRequest_ptr *(*ADL__VSget_response_wrapper)(VSRequest_ptr*, VSEnvironment*);
extern VSRequest_ptr *(*ADL__VSpoll_response_wrapper)(VSRequest_ptr*, VSEnvironment*);
extern void* (*ADL__VSsend_multiple_oneway_wrapper)(VSRequestSeq*, VSEnvironment*);
extern VSRequest_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSRequest_ptr *(*ADL__VSduplicate_wrapper)(VSRequest_ptr*, VSEnvironment*);

#endif
