/* ADL test driver from t1.tdr
 *
 * test VSUserEx_assign(userex_ptr, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop all_userex */
static struct ADL__propertyValue ADL__prop_values_914[] = {
    {"invalid_name", Pall_userex_invalid_name, 0},
    {"valid", Pall_userex_valid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_915[] = {
    {"=all_userex", "prop", ADL__prop_values_914, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_918[3] = {
    {"userex_ptr", "VSUserException *", ADL__prop_info_915, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_915, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSUserEx_assign_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSEXCEPTION_P
#define ADL__PRINT_VSEXCEPTION_P
void (*ADL__print_VSException_P)(VSException*, emitter_t) = 0;

#endif /* ADL__PRINT_VSEXCEPTION_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSSYSTEMEXCEPTION_P
#define ADL__PRINT_VSSYSTEMEXCEPTION_P
void (*ADL__print_VSSystemException_P)(VSSystemException*, emitter_t) = 0;

#endif /* ADL__PRINT_VSSYSTEMEXCEPTION_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSCOMPLETED
#define ADL__PRINT_VSCOMPLETED
void (*ADL__print_VSCompleted)(VSCompleted, emitter_t) = 0;

#endif /* ADL__PRINT_VSCOMPLETED */
#ifndef ADL__PRINT_VSUSEREXCEPTION_P
#define ADL__PRINT_VSUSEREXCEPTION_P
void (*ADL__print_VSUserException_P)(VSUserException*, emitter_t) = 0;

#endif /* ADL__PRINT_VSUSEREXCEPTION_P */

void ADL__emit_VSException_P (void* val, emitter_t emitter)
{
  VSException *tmp;

  if (ADL__print_VSException_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSException_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSSystemException_P (void* val, emitter_t emitter)
{
  VSSystemException *tmp;

  if (ADL__print_VSSystemException_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSSystemException_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSCompleted (void* val, emitter_t emitter)
{
  VSCompleted tmp;

  if (ADL__print_VSCompleted != 0) {
    tmp = *(VSCompleted*) val;
    ADL__print_VSCompleted(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSUserException_P (void* val, emitter_t emitter)
{
  VSUserException *tmp;

  if (ADL__print_VSUserException_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSUserException_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSUserException *userex_ptr_916;
    VSEnvironment *env_917;
    VSUserException *fut_return_913;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSUserEx_assign_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSUserEx_assign_InfoArrayIdx,
        ADL__VSUserEx_assign_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_userex_ptr(&userex_ptr_916, ADL__prop_values_914[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSUserException_P(&userex_ptr_916, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_917)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_917, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSUserEx_assign_assertionReport = rf->assertionReport;
       fut_return_913 = ADL__ACF_VSUserEx_assign(userex_ptr_916, env_917);
       test_value = ADL__VSUserEx_assign_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_env(&env_917);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_userex_ptr(&userex_ptr_916, ADL__prop_values_914[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_918,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSUserEx_assign_head);

    return 0;
}


struct ADL__Directive_info VSUserEx_assign1_info = {
    N_VARS,
    ADL__var_info_918
};

struct ADL__TDD_info ADL__test_info = {
    2,
    &ADL__VSUserEx_assign_InfoArrayIdx,
    ADL__VSUserEx_assign_InfoArray,
    ADL__test_driver,
    "VSUserEx_assign",
    "VSUserEx_assign1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSUserEx_assign1",
    "t1_tr.rif",
    &VSUserEx_assign1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

