/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int sysex_equal(VSSystemException *, VSSystemException *);

extern int userex_equal(VSUserException *, VSUserException *);

extern int sysex_minor_equal(VSException *, VSULong);

extern int sysex_completed_equal(VSException *, VSCompleted);

extern int ex_user_exception(VSException *);

extern int ex_system_exception(VSException *);

extern int ex_system_exception_is(VSString, VSException *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSException_P)(VSException*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSSystemException_P)(VSSystemException*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSCompleted)(VSCompleted, emitter_t);
extern void (*ADL__print_VSUserException_P)(VSUserException*, emitter_t);

/* Declarations of wrapper of FUT */
extern VSSystemException *(*ADL__VSSystemEx_narrow_wrapper)(VSException*, VSEnvironment*);
extern VSSystemException *(*ADL__VSSystemEx_assign_wrapper)(VSSystemException*, VSEnvironment*);
extern VSULong (*ADL__VSSystemEx_minor_wrapper)(VSSystemException*, VSULong, VSEnvironment*);
extern VSCompleted (*ADL__VSSystemEx_completed_wrapper)(VSSystemException*, VSCompleted, VSEnvironment*);
extern VSUserException *(*ADL__VSUserEx_narrow_wrapper)(VSException*, VSEnvironment*);
extern VSUserException *(*ADL__VSUserEx_assign_wrapper)(VSUserException*, VSEnvironment*);

#endif
