/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_arraydef_ptr(VSArrayDef_ptr *);

extern int is_nil_arraydef_ptr(VSArrayDef_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int is_correct_length(VSULong);

extern int is_correct_element_type(VSTypeCode_ptr *);

extern int is_correct_element_type_def(VSIDLType_ptr);

extern int is_correct_new_length(VSULong, VSULong);

extern int is_same_type_def(VSIDLType_ptr, VSIDLType_ptr);

extern int is_correct_def_kind(VSDefinitionKind);

extern int is_correct_typecode(VSTypeCode_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSArrayDef_ptr_P)(VSArrayDef_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);

/* Declarations of wrapper of FUT */
extern VSTypeCode_ptr *(*ADL__VSelement_type_wrapper)(VSEnvironment*);
extern VSIDLType_ptr (*ADL__VSelement_type_def_read_wrapper)(VSEnvironment*);
extern VSULong (*ADL__VSlength_read_wrapper)(VSEnvironment*);
extern VSArrayDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSArrayDef_ptr *(*ADL__VSduplicate_wrapper)(VSArrayDef_ptr*, VSEnvironment*);
extern VSArrayDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern void (*ADL__VSlength_write_wrapper)(VSULong, VSEnvironment*);
extern void (*ADL__VSelement_type_def_write_wrapper)(VSIDLType_ptr const, VSEnvironment*);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*);

#endif
