/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_attributedef_ptr(VSAttributeDef_ptr *);

extern int is_nil_attributedef_ptr(VSAttributeDef_ptr *);

extern int is_correct_mode(VSAttributeMode, VSAttributeDef_ptr);

extern int is_correct_type_def(VSIDLType_ptr);

extern int is_correct_type(VSTypeCode_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int is_correct_mode_write(VSAttributeMode);

extern int is_same_type_def(VSIDLType_ptr, VSIDLType_ptr);

extern int is_correct_def_kind(VSDefinitionKind);

extern int is_correct_description(VSDescription_ptr);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSAttributeDef_ptr)(VSAttributeDef_ptr, emitter_t);
extern void (*ADL__print_VSAttributeMode)(VSAttributeMode, emitter_t);
extern void (*ADL__print_VSAttributeDef_ptr_P)(VSAttributeDef_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);
extern void (*ADL__print_VSDescription_ptr)(VSDescription_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*);
extern VSIDLType_ptr (*ADL__VStype_def_read_wrapper)(VSEnvironment*);
extern VSAttributeMode (*ADL__VSmode_read_wrapper)(VSEnvironment*, VSAttributeDef_ptr);
extern VSAttributeDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSAttributeDef_ptr *(*ADL__VSduplicate_wrapper)(VSAttributeDef_ptr*, VSEnvironment*);
extern VSAttributeDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern void (*ADL__VStype_def_write_wrapper)(VSIDLType_ptr const, VSEnvironment*);
extern void (*ADL__VSmode_write_wrapper)(VSAttributeMode, VSEnvironment*);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);
extern VSDescription_ptr (*ADL__VSdescribe_wrapper)(VSEnvironment*);

#endif
