/* ADL test driver from t1.tdr
 *
 * test VSname_write(defname, env, name_write_contained)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for literal variable defname */
static VSIdentifier ADL__litvar_val_654[] = {
    "new_name",
};

static struct ADL__propertyValue ADL__litvar_info_653[] = {
    {"\"new_name\"", 0, ADL__litvar_val_654},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_655[] = {
    {"defname", "litvar", ADL__litvar_info_653, 1},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_659[4] = {
    {"defname", "VSIdentifier", ADL__prop_info_655, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_655, 1, 0},
    {"name_write_contained", "VSString", ADL__prop_info_655, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSname_write_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSCONTAINED_PTR_P
#define ADL__PRINT_VSCONTAINED_PTR_P
void (*ADL__print_VSContained_ptr_P)(VSContained_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTAINED_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */
#ifndef ADL__PRINT_VSIDENTIFIER
#define ADL__PRINT_VSIDENTIFIER
void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDENTIFIER */
#ifndef ADL__PRINT_VSCONTAINER_PTR
#define ADL__PRINT_VSCONTAINER_PTR
void (*ADL__print_VSContainer_ptr)(VSContainer_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTAINER_PTR */
#ifndef ADL__PRINT_VSSCOPEDNAME
#define ADL__PRINT_VSSCOPEDNAME
void (*ADL__print_VSScopedName)(VSScopedName, emitter_t) = 0;

#endif /* ADL__PRINT_VSSCOPEDNAME */
#ifndef ADL__PRINT_VSREPOSITORY_PTR
#define ADL__PRINT_VSREPOSITORY_PTR
void (*ADL__print_VSRepository_ptr)(VSRepository_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSREPOSITORY_PTR */
#ifndef ADL__PRINT_VSDESCRIPTION_PTR
#define ADL__PRINT_VSDESCRIPTION_PTR
void (*ADL__print_VSDescription_ptr)(VSDescription_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSDESCRIPTION_PTR */
#ifndef ADL__PRINT_VSREPOSITORYID
#define ADL__PRINT_VSREPOSITORYID
void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t) = 0;

#endif /* ADL__PRINT_VSREPOSITORYID */
#ifndef ADL__PRINT_VSVERSIONSPEC
#define ADL__PRINT_VSVERSIONSPEC
void (*ADL__print_VSVersionSpec)(VSVersionSpec, emitter_t) = 0;

#endif /* ADL__PRINT_VSVERSIONSPEC */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContained_ptr_P (void* val, emitter_t emitter)
{
  VSContained_ptr *tmp;

  if (ADL__print_VSContained_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSContained_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIdentifier (void* val, emitter_t emitter)
{
  VSIdentifier tmp;

  if (ADL__print_VSIdentifier != 0) {
    tmp = *(VSIdentifier*) val;
    ADL__print_VSIdentifier(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContainer_ptr (void* val, emitter_t emitter)
{
  VSContainer_ptr tmp;

  if (ADL__print_VSContainer_ptr != 0) {
    tmp = *(VSContainer_ptr*) val;
    ADL__print_VSContainer_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSScopedName (void* val, emitter_t emitter)
{
  VSScopedName tmp;

  if (ADL__print_VSScopedName != 0) {
    tmp = *(VSScopedName*) val;
    ADL__print_VSScopedName(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRepository_ptr (void* val, emitter_t emitter)
{
  VSRepository_ptr tmp;

  if (ADL__print_VSRepository_ptr != 0) {
    tmp = *(VSRepository_ptr*) val;
    ADL__print_VSRepository_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDescription_ptr (void* val, emitter_t emitter)
{
  VSDescription_ptr tmp;

  if (ADL__print_VSDescription_ptr != 0) {
    tmp = *(VSDescription_ptr*) val;
    ADL__print_VSDescription_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRepositoryId (void* val, emitter_t emitter)
{
  VSRepositoryId tmp;

  if (ADL__print_VSRepositoryId != 0) {
    tmp = *(VSRepositoryId*) val;
    ADL__print_VSRepositoryId(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSVersionSpec (void* val, emitter_t emitter)
{
  VSVersionSpec tmp;

  if (ADL__print_VSVersionSpec != 0) {
    tmp = *(VSVersionSpec*) val;
    ADL__print_VSVersionSpec(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {1};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSIdentifier defname_656;
    VSEnvironment *env_657;
    VSString name_write_contained_658;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSname_write_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSname_write_InfoArrayIdx,
        ADL__VSname_write_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       defname_656 = ADL__litvar_val_654[tvec[0]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 0, tvec + 0, 1);
       ADL__emit_VSIdentifier(&defname_656, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_657)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_657, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_name_write_contained(&name_write_contained_658)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 1, 0);
       ADL__emit_VSString(&name_write_contained_658, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSname_write_assertionReport = rf->assertionReport;
       ADL__ACF_VSname_write(defname_656, env_657, name_write_contained_658);
       test_value = ADL__VSname_write_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[2] = relinquish_name_write_contained(&name_write_contained_658);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_env(&env_657);
SKIP_1:
       relvec[0] = 1;	/* relinquish succeeds for defname_656 */
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_659,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSname_write_head);

    return 0;
}


struct ADL__Directive_info VSname_write1_info = {
    N_VARS,
    ADL__var_info_659
};

struct ADL__TDD_info ADL__test_info = {
    1,
    &ADL__VSname_write_InfoArrayIdx,
    ADL__VSname_write_InfoArray,
    ADL__test_driver,
    "VSname_write",
    "VSname_write1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSname_write1",
    "t1_tr.rif",
    &VSname_write1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

