/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_same_string(VSString, VSString);

extern int is_nil_object(VSObject_ptr);

extern int is_nil_contained_ptr(VSContained_ptr *);

extern int is_invalid_contained_ptr(VSContained_ptr *);

extern int is_same_contained_ptr(VSContained_ptr *, VSContained_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int cleanup_contained_ptr(VSContained_ptr *);

extern int is_correct_name(VSIdentifier, VSString);

extern int is_correct_defined_in(VSContainer_ptr);

extern int is_correct_absolute_name(VSScopedName);

extern int is_correct_containing_repository(VSRepository_ptr);

extern int id_exists(VSRepositoryId);

extern int nameclash(VSContainer_ptr);

extern int inherited_obj(VSString);

extern int violates_containment(VSContainer_ptr);

extern int is_correct_description(VSDescription_ptr);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSContained_ptr_P)(VSContained_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSString)(VSString, emitter_t);
extern void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t);
extern void (*ADL__print_VSContainer_ptr)(VSContainer_ptr, emitter_t);
extern void (*ADL__print_VSScopedName)(VSScopedName, emitter_t);
extern void (*ADL__print_VSRepository_ptr)(VSRepository_ptr, emitter_t);
extern void (*ADL__print_VSDescription_ptr)(VSDescription_ptr, emitter_t);
extern void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t);
extern void (*ADL__print_VSVersionSpec)(VSVersionSpec, emitter_t);

/* Declarations of wrapper of FUT */
extern VSContained_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSContained_ptr *(*ADL__VSduplicate_wrapper)(VSContained_ptr*, VSEnvironment*);
extern VSContained_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSRepositoryId (*ADL__VSid_read_wrapper)(VSEnvironment*);
extern VSIdentifier (*ADL__VSname_read_wrapper)(VSEnvironment*, VSString);
extern VSVersionSpec (*ADL__VSversion_read_wrapper)(VSEnvironment*);
extern VSContainer_ptr (*ADL__VSdefined_in_wrapper)(VSEnvironment*);
extern VSScopedName (*ADL__VSabsolute_name_wrapper)(VSEnvironment*);
extern VSRepository_ptr (*ADL__VScontaining_repository_wrapper)(VSEnvironment*);
extern VSDescription_ptr (*ADL__VSdescribe_wrapper)(VSEnvironment*);
extern void (*ADL__VSid_write_wrapper)(VSRepositoryId const, VSEnvironment*);
extern void (*ADL__VSname_write_wrapper)(VSIdentifier const, VSEnvironment*, VSString);
extern void (*ADL__VSversion_write_wrapper)(VSVersionSpec const, VSEnvironment*);
extern void (*ADL__VSmove_wrapper)(VSContainer_ptr const, VSIdentifier const, VSVersionSpec const, VSEnvironment*, VSString);

#endif
