/* ADL test driver from t1.tdr
 *
 * test VScreate_constant(new_const_id, new_const_name, vspec, type, const_value, env, calling_container_ptr)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop defId */
static struct ADL__propertyValue ADL__prop_values_1140[] = {
    {"exists", Pnew_const_id_defId_exists, 0},
    {"not_exists", Pnew_const_id_defId_not_exists, 0},
    {0, 0, 0}
};

/* values for literal variable new_const_name */
static VSIdentifier ADL__litvar_val_1142[] = {
    "new_const_name",
};

static struct ADL__propertyValue ADL__litvar_info_1141[] = {
    {"\"new_const_name\"", 0, ADL__litvar_val_1142},
    {0, 0, 0}
};

/* values for literal variable vspec */
static VSVersionSpec ADL__litvar_val_1132[] = {
    "new_version",
};

static struct ADL__propertyValue ADL__litvar_info_1131[] = {
    {"\"new_version\"", 0, ADL__litvar_val_1132},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_1143[] = {
    {"defId", "prop", ADL__prop_values_1140, 2},
    {"new_const_name", "litvar", ADL__litvar_info_1141, 1},
    {"vspec", "litvar", ADL__litvar_info_1131, 1},
    {0, 0, 0}
};
#define TVEC_SIZE 3

static struct ADL__variableInfo ADL__var_info_1151[8] = {
    {"new_const_id", "VSRepositoryId", ADL__prop_info_1143, 0, 1},
    {"new_const_name", "VSIdentifier", ADL__prop_info_1143, 1, 1},
    {"vspec", "VSVersionSpec", ADL__prop_info_1143, 2, 1},
    {"type", "VSIDLType_ptr", ADL__prop_info_1143, 3, 0},
    {"const_value", "VSAny_ptr", ADL__prop_info_1143, 3, 0},
    {"env", "VSEnvironment *", ADL__prop_info_1143, 3, 0},
    {"calling_container_ptr", "VSContainer_ptr", ADL__prop_info_1143, 3, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 7


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScreate_constant_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSSCOPEDNAME
#define ADL__PRINT_VSSCOPEDNAME
void (*ADL__print_VSScopedName)(VSScopedName, emitter_t) = 0;

#endif /* ADL__PRINT_VSSCOPEDNAME */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSCONTAINED_PTR
#define ADL__PRINT_VSCONTAINED_PTR
void (*ADL__print_VSContained_ptr)(VSContained_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTAINED_PTR */
#ifndef ADL__PRINT_VSDEFINITIONKIND
#define ADL__PRINT_VSDEFINITIONKIND
void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSDEFINITIONKIND */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSCONTAINEDSEQ_PTR
#define ADL__PRINT_VSCONTAINEDSEQ_PTR
void (*ADL__print_VSContainedSeq_ptr)(VSContainedSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTAINEDSEQ_PTR */
#ifndef ADL__PRINT_VSLONG
#define ADL__PRINT_VSLONG
void (*ADL__print_VSLong)(VSLong, emitter_t) = 0;

#endif /* ADL__PRINT_VSLONG */
#ifndef ADL__PRINT_VSDESCRIPTIONSEQ_PTR
#define ADL__PRINT_VSDESCRIPTIONSEQ_PTR
void (*ADL__print_VSDescriptionSeq_ptr)(VSDescriptionSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSDESCRIPTIONSEQ_PTR */
#ifndef ADL__PRINT_VSIDENTIFIER
#define ADL__PRINT_VSIDENTIFIER
void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDENTIFIER */
#ifndef ADL__PRINT_VSCONTAINER_PTR_P
#define ADL__PRINT_VSCONTAINER_PTR_P
void (*ADL__print_VSContainer_ptr_P)(VSContainer_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTAINER_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */
#ifndef ADL__PRINT_VSREPOSITORYID
#define ADL__PRINT_VSREPOSITORYID
void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t) = 0;

#endif /* ADL__PRINT_VSREPOSITORYID */
#ifndef ADL__PRINT_VSVERSIONSPEC
#define ADL__PRINT_VSVERSIONSPEC
void (*ADL__print_VSVersionSpec)(VSVersionSpec, emitter_t) = 0;

#endif /* ADL__PRINT_VSVERSIONSPEC */
#ifndef ADL__PRINT_VSIDLTYPE_PTR
#define ADL__PRINT_VSIDLTYPE_PTR
void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDLTYPE_PTR */
#ifndef ADL__PRINT_VSANY_PTR
#define ADL__PRINT_VSANY_PTR
void (*ADL__print_VSAny_ptr)(VSAny_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSANY_PTR */
#ifndef ADL__PRINT_VSCONTAINER_PTR
#define ADL__PRINT_VSCONTAINER_PTR
void (*ADL__print_VSContainer_ptr)(VSContainer_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTAINER_PTR */
#ifndef ADL__PRINT_VSSTRUCTMEMBERSEQ_PTR
#define ADL__PRINT_VSSTRUCTMEMBERSEQ_PTR
void (*ADL__print_VSStructMemberSeq_ptr)(VSStructMemberSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRUCTMEMBERSEQ_PTR */
#ifndef ADL__PRINT_VSUNIONMEMBERSEQ_PTR
#define ADL__PRINT_VSUNIONMEMBERSEQ_PTR
void (*ADL__print_VSUnionMemberSeq_ptr)(VSUnionMemberSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSUNIONMEMBERSEQ_PTR */
#ifndef ADL__PRINT_VSENUMMEMBERSEQ_PTR
#define ADL__PRINT_VSENUMMEMBERSEQ_PTR
void (*ADL__print_VSEnumMemberSeq_ptr)(VSEnumMemberSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSENUMMEMBERSEQ_PTR */
#ifndef ADL__PRINT_VSINTERFACEDEFSEQ_PTR
#define ADL__PRINT_VSINTERFACEDEFSEQ_PTR
void (*ADL__print_VSInterfaceDefSeq_ptr)(VSInterfaceDefSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSINTERFACEDEFSEQ_PTR */
#ifndef ADL__PRINT_VSVALUEDEF_PTR
#define ADL__PRINT_VSVALUEDEF_PTR
void (*ADL__print_VSValueDef_ptr)(VSValueDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEDEF_PTR */
#ifndef ADL__PRINT_VSVALUEDEFSEQ_PTR
#define ADL__PRINT_VSVALUEDEFSEQ_PTR
void (*ADL__print_VSValueDefSeq_ptr)(VSValueDefSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEDEFSEQ_PTR */
#ifndef ADL__PRINT_VSINITIALIZERSEQ_PTR
#define ADL__PRINT_VSINITIALIZERSEQ_PTR
void (*ADL__print_VSInitializerSeq_ptr)(VSInitializerSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSINITIALIZERSEQ_PTR */

void ADL__emit_VSScopedName (void* val, emitter_t emitter)
{
  VSScopedName tmp;

  if (ADL__print_VSScopedName != 0) {
    tmp = *(VSScopedName*) val;
    ADL__print_VSScopedName(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContained_ptr (void* val, emitter_t emitter)
{
  VSContained_ptr tmp;

  if (ADL__print_VSContained_ptr != 0) {
    tmp = *(VSContained_ptr*) val;
    ADL__print_VSContained_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter)
{
  VSDefinitionKind tmp;

  if (ADL__print_VSDefinitionKind != 0) {
    tmp = *(VSDefinitionKind*) val;
    ADL__print_VSDefinitionKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSContainedSeq_ptr (void* val, emitter_t emitter)
{
  VSContainedSeq_ptr tmp;

  if (ADL__print_VSContainedSeq_ptr != 0) {
    tmp = *(VSContainedSeq_ptr*) val;
    ADL__print_VSContainedSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSLong (void* val, emitter_t emitter)
{
  VSLong tmp;

  if (ADL__print_VSLong != 0) {
    tmp = *(VSLong*) val;
    ADL__print_VSLong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSDescriptionSeq_ptr (void* val, emitter_t emitter)
{
  VSDescriptionSeq_ptr tmp;

  if (ADL__print_VSDescriptionSeq_ptr != 0) {
    tmp = *(VSDescriptionSeq_ptr*) val;
    ADL__print_VSDescriptionSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIdentifier (void* val, emitter_t emitter)
{
  VSIdentifier tmp;

  if (ADL__print_VSIdentifier != 0) {
    tmp = *(VSIdentifier*) val;
    ADL__print_VSIdentifier(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContainer_ptr_P (void* val, emitter_t emitter)
{
  VSContainer_ptr *tmp;

  if (ADL__print_VSContainer_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSContainer_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRepositoryId (void* val, emitter_t emitter)
{
  VSRepositoryId tmp;

  if (ADL__print_VSRepositoryId != 0) {
    tmp = *(VSRepositoryId*) val;
    ADL__print_VSRepositoryId(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSVersionSpec (void* val, emitter_t emitter)
{
  VSVersionSpec tmp;

  if (ADL__print_VSVersionSpec != 0) {
    tmp = *(VSVersionSpec*) val;
    ADL__print_VSVersionSpec(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter)
{
  VSIDLType_ptr tmp;

  if (ADL__print_VSIDLType_ptr != 0) {
    tmp = *(VSIDLType_ptr*) val;
    ADL__print_VSIDLType_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAny_ptr (void* val, emitter_t emitter)
{
  VSAny_ptr tmp;

  if (ADL__print_VSAny_ptr != 0) {
    tmp = *(VSAny_ptr*) val;
    ADL__print_VSAny_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContainer_ptr (void* val, emitter_t emitter)
{
  VSContainer_ptr tmp;

  if (ADL__print_VSContainer_ptr != 0) {
    tmp = *(VSContainer_ptr*) val;
    ADL__print_VSContainer_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSStructMemberSeq_ptr (void* val, emitter_t emitter)
{
  VSStructMemberSeq_ptr tmp;

  if (ADL__print_VSStructMemberSeq_ptr != 0) {
    tmp = *(VSStructMemberSeq_ptr*) val;
    ADL__print_VSStructMemberSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSUnionMemberSeq_ptr (void* val, emitter_t emitter)
{
  VSUnionMemberSeq_ptr tmp;

  if (ADL__print_VSUnionMemberSeq_ptr != 0) {
    tmp = *(VSUnionMemberSeq_ptr*) val;
    ADL__print_VSUnionMemberSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnumMemberSeq_ptr (void* val, emitter_t emitter)
{
  VSEnumMemberSeq_ptr tmp;

  if (ADL__print_VSEnumMemberSeq_ptr != 0) {
    tmp = *(VSEnumMemberSeq_ptr*) val;
    ADL__print_VSEnumMemberSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSInterfaceDefSeq_ptr (void* val, emitter_t emitter)
{
  VSInterfaceDefSeq_ptr tmp;

  if (ADL__print_VSInterfaceDefSeq_ptr != 0) {
    tmp = *(VSInterfaceDefSeq_ptr*) val;
    ADL__print_VSInterfaceDefSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSValueDef_ptr (void* val, emitter_t emitter)
{
  VSValueDef_ptr tmp;

  if (ADL__print_VSValueDef_ptr != 0) {
    tmp = *(VSValueDef_ptr*) val;
    ADL__print_VSValueDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSValueDefSeq_ptr (void* val, emitter_t emitter)
{
  VSValueDefSeq_ptr tmp;

  if (ADL__print_VSValueDefSeq_ptr != 0) {
    tmp = *(VSValueDefSeq_ptr*) val;
    ADL__print_VSValueDefSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSInitializerSeq_ptr (void* val, emitter_t emitter)
{
  VSInitializerSeq_ptr tmp;

  if (ADL__print_VSInitializerSeq_ptr != 0) {
    tmp = *(VSInitializerSeq_ptr*) val;
    ADL__print_VSInitializerSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 1, 1};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSRepositoryId new_const_id_1144;
    VSIdentifier new_const_name_1145;
    VSVersionSpec vspec_1146;
    VSIDLType_ptr type_1147;
    VSAny_ptr const_value_1148;
    VSEnvironment *env_1149;
    VSContainer_ptr calling_container_ptr_1150;
    VSConstantDef_ptr fut_return_1139;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScreate_constant_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScreate_constant_InfoArrayIdx,
        ADL__VScreate_constant_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_new_const_id(&new_const_id_1144, ADL__prop_values_1140[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSRepositoryId(&new_const_id_1144, rf->variableReport->emitVariable);

       new_const_name_1145 = ADL__litvar_val_1142[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 1, tvec + 1, 1);
       ADL__emit_VSIdentifier(&new_const_name_1145, rf->variableReport->emitVariable);

       vspec_1146 = ADL__litvar_val_1132[tvec[2]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 2, tvec + 2, 1);
       ADL__emit_VSVersionSpec(&vspec_1146, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_type(&type_1147)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
       ADL__emit_VSIDLType_ptr(&type_1147, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_const_value(&const_value_1148)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 4, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_4;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 4, tvec + 3, 0);
       ADL__emit_VSAny_ptr(&const_value_1148, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_env(&env_1149)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 5, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_5;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 5, tvec + 3, 0);
       ADL__emit_VSEnvironment_P(&env_1149, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_calling_container_ptr(&calling_container_ptr_1150)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 6, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_6;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 6, tvec + 3, 0);
       ADL__emit_VSContainer_ptr(&calling_container_ptr_1150, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScreate_constant_assertionReport = rf->assertionReport;
       fut_return_1139 = ADL__ACF_VScreate_constant(new_const_id_1144, new_const_name_1145, vspec_1146, type_1147, const_value_1148, env_1149, calling_container_ptr_1150);
       test_value = ADL__VScreate_constant_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(3);
       relvec[6] = relinquish_calling_container_ptr(&calling_container_ptr_1150);
SKIP_6:
      ADL__set_TDDVarNum(3);
       relvec[5] = relinquish_env(&env_1149);
SKIP_5:
      ADL__set_TDDVarNum(3);
       relvec[4] = relinquish_const_value(&const_value_1148);
SKIP_4:
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_type(&type_1147);
SKIP_3:
       relvec[2] = 1;	/* relinquish succeeds for vspec_1146 */
       relvec[1] = 1;	/* relinquish succeeds for new_const_name_1145 */
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_new_const_id(&new_const_id_1144, ADL__prop_values_1140[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_1151,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScreate_constant_head);

    return 0;
}


struct ADL__Directive_info VScreate_constant1_info = {
    N_VARS,
    ADL__var_info_1151
};

struct ADL__TDD_info ADL__test_info = {
    2,
    &ADL__VScreate_constant_InfoArrayIdx,
    ADL__VScreate_constant_InfoArray,
    ADL__test_driver,
    "VScreate_constant",
    "VScreate_constant1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScreate_constant1",
    "t1_tr.rif",
    &VScreate_constant1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

