/*
 *
 * t1_acf.h -- generated automatically by ADLT
 *
 * This file contains declarations of Assertion-Checking Functions
 * of module "t1"
 *
 */

#ifndef T1_ACF_H
#define T1_ACF_H

#include <adl_reporting.h>
#include <ADL_Standard.h>
#include "corba_defs_aux.h"
#include "t1_aux.h"
#include "t1.h"


VSContained_ptr ADL__ACF_VSlookup (VSScopedName const search_name_21, VSEnvironment *ev_10);
extern VSContained_ptr (*ADL__VSlookup_wrapper)(VSScopedName const, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSlookup_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSlookup_InfoArray[];
extern unsigned int ADL__VSlookup_InfoArrayIdx;


VSContainedSeq_ptr ADL__ACF_VScontents (VSDefinitionKind limit_type_74, VSBoolean exclude_inherited_75, VSEnvironment *ev_63);
extern VSContainedSeq_ptr (*ADL__VScontents_wrapper)(VSDefinitionKind, VSBoolean, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScontents_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScontents_InfoArray[];
extern unsigned int ADL__VScontents_InfoArrayIdx;


VSDescriptionSeq_ptr ADL__ACF_VSdescribe_contents (VSDefinitionKind limit_type_156, VSBoolean exclude_inherited_157, VSLong max_returned_objs_158, VSEnvironment *ev_145);
extern VSDescriptionSeq_ptr (*ADL__VSdescribe_contents_wrapper)(VSDefinitionKind, VSBoolean, VSLong, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSdescribe_contents_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSdescribe_contents_InfoArray[];
extern unsigned int ADL__VSdescribe_contents_InfoArrayIdx;


VSContainedSeq_ptr ADL__ACF_VSlookup_name (VSIdentifier const lookup_name_247, VSLong levels_to_search_248, VSDefinitionKind limit_type_249, VSBoolean exclude_inherited_250, VSEnvironment *ev_236);
extern VSContainedSeq_ptr (*ADL__VSlookup_name_wrapper)(VSIdentifier const, VSLong, VSDefinitionKind, VSBoolean, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSlookup_name_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSlookup_name_InfoArray[];
extern unsigned int ADL__VSlookup_name_InfoArrayIdx;


VSContainer_ptr *ADL__ACF_VSnil (VSEnvironment *ev_347);
extern VSContainer_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSnil_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSnil_InfoArray[];
extern unsigned int ADL__VSnil_InfoArrayIdx;


VSContainer_ptr *ADL__ACF_VSduplicate (VSContainer_ptr *o_409, VSEnvironment *ev_398);
extern VSContainer_ptr *(*ADL__VSduplicate_wrapper)(VSContainer_ptr*, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSduplicate_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[];
extern unsigned int ADL__VSduplicate_InfoArrayIdx;


VSContainer_ptr *ADL__ACF_VSnarrow (VSObject_ptr *o_465, VSEnvironment *ev_454);
extern VSContainer_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSnarrow_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[];
extern unsigned int ADL__VSnarrow_InfoArrayIdx;


VSModuleDef_ptr ADL__ACF_VScreate_module (VSRepositoryId const vs_id_524, VSIdentifier const vs_name_525, VSVersionSpec const vs_vspec_526, VSEnvironment *ev_513);
extern VSModuleDef_ptr (*ADL__VScreate_module_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScreate_module_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_module_InfoArray[];
extern unsigned int ADL__VScreate_module_InfoArrayIdx;


VSConstantDef_ptr ADL__ACF_VScreate_constant (VSRepositoryId const vs_id_573, VSIdentifier const vs_name_574, VSVersionSpec const vs_vspec_575, VSIDLType_ptr const vs_type_576, VSAny_ptr const vs_value_577, VSEnvironment *ev_562, VSContainer_ptr calling_container_ptr_578);
extern VSConstantDef_ptr (*ADL__VScreate_constant_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSAny_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_constant_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_constant_InfoArray[];
extern unsigned int ADL__VScreate_constant_InfoArrayIdx;


VSStructDef_ptr ADL__ACF_VScreate_struct (VSRepositoryId const vs_id_625, VSIdentifier const vs_name_626, VSVersionSpec const vs_vspec_627, VSStructMemberSeq_ptr const vs_members_628, VSEnvironment *ev_614, VSContainer_ptr calling_container_ptr_629);
extern VSStructDef_ptr (*ADL__VScreate_struct_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSStructMemberSeq_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_struct_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_struct_InfoArray[];
extern unsigned int ADL__VScreate_struct_InfoArrayIdx;


VSUnionDef_ptr ADL__ACF_VScreate_union (VSRepositoryId const vs_id_676, VSIdentifier const vs_name_677, VSVersionSpec const vs_vspec_678, VSIDLType_ptr const vs_discriminator_type_679, VSUnionMemberSeq_ptr const vs_members_680, VSEnvironment *ev_665, VSContainer_ptr calling_container_ptr_681);
extern VSUnionDef_ptr (*ADL__VScreate_union_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSUnionMemberSeq_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_union_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_union_InfoArray[];
extern unsigned int ADL__VScreate_union_InfoArrayIdx;


VSEnumDef_ptr ADL__ACF_VScreate_enum (VSRepositoryId const vs_id_728, VSIdentifier const vs_name_729, VSVersionSpec const vs_vspec_730, VSEnumMemberSeq_ptr const vs_members_731, VSEnvironment *ev_717, VSContainer_ptr calling_container_ptr_732);
extern VSEnumDef_ptr (*ADL__VScreate_enum_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSEnumMemberSeq_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_enum_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_enum_InfoArray[];
extern unsigned int ADL__VScreate_enum_InfoArrayIdx;


VSAliasDef_ptr ADL__ACF_VScreate_alias (VSRepositoryId const vs_id_779, VSIdentifier const vs_name_780, VSVersionSpec const vs_vspec_781, VSIDLType_ptr const vs_original_type_782, VSEnvironment *ev_768, VSContainer_ptr calling_container_ptr_783);
extern VSAliasDef_ptr (*ADL__VScreate_alias_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_alias_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_alias_InfoArray[];
extern unsigned int ADL__VScreate_alias_InfoArrayIdx;


VSInterfaceDef_ptr ADL__ACF_VScreate_interface (VSRepositoryId const vs_id_830, VSIdentifier const vs_name_831, VSVersionSpec const vs_vspec_832, VSInterfaceDefSeq_ptr const vs_base_interfaces_833, VSEnvironment *ev_819, VSContainer_ptr calling_container_ptr_834);
extern VSInterfaceDef_ptr (*ADL__VScreate_interface_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSInterfaceDefSeq_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_interface_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_interface_InfoArray[];
extern unsigned int ADL__VScreate_interface_InfoArrayIdx;


VSExceptionDef_ptr ADL__ACF_VScreate_exception (VSRepositoryId const vs_id_885, VSIdentifier const vs_name_886, VSVersionSpec const vs_vspec_887, VSStructMemberSeq_ptr const vs_members_888, VSEnvironment *ev_874, VSContainer_ptr calling_container_ptr_889);
extern VSExceptionDef_ptr (*ADL__VScreate_exception_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSStructMemberSeq_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_exception_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_exception_InfoArray[];
extern unsigned int ADL__VScreate_exception_InfoArrayIdx;


VSValueDef_ptr ADL__ACF_VScreate_value (VSRepositoryId const vs_id_936, VSIdentifier const vs_name_937, VSVersionSpec const vs_vspec_938, const VSBoolean is_custom_939, const VSBoolean is_abstract_940, VSValueDef_ptr const base_value_941, const VSBoolean is_truncatable_942, VSValueDefSeq_ptr const abstract_base_values_943, VSInterfaceDefSeq_ptr const supported_interfaces_944, VSInitializerSeq_ptr const initializers_945, VSEnvironment *ev_925, VSContainer_ptr calling_container_ptr_946);
extern VSValueDef_ptr (*ADL__VScreate_value_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, const VSBoolean, const VSBoolean, VSValueDef_ptr const, const VSBoolean, VSValueDefSeq_ptr const, VSInterfaceDefSeq_ptr const, VSInitializerSeq_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_value_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_value_InfoArray[];
extern unsigned int ADL__VScreate_value_InfoArrayIdx;


VSValueBoxDef_ptr ADL__ACF_VScreate_value_box (VSRepositoryId const vs_id_993, VSIdentifier const vs_name_994, VSVersionSpec const vs_vspec_995, VSIDLType_ptr const original_type_def_996, VSEnvironment *ev_982, VSContainer_ptr calling_container_ptr_997);
extern VSValueBoxDef_ptr (*ADL__VScreate_value_box_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_value_box_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_value_box_InfoArray[];
extern unsigned int ADL__VScreate_value_box_InfoArrayIdx;


VSNativeDef_ptr ADL__ACF_VScreate_native (VSRepositoryId const vs_id_1044, VSIdentifier const vs_name_1045, VSVersionSpec const vs_vspec_1046, VSEnvironment *ev_1033, VSContainer_ptr calling_container_ptr_1047);
extern VSNativeDef_ptr (*ADL__VScreate_native_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSEnvironment*, VSContainer_ptr);

extern struct ADL__reportAssertion *ADL__VScreate_native_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_native_InfoArray[];
extern unsigned int ADL__VScreate_native_InfoArrayIdx;


#endif
