/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VStype
 *
 */
VSTypeCode_ptr *ADL__ACF_VStype (VSEnvironment *ev_10){

VSTypeCode_ptr *VStype_RtnVal_4;
  void *dummyVarName_352;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_21;
  int tmp_23;
  int tmp_24;
  VSEnvironment *ev_10_tmp_28;
    int tmp_29;
  int tmp_31;
  int tmp_32;
  int tmp_33;
  VSEnvironment *ev_10_tmp_36;
  int tmp_37;
  int tmp_38;
  VSEnvironment *ev_10_tmp_41;
    int tmp_42;
  int tmp_43;
  int groupExpr_47;
  int tmp_44;

/* Declare vars for result of normal and exception bindings */
  int VStype_NormalOutcome_5, VStype_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VStype_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 0, ADL__VStype_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VStype_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VStype_InfoArray[forLoopIdx_1].error > VStype_ACF_Result_3))
  VStype_ACF_Result_3 = ADL__VStype_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VStype_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_call);
  ADL__release(ADL__VStype_assertionReport->parent, &this_seq);
  VStype_RtnVal_4 = ADL__VStype_wrapper(ev_10);
  ADL__recover(ADL__VStype_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 8,&ev_10_tmp_11);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 7,&tmp_7);
  VStype_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 3,&ev_10_tmp_16);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 2,&tmp_13);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 5,&ev_10_tmp_20);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 1,&tmp_12);

  VStype_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VStype_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[0].result = (VStype_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[0].evaluated = 1;
  ADL__VStype_InfoArray[0].value = (VStype_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VStype_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[6].result = (VStype_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[6].evaluated = 1;
  ADL__VStype_InfoArray[6].value = (VStype_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VStype_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_3 = ADL__VStype_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VStype_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_3 = ADL__VStype_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VStype_ExceptionOutcome_6 && !VStype_NormalOutcome_5) {
  VStype_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VStype_ExceptionOutcome_6 && VStype_NormalOutcome_5) {
  VStype_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VStype_InfoArray, 10,&VStype_ExceptionOutcome_6);
  ev_10_tmp_28 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 13,&ev_10_tmp_28);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 12,&tmp_24);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = !tmp_24;
  ADL__setResultAndError(ADL__VStype_InfoArray, 11,&tmp_23);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_21 = (!VStype_ExceptionOutcome_6 || tmp_23);
  ADL__setResultAndError(ADL__VStype_InfoArray, 9,&tmp_21);
    ADL__setResultAndError(ADL__VStype_InfoArray, 15,&VStype_ExceptionOutcome_6);
  ev_10_tmp_36 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 19,&ev_10_tmp_36);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_33 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 18,&tmp_33);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VStype_InfoArray, 17,&tmp_32);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_31 = tmp_32;
  if (tmp_32) {
      ev_10_tmp_41 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 22,&ev_10_tmp_41);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_38 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 21,&tmp_38);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_37 = !tmp_38;
  ADL__setResultAndError(ADL__VStype_InfoArray, 20,&tmp_37);
    tmp_31 = tmp_37;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 16,&tmp_31);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_29 = (!VStype_ExceptionOutcome_6 || tmp_31);
  ADL__setResultAndError(ADL__VStype_InfoArray, 14,&tmp_29);
    ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VStype_NormalOutcome_5){
      ADL__setResultAndError(ADL__VStype_InfoArray, 25,&VStype_RtnVal_4);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[24]);

/* Evaluate is_correct_type(return) */
  tmp_44 = is_correct_type(VStype_RtnVal_4);
  ADL__setResultAndError(ADL__VStype_InfoArray, 24,&tmp_44);
  groupExpr_47 = (tmp_44);
  tmp_43 = (groupExpr_47);
  tmp_42 = tmp_43;
  }
  else {
    ADL__resetInfoStruct(ADL__VStype_InfoArray, 23, 25);
  tmp_42 = 1;
}

  ADL__setResultAndError(ADL__VStype_InfoArray, 23,&tmp_42);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VStype_InfoArray[forLoopIdx_1].level == 0))
        VStype_ACF_Result_3 = calculate_ACF_result(VStype_ACF_Result_3, ADL__VStype_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VStype_assertionReport->value = VStype_ACF_Result_3;
  ADL__VStype_assertionReport->parent->openReport(ADL__VStype_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VStype_assertionReport->emitTest(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1])) {
     ADL__VStype_assertionReport->exprStart(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
      if(!ADL__VStype_InfoArray[forLoopIdx_1].testable || !ADL__VStype_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VStype_assertionReport->emitter);
      else if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VStype_InfoArray[forLoopIdx_1].error, ADL__VStype_assertionReport->emitter);
      else
        ADL__VStype_InfoArray[forLoopIdx_1].emitFunc(ADL__VStype_InfoArray[forLoopIdx_1].value, ADL__VStype_assertionReport->emitter);
     ADL__VStype_assertionReport->exprEnd(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
    }
  }

  return (VStype_RtnVal_4);
}


VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*) = VStype;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VStype_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_type(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P }
};


unsigned int ADL__VStype_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VStype_assertionReport = 0;

/*
 *
 * ACF of VSmembers_read
 *
 */
VSStructMemberSeq_ptr ADL__ACF_VSmembers_read (VSEnvironment *ev_56){

VSStructMemberSeq_ptr VSmembers_read_RtnVal_50;
  void *dummyVarName_352;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_67;
  int tmp_69;
  int tmp_70;
  VSEnvironment *ev_56_tmp_74;
    int tmp_75;
  int tmp_77;
  int tmp_78;
  int tmp_79;
  VSEnvironment *ev_56_tmp_82;
  int tmp_83;
  int tmp_84;
  VSEnvironment *ev_56_tmp_87;
    int tmp_88;
  int tmp_89;
  int groupExpr_93;
  int tmp_90;

/* Declare vars for result of normal and exception bindings */
  int VSmembers_read_NormalOutcome_51, VSmembers_read_ExceptionOutcome_52;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_53;
  VSEnvironment *ev_56_tmp_57;
    int tmp_58;
  int tmp_59;
  VSEnvironment *ev_56_tmp_62;
  int tmp_63;
  VSEnvironment *ev_56_tmp_66;
  enum ADL__ACF_result VSmembers_read_ACF_Result_49 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSmembers_read_InfoArray, 0, ADL__VSmembers_read_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSmembers_read_assertionReport->setPhase(ADL__VSmembers_read_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSmembers_read_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSmembers_read_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSmembers_read_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSmembers_read_InfoArray[forLoopIdx_1].error > VSmembers_read_ACF_Result_49))
  VSmembers_read_ACF_Result_49 = ADL__VSmembers_read_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSmembers_read_ACF_Result_49 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSmembers_read_assertionReport->setPhase(ADL__VSmembers_read_assertionReport, PH_call);
  ADL__release(ADL__VSmembers_read_assertionReport->parent, &this_seq);
  VSmembers_read_RtnVal_50 = ADL__VSmembers_read_wrapper(ev_56);
  ADL__recover(ADL__VSmembers_read_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSmembers_read_assertionReport->setPhase(ADL__VSmembers_read_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_56_tmp_57 = ev_56;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 8,&ev_56_tmp_57);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_53 = no_exception(ev_56);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 7,&tmp_53);
  VSmembers_read_NormalOutcome_51 = (tmp_53);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_56_tmp_62 = ev_56;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 3,&ev_56_tmp_62);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_59 = system_exception(ev_56);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 2,&tmp_59);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_58 = tmp_59;
  if (!tmp_59) {
      ev_56_tmp_66 = ev_56;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 5,&ev_56_tmp_66);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_63 = user_exception(ev_56);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 4,&tmp_63);
    tmp_58 = tmp_63;
  }
  else {
  ADL__resetInfoStruct(ADL__VSmembers_read_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 1,&tmp_58);

  VSmembers_read_ExceptionOutcome_52 = (tmp_58);

/* Exception binding is the first assertion */
  if (ADL__VSmembers_read_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSmembers_read_InfoArray[0].result = (VSmembers_read_ExceptionOutcome_52 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSmembers_read_InfoArray[0].evaluated = 1;
  ADL__VSmembers_read_InfoArray[0].value = (VSmembers_read_ExceptionOutcome_52 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSmembers_read_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSmembers_read_InfoArray[6].result = (VSmembers_read_NormalOutcome_51 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSmembers_read_InfoArray[6].evaluated = 1;
  ADL__VSmembers_read_InfoArray[6].value = (VSmembers_read_NormalOutcome_51 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSmembers_read_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSmembers_read_ACF_Result_49 = ADL__VSmembers_read_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSmembers_read_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSmembers_read_ACF_Result_49 = ADL__VSmembers_read_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSmembers_read_ExceptionOutcome_52 && !VSmembers_read_NormalOutcome_51) {
  VSmembers_read_ACF_Result_49 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSmembers_read_ExceptionOutcome_52 && VSmembers_read_NormalOutcome_51) {
  VSmembers_read_ACF_Result_49 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 10,&VSmembers_read_ExceptionOutcome_52);
  ev_56_tmp_74 = ev_56;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 13,&ev_56_tmp_74);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_70 = user_exception_is("NOT_IMPLEMENTED", ev_56);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 12,&tmp_70);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_69 = !tmp_70;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 11,&tmp_69);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_67 = (!VSmembers_read_ExceptionOutcome_52 || tmp_69);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 9,&tmp_67);
    ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 15,&VSmembers_read_ExceptionOutcome_52);
  ev_56_tmp_82 = ev_56;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 19,&ev_56_tmp_82);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_79 = system_exception(ev_56);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 18,&tmp_79);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_78 = !tmp_79;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 17,&tmp_78);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_77 = tmp_78;
  if (tmp_78) {
      ev_56_tmp_87 = ev_56;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 22,&ev_56_tmp_87);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_84 = user_exception(ev_56);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 21,&tmp_84);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_83 = !tmp_84;
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 20,&tmp_83);
    tmp_77 = tmp_83;
  }
  else {
  ADL__resetInfoStruct(ADL__VSmembers_read_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 16,&tmp_77);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_75 = (!VSmembers_read_ExceptionOutcome_52 || tmp_77);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 14,&tmp_75);
    ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSmembers_read_NormalOutcome_51){
      ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 25,&VSmembers_read_RtnVal_50);
  ADL__VSmembers_read_assertionReport->exprMark(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_assertionReport->assrt_info[24]);

/* Evaluate is_correct_members(return) */
  tmp_90 = is_correct_members(VSmembers_read_RtnVal_50);
  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 24,&tmp_90);
  groupExpr_93 = (tmp_90);
  tmp_89 = (groupExpr_93);
  tmp_88 = tmp_89;
  }
  else {
    ADL__resetInfoStruct(ADL__VSmembers_read_InfoArray, 23, 25);
  tmp_88 = 1;
}

  ADL__setResultAndError(ADL__VSmembers_read_InfoArray, 23,&tmp_88);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSmembers_read_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSmembers_read_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSmembers_read_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSmembers_read_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSmembers_read_InfoArray[forLoopIdx_1].level == 0))
        VSmembers_read_ACF_Result_49 = calculate_ACF_result(VSmembers_read_ACF_Result_49, ADL__VSmembers_read_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSmembers_read_assertionReport->value = VSmembers_read_ACF_Result_49;
  ADL__VSmembers_read_assertionReport->parent->openReport(ADL__VSmembers_read_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSmembers_read_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSmembers_read_assertionReport->emitTest(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_InfoArray[forLoopIdx_1])) {
     ADL__VSmembers_read_assertionReport->exprStart(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_InfoArray[forLoopIdx_1]);
      if(!ADL__VSmembers_read_InfoArray[forLoopIdx_1].testable || !ADL__VSmembers_read_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSmembers_read_assertionReport->emitter);
      else if (ADL__VSmembers_read_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSmembers_read_InfoArray[forLoopIdx_1].error, ADL__VSmembers_read_assertionReport->emitter);
      else
        ADL__VSmembers_read_InfoArray[forLoopIdx_1].emitFunc(ADL__VSmembers_read_InfoArray[forLoopIdx_1].value, ADL__VSmembers_read_assertionReport->emitter);
     ADL__VSmembers_read_assertionReport->exprEnd(ADL__VSmembers_read_assertionReport, &ADL__VSmembers_read_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSmembers_read_RtnVal_50);
}


VSStructMemberSeq_ptr (*ADL__VSmembers_read_wrapper)(VSEnvironment*) = VSmembers_read;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSStructMemberSeq_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSmembers_read_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_members(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStructMemberSeq_ptr }
};


unsigned int ADL__VSmembers_read_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSmembers_read_assertionReport = 0;

/*
 *
 * ACF of VSnil
 *
 */
VSExceptionDef_ptr *ADL__ACF_VSnil (VSEnvironment *ev_102){

VSExceptionDef_ptr *VSnil_RtnVal_96;
  void *dummyVarName_352;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_113;
  int tmp_115;
  int tmp_116;
  VSEnvironment *ev_102_tmp_120;
    int tmp_121;
  int tmp_123;
  int tmp_124;
  int tmp_125;
  VSEnvironment *ev_102_tmp_128;
  int tmp_129;
  int tmp_130;
  VSEnvironment *ev_102_tmp_133;
    int tmp_134;
  int tmp_135;
  int groupExpr_144;
  int tmp_137;
  int tmp_138;
  int tmp_141;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_97, VSnil_ExceptionOutcome_98;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_99;
  VSEnvironment *ev_102_tmp_103;
    int tmp_104;
  int tmp_105;
  VSEnvironment *ev_102_tmp_108;
  int tmp_109;
  VSEnvironment *ev_102_tmp_112;
  enum ADL__ACF_result VSnil_ACF_Result_95 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_95))
  VSnil_ACF_Result_95 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_95 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_96 = ADL__VSnil_wrapper(ev_102);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_102_tmp_103 = ev_102;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_102_tmp_103);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_99 = no_exception(ev_102);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_99);
  VSnil_NormalOutcome_97 = (tmp_99);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_102_tmp_108 = ev_102;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_102_tmp_108);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_105 = system_exception(ev_102);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_105);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_104 = tmp_105;
  if (!tmp_105) {
      ev_102_tmp_112 = ev_102;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_102_tmp_112);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_109 = user_exception(ev_102);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_109);
    tmp_104 = tmp_109;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_104);

  VSnil_ExceptionOutcome_98 = (tmp_104);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_98 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_98 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_97 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_97 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_95 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_95 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_98 && !VSnil_NormalOutcome_97) {
  VSnil_ACF_Result_95 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_98 && VSnil_NormalOutcome_97) {
  VSnil_ACF_Result_95 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_98);
  ev_102_tmp_120 = ev_102;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_102_tmp_120);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_116 = user_exception_is("NOT_IMPLEMENTED", ev_102);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_116);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_115 = !tmp_116;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_115);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_113 = (!VSnil_ExceptionOutcome_98 || tmp_115);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_113);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_98);
  ev_102_tmp_128 = ev_102;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_102_tmp_128);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_125 = system_exception(ev_102);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_125);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_124 = !tmp_125;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_124);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_123 = tmp_124;
  if (tmp_124) {
      ev_102_tmp_133 = ev_102;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_102_tmp_133);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_130 = user_exception(ev_102);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_130);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_129 = !tmp_130;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_129);
    tmp_123 = tmp_129;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_123);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_121 = (!VSnil_ExceptionOutcome_98 || tmp_123);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_121);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_97){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_96);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_exceptiondef_ptr(return) */
  tmp_138 = is_nil_exceptiondef_ptr(VSnil_RtnVal_96);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_138);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_exceptiondef_ptr(return) && cleanup_exceptiondef_ptr(return) */
  tmp_137 = tmp_138;
  if (tmp_138) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_96);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_exceptiondef_ptr(return) */
  tmp_141 = cleanup_exceptiondef_ptr(VSnil_RtnVal_96);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_141);
    tmp_137 = tmp_141;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_137);
  groupExpr_144 = (tmp_137);
  tmp_135 = (groupExpr_144);
  tmp_134 = tmp_135;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_134 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_134);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_95 = calculate_ACF_result(VSnil_ACF_Result_95, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_95;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_96);
}


VSExceptionDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSExceptionDef_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_exceptiondef_ptr(return) && cleanup_exceptiondef_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_exceptiondef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionDef_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_exceptiondef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionDef_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSExceptionDef_ptr *ADL__ACF_VSduplicate (VSExceptionDef_ptr *o_164, VSEnvironment *ev_153){

VSExceptionDef_ptr *VSduplicate_RtnVal_147;
  void *dummyVarName_352;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_165;
  int tmp_167;
  int tmp_168;
  VSEnvironment *ev_153_tmp_172;
    int tmp_173;
  int tmp_175;
  int tmp_176;
  int tmp_177;
  VSEnvironment *ev_153_tmp_180;
  int tmp_181;
  int tmp_182;
  VSEnvironment *ev_153_tmp_185;
    int tmp_186;
  int tmp_187;
  int groupExpr_199;
  int groupExpr_200;
  int tmp_188;
  int tmp_189;
  VSExceptionDef_ptr *o_164_tmp_192;
  int tmp_193;
  int tmp_196;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_148, VSduplicate_ExceptionOutcome_149;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_150;
  VSEnvironment *ev_153_tmp_154;
    int tmp_155;
  int tmp_156;
  VSEnvironment *ev_153_tmp_159;
  int tmp_160;
  VSEnvironment *ev_153_tmp_163;
  enum ADL__ACF_result VSduplicate_ACF_Result_146 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_146))
  VSduplicate_ACF_Result_146 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_146 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_147 = ADL__VSduplicate_wrapper(o_164, ev_153);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_153_tmp_154 = ev_153;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_153_tmp_154);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_150 = no_exception(ev_153);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_150);
  VSduplicate_NormalOutcome_148 = (tmp_150);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_153_tmp_159 = ev_153;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_153_tmp_159);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_156 = system_exception(ev_153);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_156);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_155 = tmp_156;
  if (!tmp_156) {
      ev_153_tmp_163 = ev_153;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_153_tmp_163);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_160 = user_exception(ev_153);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_160);
    tmp_155 = tmp_160;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_155);

  VSduplicate_ExceptionOutcome_149 = (tmp_155);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_149 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_149 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_148 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_148 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_146 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_146 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_149 && !VSduplicate_NormalOutcome_148) {
  VSduplicate_ACF_Result_146 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_149 && VSduplicate_NormalOutcome_148) {
  VSduplicate_ACF_Result_146 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_149);
  ev_153_tmp_172 = ev_153;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_153_tmp_172);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_168 = user_exception_is("NOT_IMPLEMENTED", ev_153);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_168);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_167 = !tmp_168;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_167);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_165 = (!VSduplicate_ExceptionOutcome_149 || tmp_167);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_165);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_149);
  ev_153_tmp_180 = ev_153;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&ev_153_tmp_180);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_177 = system_exception(ev_153);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&tmp_177);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_176 = !tmp_177;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_176);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_175 = tmp_176;
  if (tmp_176) {
      ev_153_tmp_185 = ev_153;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&ev_153_tmp_185);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_182 = user_exception(ev_153);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_182);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_181 = !tmp_182;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_181);
    tmp_175 = tmp_181;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_175);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_173 = (!VSduplicate_ExceptionOutcome_149 || tmp_175);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_173);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_148){
      o_164_tmp_192 = o_164;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 26,&o_164_tmp_192);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[25]);

/* Evaluate is_nil_exceptiondef_ptr(o) */
  tmp_189 = is_nil_exceptiondef_ptr(o_164);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&tmp_189);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 28,&VSduplicate_RtnVal_147);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[27]);

/* Evaluate is_nil_exceptiondef_ptr(return) */
  tmp_193 = is_nil_exceptiondef_ptr(VSduplicate_RtnVal_147);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 27,&tmp_193);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate is_nil_exceptiondef_ptr(o) --> is_nil_exceptiondef_ptr(return) */
  tmp_188 = (!tmp_189 || tmp_193);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_188);
  groupExpr_199 = (tmp_188);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 30,&VSduplicate_RtnVal_147);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[29]);

/* Evaluate cleanup_exceptiondef_ptr(return) */
  tmp_196 = cleanup_exceptiondef_ptr(VSduplicate_RtnVal_147);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 29,&tmp_196);
  groupExpr_200 = (tmp_196);
  tmp_187 = (groupExpr_199 && groupExpr_200);
  tmp_186 = tmp_187;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 23, 30);
  tmp_186 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&tmp_186);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_146 = calculate_ACF_result(VSduplicate_ACF_Result_146, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_146;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_147);
}


VSExceptionDef_ptr *(*ADL__VSduplicate_wrapper)(VSExceptionDef_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSExceptionDef_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_exceptiondef_ptr(o) --> is_nil_exceptiondef_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_exceptiondef_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionDef_ptr_P },
  {4, 27, 24, 0, 0, "is_nil_exceptiondef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionDef_ptr_P },
  {5, 29, 23, 0, 0, "cleanup_exceptiondef_ptr(return)", 29, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionDef_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 31;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSnarrow
 *
 */
VSExceptionDef_ptr *ADL__ACF_VSnarrow (VSObject_ptr *o_220, VSEnvironment *ev_209){

VSExceptionDef_ptr *VSnarrow_RtnVal_203;
  void *dummyVarName_352;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_221;
  int tmp_223;
  int tmp_224;
  VSEnvironment *ev_209_tmp_228;
    int tmp_229;
  int tmp_231;
  int tmp_232;
  int tmp_233;
  VSEnvironment *ev_209_tmp_236;
  int tmp_237;
  int tmp_238;
  VSEnvironment *ev_209_tmp_241;
    int tmp_242;
  int tmp_243;
  int groupExpr_258;
  int groupExpr_259;
  int tmp_245;
  int tmp_246;
  int tmp_249;
  VSObject_ptr tmp_251;
  VSObject_ptr *o_220_tmp_253;
  int tmp_255;

/* Declare vars for result of normal and exception bindings */
  int VSnarrow_NormalOutcome_204, VSnarrow_ExceptionOutcome_205;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_206;
  VSEnvironment *ev_209_tmp_210;
    int tmp_211;
  int tmp_212;
  VSEnvironment *ev_209_tmp_215;
  int tmp_216;
  VSEnvironment *ev_209_tmp_219;
  enum ADL__ACF_result VSnarrow_ACF_Result_202 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 0, ADL__VSnarrow_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnarrow_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnarrow_InfoArray[forLoopIdx_1].error > VSnarrow_ACF_Result_202))
  VSnarrow_ACF_Result_202 = ADL__VSnarrow_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnarrow_ACF_Result_202 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_call);
  ADL__release(ADL__VSnarrow_assertionReport->parent, &this_seq);
  VSnarrow_RtnVal_203 = ADL__VSnarrow_wrapper(o_220, ev_209);
  ADL__recover(ADL__VSnarrow_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_209_tmp_210 = ev_209;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 8,&ev_209_tmp_210);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_206 = no_exception(ev_209);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 7,&tmp_206);
  VSnarrow_NormalOutcome_204 = (tmp_206);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_209_tmp_215 = ev_209;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 3,&ev_209_tmp_215);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_212 = system_exception(ev_209);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 2,&tmp_212);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_211 = tmp_212;
  if (!tmp_212) {
      ev_209_tmp_219 = ev_209;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 5,&ev_209_tmp_219);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_216 = user_exception(ev_209);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 4,&tmp_216);
    tmp_211 = tmp_216;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 1,&tmp_211);

  VSnarrow_ExceptionOutcome_205 = (tmp_211);

/* Exception binding is the first assertion */
  if (ADL__VSnarrow_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[0].result = (VSnarrow_ExceptionOutcome_205 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[0].evaluated = 1;
  ADL__VSnarrow_InfoArray[0].value = (VSnarrow_ExceptionOutcome_205 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnarrow_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[6].result = (VSnarrow_NormalOutcome_204 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[6].evaluated = 1;
  ADL__VSnarrow_InfoArray[6].value = (VSnarrow_NormalOutcome_204 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnarrow_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_202 = ADL__VSnarrow_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnarrow_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_202 = ADL__VSnarrow_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnarrow_ExceptionOutcome_205 && !VSnarrow_NormalOutcome_204) {
  VSnarrow_ACF_Result_202 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnarrow_ExceptionOutcome_205 && VSnarrow_NormalOutcome_204) {
  VSnarrow_ACF_Result_202 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 10,&VSnarrow_ExceptionOutcome_205);
  ev_209_tmp_228 = ev_209;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 13,&ev_209_tmp_228);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_224 = user_exception_is("NOT_IMPLEMENTED", ev_209);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 12,&tmp_224);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_223 = !tmp_224;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 11,&tmp_223);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_221 = (!VSnarrow_ExceptionOutcome_205 || tmp_223);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 9,&tmp_221);
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 15,&VSnarrow_ExceptionOutcome_205);
  ev_209_tmp_236 = ev_209;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 19,&ev_209_tmp_236);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_233 = system_exception(ev_209);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 18,&tmp_233);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_232 = !tmp_233;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 17,&tmp_232);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_231 = tmp_232;
  if (tmp_232) {
      ev_209_tmp_241 = ev_209;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 22,&ev_209_tmp_241);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_238 = user_exception(ev_209);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 21,&tmp_238);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_237 = !tmp_238;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 20,&tmp_237);
    tmp_231 = tmp_237;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 16,&tmp_231);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_229 = (!VSnarrow_ExceptionOutcome_205 || tmp_231);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 14,&tmp_229);
    ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnarrow_NormalOutcome_204){
      ADL__setResultAndError(ADL__VSnarrow_InfoArray, 26,&VSnarrow_RtnVal_203);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[25]);

/* Evaluate is_nil_exceptiondef_ptr(return) */
  tmp_246 = is_nil_exceptiondef_ptr(VSnarrow_RtnVal_203);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 25,&tmp_246);
  o_220_tmp_253 = o_220;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 29,&o_220_tmp_253);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[28]);

/* Evaluate *o */
  if (ADL__badPtrDeref("*o",(unsigned int) o_220)) { /* check for invalid ptr reference */
     VSnarrow_ACF_Result_202 = ADL__ACF_ERROR;
     goto REPORT_RESULT;
  };
  tmp_251 = *o_220;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 28,&tmp_251);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[27]);

/* Evaluate is_nil_object(*o) */
  tmp_249 = is_nil_object(tmp_251);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 27,&tmp_249);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[24]);

/* Evaluate is_nil_exceptiondef_ptr(return) <-> is_nil_object(*o) */
  tmp_245 = ((tmp_246? 1 : 0) == (tmp_249? 1 : 0));
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 24,&tmp_245);
  groupExpr_258 = (tmp_245);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 31,&VSnarrow_RtnVal_203);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[30]);

/* Evaluate cleanup_exceptiondef_ptr(return) */
  tmp_255 = cleanup_exceptiondef_ptr(VSnarrow_RtnVal_203);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 30,&tmp_255);
  groupExpr_259 = (tmp_255);
  tmp_243 = (groupExpr_258 && groupExpr_259);
  tmp_242 = tmp_243;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 23, 31);
  tmp_242 = 1;
}

  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 23,&tmp_242);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnarrow_InfoArray[forLoopIdx_1].level == 0))
        VSnarrow_ACF_Result_202 = calculate_ACF_result(VSnarrow_ACF_Result_202, ADL__VSnarrow_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnarrow_assertionReport->value = VSnarrow_ACF_Result_202;
  ADL__VSnarrow_assertionReport->parent->openReport(ADL__VSnarrow_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnarrow_assertionReport->emitTest(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1])) {
     ADL__VSnarrow_assertionReport->exprStart(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnarrow_InfoArray[forLoopIdx_1].testable || !ADL__VSnarrow_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnarrow_assertionReport->emitter);
      else if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].error, ADL__VSnarrow_assertionReport->emitter);
      else
        ADL__VSnarrow_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].value, ADL__VSnarrow_assertionReport->emitter);
     ADL__VSnarrow_assertionReport->exprEnd(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnarrow_RtnVal_203);
}


VSExceptionDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*) = VSnarrow;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSExceptionDef_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSObject_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_exceptiondef_ptr(return) <-> is_nil_object(*o)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_exceptiondef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionDef_ptr_P },
  {4, 27, 24, 0, 0, "is_nil_object(*o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "*o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr },
  {4, 29, 28, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {5, 30, 23, 0, 0, "cleanup_exceptiondef_ptr(return)", 30, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 31, 30, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSExceptionDef_ptr_P }
};


unsigned int ADL__VSnarrow_InfoArrayIdx = 32;

struct ADL__reportAssertion *ADL__VSnarrow_assertionReport = 0;

/*
 *
 * ACF of VSmembers_write
 *
 */
void ADL__ACF_VSmembers_write (VSStructMemberSeq_ptr const vs_members_279, VSEnvironment *ev_268){

  void *dummyVarName_352;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_280;
  int tmp_282;
  int tmp_283;
  VSEnvironment *ev_268_tmp_287;
    int tmp_288;
  int tmp_290;
  VSEnvironment *ev_268_tmp_294;
    int tmp_295;
  int tmp_296;
  int groupExpr_305;
  int tmp_297;
  VSStructMemberSeq_ptr vs_members_279_tmp_300;
  VSStructMemberSeq_ptr tmp_301;
  VSEnvironment *ev_268_tmp_304;

/* Declare vars for result of normal and exception bindings */
  int VSmembers_write_NormalOutcome_263, VSmembers_write_ExceptionOutcome_264;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_265;
  VSEnvironment *ev_268_tmp_269;
    int tmp_270;
  int tmp_271;
  VSEnvironment *ev_268_tmp_274;
  int tmp_275;
  VSEnvironment *ev_268_tmp_278;
  enum ADL__ACF_result VSmembers_write_ACF_Result_261 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSmembers_write_InfoArray, 0, ADL__VSmembers_write_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSmembers_write_assertionReport->setPhase(ADL__VSmembers_write_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSmembers_write_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSmembers_write_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSmembers_write_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSmembers_write_InfoArray[forLoopIdx_1].error > VSmembers_write_ACF_Result_261))
  VSmembers_write_ACF_Result_261 = ADL__VSmembers_write_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSmembers_write_ACF_Result_261 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSmembers_write_assertionReport->setPhase(ADL__VSmembers_write_assertionReport, PH_call);
  ADL__release(ADL__VSmembers_write_assertionReport->parent, &this_seq);
  ADL__VSmembers_write_wrapper(vs_members_279, ev_268);
  ADL__recover(ADL__VSmembers_write_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSmembers_write_assertionReport->setPhase(ADL__VSmembers_write_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_268_tmp_269 = ev_268;
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 8,&ev_268_tmp_269);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_265 = no_exception(ev_268);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 7,&tmp_265);
  VSmembers_write_NormalOutcome_263 = (tmp_265);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_268_tmp_274 = ev_268;
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 3,&ev_268_tmp_274);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_271 = system_exception(ev_268);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 2,&tmp_271);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_270 = tmp_271;
  if (!tmp_271) {
      ev_268_tmp_278 = ev_268;
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 5,&ev_268_tmp_278);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_275 = user_exception(ev_268);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 4,&tmp_275);
    tmp_270 = tmp_275;
  }
  else {
  ADL__resetInfoStruct(ADL__VSmembers_write_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 1,&tmp_270);

  VSmembers_write_ExceptionOutcome_264 = (tmp_270);

/* Exception binding is the first assertion */
  if (ADL__VSmembers_write_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSmembers_write_InfoArray[0].result = (VSmembers_write_ExceptionOutcome_264 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSmembers_write_InfoArray[0].evaluated = 1;
  ADL__VSmembers_write_InfoArray[0].value = (VSmembers_write_ExceptionOutcome_264 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSmembers_write_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSmembers_write_InfoArray[6].result = (VSmembers_write_NormalOutcome_263 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSmembers_write_InfoArray[6].evaluated = 1;
  ADL__VSmembers_write_InfoArray[6].value = (VSmembers_write_NormalOutcome_263 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSmembers_write_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSmembers_write_ACF_Result_261 = ADL__VSmembers_write_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSmembers_write_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSmembers_write_ACF_Result_261 = ADL__VSmembers_write_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSmembers_write_ExceptionOutcome_264 && !VSmembers_write_NormalOutcome_263) {
  VSmembers_write_ACF_Result_261 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSmembers_write_ExceptionOutcome_264 && VSmembers_write_NormalOutcome_263) {
  VSmembers_write_ACF_Result_261 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 10,&VSmembers_write_ExceptionOutcome_264);
  ev_268_tmp_287 = ev_268;
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 13,&ev_268_tmp_287);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_283 = user_exception_is("NOT_IMPLEMENTED", ev_268);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 12,&tmp_283);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_282 = !tmp_283;
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 11,&tmp_282);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_280 = (!VSmembers_write_ExceptionOutcome_264 || tmp_282);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 9,&tmp_280);
    ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 15,&VSmembers_write_ExceptionOutcome_264);
  ev_268_tmp_294 = ev_268;
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 17,&ev_268_tmp_294);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[16]);

/* Evaluate system_exception_is("NO_PERMISSION", ev) */
  tmp_290 = system_exception_is("NO_PERMISSION", ev_268);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 16,&tmp_290);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[14]);

/* Evaluate exception --> system_exception_is("NO_PERMISSION", ev) */
  tmp_288 = (!VSmembers_write_ExceptionOutcome_264 || tmp_290);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 14,&tmp_288);
    ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[18]);

/* Evaluate normally { ... } */
  if(VSmembers_write_NormalOutcome_263){
      vs_members_279_tmp_300 = vs_members_279;
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 20,&vs_members_279_tmp_300);
  ev_268_tmp_304 = ev_268;
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 22,&ev_268_tmp_304);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[21]);

/* Evaluate VSmembers_read(ev) */
  tmp_301 = VSmembers_read(ev_268);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 21,&tmp_301);
  ADL__VSmembers_write_assertionReport->exprMark(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_assertionReport->assrt_info[19]);

/* Evaluate is_same_members(vs_members, VSmembers_read(ev)) */
  tmp_297 = is_same_members(vs_members_279, tmp_301);
  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 19,&tmp_297);
  groupExpr_305 = (tmp_297);
  tmp_296 = (groupExpr_305);
  tmp_295 = tmp_296;
  }
  else {
    ADL__resetInfoStruct(ADL__VSmembers_write_InfoArray, 18, 22);
  tmp_295 = 1;
}

  ADL__setResultAndError(ADL__VSmembers_write_InfoArray, 18,&tmp_295);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSmembers_write_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSmembers_write_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSmembers_write_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSmembers_write_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSmembers_write_InfoArray[forLoopIdx_1].level == 0))
        VSmembers_write_ACF_Result_261 = calculate_ACF_result(VSmembers_write_ACF_Result_261, ADL__VSmembers_write_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSmembers_write_assertionReport->value = VSmembers_write_ACF_Result_261;
  ADL__VSmembers_write_assertionReport->parent->openReport(ADL__VSmembers_write_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSmembers_write_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSmembers_write_assertionReport->emitTest(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_InfoArray[forLoopIdx_1])) {
     ADL__VSmembers_write_assertionReport->exprStart(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_InfoArray[forLoopIdx_1]);
      if(!ADL__VSmembers_write_InfoArray[forLoopIdx_1].testable || !ADL__VSmembers_write_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSmembers_write_assertionReport->emitter);
      else if (ADL__VSmembers_write_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSmembers_write_InfoArray[forLoopIdx_1].error, ADL__VSmembers_write_assertionReport->emitter);
      else
        ADL__VSmembers_write_InfoArray[forLoopIdx_1].emitFunc(ADL__VSmembers_write_InfoArray[forLoopIdx_1].value, ADL__VSmembers_write_assertionReport->emitter);
     ADL__VSmembers_write_assertionReport->exprEnd(ADL__VSmembers_write_assertionReport, &ADL__VSmembers_write_InfoArray[forLoopIdx_1]);
    }
  }

  return;
}


void (*ADL__VSmembers_write_wrapper)(VSStructMemberSeq_ptr const, VSEnvironment*) = VSmembers_write;

void ADL__emit_VSStructMemberSeq_ptr (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSmembers_write_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> system_exception_is(\"NO_PERMISSION\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "system_exception_is(\"NO_PERMISSION\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 18, 18, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 19, 18, 0, 0, "is_same_members(vs_members, VSmembers_read(ev))", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "vs_members", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStructMemberSeq_ptr },
  {4, 21, 19, 0, 0, "VSmembers_read(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStructMemberSeq_ptr },
  {4, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P }
};


unsigned int ADL__VSmembers_write_InfoArrayIdx = 23;

struct ADL__reportAssertion *ADL__VSmembers_write_assertionReport = 0;

/*
 *
 * ACF of VSdef_kind
 *
 */
VSDefinitionKind ADL__ACF_VSdef_kind (VSEnvironment *ev_314){

VSDefinitionKind VSdef_kind_RtnVal_308;
  void *dummyVarName_352;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_325;
  int tmp_327;
  int tmp_328;
  VSEnvironment *ev_314_tmp_332;
    int tmp_333;
  int tmp_335;
  int tmp_336;
  int tmp_337;
  VSEnvironment *ev_314_tmp_340;
  int tmp_341;
  int tmp_342;
  VSEnvironment *ev_314_tmp_345;
    int tmp_346;
  int tmp_347;
  int groupExpr_351;
  int tmp_348;

/* Declare vars for result of normal and exception bindings */
  int VSdef_kind_NormalOutcome_309, VSdef_kind_ExceptionOutcome_310;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_311;
  VSEnvironment *ev_314_tmp_315;
    int tmp_316;
  int tmp_317;
  VSEnvironment *ev_314_tmp_320;
  int tmp_321;
  VSEnvironment *ev_314_tmp_324;
  enum ADL__ACF_result VSdef_kind_ACF_Result_307 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 0, ADL__VSdef_kind_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > VSdef_kind_ACF_Result_307))
  VSdef_kind_ACF_Result_307 = ADL__VSdef_kind_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSdef_kind_ACF_Result_307 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_call);
  ADL__release(ADL__VSdef_kind_assertionReport->parent, &this_seq);
  VSdef_kind_RtnVal_308 = ADL__VSdef_kind_wrapper(ev_314);
  ADL__recover(ADL__VSdef_kind_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_314_tmp_315 = ev_314;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 8,&ev_314_tmp_315);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_311 = no_exception(ev_314);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 7,&tmp_311);
  VSdef_kind_NormalOutcome_309 = (tmp_311);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_314_tmp_320 = ev_314;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 3,&ev_314_tmp_320);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_317 = system_exception(ev_314);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 2,&tmp_317);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_316 = tmp_317;
  if (!tmp_317) {
      ev_314_tmp_324 = ev_314;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 5,&ev_314_tmp_324);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_321 = user_exception(ev_314);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 4,&tmp_321);
    tmp_316 = tmp_321;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 1,&tmp_316);

  VSdef_kind_ExceptionOutcome_310 = (tmp_316);

/* Exception binding is the first assertion */
  if (ADL__VSdef_kind_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[0].result = (VSdef_kind_ExceptionOutcome_310 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[0].evaluated = 1;
  ADL__VSdef_kind_InfoArray[0].value = (VSdef_kind_ExceptionOutcome_310 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSdef_kind_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[6].result = (VSdef_kind_NormalOutcome_309 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[6].evaluated = 1;
  ADL__VSdef_kind_InfoArray[6].value = (VSdef_kind_NormalOutcome_309 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSdef_kind_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_307 = ADL__VSdef_kind_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSdef_kind_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_307 = ADL__VSdef_kind_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSdef_kind_ExceptionOutcome_310 && !VSdef_kind_NormalOutcome_309) {
  VSdef_kind_ACF_Result_307 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSdef_kind_ExceptionOutcome_310 && VSdef_kind_NormalOutcome_309) {
  VSdef_kind_ACF_Result_307 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 10,&VSdef_kind_ExceptionOutcome_310);
  ev_314_tmp_332 = ev_314;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 13,&ev_314_tmp_332);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_328 = user_exception_is("NOT_IMPLEMENTED", ev_314);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 12,&tmp_328);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_327 = !tmp_328;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 11,&tmp_327);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_325 = (!VSdef_kind_ExceptionOutcome_310 || tmp_327);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 9,&tmp_325);
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 15,&VSdef_kind_ExceptionOutcome_310);
  ev_314_tmp_340 = ev_314;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 19,&ev_314_tmp_340);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_337 = system_exception(ev_314);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 18,&tmp_337);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_336 = !tmp_337;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 17,&tmp_336);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_335 = tmp_336;
  if (tmp_336) {
      ev_314_tmp_345 = ev_314;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 22,&ev_314_tmp_345);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_342 = user_exception(ev_314);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 21,&tmp_342);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_341 = !tmp_342;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 20,&tmp_341);
    tmp_335 = tmp_341;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 16,&tmp_335);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_333 = (!VSdef_kind_ExceptionOutcome_310 || tmp_335);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 14,&tmp_333);
    ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSdef_kind_NormalOutcome_309){
      ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 25,&VSdef_kind_RtnVal_308);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[24]);

/* Evaluate is_correct_def_kind(return) */
  tmp_348 = is_correct_def_kind(VSdef_kind_RtnVal_308);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 24,&tmp_348);
  groupExpr_351 = (tmp_348);
  tmp_347 = (groupExpr_351);
  tmp_346 = tmp_347;
  }
  else {
    ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 23, 25);
  tmp_346 = 1;
}

  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 23,&tmp_346);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSdef_kind_InfoArray[forLoopIdx_1].level == 0))
        VSdef_kind_ACF_Result_307 = calculate_ACF_result(VSdef_kind_ACF_Result_307, ADL__VSdef_kind_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSdef_kind_assertionReport->value = VSdef_kind_ACF_Result_307;
  ADL__VSdef_kind_assertionReport->parent->openReport(ADL__VSdef_kind_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSdef_kind_assertionReport->emitTest(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1])) {
     ADL__VSdef_kind_assertionReport->exprStart(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
      if(!ADL__VSdef_kind_InfoArray[forLoopIdx_1].testable || !ADL__VSdef_kind_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSdef_kind_assertionReport->emitter);
      else if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].error, ADL__VSdef_kind_assertionReport->emitter);
      else
        ADL__VSdef_kind_InfoArray[forLoopIdx_1].emitFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].value, ADL__VSdef_kind_assertionReport->emitter);
     ADL__VSdef_kind_assertionReport->exprEnd(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSdef_kind_RtnVal_308);
}


VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*) = VSdef_kind;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSdef_kind_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_def_kind(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDefinitionKind }
};


unsigned int ADL__VSdef_kind_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSdef_kind_assertionReport = 0;

/*
 *
 * ACF of VSdescribe
 *
 */
VSDescription_ptr ADL__ACF_VSdescribe (VSEnvironment *ev_360){

VSDescription_ptr VSdescribe_RtnVal_354;
  void *dummyVarName_352;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_371;
  int tmp_373;
  int tmp_374;
  VSEnvironment *ev_360_tmp_378;
    int tmp_379;
  int tmp_381;
  int tmp_382;
  int tmp_383;
  VSEnvironment *ev_360_tmp_386;
  int tmp_387;
  int tmp_388;
  VSEnvironment *ev_360_tmp_391;
    int tmp_392;
  int tmp_393;
  int groupExpr_397;
  int tmp_394;

/* Declare vars for result of normal and exception bindings */
  int VSdescribe_NormalOutcome_355, VSdescribe_ExceptionOutcome_356;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_357;
  VSEnvironment *ev_360_tmp_361;
    int tmp_362;
  int tmp_363;
  VSEnvironment *ev_360_tmp_366;
  int tmp_367;
  VSEnvironment *ev_360_tmp_370;
  enum ADL__ACF_result VSdescribe_ACF_Result_353 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSdescribe_InfoArray, 0, ADL__VSdescribe_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSdescribe_assertionReport->setPhase(ADL__VSdescribe_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdescribe_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSdescribe_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSdescribe_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSdescribe_InfoArray[forLoopIdx_1].error > VSdescribe_ACF_Result_353))
  VSdescribe_ACF_Result_353 = ADL__VSdescribe_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSdescribe_ACF_Result_353 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSdescribe_assertionReport->setPhase(ADL__VSdescribe_assertionReport, PH_call);
  ADL__release(ADL__VSdescribe_assertionReport->parent, &this_seq);
  VSdescribe_RtnVal_354 = ADL__VSdescribe_wrapper(ev_360);
  ADL__recover(ADL__VSdescribe_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSdescribe_assertionReport->setPhase(ADL__VSdescribe_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_360_tmp_361 = ev_360;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 8,&ev_360_tmp_361);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_357 = no_exception(ev_360);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 7,&tmp_357);
  VSdescribe_NormalOutcome_355 = (tmp_357);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_360_tmp_366 = ev_360;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 3,&ev_360_tmp_366);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_363 = system_exception(ev_360);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 2,&tmp_363);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_362 = tmp_363;
  if (!tmp_363) {
      ev_360_tmp_370 = ev_360;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 5,&ev_360_tmp_370);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_367 = user_exception(ev_360);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 4,&tmp_367);
    tmp_362 = tmp_367;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdescribe_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 1,&tmp_362);

  VSdescribe_ExceptionOutcome_356 = (tmp_362);

/* Exception binding is the first assertion */
  if (ADL__VSdescribe_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSdescribe_InfoArray[0].result = (VSdescribe_ExceptionOutcome_356 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdescribe_InfoArray[0].evaluated = 1;
  ADL__VSdescribe_InfoArray[0].value = (VSdescribe_ExceptionOutcome_356 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSdescribe_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSdescribe_InfoArray[6].result = (VSdescribe_NormalOutcome_355 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdescribe_InfoArray[6].evaluated = 1;
  ADL__VSdescribe_InfoArray[6].value = (VSdescribe_NormalOutcome_355 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSdescribe_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSdescribe_ACF_Result_353 = ADL__VSdescribe_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSdescribe_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSdescribe_ACF_Result_353 = ADL__VSdescribe_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSdescribe_ExceptionOutcome_356 && !VSdescribe_NormalOutcome_355) {
  VSdescribe_ACF_Result_353 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSdescribe_ExceptionOutcome_356 && VSdescribe_NormalOutcome_355) {
  VSdescribe_ACF_Result_353 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSdescribe_InfoArray, 10,&VSdescribe_ExceptionOutcome_356);
  ev_360_tmp_378 = ev_360;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 13,&ev_360_tmp_378);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_374 = user_exception_is("NOT_IMPLEMENTED", ev_360);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 12,&tmp_374);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_373 = !tmp_374;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 11,&tmp_373);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_371 = (!VSdescribe_ExceptionOutcome_356 || tmp_373);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 9,&tmp_371);
    ADL__setResultAndError(ADL__VSdescribe_InfoArray, 15,&VSdescribe_ExceptionOutcome_356);
  ev_360_tmp_386 = ev_360;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 19,&ev_360_tmp_386);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_383 = system_exception(ev_360);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 18,&tmp_383);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_382 = !tmp_383;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 17,&tmp_382);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_381 = tmp_382;
  if (tmp_382) {
      ev_360_tmp_391 = ev_360;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 22,&ev_360_tmp_391);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_388 = user_exception(ev_360);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 21,&tmp_388);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_387 = !tmp_388;
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 20,&tmp_387);
    tmp_381 = tmp_387;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdescribe_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 16,&tmp_381);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_379 = (!VSdescribe_ExceptionOutcome_356 || tmp_381);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 14,&tmp_379);
    ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSdescribe_NormalOutcome_355){
      ADL__setResultAndError(ADL__VSdescribe_InfoArray, 25,&VSdescribe_RtnVal_354);
  ADL__VSdescribe_assertionReport->exprMark(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_assertionReport->assrt_info[24]);

/* Evaluate is_correct_description(return) */
  tmp_394 = is_correct_description(VSdescribe_RtnVal_354);
  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 24,&tmp_394);
  groupExpr_397 = (tmp_394);
  tmp_393 = (groupExpr_397);
  tmp_392 = tmp_393;
  }
  else {
    ADL__resetInfoStruct(ADL__VSdescribe_InfoArray, 23, 25);
  tmp_392 = 1;
}

  ADL__setResultAndError(ADL__VSdescribe_InfoArray, 23,&tmp_392);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdescribe_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSdescribe_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSdescribe_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSdescribe_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSdescribe_InfoArray[forLoopIdx_1].level == 0))
        VSdescribe_ACF_Result_353 = calculate_ACF_result(VSdescribe_ACF_Result_353, ADL__VSdescribe_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSdescribe_assertionReport->value = VSdescribe_ACF_Result_353;
  ADL__VSdescribe_assertionReport->parent->openReport(ADL__VSdescribe_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdescribe_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSdescribe_assertionReport->emitTest(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_InfoArray[forLoopIdx_1])) {
     ADL__VSdescribe_assertionReport->exprStart(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_InfoArray[forLoopIdx_1]);
      if(!ADL__VSdescribe_InfoArray[forLoopIdx_1].testable || !ADL__VSdescribe_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSdescribe_assertionReport->emitter);
      else if (ADL__VSdescribe_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSdescribe_InfoArray[forLoopIdx_1].error, ADL__VSdescribe_assertionReport->emitter);
      else
        ADL__VSdescribe_InfoArray[forLoopIdx_1].emitFunc(ADL__VSdescribe_InfoArray[forLoopIdx_1].value, ADL__VSdescribe_assertionReport->emitter);
     ADL__VSdescribe_assertionReport->exprEnd(ADL__VSdescribe_assertionReport, &ADL__VSdescribe_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSdescribe_RtnVal_354);
}


VSDescription_ptr (*ADL__VSdescribe_wrapper)(VSEnvironment*) = VSdescribe;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDescription_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSdescribe_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_description(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDescription_ptr }
};


unsigned int ADL__VSdescribe_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSdescribe_assertionReport = 0;
