/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_exceptiondef_ptr(VSExceptionDef_ptr *);

extern int is_nil_exceptiondef_ptr(VSExceptionDef_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int is_correct_members(VSStructMemberSeq_ptr);

extern int is_correct_type(VSTypeCode_ptr *);

extern int is_same_members(VSStructMemberSeq_ptr, VSStructMemberSeq_ptr);

extern int is_correct_def_kind(VSDefinitionKind);

extern int is_correct_description(VSDescription_ptr);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSStructMemberSeq_ptr)(VSStructMemberSeq_ptr, emitter_t);
extern void (*ADL__print_VSExceptionDef_ptr_P)(VSExceptionDef_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);
extern void (*ADL__print_VSDescription_ptr)(VSDescription_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*);
extern VSStructMemberSeq_ptr (*ADL__VSmembers_read_wrapper)(VSEnvironment*);
extern VSExceptionDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSExceptionDef_ptr *(*ADL__VSduplicate_wrapper)(VSExceptionDef_ptr*, VSEnvironment*);
extern VSExceptionDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern void (*ADL__VSmembers_write_wrapper)(VSStructMemberSeq_ptr const, VSEnvironment*);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);
extern VSDescription_ptr (*ADL__VSdescribe_wrapper)(VSEnvironment*);

#endif
