/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VStype
 *
 */
VSTypeCode_ptr *ADL__ACF_VStype (VSEnvironment *ev_10){

VSTypeCode_ptr *VStype_RtnVal_4;
  void *dummyVarName_155;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_21;
  int tmp_23;
  int tmp_24;
  VSEnvironment *ev_10_tmp_28;
    int tmp_29;
  int tmp_31;
  int tmp_32;
  int tmp_33;
  VSEnvironment *ev_10_tmp_36;
  int tmp_37;
  int tmp_38;
  VSEnvironment *ev_10_tmp_41;
    int tmp_42;
  int tmp_43;
  int groupExpr_47;
  int tmp_44;

/* Declare vars for result of normal and exception bindings */
  int VStype_NormalOutcome_5, VStype_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VStype_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 0, ADL__VStype_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VStype_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VStype_InfoArray[forLoopIdx_1].error > VStype_ACF_Result_3))
  VStype_ACF_Result_3 = ADL__VStype_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VStype_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_call);
  ADL__release(ADL__VStype_assertionReport->parent, &this_seq);
  VStype_RtnVal_4 = ADL__VStype_wrapper(ev_10);
  ADL__recover(ADL__VStype_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 8,&ev_10_tmp_11);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 7,&tmp_7);
  VStype_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 3,&ev_10_tmp_16);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 2,&tmp_13);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 5,&ev_10_tmp_20);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 1,&tmp_12);

  VStype_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VStype_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[0].result = (VStype_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[0].evaluated = 1;
  ADL__VStype_InfoArray[0].value = (VStype_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VStype_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[6].result = (VStype_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[6].evaluated = 1;
  ADL__VStype_InfoArray[6].value = (VStype_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VStype_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_3 = ADL__VStype_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VStype_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_3 = ADL__VStype_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VStype_ExceptionOutcome_6 && !VStype_NormalOutcome_5) {
  VStype_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VStype_ExceptionOutcome_6 && VStype_NormalOutcome_5) {
  VStype_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VStype_InfoArray, 10,&VStype_ExceptionOutcome_6);
  ev_10_tmp_28 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 13,&ev_10_tmp_28);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 12,&tmp_24);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = !tmp_24;
  ADL__setResultAndError(ADL__VStype_InfoArray, 11,&tmp_23);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_21 = (!VStype_ExceptionOutcome_6 || tmp_23);
  ADL__setResultAndError(ADL__VStype_InfoArray, 9,&tmp_21);
    ADL__setResultAndError(ADL__VStype_InfoArray, 15,&VStype_ExceptionOutcome_6);
  ev_10_tmp_36 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 19,&ev_10_tmp_36);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_33 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 18,&tmp_33);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VStype_InfoArray, 17,&tmp_32);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_31 = tmp_32;
  if (tmp_32) {
      ev_10_tmp_41 = ev_10;
  ADL__setResultAndError(ADL__VStype_InfoArray, 22,&ev_10_tmp_41);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_38 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VStype_InfoArray, 21,&tmp_38);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_37 = !tmp_38;
  ADL__setResultAndError(ADL__VStype_InfoArray, 20,&tmp_37);
    tmp_31 = tmp_37;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 16,&tmp_31);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_29 = (!VStype_ExceptionOutcome_6 || tmp_31);
  ADL__setResultAndError(ADL__VStype_InfoArray, 14,&tmp_29);
    ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VStype_NormalOutcome_5){
      ADL__setResultAndError(ADL__VStype_InfoArray, 25,&VStype_RtnVal_4);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[24]);

/* Evaluate is_correct_typecode(return) */
  tmp_44 = is_correct_typecode(VStype_RtnVal_4);
  ADL__setResultAndError(ADL__VStype_InfoArray, 24,&tmp_44);
  groupExpr_47 = (tmp_44);
  tmp_43 = (groupExpr_47);
  tmp_42 = tmp_43;
  }
  else {
    ADL__resetInfoStruct(ADL__VStype_InfoArray, 23, 25);
  tmp_42 = 1;
}

  ADL__setResultAndError(ADL__VStype_InfoArray, 23,&tmp_42);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VStype_InfoArray[forLoopIdx_1].level == 0))
        VStype_ACF_Result_3 = calculate_ACF_result(VStype_ACF_Result_3, ADL__VStype_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VStype_assertionReport->value = VStype_ACF_Result_3;
  ADL__VStype_assertionReport->parent->openReport(ADL__VStype_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VStype_assertionReport->emitTest(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1])) {
     ADL__VStype_assertionReport->exprStart(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
      if(!ADL__VStype_InfoArray[forLoopIdx_1].testable || !ADL__VStype_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VStype_assertionReport->emitter);
      else if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VStype_InfoArray[forLoopIdx_1].error, ADL__VStype_assertionReport->emitter);
      else
        ADL__VStype_InfoArray[forLoopIdx_1].emitFunc(ADL__VStype_InfoArray[forLoopIdx_1].value, ADL__VStype_assertionReport->emitter);
     ADL__VStype_assertionReport->exprEnd(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
    }
  }

  return (VStype_RtnVal_4);
}


VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*) = VStype;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VStype_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_typecode(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P }
};


unsigned int ADL__VStype_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VStype_assertionReport = 0;

/*
 *
 * ACF of VSnil
 *
 */
VSIDLType_ptr *ADL__ACF_VSnil (VSEnvironment *ev_56){

VSIDLType_ptr *VSnil_RtnVal_50;
  void *dummyVarName_155;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_67;
  int tmp_69;
  int tmp_70;
  VSEnvironment *ev_56_tmp_74;
    int tmp_75;
  int tmp_77;
  int tmp_78;
  int tmp_79;
  VSEnvironment *ev_56_tmp_82;
  int tmp_83;
  int tmp_84;
  VSEnvironment *ev_56_tmp_87;
    int tmp_88;
  int tmp_89;
  int groupExpr_98;
  int tmp_91;
  int tmp_92;
  int tmp_95;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_51, VSnil_ExceptionOutcome_52;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_53;
  VSEnvironment *ev_56_tmp_57;
    int tmp_58;
  int tmp_59;
  VSEnvironment *ev_56_tmp_62;
  int tmp_63;
  VSEnvironment *ev_56_tmp_66;
  enum ADL__ACF_result VSnil_ACF_Result_49 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_49))
  VSnil_ACF_Result_49 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_49 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_50 = ADL__VSnil_wrapper(ev_56);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_56_tmp_57 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_56_tmp_57);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_53 = no_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_53);
  VSnil_NormalOutcome_51 = (tmp_53);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_56_tmp_62 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_56_tmp_62);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_59 = system_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_59);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_58 = tmp_59;
  if (!tmp_59) {
      ev_56_tmp_66 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_56_tmp_66);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_63 = user_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_63);
    tmp_58 = tmp_63;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_58);

  VSnil_ExceptionOutcome_52 = (tmp_58);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_52 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_52 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_51 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_51 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_49 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_49 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_52 && !VSnil_NormalOutcome_51) {
  VSnil_ACF_Result_49 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_52 && VSnil_NormalOutcome_51) {
  VSnil_ACF_Result_49 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_52);
  ev_56_tmp_74 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_56_tmp_74);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_70 = user_exception_is("NOT_IMPLEMENTED", ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_70);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_69 = !tmp_70;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_69);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_67 = (!VSnil_ExceptionOutcome_52 || tmp_69);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_67);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_52);
  ev_56_tmp_82 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_56_tmp_82);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_79 = system_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_79);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_78 = !tmp_79;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_78);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_77 = tmp_78;
  if (tmp_78) {
      ev_56_tmp_87 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_56_tmp_87);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_84 = user_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_84);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_83 = !tmp_84;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_83);
    tmp_77 = tmp_83;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_77);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_75 = (!VSnil_ExceptionOutcome_52 || tmp_77);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_75);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_51){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_50);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_idltype_ptr(return) */
  tmp_92 = is_nil_idltype_ptr(VSnil_RtnVal_50);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_92);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_idltype_ptr(return) && cleanup_idltype_ptr(return) */
  tmp_91 = tmp_92;
  if (tmp_92) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_50);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_idltype_ptr(return) */
  tmp_95 = cleanup_idltype_ptr(VSnil_RtnVal_50);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_95);
    tmp_91 = tmp_95;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_91);
  groupExpr_98 = (tmp_91);
  tmp_89 = (groupExpr_98);
  tmp_88 = tmp_89;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_88 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_88);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_49 = calculate_ACF_result(VSnil_ACF_Result_49, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_49;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_50);
}


VSIDLType_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSIDLType_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_idltype_ptr(return) && cleanup_idltype_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_idltype_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_idltype_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSIDLType_ptr *ADL__ACF_VSduplicate (VSIDLType_ptr *o_118, VSEnvironment *ev_107){

VSIDLType_ptr *VSduplicate_RtnVal_101;
  void *dummyVarName_155;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_119;
  int tmp_121;
  int tmp_122;
  VSEnvironment *ev_107_tmp_126;
    int tmp_127;
  int tmp_129;
  int tmp_130;
  int tmp_131;
  VSEnvironment *ev_107_tmp_134;
  int tmp_135;
  int tmp_136;
  VSEnvironment *ev_107_tmp_139;
    int tmp_140;
  int tmp_141;
  int groupExpr_153;
  int groupExpr_154;
  int tmp_142;
  int tmp_143;
  VSIDLType_ptr *o_118_tmp_146;
  int tmp_147;
  int tmp_150;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_102, VSduplicate_ExceptionOutcome_103;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_104;
  VSEnvironment *ev_107_tmp_108;
    int tmp_109;
  int tmp_110;
  VSEnvironment *ev_107_tmp_113;
  int tmp_114;
  VSEnvironment *ev_107_tmp_117;
  enum ADL__ACF_result VSduplicate_ACF_Result_100 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_100))
  VSduplicate_ACF_Result_100 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_100 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_101 = ADL__VSduplicate_wrapper(o_118, ev_107);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_107_tmp_108 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_107_tmp_108);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_104 = no_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_104);
  VSduplicate_NormalOutcome_102 = (tmp_104);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_107_tmp_113 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_107_tmp_113);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_110 = system_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_110);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_109 = tmp_110;
  if (!tmp_110) {
      ev_107_tmp_117 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_107_tmp_117);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_114 = user_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_114);
    tmp_109 = tmp_114;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_109);

  VSduplicate_ExceptionOutcome_103 = (tmp_109);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_103 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_103 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_102 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_102 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_100 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_100 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_103 && !VSduplicate_NormalOutcome_102) {
  VSduplicate_ACF_Result_100 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_103 && VSduplicate_NormalOutcome_102) {
  VSduplicate_ACF_Result_100 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_103);
  ev_107_tmp_126 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_107_tmp_126);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_122 = user_exception_is("NOT_IMPLEMENTED", ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_122);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_121 = !tmp_122;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_121);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_119 = (!VSduplicate_ExceptionOutcome_103 || tmp_121);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_119);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_103);
  ev_107_tmp_134 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&ev_107_tmp_134);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_131 = system_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&tmp_131);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_130 = !tmp_131;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_130);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_129 = tmp_130;
  if (tmp_130) {
      ev_107_tmp_139 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&ev_107_tmp_139);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_136 = user_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_136);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_135 = !tmp_136;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_135);
    tmp_129 = tmp_135;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_129);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_127 = (!VSduplicate_ExceptionOutcome_103 || tmp_129);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_127);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_102){
      o_118_tmp_146 = o_118;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 26,&o_118_tmp_146);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[25]);

/* Evaluate is_nil_idltype_ptr(o) */
  tmp_143 = is_nil_idltype_ptr(o_118);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&tmp_143);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 28,&VSduplicate_RtnVal_101);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[27]);

/* Evaluate is_nil_idltype_ptr(return) */
  tmp_147 = is_nil_idltype_ptr(VSduplicate_RtnVal_101);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 27,&tmp_147);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate is_nil_idltype_ptr(o) --> is_nil_idltype_ptr(return) */
  tmp_142 = (!tmp_143 || tmp_147);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_142);
  groupExpr_153 = (tmp_142);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 30,&VSduplicate_RtnVal_101);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[29]);

/* Evaluate cleanup_idltype_ptr(return) */
  tmp_150 = cleanup_idltype_ptr(VSduplicate_RtnVal_101);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 29,&tmp_150);
  groupExpr_154 = (tmp_150);
  tmp_141 = (groupExpr_153 && groupExpr_154);
  tmp_140 = tmp_141;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 23, 30);
  tmp_140 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&tmp_140);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_100 = calculate_ACF_result(VSduplicate_ACF_Result_100, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_100;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_101);
}


VSIDLType_ptr *(*ADL__VSduplicate_wrapper)(VSIDLType_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSIDLType_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_idltype_ptr(o) --> is_nil_idltype_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_idltype_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr_P },
  {4, 27, 24, 0, 0, "is_nil_idltype_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr_P },
  {5, 29, 23, 0, 0, "cleanup_idltype_ptr(return)", 29, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 31;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSnarrow
 *
 */
VSIDLType_ptr *ADL__ACF_VSnarrow (VSObject_ptr *o_174, VSEnvironment *ev_163){

VSIDLType_ptr *VSnarrow_RtnVal_157;
  void *dummyVarName_155;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_175;
  int tmp_177;
  int tmp_178;
  VSEnvironment *ev_163_tmp_182;
    int tmp_183;
  int tmp_185;
  int tmp_186;
  int tmp_187;
  VSEnvironment *ev_163_tmp_190;
  int tmp_191;
  int tmp_192;
  VSEnvironment *ev_163_tmp_195;
    int tmp_196;
  int tmp_197;
  int groupExpr_212;
  int groupExpr_213;
  int tmp_199;
  int tmp_200;
  int tmp_203;
  VSObject_ptr tmp_205;
  VSObject_ptr *o_174_tmp_207;
  int tmp_209;

/* Declare vars for result of normal and exception bindings */
  int VSnarrow_NormalOutcome_158, VSnarrow_ExceptionOutcome_159;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_160;
  VSEnvironment *ev_163_tmp_164;
    int tmp_165;
  int tmp_166;
  VSEnvironment *ev_163_tmp_169;
  int tmp_170;
  VSEnvironment *ev_163_tmp_173;
  enum ADL__ACF_result VSnarrow_ACF_Result_156 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 0, ADL__VSnarrow_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnarrow_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnarrow_InfoArray[forLoopIdx_1].error > VSnarrow_ACF_Result_156))
  VSnarrow_ACF_Result_156 = ADL__VSnarrow_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnarrow_ACF_Result_156 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_call);
  ADL__release(ADL__VSnarrow_assertionReport->parent, &this_seq);
  VSnarrow_RtnVal_157 = ADL__VSnarrow_wrapper(o_174, ev_163);
  ADL__recover(ADL__VSnarrow_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_163_tmp_164 = ev_163;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 8,&ev_163_tmp_164);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_160 = no_exception(ev_163);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 7,&tmp_160);
  VSnarrow_NormalOutcome_158 = (tmp_160);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_163_tmp_169 = ev_163;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 3,&ev_163_tmp_169);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_166 = system_exception(ev_163);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 2,&tmp_166);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_165 = tmp_166;
  if (!tmp_166) {
      ev_163_tmp_173 = ev_163;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 5,&ev_163_tmp_173);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_170 = user_exception(ev_163);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 4,&tmp_170);
    tmp_165 = tmp_170;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 1,&tmp_165);

  VSnarrow_ExceptionOutcome_159 = (tmp_165);

/* Exception binding is the first assertion */
  if (ADL__VSnarrow_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[0].result = (VSnarrow_ExceptionOutcome_159 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[0].evaluated = 1;
  ADL__VSnarrow_InfoArray[0].value = (VSnarrow_ExceptionOutcome_159 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnarrow_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[6].result = (VSnarrow_NormalOutcome_158 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[6].evaluated = 1;
  ADL__VSnarrow_InfoArray[6].value = (VSnarrow_NormalOutcome_158 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnarrow_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_156 = ADL__VSnarrow_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnarrow_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_156 = ADL__VSnarrow_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnarrow_ExceptionOutcome_159 && !VSnarrow_NormalOutcome_158) {
  VSnarrow_ACF_Result_156 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnarrow_ExceptionOutcome_159 && VSnarrow_NormalOutcome_158) {
  VSnarrow_ACF_Result_156 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 10,&VSnarrow_ExceptionOutcome_159);
  ev_163_tmp_182 = ev_163;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 13,&ev_163_tmp_182);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_178 = user_exception_is("NOT_IMPLEMENTED", ev_163);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 12,&tmp_178);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_177 = !tmp_178;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 11,&tmp_177);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_175 = (!VSnarrow_ExceptionOutcome_159 || tmp_177);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 9,&tmp_175);
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 15,&VSnarrow_ExceptionOutcome_159);
  ev_163_tmp_190 = ev_163;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 19,&ev_163_tmp_190);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_187 = system_exception(ev_163);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 18,&tmp_187);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_186 = !tmp_187;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 17,&tmp_186);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_185 = tmp_186;
  if (tmp_186) {
      ev_163_tmp_195 = ev_163;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 22,&ev_163_tmp_195);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_192 = user_exception(ev_163);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 21,&tmp_192);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_191 = !tmp_192;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 20,&tmp_191);
    tmp_185 = tmp_191;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 16,&tmp_185);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_183 = (!VSnarrow_ExceptionOutcome_159 || tmp_185);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 14,&tmp_183);
    ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnarrow_NormalOutcome_158){
      ADL__setResultAndError(ADL__VSnarrow_InfoArray, 26,&VSnarrow_RtnVal_157);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[25]);

/* Evaluate is_nil_idltype_ptr(return) */
  tmp_200 = is_nil_idltype_ptr(VSnarrow_RtnVal_157);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 25,&tmp_200);
  o_174_tmp_207 = o_174;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 29,&o_174_tmp_207);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[28]);

/* Evaluate *o */
  if (ADL__badPtrDeref("*o",(unsigned int) o_174)) { /* check for invalid ptr reference */
     VSnarrow_ACF_Result_156 = ADL__ACF_ERROR;
     goto REPORT_RESULT;
  };
  tmp_205 = *o_174;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 28,&tmp_205);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[27]);

/* Evaluate is_nil_object(*o) */
  tmp_203 = is_nil_object(tmp_205);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 27,&tmp_203);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[24]);

/* Evaluate is_nil_idltype_ptr(return) <-> is_nil_object(*o) */
  tmp_199 = ((tmp_200? 1 : 0) == (tmp_203? 1 : 0));
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 24,&tmp_199);
  groupExpr_212 = (tmp_199);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 31,&VSnarrow_RtnVal_157);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[30]);

/* Evaluate cleanup_idltype_ptr(return) */
  tmp_209 = cleanup_idltype_ptr(VSnarrow_RtnVal_157);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 30,&tmp_209);
  groupExpr_213 = (tmp_209);
  tmp_197 = (groupExpr_212 && groupExpr_213);
  tmp_196 = tmp_197;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 23, 31);
  tmp_196 = 1;
}

  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 23,&tmp_196);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnarrow_InfoArray[forLoopIdx_1].level == 0))
        VSnarrow_ACF_Result_156 = calculate_ACF_result(VSnarrow_ACF_Result_156, ADL__VSnarrow_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnarrow_assertionReport->value = VSnarrow_ACF_Result_156;
  ADL__VSnarrow_assertionReport->parent->openReport(ADL__VSnarrow_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnarrow_assertionReport->emitTest(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1])) {
     ADL__VSnarrow_assertionReport->exprStart(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnarrow_InfoArray[forLoopIdx_1].testable || !ADL__VSnarrow_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnarrow_assertionReport->emitter);
      else if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].error, ADL__VSnarrow_assertionReport->emitter);
      else
        ADL__VSnarrow_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].value, ADL__VSnarrow_assertionReport->emitter);
     ADL__VSnarrow_assertionReport->exprEnd(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnarrow_RtnVal_157);
}


VSIDLType_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*) = VSnarrow;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSIDLType_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSObject_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_idltype_ptr(return) <-> is_nil_object(*o)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_idltype_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr_P },
  {4, 27, 24, 0, 0, "is_nil_object(*o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "*o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr },
  {4, 29, 28, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {5, 30, 23, 0, 0, "cleanup_idltype_ptr(return)", 30, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 31, 30, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr_P }
};


unsigned int ADL__VSnarrow_InfoArrayIdx = 32;

struct ADL__reportAssertion *ADL__VSnarrow_assertionReport = 0;
