/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/IRObject/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:12  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.5  1997/10/24 11:34:13  kevin
   added tests for write functionality

   Revision 1.4  1997/09/29 11:55:28  kevin
   added CORBA namespace

   Revision 1.3  1997/09/18 17:17:15  kevin
   Sample Repository used in testing IRObject functionality

   Revision 1.2  1997/09/18 12:18:56  kevin
   Checked in before moving to the C-mapping

   Revision 1.1  1997/08/21 14:38:59  kevin
   Tests for the root abstract class IRObject in the IR.

*/

#include <corba_defs.h>

VSIRObject_ptr*
VSnil(VSEnvironment *env);

VSIRObject_ptr*
VSduplicate(VSIRObject_ptr *o, VSEnvironment *env);

VSIRObject_ptr*
VSnarrow(VSObject_ptr *o, VSEnvironment *env);

VSDefinitionKind 
VSdef_kind(VSEnvironment *env);


void 
VSdestroy(VSEnvironment *ev, VSIRObject_ptr vs_irObj_ptr);

