/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSdestroy
 *
 */
void ADL__ACF_VSdestroy (VSEnvironment *ev_10, VSIRObject_ptr irObj_21){

  void *dummyVarName_194;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_22;
  int tmp_24;
  int tmp_25;
  VSEnvironment *ev_10_tmp_29;
    int tmp_30;
  int tmp_32;
  VSEnvironment *ev_10_tmp_36;
    int tmp_37;
  int tmp_38;
  int groupExpr_42;
  int tmp_39;
  int tmp_40;

/* Declare vars for result of normal and exception bindings */
  int VSdestroy_NormalOutcome_5, VSdestroy_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSdestroy_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSdestroy_InfoArray, 0, ADL__VSdestroy_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSdestroy_assertionReport->setPhase(ADL__VSdestroy_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdestroy_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSdestroy_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSdestroy_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSdestroy_InfoArray[forLoopIdx_1].error > VSdestroy_ACF_Result_3))
  VSdestroy_ACF_Result_3 = ADL__VSdestroy_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSdestroy_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSdestroy_assertionReport->setPhase(ADL__VSdestroy_assertionReport, PH_call);
  ADL__release(ADL__VSdestroy_assertionReport->parent, &this_seq);
  ADL__VSdestroy_wrapper(ev_10, irObj_21);
  ADL__recover(ADL__VSdestroy_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSdestroy_assertionReport->setPhase(ADL__VSdestroy_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 7,&tmp_7);
  VSdestroy_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 2,&tmp_13);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdestroy_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 1,&tmp_12);

  VSdestroy_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSdestroy_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSdestroy_InfoArray[0].result = (VSdestroy_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdestroy_InfoArray[0].evaluated = 1;
  ADL__VSdestroy_InfoArray[0].value = (VSdestroy_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSdestroy_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSdestroy_InfoArray[6].result = (VSdestroy_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdestroy_InfoArray[6].evaluated = 1;
  ADL__VSdestroy_InfoArray[6].value = (VSdestroy_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSdestroy_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSdestroy_ACF_Result_3 = ADL__VSdestroy_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSdestroy_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSdestroy_ACF_Result_3 = ADL__VSdestroy_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSdestroy_ExceptionOutcome_6 && !VSdestroy_NormalOutcome_5) {
  VSdestroy_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSdestroy_ExceptionOutcome_6 && VSdestroy_NormalOutcome_5) {
  VSdestroy_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSdestroy_InfoArray, 10,&VSdestroy_ExceptionOutcome_6);
  ev_10_tmp_29 = ev_10;
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 13,&ev_10_tmp_29);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_25 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 12,&tmp_25);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = !tmp_25;
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 11,&tmp_24);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_22 = (!VSdestroy_ExceptionOutcome_6 || tmp_24);
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 9,&tmp_22);
    ADL__setResultAndError(ADL__VSdestroy_InfoArray, 15,&VSdestroy_ExceptionOutcome_6);
  ev_10_tmp_36 = ev_10;
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 17,&ev_10_tmp_36);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[16]);

/* Evaluate system_exception_is("BAD_INV_ORDER", ev) */
  tmp_32 = system_exception_is("BAD_INV_ORDER", ev_10);
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 16,&tmp_32);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[14]);

/* Evaluate exception --> system_exception_is("BAD_INV_ORDER", ev) */
  tmp_30 = (!VSdestroy_ExceptionOutcome_6 || tmp_32);
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 14,&tmp_30);
    ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[18]);

/* Evaluate normally { ... } */
  if(VSdestroy_NormalOutcome_5){
      ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[20]);

/* Evaluate existsTestInterface() */
  tmp_40 = existsTestInterface();
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 20,&tmp_40);
  ADL__VSdestroy_assertionReport->exprMark(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_assertionReport->assrt_info[19]);

/* Evaluate !existsTestInterface() */
  tmp_39 = !tmp_40;
  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 19,&tmp_39);
  groupExpr_42 = (tmp_39);
  tmp_38 = (groupExpr_42);
  tmp_37 = tmp_38;
  }
  else {
    ADL__resetInfoStruct(ADL__VSdestroy_InfoArray, 18, 20);
  tmp_37 = 1;
}

  ADL__setResultAndError(ADL__VSdestroy_InfoArray, 18,&tmp_37);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdestroy_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSdestroy_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSdestroy_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSdestroy_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSdestroy_InfoArray[forLoopIdx_1].level == 0))
        VSdestroy_ACF_Result_3 = calculate_ACF_result(VSdestroy_ACF_Result_3, ADL__VSdestroy_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSdestroy_assertionReport->value = VSdestroy_ACF_Result_3;
  ADL__VSdestroy_assertionReport->parent->openReport(ADL__VSdestroy_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdestroy_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSdestroy_assertionReport->emitTest(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_InfoArray[forLoopIdx_1])) {
     ADL__VSdestroy_assertionReport->exprStart(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_InfoArray[forLoopIdx_1]);
      if(!ADL__VSdestroy_InfoArray[forLoopIdx_1].testable || !ADL__VSdestroy_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSdestroy_assertionReport->emitter);
      else if (ADL__VSdestroy_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSdestroy_InfoArray[forLoopIdx_1].error, ADL__VSdestroy_assertionReport->emitter);
      else
        ADL__VSdestroy_InfoArray[forLoopIdx_1].emitFunc(ADL__VSdestroy_InfoArray[forLoopIdx_1].value, ADL__VSdestroy_assertionReport->emitter);
     ADL__VSdestroy_assertionReport->exprEnd(ADL__VSdestroy_assertionReport, &ADL__VSdestroy_InfoArray[forLoopIdx_1]);
    }
  }

  return;
}


void (*ADL__VSdestroy_wrapper)(VSEnvironment*, VSIRObject_ptr) = VSdestroy;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSIRObject_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSdestroy_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> system_exception_is(\"BAD_INV_ORDER\", ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "system_exception_is(\"BAD_INV_ORDER\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 18, 18, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 19, 18, 0, 0, "!existsTestInterface()", 19, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "existsTestInterface()", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean }
};


unsigned int ADL__VSdestroy_InfoArrayIdx = 21;

struct ADL__reportAssertion *ADL__VSdestroy_assertionReport = 0;

/*
 *
 * ACF of VSdef_kind
 *
 */
VSDefinitionKind ADL__ACF_VSdef_kind (VSEnvironment *ev_51){

VSDefinitionKind VSdef_kind_RtnVal_45;
  void *dummyVarName_194;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_62;
  int tmp_64;
  int tmp_65;
  VSEnvironment *ev_51_tmp_69;
    int tmp_70;
  int tmp_72;
  int tmp_73;
  int tmp_74;
  VSEnvironment *ev_51_tmp_77;
  int tmp_78;
  int tmp_79;
  VSEnvironment *ev_51_tmp_82;
    int tmp_83;
  int tmp_84;
  int groupExpr_88;
  int tmp_85;

/* Declare vars for result of normal and exception bindings */
  int VSdef_kind_NormalOutcome_46, VSdef_kind_ExceptionOutcome_47;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_48;
  VSEnvironment *ev_51_tmp_52;
    int tmp_53;
  int tmp_54;
  VSEnvironment *ev_51_tmp_57;
  int tmp_58;
  VSEnvironment *ev_51_tmp_61;
  enum ADL__ACF_result VSdef_kind_ACF_Result_44 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 0, ADL__VSdef_kind_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > VSdef_kind_ACF_Result_44))
  VSdef_kind_ACF_Result_44 = ADL__VSdef_kind_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSdef_kind_ACF_Result_44 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_call);
  ADL__release(ADL__VSdef_kind_assertionReport->parent, &this_seq);
  VSdef_kind_RtnVal_45 = ADL__VSdef_kind_wrapper(ev_51);
  ADL__recover(ADL__VSdef_kind_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_51_tmp_52 = ev_51;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 8,&ev_51_tmp_52);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_48 = no_exception(ev_51);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 7,&tmp_48);
  VSdef_kind_NormalOutcome_46 = (tmp_48);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_51_tmp_57 = ev_51;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 3,&ev_51_tmp_57);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_54 = system_exception(ev_51);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 2,&tmp_54);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_53 = tmp_54;
  if (!tmp_54) {
      ev_51_tmp_61 = ev_51;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 5,&ev_51_tmp_61);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_58 = user_exception(ev_51);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 4,&tmp_58);
    tmp_53 = tmp_58;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 1,&tmp_53);

  VSdef_kind_ExceptionOutcome_47 = (tmp_53);

/* Exception binding is the first assertion */
  if (ADL__VSdef_kind_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[0].result = (VSdef_kind_ExceptionOutcome_47 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[0].evaluated = 1;
  ADL__VSdef_kind_InfoArray[0].value = (VSdef_kind_ExceptionOutcome_47 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSdef_kind_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[6].result = (VSdef_kind_NormalOutcome_46 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[6].evaluated = 1;
  ADL__VSdef_kind_InfoArray[6].value = (VSdef_kind_NormalOutcome_46 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSdef_kind_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_44 = ADL__VSdef_kind_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSdef_kind_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_44 = ADL__VSdef_kind_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSdef_kind_ExceptionOutcome_47 && !VSdef_kind_NormalOutcome_46) {
  VSdef_kind_ACF_Result_44 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSdef_kind_ExceptionOutcome_47 && VSdef_kind_NormalOutcome_46) {
  VSdef_kind_ACF_Result_44 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 10,&VSdef_kind_ExceptionOutcome_47);
  ev_51_tmp_69 = ev_51;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 13,&ev_51_tmp_69);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_65 = user_exception_is("NOT_IMPLEMENTED", ev_51);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 12,&tmp_65);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_64 = !tmp_65;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 11,&tmp_64);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_62 = (!VSdef_kind_ExceptionOutcome_47 || tmp_64);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 9,&tmp_62);
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 15,&VSdef_kind_ExceptionOutcome_47);
  ev_51_tmp_77 = ev_51;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 19,&ev_51_tmp_77);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_74 = system_exception(ev_51);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 18,&tmp_74);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_73 = !tmp_74;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 17,&tmp_73);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_72 = tmp_73;
  if (tmp_73) {
      ev_51_tmp_82 = ev_51;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 22,&ev_51_tmp_82);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_79 = user_exception(ev_51);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 21,&tmp_79);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_78 = !tmp_79;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 20,&tmp_78);
    tmp_72 = tmp_78;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 16,&tmp_72);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_70 = (!VSdef_kind_ExceptionOutcome_47 || tmp_72);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 14,&tmp_70);
    ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSdef_kind_NormalOutcome_46){
      ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 25,&VSdef_kind_RtnVal_45);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[24]);

/* Evaluate is_correct_def_kind(return) */
  tmp_85 = is_correct_def_kind(VSdef_kind_RtnVal_45);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 24,&tmp_85);
  groupExpr_88 = (tmp_85);
  tmp_84 = (groupExpr_88);
  tmp_83 = tmp_84;
  }
  else {
    ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 23, 25);
  tmp_83 = 1;
}

  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 23,&tmp_83);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSdef_kind_InfoArray[forLoopIdx_1].level == 0))
        VSdef_kind_ACF_Result_44 = calculate_ACF_result(VSdef_kind_ACF_Result_44, ADL__VSdef_kind_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSdef_kind_assertionReport->value = VSdef_kind_ACF_Result_44;
  ADL__VSdef_kind_assertionReport->parent->openReport(ADL__VSdef_kind_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSdef_kind_assertionReport->emitTest(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1])) {
     ADL__VSdef_kind_assertionReport->exprStart(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
      if(!ADL__VSdef_kind_InfoArray[forLoopIdx_1].testable || !ADL__VSdef_kind_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSdef_kind_assertionReport->emitter);
      else if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].error, ADL__VSdef_kind_assertionReport->emitter);
      else
        ADL__VSdef_kind_InfoArray[forLoopIdx_1].emitFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].value, ADL__VSdef_kind_assertionReport->emitter);
     ADL__VSdef_kind_assertionReport->exprEnd(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSdef_kind_RtnVal_45);
}


VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*) = VSdef_kind;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSdef_kind_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_def_kind(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDefinitionKind }
};


unsigned int ADL__VSdef_kind_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSdef_kind_assertionReport = 0;

/*
 *
 * ACF of VSnil
 *
 */
VSIRObject_ptr *ADL__ACF_VSnil (VSEnvironment *ev_97){

VSIRObject_ptr *VSnil_RtnVal_91;
  void *dummyVarName_194;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_108;
  int tmp_110;
  int tmp_111;
  VSEnvironment *ev_97_tmp_115;
    int tmp_116;
  int tmp_118;
  int tmp_119;
  int tmp_120;
  VSEnvironment *ev_97_tmp_123;
  int tmp_124;
  int tmp_125;
  VSEnvironment *ev_97_tmp_128;
    int tmp_129;
  int tmp_130;
  int groupExpr_139;
  int tmp_132;
  int tmp_133;
  int tmp_136;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_92, VSnil_ExceptionOutcome_93;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_94;
  VSEnvironment *ev_97_tmp_98;
    int tmp_99;
  int tmp_100;
  VSEnvironment *ev_97_tmp_103;
  int tmp_104;
  VSEnvironment *ev_97_tmp_107;
  enum ADL__ACF_result VSnil_ACF_Result_90 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_90))
  VSnil_ACF_Result_90 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_90 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_91 = ADL__VSnil_wrapper(ev_97);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_97_tmp_98 = ev_97;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_97_tmp_98);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_94 = no_exception(ev_97);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_94);
  VSnil_NormalOutcome_92 = (tmp_94);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_97_tmp_103 = ev_97;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_97_tmp_103);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_100 = system_exception(ev_97);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_100);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_99 = tmp_100;
  if (!tmp_100) {
      ev_97_tmp_107 = ev_97;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_97_tmp_107);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_104 = user_exception(ev_97);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_104);
    tmp_99 = tmp_104;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_99);

  VSnil_ExceptionOutcome_93 = (tmp_99);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_93 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_93 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_92 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_92 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_90 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_90 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_93 && !VSnil_NormalOutcome_92) {
  VSnil_ACF_Result_90 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_93 && VSnil_NormalOutcome_92) {
  VSnil_ACF_Result_90 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_93);
  ev_97_tmp_115 = ev_97;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_97_tmp_115);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_111 = user_exception_is("NOT_IMPLEMENTED", ev_97);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_111);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_110 = !tmp_111;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_110);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_108 = (!VSnil_ExceptionOutcome_93 || tmp_110);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_108);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_93);
  ev_97_tmp_123 = ev_97;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_97_tmp_123);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_120 = system_exception(ev_97);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_120);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_119 = !tmp_120;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_119);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_118 = tmp_119;
  if (tmp_119) {
      ev_97_tmp_128 = ev_97;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_97_tmp_128);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_125 = user_exception(ev_97);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_125);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_124 = !tmp_125;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_124);
    tmp_118 = tmp_124;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_118);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_116 = (!VSnil_ExceptionOutcome_93 || tmp_118);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_116);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_92){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_91);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_irobject_ptr(return) */
  tmp_133 = is_nil_irobject_ptr(VSnil_RtnVal_91);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_133);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_irobject_ptr(return) && cleanup_irobject_ptr(return) */
  tmp_132 = tmp_133;
  if (tmp_133) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_91);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_irobject_ptr(return) */
  tmp_136 = cleanup_irobject_ptr(VSnil_RtnVal_91);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_136);
    tmp_132 = tmp_136;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_132);
  groupExpr_139 = (tmp_132);
  tmp_130 = (groupExpr_139);
  tmp_129 = tmp_130;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_129 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_129);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_90 = calculate_ACF_result(VSnil_ACF_Result_90, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_90;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_91);
}


VSIRObject_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSIRObject_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_irobject_ptr(return) && cleanup_irobject_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_irobject_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIRObject_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_irobject_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIRObject_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSIRObject_ptr *ADL__ACF_VSduplicate (VSIRObject_ptr *o_159, VSEnvironment *ev_148){

VSIRObject_ptr *VSduplicate_RtnVal_142;
  void *dummyVarName_194;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_160;
  int tmp_162;
  int tmp_163;
  VSEnvironment *ev_148_tmp_167;
    int tmp_168;
  int tmp_170;
  int tmp_171;
  int tmp_172;
  VSEnvironment *ev_148_tmp_175;
  int tmp_176;
  int tmp_177;
  VSEnvironment *ev_148_tmp_180;
    int tmp_181;
  int tmp_182;
  int groupExpr_193;
  int tmp_184;
  int tmp_185;
  VSIRObject_ptr *o_159_tmp_189;
  int tmp_190;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_143, VSduplicate_ExceptionOutcome_144;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_145;
  VSEnvironment *ev_148_tmp_149;
    int tmp_150;
  int tmp_151;
  VSEnvironment *ev_148_tmp_154;
  int tmp_155;
  VSEnvironment *ev_148_tmp_158;
  enum ADL__ACF_result VSduplicate_ACF_Result_141 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_141))
  VSduplicate_ACF_Result_141 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_141 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_142 = ADL__VSduplicate_wrapper(o_159, ev_148);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_148_tmp_149 = ev_148;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_148_tmp_149);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_145 = no_exception(ev_148);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_145);
  VSduplicate_NormalOutcome_143 = (tmp_145);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_148_tmp_154 = ev_148;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_148_tmp_154);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_151 = system_exception(ev_148);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_151);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_150 = tmp_151;
  if (!tmp_151) {
      ev_148_tmp_158 = ev_148;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_148_tmp_158);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_155 = user_exception(ev_148);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_155);
    tmp_150 = tmp_155;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_150);

  VSduplicate_ExceptionOutcome_144 = (tmp_150);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_144 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_144 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_143 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_143 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_141 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_141 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_144 && !VSduplicate_NormalOutcome_143) {
  VSduplicate_ACF_Result_141 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_144 && VSduplicate_NormalOutcome_143) {
  VSduplicate_ACF_Result_141 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_144);
  ev_148_tmp_167 = ev_148;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_148_tmp_167);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_163 = user_exception_is("NOT_IMPLEMENTED", ev_148);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_163);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_162 = !tmp_163;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_162);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_160 = (!VSduplicate_ExceptionOutcome_144 || tmp_162);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_160);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_144);
  ev_148_tmp_175 = ev_148;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&ev_148_tmp_175);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_172 = system_exception(ev_148);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&tmp_172);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_171 = !tmp_172;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_171);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_170 = tmp_171;
  if (tmp_171) {
      ev_148_tmp_180 = ev_148;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&ev_148_tmp_180);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_177 = user_exception(ev_148);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_177);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_176 = !tmp_177;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_176);
    tmp_170 = tmp_176;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_170);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_168 = (!VSduplicate_ExceptionOutcome_144 || tmp_170);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_168);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_143){
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 26,&VSduplicate_RtnVal_142);
  o_159_tmp_189 = o_159;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 27,&o_159_tmp_189);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[25]);

/* Evaluate is_same_irobject_ptr(return, o) */
  tmp_185 = is_same_irobject_ptr(VSduplicate_RtnVal_142, o_159);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&tmp_185);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate is_same_irobject_ptr(return, o) && cleanup_irobject_ptr(return) */
  tmp_184 = tmp_185;
  if (tmp_185) {
      ADL__setResultAndError(ADL__VSduplicate_InfoArray, 29,&VSduplicate_RtnVal_142);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[28]);

/* Evaluate cleanup_irobject_ptr(return) */
  tmp_190 = cleanup_irobject_ptr(VSduplicate_RtnVal_142);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 28,&tmp_190);
    tmp_184 = tmp_190;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 28, 29);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_184);
  groupExpr_193 = (tmp_184);
  tmp_182 = (groupExpr_193);
  tmp_181 = tmp_182;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 23, 29);
  tmp_181 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&tmp_181);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_141 = calculate_ACF_result(VSduplicate_ACF_Result_141, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_141;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_142);
}


VSIRObject_ptr *(*ADL__VSduplicate_wrapper)(VSIRObject_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSIRObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_same_irobject_ptr(return, o) && cleanup_irobject_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_same_irobject_ptr(return, o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIRObject_ptr_P },
  {4, 27, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIRObject_ptr_P },
  {4, 28, 24, 0, 0, "cleanup_irobject_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 29, 28, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIRObject_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 30;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSnarrow
 *
 */
VSIRObject_ptr *ADL__ACF_VSnarrow (VSObject_ptr *o_213, VSEnvironment *ev_202){

VSIRObject_ptr *VSnarrow_RtnVal_196;
  void *dummyVarName_194;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_214;
  int tmp_216;
  int tmp_217;
  VSEnvironment *ev_202_tmp_221;
    int tmp_222;
  int tmp_224;
  int tmp_225;
  int tmp_226;
  VSEnvironment *ev_202_tmp_229;
  int tmp_230;
  int tmp_231;
  VSEnvironment *ev_202_tmp_234;
    int tmp_235;
  int tmp_236;
  int groupExpr_251;
  int groupExpr_252;
  int tmp_238;
  int tmp_239;
  int tmp_242;
  VSObject_ptr tmp_244;
  VSObject_ptr *o_213_tmp_246;
  int tmp_248;

/* Declare vars for result of normal and exception bindings */
  int VSnarrow_NormalOutcome_197, VSnarrow_ExceptionOutcome_198;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_199;
  VSEnvironment *ev_202_tmp_203;
    int tmp_204;
  int tmp_205;
  VSEnvironment *ev_202_tmp_208;
  int tmp_209;
  VSEnvironment *ev_202_tmp_212;
  enum ADL__ACF_result VSnarrow_ACF_Result_195 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 0, ADL__VSnarrow_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnarrow_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnarrow_InfoArray[forLoopIdx_1].error > VSnarrow_ACF_Result_195))
  VSnarrow_ACF_Result_195 = ADL__VSnarrow_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnarrow_ACF_Result_195 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_call);
  ADL__release(ADL__VSnarrow_assertionReport->parent, &this_seq);
  VSnarrow_RtnVal_196 = ADL__VSnarrow_wrapper(o_213, ev_202);
  ADL__recover(ADL__VSnarrow_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_202_tmp_203 = ev_202;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 8,&ev_202_tmp_203);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_199 = no_exception(ev_202);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 7,&tmp_199);
  VSnarrow_NormalOutcome_197 = (tmp_199);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_202_tmp_208 = ev_202;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 3,&ev_202_tmp_208);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_205 = system_exception(ev_202);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 2,&tmp_205);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_204 = tmp_205;
  if (!tmp_205) {
      ev_202_tmp_212 = ev_202;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 5,&ev_202_tmp_212);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_209 = user_exception(ev_202);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 4,&tmp_209);
    tmp_204 = tmp_209;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 1,&tmp_204);

  VSnarrow_ExceptionOutcome_198 = (tmp_204);

/* Exception binding is the first assertion */
  if (ADL__VSnarrow_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[0].result = (VSnarrow_ExceptionOutcome_198 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[0].evaluated = 1;
  ADL__VSnarrow_InfoArray[0].value = (VSnarrow_ExceptionOutcome_198 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnarrow_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[6].result = (VSnarrow_NormalOutcome_197 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[6].evaluated = 1;
  ADL__VSnarrow_InfoArray[6].value = (VSnarrow_NormalOutcome_197 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnarrow_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_195 = ADL__VSnarrow_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnarrow_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_195 = ADL__VSnarrow_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnarrow_ExceptionOutcome_198 && !VSnarrow_NormalOutcome_197) {
  VSnarrow_ACF_Result_195 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnarrow_ExceptionOutcome_198 && VSnarrow_NormalOutcome_197) {
  VSnarrow_ACF_Result_195 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 10,&VSnarrow_ExceptionOutcome_198);
  ev_202_tmp_221 = ev_202;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 13,&ev_202_tmp_221);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_217 = user_exception_is("NOT_IMPLEMENTED", ev_202);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 12,&tmp_217);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_216 = !tmp_217;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 11,&tmp_216);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_214 = (!VSnarrow_ExceptionOutcome_198 || tmp_216);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 9,&tmp_214);
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 15,&VSnarrow_ExceptionOutcome_198);
  ev_202_tmp_229 = ev_202;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 19,&ev_202_tmp_229);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_226 = system_exception(ev_202);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 18,&tmp_226);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_225 = !tmp_226;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 17,&tmp_225);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_224 = tmp_225;
  if (tmp_225) {
      ev_202_tmp_234 = ev_202;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 22,&ev_202_tmp_234);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_231 = user_exception(ev_202);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 21,&tmp_231);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_230 = !tmp_231;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 20,&tmp_230);
    tmp_224 = tmp_230;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 16,&tmp_224);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_222 = (!VSnarrow_ExceptionOutcome_198 || tmp_224);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 14,&tmp_222);
    ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnarrow_NormalOutcome_197){
      ADL__setResultAndError(ADL__VSnarrow_InfoArray, 26,&VSnarrow_RtnVal_196);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[25]);

/* Evaluate is_nil_irobject_ptr(return) */
  tmp_239 = is_nil_irobject_ptr(VSnarrow_RtnVal_196);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 25,&tmp_239);
  o_213_tmp_246 = o_213;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 29,&o_213_tmp_246);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[28]);

/* Evaluate *o */
  if (ADL__badPtrDeref("*o",(unsigned int) o_213)) { /* check for invalid ptr reference */
     VSnarrow_ACF_Result_195 = ADL__ACF_ERROR;
     goto REPORT_RESULT;
  };
  tmp_244 = *o_213;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 28,&tmp_244);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[27]);

/* Evaluate is_nil_object(*o) */
  tmp_242 = is_nil_object(tmp_244);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 27,&tmp_242);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[24]);

/* Evaluate is_nil_irobject_ptr(return) <-> is_nil_object(*o) */
  tmp_238 = ((tmp_239? 1 : 0) == (tmp_242? 1 : 0));
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 24,&tmp_238);
  groupExpr_251 = (tmp_238);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 31,&VSnarrow_RtnVal_196);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[30]);

/* Evaluate cleanup_irobject_ptr(return) */
  tmp_248 = cleanup_irobject_ptr(VSnarrow_RtnVal_196);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 30,&tmp_248);
  groupExpr_252 = (tmp_248);
  tmp_236 = (groupExpr_251 && groupExpr_252);
  tmp_235 = tmp_236;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 23, 31);
  tmp_235 = 1;
}

  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 23,&tmp_235);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnarrow_InfoArray[forLoopIdx_1].level == 0))
        VSnarrow_ACF_Result_195 = calculate_ACF_result(VSnarrow_ACF_Result_195, ADL__VSnarrow_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnarrow_assertionReport->value = VSnarrow_ACF_Result_195;
  ADL__VSnarrow_assertionReport->parent->openReport(ADL__VSnarrow_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnarrow_assertionReport->emitTest(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1])) {
     ADL__VSnarrow_assertionReport->exprStart(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnarrow_InfoArray[forLoopIdx_1].testable || !ADL__VSnarrow_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnarrow_assertionReport->emitter);
      else if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].error, ADL__VSnarrow_assertionReport->emitter);
      else
        ADL__VSnarrow_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].value, ADL__VSnarrow_assertionReport->emitter);
     ADL__VSnarrow_assertionReport->exprEnd(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnarrow_RtnVal_196);
}


VSIRObject_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*) = VSnarrow;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSIRObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSObject_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_irobject_ptr(return) <-> is_nil_object(*o)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_irobject_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIRObject_ptr_P },
  {4, 27, 24, 0, 0, "is_nil_object(*o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "*o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr },
  {4, 29, 28, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {5, 30, 23, 0, 0, "cleanup_irobject_ptr(return)", 30, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 31, 30, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIRObject_ptr_P }
};


unsigned int ADL__VSnarrow_InfoArrayIdx = 32;

struct ADL__reportAssertion *ADL__VSnarrow_assertionReport = 0;
