/* ADL test driver from t1.tdr
 *
 * test VSis_abstract_write(env, abs_intf, abs)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop it */
static struct ADL__propertyValue ADL__prop_values_738[] = {
    {"abstract", Pabs_intf_it_abstract, 0},
    {"not_abstract", Pabs_intf_it_not_abstract, 0},
    {0, 0, 0}
};

/* values for literal variable abs */
static VSBoolean ADL__litvar_val_740[] = {
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_739[] = {
    {"1", 0, ADL__litvar_val_740},
    {"0", 1, ADL__litvar_val_740},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_741[] = {
    {"it", "prop", ADL__prop_values_738, 2},
    {"abs", "litvar", ADL__litvar_info_739, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_745[4] = {
    {"env", "VSEnvironment *", ADL__prop_info_741, 0, 0},
    {"abs_intf", "VSInterfaceDef_ptr", ADL__prop_info_741, 0, 1},
    {"abs", "VSBoolean", ADL__prop_info_741, 1, 1},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSis_abstract_write_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSINTERFACEDEF_PTR
#define ADL__PRINT_VSINTERFACEDEF_PTR
void (*ADL__print_VSInterfaceDef_ptr)(VSInterfaceDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSINTERFACEDEF_PTR */
#ifndef ADL__PRINT_VSINTERFACEDEFSEQ_PTR
#define ADL__PRINT_VSINTERFACEDEFSEQ_PTR
void (*ADL__print_VSInterfaceDefSeq_ptr)(VSInterfaceDefSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSINTERFACEDEFSEQ_PTR */
#ifndef ADL__PRINT_VSREPOSITORYID
#define ADL__PRINT_VSREPOSITORYID
void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t) = 0;

#endif /* ADL__PRINT_VSREPOSITORYID */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSFULLINTERFACEDESCRIPTION_PTR
#define ADL__PRINT_VSFULLINTERFACEDESCRIPTION_PTR
void (*ADL__print_VSFullInterfaceDescription_ptr)(VSFullInterfaceDescription_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSFULLINTERFACEDESCRIPTION_PTR */
#ifndef ADL__PRINT_VSINTERFACEDEF_PTR_P
#define ADL__PRINT_VSINTERFACEDEF_PTR_P
void (*ADL__print_VSInterfaceDef_ptr_P)(VSInterfaceDef_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSINTERFACEDEF_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */
#ifndef ADL__PRINT_VSIDENTIFIER
#define ADL__PRINT_VSIDENTIFIER
void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDENTIFIER */
#ifndef ADL__PRINT_VSVERSIONSPEC
#define ADL__PRINT_VSVERSIONSPEC
void (*ADL__print_VSVersionSpec)(VSVersionSpec, emitter_t) = 0;

#endif /* ADL__PRINT_VSVERSIONSPEC */
#ifndef ADL__PRINT_VSIDLTYPE_PTR
#define ADL__PRINT_VSIDLTYPE_PTR
void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDLTYPE_PTR */
#ifndef ADL__PRINT_VSATTRIBUTEMODE
#define ADL__PRINT_VSATTRIBUTEMODE
void (*ADL__print_VSAttributeMode)(VSAttributeMode, emitter_t) = 0;

#endif /* ADL__PRINT_VSATTRIBUTEMODE */
#ifndef ADL__PRINT_VSATTRIBUTEDEF_PTR
#define ADL__PRINT_VSATTRIBUTEDEF_PTR
void (*ADL__print_VSAttributeDef_ptr)(VSAttributeDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSATTRIBUTEDEF_PTR */
#ifndef ADL__PRINT_VSOPERATIONMODE
#define ADL__PRINT_VSOPERATIONMODE
void (*ADL__print_VSOperationMode)(VSOperationMode, emitter_t) = 0;

#endif /* ADL__PRINT_VSOPERATIONMODE */
#ifndef ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR
#define ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR
void (*ADL__print_VSParDescriptionSeq_ptr)(VSParDescriptionSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR */
#ifndef ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR
#define ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR
void (*ADL__print_VSExceptionDefSeq_ptr)(VSExceptionDefSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR */
#ifndef ADL__PRINT_VSCONTEXTIDSEQ_PTR
#define ADL__PRINT_VSCONTEXTIDSEQ_PTR
void (*ADL__print_VSContextIdSeq_ptr)(VSContextIdSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTEXTIDSEQ_PTR */
#ifndef ADL__PRINT_VSOPERATIONDEF_PTR
#define ADL__PRINT_VSOPERATIONDEF_PTR
void (*ADL__print_VSOperationDef_ptr)(VSOperationDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOPERATIONDEF_PTR */
#ifndef ADL__PRINT_VSDESCRIPTION_PTR
#define ADL__PRINT_VSDESCRIPTION_PTR
void (*ADL__print_VSDescription_ptr)(VSDescription_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSDESCRIPTION_PTR */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSInterfaceDef_ptr (void* val, emitter_t emitter)
{
  VSInterfaceDef_ptr tmp;

  if (ADL__print_VSInterfaceDef_ptr != 0) {
    tmp = *(VSInterfaceDef_ptr*) val;
    ADL__print_VSInterfaceDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSInterfaceDefSeq_ptr (void* val, emitter_t emitter)
{
  VSInterfaceDefSeq_ptr tmp;

  if (ADL__print_VSInterfaceDefSeq_ptr != 0) {
    tmp = *(VSInterfaceDefSeq_ptr*) val;
    ADL__print_VSInterfaceDefSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRepositoryId (void* val, emitter_t emitter)
{
  VSRepositoryId tmp;

  if (ADL__print_VSRepositoryId != 0) {
    tmp = *(VSRepositoryId*) val;
    ADL__print_VSRepositoryId(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSFullInterfaceDescription_ptr (void* val, emitter_t emitter)
{
  VSFullInterfaceDescription_ptr tmp;

  if (ADL__print_VSFullInterfaceDescription_ptr != 0) {
    tmp = *(VSFullInterfaceDescription_ptr*) val;
    ADL__print_VSFullInterfaceDescription_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSInterfaceDef_ptr_P (void* val, emitter_t emitter)
{
  VSInterfaceDef_ptr *tmp;

  if (ADL__print_VSInterfaceDef_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSInterfaceDef_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIdentifier (void* val, emitter_t emitter)
{
  VSIdentifier tmp;

  if (ADL__print_VSIdentifier != 0) {
    tmp = *(VSIdentifier*) val;
    ADL__print_VSIdentifier(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSVersionSpec (void* val, emitter_t emitter)
{
  VSVersionSpec tmp;

  if (ADL__print_VSVersionSpec != 0) {
    tmp = *(VSVersionSpec*) val;
    ADL__print_VSVersionSpec(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter)
{
  VSIDLType_ptr tmp;

  if (ADL__print_VSIDLType_ptr != 0) {
    tmp = *(VSIDLType_ptr*) val;
    ADL__print_VSIDLType_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAttributeMode (void* val, emitter_t emitter)
{
  VSAttributeMode tmp;

  if (ADL__print_VSAttributeMode != 0) {
    tmp = *(VSAttributeMode*) val;
    ADL__print_VSAttributeMode(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSAttributeDef_ptr (void* val, emitter_t emitter)
{
  VSAttributeDef_ptr tmp;

  if (ADL__print_VSAttributeDef_ptr != 0) {
    tmp = *(VSAttributeDef_ptr*) val;
    ADL__print_VSAttributeDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSOperationMode (void* val, emitter_t emitter)
{
  VSOperationMode tmp;

  if (ADL__print_VSOperationMode != 0) {
    tmp = *(VSOperationMode*) val;
    ADL__print_VSOperationMode(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSParDescriptionSeq_ptr (void* val, emitter_t emitter)
{
  VSParDescriptionSeq_ptr tmp;

  if (ADL__print_VSParDescriptionSeq_ptr != 0) {
    tmp = *(VSParDescriptionSeq_ptr*) val;
    ADL__print_VSParDescriptionSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSExceptionDefSeq_ptr (void* val, emitter_t emitter)
{
  VSExceptionDefSeq_ptr tmp;

  if (ADL__print_VSExceptionDefSeq_ptr != 0) {
    tmp = *(VSExceptionDefSeq_ptr*) val;
    ADL__print_VSExceptionDefSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContextIdSeq_ptr (void* val, emitter_t emitter)
{
  VSContextIdSeq_ptr tmp;

  if (ADL__print_VSContextIdSeq_ptr != 0) {
    tmp = *(VSContextIdSeq_ptr*) val;
    ADL__print_VSContextIdSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSOperationDef_ptr (void* val, emitter_t emitter)
{
  VSOperationDef_ptr tmp;

  if (ADL__print_VSOperationDef_ptr != 0) {
    tmp = *(VSOperationDef_ptr*) val;
    ADL__print_VSOperationDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDescription_ptr (void* val, emitter_t emitter)
{
  VSDescription_ptr tmp;

  if (ADL__print_VSDescription_ptr != 0) {
    tmp = *(VSDescription_ptr*) val;
    ADL__print_VSDescription_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSEnvironment *env_742;
    VSInterfaceDef_ptr abs_intf_743;
    VSBoolean abs_744;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSis_abstract_write_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSis_abstract_write_InfoArrayIdx,
        ADL__VSis_abstract_write_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_env(&env_742)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
       ADL__emit_VSEnvironment_P(&env_742, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(0);
       if (!provide_abs_intf(&abs_intf_743, ADL__prop_values_738[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 1);
       ADL__emit_VSInterfaceDef_ptr(&abs_intf_743, rf->variableReport->emitVariable);

       abs_744 = ADL__litvar_val_740[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 2, tvec + 1, 1);
       ADL__emit_VSBoolean(&abs_744, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSis_abstract_write_assertionReport = rf->assertionReport;
       ADL__ACF_VSis_abstract_write(env_742, abs_intf_743, abs_744);
       test_value = ADL__VSis_abstract_write_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
       relvec[2] = 1;	/* relinquish succeeds for abs_744 */
      ADL__set_TDDVarNum(0);
       relvec[1] = relinquish_abs_intf(&abs_intf_743, ADL__prop_values_738[tvec[0]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_env(&env_742);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_745,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSis_abstract_write_head);

    return 0;
}


struct ADL__Directive_info VSis_abstract_write1_info = {
    N_VARS,
    ADL__var_info_745
};

struct ADL__TDD_info ADL__test_info = {
    4,
    &ADL__VSis_abstract_write_InfoArrayIdx,
    ADL__VSis_abstract_write_InfoArray,
    ADL__test_driver,
    "VSis_abstract_write",
    "VSis_abstract_write1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSis_abstract_write1",
    "t1_tr.rif",
    &VSis_abstract_write1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

