/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_interfacedef_ptr(VSInterfaceDef_ptr *);

extern int is_nil_interfacedef_ptr(VSInterfaceDef_ptr *);

extern int is_derived_from(VSRepositoryId iface_id);

extern int correct_base_interface_set(VSInterfaceDefSeq_ptr, VSInterfaceDef_ptr);

extern int contains_base_interface_set(VSInterfaceDefSeq_ptr, char *);

extern int correct_full_description_operations(VSFullInterfaceDescription_ptr);

extern int correct_full_description_attributes(VSFullInterfaceDescription_ptr);

extern int correct_full_description_base_interfaces(VSFullInterfaceDescription_ptr, VSInterfaceDef_ptr);

extern int correct_full_description_type(VSFullInterfaceDescription_ptr, VSInterfaceDef_ptr);

extern int correct_full_description_version(VSFullInterfaceDescription_ptr, VSInterfaceDef_ptr);

extern int correct_full_description_defined_in(VSFullInterfaceDescription_ptr, VSInterfaceDef_ptr);

extern int correct_full_description_id(VSFullInterfaceDescription_ptr, VSInterfaceDef_ptr);

extern int correct_full_description_name(VSFullInterfaceDescription_ptr, VSInterfaceDef_ptr);

extern int contains_operations_seq(VSOpDescriptionSeq_ptr, char *);

extern int contains_attributes_seq(VSAttrDescriptionSeq_ptr, char *);

extern int is_nil_object(VSObject_ptr);

extern int is_correct_base_interfaces(VSInterfaceDefSeq_ptr);

extern int att_defined_in_correct_interface(VSAttributeDef_ptr);

extern int op_defined_in_correct_interface(VSOperationDef_ptr);

extern int is_same_string(VSString s1, VSString s2);

extern int not_existingid(VSRepositoryId);

extern int not_existing_opid(VSRepositoryId);

extern int not_existing_opname(VSIdentifier);

extern int is_correct_description(VSDescription_ptr);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSInterfaceDef_ptr)(VSInterfaceDef_ptr, emitter_t);
extern void (*ADL__print_VSInterfaceDefSeq_ptr)(VSInterfaceDefSeq_ptr, emitter_t);
extern void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSFullInterfaceDescription_ptr)(VSFullInterfaceDescription_ptr, emitter_t);
extern void (*ADL__print_VSInterfaceDef_ptr_P)(VSInterfaceDef_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t);
extern void (*ADL__print_VSVersionSpec)(VSVersionSpec, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSAttributeMode)(VSAttributeMode, emitter_t);
extern void (*ADL__print_VSAttributeDef_ptr)(VSAttributeDef_ptr, emitter_t);
extern void (*ADL__print_VSOperationMode)(VSOperationMode, emitter_t);
extern void (*ADL__print_VSParDescriptionSeq_ptr)(VSParDescriptionSeq_ptr, emitter_t);
extern void (*ADL__print_VSExceptionDefSeq_ptr)(VSExceptionDefSeq_ptr, emitter_t);
extern void (*ADL__print_VSContextIdSeq_ptr)(VSContextIdSeq_ptr, emitter_t);
extern void (*ADL__print_VSOperationDef_ptr)(VSOperationDef_ptr, emitter_t);
extern void (*ADL__print_VSDescription_ptr)(VSDescription_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSInterfaceDefSeq_ptr (*ADL__VSbase_interfaces_read_wrapper)(VSEnvironment*, VSInterfaceDef_ptr);
extern VSBoolean (*ADL__VSis_a_wrapper)(VSRepositoryId const, VSEnvironment*);
extern VSFullInterfaceDescription_ptr (*ADL__VSdescribe_interface_wrapper)(VSEnvironment*, VSInterfaceDef_ptr);
extern VSInterfaceDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSInterfaceDef_ptr *(*ADL__VSduplicate_wrapper)(VSInterfaceDef_ptr*, VSEnvironment*);
extern VSInterfaceDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern void (*ADL__VSbase_interfaces_write_wrapper)(VSInterfaceDefSeq_ptr const, VSEnvironment*);
extern VSAttributeDef_ptr (*ADL__VScreate_attribute_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSAttributeMode, VSEnvironment*);
extern VSOperationDef_ptr (*ADL__VScreate_operation_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, VSOperationMode, VSParDescriptionSeq_ptr const, VSExceptionDefSeq_ptr const, VSContextIdSeq_ptr const, VSEnvironment*);
extern VSDescription_ptr (*ADL__VSdescribe_wrapper)(VSEnvironment*);

#endif
