/*
 * ./t1i_tdi.h
 * generated from t1i.tdi by ADLT
 */
#ifndef T1I_TDI_H
#define T1I_TDI_H 1

#include <adl_reporting.h>
#include "t1_aux.h"

/* ---- global property declarations ---- */
/* ---- test variables and local properties ---- */
enum prop_interface_id_idValue {Pinterface_id_idValue_direct, Pinterface_id_idValue_indirect, Pinterface_id_idValue_same, Pinterface_id_idValue_derived, Pinterface_id_idValue_unrelated, Pinterface_id_idValue_non_interface};
#define PROP_INTERFACE_ID_IDVALUE_SZ 6

/* test variable VSRepositoryId interface_id(prop idValue) */
int provide_interface_id (VSRepositoryId *testvar, enum prop_interface_id_idValue idValue);
int relinquish_interface_id (VSRepositoryId *testvar, enum prop_interface_id_idValue idValue);

enum prop_calling_interface_ciValue {Pcalling_interface_ciValue_base, Pcalling_interface_ciValue_derived_single, Pcalling_interface_ciValue_derived_multiple};
#define PROP_CALLING_INTERFACE_CIVALUE_SZ 3

/* test variable VSInterfaceDef_ptr calling_interface(prop ciValue) */
int provide_calling_interface (VSInterfaceDef_ptr *testvar, enum prop_calling_interface_ciValue ciValue);
int relinquish_calling_interface (VSInterfaceDef_ptr *testvar, enum prop_calling_interface_ciValue ciValue);

enum prop_fulldesc_calling_interface_ciValue {Pfulldesc_calling_interface_ciValue_base};
#define PROP_FULLDESC_CALLING_INTERFACE_CIVALUE_SZ 1

/* test variable VSInterfaceDef_ptr fulldesc_calling_interface(prop ciValue) */
int provide_fulldesc_calling_interface (VSInterfaceDef_ptr *testvar, enum prop_fulldesc_calling_interface_ciValue ciValue);
int relinquish_fulldesc_calling_interface (VSInterfaceDef_ptr *testvar, enum prop_fulldesc_calling_interface_ciValue ciValue);

enum prop_object_ptr_objValue {Pobject_ptr_objValue_valid, Pobject_ptr_objValue_null};
#define PROP_OBJECT_PTR_OBJVALUE_SZ 2

/* test variable VSObject_ptr * object_ptr(prop objValue) */
int provide_object_ptr (void*** testvar, enum prop_object_ptr_objValue objValue);
int relinquish_object_ptr (void*** testvar, enum prop_object_ptr_objValue objValue);

enum prop_interfacedef_ptr_intdefValue {Pinterfacedef_ptr_intdefValue_valid, Pinterfacedef_ptr_intdefValue_null};
#define PROP_INTERFACEDEF_PTR_INTDEFVALUE_SZ 2

/* test variable VSInterfaceDef_ptr * interfacedef_ptr(prop intdefValue) */
int provide_interfacedef_ptr (void*** testvar, enum prop_interfacedef_ptr_intdefValue intdefValue);
int relinquish_interfacedef_ptr (void*** testvar, enum prop_interfacedef_ptr_intdefValue intdefValue);

enum prop_intDefSeq_iDefSeqVal {PintDefSeq_iDefSeqVal_name_conflict, PintDefSeq_iDefSeqVal_no_conflict};
#define PROP_INTDEFSEQ_IDEFSEQVAL_SZ 2

/* test variable VSInterfaceDefSeq_ptr intDefSeq(prop iDefSeqVal) */
int provide_intDefSeq (VSInterfaceDefSeq_ptr *testvar, enum prop_intDefSeq_iDefSeqVal iDefSeqVal);
int relinquish_intDefSeq (VSInterfaceDefSeq_ptr *testvar, enum prop_intDefSeq_iDefSeqVal iDefSeqVal);

enum prop_att_id_atIdVal {Patt_id_atIdVal_exists, Patt_id_atIdVal_not_exists};
#define PROP_ATT_ID_ATIDVAL_SZ 2

/* test variable VSRepositoryId att_id(prop atIdVal) */
int provide_att_id (VSRepositoryId *testvar, enum prop_att_id_atIdVal atIdVal);
int relinquish_att_id (VSRepositoryId *testvar, enum prop_att_id_atIdVal atIdVal);

/* test variable VSIDLType_ptr type() */
int provide_type (VSIDLType_ptr *testvar);
int relinquish_type (VSIDLType_ptr *testvar);

/* test variable VSAttributeMode att_mode() */
int provide_att_mode (VSAttributeMode *testvar);
int relinquish_att_mode (VSAttributeMode *testvar);

enum prop_op_id_opIdVal {Pop_id_opIdVal_not_exists, Pop_id_opIdVal_exists};
#define PROP_OP_ID_OPIDVAL_SZ 2

/* test variable VSRepositoryId op_id(prop opIdVal) */
int provide_op_id (VSRepositoryId *testvar, enum prop_op_id_opIdVal opIdVal);
int relinquish_op_id (VSRepositoryId *testvar, enum prop_op_id_opIdVal opIdVal);

enum prop_op_mode_opModeVal {Pop_mode_opModeVal_oneway, Pop_mode_opModeVal_normal};
#define PROP_OP_MODE_OPMODEVAL_SZ 2

/* test variable VSOperationMode op_mode(prop opModeVal) */
int provide_op_mode (VSOperationMode *testvar, enum prop_op_mode_opModeVal opModeVal);
int relinquish_op_mode (VSOperationMode *testvar, enum prop_op_mode_opModeVal opModeVal);

/* test variable VSParDescriptionSeq_ptr params() */
int provide_params (VSParDescriptionSeq_ptr *testvar);
int relinquish_params (VSParDescriptionSeq_ptr *testvar);

/* test variable VSExceptionDefSeq_ptr exceptions() */
int provide_exceptions (VSExceptionDefSeq_ptr *testvar);
int relinquish_exceptions (VSExceptionDefSeq_ptr *testvar);

/* test variable VSContextIdSeq_ptr contexts() */
int provide_contexts (VSContextIdSeq_ptr *testvar);
int relinquish_contexts (VSContextIdSeq_ptr *testvar);

#endif
