/*
 *
 * t1_acf.h -- generated automatically by ADLT
 *
 * This file contains declarations of Assertion-Checking Functions
 * of module "t1"
 *
 */

#ifndef T1_ACF_H
#define T1_ACF_H

#include <adl_reporting.h>
#include <ADL_Standard.h>
#include "corba_defs_aux.h"
#include "t1_aux.h"
#include "t1.h"


VSTypeCode_ptr *ADL__ACF_VSresult (VSEnvironment *ev_10);
extern VSTypeCode_ptr *(*ADL__VSresult_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSresult_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSresult_InfoArray[];
extern unsigned int ADL__VSresult_InfoArrayIdx;


VSIDLType_ptr ADL__ACF_VSresult_def_read (VSEnvironment *ev_56);
extern VSIDLType_ptr (*ADL__VSresult_def_read_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSresult_def_read_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSresult_def_read_InfoArray[];
extern unsigned int ADL__VSresult_def_read_InfoArrayIdx;


VSParDescriptionSeq_ptr ADL__ACF_VSparams_read (VSEnvironment *ev_102);
extern VSParDescriptionSeq_ptr (*ADL__VSparams_read_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSparams_read_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSparams_read_InfoArray[];
extern unsigned int ADL__VSparams_read_InfoArrayIdx;


VSOperationMode ADL__ACF_VSmode_read (VSEnvironment *ev_152, VSOperationDef_ptr calling_operation_163);
extern VSOperationMode (*ADL__VSmode_read_wrapper)(VSEnvironment*, VSOperationDef_ptr);

extern struct ADL__reportAssertion *ADL__VSmode_read_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSmode_read_InfoArray[];
extern unsigned int ADL__VSmode_read_InfoArrayIdx;


VSContextIdSeq_ptr ADL__ACF_VScontexts_read (VSEnvironment *ev_201);
extern VSContextIdSeq_ptr (*ADL__VScontexts_read_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScontexts_read_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScontexts_read_InfoArray[];
extern unsigned int ADL__VScontexts_read_InfoArrayIdx;


VSExceptionDefSeq_ptr ADL__ACF_VSexceptions_read (VSEnvironment *ev_247);
extern VSExceptionDefSeq_ptr (*ADL__VSexceptions_read_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSexceptions_read_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSexceptions_read_InfoArray[];
extern unsigned int ADL__VSexceptions_read_InfoArrayIdx;


VSOperationDef_ptr *ADL__ACF_VSnil (VSEnvironment *ev_293);
extern VSOperationDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSnil_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSnil_InfoArray[];
extern unsigned int ADL__VSnil_InfoArrayIdx;


VSOperationDef_ptr *ADL__ACF_VSduplicate (VSOperationDef_ptr *o_355, VSEnvironment *ev_344);
extern VSOperationDef_ptr *(*ADL__VSduplicate_wrapper)(VSOperationDef_ptr*, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSduplicate_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[];
extern unsigned int ADL__VSduplicate_InfoArrayIdx;


VSOperationDef_ptr *ADL__ACF_VSnarrow (VSObject_ptr *o_411, VSEnvironment *ev_400);
extern VSOperationDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSnarrow_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[];
extern unsigned int ADL__VSnarrow_InfoArrayIdx;


void ADL__ACF_VSresult_def_write (VSIDLType_ptr const vs_idltype_ptr_470, VSEnvironment *ev_459);
extern void (*ADL__VSresult_def_write_wrapper)(VSIDLType_ptr const, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSresult_def_write_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSresult_def_write_InfoArray[];
extern unsigned int ADL__VSresult_def_write_InfoArrayIdx;


void ADL__ACF_VSparams_write (VSParDescriptionSeq_ptr const vs_params_516, VSEnvironment *ev_505);
extern void (*ADL__VSparams_write_wrapper)(VSParDescriptionSeq_ptr const, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSparams_write_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSparams_write_InfoArray[];
extern unsigned int ADL__VSparams_write_InfoArrayIdx;


void ADL__ACF_VSmode_write (VSOperationMode vs_opmode_562, VSEnvironment *ev_551, VSOperationDef_ptr vs_calling_op_563);
extern void (*ADL__VSmode_write_wrapper)(VSOperationMode, VSEnvironment*, VSOperationDef_ptr);

extern struct ADL__reportAssertion *ADL__VSmode_write_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSmode_write_InfoArray[];
extern unsigned int ADL__VSmode_write_InfoArrayIdx;


void ADL__ACF_VScontexts_write (VSContextIdSeq_ptr const vs_contexts_616, VSEnvironment *ev_605);
extern void (*ADL__VScontexts_write_wrapper)(VSContextIdSeq_ptr const, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScontexts_write_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScontexts_write_InfoArray[];
extern unsigned int ADL__VScontexts_write_InfoArrayIdx;


void ADL__ACF_VSexceptions_write (VSExceptionDefSeq_ptr const vs_exceptions_662, VSEnvironment *ev_651);
extern void (*ADL__VSexceptions_write_wrapper)(VSExceptionDefSeq_ptr const, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSexceptions_write_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSexceptions_write_InfoArray[];
extern unsigned int ADL__VSexceptions_write_InfoArrayIdx;


VSDefinitionKind ADL__ACF_VSdef_kind (VSEnvironment *ev_697);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSdef_kind_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSdef_kind_InfoArray[];
extern unsigned int ADL__VSdef_kind_InfoArrayIdx;


VSDescription_ptr ADL__ACF_VSdescribe (VSEnvironment *ev_743);
extern VSDescription_ptr (*ADL__VSdescribe_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSdescribe_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSdescribe_InfoArray[];
extern unsigned int ADL__VSdescribe_InfoArrayIdx;


#endif
