/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/PrimitiveDef/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:22  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.3  1997/11/26 14:57:43  kevin
   Added write tests and update CORBA scoping.

   Revision 1.2  1997/10/03 12:05:42  kevin
   *** empty log message ***

   Revision 1.1  1997/09/18 17:12:41  kevin
   Tested read functionality bar kind under ORBIX - moving to DAIS

   Revision 1.1  1997/08/21 14:37:03  kevin


*/

#include <corba_defs.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSPrimitiveKind
VSkind(VSEnvironment *ev);

/*------------------------------------------------------*/
VSPrimtiveDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSPrimtiveDef_ptr*
VSduplicate(VSPrimtiveDef_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSPrimtiveDef_ptr*
VSnil(VSEnvironment *ev);

/*------------------------------------------------------*/
/* REDEFINED INTERFACE */
/*------------------------------------------------------*/

VSDefinitionKind 
VSdef_kind(VSEnvironment *ev);

/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev);

