/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_invalid_id(VSString);

extern int is_nil_object(VSObject_ptr);

extern int cleanup_repository_ptr(VSRepository_ptr *);

extern int is_nil_repository_ptr(VSRepository_ptr *);

extern int is_nil_contained_ptr(VSContained_ptr);

extern int is_correct_primitive(VSPrimitiveDef_ptr);

extern int exists_sequence(VSSequenceDef_ptr);

extern int exists_array(VSArrayDef_ptr);

extern int exists_string(VSStringDef_ptr);

extern int zero_val(VSULong);

extern int is_correct_def_kind(VSDefinitionKind);

extern int is_correct_typecode(VSTypeCode_ptr, VSTypeCode_ptr);

extern int exists_wstring(VSWstringDef_ptr);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSContained_ptr)(VSContained_ptr, emitter_t);
extern void (*ADL__print_VSPrimitiveKind)(VSPrimitiveKind, emitter_t);
extern void (*ADL__print_VSPrimitiveDef_ptr)(VSPrimitiveDef_ptr, emitter_t);
extern void (*ADL__print_VSRepository_ptr_P)(VSRepository_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSContained_ptr_P)(VSContained_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSStringDef_ptr)(VSStringDef_ptr, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSSequenceDef_ptr)(VSSequenceDef_ptr, emitter_t);
extern void (*ADL__print_VSArrayDef_ptr)(VSArrayDef_ptr, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr)(VSTypeCode_ptr, emitter_t);
extern void (*ADL__print_VSWstringDef_ptr)(VSWstringDef_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSContained_ptr (*ADL__VSlookup_id_wrapper)(VSRepositoryId const, VSEnvironment*);
extern VSPrimitiveDef_ptr (*ADL__VSget_primitive_wrapper)(VSPrimitiveKind, VSEnvironment*);
extern VSRepository_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSRepository_ptr *(*ADL__VSduplicate_wrapper)(VSRepository_ptr*, VSEnvironment*);
extern VSContained_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSStringDef_ptr (*ADL__VScreate_string_wrapper)(VSULong, VSEnvironment*);
extern VSSequenceDef_ptr (*ADL__VScreate_sequence_wrapper)(VSULong, VSIDLType_ptr const, VSEnvironment*);
extern VSArrayDef_ptr (*ADL__VScreate_array_wrapper)(VSULong, VSIDLType_ptr const, VSEnvironment*);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr (*ADL__VSget_canonical_typecode_wrapper)(VSTypeCode_ptr const, VSEnvironment*);
extern VSWstringDef_ptr (*ADL__VScreate_wstring_wrapper)(VSULong, VSEnvironment*);

#endif
