/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSbound_read
 *
 */
VSULong ADL__ACF_VSbound_read (VSEnvironment *ev_10){

VSULong VSbound_read_RtnVal_4;
  void *dummyVarName_287;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_21;
  int tmp_23;
  int tmp_24;
  VSEnvironment *ev_10_tmp_28;
    int tmp_29;
  int tmp_31;
  int tmp_32;
  int tmp_33;
  VSEnvironment *ev_10_tmp_36;
  int tmp_37;
  int tmp_38;
  VSEnvironment *ev_10_tmp_41;
    int tmp_42;
  int tmp_43;
  int groupExpr_47;
  int tmp_44;

/* Declare vars for result of normal and exception bindings */
  int VSbound_read_NormalOutcome_5, VSbound_read_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSbound_read_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSbound_read_InfoArray, 0, ADL__VSbound_read_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSbound_read_assertionReport->setPhase(ADL__VSbound_read_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSbound_read_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSbound_read_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSbound_read_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSbound_read_InfoArray[forLoopIdx_1].error > VSbound_read_ACF_Result_3))
  VSbound_read_ACF_Result_3 = ADL__VSbound_read_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSbound_read_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSbound_read_assertionReport->setPhase(ADL__VSbound_read_assertionReport, PH_call);
  ADL__release(ADL__VSbound_read_assertionReport->parent, &this_seq);
  VSbound_read_RtnVal_4 = ADL__VSbound_read_wrapper(ev_10);
  ADL__recover(ADL__VSbound_read_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSbound_read_assertionReport->setPhase(ADL__VSbound_read_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 7,&tmp_7);
  VSbound_read_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 2,&tmp_13);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSbound_read_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 1,&tmp_12);

  VSbound_read_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSbound_read_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSbound_read_InfoArray[0].result = (VSbound_read_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSbound_read_InfoArray[0].evaluated = 1;
  ADL__VSbound_read_InfoArray[0].value = (VSbound_read_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSbound_read_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSbound_read_InfoArray[6].result = (VSbound_read_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSbound_read_InfoArray[6].evaluated = 1;
  ADL__VSbound_read_InfoArray[6].value = (VSbound_read_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSbound_read_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSbound_read_ACF_Result_3 = ADL__VSbound_read_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSbound_read_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSbound_read_ACF_Result_3 = ADL__VSbound_read_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSbound_read_ExceptionOutcome_6 && !VSbound_read_NormalOutcome_5) {
  VSbound_read_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSbound_read_ExceptionOutcome_6 && VSbound_read_NormalOutcome_5) {
  VSbound_read_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSbound_read_InfoArray, 10,&VSbound_read_ExceptionOutcome_6);
  ev_10_tmp_28 = ev_10;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 13,&ev_10_tmp_28);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 12,&tmp_24);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = !tmp_24;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 11,&tmp_23);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_21 = (!VSbound_read_ExceptionOutcome_6 || tmp_23);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 9,&tmp_21);
    ADL__setResultAndError(ADL__VSbound_read_InfoArray, 15,&VSbound_read_ExceptionOutcome_6);
  ev_10_tmp_36 = ev_10;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 19,&ev_10_tmp_36);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_33 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 18,&tmp_33);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 17,&tmp_32);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_31 = tmp_32;
  if (tmp_32) {
      ev_10_tmp_41 = ev_10;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 22,&ev_10_tmp_41);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_38 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 21,&tmp_38);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_37 = !tmp_38;
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 20,&tmp_37);
    tmp_31 = tmp_37;
  }
  else {
  ADL__resetInfoStruct(ADL__VSbound_read_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 16,&tmp_31);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_29 = (!VSbound_read_ExceptionOutcome_6 || tmp_31);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 14,&tmp_29);
    ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSbound_read_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSbound_read_InfoArray, 25,&VSbound_read_RtnVal_4);
  ADL__VSbound_read_assertionReport->exprMark(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_assertionReport->assrt_info[24]);

/* Evaluate is_correct_bound(return) */
  tmp_44 = is_correct_bound(VSbound_read_RtnVal_4);
  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 24,&tmp_44);
  groupExpr_47 = (tmp_44);
  tmp_43 = (groupExpr_47);
  tmp_42 = tmp_43;
  }
  else {
    ADL__resetInfoStruct(ADL__VSbound_read_InfoArray, 23, 25);
  tmp_42 = 1;
}

  ADL__setResultAndError(ADL__VSbound_read_InfoArray, 23,&tmp_42);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSbound_read_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSbound_read_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSbound_read_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSbound_read_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSbound_read_InfoArray[forLoopIdx_1].level == 0))
        VSbound_read_ACF_Result_3 = calculate_ACF_result(VSbound_read_ACF_Result_3, ADL__VSbound_read_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSbound_read_assertionReport->value = VSbound_read_ACF_Result_3;
  ADL__VSbound_read_assertionReport->parent->openReport(ADL__VSbound_read_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSbound_read_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSbound_read_assertionReport->emitTest(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_InfoArray[forLoopIdx_1])) {
     ADL__VSbound_read_assertionReport->exprStart(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_InfoArray[forLoopIdx_1]);
      if(!ADL__VSbound_read_InfoArray[forLoopIdx_1].testable || !ADL__VSbound_read_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSbound_read_assertionReport->emitter);
      else if (ADL__VSbound_read_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSbound_read_InfoArray[forLoopIdx_1].error, ADL__VSbound_read_assertionReport->emitter);
      else
        ADL__VSbound_read_InfoArray[forLoopIdx_1].emitFunc(ADL__VSbound_read_InfoArray[forLoopIdx_1].value, ADL__VSbound_read_assertionReport->emitter);
     ADL__VSbound_read_assertionReport->exprEnd(ADL__VSbound_read_assertionReport, &ADL__VSbound_read_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSbound_read_RtnVal_4);
}


VSULong (*ADL__VSbound_read_wrapper)(VSEnvironment*) = VSbound_read;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSULong (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSbound_read_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_bound(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong }
};


unsigned int ADL__VSbound_read_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSbound_read_assertionReport = 0;

/*
 *
 * ACF of VSnil
 *
 */
VSStringDef_ptr *ADL__ACF_VSnil (VSEnvironment *ev_56){

VSStringDef_ptr *VSnil_RtnVal_50;
  void *dummyVarName_287;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_67;
  int tmp_69;
  int tmp_70;
  VSEnvironment *ev_56_tmp_74;
    int tmp_75;
  int tmp_77;
  int tmp_78;
  int tmp_79;
  VSEnvironment *ev_56_tmp_82;
  int tmp_83;
  int tmp_84;
  VSEnvironment *ev_56_tmp_87;
    int tmp_88;
  int tmp_89;
  int groupExpr_98;
  int tmp_91;
  int tmp_92;
  int tmp_95;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_51, VSnil_ExceptionOutcome_52;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_53;
  VSEnvironment *ev_56_tmp_57;
    int tmp_58;
  int tmp_59;
  VSEnvironment *ev_56_tmp_62;
  int tmp_63;
  VSEnvironment *ev_56_tmp_66;
  enum ADL__ACF_result VSnil_ACF_Result_49 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_49))
  VSnil_ACF_Result_49 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_49 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_50 = ADL__VSnil_wrapper(ev_56);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_56_tmp_57 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_56_tmp_57);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_53 = no_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_53);
  VSnil_NormalOutcome_51 = (tmp_53);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_56_tmp_62 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_56_tmp_62);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_59 = system_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_59);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_58 = tmp_59;
  if (!tmp_59) {
      ev_56_tmp_66 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_56_tmp_66);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_63 = user_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_63);
    tmp_58 = tmp_63;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_58);

  VSnil_ExceptionOutcome_52 = (tmp_58);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_52 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_52 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_51 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_51 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_49 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_49 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_52 && !VSnil_NormalOutcome_51) {
  VSnil_ACF_Result_49 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_52 && VSnil_NormalOutcome_51) {
  VSnil_ACF_Result_49 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_52);
  ev_56_tmp_74 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_56_tmp_74);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_70 = user_exception_is("NOT_IMPLEMENTED", ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_70);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_69 = !tmp_70;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_69);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_67 = (!VSnil_ExceptionOutcome_52 || tmp_69);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_67);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_52);
  ev_56_tmp_82 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_56_tmp_82);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_79 = system_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_79);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_78 = !tmp_79;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_78);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_77 = tmp_78;
  if (tmp_78) {
      ev_56_tmp_87 = ev_56;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_56_tmp_87);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_84 = user_exception(ev_56);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_84);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_83 = !tmp_84;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_83);
    tmp_77 = tmp_83;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_77);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_75 = (!VSnil_ExceptionOutcome_52 || tmp_77);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_75);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_51){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_50);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_stringdef_ptr(return) */
  tmp_92 = is_nil_stringdef_ptr(VSnil_RtnVal_50);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_92);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_stringdef_ptr(return) && cleanup_stringdef_ptr(return) */
  tmp_91 = tmp_92;
  if (tmp_92) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_50);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_stringdef_ptr(return) */
  tmp_95 = cleanup_stringdef_ptr(VSnil_RtnVal_50);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_95);
    tmp_91 = tmp_95;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_91);
  groupExpr_98 = (tmp_91);
  tmp_89 = (groupExpr_98);
  tmp_88 = tmp_89;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_88 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_88);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_49 = calculate_ACF_result(VSnil_ACF_Result_49, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_49;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_50);
}


VSStringDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSStringDef_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_stringdef_ptr(return) && cleanup_stringdef_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_stringdef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStringDef_ptr_P },
  {4, 27, 24, 0, 0, "cleanup_stringdef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStringDef_ptr_P }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSStringDef_ptr *ADL__ACF_VSduplicate (VSStringDef_ptr *o_118, VSEnvironment *ev_107){

VSStringDef_ptr *VSduplicate_RtnVal_101;
  void *dummyVarName_287;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_119;
  int tmp_121;
  int tmp_122;
  VSEnvironment *ev_107_tmp_126;
    int tmp_127;
  int tmp_129;
  int tmp_130;
  VSEnvironment *ev_107_tmp_133;
    int tmp_134;
  int tmp_135;
  int groupExpr_147;
  int groupExpr_148;
  int tmp_136;
  int tmp_137;
  VSStringDef_ptr *o_118_tmp_140;
  int tmp_141;
  int tmp_144;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_102, VSduplicate_ExceptionOutcome_103;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_104;
  VSEnvironment *ev_107_tmp_108;
    int tmp_109;
  int tmp_110;
  VSEnvironment *ev_107_tmp_113;
  int tmp_114;
  VSEnvironment *ev_107_tmp_117;
  enum ADL__ACF_result VSduplicate_ACF_Result_100 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_100))
  VSduplicate_ACF_Result_100 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_100 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_101 = ADL__VSduplicate_wrapper(o_118, ev_107);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_107_tmp_108 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_107_tmp_108);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_104 = no_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_104);
  VSduplicate_NormalOutcome_102 = (tmp_104);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_107_tmp_113 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_107_tmp_113);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_110 = system_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_110);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_109 = tmp_110;
  if (!tmp_110) {
      ev_107_tmp_117 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_107_tmp_117);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_114 = user_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_114);
    tmp_109 = tmp_114;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_109);

  VSduplicate_ExceptionOutcome_103 = (tmp_109);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_103 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_103 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_102 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_102 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_100 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_100 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_103 && !VSduplicate_NormalOutcome_102) {
  VSduplicate_ACF_Result_100 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_103 && VSduplicate_NormalOutcome_102) {
  VSduplicate_ACF_Result_100 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_103);
  ev_107_tmp_126 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_107_tmp_126);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_122 = user_exception_is("NOT_IMPLEMENTED", ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_122);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_121 = !tmp_122;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_121);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_119 = (!VSduplicate_ExceptionOutcome_103 || tmp_121);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_119);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_103);
  ev_107_tmp_133 = ev_107;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&ev_107_tmp_133);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_130 = user_exception(ev_107);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_130);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_129 = !tmp_130;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_129);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_127 = (!VSduplicate_ExceptionOutcome_103 || tmp_129);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_127);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_102){
      o_118_tmp_140 = o_118;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&o_118_tmp_140);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate is_nil_stringdef_ptr(o) */
  tmp_137 = is_nil_stringdef_ptr(o_118);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_137);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&VSduplicate_RtnVal_101);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[23]);

/* Evaluate is_nil_stringdef_ptr(return) */
  tmp_141 = is_nil_stringdef_ptr(VSduplicate_RtnVal_101);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&tmp_141);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate is_nil_stringdef_ptr(o) --> is_nil_stringdef_ptr(return) */
  tmp_136 = (!tmp_137 || tmp_141);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_136);
  groupExpr_147 = (tmp_136);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 26,&VSduplicate_RtnVal_101);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[25]);

/* Evaluate cleanup_stringdef_ptr(return) */
  tmp_144 = cleanup_stringdef_ptr(VSduplicate_RtnVal_101);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&tmp_144);
  groupExpr_148 = (tmp_144);
  tmp_135 = (groupExpr_147 && groupExpr_148);
  tmp_134 = tmp_135;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 19, 26);
  tmp_134 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&tmp_134);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_100 = calculate_ACF_result(VSduplicate_ACF_Result_100, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_100;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_101);
}


VSStringDef_ptr *(*ADL__VSduplicate_wrapper)(VSStringDef_ptr*, VSEnvironment*) = VSduplicate;

void ADL__emit_VSStringDef_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_nil_stringdef_ptr(o) --> is_nil_stringdef_ptr(return)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_nil_stringdef_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStringDef_ptr_P },
  {4, 23, 20, 0, 0, "is_nil_stringdef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStringDef_ptr_P },
  {5, 25, 19, 0, 0, "cleanup_stringdef_ptr(return)", 25, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStringDef_ptr_P }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 27;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSnarrow
 *
 */
VSStringDef_ptr *ADL__ACF_VSnarrow (VSObject_ptr *o_168, VSEnvironment *ev_157){

VSStringDef_ptr *VSnarrow_RtnVal_151;
  void *dummyVarName_287;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_169;
  int tmp_171;
  int tmp_172;
  VSEnvironment *ev_157_tmp_176;
    int tmp_177;
  int tmp_179;
  int tmp_180;
  VSEnvironment *ev_157_tmp_183;
    int tmp_184;
  int tmp_185;
  int groupExpr_200;
  int groupExpr_201;
  int tmp_187;
  int tmp_188;
  int tmp_191;
  VSObject_ptr tmp_193;
  VSObject_ptr *o_168_tmp_195;
  int tmp_197;

/* Declare vars for result of normal and exception bindings */
  int VSnarrow_NormalOutcome_152, VSnarrow_ExceptionOutcome_153;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_154;
  VSEnvironment *ev_157_tmp_158;
    int tmp_159;
  int tmp_160;
  VSEnvironment *ev_157_tmp_163;
  int tmp_164;
  VSEnvironment *ev_157_tmp_167;
  enum ADL__ACF_result VSnarrow_ACF_Result_150 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 0, ADL__VSnarrow_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnarrow_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnarrow_InfoArray[forLoopIdx_1].error > VSnarrow_ACF_Result_150))
  VSnarrow_ACF_Result_150 = ADL__VSnarrow_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnarrow_ACF_Result_150 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_call);
  ADL__release(ADL__VSnarrow_assertionReport->parent, &this_seq);
  VSnarrow_RtnVal_151 = ADL__VSnarrow_wrapper(o_168, ev_157);
  ADL__recover(ADL__VSnarrow_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_157_tmp_158 = ev_157;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 8,&ev_157_tmp_158);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_154 = no_exception(ev_157);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 7,&tmp_154);
  VSnarrow_NormalOutcome_152 = (tmp_154);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_157_tmp_163 = ev_157;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 3,&ev_157_tmp_163);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_160 = system_exception(ev_157);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 2,&tmp_160);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_159 = tmp_160;
  if (!tmp_160) {
      ev_157_tmp_167 = ev_157;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 5,&ev_157_tmp_167);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_164 = user_exception(ev_157);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 4,&tmp_164);
    tmp_159 = tmp_164;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 1,&tmp_159);

  VSnarrow_ExceptionOutcome_153 = (tmp_159);

/* Exception binding is the first assertion */
  if (ADL__VSnarrow_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[0].result = (VSnarrow_ExceptionOutcome_153 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[0].evaluated = 1;
  ADL__VSnarrow_InfoArray[0].value = (VSnarrow_ExceptionOutcome_153 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnarrow_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[6].result = (VSnarrow_NormalOutcome_152 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[6].evaluated = 1;
  ADL__VSnarrow_InfoArray[6].value = (VSnarrow_NormalOutcome_152 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnarrow_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_150 = ADL__VSnarrow_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnarrow_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_150 = ADL__VSnarrow_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnarrow_ExceptionOutcome_153 && !VSnarrow_NormalOutcome_152) {
  VSnarrow_ACF_Result_150 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnarrow_ExceptionOutcome_153 && VSnarrow_NormalOutcome_152) {
  VSnarrow_ACF_Result_150 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 10,&VSnarrow_ExceptionOutcome_153);
  ev_157_tmp_176 = ev_157;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 13,&ev_157_tmp_176);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_172 = user_exception_is("NOT_IMPLEMENTED", ev_157);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 12,&tmp_172);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_171 = !tmp_172;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 11,&tmp_171);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_169 = (!VSnarrow_ExceptionOutcome_153 || tmp_171);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 9,&tmp_169);
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 15,&VSnarrow_ExceptionOutcome_153);
  ev_157_tmp_183 = ev_157;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 18,&ev_157_tmp_183);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[17]);

/* Evaluate user_exception(ev) */
  tmp_180 = user_exception(ev_157);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 17,&tmp_180);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[16]);

/* Evaluate !user_exception(ev) */
  tmp_179 = !tmp_180;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 16,&tmp_179);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[14]);

/* Evaluate exception --> !user_exception(ev) */
  tmp_177 = (!VSnarrow_ExceptionOutcome_153 || tmp_179);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 14,&tmp_177);
    ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[19]);

/* Evaluate normally { ... } */
  if(VSnarrow_NormalOutcome_152){
      ADL__setResultAndError(ADL__VSnarrow_InfoArray, 22,&VSnarrow_RtnVal_151);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[21]);

/* Evaluate is_nil_stringdef_ptr(return) */
  tmp_188 = is_nil_stringdef_ptr(VSnarrow_RtnVal_151);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 21,&tmp_188);
  o_168_tmp_195 = o_168;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 25,&o_168_tmp_195);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[24]);

/* Evaluate *o */
  if (ADL__badPtrDeref("*o",(unsigned int) o_168)) { /* check for invalid ptr reference */
     VSnarrow_ACF_Result_150 = ADL__ACF_ERROR;
     goto REPORT_RESULT;
  };
  tmp_193 = *o_168;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 24,&tmp_193);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[23]);

/* Evaluate is_nil_object(*o) */
  tmp_191 = is_nil_object(tmp_193);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 23,&tmp_191);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[20]);

/* Evaluate is_nil_stringdef_ptr(return) <-> is_nil_object(*o) */
  tmp_187 = ((tmp_188? 1 : 0) == (tmp_191? 1 : 0));
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 20,&tmp_187);
  groupExpr_200 = (tmp_187);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 27,&VSnarrow_RtnVal_151);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[26]);

/* Evaluate cleanup_stringdef_ptr(return) */
  tmp_197 = cleanup_stringdef_ptr(VSnarrow_RtnVal_151);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 26,&tmp_197);
  groupExpr_201 = (tmp_197);
  tmp_185 = (groupExpr_200 && groupExpr_201);
  tmp_184 = tmp_185;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 19, 27);
  tmp_184 = 1;
}

  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 19,&tmp_184);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnarrow_InfoArray[forLoopIdx_1].level == 0))
        VSnarrow_ACF_Result_150 = calculate_ACF_result(VSnarrow_ACF_Result_150, ADL__VSnarrow_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnarrow_assertionReport->value = VSnarrow_ACF_Result_150;
  ADL__VSnarrow_assertionReport->parent->openReport(ADL__VSnarrow_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnarrow_assertionReport->emitTest(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1])) {
     ADL__VSnarrow_assertionReport->exprStart(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnarrow_InfoArray[forLoopIdx_1].testable || !ADL__VSnarrow_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnarrow_assertionReport->emitter);
      else if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].error, ADL__VSnarrow_assertionReport->emitter);
      else
        ADL__VSnarrow_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].value, ADL__VSnarrow_assertionReport->emitter);
     ADL__VSnarrow_assertionReport->exprEnd(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnarrow_RtnVal_151);
}


VSStringDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*) = VSnarrow;

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSStringDef_ptr_P (void* val, emitter_t emitter);
void ADL__emit_VSObject_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 19, 19, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 20, 19, 0, 0, "is_nil_stringdef_ptr(return) <-> is_nil_object(*o)", 20, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 21, 20, 0, 0, "is_nil_stringdef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 22, 21, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStringDef_ptr_P },
  {4, 23, 20, 0, 0, "is_nil_object(*o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "*o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr },
  {4, 25, 24, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr_P },
  {5, 26, 19, 0, 0, "cleanup_stringdef_ptr(return)", 26, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 27, 26, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSStringDef_ptr_P }
};


unsigned int ADL__VSnarrow_InfoArrayIdx = 28;

struct ADL__reportAssertion *ADL__VSnarrow_assertionReport = 0;

/*
 *
 * ACF of VSbound_write
 *
 */
void ADL__ACF_VSbound_write (VSULong vs_new_bound_221, VSEnvironment *ev_210){

  void *dummyVarName_287;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_222;
  int tmp_224;
  int tmp_225;
  VSEnvironment *ev_210_tmp_229;
    int tmp_230;
  int tmp_231;
  int groupExpr_240;
  int tmp_232;
  VSULong tmp_234;
  VSEnvironment *ev_210_tmp_237;
  VSULong vs_new_bound_221_tmp_239;

/* Declare vars for result of normal and exception bindings */
  int VSbound_write_NormalOutcome_205, VSbound_write_ExceptionOutcome_206;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_207;
  VSEnvironment *ev_210_tmp_211;
    int tmp_212;
  int tmp_213;
  VSEnvironment *ev_210_tmp_216;
  int tmp_217;
  VSEnvironment *ev_210_tmp_220;
  enum ADL__ACF_result VSbound_write_ACF_Result_203 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSbound_write_InfoArray, 0, ADL__VSbound_write_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSbound_write_assertionReport->setPhase(ADL__VSbound_write_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSbound_write_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSbound_write_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSbound_write_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSbound_write_InfoArray[forLoopIdx_1].error > VSbound_write_ACF_Result_203))
  VSbound_write_ACF_Result_203 = ADL__VSbound_write_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSbound_write_ACF_Result_203 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSbound_write_assertionReport->setPhase(ADL__VSbound_write_assertionReport, PH_call);
  ADL__release(ADL__VSbound_write_assertionReport->parent, &this_seq);
  ADL__VSbound_write_wrapper(vs_new_bound_221, ev_210);
  ADL__recover(ADL__VSbound_write_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSbound_write_assertionReport->setPhase(ADL__VSbound_write_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_210_tmp_211 = ev_210;
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 8,&ev_210_tmp_211);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_207 = no_exception(ev_210);
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 7,&tmp_207);
  VSbound_write_NormalOutcome_205 = (tmp_207);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_210_tmp_216 = ev_210;
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 3,&ev_210_tmp_216);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_213 = system_exception(ev_210);
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 2,&tmp_213);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_212 = tmp_213;
  if (!tmp_213) {
      ev_210_tmp_220 = ev_210;
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 5,&ev_210_tmp_220);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_217 = user_exception(ev_210);
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 4,&tmp_217);
    tmp_212 = tmp_217;
  }
  else {
  ADL__resetInfoStruct(ADL__VSbound_write_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 1,&tmp_212);

  VSbound_write_ExceptionOutcome_206 = (tmp_212);

/* Exception binding is the first assertion */
  if (ADL__VSbound_write_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSbound_write_InfoArray[0].result = (VSbound_write_ExceptionOutcome_206 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSbound_write_InfoArray[0].evaluated = 1;
  ADL__VSbound_write_InfoArray[0].value = (VSbound_write_ExceptionOutcome_206 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSbound_write_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSbound_write_InfoArray[6].result = (VSbound_write_NormalOutcome_205 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSbound_write_InfoArray[6].evaluated = 1;
  ADL__VSbound_write_InfoArray[6].value = (VSbound_write_NormalOutcome_205 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSbound_write_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSbound_write_ACF_Result_203 = ADL__VSbound_write_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSbound_write_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSbound_write_ACF_Result_203 = ADL__VSbound_write_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSbound_write_ExceptionOutcome_206 && !VSbound_write_NormalOutcome_205) {
  VSbound_write_ACF_Result_203 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSbound_write_ExceptionOutcome_206 && VSbound_write_NormalOutcome_205) {
  VSbound_write_ACF_Result_203 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSbound_write_InfoArray, 10,&VSbound_write_ExceptionOutcome_206);
  ev_210_tmp_229 = ev_210;
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 13,&ev_210_tmp_229);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_225 = user_exception_is("NOT_IMPLEMENTED", ev_210);
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 12,&tmp_225);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_224 = !tmp_225;
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 11,&tmp_224);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_222 = (!VSbound_write_ExceptionOutcome_206 || tmp_224);
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 9,&tmp_222);
    ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSbound_write_NormalOutcome_205){
      ev_210_tmp_237 = ev_210;
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 17,&ev_210_tmp_237);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[16]);

/* Evaluate VSbound_read(ev) */
  tmp_234 = VSbound_read(ev_210);
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 16,&tmp_234);
  vs_new_bound_221_tmp_239 = vs_new_bound_221;
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 18,&vs_new_bound_221_tmp_239);
  ADL__VSbound_write_assertionReport->exprMark(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_assertionReport->assrt_info[15]);

/* Evaluate is_correct_new_bound(VSbound_read(ev), vs_new_bound) */
  tmp_232 = is_correct_new_bound(tmp_234, vs_new_bound_221);
  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 15,&tmp_232);
  groupExpr_240 = (tmp_232);
  tmp_231 = (groupExpr_240);
  tmp_230 = tmp_231;
  }
  else {
    ADL__resetInfoStruct(ADL__VSbound_write_InfoArray, 14, 18);
  tmp_230 = 1;
}

  ADL__setResultAndError(ADL__VSbound_write_InfoArray, 14,&tmp_230);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSbound_write_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSbound_write_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSbound_write_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSbound_write_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSbound_write_InfoArray[forLoopIdx_1].level == 0))
        VSbound_write_ACF_Result_203 = calculate_ACF_result(VSbound_write_ACF_Result_203, ADL__VSbound_write_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSbound_write_assertionReport->value = VSbound_write_ACF_Result_203;
  ADL__VSbound_write_assertionReport->parent->openReport(ADL__VSbound_write_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSbound_write_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSbound_write_assertionReport->emitTest(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_InfoArray[forLoopIdx_1])) {
     ADL__VSbound_write_assertionReport->exprStart(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_InfoArray[forLoopIdx_1]);
      if(!ADL__VSbound_write_InfoArray[forLoopIdx_1].testable || !ADL__VSbound_write_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSbound_write_assertionReport->emitter);
      else if (ADL__VSbound_write_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSbound_write_InfoArray[forLoopIdx_1].error, ADL__VSbound_write_assertionReport->emitter);
      else
        ADL__VSbound_write_InfoArray[forLoopIdx_1].emitFunc(ADL__VSbound_write_InfoArray[forLoopIdx_1].value, ADL__VSbound_write_assertionReport->emitter);
     ADL__VSbound_write_assertionReport->exprEnd(ADL__VSbound_write_assertionReport, &ADL__VSbound_write_InfoArray[forLoopIdx_1]);
    }
  }

  return;
}


void (*ADL__VSbound_write_wrapper)(VSULong, VSEnvironment*) = VSbound_write;

void ADL__emit_VSULong (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSbound_write_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "is_correct_new_bound(VSbound_read(ev), vs_new_bound)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "VSbound_read(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong },
  {3, 17, 16, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 18, 15, 0, 0, "vs_new_bound", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSULong }
};


unsigned int ADL__VSbound_write_InfoArrayIdx = 19;

struct ADL__reportAssertion *ADL__VSbound_write_assertionReport = 0;

/*
 *
 * ACF of VSdef_kind
 *
 */
VSDefinitionKind ADL__ACF_VSdef_kind (VSEnvironment *ev_249){

VSDefinitionKind VSdef_kind_RtnVal_243;
  void *dummyVarName_287;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_260;
  int tmp_262;
  int tmp_263;
  VSEnvironment *ev_249_tmp_267;
    int tmp_268;
  int tmp_270;
  int tmp_271;
  int tmp_272;
  VSEnvironment *ev_249_tmp_275;
  int tmp_276;
  int tmp_277;
  VSEnvironment *ev_249_tmp_280;
    int tmp_281;
  int tmp_282;
  int groupExpr_286;
  int tmp_283;

/* Declare vars for result of normal and exception bindings */
  int VSdef_kind_NormalOutcome_244, VSdef_kind_ExceptionOutcome_245;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_246;
  VSEnvironment *ev_249_tmp_250;
    int tmp_251;
  int tmp_252;
  VSEnvironment *ev_249_tmp_255;
  int tmp_256;
  VSEnvironment *ev_249_tmp_259;
  enum ADL__ACF_result VSdef_kind_ACF_Result_242 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 0, ADL__VSdef_kind_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > VSdef_kind_ACF_Result_242))
  VSdef_kind_ACF_Result_242 = ADL__VSdef_kind_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSdef_kind_ACF_Result_242 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_call);
  ADL__release(ADL__VSdef_kind_assertionReport->parent, &this_seq);
  VSdef_kind_RtnVal_243 = ADL__VSdef_kind_wrapper(ev_249);
  ADL__recover(ADL__VSdef_kind_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_249_tmp_250 = ev_249;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 8,&ev_249_tmp_250);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_246 = no_exception(ev_249);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 7,&tmp_246);
  VSdef_kind_NormalOutcome_244 = (tmp_246);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_249_tmp_255 = ev_249;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 3,&ev_249_tmp_255);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_252 = system_exception(ev_249);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 2,&tmp_252);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_251 = tmp_252;
  if (!tmp_252) {
      ev_249_tmp_259 = ev_249;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 5,&ev_249_tmp_259);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_256 = user_exception(ev_249);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 4,&tmp_256);
    tmp_251 = tmp_256;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 1,&tmp_251);

  VSdef_kind_ExceptionOutcome_245 = (tmp_251);

/* Exception binding is the first assertion */
  if (ADL__VSdef_kind_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[0].result = (VSdef_kind_ExceptionOutcome_245 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[0].evaluated = 1;
  ADL__VSdef_kind_InfoArray[0].value = (VSdef_kind_ExceptionOutcome_245 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSdef_kind_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[6].result = (VSdef_kind_NormalOutcome_244 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[6].evaluated = 1;
  ADL__VSdef_kind_InfoArray[6].value = (VSdef_kind_NormalOutcome_244 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSdef_kind_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_242 = ADL__VSdef_kind_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSdef_kind_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_242 = ADL__VSdef_kind_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSdef_kind_ExceptionOutcome_245 && !VSdef_kind_NormalOutcome_244) {
  VSdef_kind_ACF_Result_242 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSdef_kind_ExceptionOutcome_245 && VSdef_kind_NormalOutcome_244) {
  VSdef_kind_ACF_Result_242 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 10,&VSdef_kind_ExceptionOutcome_245);
  ev_249_tmp_267 = ev_249;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 13,&ev_249_tmp_267);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_263 = user_exception_is("NOT_IMPLEMENTED", ev_249);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 12,&tmp_263);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_262 = !tmp_263;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 11,&tmp_262);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_260 = (!VSdef_kind_ExceptionOutcome_245 || tmp_262);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 9,&tmp_260);
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 15,&VSdef_kind_ExceptionOutcome_245);
  ev_249_tmp_275 = ev_249;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 19,&ev_249_tmp_275);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_272 = system_exception(ev_249);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 18,&tmp_272);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_271 = !tmp_272;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 17,&tmp_271);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_270 = tmp_271;
  if (tmp_271) {
      ev_249_tmp_280 = ev_249;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 22,&ev_249_tmp_280);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_277 = user_exception(ev_249);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 21,&tmp_277);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_276 = !tmp_277;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 20,&tmp_276);
    tmp_270 = tmp_276;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 16,&tmp_270);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_268 = (!VSdef_kind_ExceptionOutcome_245 || tmp_270);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 14,&tmp_268);
    ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSdef_kind_NormalOutcome_244){
      ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 25,&VSdef_kind_RtnVal_243);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[24]);

/* Evaluate is_correct_def_kind(return) */
  tmp_283 = is_correct_def_kind(VSdef_kind_RtnVal_243);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 24,&tmp_283);
  groupExpr_286 = (tmp_283);
  tmp_282 = (groupExpr_286);
  tmp_281 = tmp_282;
  }
  else {
    ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 23, 25);
  tmp_281 = 1;
}

  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 23,&tmp_281);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSdef_kind_InfoArray[forLoopIdx_1].level == 0))
        VSdef_kind_ACF_Result_242 = calculate_ACF_result(VSdef_kind_ACF_Result_242, ADL__VSdef_kind_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSdef_kind_assertionReport->value = VSdef_kind_ACF_Result_242;
  ADL__VSdef_kind_assertionReport->parent->openReport(ADL__VSdef_kind_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSdef_kind_assertionReport->emitTest(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1])) {
     ADL__VSdef_kind_assertionReport->exprStart(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
      if(!ADL__VSdef_kind_InfoArray[forLoopIdx_1].testable || !ADL__VSdef_kind_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSdef_kind_assertionReport->emitter);
      else if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].error, ADL__VSdef_kind_assertionReport->emitter);
      else
        ADL__VSdef_kind_InfoArray[forLoopIdx_1].emitFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].value, ADL__VSdef_kind_assertionReport->emitter);
     ADL__VSdef_kind_assertionReport->exprEnd(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSdef_kind_RtnVal_243);
}


VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*) = VSdef_kind;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSdef_kind_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_def_kind(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDefinitionKind }
};


unsigned int ADL__VSdef_kind_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSdef_kind_assertionReport = 0;

/*
 *
 * ACF of VStype
 *
 */
VSTypeCode_ptr *ADL__ACF_VStype (VSEnvironment *ev_295){

VSTypeCode_ptr *VStype_RtnVal_289;
  void *dummyVarName_287;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_306;
  int tmp_308;
  int tmp_309;
  VSEnvironment *ev_295_tmp_313;
    int tmp_314;
  int tmp_316;
  int tmp_317;
  int tmp_318;
  VSEnvironment *ev_295_tmp_321;
  int tmp_322;
  int tmp_323;
  VSEnvironment *ev_295_tmp_326;
    int tmp_327;
  int tmp_328;
  int groupExpr_332;
  int tmp_329;

/* Declare vars for result of normal and exception bindings */
  int VStype_NormalOutcome_290, VStype_ExceptionOutcome_291;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_292;
  VSEnvironment *ev_295_tmp_296;
    int tmp_297;
  int tmp_298;
  VSEnvironment *ev_295_tmp_301;
  int tmp_302;
  VSEnvironment *ev_295_tmp_305;
  enum ADL__ACF_result VStype_ACF_Result_288 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 0, ADL__VStype_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VStype_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VStype_InfoArray[forLoopIdx_1].error > VStype_ACF_Result_288))
  VStype_ACF_Result_288 = ADL__VStype_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VStype_ACF_Result_288 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_call);
  ADL__release(ADL__VStype_assertionReport->parent, &this_seq);
  VStype_RtnVal_289 = ADL__VStype_wrapper(ev_295);
  ADL__recover(ADL__VStype_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_295_tmp_296 = ev_295;
  ADL__setResultAndError(ADL__VStype_InfoArray, 8,&ev_295_tmp_296);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_292 = no_exception(ev_295);
  ADL__setResultAndError(ADL__VStype_InfoArray, 7,&tmp_292);
  VStype_NormalOutcome_290 = (tmp_292);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_295_tmp_301 = ev_295;
  ADL__setResultAndError(ADL__VStype_InfoArray, 3,&ev_295_tmp_301);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_298 = system_exception(ev_295);
  ADL__setResultAndError(ADL__VStype_InfoArray, 2,&tmp_298);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_297 = tmp_298;
  if (!tmp_298) {
      ev_295_tmp_305 = ev_295;
  ADL__setResultAndError(ADL__VStype_InfoArray, 5,&ev_295_tmp_305);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_302 = user_exception(ev_295);
  ADL__setResultAndError(ADL__VStype_InfoArray, 4,&tmp_302);
    tmp_297 = tmp_302;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 1,&tmp_297);

  VStype_ExceptionOutcome_291 = (tmp_297);

/* Exception binding is the first assertion */
  if (ADL__VStype_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[0].result = (VStype_ExceptionOutcome_291 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[0].evaluated = 1;
  ADL__VStype_InfoArray[0].value = (VStype_ExceptionOutcome_291 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VStype_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[6].result = (VStype_NormalOutcome_290 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[6].evaluated = 1;
  ADL__VStype_InfoArray[6].value = (VStype_NormalOutcome_290 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VStype_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_288 = ADL__VStype_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VStype_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_288 = ADL__VStype_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VStype_ExceptionOutcome_291 && !VStype_NormalOutcome_290) {
  VStype_ACF_Result_288 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VStype_ExceptionOutcome_291 && VStype_NormalOutcome_290) {
  VStype_ACF_Result_288 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VStype_InfoArray, 10,&VStype_ExceptionOutcome_291);
  ev_295_tmp_313 = ev_295;
  ADL__setResultAndError(ADL__VStype_InfoArray, 13,&ev_295_tmp_313);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_309 = user_exception_is("NOT_IMPLEMENTED", ev_295);
  ADL__setResultAndError(ADL__VStype_InfoArray, 12,&tmp_309);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_308 = !tmp_309;
  ADL__setResultAndError(ADL__VStype_InfoArray, 11,&tmp_308);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_306 = (!VStype_ExceptionOutcome_291 || tmp_308);
  ADL__setResultAndError(ADL__VStype_InfoArray, 9,&tmp_306);
    ADL__setResultAndError(ADL__VStype_InfoArray, 15,&VStype_ExceptionOutcome_291);
  ev_295_tmp_321 = ev_295;
  ADL__setResultAndError(ADL__VStype_InfoArray, 19,&ev_295_tmp_321);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_318 = system_exception(ev_295);
  ADL__setResultAndError(ADL__VStype_InfoArray, 18,&tmp_318);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_317 = !tmp_318;
  ADL__setResultAndError(ADL__VStype_InfoArray, 17,&tmp_317);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_316 = tmp_317;
  if (tmp_317) {
      ev_295_tmp_326 = ev_295;
  ADL__setResultAndError(ADL__VStype_InfoArray, 22,&ev_295_tmp_326);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_323 = user_exception(ev_295);
  ADL__setResultAndError(ADL__VStype_InfoArray, 21,&tmp_323);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_322 = !tmp_323;
  ADL__setResultAndError(ADL__VStype_InfoArray, 20,&tmp_322);
    tmp_316 = tmp_322;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 16,&tmp_316);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_314 = (!VStype_ExceptionOutcome_291 || tmp_316);
  ADL__setResultAndError(ADL__VStype_InfoArray, 14,&tmp_314);
    ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VStype_NormalOutcome_290){
      ADL__setResultAndError(ADL__VStype_InfoArray, 25,&VStype_RtnVal_289);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[24]);

/* Evaluate is_correct_typecode(return) */
  tmp_329 = is_correct_typecode(VStype_RtnVal_289);
  ADL__setResultAndError(ADL__VStype_InfoArray, 24,&tmp_329);
  groupExpr_332 = (tmp_329);
  tmp_328 = (groupExpr_332);
  tmp_327 = tmp_328;
  }
  else {
    ADL__resetInfoStruct(ADL__VStype_InfoArray, 23, 25);
  tmp_327 = 1;
}

  ADL__setResultAndError(ADL__VStype_InfoArray, 23,&tmp_327);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VStype_InfoArray[forLoopIdx_1].level == 0))
        VStype_ACF_Result_288 = calculate_ACF_result(VStype_ACF_Result_288, ADL__VStype_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VStype_assertionReport->value = VStype_ACF_Result_288;
  ADL__VStype_assertionReport->parent->openReport(ADL__VStype_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VStype_assertionReport->emitTest(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1])) {
     ADL__VStype_assertionReport->exprStart(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
      if(!ADL__VStype_InfoArray[forLoopIdx_1].testable || !ADL__VStype_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VStype_assertionReport->emitter);
      else if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VStype_InfoArray[forLoopIdx_1].error, ADL__VStype_assertionReport->emitter);
      else
        ADL__VStype_InfoArray[forLoopIdx_1].emitFunc(ADL__VStype_InfoArray[forLoopIdx_1].value, ADL__VStype_assertionReport->emitter);
     ADL__VStype_assertionReport->exprEnd(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
    }
  }

  return (VStype_RtnVal_289);
}


VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*) = VStype;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VStype_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_typecode(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr_P }
};


unsigned int ADL__VStype_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VStype_assertionReport = 0;
