/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/IR/UnionDef/t1.h
  
   Purpose:
  
   Modifications:
	 $Log: t1.h,v $
	 Revision 1.1.1.1  2000/02/09 17:14:34  mli
	 Imported TOG's VSOrb 1.1.1
	
	 Revision 1.5  1997/11/26 14:58:52  kevin
	 Added write tests and update CORBA scoping.

	 Revision 1.4  1997/10/24 14:15:49  kevin
	 *** empty log message ***



*/

#include <corba_defs.h>

/*------------------------------------------------------*/
/* READ INTERFACE */
/*------------------------------------------------------*/

VSTypeCode_ptr*
VSdiscriminator_type(VSEnvironment *ev);

/*------------------------------------------------------*/
VSIDLType_ptr
VSdiscriminator_type_def_read(VSEnvironment *ev);

/*------------------------------------------------------*/
VSUnionMemberSeq_ptr
VSmembers_read(VSEnvironment *ev);

/*------------------------------------------------------*/
VSUnionDef_ptr*
VSnarrow(VSObject_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSUnionDef_ptr*
VSduplicate(VSUnionDef_ptr *o1, VSEnvironment *ev);

/*------------------------------------------------------*/
VSUnionDef_ptr*
VSnil(VSEnvironment *ev);

/*------------------------------------------------------*/
/* WRITE INTERFACE */
/*------------------------------------------------------*/

void
VSdiscriminator_type_def_write(const VSIDLType_ptr vs_idltype_ptr, VSEnvironment *ev);

/*------------------------------------------------------*/
void
VSmembers_write(const VSUnionMemberSeq_ptr vs_members, VSEnvironment *ev);

/*------------------------------------------------------*/
/* REDEFINED INTERFACE */
/*------------------------------------------------------*/

VSDefinitionKind 
VSdef_kind(VSEnvironment *ev);

/*------------------------------------------------------*/
VSTypeCode_ptr*
VStype(VSEnvironment *ev);

