/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_uniondef_ptr(VSUnionDef_ptr *);

extern int is_nil_uniondef_ptr(VSUnionDef_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int is_correct_members(VSUnionMemberSeq_ptr);

extern int is_correct_discriminator_type_def(VSIDLType_ptr);

extern int is_correct_discriminator_type(VSTypeCode_ptr *);

extern int is_same_members(VSUnionMemberSeq_ptr, VSUnionMemberSeq_ptr);

extern int is_same_type_def(VSIDLType_ptr, VSIDLType_ptr);

extern int is_correct_def_kind(VSDefinitionKind);

extern int is_correct_typecode(VSTypeCode_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSUnionMemberSeq_ptr)(VSUnionMemberSeq_ptr, emitter_t);
extern void (*ADL__print_VSUnionDef_ptr_P)(VSUnionDef_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);

/* Declarations of wrapper of FUT */
extern VSTypeCode_ptr *(*ADL__VSdiscriminator_type_wrapper)(VSEnvironment*);
extern VSIDLType_ptr (*ADL__VSdiscriminator_type_def_read_wrapper)(VSEnvironment*);
extern VSUnionMemberSeq_ptr (*ADL__VSmembers_read_wrapper)(VSEnvironment*);
extern VSUnionDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSUnionDef_ptr *(*ADL__VSduplicate_wrapper)(VSUnionDef_ptr*, VSEnvironment*);
extern VSUnionDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern void (*ADL__VSdiscriminator_type_def_write_wrapper)(VSIDLType_ptr const, VSEnvironment*);
extern void (*ADL__VSmembers_write_wrapper)(VSUnionMemberSeq_ptr const, VSEnvironment*);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*);

#endif
