/* ADL test driver from t1.tdr
 *
 * test VSoriginal_type_def_write(o_tc, valueboxdef_ptr, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop tc */
static struct ADL__propertyValue ADL__prop_values_377[] = {
    {"same", Po_tc_tc_same, 0},
    {"diff", Po_tc_tc_diff, 0},
    {0, 0, 0}
};

/* values for prop valueboxValue */
static struct ADL__propertyValue ADL__prop_values_378[] = {
    {"valid", Pvalueboxdef_ptr_valueboxValue_valid, 0},
    {"null", Pvalueboxdef_ptr_valueboxValue_null, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_379[] = {
    {"tc", "prop", ADL__prop_values_377, 2},
    {"valueboxValue", "prop", ADL__prop_values_378, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 2

static struct ADL__variableInfo ADL__var_info_383[4] = {
    {"o_tc", "VSIDLType_ptr", ADL__prop_info_379, 0, 1},
    {"valueboxdef_ptr", "VSValueBoxDef_ptr *", ADL__prop_info_379, 1, 1},
    {"env", "VSEnvironment *", ADL__prop_info_379, 2, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 3


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSoriginal_type_def_write_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSVALUEBOXDEF_PTR_P
#define ADL__PRINT_VSVALUEBOXDEF_PTR_P
void (*ADL__print_VSValueBoxDef_ptr_P)(VSValueBoxDef_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEBOXDEF_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */
#ifndef ADL__PRINT_VSDEFINITIONKIND
#define ADL__PRINT_VSDEFINITIONKIND
void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t) = 0;

#endif /* ADL__PRINT_VSDEFINITIONKIND */
#ifndef ADL__PRINT_VSTYPECODE_PTR_P
#define ADL__PRINT_VSTYPECODE_PTR_P
void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR_P */
#ifndef ADL__PRINT_VSIDLTYPE_PTR
#define ADL__PRINT_VSIDLTYPE_PTR
void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDLTYPE_PTR */
#ifndef ADL__PRINT_VSVALUEBOXDEF_PTR
#define ADL__PRINT_VSVALUEBOXDEF_PTR
void (*ADL__print_VSValueBoxDef_ptr)(VSValueBoxDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEBOXDEF_PTR */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSValueBoxDef_ptr_P (void* val, emitter_t emitter)
{
  VSValueBoxDef_ptr *tmp;

  if (ADL__print_VSValueBoxDef_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSValueBoxDef_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter)
{
  VSDefinitionKind tmp;

  if (ADL__print_VSDefinitionKind != 0) {
    tmp = *(VSDefinitionKind*) val;
    ADL__print_VSDefinitionKind(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter)
{
  VSTypeCode_ptr *tmp;

  if (ADL__print_VSTypeCode_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSTypeCode_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter)
{
  VSIDLType_ptr tmp;

  if (ADL__print_VSIDLType_ptr != 0) {
    tmp = *(VSIDLType_ptr*) val;
    ADL__print_VSIDLType_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSValueBoxDef_ptr (void* val, emitter_t emitter)
{
  VSValueBoxDef_ptr tmp;

  if (ADL__print_VSValueBoxDef_ptr != 0) {
    tmp = *(VSValueBoxDef_ptr*) val;
    ADL__print_VSValueBoxDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSIDLType_ptr o_tc_380;
    VSValueBoxDef_ptr *valueboxdef_ptr_381;
    VSEnvironment *env_382;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSoriginal_type_def_write_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSoriginal_type_def_write_InfoArrayIdx,
        ADL__VSoriginal_type_def_write_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_o_tc(&o_tc_380, ADL__prop_values_377[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSIDLType_ptr(&o_tc_380, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_valueboxdef_ptr(&valueboxdef_ptr_381, ADL__prop_values_378[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSValueBoxDef_ptr_P(&valueboxdef_ptr_381, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(2);
       if (!provide_env(&env_382)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_2;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 2, tvec + 2, 0);
       ADL__emit_VSEnvironment_P(&env_382, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSoriginal_type_def_write_assertionReport = rf->assertionReport;
       ADL__ACF_VSoriginal_type_def_write(o_tc_380, valueboxdef_ptr_381, env_382);
       test_value = ADL__VSoriginal_type_def_write_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(2);
       relvec[2] = relinquish_env(&env_382);
SKIP_2:
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_valueboxdef_ptr(&valueboxdef_ptr_381, ADL__prop_values_378[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_o_tc(&o_tc_380, ADL__prop_values_377[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_383,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSoriginal_type_def_write_head);

    return 0;
}


struct ADL__Directive_info VSoriginal_type_def_write1_info = {
    N_VARS,
    ADL__var_info_383
};

struct ADL__TDD_info ADL__test_info = {
    4,
    &ADL__VSoriginal_type_def_write_InfoArrayIdx,
    ADL__VSoriginal_type_def_write_InfoArray,
    ADL__test_driver,
    "VSoriginal_type_def_write",
    "VSoriginal_type_def_write1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSoriginal_type_def_write1",
    "t1_tr.rif",
    &VSoriginal_type_def_write1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

