/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_valueboxdef_ptr(VSValueBoxDef_ptr *);

extern int is_nil_valueboxdef_ptr(VSValueBoxDef_ptr *);

extern int is_nil_object(VSObject_ptr);

extern int is_correct_def_kind(VSDefinitionKind);

extern int is_correct_typecode(VSTypeCode_ptr *);

extern int is_correct_orig_typecode(VSIDLType_ptr);

extern int equal_typecode(VSIDLType_ptr, VSValueBoxDef_ptr *);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSValueBoxDef_ptr_P)(VSValueBoxDef_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSDefinitionKind)(VSDefinitionKind, emitter_t);
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSValueBoxDef_ptr)(VSValueBoxDef_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSValueBoxDef_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSValueBoxDef_ptr *(*ADL__VSduplicate_wrapper)(VSValueBoxDef_ptr*, VSEnvironment*);
extern VSValueBoxDef_ptr *(*ADL__VSnarrow_wrapper)(VSObject_ptr*, VSEnvironment*);
extern VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VStype_wrapper)(VSEnvironment*);
extern VSIDLType_ptr (*ADL__VSoriginal_type_def_read_wrapper)(VSValueBoxDef_ptr*, VSEnvironment*);
extern void (*ADL__VSoriginal_type_def_write_wrapper)(VSIDLType_ptr, VSValueBoxDef_ptr*, VSEnvironment*);

#endif
