/* ADL test driver from t1.tdr
 *
 * test VScreate_value_member(vl_id, vl_name, vs_version, vl_type, access, c_vdef, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop a */
static struct ADL__propertyValue ADL__prop_values_1056[] = {
    {"exist", Pvl_id_a_exist, 0},
    {"non_exist", Pvl_id_a_non_exist, 0},
    {0, 0, 0}
};

/* values for prop b */
static struct ADL__propertyValue ADL__prop_values_1057[] = {
    {"exist", Pvl_name_b_exist, 0},
    {"non_exist", Pvl_name_b_non_exist, 0},
    {0, 0, 0}
};

/* values for literal variable vs_version */
static VSVersionSpec ADL__litvar_val_1059[] = {
    "1.0",
};

static struct ADL__propertyValue ADL__litvar_info_1058[] = {
    {"\"1.0\"", 0, ADL__litvar_val_1059},
    {0, 0, 0}
};

/* values for literal variable access */
static VSVisibility ADL__litvar_val_1061[] = {
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_1060[] = {
    {"1", 0, ADL__litvar_val_1061},
    {"0", 1, ADL__litvar_val_1061},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_1062[] = {
    {"a", "prop", ADL__prop_values_1056, 2},
    {"b", "prop", ADL__prop_values_1057, 2},
    {"vs_version", "litvar", ADL__litvar_info_1058, 1},
    {"access", "litvar", ADL__litvar_info_1060, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 4

static struct ADL__variableInfo ADL__var_info_1070[8] = {
    {"vl_id", "VSRepositoryId", ADL__prop_info_1062, 0, 1},
    {"vl_name", "VSIdentifier", ADL__prop_info_1062, 1, 1},
    {"vs_version", "VSVersionSpec", ADL__prop_info_1062, 2, 1},
    {"vl_type", "VSIDLType_ptr", ADL__prop_info_1062, 3, 0},
    {"access", "VSVisibility", ADL__prop_info_1062, 3, 1},
    {"c_vdef", "VSValueDef_ptr", ADL__prop_info_1062, 4, 0},
    {"env", "VSEnvironment *", ADL__prop_info_1062, 4, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 7


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScreate_value_member_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSVALUEDEF_PTR
#define ADL__PRINT_VSVALUEDEF_PTR
void (*ADL__print_VSValueDef_ptr)(VSValueDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEDEF_PTR */
#ifndef ADL__PRINT_VSOBJECT_PTR
#define ADL__PRINT_VSOBJECT_PTR
void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR */
#ifndef ADL__PRINT_VSINTERFACEDEFSEQ_PTR
#define ADL__PRINT_VSINTERFACEDEFSEQ_PTR
void (*ADL__print_VSInterfaceDefSeq_ptr)(VSInterfaceDefSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSINTERFACEDEFSEQ_PTR */
#ifndef ADL__PRINT_VSINITIALIZERSEQ_PTR
#define ADL__PRINT_VSINITIALIZERSEQ_PTR
void (*ADL__print_VSInitializerSeq_ptr)(VSInitializerSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSINITIALIZERSEQ_PTR */
#ifndef ADL__PRINT_VSVALUEDEFSEQ_PTR
#define ADL__PRINT_VSVALUEDEFSEQ_PTR
void (*ADL__print_VSValueDefSeq_ptr)(VSValueDefSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEDEFSEQ_PTR */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSREPOSITORYID
#define ADL__PRINT_VSREPOSITORYID
void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t) = 0;

#endif /* ADL__PRINT_VSREPOSITORYID */
#ifndef ADL__PRINT_VSFULLVALUEDESCRIPTION_PTR
#define ADL__PRINT_VSFULLVALUEDESCRIPTION_PTR
void (*ADL__print_VSFullValueDescription_ptr)(VSFullValueDescription_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSFULLVALUEDESCRIPTION_PTR */
#ifndef ADL__PRINT_VSIDENTIFIER
#define ADL__PRINT_VSIDENTIFIER
void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDENTIFIER */
#ifndef ADL__PRINT_VSVERSIONSPEC
#define ADL__PRINT_VSVERSIONSPEC
void (*ADL__print_VSVersionSpec)(VSVersionSpec, emitter_t) = 0;

#endif /* ADL__PRINT_VSVERSIONSPEC */
#ifndef ADL__PRINT_VSIDLTYPE_PTR
#define ADL__PRINT_VSIDLTYPE_PTR
void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDLTYPE_PTR */
#ifndef ADL__PRINT_VSVISIBILITY
#define ADL__PRINT_VSVISIBILITY
void (*ADL__print_VSVisibility)(VSVisibility, emitter_t) = 0;

#endif /* ADL__PRINT_VSVISIBILITY */
#ifndef ADL__PRINT_VSVALUEMEMBERDEF_PTR
#define ADL__PRINT_VSVALUEMEMBERDEF_PTR
void (*ADL__print_VSValueMemberDef_ptr)(VSValueMemberDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSVALUEMEMBERDEF_PTR */
#ifndef ADL__PRINT_VSATTRIBUTEMODE
#define ADL__PRINT_VSATTRIBUTEMODE
void (*ADL__print_VSAttributeMode)(VSAttributeMode, emitter_t) = 0;

#endif /* ADL__PRINT_VSATTRIBUTEMODE */
#ifndef ADL__PRINT_VSATTRIBUTEDEF_PTR
#define ADL__PRINT_VSATTRIBUTEDEF_PTR
void (*ADL__print_VSAttributeDef_ptr)(VSAttributeDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSATTRIBUTEDEF_PTR */
#ifndef ADL__PRINT_VSOPERATIONMODE
#define ADL__PRINT_VSOPERATIONMODE
void (*ADL__print_VSOperationMode)(VSOperationMode, emitter_t) = 0;

#endif /* ADL__PRINT_VSOPERATIONMODE */
#ifndef ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR
#define ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR
void (*ADL__print_VSParDescriptionSeq_ptr)(VSParDescriptionSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSPARDESCRIPTIONSEQ_PTR */
#ifndef ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR
#define ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR
void (*ADL__print_VSExceptionDefSeq_ptr)(VSExceptionDefSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSEXCEPTIONDEFSEQ_PTR */
#ifndef ADL__PRINT_VSCONTEXTIDSEQ_PTR
#define ADL__PRINT_VSCONTEXTIDSEQ_PTR
void (*ADL__print_VSContextIdSeq_ptr)(VSContextIdSeq_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTEXTIDSEQ_PTR */
#ifndef ADL__PRINT_VSOPERATIONDEF_PTR
#define ADL__PRINT_VSOPERATIONDEF_PTR
void (*ADL__print_VSOperationDef_ptr)(VSOperationDef_ptr, emitter_t) = 0;

#endif /* ADL__PRINT_VSOPERATIONDEF_PTR */

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSValueDef_ptr (void* val, emitter_t emitter)
{
  VSValueDef_ptr tmp;

  if (ADL__print_VSValueDef_ptr != 0) {
    tmp = *(VSValueDef_ptr*) val;
    ADL__print_VSValueDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter)
{
  VSObject_ptr tmp;

  if (ADL__print_VSObject_ptr != 0) {
    tmp = *(VSObject_ptr*) val;
    ADL__print_VSObject_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSInterfaceDefSeq_ptr (void* val, emitter_t emitter)
{
  VSInterfaceDefSeq_ptr tmp;

  if (ADL__print_VSInterfaceDefSeq_ptr != 0) {
    tmp = *(VSInterfaceDefSeq_ptr*) val;
    ADL__print_VSInterfaceDefSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSInitializerSeq_ptr (void* val, emitter_t emitter)
{
  VSInitializerSeq_ptr tmp;

  if (ADL__print_VSInitializerSeq_ptr != 0) {
    tmp = *(VSInitializerSeq_ptr*) val;
    ADL__print_VSInitializerSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSValueDefSeq_ptr (void* val, emitter_t emitter)
{
  VSValueDefSeq_ptr tmp;

  if (ADL__print_VSValueDefSeq_ptr != 0) {
    tmp = *(VSValueDefSeq_ptr*) val;
    ADL__print_VSValueDefSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSRepositoryId (void* val, emitter_t emitter)
{
  VSRepositoryId tmp;

  if (ADL__print_VSRepositoryId != 0) {
    tmp = *(VSRepositoryId*) val;
    ADL__print_VSRepositoryId(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSFullValueDescription_ptr (void* val, emitter_t emitter)
{
  VSFullValueDescription_ptr tmp;

  if (ADL__print_VSFullValueDescription_ptr != 0) {
    tmp = *(VSFullValueDescription_ptr*) val;
    ADL__print_VSFullValueDescription_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIdentifier (void* val, emitter_t emitter)
{
  VSIdentifier tmp;

  if (ADL__print_VSIdentifier != 0) {
    tmp = *(VSIdentifier*) val;
    ADL__print_VSIdentifier(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSVersionSpec (void* val, emitter_t emitter)
{
  VSVersionSpec tmp;

  if (ADL__print_VSVersionSpec != 0) {
    tmp = *(VSVersionSpec*) val;
    ADL__print_VSVersionSpec(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter)
{
  VSIDLType_ptr tmp;

  if (ADL__print_VSIDLType_ptr != 0) {
    tmp = *(VSIDLType_ptr*) val;
    ADL__print_VSIDLType_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSVisibility (void* val, emitter_t emitter)
{
  VSVisibility tmp;

  if (ADL__print_VSVisibility != 0) {
    tmp = *(VSVisibility*) val;
    ADL__print_VSVisibility(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter)
{
  VSValueMemberDef_ptr tmp;

  if (ADL__print_VSValueMemberDef_ptr != 0) {
    tmp = *(VSValueMemberDef_ptr*) val;
    ADL__print_VSValueMemberDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAttributeMode (void* val, emitter_t emitter)
{
  VSAttributeMode tmp;

  if (ADL__print_VSAttributeMode != 0) {
    tmp = *(VSAttributeMode*) val;
    ADL__print_VSAttributeMode(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSAttributeDef_ptr (void* val, emitter_t emitter)
{
  VSAttributeDef_ptr tmp;

  if (ADL__print_VSAttributeDef_ptr != 0) {
    tmp = *(VSAttributeDef_ptr*) val;
    ADL__print_VSAttributeDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSOperationMode (void* val, emitter_t emitter)
{
  VSOperationMode tmp;

  if (ADL__print_VSOperationMode != 0) {
    tmp = *(VSOperationMode*) val;
    ADL__print_VSOperationMode(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSParDescriptionSeq_ptr (void* val, emitter_t emitter)
{
  VSParDescriptionSeq_ptr tmp;

  if (ADL__print_VSParDescriptionSeq_ptr != 0) {
    tmp = *(VSParDescriptionSeq_ptr*) val;
    ADL__print_VSParDescriptionSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSExceptionDefSeq_ptr (void* val, emitter_t emitter)
{
  VSExceptionDefSeq_ptr tmp;

  if (ADL__print_VSExceptionDefSeq_ptr != 0) {
    tmp = *(VSExceptionDefSeq_ptr*) val;
    ADL__print_VSExceptionDefSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContextIdSeq_ptr (void* val, emitter_t emitter)
{
  VSContextIdSeq_ptr tmp;

  if (ADL__print_VSContextIdSeq_ptr != 0) {
    tmp = *(VSContextIdSeq_ptr*) val;
    ADL__print_VSContextIdSeq_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSOperationDef_ptr (void* val, emitter_t emitter)
{
  VSOperationDef_ptr tmp;

  if (ADL__print_VSOperationDef_ptr != 0) {
    tmp = *(VSOperationDef_ptr*) val;
    ADL__print_VSOperationDef_ptr(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2, 2, 1, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSRepositoryId vl_id_1063;
    VSIdentifier vl_name_1064;
    VSVersionSpec vs_version_1065;
    VSIDLType_ptr vl_type_1066;
    VSVisibility access_1067;
    VSValueDef_ptr c_vdef_1068;
    VSEnvironment *env_1069;
    VSValueMemberDef_ptr fut_return_1055;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScreate_value_member_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScreate_value_member_InfoArrayIdx,
        ADL__VScreate_value_member_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_vl_id(&vl_id_1063, ADL__prop_values_1056[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSRepositoryId(&vl_id_1063, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_vl_name(&vl_name_1064, ADL__prop_values_1057[tvec[1]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 1);
       ADL__emit_VSIdentifier(&vl_name_1064, rf->variableReport->emitVariable);

       vs_version_1065 = ADL__litvar_val_1059[tvec[2]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 2, tvec + 2, 1);
       ADL__emit_VSVersionSpec(&vs_version_1065, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_vl_type(&vl_type_1066)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
       ADL__emit_VSIDLType_ptr(&vl_type_1066, rf->variableReport->emitVariable);

       access_1067 = ADL__litvar_val_1061[tvec[3]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 4, tvec + 3, 1);
       ADL__emit_VSVisibility(&access_1067, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(4);
       if (!provide_c_vdef(&c_vdef_1068)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 5, tvec + 4, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_5;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 5, tvec + 4, 0);
       ADL__emit_VSValueDef_ptr(&c_vdef_1068, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(4);
       if (!provide_env(&env_1069)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 6, tvec + 4, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_6;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 6, tvec + 4, 0);
       ADL__emit_VSEnvironment_P(&env_1069, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScreate_value_member_assertionReport = rf->assertionReport;
       fut_return_1055 = ADL__ACF_VScreate_value_member(vl_id_1063, vl_name_1064, vs_version_1065, vl_type_1066, access_1067, c_vdef_1068, env_1069);
       test_value = ADL__VScreate_value_member_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(4);
       relvec[6] = relinquish_env(&env_1069);
SKIP_6:
      ADL__set_TDDVarNum(4);
       relvec[5] = relinquish_c_vdef(&c_vdef_1068);
SKIP_5:
       relvec[4] = 1;	/* relinquish succeeds for access_1067 */
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_vl_type(&vl_type_1066);
SKIP_3:
       relvec[2] = 1;	/* relinquish succeeds for vs_version_1065 */
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_vl_name(&vl_name_1064, ADL__prop_values_1057[tvec[1]].propValCode);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_vl_id(&vl_id_1063, ADL__prop_values_1056[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_1070,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScreate_value_member_head);

    return 0;
}


struct ADL__Directive_info VScreate_value_member1_info = {
    N_VARS,
    ADL__var_info_1070
};

struct ADL__TDD_info ADL__test_info = {
    8,
    &ADL__VScreate_value_member_InfoArrayIdx,
    ADL__VScreate_value_member_InfoArray,
    ADL__test_driver,
    "VScreate_value_member",
    "VScreate_value_member1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScreate_value_member1",
    "t1_tr.rif",
    &VScreate_value_member1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

