/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int cleanup_valuedef_ptr(VSValueDef_ptr);

extern int is_nil_valuedef_ptr(VSValueDef_ptr);

extern int is_nil_object(VSObject_ptr);

extern int correct_supported_interfaces(VSInterfaceDefSeq_ptr);

extern int correct_supported_interfaces_set(VSInterfaceDefSeq_ptr, VSValueDef_ptr);

extern int correct_initializers(VSInitializerSeq_ptr);

extern int correct_initializers_set(VSInitializerSeq_ptr, VSValueDef_ptr);

extern int correct_base_value(VSValueDef_ptr);

extern int correct_base_value_set(VSValueDef_ptr, VSValueDef_ptr);

extern int correct_abstract_base_values(VSValueDefSeq_ptr);

extern int correct_abstract_base_values_set(VSValueDefSeq_ptr, VSValueDef_ptr);

extern int is_abstract(VSValueDef_ptr);

extern int is_abstract_set(VSBoolean, VSValueDef_ptr);

extern int is_custom(VSValueDef_ptr);

extern int is_custom_set(VSBoolean, VSValueDef_ptr);

extern int is_truncatable(VSValueDef_ptr);

extern int is_truncatable_set(VSBoolean, VSValueDef_ptr);

extern int is_derived_from(VSRepositoryId);

extern int correct_full_description(VSFullValueDescription_ptr);

extern int id_exists(VSRepositoryId);

extern int name_exists(VSIdentifier);

extern int correct_vmem_defined_in(VSValueMemberDef_ptr);

extern int correct_att_defined_in(VSAttributeDef_ptr);

extern int correct_op_defined_in(VSOperationDef_ptr);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSValueDef_ptr)(VSValueDef_ptr, emitter_t);
extern void (*ADL__print_VSObject_ptr)(VSObject_ptr, emitter_t);
extern void (*ADL__print_VSInterfaceDefSeq_ptr)(VSInterfaceDefSeq_ptr, emitter_t);
extern void (*ADL__print_VSInitializerSeq_ptr)(VSInitializerSeq_ptr, emitter_t);
extern void (*ADL__print_VSValueDefSeq_ptr)(VSValueDefSeq_ptr, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSRepositoryId)(VSRepositoryId, emitter_t);
extern void (*ADL__print_VSFullValueDescription_ptr)(VSFullValueDescription_ptr, emitter_t);
extern void (*ADL__print_VSIdentifier)(VSIdentifier, emitter_t);
extern void (*ADL__print_VSVersionSpec)(VSVersionSpec, emitter_t);
extern void (*ADL__print_VSIDLType_ptr)(VSIDLType_ptr, emitter_t);
extern void (*ADL__print_VSVisibility)(VSVisibility, emitter_t);
extern void (*ADL__print_VSValueMemberDef_ptr)(VSValueMemberDef_ptr, emitter_t);
extern void (*ADL__print_VSAttributeMode)(VSAttributeMode, emitter_t);
extern void (*ADL__print_VSAttributeDef_ptr)(VSAttributeDef_ptr, emitter_t);
extern void (*ADL__print_VSOperationMode)(VSOperationMode, emitter_t);
extern void (*ADL__print_VSParDescriptionSeq_ptr)(VSParDescriptionSeq_ptr, emitter_t);
extern void (*ADL__print_VSExceptionDefSeq_ptr)(VSExceptionDefSeq_ptr, emitter_t);
extern void (*ADL__print_VSContextIdSeq_ptr)(VSContextIdSeq_ptr, emitter_t);
extern void (*ADL__print_VSOperationDef_ptr)(VSOperationDef_ptr, emitter_t);

/* Declarations of wrapper of FUT */
extern VSValueDef_ptr (*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSValueDef_ptr (*ADL__VSduplicate_wrapper)(VSValueDef_ptr, VSEnvironment*);
extern VSValueDef_ptr (*ADL__VSnarrow_wrapper)(VSObject_ptr, VSEnvironment*);
extern VSInterfaceDefSeq_ptr (*ADL__VSsupported_interfaces_read_wrapper)(VSEnvironment*, VSValueDef_ptr);
extern void (*ADL__VSsupported_interfaces_write_wrapper)(VSEnvironment*, VSValueDef_ptr, VSInterfaceDefSeq_ptr);
extern VSInitializerSeq_ptr (*ADL__VSinitializers_read_wrapper)(VSEnvironment*, VSValueDef_ptr);
extern void (*ADL__VSinitializers_write_wrapper)(VSEnvironment*, VSValueDef_ptr, VSInitializerSeq_ptr);
extern VSValueDef_ptr (*ADL__VSbase_value_read_wrapper)(VSEnvironment*, VSValueDef_ptr);
extern void (*ADL__VSbase_value_write_wrapper)(VSEnvironment*, VSValueDef_ptr, VSValueDef_ptr);
extern VSValueDefSeq_ptr (*ADL__VSabstract_base_values_read_wrapper)(VSEnvironment*, VSValueDef_ptr);
extern void (*ADL__VSabstract_base_values_write_wrapper)(VSEnvironment*, VSValueDef_ptr, VSValueDefSeq_ptr);
extern VSBoolean (*ADL__VSis_abstract_read_wrapper)(VSEnvironment*, VSValueDef_ptr);
extern void (*ADL__VSis_abstract_write_wrapper)(VSEnvironment*, VSValueDef_ptr, VSBoolean);
extern VSBoolean (*ADL__VSis_custom_read_wrapper)(VSEnvironment*, VSValueDef_ptr);
extern void (*ADL__VSis_custom_write_wrapper)(VSEnvironment*, VSValueDef_ptr, VSBoolean);
extern VSBoolean (*ADL__VSis_truncatable_read_wrapper)(VSEnvironment*, VSValueDef_ptr);
extern void (*ADL__VSis_truncatable_write_wrapper)(VSEnvironment*, VSValueDef_ptr, VSBoolean);
extern VSBoolean (*ADL__VSis_a_wrapper)(VSRepositoryId const, VSValueDef_ptr, VSEnvironment*);
extern VSFullValueDescription_ptr (*ADL__VSdescribe_value_wrapper)(VSEnvironment*, VSValueDef_ptr);
extern VSValueMemberDef_ptr (*ADL__VScreate_value_member_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, const VSVisibility, VSValueDef_ptr, VSEnvironment*);
extern VSAttributeDef_ptr (*ADL__VScreate_attribute_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, const VSAttributeMode, VSValueDef_ptr, VSEnvironment*);
extern VSOperationDef_ptr (*ADL__VScreate_operation_wrapper)(VSRepositoryId const, VSIdentifier const, VSVersionSpec const, VSIDLType_ptr const, const VSOperationMode, VSParDescriptionSeq_ptr const, VSExceptionDefSeq_ptr const, VSContextIdSeq_ptr const, VSValueDef_ptr, VSEnvironment*);

#endif
