/*
 *
 * t1_acf.c -- generated automatically by ADLT
 * This file contains definitions of Assertion-Checking Functions
 * of module "t1"
 */

#include "t1_acf.h"


/*
 *
 * ACF of VSnil
 *
 */
VSValueMemberDef_ptr ADL__ACF_VSnil (VSEnvironment *ev_10){

VSValueMemberDef_ptr VSnil_RtnVal_4;
  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_21;
  int tmp_23;
  int tmp_24;
  VSEnvironment *ev_10_tmp_28;
    int tmp_29;
  int tmp_31;
  int tmp_32;
  int tmp_33;
  VSEnvironment *ev_10_tmp_36;
  int tmp_37;
  int tmp_38;
  VSEnvironment *ev_10_tmp_41;
    int tmp_42;
  int tmp_43;
  int groupExpr_52;
  int tmp_45;
  int tmp_46;
  int tmp_49;

/* Declare vars for result of normal and exception bindings */
  int VSnil_NormalOutcome_5, VSnil_ExceptionOutcome_6;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_7;
  VSEnvironment *ev_10_tmp_11;
    int tmp_12;
  int tmp_13;
  VSEnvironment *ev_10_tmp_16;
  int tmp_17;
  VSEnvironment *ev_10_tmp_20;
  enum ADL__ACF_result VSnil_ACF_Result_3 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 0, ADL__VSnil_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnil_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnil_InfoArray[forLoopIdx_1].error > VSnil_ACF_Result_3))
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnil_ACF_Result_3 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_call);
  ADL__release(ADL__VSnil_assertionReport->parent, &this_seq);
  VSnil_RtnVal_4 = ADL__VSnil_wrapper(ev_10);
  ADL__recover(ADL__VSnil_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnil_assertionReport->setPhase(ADL__VSnil_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_10_tmp_11 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 8,&ev_10_tmp_11);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_7 = no_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 7,&tmp_7);
  VSnil_NormalOutcome_5 = (tmp_7);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_10_tmp_16 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 3,&ev_10_tmp_16);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_13 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 2,&tmp_13);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_12 = tmp_13;
  if (!tmp_13) {
      ev_10_tmp_20 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 5,&ev_10_tmp_20);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_17 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 4,&tmp_17);
    tmp_12 = tmp_17;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 1,&tmp_12);

  VSnil_ExceptionOutcome_6 = (tmp_12);

/* Exception binding is the first assertion */
  if (ADL__VSnil_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[0].result = (VSnil_ExceptionOutcome_6 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[0].evaluated = 1;
  ADL__VSnil_InfoArray[0].value = (VSnil_ExceptionOutcome_6 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnil_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnil_InfoArray[6].result = (VSnil_NormalOutcome_5 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnil_InfoArray[6].evaluated = 1;
  ADL__VSnil_InfoArray[6].value = (VSnil_NormalOutcome_5 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnil_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnil_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnil_ACF_Result_3 = ADL__VSnil_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnil_ExceptionOutcome_6 && !VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnil_ExceptionOutcome_6 && VSnil_NormalOutcome_5) {
  VSnil_ACF_Result_3 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnil_InfoArray, 10,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_28 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 13,&ev_10_tmp_28);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_24 = user_exception_is("NOT_IMPLEMENTED", ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 12,&tmp_24);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_23 = !tmp_24;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 11,&tmp_23);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_21 = (!VSnil_ExceptionOutcome_6 || tmp_23);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 9,&tmp_21);
    ADL__setResultAndError(ADL__VSnil_InfoArray, 15,&VSnil_ExceptionOutcome_6);
  ev_10_tmp_36 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 19,&ev_10_tmp_36);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_33 = system_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 18,&tmp_33);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_32 = !tmp_33;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 17,&tmp_32);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_31 = tmp_32;
  if (tmp_32) {
      ev_10_tmp_41 = ev_10;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 22,&ev_10_tmp_41);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_38 = user_exception(ev_10);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 21,&tmp_38);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_37 = !tmp_38;
  ADL__setResultAndError(ADL__VSnil_InfoArray, 20,&tmp_37);
    tmp_31 = tmp_37;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 16,&tmp_31);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_29 = (!VSnil_ExceptionOutcome_6 || tmp_31);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 14,&tmp_29);
    ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnil_NormalOutcome_5){
      ADL__setResultAndError(ADL__VSnil_InfoArray, 26,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[25]);

/* Evaluate is_nil_valuememdef_ptr(return) */
  tmp_46 = is_nil_valuememdef_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 25,&tmp_46);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[24]);

/* Evaluate is_nil_valuememdef_ptr(return) && cleanup_valuememdef_ptr(return) */
  tmp_45 = tmp_46;
  if (tmp_46) {
      ADL__setResultAndError(ADL__VSnil_InfoArray, 28,&VSnil_RtnVal_4);
  ADL__VSnil_assertionReport->exprMark(ADL__VSnil_assertionReport, &ADL__VSnil_assertionReport->assrt_info[27]);

/* Evaluate cleanup_valuememdef_ptr(return) */
  tmp_49 = cleanup_valuememdef_ptr(VSnil_RtnVal_4);
  ADL__setResultAndError(ADL__VSnil_InfoArray, 27,&tmp_49);
    tmp_45 = tmp_49;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnil_InfoArray, 27, 28);
  }
  ADL__setResultAndError(ADL__VSnil_InfoArray, 24,&tmp_45);
  groupExpr_52 = (tmp_45);
  tmp_43 = (groupExpr_52);
  tmp_42 = tmp_43;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnil_InfoArray, 23, 28);
  tmp_42 = 1;
}

  ADL__setResultAndError(ADL__VSnil_InfoArray, 23,&tmp_42);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnil_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnil_InfoArray[forLoopIdx_1].level == 0))
        VSnil_ACF_Result_3 = calculate_ACF_result(VSnil_ACF_Result_3, ADL__VSnil_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnil_assertionReport->value = VSnil_ACF_Result_3;
  ADL__VSnil_assertionReport->parent->openReport(ADL__VSnil_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnil_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnil_assertionReport->emitTest(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1])) {
     ADL__VSnil_assertionReport->exprStart(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnil_InfoArray[forLoopIdx_1].testable || !ADL__VSnil_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnil_assertionReport->emitter);
      else if (ADL__VSnil_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnil_InfoArray[forLoopIdx_1].error, ADL__VSnil_assertionReport->emitter);
      else
        ADL__VSnil_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnil_InfoArray[forLoopIdx_1].value, ADL__VSnil_assertionReport->emitter);
     ADL__VSnil_assertionReport->exprEnd(ADL__VSnil_assertionReport, &ADL__VSnil_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnil_RtnVal_4);
}


VSValueMemberDef_ptr (*ADL__VSnil_wrapper)(VSEnvironment*) = VSnil;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnil_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_valuememdef_ptr(return) && cleanup_valuememdef_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_valuememdef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr },
  {4, 27, 24, 0, 0, "cleanup_valuememdef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr }
};


unsigned int ADL__VSnil_InfoArrayIdx = 29;

struct ADL__reportAssertion *ADL__VSnil_assertionReport = 0;

/*
 *
 * ACF of VSduplicate
 *
 */
VSValueMemberDef_ptr ADL__ACF_VSduplicate (VSValueMemberDef_ptr o_72, VSEnvironment *ev_61){

VSValueMemberDef_ptr VSduplicate_RtnVal_55;
  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_73;
  int tmp_75;
  int tmp_76;
  VSEnvironment *ev_61_tmp_80;
    int tmp_81;
  int tmp_83;
  int tmp_84;
  int tmp_85;
  VSEnvironment *ev_61_tmp_88;
  int tmp_89;
  int tmp_90;
  VSEnvironment *ev_61_tmp_93;
    int tmp_94;
  int tmp_95;
  int groupExpr_107;
  int groupExpr_108;
  int tmp_96;
  int tmp_97;
  VSValueMemberDef_ptr o_72_tmp_100;
  int tmp_101;
  int tmp_104;

/* Declare vars for result of normal and exception bindings */
  int VSduplicate_NormalOutcome_56, VSduplicate_ExceptionOutcome_57;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_58;
  VSEnvironment *ev_61_tmp_62;
    int tmp_63;
  int tmp_64;
  VSEnvironment *ev_61_tmp_67;
  int tmp_68;
  VSEnvironment *ev_61_tmp_71;
  enum ADL__ACF_result VSduplicate_ACF_Result_54 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 0, ADL__VSduplicate_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSduplicate_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSduplicate_InfoArray[forLoopIdx_1].error > VSduplicate_ACF_Result_54))
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSduplicate_ACF_Result_54 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_call);
  ADL__release(ADL__VSduplicate_assertionReport->parent, &this_seq);
  VSduplicate_RtnVal_55 = ADL__VSduplicate_wrapper(o_72, ev_61);
  ADL__recover(ADL__VSduplicate_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSduplicate_assertionReport->setPhase(ADL__VSduplicate_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_61_tmp_62 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 8,&ev_61_tmp_62);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_58 = no_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 7,&tmp_58);
  VSduplicate_NormalOutcome_56 = (tmp_58);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_61_tmp_67 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 3,&ev_61_tmp_67);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_64 = system_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 2,&tmp_64);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_63 = tmp_64;
  if (!tmp_64) {
      ev_61_tmp_71 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 5,&ev_61_tmp_71);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_68 = user_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 4,&tmp_68);
    tmp_63 = tmp_68;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 1,&tmp_63);

  VSduplicate_ExceptionOutcome_57 = (tmp_63);

/* Exception binding is the first assertion */
  if (ADL__VSduplicate_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[0].result = (VSduplicate_ExceptionOutcome_57 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[0].evaluated = 1;
  ADL__VSduplicate_InfoArray[0].value = (VSduplicate_ExceptionOutcome_57 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSduplicate_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSduplicate_InfoArray[6].result = (VSduplicate_NormalOutcome_56 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSduplicate_InfoArray[6].evaluated = 1;
  ADL__VSduplicate_InfoArray[6].value = (VSduplicate_NormalOutcome_56 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSduplicate_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSduplicate_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSduplicate_ACF_Result_54 = ADL__VSduplicate_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSduplicate_ExceptionOutcome_57 && !VSduplicate_NormalOutcome_56) {
  VSduplicate_ACF_Result_54 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSduplicate_ExceptionOutcome_57 && VSduplicate_NormalOutcome_56) {
  VSduplicate_ACF_Result_54 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 10,&VSduplicate_ExceptionOutcome_57);
  ev_61_tmp_80 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 13,&ev_61_tmp_80);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_76 = user_exception_is("NOT_IMPLEMENTED", ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 12,&tmp_76);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_75 = !tmp_76;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 11,&tmp_75);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_73 = (!VSduplicate_ExceptionOutcome_57 || tmp_75);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 9,&tmp_73);
    ADL__setResultAndError(ADL__VSduplicate_InfoArray, 15,&VSduplicate_ExceptionOutcome_57);
  ev_61_tmp_88 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 19,&ev_61_tmp_88);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_85 = system_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 18,&tmp_85);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_84 = !tmp_85;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 17,&tmp_84);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_83 = tmp_84;
  if (tmp_84) {
      ev_61_tmp_93 = ev_61;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 22,&ev_61_tmp_93);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_90 = user_exception(ev_61);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 21,&tmp_90);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_89 = !tmp_90;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 20,&tmp_89);
    tmp_83 = tmp_89;
  }
  else {
  ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 16,&tmp_83);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_81 = (!VSduplicate_ExceptionOutcome_57 || tmp_83);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 14,&tmp_81);
    ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSduplicate_NormalOutcome_56){
      o_72_tmp_100 = o_72;
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 26,&o_72_tmp_100);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[25]);

/* Evaluate is_nil_valuememdef_ptr(o) */
  tmp_97 = is_nil_valuememdef_ptr(o_72);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 25,&tmp_97);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 28,&VSduplicate_RtnVal_55);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[27]);

/* Evaluate is_nil_valuememdef_ptr(return) */
  tmp_101 = is_nil_valuememdef_ptr(VSduplicate_RtnVal_55);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 27,&tmp_101);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[24]);

/* Evaluate is_nil_valuememdef_ptr(o) --> is_nil_valuememdef_ptr(return) */
  tmp_96 = (!tmp_97 || tmp_101);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 24,&tmp_96);
  groupExpr_107 = (tmp_96);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 30,&VSduplicate_RtnVal_55);
  ADL__VSduplicate_assertionReport->exprMark(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_assertionReport->assrt_info[29]);

/* Evaluate cleanup_valuememdef_ptr(return) */
  tmp_104 = cleanup_valuememdef_ptr(VSduplicate_RtnVal_55);
  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 29,&tmp_104);
  groupExpr_108 = (tmp_104);
  tmp_95 = (groupExpr_107 && groupExpr_108);
  tmp_94 = tmp_95;
  }
  else {
    ADL__resetInfoStruct(ADL__VSduplicate_InfoArray, 23, 30);
  tmp_94 = 1;
}

  ADL__setResultAndError(ADL__VSduplicate_InfoArray, 23,&tmp_94);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSduplicate_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSduplicate_InfoArray[forLoopIdx_1].level == 0))
        VSduplicate_ACF_Result_54 = calculate_ACF_result(VSduplicate_ACF_Result_54, ADL__VSduplicate_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSduplicate_assertionReport->value = VSduplicate_ACF_Result_54;
  ADL__VSduplicate_assertionReport->parent->openReport(ADL__VSduplicate_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSduplicate_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSduplicate_assertionReport->emitTest(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1])) {
     ADL__VSduplicate_assertionReport->exprStart(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
      if(!ADL__VSduplicate_InfoArray[forLoopIdx_1].testable || !ADL__VSduplicate_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSduplicate_assertionReport->emitter);
      else if (ADL__VSduplicate_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].error, ADL__VSduplicate_assertionReport->emitter);
      else
        ADL__VSduplicate_InfoArray[forLoopIdx_1].emitFunc(ADL__VSduplicate_InfoArray[forLoopIdx_1].value, ADL__VSduplicate_assertionReport->emitter);
     ADL__VSduplicate_assertionReport->exprEnd(ADL__VSduplicate_assertionReport, &ADL__VSduplicate_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSduplicate_RtnVal_55);
}


VSValueMemberDef_ptr (*ADL__VSduplicate_wrapper)(VSValueMemberDef_ptr, VSEnvironment*) = VSduplicate;

void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSduplicate_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_valuememdef_ptr(o) --> is_nil_valuememdef_ptr(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_valuememdef_ptr(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr },
  {4, 27, 24, 0, 0, "is_nil_valuememdef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr },
  {5, 29, 23, 0, 0, "cleanup_valuememdef_ptr(return)", 29, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr }
};


unsigned int ADL__VSduplicate_InfoArrayIdx = 31;

struct ADL__reportAssertion *ADL__VSduplicate_assertionReport = 0;

/*
 *
 * ACF of VSnarrow
 *
 */
VSValueMemberDef_ptr ADL__ACF_VSnarrow (VSObject_ptr o_128, VSEnvironment *ev_117){

VSValueMemberDef_ptr VSnarrow_RtnVal_111;
  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_129;
  int tmp_131;
  int tmp_132;
  VSEnvironment *ev_117_tmp_136;
    int tmp_137;
  int tmp_139;
  int tmp_140;
  int tmp_141;
  VSEnvironment *ev_117_tmp_144;
  int tmp_145;
  int tmp_146;
  VSEnvironment *ev_117_tmp_149;
    int tmp_150;
  int tmp_151;
  int groupExpr_165;
  int groupExpr_166;
  int tmp_153;
  int tmp_154;
  int tmp_157;
  VSObject_ptr o_128_tmp_160;
  int tmp_162;

/* Declare vars for result of normal and exception bindings */
  int VSnarrow_NormalOutcome_112, VSnarrow_ExceptionOutcome_113;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_114;
  VSEnvironment *ev_117_tmp_118;
    int tmp_119;
  int tmp_120;
  VSEnvironment *ev_117_tmp_123;
  int tmp_124;
  VSEnvironment *ev_117_tmp_127;
  enum ADL__ACF_result VSnarrow_ACF_Result_110 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 0, ADL__VSnarrow_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSnarrow_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSnarrow_InfoArray[forLoopIdx_1].error > VSnarrow_ACF_Result_110))
  VSnarrow_ACF_Result_110 = ADL__VSnarrow_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSnarrow_ACF_Result_110 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_call);
  ADL__release(ADL__VSnarrow_assertionReport->parent, &this_seq);
  VSnarrow_RtnVal_111 = ADL__VSnarrow_wrapper(o_128, ev_117);
  ADL__recover(ADL__VSnarrow_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSnarrow_assertionReport->setPhase(ADL__VSnarrow_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_117_tmp_118 = ev_117;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 8,&ev_117_tmp_118);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_114 = no_exception(ev_117);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 7,&tmp_114);
  VSnarrow_NormalOutcome_112 = (tmp_114);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_117_tmp_123 = ev_117;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 3,&ev_117_tmp_123);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_120 = system_exception(ev_117);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 2,&tmp_120);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_119 = tmp_120;
  if (!tmp_120) {
      ev_117_tmp_127 = ev_117;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 5,&ev_117_tmp_127);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_124 = user_exception(ev_117);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 4,&tmp_124);
    tmp_119 = tmp_124;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 1,&tmp_119);

  VSnarrow_ExceptionOutcome_113 = (tmp_119);

/* Exception binding is the first assertion */
  if (ADL__VSnarrow_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[0].result = (VSnarrow_ExceptionOutcome_113 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[0].evaluated = 1;
  ADL__VSnarrow_InfoArray[0].value = (VSnarrow_ExceptionOutcome_113 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSnarrow_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSnarrow_InfoArray[6].result = (VSnarrow_NormalOutcome_112 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSnarrow_InfoArray[6].evaluated = 1;
  ADL__VSnarrow_InfoArray[6].value = (VSnarrow_NormalOutcome_112 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSnarrow_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_110 = ADL__VSnarrow_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSnarrow_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSnarrow_ACF_Result_110 = ADL__VSnarrow_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSnarrow_ExceptionOutcome_113 && !VSnarrow_NormalOutcome_112) {
  VSnarrow_ACF_Result_110 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSnarrow_ExceptionOutcome_113 && VSnarrow_NormalOutcome_112) {
  VSnarrow_ACF_Result_110 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 10,&VSnarrow_ExceptionOutcome_113);
  ev_117_tmp_136 = ev_117;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 13,&ev_117_tmp_136);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_132 = user_exception_is("NOT_IMPLEMENTED", ev_117);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 12,&tmp_132);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_131 = !tmp_132;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 11,&tmp_131);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_129 = (!VSnarrow_ExceptionOutcome_113 || tmp_131);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 9,&tmp_129);
    ADL__setResultAndError(ADL__VSnarrow_InfoArray, 15,&VSnarrow_ExceptionOutcome_113);
  ev_117_tmp_144 = ev_117;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 19,&ev_117_tmp_144);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_141 = system_exception(ev_117);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 18,&tmp_141);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_140 = !tmp_141;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 17,&tmp_140);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_139 = tmp_140;
  if (tmp_140) {
      ev_117_tmp_149 = ev_117;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 22,&ev_117_tmp_149);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_146 = user_exception(ev_117);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 21,&tmp_146);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_145 = !tmp_146;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 20,&tmp_145);
    tmp_139 = tmp_145;
  }
  else {
  ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 16,&tmp_139);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_137 = (!VSnarrow_ExceptionOutcome_113 || tmp_139);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 14,&tmp_137);
    ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSnarrow_NormalOutcome_112){
      ADL__setResultAndError(ADL__VSnarrow_InfoArray, 26,&VSnarrow_RtnVal_111);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[25]);

/* Evaluate is_nil_valuememdef_ptr(return) */
  tmp_154 = is_nil_valuememdef_ptr(VSnarrow_RtnVal_111);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 25,&tmp_154);
  o_128_tmp_160 = o_128;
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 28,&o_128_tmp_160);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[27]);

/* Evaluate is_nil_object(o) */
  tmp_157 = is_nil_object(o_128);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 27,&tmp_157);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[24]);

/* Evaluate is_nil_valuememdef_ptr(return) <-> is_nil_object(o) */
  tmp_153 = ((tmp_154? 1 : 0) == (tmp_157? 1 : 0));
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 24,&tmp_153);
  groupExpr_165 = (tmp_153);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 30,&VSnarrow_RtnVal_111);
  ADL__VSnarrow_assertionReport->exprMark(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_assertionReport->assrt_info[29]);

/* Evaluate cleanup_valuememdef_ptr(return) */
  tmp_162 = cleanup_valuememdef_ptr(VSnarrow_RtnVal_111);
  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 29,&tmp_162);
  groupExpr_166 = (tmp_162);
  tmp_151 = (groupExpr_165 && groupExpr_166);
  tmp_150 = tmp_151;
  }
  else {
    ADL__resetInfoStruct(ADL__VSnarrow_InfoArray, 23, 30);
  tmp_150 = 1;
}

  ADL__setResultAndError(ADL__VSnarrow_InfoArray, 23,&tmp_150);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSnarrow_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSnarrow_InfoArray[forLoopIdx_1].level == 0))
        VSnarrow_ACF_Result_110 = calculate_ACF_result(VSnarrow_ACF_Result_110, ADL__VSnarrow_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSnarrow_assertionReport->value = VSnarrow_ACF_Result_110;
  ADL__VSnarrow_assertionReport->parent->openReport(ADL__VSnarrow_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSnarrow_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSnarrow_assertionReport->emitTest(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1])) {
     ADL__VSnarrow_assertionReport->exprStart(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
      if(!ADL__VSnarrow_InfoArray[forLoopIdx_1].testable || !ADL__VSnarrow_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSnarrow_assertionReport->emitter);
      else if (ADL__VSnarrow_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].error, ADL__VSnarrow_assertionReport->emitter);
      else
        ADL__VSnarrow_InfoArray[forLoopIdx_1].emitFunc(ADL__VSnarrow_InfoArray[forLoopIdx_1].value, ADL__VSnarrow_assertionReport->emitter);
     ADL__VSnarrow_assertionReport->exprEnd(ADL__VSnarrow_assertionReport, &ADL__VSnarrow_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSnarrow_RtnVal_111);
}


VSValueMemberDef_ptr (*ADL__VSnarrow_wrapper)(VSObject_ptr, VSEnvironment*) = VSnarrow;

void ADL__emit_VSObject_ptr (void* val, emitter_t emitter);
void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSnarrow_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_nil_valuememdef_ptr(return) <-> is_nil_object(o)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "is_nil_valuememdef_ptr(return)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 26, 25, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr },
  {4, 27, 24, 0, 0, "is_nil_object(o)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {4, 28, 27, 0, 0, "o", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSObject_ptr },
  {5, 29, 23, 0, 0, "cleanup_valuememdef_ptr(return)", 29, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {5, 30, 29, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr }
};


unsigned int ADL__VSnarrow_InfoArrayIdx = 31;

struct ADL__reportAssertion *ADL__VSnarrow_assertionReport = 0;

/*
 *
 * ACF of VStype
 *
 */
VSTypeCode_ptr ADL__ACF_VStype (VSEnvironment *ev_175, VSValueMemberDef_ptr c_vmdef_186){

VSTypeCode_ptr VStype_RtnVal_169;
  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_188;
  int tmp_190;
  int tmp_191;
  VSEnvironment *ev_175_tmp_195;
    int tmp_196;
  int tmp_197;
  int groupExpr_201;
  int tmp_198;

/* Declare vars for result of normal and exception bindings */
  int VStype_NormalOutcome_170, VStype_ExceptionOutcome_171;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_172;
  VSEnvironment *ev_175_tmp_176;
    int tmp_177;
  int tmp_178;
  VSEnvironment *ev_175_tmp_181;
  int tmp_182;
  VSEnvironment *ev_175_tmp_185;
  enum ADL__ACF_result VStype_ACF_Result_168 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 0, ADL__VStype_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VStype_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VStype_InfoArray[forLoopIdx_1].error > VStype_ACF_Result_168))
  VStype_ACF_Result_168 = ADL__VStype_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VStype_ACF_Result_168 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_call);
  ADL__release(ADL__VStype_assertionReport->parent, &this_seq);
  VStype_RtnVal_169 = ADL__VStype_wrapper(ev_175, c_vmdef_186);
  ADL__recover(ADL__VStype_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VStype_assertionReport->setPhase(ADL__VStype_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_175_tmp_176 = ev_175;
  ADL__setResultAndError(ADL__VStype_InfoArray, 8,&ev_175_tmp_176);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_172 = no_exception(ev_175);
  ADL__setResultAndError(ADL__VStype_InfoArray, 7,&tmp_172);
  VStype_NormalOutcome_170 = (tmp_172);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_175_tmp_181 = ev_175;
  ADL__setResultAndError(ADL__VStype_InfoArray, 3,&ev_175_tmp_181);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_178 = system_exception(ev_175);
  ADL__setResultAndError(ADL__VStype_InfoArray, 2,&tmp_178);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_177 = tmp_178;
  if (!tmp_178) {
      ev_175_tmp_185 = ev_175;
  ADL__setResultAndError(ADL__VStype_InfoArray, 5,&ev_175_tmp_185);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_182 = user_exception(ev_175);
  ADL__setResultAndError(ADL__VStype_InfoArray, 4,&tmp_182);
    tmp_177 = tmp_182;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VStype_InfoArray, 1,&tmp_177);

  VStype_ExceptionOutcome_171 = (tmp_177);

/* Exception binding is the first assertion */
  if (ADL__VStype_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[0].result = (VStype_ExceptionOutcome_171 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[0].evaluated = 1;
  ADL__VStype_InfoArray[0].value = (VStype_ExceptionOutcome_171 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VStype_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VStype_InfoArray[6].result = (VStype_NormalOutcome_170 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_InfoArray[6].evaluated = 1;
  ADL__VStype_InfoArray[6].value = (VStype_NormalOutcome_170 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VStype_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_168 = ADL__VStype_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VStype_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VStype_ACF_Result_168 = ADL__VStype_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VStype_ExceptionOutcome_171 && !VStype_NormalOutcome_170) {
  VStype_ACF_Result_168 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VStype_ExceptionOutcome_171 && VStype_NormalOutcome_170) {
  VStype_ACF_Result_168 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VStype_InfoArray, 10,&VStype_ExceptionOutcome_171);
  ev_175_tmp_195 = ev_175;
  ADL__setResultAndError(ADL__VStype_InfoArray, 13,&ev_175_tmp_195);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_191 = user_exception_is("NOT_IMPLEMENTED", ev_175);
  ADL__setResultAndError(ADL__VStype_InfoArray, 12,&tmp_191);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_190 = !tmp_191;
  ADL__setResultAndError(ADL__VStype_InfoArray, 11,&tmp_190);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_188 = (!VStype_ExceptionOutcome_171 || tmp_190);
  ADL__setResultAndError(ADL__VStype_InfoArray, 9,&tmp_188);
    ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VStype_NormalOutcome_170){
      ADL__setResultAndError(ADL__VStype_InfoArray, 16,&VStype_RtnVal_169);
  ADL__VStype_assertionReport->exprMark(ADL__VStype_assertionReport, &ADL__VStype_assertionReport->assrt_info[15]);

/* Evaluate correct_type(return) */
  tmp_198 = correct_type(VStype_RtnVal_169);
  ADL__setResultAndError(ADL__VStype_InfoArray, 15,&tmp_198);
  groupExpr_201 = (tmp_198);
  tmp_197 = (groupExpr_201);
  tmp_196 = tmp_197;
  }
  else {
    ADL__resetInfoStruct(ADL__VStype_InfoArray, 14, 16);
  tmp_196 = 1;
}

  ADL__setResultAndError(ADL__VStype_InfoArray, 14,&tmp_196);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VStype_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VStype_InfoArray[forLoopIdx_1].level == 0))
        VStype_ACF_Result_168 = calculate_ACF_result(VStype_ACF_Result_168, ADL__VStype_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VStype_assertionReport->value = VStype_ACF_Result_168;
  ADL__VStype_assertionReport->parent->openReport(ADL__VStype_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VStype_assertionReport->emitTest(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1])) {
     ADL__VStype_assertionReport->exprStart(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
      if(!ADL__VStype_InfoArray[forLoopIdx_1].testable || !ADL__VStype_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VStype_assertionReport->emitter);
      else if (ADL__VStype_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VStype_InfoArray[forLoopIdx_1].error, ADL__VStype_assertionReport->emitter);
      else
        ADL__VStype_InfoArray[forLoopIdx_1].emitFunc(ADL__VStype_InfoArray[forLoopIdx_1].value, ADL__VStype_assertionReport->emitter);
     ADL__VStype_assertionReport->exprEnd(ADL__VStype_assertionReport, &ADL__VStype_InfoArray[forLoopIdx_1]);
    }
  }

  return (VStype_RtnVal_169);
}


VSTypeCode_ptr (*ADL__VStype_wrapper)(VSEnvironment*, VSValueMemberDef_ptr) = VStype;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);
void ADL__emit_VSTypeCode_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VStype_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "correct_type(return)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSTypeCode_ptr }
};


unsigned int ADL__VStype_InfoArrayIdx = 17;

struct ADL__reportAssertion *ADL__VStype_assertionReport = 0;

/*
 *
 * ACF of VStype_def_read
 *
 */
VSIDLType_ptr ADL__ACF_VStype_def_read (VSEnvironment *ev_210, VSValueMemberDef_ptr c_vmdef_221){

VSIDLType_ptr VStype_def_read_RtnVal_204;
  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_223;
  int tmp_225;
  int tmp_226;
  VSEnvironment *ev_210_tmp_230;
    int tmp_231;
  int tmp_232;
  int groupExpr_236;
  int tmp_233;

/* Declare vars for result of normal and exception bindings */
  int VStype_def_read_NormalOutcome_205, VStype_def_read_ExceptionOutcome_206;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_207;
  VSEnvironment *ev_210_tmp_211;
    int tmp_212;
  int tmp_213;
  VSEnvironment *ev_210_tmp_216;
  int tmp_217;
  VSEnvironment *ev_210_tmp_220;
  enum ADL__ACF_result VStype_def_read_ACF_Result_203 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VStype_def_read_InfoArray, 0, ADL__VStype_def_read_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VStype_def_read_assertionReport->setPhase(ADL__VStype_def_read_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_def_read_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VStype_def_read_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VStype_def_read_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VStype_def_read_InfoArray[forLoopIdx_1].error > VStype_def_read_ACF_Result_203))
  VStype_def_read_ACF_Result_203 = ADL__VStype_def_read_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VStype_def_read_ACF_Result_203 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VStype_def_read_assertionReport->setPhase(ADL__VStype_def_read_assertionReport, PH_call);
  ADL__release(ADL__VStype_def_read_assertionReport->parent, &this_seq);
  VStype_def_read_RtnVal_204 = ADL__VStype_def_read_wrapper(ev_210, c_vmdef_221);
  ADL__recover(ADL__VStype_def_read_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VStype_def_read_assertionReport->setPhase(ADL__VStype_def_read_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_210_tmp_211 = ev_210;
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 8,&ev_210_tmp_211);
  ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_207 = no_exception(ev_210);
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 7,&tmp_207);
  VStype_def_read_NormalOutcome_205 = (tmp_207);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_210_tmp_216 = ev_210;
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 3,&ev_210_tmp_216);
  ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_213 = system_exception(ev_210);
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 2,&tmp_213);
  ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_212 = tmp_213;
  if (!tmp_213) {
      ev_210_tmp_220 = ev_210;
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 5,&ev_210_tmp_220);
  ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_217 = user_exception(ev_210);
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 4,&tmp_217);
    tmp_212 = tmp_217;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_def_read_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 1,&tmp_212);

  VStype_def_read_ExceptionOutcome_206 = (tmp_212);

/* Exception binding is the first assertion */
  if (ADL__VStype_def_read_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VStype_def_read_InfoArray[0].result = (VStype_def_read_ExceptionOutcome_206 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_def_read_InfoArray[0].evaluated = 1;
  ADL__VStype_def_read_InfoArray[0].value = (VStype_def_read_ExceptionOutcome_206 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VStype_def_read_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VStype_def_read_InfoArray[6].result = (VStype_def_read_NormalOutcome_205 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_def_read_InfoArray[6].evaluated = 1;
  ADL__VStype_def_read_InfoArray[6].value = (VStype_def_read_NormalOutcome_205 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VStype_def_read_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VStype_def_read_ACF_Result_203 = ADL__VStype_def_read_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VStype_def_read_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VStype_def_read_ACF_Result_203 = ADL__VStype_def_read_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VStype_def_read_ExceptionOutcome_206 && !VStype_def_read_NormalOutcome_205) {
  VStype_def_read_ACF_Result_203 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VStype_def_read_ExceptionOutcome_206 && VStype_def_read_NormalOutcome_205) {
  VStype_def_read_ACF_Result_203 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 10,&VStype_def_read_ExceptionOutcome_206);
  ev_210_tmp_230 = ev_210;
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 13,&ev_210_tmp_230);
  ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_226 = user_exception_is("NOT_IMPLEMENTED", ev_210);
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 12,&tmp_226);
  ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_225 = !tmp_226;
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 11,&tmp_225);
  ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_223 = (!VStype_def_read_ExceptionOutcome_206 || tmp_225);
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 9,&tmp_223);
    ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VStype_def_read_NormalOutcome_205){
      ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 16,&VStype_def_read_RtnVal_204);
  ADL__VStype_def_read_assertionReport->exprMark(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_assertionReport->assrt_info[15]);

/* Evaluate correct_type_def(return) */
  tmp_233 = correct_type_def(VStype_def_read_RtnVal_204);
  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 15,&tmp_233);
  groupExpr_236 = (tmp_233);
  tmp_232 = (groupExpr_236);
  tmp_231 = tmp_232;
  }
  else {
    ADL__resetInfoStruct(ADL__VStype_def_read_InfoArray, 14, 16);
  tmp_231 = 1;
}

  ADL__setResultAndError(ADL__VStype_def_read_InfoArray, 14,&tmp_231);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_def_read_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VStype_def_read_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VStype_def_read_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VStype_def_read_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VStype_def_read_InfoArray[forLoopIdx_1].level == 0))
        VStype_def_read_ACF_Result_203 = calculate_ACF_result(VStype_def_read_ACF_Result_203, ADL__VStype_def_read_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VStype_def_read_assertionReport->value = VStype_def_read_ACF_Result_203;
  ADL__VStype_def_read_assertionReport->parent->openReport(ADL__VStype_def_read_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_def_read_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VStype_def_read_assertionReport->emitTest(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_InfoArray[forLoopIdx_1])) {
     ADL__VStype_def_read_assertionReport->exprStart(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_InfoArray[forLoopIdx_1]);
      if(!ADL__VStype_def_read_InfoArray[forLoopIdx_1].testable || !ADL__VStype_def_read_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VStype_def_read_assertionReport->emitter);
      else if (ADL__VStype_def_read_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VStype_def_read_InfoArray[forLoopIdx_1].error, ADL__VStype_def_read_assertionReport->emitter);
      else
        ADL__VStype_def_read_InfoArray[forLoopIdx_1].emitFunc(ADL__VStype_def_read_InfoArray[forLoopIdx_1].value, ADL__VStype_def_read_assertionReport->emitter);
     ADL__VStype_def_read_assertionReport->exprEnd(ADL__VStype_def_read_assertionReport, &ADL__VStype_def_read_InfoArray[forLoopIdx_1]);
    }
  }

  return (VStype_def_read_RtnVal_204);
}


VSIDLType_ptr (*ADL__VStype_def_read_wrapper)(VSEnvironment*, VSValueMemberDef_ptr) = VStype_def_read;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);
void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VStype_def_read_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "correct_type_def(return)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr }
};


unsigned int ADL__VStype_def_read_InfoArrayIdx = 17;

struct ADL__reportAssertion *ADL__VStype_def_read_assertionReport = 0;

/*
 *
 * ACF of VStype_def_write
 *
 */
void ADL__ACF_VStype_def_write (VSEnvironment *ev_245, VSValueMemberDef_ptr c_vmdef_256, VSIDLType_ptr s_itp_257){

  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_259;
  int tmp_261;
  int tmp_262;
  VSEnvironment *ev_245_tmp_266;
    int tmp_267;
  int tmp_268;
  int groupExpr_275;
  int tmp_269;
  VSIDLType_ptr s_itp_257_tmp_272;
  VSValueMemberDef_ptr c_vmdef_256_tmp_274;

/* Declare vars for result of normal and exception bindings */
  int VStype_def_write_NormalOutcome_240, VStype_def_write_ExceptionOutcome_241;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_242;
  VSEnvironment *ev_245_tmp_246;
    int tmp_247;
  int tmp_248;
  VSEnvironment *ev_245_tmp_251;
  int tmp_252;
  VSEnvironment *ev_245_tmp_255;
  enum ADL__ACF_result VStype_def_write_ACF_Result_238 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VStype_def_write_InfoArray, 0, ADL__VStype_def_write_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VStype_def_write_assertionReport->setPhase(ADL__VStype_def_write_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_def_write_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VStype_def_write_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VStype_def_write_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VStype_def_write_InfoArray[forLoopIdx_1].error > VStype_def_write_ACF_Result_238))
  VStype_def_write_ACF_Result_238 = ADL__VStype_def_write_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VStype_def_write_ACF_Result_238 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VStype_def_write_assertionReport->setPhase(ADL__VStype_def_write_assertionReport, PH_call);
  ADL__release(ADL__VStype_def_write_assertionReport->parent, &this_seq);
  ADL__VStype_def_write_wrapper(ev_245, c_vmdef_256, s_itp_257);
  ADL__recover(ADL__VStype_def_write_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VStype_def_write_assertionReport->setPhase(ADL__VStype_def_write_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_245_tmp_246 = ev_245;
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 8,&ev_245_tmp_246);
  ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_242 = no_exception(ev_245);
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 7,&tmp_242);
  VStype_def_write_NormalOutcome_240 = (tmp_242);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_245_tmp_251 = ev_245;
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 3,&ev_245_tmp_251);
  ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_248 = system_exception(ev_245);
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 2,&tmp_248);
  ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_247 = tmp_248;
  if (!tmp_248) {
      ev_245_tmp_255 = ev_245;
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 5,&ev_245_tmp_255);
  ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_252 = user_exception(ev_245);
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 4,&tmp_252);
    tmp_247 = tmp_252;
  }
  else {
  ADL__resetInfoStruct(ADL__VStype_def_write_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 1,&tmp_247);

  VStype_def_write_ExceptionOutcome_241 = (tmp_247);

/* Exception binding is the first assertion */
  if (ADL__VStype_def_write_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VStype_def_write_InfoArray[0].result = (VStype_def_write_ExceptionOutcome_241 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_def_write_InfoArray[0].evaluated = 1;
  ADL__VStype_def_write_InfoArray[0].value = (VStype_def_write_ExceptionOutcome_241 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VStype_def_write_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VStype_def_write_InfoArray[6].result = (VStype_def_write_NormalOutcome_240 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VStype_def_write_InfoArray[6].evaluated = 1;
  ADL__VStype_def_write_InfoArray[6].value = (VStype_def_write_NormalOutcome_240 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VStype_def_write_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VStype_def_write_ACF_Result_238 = ADL__VStype_def_write_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VStype_def_write_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VStype_def_write_ACF_Result_238 = ADL__VStype_def_write_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VStype_def_write_ExceptionOutcome_241 && !VStype_def_write_NormalOutcome_240) {
  VStype_def_write_ACF_Result_238 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VStype_def_write_ExceptionOutcome_241 && VStype_def_write_NormalOutcome_240) {
  VStype_def_write_ACF_Result_238 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 10,&VStype_def_write_ExceptionOutcome_241);
  ev_245_tmp_266 = ev_245;
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 13,&ev_245_tmp_266);
  ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_262 = user_exception_is("NOT_IMPLEMENTED", ev_245);
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 12,&tmp_262);
  ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_261 = !tmp_262;
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 11,&tmp_261);
  ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_259 = (!VStype_def_write_ExceptionOutcome_241 || tmp_261);
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 9,&tmp_259);
    ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VStype_def_write_NormalOutcome_240){
      s_itp_257_tmp_272 = s_itp_257;
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 16,&s_itp_257_tmp_272);
  c_vmdef_256_tmp_274 = c_vmdef_256;
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 17,&c_vmdef_256_tmp_274);
  ADL__VStype_def_write_assertionReport->exprMark(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_assertionReport->assrt_info[15]);

/* Evaluate correct_type_def_set(s_itp, c_vmdef) */
  tmp_269 = correct_type_def_set(s_itp_257, c_vmdef_256);
  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 15,&tmp_269);
  groupExpr_275 = (tmp_269);
  tmp_268 = (groupExpr_275);
  tmp_267 = tmp_268;
  }
  else {
    ADL__resetInfoStruct(ADL__VStype_def_write_InfoArray, 14, 17);
  tmp_267 = 1;
}

  ADL__setResultAndError(ADL__VStype_def_write_InfoArray, 14,&tmp_267);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_def_write_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VStype_def_write_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VStype_def_write_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VStype_def_write_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VStype_def_write_InfoArray[forLoopIdx_1].level == 0))
        VStype_def_write_ACF_Result_238 = calculate_ACF_result(VStype_def_write_ACF_Result_238, ADL__VStype_def_write_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VStype_def_write_assertionReport->value = VStype_def_write_ACF_Result_238;
  ADL__VStype_def_write_assertionReport->parent->openReport(ADL__VStype_def_write_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VStype_def_write_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VStype_def_write_assertionReport->emitTest(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_InfoArray[forLoopIdx_1])) {
     ADL__VStype_def_write_assertionReport->exprStart(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_InfoArray[forLoopIdx_1]);
      if(!ADL__VStype_def_write_InfoArray[forLoopIdx_1].testable || !ADL__VStype_def_write_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VStype_def_write_assertionReport->emitter);
      else if (ADL__VStype_def_write_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VStype_def_write_InfoArray[forLoopIdx_1].error, ADL__VStype_def_write_assertionReport->emitter);
      else
        ADL__VStype_def_write_InfoArray[forLoopIdx_1].emitFunc(ADL__VStype_def_write_InfoArray[forLoopIdx_1].value, ADL__VStype_def_write_assertionReport->emitter);
     ADL__VStype_def_write_assertionReport->exprEnd(ADL__VStype_def_write_assertionReport, &ADL__VStype_def_write_InfoArray[forLoopIdx_1]);
    }
  }

  return;
}


void (*ADL__VStype_def_write_wrapper)(VSEnvironment*, VSValueMemberDef_ptr, VSIDLType_ptr) = VStype_def_write;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);
void ADL__emit_VSIDLType_ptr (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VStype_def_write_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "correct_type_def_set(s_itp, c_vmdef)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "s_itp", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSIDLType_ptr },
  {3, 17, 15, 0, 0, "c_vmdef", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr }
};


unsigned int ADL__VStype_def_write_InfoArrayIdx = 18;

struct ADL__reportAssertion *ADL__VStype_def_write_assertionReport = 0;

/*
 *
 * ACF of VSaccess_read
 *
 */
VSVisibility ADL__ACF_VSaccess_read (VSEnvironment *ev_284, VSValueMemberDef_ptr c_vmdef_295){

VSVisibility VSaccess_read_RtnVal_278;
  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_297;
  int tmp_299;
  int tmp_300;
  VSEnvironment *ev_284_tmp_304;
    int tmp_305;
  int tmp_306;
  int groupExpr_310;
  int tmp_307;

/* Declare vars for result of normal and exception bindings */
  int VSaccess_read_NormalOutcome_279, VSaccess_read_ExceptionOutcome_280;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_281;
  VSEnvironment *ev_284_tmp_285;
    int tmp_286;
  int tmp_287;
  VSEnvironment *ev_284_tmp_290;
  int tmp_291;
  VSEnvironment *ev_284_tmp_294;
  enum ADL__ACF_result VSaccess_read_ACF_Result_277 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSaccess_read_InfoArray, 0, ADL__VSaccess_read_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSaccess_read_assertionReport->setPhase(ADL__VSaccess_read_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSaccess_read_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSaccess_read_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSaccess_read_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSaccess_read_InfoArray[forLoopIdx_1].error > VSaccess_read_ACF_Result_277))
  VSaccess_read_ACF_Result_277 = ADL__VSaccess_read_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSaccess_read_ACF_Result_277 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSaccess_read_assertionReport->setPhase(ADL__VSaccess_read_assertionReport, PH_call);
  ADL__release(ADL__VSaccess_read_assertionReport->parent, &this_seq);
  VSaccess_read_RtnVal_278 = ADL__VSaccess_read_wrapper(ev_284, c_vmdef_295);
  ADL__recover(ADL__VSaccess_read_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSaccess_read_assertionReport->setPhase(ADL__VSaccess_read_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_284_tmp_285 = ev_284;
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 8,&ev_284_tmp_285);
  ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_281 = no_exception(ev_284);
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 7,&tmp_281);
  VSaccess_read_NormalOutcome_279 = (tmp_281);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_284_tmp_290 = ev_284;
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 3,&ev_284_tmp_290);
  ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_287 = system_exception(ev_284);
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 2,&tmp_287);
  ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_286 = tmp_287;
  if (!tmp_287) {
      ev_284_tmp_294 = ev_284;
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 5,&ev_284_tmp_294);
  ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_291 = user_exception(ev_284);
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 4,&tmp_291);
    tmp_286 = tmp_291;
  }
  else {
  ADL__resetInfoStruct(ADL__VSaccess_read_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 1,&tmp_286);

  VSaccess_read_ExceptionOutcome_280 = (tmp_286);

/* Exception binding is the first assertion */
  if (ADL__VSaccess_read_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSaccess_read_InfoArray[0].result = (VSaccess_read_ExceptionOutcome_280 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSaccess_read_InfoArray[0].evaluated = 1;
  ADL__VSaccess_read_InfoArray[0].value = (VSaccess_read_ExceptionOutcome_280 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSaccess_read_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSaccess_read_InfoArray[6].result = (VSaccess_read_NormalOutcome_279 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSaccess_read_InfoArray[6].evaluated = 1;
  ADL__VSaccess_read_InfoArray[6].value = (VSaccess_read_NormalOutcome_279 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSaccess_read_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSaccess_read_ACF_Result_277 = ADL__VSaccess_read_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSaccess_read_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSaccess_read_ACF_Result_277 = ADL__VSaccess_read_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSaccess_read_ExceptionOutcome_280 && !VSaccess_read_NormalOutcome_279) {
  VSaccess_read_ACF_Result_277 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSaccess_read_ExceptionOutcome_280 && VSaccess_read_NormalOutcome_279) {
  VSaccess_read_ACF_Result_277 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 10,&VSaccess_read_ExceptionOutcome_280);
  ev_284_tmp_304 = ev_284;
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 13,&ev_284_tmp_304);
  ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_300 = user_exception_is("NOT_IMPLEMENTED", ev_284);
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 12,&tmp_300);
  ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_299 = !tmp_300;
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 11,&tmp_299);
  ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_297 = (!VSaccess_read_ExceptionOutcome_280 || tmp_299);
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 9,&tmp_297);
    ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSaccess_read_NormalOutcome_279){
      ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 16,&VSaccess_read_RtnVal_278);
  ADL__VSaccess_read_assertionReport->exprMark(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_assertionReport->assrt_info[15]);

/* Evaluate correct_access(return) */
  tmp_307 = correct_access(VSaccess_read_RtnVal_278);
  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 15,&tmp_307);
  groupExpr_310 = (tmp_307);
  tmp_306 = (groupExpr_310);
  tmp_305 = tmp_306;
  }
  else {
    ADL__resetInfoStruct(ADL__VSaccess_read_InfoArray, 14, 16);
  tmp_305 = 1;
}

  ADL__setResultAndError(ADL__VSaccess_read_InfoArray, 14,&tmp_305);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSaccess_read_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSaccess_read_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSaccess_read_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSaccess_read_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSaccess_read_InfoArray[forLoopIdx_1].level == 0))
        VSaccess_read_ACF_Result_277 = calculate_ACF_result(VSaccess_read_ACF_Result_277, ADL__VSaccess_read_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSaccess_read_assertionReport->value = VSaccess_read_ACF_Result_277;
  ADL__VSaccess_read_assertionReport->parent->openReport(ADL__VSaccess_read_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSaccess_read_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSaccess_read_assertionReport->emitTest(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_InfoArray[forLoopIdx_1])) {
     ADL__VSaccess_read_assertionReport->exprStart(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_InfoArray[forLoopIdx_1]);
      if(!ADL__VSaccess_read_InfoArray[forLoopIdx_1].testable || !ADL__VSaccess_read_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSaccess_read_assertionReport->emitter);
      else if (ADL__VSaccess_read_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSaccess_read_InfoArray[forLoopIdx_1].error, ADL__VSaccess_read_assertionReport->emitter);
      else
        ADL__VSaccess_read_InfoArray[forLoopIdx_1].emitFunc(ADL__VSaccess_read_InfoArray[forLoopIdx_1].value, ADL__VSaccess_read_assertionReport->emitter);
     ADL__VSaccess_read_assertionReport->exprEnd(ADL__VSaccess_read_assertionReport, &ADL__VSaccess_read_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSaccess_read_RtnVal_278);
}


VSVisibility (*ADL__VSaccess_read_wrapper)(VSEnvironment*, VSValueMemberDef_ptr) = VSaccess_read;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);
void ADL__emit_VSVisibility (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSaccess_read_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "correct_access(return)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSVisibility }
};


unsigned int ADL__VSaccess_read_InfoArrayIdx = 17;

struct ADL__reportAssertion *ADL__VSaccess_read_assertionReport = 0;

/*
 *
 * ACF of VSaccess_write
 *
 */
void ADL__ACF_VSaccess_write (VSEnvironment *ev_319, VSValueMemberDef_ptr c_vmdef_330, VSVisibility s_as_331){

  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_333;
  int tmp_335;
  int tmp_336;
  VSEnvironment *ev_319_tmp_340;
    int tmp_341;
  int tmp_342;
  int groupExpr_349;
  int tmp_343;
  VSVisibility s_as_331_tmp_346;
  VSValueMemberDef_ptr c_vmdef_330_tmp_348;

/* Declare vars for result of normal and exception bindings */
  int VSaccess_write_NormalOutcome_314, VSaccess_write_ExceptionOutcome_315;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_316;
  VSEnvironment *ev_319_tmp_320;
    int tmp_321;
  int tmp_322;
  VSEnvironment *ev_319_tmp_325;
  int tmp_326;
  VSEnvironment *ev_319_tmp_329;
  enum ADL__ACF_result VSaccess_write_ACF_Result_312 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSaccess_write_InfoArray, 0, ADL__VSaccess_write_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSaccess_write_assertionReport->setPhase(ADL__VSaccess_write_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
    
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSaccess_write_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSaccess_write_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSaccess_write_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSaccess_write_InfoArray[forLoopIdx_1].error > VSaccess_write_ACF_Result_312))
  VSaccess_write_ACF_Result_312 = ADL__VSaccess_write_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSaccess_write_ACF_Result_312 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSaccess_write_assertionReport->setPhase(ADL__VSaccess_write_assertionReport, PH_call);
  ADL__release(ADL__VSaccess_write_assertionReport->parent, &this_seq);
  ADL__VSaccess_write_wrapper(ev_319, c_vmdef_330, s_as_331);
  ADL__recover(ADL__VSaccess_write_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSaccess_write_assertionReport->setPhase(ADL__VSaccess_write_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_319_tmp_320 = ev_319;
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 8,&ev_319_tmp_320);
  ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_316 = no_exception(ev_319);
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 7,&tmp_316);
  VSaccess_write_NormalOutcome_314 = (tmp_316);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_319_tmp_325 = ev_319;
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 3,&ev_319_tmp_325);
  ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_322 = system_exception(ev_319);
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 2,&tmp_322);
  ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_321 = tmp_322;
  if (!tmp_322) {
      ev_319_tmp_329 = ev_319;
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 5,&ev_319_tmp_329);
  ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_326 = user_exception(ev_319);
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 4,&tmp_326);
    tmp_321 = tmp_326;
  }
  else {
  ADL__resetInfoStruct(ADL__VSaccess_write_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 1,&tmp_321);

  VSaccess_write_ExceptionOutcome_315 = (tmp_321);

/* Exception binding is the first assertion */
  if (ADL__VSaccess_write_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSaccess_write_InfoArray[0].result = (VSaccess_write_ExceptionOutcome_315 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSaccess_write_InfoArray[0].evaluated = 1;
  ADL__VSaccess_write_InfoArray[0].value = (VSaccess_write_ExceptionOutcome_315 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSaccess_write_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSaccess_write_InfoArray[6].result = (VSaccess_write_NormalOutcome_314 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSaccess_write_InfoArray[6].evaluated = 1;
  ADL__VSaccess_write_InfoArray[6].value = (VSaccess_write_NormalOutcome_314 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSaccess_write_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSaccess_write_ACF_Result_312 = ADL__VSaccess_write_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSaccess_write_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSaccess_write_ACF_Result_312 = ADL__VSaccess_write_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSaccess_write_ExceptionOutcome_315 && !VSaccess_write_NormalOutcome_314) {
  VSaccess_write_ACF_Result_312 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSaccess_write_ExceptionOutcome_315 && VSaccess_write_NormalOutcome_314) {
  VSaccess_write_ACF_Result_312 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 10,&VSaccess_write_ExceptionOutcome_315);
  ev_319_tmp_340 = ev_319;
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 13,&ev_319_tmp_340);
  ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_336 = user_exception_is("NOT_IMPLEMENTED", ev_319);
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 12,&tmp_336);
  ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_335 = !tmp_336;
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 11,&tmp_335);
  ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_333 = (!VSaccess_write_ExceptionOutcome_315 || tmp_335);
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 9,&tmp_333);
    ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[14]);

/* Evaluate normally { ... } */
  if(VSaccess_write_NormalOutcome_314){
      s_as_331_tmp_346 = s_as_331;
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 16,&s_as_331_tmp_346);
  c_vmdef_330_tmp_348 = c_vmdef_330;
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 17,&c_vmdef_330_tmp_348);
  ADL__VSaccess_write_assertionReport->exprMark(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_assertionReport->assrt_info[15]);

/* Evaluate correct_access_set(s_as, c_vmdef) */
  tmp_343 = correct_access_set(s_as_331, c_vmdef_330);
  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 15,&tmp_343);
  groupExpr_349 = (tmp_343);
  tmp_342 = (groupExpr_349);
  tmp_341 = tmp_342;
  }
  else {
    ADL__resetInfoStruct(ADL__VSaccess_write_InfoArray, 14, 17);
  tmp_341 = 1;
}

  ADL__setResultAndError(ADL__VSaccess_write_InfoArray, 14,&tmp_341);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSaccess_write_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSaccess_write_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSaccess_write_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSaccess_write_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSaccess_write_InfoArray[forLoopIdx_1].level == 0))
        VSaccess_write_ACF_Result_312 = calculate_ACF_result(VSaccess_write_ACF_Result_312, ADL__VSaccess_write_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSaccess_write_assertionReport->value = VSaccess_write_ACF_Result_312;
  ADL__VSaccess_write_assertionReport->parent->openReport(ADL__VSaccess_write_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSaccess_write_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSaccess_write_assertionReport->emitTest(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_InfoArray[forLoopIdx_1])) {
     ADL__VSaccess_write_assertionReport->exprStart(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_InfoArray[forLoopIdx_1]);
      if(!ADL__VSaccess_write_InfoArray[forLoopIdx_1].testable || !ADL__VSaccess_write_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSaccess_write_assertionReport->emitter);
      else if (ADL__VSaccess_write_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSaccess_write_InfoArray[forLoopIdx_1].error, ADL__VSaccess_write_assertionReport->emitter);
      else
        ADL__VSaccess_write_InfoArray[forLoopIdx_1].emitFunc(ADL__VSaccess_write_InfoArray[forLoopIdx_1].value, ADL__VSaccess_write_assertionReport->emitter);
     ADL__VSaccess_write_assertionReport->exprEnd(ADL__VSaccess_write_assertionReport, &ADL__VSaccess_write_InfoArray[forLoopIdx_1]);
    }
  }

  return;
}


void (*ADL__VSaccess_write_wrapper)(VSEnvironment*, VSValueMemberDef_ptr, VSVisibility) = VSaccess_write;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);
void ADL__emit_VSVisibility (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSaccess_write_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {3, 15, 14, 0, 0, "correct_access_set(s_as, c_vmdef)", 15, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {3, 16, 15, 0, 0, "s_as", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSVisibility },
  {3, 17, 15, 0, 0, "c_vmdef", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSValueMemberDef_ptr }
};


unsigned int ADL__VSaccess_write_InfoArrayIdx = 18;

struct ADL__reportAssertion *ADL__VSaccess_write_assertionReport = 0;

/*
 *
 * ACF of VSdef_kind
 *
 */
VSDefinitionKind ADL__ACF_VSdef_kind (VSEnvironment *ev_358, VSValueMemberDef_ptr c_vmdef_369){

VSDefinitionKind VSdef_kind_RtnVal_352;
  void *dummyVarName_350;
  int TRUE_tmp = ADL__ASSERTION_TRUE;
  int FALSE_tmp = ADL__ASSERTION_FALSE;
  int this_seq; /* local storage for seq number for thread safety */
  unsigned int forLoopIdx_1;


/* Declare vars for tmp vars for assertions */
    int tmp_370;
  int tmp_372;
  int tmp_373;
  VSEnvironment *ev_358_tmp_377;
    int tmp_378;
  int tmp_380;
  int tmp_381;
  int tmp_382;
  VSEnvironment *ev_358_tmp_385;
  int tmp_386;
  int tmp_387;
  VSEnvironment *ev_358_tmp_390;
    int tmp_391;
  int tmp_392;
  int groupExpr_396;
  int tmp_393;

/* Declare vars for result of normal and exception bindings */
  int VSdef_kind_NormalOutcome_353, VSdef_kind_ExceptionOutcome_354;

/* Declare tmp var needed in  normal and exception bindings */
    int tmp_355;
  VSEnvironment *ev_358_tmp_359;
    int tmp_360;
  int tmp_361;
  VSEnvironment *ev_358_tmp_364;
  int tmp_365;
  VSEnvironment *ev_358_tmp_368;
  enum ADL__ACF_result VSdef_kind_ACF_Result_351 = ADL__ACF_SKIPPED;


/************* Initialization of Results *************/
  ADL__user_errno = 0;
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 0, ADL__VSdef_kind_InfoArrayIdx - 1);

/******************* Preconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_pre);

/* Evaluate @ expressions in Normal and Exception bindings */
    
/* Evaluate @ expressions in assertions */
      
/* Check for error in Preconditions */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
  if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) {
    if ((ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > 1) && 
      (ADL__VSdef_kind_InfoArray[forLoopIdx_1].error > VSdef_kind_ACF_Result_351))
  VSdef_kind_ACF_Result_351 = ADL__VSdef_kind_InfoArray[forLoopIdx_1].error;
    }
  }

/* If there is error in precondition goto REPORT_RESULT */
  if (VSdef_kind_ACF_Result_351 != ADL__ACF_SKIPPED) 
    goto REPORT_RESULT;

/******************* Execution of Function Under Test *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_call);
  ADL__release(ADL__VSdef_kind_assertionReport->parent, &this_seq);
  VSdef_kind_RtnVal_352 = ADL__VSdef_kind_wrapper(ev_358, c_vmdef_369);
  ADL__recover(ADL__VSdef_kind_assertionReport->parent, &this_seq);

/******************* Postconditions *******************/
  ADL__VSdef_kind_assertionReport->setPhase(ADL__VSdef_kind_assertionReport, PH_post);

/*
 * Evaluate
 *
 * normal binding
 *
 */
    ev_358_tmp_359 = ev_358;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 8,&ev_358_tmp_359);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[7]);

/* Evaluate no_exception(ev) */
  tmp_355 = no_exception(ev_358);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 7,&tmp_355);
  VSdef_kind_NormalOutcome_353 = (tmp_355);

/*
 * Evaluate
 *
 * exception binding
 *
 */
    ev_358_tmp_364 = ev_358;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 3,&ev_358_tmp_364);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[2]);

/* Evaluate system_exception(ev) */
  tmp_361 = system_exception(ev_358);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 2,&tmp_361);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[1]);

/* Evaluate system_exception(ev) || user_exception(ev) */
  tmp_360 = tmp_361;
  if (!tmp_361) {
      ev_358_tmp_368 = ev_358;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 5,&ev_358_tmp_368);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[4]);

/* Evaluate user_exception(ev) */
  tmp_365 = user_exception(ev_358);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 4,&tmp_365);
    tmp_360 = tmp_365;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 4, 5);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 1,&tmp_360);

  VSdef_kind_ExceptionOutcome_354 = (tmp_360);

/* Exception binding is the first assertion */
  if (ADL__VSdef_kind_InfoArray[0].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[0].result = (VSdef_kind_ExceptionOutcome_354 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[0].evaluated = 1;
  ADL__VSdef_kind_InfoArray[0].value = (VSdef_kind_ExceptionOutcome_354 ? &TRUE_tmp : &FALSE_tmp);

/* Normal binding is the second assertion */
  if (ADL__VSdef_kind_InfoArray[6].result != ADL__ASSERTION_ERROR)
    ADL__VSdef_kind_InfoArray[6].result = (VSdef_kind_NormalOutcome_353 ? ADL__ASSERTION_TRUE : ADL__ASSERTION_FALSE);
  ADL__VSdef_kind_InfoArray[6].evaluated = 1;
  ADL__VSdef_kind_InfoArray[6].value = (VSdef_kind_NormalOutcome_353 ? &TRUE_tmp : &FALSE_tmp);

/* Check ERROR condition */
  if (ADL__VSdef_kind_InfoArray[0].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_351 = ADL__VSdef_kind_InfoArray[0].error;

    goto REPORT_RESULT;
  }

if (ADL__VSdef_kind_InfoArray[6].result == ADL__ASSERTION_ERROR) {
  VSdef_kind_ACF_Result_351 = ADL__VSdef_kind_InfoArray[6].error;

    goto REPORT_RESULT;
  }


/* Check UNDEFINED condition */
  if (!VSdef_kind_ExceptionOutcome_354 && !VSdef_kind_NormalOutcome_353) {
  VSdef_kind_ACF_Result_351 = ADL__ACF_UNDEFINED;

    goto REPORT_RESULT;
  }


/* Check AMBIGUOUS condition */
  if (VSdef_kind_ExceptionOutcome_354 && VSdef_kind_NormalOutcome_353) {
  VSdef_kind_ACF_Result_351 = ADL__ACF_AMBIGUOUS;

    goto REPORT_RESULT;
  }


/* Evaluate assertions */
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 10,&VSdef_kind_ExceptionOutcome_354);
  ev_358_tmp_377 = ev_358;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 13,&ev_358_tmp_377);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[12]);

/* Evaluate user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_373 = user_exception_is("NOT_IMPLEMENTED", ev_358);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 12,&tmp_373);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[11]);

/* Evaluate !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_372 = !tmp_373;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 11,&tmp_372);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[9]);

/* Evaluate exception --> !user_exception_is("NOT_IMPLEMENTED", ev) */
  tmp_370 = (!VSdef_kind_ExceptionOutcome_354 || tmp_372);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 9,&tmp_370);
    ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 15,&VSdef_kind_ExceptionOutcome_354);
  ev_358_tmp_385 = ev_358;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 19,&ev_358_tmp_385);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[18]);

/* Evaluate system_exception(ev) */
  tmp_382 = system_exception(ev_358);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 18,&tmp_382);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[17]);

/* Evaluate !system_exception(ev) */
  tmp_381 = !tmp_382;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 17,&tmp_381);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[16]);

/* Evaluate !system_exception(ev) && !user_exception(ev) */
  tmp_380 = tmp_381;
  if (tmp_381) {
      ev_358_tmp_390 = ev_358;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 22,&ev_358_tmp_390);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[21]);

/* Evaluate user_exception(ev) */
  tmp_387 = user_exception(ev_358);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 21,&tmp_387);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[20]);

/* Evaluate !user_exception(ev) */
  tmp_386 = !tmp_387;
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 20,&tmp_386);
    tmp_380 = tmp_386;
  }
  else {
  ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 20, 22);
  }
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 16,&tmp_380);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[14]);

/* Evaluate exception --> !system_exception(ev) && !user_exception(ev) */
  tmp_378 = (!VSdef_kind_ExceptionOutcome_354 || tmp_380);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 14,&tmp_378);
    ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[23]);

/* Evaluate normally { ... } */
  if(VSdef_kind_NormalOutcome_353){
      ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 25,&VSdef_kind_RtnVal_352);
  ADL__VSdef_kind_assertionReport->exprMark(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_assertionReport->assrt_info[24]);

/* Evaluate is_correct_def_kind(return) */
  tmp_393 = is_correct_def_kind(VSdef_kind_RtnVal_352);
  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 24,&tmp_393);
  groupExpr_396 = (tmp_393);
  tmp_392 = (groupExpr_396);
  tmp_391 = tmp_392;
  }
  else {
    ADL__resetInfoStruct(ADL__VSdef_kind_InfoArray, 23, 25);
  tmp_391 = 1;
}

  ADL__setResultAndError(ADL__VSdef_kind_InfoArray, 23,&tmp_391);

/******************* Calculate and report results *******************/

/* Calculate ACF results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {

/* Calculate ACF result */
      if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__GENERAL_ASSERTION ||
       ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__NORMALLY_ASSERTION ||
       (ADL__VSdef_kind_InfoArray[forLoopIdx_1].kind == ADL__CONSTANT && ADL__VSdef_kind_InfoArray[forLoopIdx_1].level == 0))
        VSdef_kind_ACF_Result_351 = calculate_ACF_result(VSdef_kind_ACF_Result_351, ADL__VSdef_kind_InfoArray[forLoopIdx_1].result);
  }
REPORT_RESULT:

/* Assign ACF result */
  ADL__VSdef_kind_assertionReport->value = VSdef_kind_ACF_Result_351;
  ADL__VSdef_kind_assertionReport->parent->openReport(ADL__VSdef_kind_assertionReport->parent);

/* Report assertion results */
  for(forLoopIdx_1 = 0; forLoopIdx_1 < ADL__VSdef_kind_InfoArrayIdx; forLoopIdx_1++) {
    if(ADL__VSdef_kind_assertionReport->emitTest(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1])) {
     ADL__VSdef_kind_assertionReport->exprStart(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
      if(!ADL__VSdef_kind_InfoArray[forLoopIdx_1].testable || !ADL__VSdef_kind_InfoArray[forLoopIdx_1].evaluated) 
        ADL__unevaluatedPrintFunc(ADL__VSdef_kind_assertionReport->emitter);
      else if (ADL__VSdef_kind_InfoArray[forLoopIdx_1].result == ADL__ASSERTION_ERROR) 
        ADL__errorPrintFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].error, ADL__VSdef_kind_assertionReport->emitter);
      else
        ADL__VSdef_kind_InfoArray[forLoopIdx_1].emitFunc(ADL__VSdef_kind_InfoArray[forLoopIdx_1].value, ADL__VSdef_kind_assertionReport->emitter);
     ADL__VSdef_kind_assertionReport->exprEnd(ADL__VSdef_kind_assertionReport, &ADL__VSdef_kind_InfoArray[forLoopIdx_1]);
    }
  }

  return (VSdef_kind_RtnVal_352);
}


VSDefinitionKind (*ADL__VSdef_kind_wrapper)(VSEnvironment*, VSValueMemberDef_ptr) = VSdef_kind;

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter);
void ADL__emit_VSValueMemberDef_ptr (void* val, emitter_t emitter);
void ADL__emit_VSDefinitionKind (void* val, emitter_t emitter);

struct ADL__assertionReportStruct ADL__VSdef_kind_InfoArray[] = {
  {0, 0, 0, 0, 0, "exception := system_exception(ev) || user_exception(ev)", 0, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__EXCEPTION_BINDING, 0, ADL__emit_boolean },
  {0, 1, 0, 0, 0, "system_exception(ev) || user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 2, 1, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 3, 2, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 4, 1, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 5, 4, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {0, 6, 6, 0, 0, "normal := no_exception(ev)", 6, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMAL_BINDING, 0, ADL__emit_boolean },
  {0, 7, 6, 0, 0, "no_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {0, 8, 7, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {1, 9, 9, 0, 0, "exception --> !user_exception_is(\"NOT_IMPLEMENTED\", ev)", 9, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {1, 10, 9, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 11, 9, 0, 0, "!user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 12, 11, 0, 0, "user_exception_is(\"NOT_IMPLEMENTED\", ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {1, 13, 12, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 14, 14, 0, 0, "exception --> !system_exception(ev) && !user_exception(ev)", 14, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__GENERAL_ASSERTION, 0, ADL__emit_boolean },
  {2, 15, 14, 0, 0, "exception", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 16, 14, 0, 0, "!system_exception(ev) && !user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 17, 16, 0, 0, "!system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 18, 17, 0, 0, "system_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 19, 18, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {2, 20, 16, 0, 0, "!user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 21, 20, 0, 0, "user_exception(ev)", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 3, 1, 1, ADL__SUBEXPRESSION, 0, ADL__emit_boolean },
  {2, 22, 21, 0, 0, "ev", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 4, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSEnvironment_P },
  {3, 23, 23, 0, 0, "normally {....}", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 0, 1, 1, ADL__NORMALLY_ASSERTION, 0, ADL__emit_boolean },
  {4, 24, 23, 0, 0, "is_correct_def_kind(return)", 24, ADL__ASSERTION_UNEVALUATED, 0, 0, 1, 1, 1, ADL__NESTED_ASSERTION, 0, ADL__emit_boolean },
  {4, 25, 24, 0, 0, "return", -1, ADL__ASSERTION_UNEVALUATED, 0, 0, 2, 1, 0, ADL__SUBEXPRESSION, 0, ADL__emit_VSDefinitionKind }
};


unsigned int ADL__VSdef_kind_InfoArrayIdx = 26;

struct ADL__reportAssertion *ADL__VSdef_kind_assertionReport = 0;
