/* ADL test driver from t1.tdr
 *
 * test VSdestroy(testPOA, etherealize, wait, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop value */
static struct ADL__propertyValue ADL__prop_values_251[] = {
    {"valid", PtestPOA_value_valid, 0},
    {0, 0, 0}
};

/* values for literal variable etherealize */
static VSBoolean ADL__litvar_val_253[] = {
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_252[] = {
    {"1", 0, ADL__litvar_val_253},
    {"0", 1, ADL__litvar_val_253},
    {0, 0, 0}
};

/* values for literal variable wait */
static VSBoolean ADL__litvar_val_255[] = {
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_254[] = {
    {"1", 0, ADL__litvar_val_255},
    {"0", 1, ADL__litvar_val_255},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_256[] = {
    {"value", "prop", ADL__prop_values_251, 1},
    {"etherealize", "litvar", ADL__litvar_info_252, 2},
    {"wait", "litvar", ADL__litvar_info_254, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 3

static struct ADL__variableInfo ADL__var_info_261[5] = {
    {"testPOA", "VSPOA_ptr *", ADL__prop_info_256, 0, 1},
    {"etherealize", "VSBoolean", ADL__prop_info_256, 1, 1},
    {"wait", "VSBoolean", ADL__prop_info_256, 2, 1},
    {"env", "VSEnvironment *", ADL__prop_info_256, 3, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 4


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSdestroy_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSADAPTER
#define ADL__PRINT_VSADAPTER
void (*ADL__print_VSAdapter)(VSAdapter, emitter_t) = 0;

#endif /* ADL__PRINT_VSADAPTER */
#ifndef ADL__PRINT_VSPOAMANAGER_PTR_P
#define ADL__PRINT_VSPOAMANAGER_PTR_P
void (*ADL__print_VSPOAManager_ptr_P)(VSPOAManager_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOAMANAGER_PTR_P */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSPOA_PTR_P
#define ADL__PRINT_VSPOA_PTR_P
void (*ADL__print_VSPOA_ptr_P)(VSPOA_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOA_PTR_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */

void ADL__emit_VSAdapter (void* val, emitter_t emitter)
{
  VSAdapter tmp;

  if (ADL__print_VSAdapter != 0) {
    tmp = *(VSAdapter*) val;
    ADL__print_VSAdapter(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOAManager_ptr_P (void* val, emitter_t emitter)
{
  VSPOAManager_ptr *tmp;

  if (ADL__print_VSPOAManager_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOAManager_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSPOA_ptr_P (void* val, emitter_t emitter)
{
  VSPOA_ptr *tmp;

  if (ADL__print_VSPOA_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOA_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {1, 2, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSPOA_ptr *testPOA_257;
    VSBoolean etherealize_258;
    VSBoolean wait_259;
    VSEnvironment *env_260;
    VSBoolean fut_return_250;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSdestroy_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSdestroy_InfoArrayIdx,
        ADL__VSdestroy_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_testPOA(&testPOA_257, ADL__prop_values_251[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSPOA_ptr_P(&testPOA_257, rf->variableReport->emitVariable);

       etherealize_258 = ADL__litvar_val_253[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 1, tvec + 1, 1);
       ADL__emit_VSBoolean(&etherealize_258, rf->variableReport->emitVariable);

       wait_259 = ADL__litvar_val_255[tvec[2]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 2, tvec + 2, 1);
       ADL__emit_VSBoolean(&wait_259, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_env(&env_260)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
       ADL__emit_VSEnvironment_P(&env_260, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSdestroy_assertionReport = rf->assertionReport;
       fut_return_250 = ADL__ACF_VSdestroy(testPOA_257, etherealize_258, wait_259, env_260);
       test_value = ADL__VSdestroy_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_env(&env_260);
SKIP_3:
       relvec[2] = 1;	/* relinquish succeeds for wait_259 */
       relvec[1] = 1;	/* relinquish succeeds for etherealize_258 */
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_testPOA(&testPOA_257, ADL__prop_values_251[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_261,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSdestroy_head);

    return 0;
}


struct ADL__Directive_info VSdestroy1_info = {
    N_VARS,
    ADL__var_info_261
};

struct ADL__TDD_info ADL__test_info = {
    4,
    &ADL__VSdestroy_InfoArrayIdx,
    ADL__VSdestroy_InfoArray,
    ADL__test_driver,
    "VSdestroy",
    "VSdestroy1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSdestroy1",
    "t1_tr.rif",
    &VSdestroy1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

