/* ADL test driver from t1.tdr
 *
 * test VScreate_implicit_activation_policy(implicitAct, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


static struct ADL__propertyInfo ADL__prop_info_648[] = {
    {0, 0, 0}
};
#define TVEC_SIZE 0

static struct ADL__variableInfo ADL__var_info_651[3] = {
    {"implicitAct", "VSImplicitActivationPolicyValue", ADL__prop_info_648, 0, 0},
    {"env", "VSEnvironment *", ADL__prop_info_648, 0, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScreate_implicit_activation_policy_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSTHREADPOLICYVALUE
#define ADL__PRINT_VSTHREADPOLICYVALUE
void (*ADL__print_VSThreadPolicyValue)(VSThreadPolicyValue, emitter_t) = 0;

#endif /* ADL__PRINT_VSTHREADPOLICYVALUE */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSTHREADPOLICY_VAR_P
#define ADL__PRINT_VSTHREADPOLICY_VAR_P
void (*ADL__print_VSThreadPolicy_var_P)(VSThreadPolicy_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTHREADPOLICY_VAR_P */
#ifndef ADL__PRINT_VSLIFESPANPOLICYVALUE
#define ADL__PRINT_VSLIFESPANPOLICYVALUE
void (*ADL__print_VSLifespanPolicyValue)(VSLifespanPolicyValue, emitter_t) = 0;

#endif /* ADL__PRINT_VSLIFESPANPOLICYVALUE */
#ifndef ADL__PRINT_VSLIFESPANPOLICY_VAR_P
#define ADL__PRINT_VSLIFESPANPOLICY_VAR_P
void (*ADL__print_VSLifespanPolicy_var_P)(VSLifespanPolicy_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSLIFESPANPOLICY_VAR_P */
#ifndef ADL__PRINT_VSIDUNIQUENESSPOLICYVALUE
#define ADL__PRINT_VSIDUNIQUENESSPOLICYVALUE
void (*ADL__print_VSIdUniquenessPolicyValue)(VSIdUniquenessPolicyValue, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDUNIQUENESSPOLICYVALUE */
#ifndef ADL__PRINT_VSIDUNIQUENESSPOLICY_VAR_P
#define ADL__PRINT_VSIDUNIQUENESSPOLICY_VAR_P
void (*ADL__print_VSIdUniquenessPolicy_var_P)(VSIdUniquenessPolicy_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDUNIQUENESSPOLICY_VAR_P */
#ifndef ADL__PRINT_VSIDASSIGNMENTPOLICYVALUE
#define ADL__PRINT_VSIDASSIGNMENTPOLICYVALUE
void (*ADL__print_VSIdAssignmentPolicyValue)(VSIdAssignmentPolicyValue, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDASSIGNMENTPOLICYVALUE */
#ifndef ADL__PRINT_VSIDASSIGNMENTPOLICY_VAR_P
#define ADL__PRINT_VSIDASSIGNMENTPOLICY_VAR_P
void (*ADL__print_VSIdAssignmentPolicy_var_P)(VSIdAssignmentPolicy_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSIDASSIGNMENTPOLICY_VAR_P */
#ifndef ADL__PRINT_VSIMPLICITACTIVATIONPOLICYVALUE
#define ADL__PRINT_VSIMPLICITACTIVATIONPOLICYVALUE
void (*ADL__print_VSImplicitActivationPolicyValue)(VSImplicitActivationPolicyValue, emitter_t) = 0;

#endif /* ADL__PRINT_VSIMPLICITACTIVATIONPOLICYVALUE */
#ifndef ADL__PRINT_VSIMPLICITACTIVATIONPOLICY_VAR_P
#define ADL__PRINT_VSIMPLICITACTIVATIONPOLICY_VAR_P
void (*ADL__print_VSImplicitActivationPolicy_var_P)(VSImplicitActivationPolicy_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSIMPLICITACTIVATIONPOLICY_VAR_P */
#ifndef ADL__PRINT_VSSERVANTRETENTIONPOLICYVALUE
#define ADL__PRINT_VSSERVANTRETENTIONPOLICYVALUE
void (*ADL__print_VSServantRetentionPolicyValue)(VSServantRetentionPolicyValue, emitter_t) = 0;

#endif /* ADL__PRINT_VSSERVANTRETENTIONPOLICYVALUE */
#ifndef ADL__PRINT_VSSERVANTRETENTIONPOLICY_VAR_P
#define ADL__PRINT_VSSERVANTRETENTIONPOLICY_VAR_P
void (*ADL__print_VSServantRetentionPolicy_var_P)(VSServantRetentionPolicy_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSSERVANTRETENTIONPOLICY_VAR_P */
#ifndef ADL__PRINT_VSREQUESTPROCESSINGPOLICYVALUE
#define ADL__PRINT_VSREQUESTPROCESSINGPOLICYVALUE
void (*ADL__print_VSRequestProcessingPolicyValue)(VSRequestProcessingPolicyValue, emitter_t) = 0;

#endif /* ADL__PRINT_VSREQUESTPROCESSINGPOLICYVALUE */
#ifndef ADL__PRINT_VSREQUESTPROCESSINGPOLICY_VAR_P
#define ADL__PRINT_VSREQUESTPROCESSINGPOLICY_VAR_P
void (*ADL__print_VSRequestProcessingPolicy_var_P)(VSRequestProcessingPolicy_var*, emitter_t) = 0;

#endif /* ADL__PRINT_VSREQUESTPROCESSINGPOLICY_VAR_P */

void ADL__emit_VSThreadPolicyValue (void* val, emitter_t emitter)
{
  VSThreadPolicyValue tmp;

  if (ADL__print_VSThreadPolicyValue != 0) {
    tmp = *(VSThreadPolicyValue*) val;
    ADL__print_VSThreadPolicyValue(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSThreadPolicy_var_P (void* val, emitter_t emitter)
{
  VSThreadPolicy_var *tmp;

  if (ADL__print_VSThreadPolicy_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSThreadPolicy_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSLifespanPolicyValue (void* val, emitter_t emitter)
{
  VSLifespanPolicyValue tmp;

  if (ADL__print_VSLifespanPolicyValue != 0) {
    tmp = *(VSLifespanPolicyValue*) val;
    ADL__print_VSLifespanPolicyValue(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSLifespanPolicy_var_P (void* val, emitter_t emitter)
{
  VSLifespanPolicy_var *tmp;

  if (ADL__print_VSLifespanPolicy_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSLifespanPolicy_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIdUniquenessPolicyValue (void* val, emitter_t emitter)
{
  VSIdUniquenessPolicyValue tmp;

  if (ADL__print_VSIdUniquenessPolicyValue != 0) {
    tmp = *(VSIdUniquenessPolicyValue*) val;
    ADL__print_VSIdUniquenessPolicyValue(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSIdUniquenessPolicy_var_P (void* val, emitter_t emitter)
{
  VSIdUniquenessPolicy_var *tmp;

  if (ADL__print_VSIdUniquenessPolicy_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSIdUniquenessPolicy_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSIdAssignmentPolicyValue (void* val, emitter_t emitter)
{
  VSIdAssignmentPolicyValue tmp;

  if (ADL__print_VSIdAssignmentPolicyValue != 0) {
    tmp = *(VSIdAssignmentPolicyValue*) val;
    ADL__print_VSIdAssignmentPolicyValue(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSIdAssignmentPolicy_var_P (void* val, emitter_t emitter)
{
  VSIdAssignmentPolicy_var *tmp;

  if (ADL__print_VSIdAssignmentPolicy_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSIdAssignmentPolicy_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSImplicitActivationPolicyValue (void* val, emitter_t emitter)
{
  VSImplicitActivationPolicyValue tmp;

  if (ADL__print_VSImplicitActivationPolicyValue != 0) {
    tmp = *(VSImplicitActivationPolicyValue*) val;
    ADL__print_VSImplicitActivationPolicyValue(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSImplicitActivationPolicy_var_P (void* val, emitter_t emitter)
{
  VSImplicitActivationPolicy_var *tmp;

  if (ADL__print_VSImplicitActivationPolicy_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSImplicitActivationPolicy_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSServantRetentionPolicyValue (void* val, emitter_t emitter)
{
  VSServantRetentionPolicyValue tmp;

  if (ADL__print_VSServantRetentionPolicyValue != 0) {
    tmp = *(VSServantRetentionPolicyValue*) val;
    ADL__print_VSServantRetentionPolicyValue(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSServantRetentionPolicy_var_P (void* val, emitter_t emitter)
{
  VSServantRetentionPolicy_var *tmp;

  if (ADL__print_VSServantRetentionPolicy_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSServantRetentionPolicy_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRequestProcessingPolicyValue (void* val, emitter_t emitter)
{
  VSRequestProcessingPolicyValue tmp;

  if (ADL__print_VSRequestProcessingPolicyValue != 0) {
    tmp = *(VSRequestProcessingPolicyValue*) val;
    ADL__print_VSRequestProcessingPolicyValue(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSRequestProcessingPolicy_var_P (void* val, emitter_t emitter)
{
  VSRequestProcessingPolicy_var *tmp;

  if (ADL__print_VSRequestProcessingPolicy_var_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSRequestProcessingPolicy_var_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[1];
    enum ADL__ACF_result test_value;
    VSImplicitActivationPolicyValue implicitAct_649;
    VSEnvironment *env_650;
    VSImplicitActivationPolicy_var *fut_return_647;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    tvec[0] = 0;
    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScreate_implicit_activation_policy_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScreate_implicit_activation_policy_InfoArrayIdx,
        ADL__VScreate_implicit_activation_policy_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_implicitAct(&implicitAct_649)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 0);
       ADL__emit_VSImplicitActivationPolicyValue(&implicitAct_649, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(0);
       if (!provide_env(&env_650)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 0, 0);
       ADL__emit_VSEnvironment_P(&env_650, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScreate_implicit_activation_policy_assertionReport = rf->assertionReport;
       fut_return_647 = ADL__ACF_VScreate_implicit_activation_policy(implicitAct_649, env_650);
       test_value = ADL__VScreate_implicit_activation_policy_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(0);
       relvec[1] = relinquish_env(&env_650);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_implicitAct(&implicitAct_649);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScreate_implicit_activation_policy_head);

    return 0;
}


struct ADL__Directive_info VScreate_implicit_activation_policy1_info = {
    N_VARS,
    ADL__var_info_651
};

struct ADL__TDD_info ADL__test_info = {
    1,
    &ADL__VScreate_implicit_activation_policy_InfoArrayIdx,
    ADL__VScreate_implicit_activation_policy_InfoArray,
    ADL__test_driver,
    "VScreate_implicit_activation_policy",
    "VScreate_implicit_activation_policy1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScreate_implicit_activation_policy1",
    "t1_tr.rif",
    &VScreate_implicit_activation_policy1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

