/*
 *
 * t1_acf.h -- generated automatically by ADLT
 *
 * This file contains declarations of Assertion-Checking Functions
 * of module "t1"
 *
 */

#ifndef T1_ACF_H
#define T1_ACF_H

#include <adl_reporting.h>
#include <ADL_Standard.h>
#include "corba_defs_aux.h"
#include "t1_aux.h"
#include "t1.h"


VSThreadPolicy_var *ADL__ACF_VScreate_thread_policy (VSThreadPolicyValue polVal_21, VSEnvironment *ev_10);
extern VSThreadPolicy_var *(*ADL__VScreate_thread_policy_wrapper)(VSThreadPolicyValue, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScreate_thread_policy_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_thread_policy_InfoArray[];
extern unsigned int ADL__VScreate_thread_policy_InfoArrayIdx;


VSThreadPolicyValue ADL__ACF_VSThread_value (VSEnvironment *ev_51);
extern VSThreadPolicyValue (*ADL__VSThread_value_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSThread_value_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSThread_value_InfoArray[];
extern unsigned int ADL__VSThread_value_InfoArrayIdx;


VSLifespanPolicy_var *ADL__ACF_VScreate_lifespan_policy (VSLifespanPolicyValue polVal_108, VSEnvironment *ev_97);
extern VSLifespanPolicy_var *(*ADL__VScreate_lifespan_policy_wrapper)(VSLifespanPolicyValue, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScreate_lifespan_policy_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_lifespan_policy_InfoArray[];
extern unsigned int ADL__VScreate_lifespan_policy_InfoArrayIdx;


VSLifespanPolicyValue ADL__ACF_VSLifespan_value (VSEnvironment *ev_138);
extern VSLifespanPolicyValue (*ADL__VSLifespan_value_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSLifespan_value_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSLifespan_value_InfoArray[];
extern unsigned int ADL__VSLifespan_value_InfoArrayIdx;


VSIdUniquenessPolicy_var *ADL__ACF_VScreate_id_uniqueness_policy (VSIdUniquenessPolicyValue polVal_195, VSEnvironment *ev_184);
extern VSIdUniquenessPolicy_var *(*ADL__VScreate_id_uniqueness_policy_wrapper)(VSIdUniquenessPolicyValue, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScreate_id_uniqueness_policy_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_id_uniqueness_policy_InfoArray[];
extern unsigned int ADL__VScreate_id_uniqueness_policy_InfoArrayIdx;


VSIdUniquenessPolicyValue ADL__ACF_VSIdUniqueness_value (VSEnvironment *ev_225);
extern VSIdUniquenessPolicyValue (*ADL__VSIdUniqueness_value_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSIdUniqueness_value_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSIdUniqueness_value_InfoArray[];
extern unsigned int ADL__VSIdUniqueness_value_InfoArrayIdx;


VSIdAssignmentPolicy_var *ADL__ACF_VScreate_id_assignment_policy (VSIdAssignmentPolicyValue polVal_282, VSEnvironment *ev_271);
extern VSIdAssignmentPolicy_var *(*ADL__VScreate_id_assignment_policy_wrapper)(VSIdAssignmentPolicyValue, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScreate_id_assignment_policy_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_id_assignment_policy_InfoArray[];
extern unsigned int ADL__VScreate_id_assignment_policy_InfoArrayIdx;


VSIdAssignmentPolicyValue ADL__ACF_VSIdAssignment_value (VSEnvironment *ev_312);
extern VSIdAssignmentPolicyValue (*ADL__VSIdAssignment_value_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSIdAssignment_value_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSIdAssignment_value_InfoArray[];
extern unsigned int ADL__VSIdAssignment_value_InfoArrayIdx;


VSImplicitActivationPolicy_var *ADL__ACF_VScreate_implicit_activation_policy (VSImplicitActivationPolicyValue polVal_369, VSEnvironment *ev_358);
extern VSImplicitActivationPolicy_var *(*ADL__VScreate_implicit_activation_policy_wrapper)(VSImplicitActivationPolicyValue, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScreate_implicit_activation_policy_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_implicit_activation_policy_InfoArray[];
extern unsigned int ADL__VScreate_implicit_activation_policy_InfoArrayIdx;


VSImplicitActivationPolicyValue ADL__ACF_VSImplicitActivation_value (VSEnvironment *ev_399);
extern VSImplicitActivationPolicyValue (*ADL__VSImplicitActivation_value_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSImplicitActivation_value_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSImplicitActivation_value_InfoArray[];
extern unsigned int ADL__VSImplicitActivation_value_InfoArrayIdx;


VSServantRetentionPolicy_var *ADL__ACF_VScreate_servant_retention_policy (VSServantRetentionPolicyValue polVal_456, VSEnvironment *ev_445);
extern VSServantRetentionPolicy_var *(*ADL__VScreate_servant_retention_policy_wrapper)(VSServantRetentionPolicyValue, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScreate_servant_retention_policy_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_servant_retention_policy_InfoArray[];
extern unsigned int ADL__VScreate_servant_retention_policy_InfoArrayIdx;


VSServantRetentionPolicyValue ADL__ACF_VSServantRetention_value (VSEnvironment *ev_486);
extern VSServantRetentionPolicyValue (*ADL__VSServantRetention_value_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSServantRetention_value_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSServantRetention_value_InfoArray[];
extern unsigned int ADL__VSServantRetention_value_InfoArrayIdx;


VSRequestProcessingPolicy_var *ADL__ACF_VScreate_request_processing_policy (VSRequestProcessingPolicyValue polVal_543, VSEnvironment *ev_532);
extern VSRequestProcessingPolicy_var *(*ADL__VScreate_request_processing_policy_wrapper)(VSRequestProcessingPolicyValue, VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VScreate_request_processing_policy_assertionReport;
extern struct ADL__assertionReportStruct ADL__VScreate_request_processing_policy_InfoArray[];
extern unsigned int ADL__VScreate_request_processing_policy_InfoArrayIdx;


VSRequestProcessingPolicyValue ADL__ACF_VSRequestProcessing_value (VSEnvironment *ev_573);
extern VSRequestProcessingPolicyValue (*ADL__VSRequestProcessing_value_wrapper)(VSEnvironment*);

extern struct ADL__reportAssertion *ADL__VSRequestProcessing_value_assertionReport;
extern struct ADL__assertionReportStruct ADL__VSRequestProcessing_value_InfoArray[];
extern unsigned int ADL__VSRequestProcessing_value_InfoArrayIdx;


#endif
