/* ADL test driver from t1.tdr
 *
 * test VSdeactivate(poamgr_inactive, wait, etherealize, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop state */
static struct ADL__propertyValue ADL__prop_values_293[] = {
    {"active", Ppoamgr_inactive_state_active, 0},
    {"hold", Ppoamgr_inactive_state_hold, 0},
    {"discard", Ppoamgr_inactive_state_discard, 0},
    {0, 0, 0}
};

/* values for literal variable wait */
static VSBoolean ADL__litvar_val_279[] = {
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_278[] = {
    {"1", 0, ADL__litvar_val_279},
    {"0", 1, ADL__litvar_val_279},
    {0, 0, 0}
};

/* values for literal variable etherealize */
static VSBoolean ADL__litvar_val_295[] = {
    1,
    0,
};

static struct ADL__propertyValue ADL__litvar_info_294[] = {
    {"1", 0, ADL__litvar_val_295},
    {"0", 1, ADL__litvar_val_295},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_296[] = {
    {"state", "prop", ADL__prop_values_293, 3},
    {"wait", "litvar", ADL__litvar_info_278, 2},
    {"etherealize", "litvar", ADL__litvar_info_294, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 3

static struct ADL__variableInfo ADL__var_info_301[5] = {
    {"poamgr_inactive", "VSPOAManager_ptr *", ADL__prop_info_296, 0, 1},
    {"wait", "VSBoolean", ADL__prop_info_296, 1, 1},
    {"etherealize", "VSBoolean", ADL__prop_info_296, 2, 1},
    {"env", "VSEnvironment *", ADL__prop_info_296, 3, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 4


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSdeactivate_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSPOAMANAGER_PTR_P
#define ADL__PRINT_VSPOAMANAGER_PTR_P
void (*ADL__print_VSPOAManager_ptr_P)(VSPOAManager_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSPOAMANAGER_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSSTATE
#define ADL__PRINT_VSSTATE
void (*ADL__print_VSState)(VSState, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTATE */

void ADL__emit_VSPOAManager_ptr_P (void* val, emitter_t emitter)
{
  VSPOAManager_ptr *tmp;

  if (ADL__print_VSPOAManager_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSPOAManager_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSState (void* val, emitter_t emitter)
{
  VSState tmp;

  if (ADL__print_VSState != 0) {
    tmp = *(VSState*) val;
    ADL__print_VSState(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {3, 2, 2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSPOAManager_ptr *poamgr_inactive_297;
    VSBoolean wait_298;
    VSBoolean etherealize_299;
    VSEnvironment *env_300;
    VSBoolean fut_return_292;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSdeactivate_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSdeactivate_InfoArrayIdx,
        ADL__VSdeactivate_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_poamgr_inactive(&poamgr_inactive_297, ADL__prop_values_293[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSPOAManager_ptr_P(&poamgr_inactive_297, rf->variableReport->emitVariable);

       wait_298 = ADL__litvar_val_279[tvec[1]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 1, tvec + 1, 1);
       ADL__emit_VSBoolean(&wait_298, rf->variableReport->emitVariable);

       etherealize_299 = ADL__litvar_val_295[tvec[2]];
       rf->variableReport->saveVariableInfo(rf->variableReport, 1, 2, tvec + 2, 1);
       ADL__emit_VSBoolean(&etherealize_299, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(3);
       if (!provide_env(&env_300)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_3;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 3, tvec + 3, 0);
       ADL__emit_VSEnvironment_P(&env_300, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSdeactivate_assertionReport = rf->assertionReport;
       fut_return_292 = ADL__ACF_VSdeactivate(poamgr_inactive_297, wait_298, etherealize_299, env_300);
       test_value = ADL__VSdeactivate_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(3);
       relvec[3] = relinquish_env(&env_300);
SKIP_3:
       relvec[2] = 1;	/* relinquish succeeds for etherealize_299 */
       relvec[1] = 1;	/* relinquish succeeds for wait_298 */
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_poamgr_inactive(&poamgr_inactive_297, ADL__prop_values_293[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_301,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSdeactivate_head);

    return 0;
}


struct ADL__Directive_info VSdeactivate1_info = {
    N_VARS,
    ADL__var_info_301
};

struct ADL__TDD_info ADL__test_info = {
    12,
    &ADL__VSdeactivate_InfoArrayIdx,
    ADL__VSdeactivate_InfoArray,
    ADL__test_driver,
    "VSdeactivate",
    "VSdeactivate1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSdeactivate1",
    "t1_tr.rif",
    &VSdeactivate1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

