/* ADL test driver from t1.tdr
 *
 * test VSBooleanToAny(b, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop boolean_values */
static struct ADL__propertyValue ADL__prop_values_652[] = {
    {"true", Pboolean_values_true, 0},
    {"false", Pboolean_values_false, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_653[] = {
    {"=boolean_values", "prop", ADL__prop_values_652, 2},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_656[3] = {
    {"b", "VSBoolean", ADL__prop_info_653, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_653, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VSBooleanToAny_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSSHORT
#define ADL__PRINT_VSSHORT
void (*ADL__print_VSShort)(VSShort, emitter_t) = 0;

#endif /* ADL__PRINT_VSSHORT */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSANY_P
#define ADL__PRINT_VSANY_P
void (*ADL__print_VSAny_P)(VSAny*, emitter_t) = 0;

#endif /* ADL__PRINT_VSANY_P */
#ifndef ADL__PRINT_VSUSHORT
#define ADL__PRINT_VSUSHORT
void (*ADL__print_VSUShort)(VSUShort, emitter_t) = 0;

#endif /* ADL__PRINT_VSUSHORT */
#ifndef ADL__PRINT_VSLONG
#define ADL__PRINT_VSLONG
void (*ADL__print_VSLong)(VSLong, emitter_t) = 0;

#endif /* ADL__PRINT_VSLONG */
#ifndef ADL__PRINT_VSULONG
#define ADL__PRINT_VSULONG
void (*ADL__print_VSULong)(VSULong, emitter_t) = 0;

#endif /* ADL__PRINT_VSULONG */
#ifndef ADL__PRINT_VSFLOAT
#define ADL__PRINT_VSFLOAT
void (*ADL__print_VSFloat)(VSFloat, emitter_t) = 0;

#endif /* ADL__PRINT_VSFLOAT */
#ifndef ADL__PRINT_VSDOUBLE
#define ADL__PRINT_VSDOUBLE
void (*ADL__print_VSDouble)(VSDouble, emitter_t) = 0;

#endif /* ADL__PRINT_VSDOUBLE */
#ifndef ADL__PRINT_VSSTRING
#define ADL__PRINT_VSSTRING
void (*ADL__print_VSString)(VSString, emitter_t) = 0;

#endif /* ADL__PRINT_VSSTRING */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSOCTET
#define ADL__PRINT_VSOCTET
void (*ADL__print_VSOctet)(VSOctet, emitter_t) = 0;

#endif /* ADL__PRINT_VSOCTET */
#ifndef ADL__PRINT_VSCHAR
#define ADL__PRINT_VSCHAR
void (*ADL__print_VSChar)(VSChar, emitter_t) = 0;

#endif /* ADL__PRINT_VSCHAR */

void ADL__emit_VSShort (void* val, emitter_t emitter)
{
  VSShort tmp;

  if (ADL__print_VSShort != 0) {
    tmp = *(VSShort*) val;
    ADL__print_VSShort(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSAny_P (void* val, emitter_t emitter)
{
  VSAny *tmp;

  if (ADL__print_VSAny_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSAny_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSUShort (void* val, emitter_t emitter)
{
  VSUShort tmp;

  if (ADL__print_VSUShort != 0) {
    tmp = *(VSUShort*) val;
    ADL__print_VSUShort(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSLong (void* val, emitter_t emitter)
{
  VSLong tmp;

  if (ADL__print_VSLong != 0) {
    tmp = *(VSLong*) val;
    ADL__print_VSLong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSULong (void* val, emitter_t emitter)
{
  VSULong tmp;

  if (ADL__print_VSULong != 0) {
    tmp = *(VSULong*) val;
    ADL__print_VSULong(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSFloat (void* val, emitter_t emitter)
{
  VSFloat tmp;

  if (ADL__print_VSFloat != 0) {
    tmp = *(VSFloat*) val;
    ADL__print_VSFloat(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSDouble (void* val, emitter_t emitter)
{
  VSDouble tmp;

  if (ADL__print_VSDouble != 0) {
    tmp = *(VSDouble*) val;
    ADL__print_VSDouble(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSString (void* val, emitter_t emitter)
{
  VSString tmp;

  if (ADL__print_VSString != 0) {
    tmp = *(VSString*) val;
    ADL__print_VSString(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSOctet (void* val, emitter_t emitter)
{
  VSOctet tmp;

  if (ADL__print_VSOctet != 0) {
    tmp = *(VSOctet*) val;
    ADL__print_VSOctet(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSChar (void* val, emitter_t emitter)
{
  VSChar tmp;

  if (ADL__print_VSChar != 0) {
    tmp = *(VSChar*) val;
    ADL__print_VSChar(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {2};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSBoolean b_654;
    VSEnvironment *env_655;
    VSAny *fut_return_651;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VSBooleanToAny_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VSBooleanToAny_InfoArrayIdx,
        ADL__VSBooleanToAny_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_b(&b_654, ADL__prop_values_652[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSBoolean(&b_654, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_655)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_655, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VSBooleanToAny_assertionReport = rf->assertionReport;
       fut_return_651 = ADL__ACF_VSBooleanToAny(b_654, env_655);
       test_value = ADL__VSBooleanToAny_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_env(&env_655);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_b(&b_654, ADL__prop_values_652[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_656,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VSBooleanToAny_head);

    return 0;
}


struct ADL__Directive_info VSBooleanToAny1_info = {
    N_VARS,
    ADL__var_info_656
};

struct ADL__TDD_info ADL__test_info = {
    2,
    &ADL__VSBooleanToAny_InfoArrayIdx,
    ADL__VSBooleanToAny_InfoArray,
    ADL__test_driver,
    "VSBooleanToAny",
    "VSBooleanToAny1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VSBooleanToAny1",
    "t1_tr.rif",
    &VSBooleanToAny1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

