/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int ReleaseAny(VSAny *);

extern int IsAnyToShortEqual(VSAny *, VSShort);

extern int IsAnyToUShortEqual(VSAny *, VSUShort);

extern int IsAnyToLongEqual(VSAny *, VSLong);

extern int IsAnyToULongEqual(VSAny *, VSULong);

extern int IsAnyToFloatEqual(VSAny *, VSFloat);

extern int IsAnyToDoubleEqual(VSAny *, VSDouble);

extern int IsAnyToUnboundStringEqual(VSAny *, VSString);

extern int IsAnyToBoundStringEqual(VSAny *, VSString);

extern int IsAnyToAnyEqual(VSAny *, VSAny *);

extern int IsAnyToBooleanEqual(VSAny *, VSBoolean);

extern int IsAnyToOctetEqual(VSAny *, VSOctet);

extern int IsAnyToCharEqual(VSAny *, VSChar);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSShort)(VSShort, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSAny_P)(VSAny*, emitter_t);
extern void (*ADL__print_VSUShort)(VSUShort, emitter_t);
extern void (*ADL__print_VSLong)(VSLong, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSFloat)(VSFloat, emitter_t);
extern void (*ADL__print_VSDouble)(VSDouble, emitter_t);
extern void (*ADL__print_VSString)(VSString, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSOctet)(VSOctet, emitter_t);
extern void (*ADL__print_VSChar)(VSChar, emitter_t);

/* Declarations of wrapper of FUT */
extern VSAny *(*ADL__VSShortToAny_wrapper)(VSShort, VSEnvironment*);
extern VSAny *(*ADL__VSUShortToAny_wrapper)(VSUShort, VSEnvironment*);
extern VSAny *(*ADL__VSLongToAny_wrapper)(VSLong, VSEnvironment*);
extern VSAny *(*ADL__VSULongToAny_wrapper)(VSULong, VSEnvironment*);
extern VSAny *(*ADL__VSFloatToAny_wrapper)(VSFloat, VSEnvironment*);
extern VSAny *(*ADL__VSDoubleToAny_wrapper)(VSDouble, VSEnvironment*);
extern VSAny *(*ADL__VSUnboundStringToAny_wrapper)(VSString, VSEnvironment*);
extern VSAny *(*ADL__VSBooleanToAny_wrapper)(VSBoolean, VSEnvironment*);
extern VSAny *(*ADL__VSOctetToAny_wrapper)(VSOctet, VSEnvironment*);
extern VSAny *(*ADL__VSCharToAny_wrapper)(VSChar, VSEnvironment*);

#endif
