/* ADL test driver from t1.tdr
 *
 * test VScontext_is_nil(context_ptr, env)
 */

#include "t1_tdr.h"
#include "t1_acf.h"
#include "t1_acf.h"


/* values for prop v */
static struct ADL__propertyValue ADL__prop_values_639[] = {
    {"valid", Pcontext_ptr_v_valid, 0},
    {"nil", Pcontext_ptr_v_nil, 0},
    {"null", Pcontext_ptr_v_null, 0},
    {"invalid", Pcontext_ptr_v_invalid, 0},
    {0, 0, 0}
};

static struct ADL__propertyInfo ADL__prop_info_640[] = {
    {"v", "prop", ADL__prop_values_639, 4},
    {0, 0, 0}
};
#define TVEC_SIZE 1

static struct ADL__variableInfo ADL__var_info_643[3] = {
    {"context_ptr", "VSContext_ptr *", ADL__prop_info_640, 0, 1},
    {"env", "VSEnvironment *", ADL__prop_info_640, 1, 0},
    {0, 0, 0, TVEC_SIZE, 0}
};
#define N_VARS 2


extern struct ADL__TDD_info ADL__test_info;
struct ADL__FUNC_STATE ADL__VScontext_is_nil_head = {
    &ADL__test_info,
    0,
    0,
    0
};



/* Variables for all types of print functions */
#ifndef ADL__PRINT_VSOBJECT_PTR_P
#define ADL__PRINT_VSOBJECT_PTR_P
void (*ADL__print_VSObject_ptr_P)(VSObject_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSOBJECT_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_P
#define ADL__PRINT_VSENVIRONMENT_P
void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_P */
#ifndef ADL__PRINT_VSBOOLEAN
#define ADL__PRINT_VSBOOLEAN
void (*ADL__print_VSBoolean)(VSBoolean, emitter_t) = 0;

#endif /* ADL__PRINT_VSBOOLEAN */
#ifndef ADL__PRINT_VSNAMEDVALUE_PTR_P
#define ADL__PRINT_VSNAMEDVALUE_PTR_P
void (*ADL__print_VSNamedValue_ptr_P)(VSNamedValue_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSNAMEDVALUE_PTR_P */
#ifndef ADL__PRINT_VSTYPECODE_PTR_P
#define ADL__PRINT_VSTYPECODE_PTR_P
void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSTYPECODE_PTR_P */
#ifndef ADL__PRINT_VSENVIRONMENT_PTR_P
#define ADL__PRINT_VSENVIRONMENT_PTR_P
void (*ADL__print_VSEnvironment_ptr_P)(VSEnvironment_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSENVIRONMENT_PTR_P */
#ifndef ADL__PRINT_VSNVLIST_PTR_P
#define ADL__PRINT_VSNVLIST_PTR_P
void (*ADL__print_VSNVList_ptr_P)(VSNVList_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSNVLIST_PTR_P */
#ifndef ADL__PRINT_VSREQUEST_PTR_P
#define ADL__PRINT_VSREQUEST_PTR_P
void (*ADL__print_VSRequest_ptr_P)(VSRequest_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSREQUEST_PTR_P */
#ifndef ADL__PRINT_VSCONTEXT_PTR_P
#define ADL__PRINT_VSCONTEXT_PTR_P
void (*ADL__print_VSContext_ptr_P)(VSContext_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSCONTEXT_PTR_P */
#ifndef ADL__PRINT_VSORB_PTR_P
#define ADL__PRINT_VSORB_PTR_P
void (*ADL__print_VSORB_ptr_P)(VSORB_ptr*, emitter_t) = 0;

#endif /* ADL__PRINT_VSORB_PTR_P */

void ADL__emit_VSObject_ptr_P (void* val, emitter_t emitter)
{
  VSObject_ptr *tmp;

  if (ADL__print_VSObject_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSObject_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_P (void* val, emitter_t emitter)
{
  VSEnvironment *tmp;

  if (ADL__print_VSEnvironment_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSBoolean (void* val, emitter_t emitter)
{
  VSBoolean tmp;

  if (ADL__print_VSBoolean != 0) {
    tmp = *(VSBoolean*) val;
    ADL__print_VSBoolean(tmp, emitter);
}
  else {
    ADL__defaultPrintFunc(emitter);
  }
}

void ADL__emit_VSNamedValue_ptr_P (void* val, emitter_t emitter)
{
  VSNamedValue_ptr *tmp;

  if (ADL__print_VSNamedValue_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSNamedValue_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSTypeCode_ptr_P (void* val, emitter_t emitter)
{
  VSTypeCode_ptr *tmp;

  if (ADL__print_VSTypeCode_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSTypeCode_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSEnvironment_ptr_P (void* val, emitter_t emitter)
{
  VSEnvironment_ptr *tmp;

  if (ADL__print_VSEnvironment_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSEnvironment_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSNVList_ptr_P (void* val, emitter_t emitter)
{
  VSNVList_ptr *tmp;

  if (ADL__print_VSNVList_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSNVList_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSRequest_ptr_P (void* val, emitter_t emitter)
{
  VSRequest_ptr *tmp;

  if (ADL__print_VSRequest_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSRequest_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSContext_ptr_P (void* val, emitter_t emitter)
{
  VSContext_ptr *tmp;

  if (ADL__print_VSContext_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSContext_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

void ADL__emit_VSORB_ptr_P (void* val, emitter_t emitter)
{
  VSORB_ptr *tmp;

  if (ADL__print_VSORB_ptr_P != 0) {
    tmp = *(void***) val;
    ADL__print_VSORB_ptr_P(tmp, emitter);
}
  else {
    ADL__defaultPrintPointer(val, emitter);
  }
}

static int ADL__test_driver(struct ADL__TDD_report *rf, int tnum) {
    int res;
    int relvec[(N_VARS>0)?N_VARS:1];

    int tvec[TVEC_SIZE];
    static int prop_vec[TVEC_SIZE] = {4};
    extern int ADL__factor_tnum(int, int, int *, int *);

    enum ADL__ACF_result test_value;
    VSContext_ptr *context_ptr_641;
    VSEnvironment *env_642;
    VSBoolean fut_return_638;

    for (res = 0; res < N_VARS; ++res) {
        relvec[res] = 1;
    }

    res = ADL__factor_tnum(tnum, TVEC_SIZE, tvec, prop_vec);
    if (res != 0) {
        ADL__bad_test_num();
    }

    /* protect against multithread confusion */
    ADL__save(rf, &ADL__VScontext_is_nil_head);
    rf->testNumber = rf->assertionReport->gridPoint = tnum;
    rf->assertionReport->reset(
        rf->assertionReport,
        ADL__VScontext_is_nil_InfoArrayIdx,
        ADL__VScontext_is_nil_InfoArray
    );
    rf->assertionReport->parent = rf;

    if (rf->bracket->testStart(rf->bracket, rf)) {
       rf->assertionReport->setPhase(rf->assertionReport, PH_provide);

       ADL__set_TDDVarNum(0);
       if (!provide_context_ptr(&context_ptr_641, ADL__prop_values_639[tvec[0]].propValCode)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_0;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 0, tvec + 0, 1);
       ADL__emit_VSContext_ptr_P(&context_ptr_641, rf->variableReport->emitVariable);

       ADL__set_TDDVarNum(1);
       if (!provide_env(&env_642)) {
           test_value = ADL__ACF_SKIPPED;
           rf->assertionReport->value = test_value;
           rf->openReport(rf);
           rf->reportSkip(rf);
           rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
           rf->variableReport->emitSkippedVar();

           rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
           goto SKIP_1;
       }
       rf->variableReport->saveVariableInfo(rf->variableReport, 0, 1, tvec + 1, 0);
       ADL__emit_VSEnvironment_P(&env_642, rf->variableReport->emitVariable);

       /* set reporting global then call function under test*/
       ADL__VScontext_is_nil_assertionReport = rf->assertionReport;
       fut_return_638 = ADL__ACF_VScontext_is_nil(context_ptr_641, env_642);
       test_value = ADL__VScontext_is_nil_assertionReport->value;

       /*preserve result of ACF, go to relinquish phase */
       rf->assertionReport->value = test_value;
       rf->assertionReport->setPhase(rf->assertionReport, PH_relinquish);
      ADL__set_TDDVarNum(1);
       relvec[1] = relinquish_env(&env_642);
SKIP_1:
      ADL__set_TDDVarNum(0);
       relvec[0] = relinquish_context_ptr(&context_ptr_641, ADL__prop_values_639[tvec[0]].propValCode);
SKIP_0:
       rf->assertionReport->setPhase(rf->assertionReport, PH_final);
       rf->assertionReport->end(rf->assertionReport);

       rf->propertyReport->reportProperties(
           rf->propertyReport,
           tnum,
           test_value,
           N_VARS,
           ADL__var_info_643,
           relvec,
           TVEC_SIZE,
           tvec
       );

       rf->closeReport(rf);
    }; /* fi bracket->testStart */

    rf->bracket->testEnd(rf->bracket, rf);

    /* gather statistics after bracketEnd */
    rf->assertionStats->gather(
        rf->assertionStats,
        rf->assertionReport);

   /* undo effect of ADL__save */
    ADL__cleanup(rf, &ADL__VScontext_is_nil_head);

    return 0;
}


struct ADL__Directive_info VScontext_is_nil1_info = {
    N_VARS,
    ADL__var_info_643
};

struct ADL__TDD_info ADL__test_info = {
    4,
    &ADL__VScontext_is_nil_InfoArrayIdx,
    ADL__VScontext_is_nil_InfoArray,
    ADL__test_driver,
    "VScontext_is_nil",
    "VScontext_is_nil1",
    "t1.adl",
    "t1.tdr",
    "t1",
    "VScontext_is_nil1",
    "t1_tr.rif",
    &VScontext_is_nil1_info,
    1
};

main(int argc, char **argv) {
   /* call into ADL library to do setup and run test */
   adl_run_test(argc, argv, &ADL__test_info);
}

