/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/corba/isnil/t1.h
  
   Purpose:
  
   Modifications:
   $Log: t1.h,v $
   Revision 1.1.1.1  2000/02/09 17:14:40  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.1  1997/10/01 15:55:22  cwatson
   Initial is_nil() versions.

*/

#include <corba_defs.h>

extern VSBoolean VSobj_is_nil(VSObject_ptr *o, VSEnvironment *env);
extern VSBoolean VSnvalue_is_nil(VSNamedValue_ptr *o, VSEnvironment *env);
extern VSBoolean VStypecode_is_nil(VSTypeCode_ptr *o, VSEnvironment *env);
extern VSBoolean VSenv_is_nil(VSEnvironment_ptr *o, VSEnvironment *env);
extern VSBoolean VSnvlist_is_nil(VSNVList_ptr *o, VSEnvironment *env);
extern VSBoolean VSrequest_is_nil(VSRequest_ptr *o, VSEnvironment *env);
extern VSBoolean VScontext_is_nil(VSContext_ptr *o, VSEnvironment *env);
extern VSBoolean VSorb_is_nil(VSORB_ptr *o, VSEnvironment *env);

