/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/api/include/exwrap.h
  
   Purpose:
  
   Modifications:
   $Log: exwrap.hh,v $
   Revision 1.1.1.1  2000/02/09 17:14:44  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.1  1997/12/08 14:39:04  cwatson
   Filename changes.

   Revision 1.7  1997/11/11 13:06:21  cwatson
   Removed VSExceptionWrap - API now uses IDL generated not_implemented exception.

   Revision 1.6  1997/10/01 16:05:27  cwatson
   Makefile changes.

   Revision 1.5  1997/09/15 10:58:08  cwatson
   Added the VSNOT_IMPLEMENTED macro and we now check for the NOT_IMPLEMENTED
   User Exception.

   Revision 1.4  1997/09/08 11:47:36  cwatson
   Defaulted the constructor to take a User Exception.

   Revision 1.3  1997/08/29 15:05:19  cwatson
   Cannot release a TypeCode_ptr in DAIS.

   Revision 1.2  1997/08/20 09:11:31  cwatson
   *** empty log message ***

   Revision 1.1  1997/08/06 14:41:43  cwatson
   *** empty log message ***

*/

/*------------------------------------------------------*/
/* A macro to create our own NOT_IMPLEMENTED user exception. */

#include	<tin.hh>

#define VSNOT_IMPLEMENTED \
		{CORBA::Exception *t = new not_implemented(); \
		if(env) \
				env->exception(t);}

extern "C" {
extern CORBA::Exception *exception_convert(CORBA::Exception *);
}

