/*
 *
 * t1_aux.h -- generated automatically by ADLT
 *
 * This file contains declarations of auxiliary functions
 * in module "t1"
 *
 */

#ifndef T1_AUX_H
#define T1_AUX_H

#include <ADL_Standard.h>
#include <adl_reporting.h>
#include "corba_defs_aux.h"
#include "t1.h"

extern int is_same_typecode_ptr(VSTypeCode_ptr *, VSTypeCode_ptr *);

extern int cleanup_typecode_ptr(VSTypeCode_ptr *);

extern int kind_is_correct(VSTCKind);

extern int is_equal_kind(VSTypeCode_ptr *t1, VSTypeCode_ptr *t2);

extern int id_typecode_is_allowed(VSTypeCode_ptr *t);

extern int id_is_correct(VSChar *id);

extern int name_typecode_is_allowed(VSTypeCode_ptr *t);

extern int name_is_correct(VSChar *name);

extern int member_count_typecode_is_allowed(VSTypeCode_ptr *t);

extern int member_count_is_correct(VSULong i);

extern int member_name_typecode_is_allowed(VSTypeCode_ptr *t);

extern int member_name_is_correct(VSChar *name);

extern int name_index_out_of_bounds(VSTypeCode_ptr *t, VSULong i);

extern int member_type_typecode_is_allowed(VSTypeCode_ptr *t);

extern int member_type_is_correct(VSTypeCode_ptr *t);

extern int type_index_out_of_bounds(VSTypeCode_ptr *t, VSULong i);

extern int member_label_typecode_is_allowed(VSTypeCode_ptr *t);

extern int member_label_is_correct(VSAny *a);

extern int label_index_out_of_bounds(VSTypeCode_ptr *t, VSULong i);

extern int dt_typecode_is_allowed(VSTypeCode_ptr *t);

extern int dt_is_correct(VSTypeCode_ptr *dt);

extern int dfind_typecode_is_allowed(VSTypeCode_ptr *t);

extern int dfind_is_correct(VSLong i);

extern int length_typecode_is_allowed(VSTypeCode_ptr *t);

extern int length_is_correct(VSULong i);

extern int content_typecode_is_allowed(VSTypeCode_ptr *t);

extern int content_is_correct(VSTypeCode_ptr *dt);

/* Declarations of User-Defined-Print-Function-Pointer */
extern void (*ADL__print_VSTypeCode_ptr_P)(VSTypeCode_ptr*, emitter_t);
extern void (*ADL__print_VSEnvironment_P)(VSEnvironment*, emitter_t);
extern void (*ADL__print_VSTCKind)(VSTCKind, emitter_t);
extern void (*ADL__print_VSBoolean)(VSBoolean, emitter_t);
extern void (*ADL__print_VSChar_P)(VSChar*, emitter_t);
extern void (*ADL__print_VSULong)(VSULong, emitter_t);
extern void (*ADL__print_VSAny_P)(VSAny*, emitter_t);
extern void (*ADL__print_VSLong)(VSLong, emitter_t);

/* Declarations of wrapper of FUT */
extern VSTCKind (*ADL__VSkind_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern VSBoolean (*ADL__VSequal_wrapper)(VSTypeCode_ptr*, VSTypeCode_ptr*, VSEnvironment*);
extern VSChar *(*ADL__VSid_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern VSChar *(*ADL__VSname_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern VSULong (*ADL__VSmember_count_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern VSChar *(*ADL__VSmember_name_wrapper)(VSULong, VSTypeCode_ptr*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VSmember_type_wrapper)(VSULong, VSTypeCode_ptr*, VSEnvironment*);
extern VSAny *(*ADL__VSmember_label_wrapper)(VSULong, VSTypeCode_ptr*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VSdiscriminator_type_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern VSLong (*ADL__VSdefault_index_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern VSULong (*ADL__VSlength_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VScontent_type_wrapper)(VSTypeCode_ptr*, VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VSnil_wrapper)(VSEnvironment*);
extern VSTypeCode_ptr *(*ADL__VSduplicate_wrapper)(VSTypeCode_ptr*, VSEnvironment*);

#endif
