//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include	<corba_supp.hh>
#include	<tserver.hh>

extern "C" {

#include	<t1.h>
#include	<t1_aux.h>
#include	<t1i_tdi.h>

VSORB_ptr VSORB_init(int* argc, char** argv, VSORBid oid, VSEnvironment *ev)
{
		CORBA::Environment *env = (CORBA::Environment *) ev;
		CORBA::ORB_ptr optr;
		int targc = *argc;
		try {
				optr = CORBA::ORB_init(targc, argv, oid);
		}
		catch (CORBA::Exception &ex) {
				if(env)
						env->exception(&ex);
				return (VSORB_ptr) 0;
		}

		return (VSORB_ptr) optr;
}

}

