/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
   Copyright (c) 2000 Object Oriented Concepts GmbH.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Project: CORVAL2
*/

#include "idlmacros.hh"

class apiServer_imp : public virtual POA_apiServer
{
public:
  
  CORBA::Char charOp(CORBA::Char c1,
                     CORBA::Char& c2,
                     CORBA::Char_out c3)
      throw(CORBA::SystemException);

  CORBA::Octet octetOp(CORBA::Octet o1,
                       CORBA::Octet& o2,
                       CORBA::Octet_out o3)
      throw(CORBA::SystemException);
  
  CORBA::Boolean booleanOp(CORBA::Boolean b1,
                           CORBA::Boolean& b2,
                           CORBA::Boolean_out b3)
      throw(CORBA::SystemException);
    
  CORBA::Short shortOp(CORBA::Short s1,
                       CORBA::Short& s2,
                       CORBA::Short_out s3)
      throw(CORBA::SystemException);
  
  CORBA::Long longOp(CORBA::Long l1,
                     CORBA::Long& l2,
                     CORBA::Long_out l3)
      throw(CORBA::SystemException);
  
  CORBA::Float floatOp(CORBA::Float f1,
                       CORBA::Float& f2,
                       CORBA::Float_out f3)
      throw(CORBA::SystemException);
  
  CORBA::Double doubleOp(CORBA::Double d1,
                         CORBA::Double& d2,
                         CORBA::Double_out d3)
      throw(CORBA::SystemException);
    
  char* stringOp(const char* s1,
                 char*& s2,
                 CORBA::String_out s3)
      throw(CORBA::SystemException);
  
  CORBA::UShort ushortOp(CORBA::UShort us1,
                         CORBA::UShort& us2,
                         CORBA::UShort_out us3)
      throw(CORBA::SystemException);

  CORBA::ULong ulongOp(CORBA::ULong ul1,
                       CORBA::ULong& ul2,
                       CORBA::ULong_out ul3)
      throw(CORBA::SystemException);
  
  CORBA::Long increment(CORBA::Long num)
      throw(CORBA::SystemException);
};

