//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; 

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{
  ::tet_infoline("The class CORBA::ExceptionList_var shall be defined.");

	CORBA::ExceptionList_var exceptionlist_var;
	(void *)&exceptionlist_var;

  ::tet_infoline("TEST: Assignment");

	if (always_ret_0())
	{
    CORBA::ExceptionList_var  myExceptionList_var1;
    CORBA::ExceptionList_var  myExceptionList_var2;

		myExceptionList_var1 = myExceptionList_var2;
	}

  ::tet_infoline("TEST: Pointer construction");

	if (always_ret_0())
	{
		CORBA::ExceptionList *pExceptionList;

		CORBA::ExceptionList_var myExceptionList_var3(pExceptionList);
		(void *)&myExceptionList_var3;
	}

  ::tet_infoline("TEST: Pointer assignment");

	if (always_ret_0())
	{
		CORBA::ExceptionList *pExceptionList;

		CORBA::ExceptionList_var myExceptionList_var3 = pExceptionList;

		(void *)&myExceptionList_var3;
	}

  ::tet_infoline("TEST: Copy constructor");

  if (always_ret_0())
  {
    CORBA::ExceptionList_var  myExceptionList_var1;
    CORBA::ExceptionList_var  myExceptionList_var2(myExceptionList_var1);

		(void *)&myExceptionList_var2;
  }

	::tet_infoline("TEST: operator->");

	if (always_ret_0())
  {
    CORBA::ExceptionList_var myExceptionList_var;

		CORBA::ExceptionList *pe = myExceptionList_var.operator->();
	}

  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}

