//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <stdio.h>
#include <tet_api.h>

char ebuf[4096];

extern "C" {
static void test1A(void)
{
CORBA::NamedValue  myNamedValue;

// Declare pointers for each of the member fields 
CORBA::Identifier *pname;
CORBA::Any *pargument;
CORBA::Long *plen;
CORBA::Flags *parg_modes;


  ::tet_infoline("The struct CORBA::NamedValue");
  ::tet_infoline("shall be defined and shall have the members");
  ::tet_infoline("{ Identifier name, CORBA::Any argument, CORBA::Long len, Flags arg_modes}");

  // Force the compiler to complain if the a member type is incorrect

  // Test the field name 
  pname = &myNamedValue.name;

  // Test the field argument 
  pargument = &myNamedValue.argument;

  // Test the field len 
  plen = &myNamedValue.len;

  // Test the field arg_modes 
  parg_modes = &myNamedValue.arg_modes;


  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}
