//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; 

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{
	CORBA::ORB_var  myObjRef;

	// declare an instance of the return type 
	CORBA::TypeCode_ptr ret;

	// declare an instance of each parameter 
	CORBA::UShort myp1 = (CORBA::UShort)0; // in 
	CORBA::UShort myp2 = (CORBA::UShort)0; // in 

  ::tet_infoline("The function CORBA::ORB::create_fixed_tc");
  ::tet_infoline("shall be defined to be of type");
  ::tet_infoline("CORBA::TypeCode_ptr CORBA::ORB::create_fixed_tc(");
  ::tet_infoline("    CORBA::UShort");
  ::tet_infoline("    CORBA::UShort");
  ::tet_infoline("    );");

  // Include a call to the function to make sure it is present in the library 
  if (always_ret_0())
    ret = 
      myObjRef->create_fixed_tc(myp1, myp2);

  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}

