//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by GMD Fokus, Berlin.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	CORBA::ValueBoxDef_var myObjRef;

#if VSORB_CORBA_STATUS
	// declare an instance of the return type 
	CORBA::Status ret;
#endif /* VSORB_CORBA_STATUS */

	// declare an instance of each parameter 
	CORBA::Context_ptr ctx = (CORBA::Context_ptr)0; // in 
	const char * operation = (const char *)0; // in 
	CORBA::NVList_ptr arg_list = (CORBA::NVList_ptr)0; // in 
	CORBA::NamedValue_ptr result = (CORBA::NamedValue_ptr)0; // in 
	CORBA::ExceptionList_ptr exclist = (CORBA::ExceptionList_ptr)0; // in 
	CORBA::ContextList_ptr ctxlist = (CORBA::ContextList_ptr)0; // in 
	CORBA::Request_ptr request = (CORBA::Request_ptr)0; // out 
	CORBA::Flags req_flags = (CORBA::Flags)0; // in 

	::tet_infoline("The function CORBA::ValueBoxDef::_create_request");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("CORBA::Status CORBA::ValueBoxDef::_create_request(");
	::tet_infoline("CORBA::Context_ptr,");
	::tet_infoline("const char *,");
	::tet_infoline("CORBA::NVList_ptr,");
	::tet_infoline("CORBA::NamedValue_ptr,");
	::tet_infoline("CORBA::ExceptionList_ptr,");
	::tet_infoline("CORBA::ContextList_ptr,");
	::tet_infoline("CORBA::Request_ptr&,");
	::tet_infoline("CORBA::Flags");
	::tet_infoline(");");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
#if VSORB_CORBA_STATUS
		ret = 
#endif /* VSORB_CORBA_STATUS */

			myObjRef->_create_request(ctx, operation, arg_list, result, exclist, ctxlist, request, req_flags );

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

