//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by GMD Fokus, Berlin.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	CORBA::ValueDef_var myObjRef;

	// declare an instance of the return type 
	CORBA::Boolean ret;

	// declare an instance of each parameter 
	CORBA::RepositoryId p1 = (CORBA::RepositoryId)0; // in 

	::tet_infoline("The function CORBA::ValueDef::describe_contents");
	::tet_infoline("shall be defined to be of type");
	::tet_infoline("CORBA::Boolean CORBA::ValueDef::is_a(CORBA::RepositoryId)");

	// Include a call to the function to make sure it is present in the library 
	if (always_ret_0())
		ret = myObjRef->is_a(p1);

	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

