//
// Copyright (c) 2000 The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for The Open Group by GMD Fokus, Berlin.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>
 
volatile int vol = 0;
 
static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The read access function CORBA::Repository_ptr containing_repository();");

	::tet_infoline("shall be defined for class CORBA::ValueMemberDef.");

	if (always_ret_0())
	{
 		CORBA::ValueMemberDef_var myObjRef;
 		CORBA::Repository_ptr ret;

		ret = myObjRef->containing_repository();
	}


  ::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

