//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class PortableServer::ServantBase_var has been defined");
  ::tet_infoline("ServantBase_var().");

  if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass();

		(void *)&myClass;
	}

  ::tet_infoline("The class PortableServer::ServantBase_var shall have a copy constructor.");

  if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass_var1;
		PortableServer::ServantBase_var myClass_var2(myClass_var1);

		(void *)&myClass_var2;
	}


  ::tet_infoline("The class PortableServer::ServantBase_var shall have a constructor of the form.");
  ::tet_infoline("PortableServer::ServantBase_var(const PortableServer::ServantBase_var)");

  if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass_var3(PortableServer::ServantBase* myp3);
		(void *)&myClass_var3;
	}


  ::tet_infoline("The class PortableServer::ServantBase_var shall have a constructor of the form.");
  ::tet_infoline("PortableServer::ServantBase_var(const PortableServer::ServantBase_var)");

  if (always_ret_0())
	{
		PortableServer::ServantBase_var myClass_var4(const PortableServer::ServantBase_var& myp4);
		(void *)&myClass_var4;
	}


  ::tet_infoline("The class PortableServer::ServantBase_var has an assignment operator of the form");
  ::tet_infoline(" ServantBase_var& operator=(ServantBase* p).");

	PortableServer::ServantBase_var& (PortableServer::ServantBase_var::*pf5)(PortableServer::ServantBase *) = NULL;

	pf5 = &PortableServer::ServantBase_var::operator=;



  ::tet_infoline("The class PortableServer::ServantBase_var has an assignment operator of the form");
  ::tet_infoline(" ServantBase_var& operator=(const ServantBase_var& b).");

	PortableServer::ServantBase_var& (PortableServer::ServantBase_var::*pf6)(const PortableServer::ServantBase_var&) = NULL;

	pf6 = &PortableServer::ServantBase_var::operator=;



	::tet_infoline("TEST: operator->");

	if (always_ret_0())
	{
	PortableServer::ServantBase_var myClass7_var;
	PortableServer::ServantBase *p7_out = myClass7_var.operator->();
	}	

	
	::tet_infoline("TEST member: ServantBase* in()");

	if (always_ret_0())
	{
	PortableServer::ServantBase_var myClass8_var;
	PortableServer::ServantBase *p8_out = myClass8_var.in();
	}

	
	::tet_infoline("TEST member: ServantBase*& inout()");

	if (always_ret_0())
	{
	PortableServer::ServantBase_var myClass9_var;
	PortableServer::ServantBase*& p9_out = myClass9_var.inout();
	}
	
	::tet_infoline("TEST member: ServantBase*& out()");

	if (always_ret_0())
	{
	PortableServer::ServantBase_var myClass_var;
	PortableServer::ServantBase*& p10_out = myClass_var.out();
	}
	
	::tet_infoline("TEST member: ServantBase* retn()");

	if (always_ret_0())
	{
	PortableServer::ServantBase_var myClass_var;
	PortableServer::ServantBase* p11_out = myClass_var._retn();
	}


    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
