//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{

  ::tet_infoline("The class PortableServer::Current shall be defined ");
  ::tet_infoline("to be a class that inherits from");
  ::tet_infoline("CORBA::Current .");

  ::tet_infoline("TEST: Widening of object reference to PortableServer::ServantManager");
  if (always_ret_0())
  {
    PortableServer::Current_ptr  myCurrent_ptr = (PortableServer::Current_ptr)0;
    PortableServer::Current_var  myCurrent_var;

    CORBA::Current_ptr myparent1_ptr1 = myCurrent_ptr;
    CORBA::Current_ptr myparent1_ptr2 = myCurrent_var;
    CORBA::Current_var myparent1_var = PortableServer::Current::_duplicate(myCurrent_var);

    (void *)&myparent1_var;
  }


  ::tet_infoline("TEST: Assignment");
  if (always_ret_0())
  {
    PortableServer::Current_var  myCurrent_var1;
    PortableServer::Current_var  myCurrent_var2;

    myCurrent_var1 = myCurrent_var2;

    (void *)&myCurrent_var1;
  }

//   ::tet_infoline("TEST: Insertion into CORBA::Any");
//   if (always_ret_0())
//   {
//     CORBA::Any any;
//     PortableServer::Current_ptr  myCurrent_ptr = (PortableServer::Current_ptr)0;

//     any <<= myCurrent_ptr;
//   }

//   ::tet_infoline("TEST: Extraction from CORBA::Any");
//   if (always_ret_0())
//   {
//     CORBA::Any any;
//     CORBA::Boolean b;
//     PortableServer::Current_ptr  myCurrent_ptr=(PortableServer::Current_ptr)0;

//     b = any >>= myCurrent_ptr;

//     (void*)&b;
//     (void*)&myCurrent_ptr;
//   }


  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}

