//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A()
{
	::tet_infoline("The exception PortableServer::POAManager::AdapterInactive shall be defined.");

	// Test the constructors

	::tet_infoline("TEST: The constructor PortableServer::POAManager::AdapterInactive::AdapterInactive()");
	if (always_ret_0())
	{
		PortableServer::POAManager::AdapterInactive myAdapterInactive;

		(void *)&myAdapterInactive;
	}

	::tet_infoline("TEST: The constructor PortableServer::POAManager::AdapterInactive::AdapterInactive(const AdapterInactive &)");
	if (always_ret_0())
	{
		PortableServer::POAManager::AdapterInactive myAdapterInactive1;

		PortableServer::POAManager::AdapterInactive myAdapterInactive2(myAdapterInactive1);

		(void *)&myAdapterInactive2;
	}



//	::tet_infoline("TEST: The assignment operator");
//	if (always_ret_0())
//	{
//		PortableServer::POAManager::AdapterInactive myAdapterInactive1;
//		PortableServer::POAManager::AdapterInactive myAdapterInactive2;
//
//		myAdapterInactive1 = myAdapterInactive2;
//
//		(void *)&myAdapterInactive1;
//	}

	::tet_infoline("TEST: Test the _downcast method");
	if (always_ret_0())
	{
		CORBA::Exception *pException = 0;;
		PortableServer::POAManager::AdapterInactive *pAdapterInactive;

		pAdapterInactive = PortableServer::POAManager::AdapterInactive::_downcast(pException);
	}
	if (always_ret_0())
	{
		const CORBA::Exception *pException = 0;;
		const PortableServer::POAManager::AdapterInactive*pAdapterInactive;

		pAdapterInactive = PortableServer::POAManager::AdapterInactive::_downcast(pException);
	}

	::tet_infoline("TEST: Test the _raise method");
	if (always_ret_0())
	{
		PortableServer::POAManager::AdapterInactive myAdapterInactive;

		myAdapterInactive._raise();
	}


	::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

