//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0;

static int always_ret_0()
{
  return vol;
}

extern "C" {
static void test1A(void)
{
  ::tet_infoline("The class PortableServer::ServantManager_var shall be defined.");

	PortableServer::ServantManager_var servantmanager_var;
	(void *)&servantmanager_var;

  ::tet_infoline("TEST: Assignment");

	if (always_ret_0())
	{
    PortableServer::ServantManager_var  myServantManager_var1;
    PortableServer::ServantManager_var  myServantManager_var2;

		myServantManager_var1 = myServantManager_var2;
	}

	::tet_infoline("TEST: Pointer construction");

  if (always_ret_0())
  {
    PortableServer::ServantManager *pServantManager;

    PortableServer::ServantManager_var myServantManager_var3(pServantManager);
    (void *)&myServantManager_var3;
  }

  ::tet_infoline("TEST: Pointer assignment");

  if (always_ret_0())
  {
    PortableServer::ServantManager *pServantManager;

    PortableServer::ServantManager_var myServantManager_var3 = pServantManager;
    (void *)&myServantManager_var3;
  }

  ::tet_infoline("TEST: Copy constructor");

  if (always_ret_0())
  {
    PortableServer::ServantManager_var  myServantManager_var1;
    PortableServer::ServantManager_var  myServantManager_var2(myServantManager_var1);
		
		(void *)&myServantManager_var2;
  }

	::tet_infoline("TEST: operator->");

	if (always_ret_0())
	{
    PortableServer::ServantManager_var myServantManager_var;

		PortableServer::ServantManager *pc = myServantManager_var.operator->();
	}

  ::tet_result(TET_PASS);


}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
}

