//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::ValueFactoryBase has been defined");

  if (always_ret_0())
	{
		CORBA::ValueFactoryBase& myValueFactoryBase();

		(void *)&myValueFactoryBase;
	}


  ::tet_infoline("The class CORBA::ValueFactoryBase shall have a member ");
  ::tet_infoline("void _add_ref() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::ValueFactoryBase::*pf5)() = NULL;
	pf5 = &CORBA::ValueFactoryBase::_add_ref;

	if (always_ret_0())
	{
		CORBA::ValueFactoryBase_var myValueFactoryBase5=NULL;
		(void) (myValueFactoryBase5->*pf5)();
	}



  ::tet_infoline("The class CORBA::ValueFactoryBase shall have a member ");
  ::tet_infoline("void _remove_ref() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::ValueFactoryBase::*pf6)() = NULL;
	pf6 = &CORBA::ValueFactoryBase::_remove_ref;

	if (always_ret_0())
	{
		CORBA::ValueFactoryBase_var myValueFactoryBase6=NULL;
		(void) (myValueFactoryBase6->*pf6)();
	}
 

  ::tet_infoline("The class CORBA::ValueFactoryBase shall have a member ");
  ::tet_infoline("static ValueFactoryBase* _downcast(ValueFactoryBase*) defined.");

  // Force the compiler to generate warnings/errors if member does not exist

	if (always_ret_0())
	{
		CORBA::ValueFactoryBase_var myValueFactoryBase9;
		CORBA::ValueFactoryBase* p9;
		CORBA::ValueFactoryBase* ret9;
		ret9 = (myValueFactoryBase9->_downcast)(p9);
	}
  



    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
