//
// Copyright (c) 2000 GMD-Fokus Berlin.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{


  ::tet_infoline("The class CORBA::DataInputStream has a constructor of the form");
  ::tet_infoline("DataInputStream_var().");

  if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream_var();

		(void *)&myDataInputStream_var;
	}


  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Any* read_any() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Any* (CORBA::DataInputStream::*pf)() = NULL;
	pf = &CORBA::DataInputStream::read_any;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Any* p1 = (myDataInputStream1->*pf)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Boolean read_boolean() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Boolean (CORBA::DataInputStream::*pf2)() = NULL;
	pf2 = &CORBA::DataInputStream::read_boolean;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Boolean p2 = (myDataInputStream1->*pf2)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Char read_char() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Char (CORBA::DataInputStream::*pf3)() = NULL;
	pf3 = &CORBA::DataInputStream::read_char;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Char p3 = (myDataInputStream1->*pf3)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::WChar read_wchar() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::WChar (CORBA::DataInputStream::*pf4)() = NULL;
	pf4 = &CORBA::DataInputStream::read_wchar;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::WChar p4 = (myDataInputStream1->*pf4)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Octet read_octet() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Octet (CORBA::DataInputStream::*pf5)() = NULL;
	pf5 = &CORBA::DataInputStream::read_octet;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Octet p5 = (myDataInputStream1->*pf5)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Short read_short() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Short (CORBA::DataInputStream::*pf6)() = NULL;
	pf6 = &CORBA::DataInputStream::read_short;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Short p6 = (myDataInputStream1->*pf6)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::UShort read_ushort() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::UShort (CORBA::DataInputStream::*pf7)() = NULL;
	pf7 = &CORBA::DataInputStream::read_ushort;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::UShort p7 = (myDataInputStream1->*pf7)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Long read_long() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Long (CORBA::DataInputStream::*pf8)() = NULL;
	pf8 = &CORBA::DataInputStream::read_long;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Long p8 = (myDataInputStream1->*pf8)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::ULong read_ulong() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::ULong (CORBA::DataInputStream::*pf9)() = NULL;
	pf9 = &CORBA::DataInputStream::read_ulong;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::ULong p9 = (myDataInputStream1->*pf9)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::LongLong read_longlong() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::LongLong (CORBA::DataInputStream::*pf10)() = NULL;
	pf10 = &CORBA::DataInputStream::read_longlong;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::LongLong p10 = (myDataInputStream1->*pf10)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::ULongLong read_ulonglong() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::ULongLong (CORBA::DataInputStream::*pf11)() = NULL;
	pf11 = &CORBA::DataInputStream::read_ulonglong;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::ULongLong p11 = (myDataInputStream1->*pf11)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Float read_float() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Float (CORBA::DataInputStream::*pf12)() = NULL;
	pf12 = &CORBA::DataInputStream::read_float;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Float p12 = (myDataInputStream1->*pf12)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Double read_double() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Double (CORBA::DataInputStream::*pf13)() = NULL;
	pf13 = &CORBA::DataInputStream::read_double;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Double p13 = (myDataInputStream1->*pf13)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::LongDouble read_longdouble() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::LongDouble (CORBA::DataInputStream::*pf14)() = NULL;
	pf14 = &CORBA::DataInputStream::read_longdouble;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::LongDouble p14 = (myDataInputStream1->*pf14)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("char* read_string() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	char* (CORBA::DataInputStream::*pf15)() = NULL;
	pf15 = &CORBA::DataInputStream::read_string;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		char* p15 = (myDataInputStream1->*pf15)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Float read_float() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Float (CORBA::DataInputStream::*pf16)() = NULL;
	pf16 = &CORBA::DataInputStream::read_float;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Float p16 = (myDataInputStream1->*pf16)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::Object_ptr read_Object() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::Object_ptr (CORBA::DataInputStream::*pf17)() = NULL;
	pf17 = &CORBA::DataInputStream::read_Object;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::Object_ptr p17 = (myDataInputStream1->*pf17)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::AbstractBase_ptr read_Abstract() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::AbstractBase_ptr (CORBA::DataInputStream::*pf18)() = NULL;
	pf18 = &CORBA::DataInputStream::read_Abstract;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::AbstractBase_ptr p18 = (myDataInputStream1->*pf18)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::ValueBase* read_Value() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::ValueBase* (CORBA::DataInputStream::*pf19)() = NULL;
	pf19 = &CORBA::DataInputStream::read_Value;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::ValueBase* p19 = (myDataInputStream1->*pf19)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("CORBA::TypeCode_ptr read_TypeCode() defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	CORBA::TypeCode_ptr (CORBA::DataInputStream::*pf20)() = NULL;
	pf20 = &CORBA::DataInputStream::read_TypeCode;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::TypeCode_ptr p20 = (myDataInputStream1->*pf20)();
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_any_array( CORBA::AnySeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf21)( CORBA::AnySeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf21 = &CORBA::DataInputStream::read_any_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::AnySeq p21;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf21)(p21,index,index);
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_boolean_array( CORBA::BooleanSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf22)( CORBA::BooleanSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf22 = &CORBA::DataInputStream::read_boolean_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::BooleanSeq p22;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf22)(p22,index,index);
	}
  

  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_char_array( CORBA::CharSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf23)( CORBA::CharSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf23 = &CORBA::DataInputStream::read_char_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::CharSeq p23;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf23)(p23,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_wchar_array( CORBA::WCharSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf24)( CORBA::WCharSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf24 = &CORBA::DataInputStream::read_wchar_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::WCharSeq p24;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf24)(p24,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_octet_array( CORBA::OctetSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf25)( CORBA::OctetSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf25 = &CORBA::DataInputStream::read_octet_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::OctetSeq p25;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf25)(p25,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_short_array( CORBA::ShortSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf26)( CORBA::ShortSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf26 = &CORBA::DataInputStream::read_short_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::ShortSeq p26;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf26)(p26,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_ushort_array( CORBA::UShortSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf27)( CORBA::UShortSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf27 = &CORBA::DataInputStream::read_ushort_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::UShortSeq p27;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf27)(p27,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_long_array( CORBA::LongSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf28)( CORBA::LongSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf28 = &CORBA::DataInputStream::read_long_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::LongSeq p28;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf28)(p28,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_ulong_array( CORBA::ULongSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf29)( CORBA::ULongSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf29 = &CORBA::DataInputStream::read_ulong_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::ULongSeq p29;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf29)(p29,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_ulonglong_array( CORBA::ULongLongSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf30)( CORBA::ULongLongSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf30 = &CORBA::DataInputStream::read_ulonglong_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::ULongLongSeq p30;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf30)(p30,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_longlong_array( CORBA::LongLongSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf31)( CORBA::LongLongSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf31 = &CORBA::DataInputStream::read_longlong_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::LongLongSeq p31;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf31)(p31,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_float_array( CORBA::FloatSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf32)( CORBA::FloatSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf32 = &CORBA::DataInputStream::read_float_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::FloatSeq p32;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf32)(p32,index,index);
	}
  
  ::tet_infoline("The class CORBA::DataInputStream shall have a member ");
  ::tet_infoline("void read_double_array( CORBA::DoubleSeq,CORBA::ULong,CORBA::ULong) defined.");

  // Force the compiler to generate warnings/errors if member does not exist
	void (CORBA::DataInputStream::*pf33)( CORBA::DoubleSeq&,CORBA::ULong,CORBA::ULong) = NULL;
	pf33 = &CORBA::DataInputStream::read_double_array;

	if (always_ret_0())
	{
		CORBA::DataInputStream_var myDataInputStream1=NULL;
		CORBA::DoubleSeq p33;
		CORBA::ULong index;
		(void)(myDataInputStream1->*pf33)(p33,index,index);
	}
 
 


    ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
