/*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Developed for X/Open by ApTest Ireland Limited.
*
* Project: CORVAL2
*
*/

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A(void)
{
	CORBA::String_var& (CORBA::String_var::*pf)(const CORBA::String_var&) = NULL;

  ::tet_infoline("The class CORBA::String_var has an assignment operator of the form");
  ::tet_infoline(" String_var &operator=(const String_var&).");

	pf = &CORBA::String_var::operator=;

  if (always_ret_0())
	{
		CORBA::String_var myString_var1;
		CORBA::String_var myString_var2;

		(void)(myString_var1.*pf)(myString_var2);
	}
  
  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
