/*
* Copyright (c) 2000 Object Oriented Concepts GmbH
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Project: CORVAL2
*
*/

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; static int always_ret_0()
{
    return vol;
}

extern "C" {
static void test1A(void)
{
	CORBA::WString_var& (CORBA::WString_var::*pf)(const wchar_t *) = NULL;

  ::tet_infoline("The class CORBA::WString_var has an assignment operator of the form");
  ::tet_infoline(" WString_var &operator=(const wchar_t *p).");

	pf = &CORBA::WString_var::operator=;

  if (always_ret_0())
	{
		const wchar_t *p = L"WString_var &operator=(const wchar_t *p)";
		CORBA::WString_var myWString_var;

		(void)(myWString_var.*pf)(p);
	}
  
  ::tet_result(TET_PASS);
}
}

extern "C" {
void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
struct tet_testlist tet_testlist[] = { {test1A,1}, {NULL,0} };
};
