//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <corba_supp.hh>
#include <tet_api.h>

volatile int vol = 0; 

static int always_ret_0()
{
	return vol;
}

extern "C" {
static void test1A(void)
{
  ::tet_infoline("The exception CORBA::ORB::InvalidName shall be defined.");

	// Test the constructors

  ::tet_infoline("TEST: The constructor CORBA::ORB::InvalidName::InvalidName()");
  if (always_ret_0())
  {
    CORBA::ORB::InvalidName myInvalidName;

		(void *)&myInvalidName;
  }

  ::tet_infoline("TEST: The constructor CORBA::ORB::InvalidName::InvalidName(const InvalidName &)");
  if (always_ret_0())
  {
		CORBA::ORB::InvalidName myInvalidName1;
    CORBA::ORB::InvalidName myInvalidName2(myInvalidName1);

		(void *)&myInvalidName2;
  }

  ::tet_infoline("TEST: Test the assignment operator");
	if (always_ret_0())
	{
		CORBA::ORB::InvalidName myInvalidName1;
		CORBA::ORB::InvalidName myInvalidName2;
		
		myInvalidName1 = myInvalidName2;

		(void *)&myInvalidName1;
	}

  ::tet_result(TET_PASS);
}
}

extern "C" {
	void (*tet_startup)() = NULL, (*tet_cleanup)() = NULL;
	struct tet_testlist tet_testlist[] = { {test1A, 1}, {NULL, 0} };
}

