/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the abstract interface construct 
// Test subgroup description: Testing  the abstract interface construct used as operation parameter and attribute 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Basic features of Abstract Interface 
// Directory: aif_b01 


extern "C"
void test1(void)
{
   /* Existence Of  Class AbsInf   for abstract interface AbsInf */

  tet_printf("TC: Basic features of Abstract Interface\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Existence of AbsInf_var for abstract interface AbsInf */

  tet_printf("TC: Basic features of Abstract Interface\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Existence of AbsInf_ptr for abstract interface AbsInf */

  tet_printf("TC: Basic features of Abstract Interface\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Existence of AbsInf_out for abstract interface AbsInf */

  tet_printf("TC: Basic features of Abstract Interface\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Definition of narrow, duplicate and nil functions in class AbsInf  for abstract interface AbsInf */

  tet_printf("TC: Basic features of Abstract Interface\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Class AbsInf  for abstract interface AbsInf inherits from AbstractBase */

  tet_printf("TC: Basic features of Abstract Interface\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* For Class AbsInf  for abstract interface AbsInf not possible to generate public object */

  tet_printf("TC: Basic features of Abstract Interface\n");
  tet_printf(" ********************* NEGATIVE CHECK *********************");
  tp7.run(1);
}

// Test case Nr. 2 
// Name: tc02 
// Testcase goal: Operation in Abstract Interface 
// Directory: aif_b01 


extern "C"
void test8(void)
{
   /* Member function  in the class AbsInf for an operation in the abstract interface AbsInf */

  tet_printf("TC: Operation in Abstract Interface\n");
  tp8.run();
}
