/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the abstract valuetype construct 
// Test subgroup description: Testing  the abstract valuetype as operation parameter 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Basic features of Abstract Valuetype 
// Directory: avt_b01 


extern "C"
void test1(void)
{
   /* Existence of  Class AbsVal mapping for abstract valuetype AbsVal */

  tet_printf("TC: Basic features of Abstract Valuetype\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Existence of AbsVal_var for abstract valuetype AbsVal */

  tet_printf("TC: Basic features of Abstract Valuetype\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Existence of AbsVal_out for abstract valuetype AbsVal */

  tet_printf("TC: Basic features of Abstract Valuetype\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Definition in class AbsVal of _downcast() for abstract valuetype AbsVal */

  tet_printf("TC: Basic features of Abstract Valuetype\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Extraction/insertion of abstract valuetype from/to Any */

  tet_printf("TC: Basic features of Abstract Valuetype\n");
  tp5.run();
}

// Test case Nr. 2 
// Name: tc02 
// Testcase goal: Operation in Abstract Valuetype 
// Directory: avt_b01 


extern "C"
void test6(void)
{
   /* Mapping function op() in scope of class AbsVal */

  tet_printf("TC: Operation in Abstract Valuetype\n");
  tp6.run();
}
