#include <stdio.h>
#include <stdlib.h>

#define VSORB_THROW_SYSTEMEXCEPTION throw (CORBA::SystemException)

#define Type_Exists(x) x* ptr;

#define Type_InsertionExtraction_Any_OK(x) \
CORBA::Any AnyVar; \
x VarOrPtr; \
AnyVar <<= VarOrPtr; \
AnyVar >>= VarOrPtr;

#define Class_Exists(x) class deriv : public x {};


#define Class_Supports_PublMemFunction_Result(x,f,r) \
x* ptr1; \
r  res; \
res = (ptr1)->f();

#define Class_Supports_PublMemFunction_Result_2(x,f,r) \
x ptr1; \
r  res; \
res = (ptr1)->f();

#define Class_Supports_PublMemFunction_Result_3(x,f,r) \
x* ptr1; \
r  res; \
res = (*ptr1)->f();

#define Class_Supports_PublMemFunction_Parameter(x,f,p) \
x* ptr1; \
p  par; \
(ptr1)->f(par);

#define Class_Supports_PublMemFunction_Parameter_2(x,f,p) \
x ptr1; \
p  par; \
(ptr1)->f(par);

#define Class_Supports_PublMemFunction_Result_Parameter1(x,f,r,p) \
x* ptr1; \
r  res; \
p  par; \
res = (ptr1)->f(par);

#define Class_Supports_PublMemFunction_Result_Parameter2(x,f,r,p1,p2) \
x* ptr1; \
r  res; \
p1  par1; \
p2  par2; \
res = (ptr1)->f(par1,par2);

#define Class_Supports_PublMemFunction_Result_Parameter3(x,f,r,p1,p2,p3) \
x* x##ptr1; \
r  res; \
p1  par1; \
p2  par2=par1; \
p3  par3; \
res = (x##ptr1)->f(par1,par2,par3);

#define Class_Supports_PublMemFunction_Result_Parameter3_2(x,f,r,p1,p2,p3) \
x var; \
r  res; \
p1  par1; \
p2  par2=par1; \
p3  par3; \
res = (var)->f(par1,par2,par3);

#define Class_Supports_PublMemFunction_Result_Parameter7(x,f,r,p1,p2,p3,p4,p5,p6,p7) \
x* ptr1; \
r  res; \
p1  par1; \
p2  par2; \
p3  par3; \
p4  par4; \
p5  par5; \
p6  par6; \
p7  par7; \
res = (ptr1)->f(par1,par2,par3,par4,par5,par6,par7);

#define Class_Supports_PublStaticMemFunction_Result_Parameter1(x,f,r,p) \
r  res; \
p  par; \
res = x::f(par);

#define Class_Supports_PublStaticMemFunction_Result(x,f,r) \
r  res; \
res = x::f();

#define Class_Supports_PublAccessor(x,name,type) \
x*  ptr; \
type* lvar=new type(); \
*lvar = (ptr)->name();

#define Class_Supports_PublAccessor2(x,name,type) \
x*  v; \
type lvar; \
lvar = (v)->name();

#define Class_Supports_ProtectedAccessor(x,name,type) \
class  deriv : public x { \
void test() {type lvar = this->name();}; \
};

#define Class_Supports_PublModifier(x,name,type) \
x*  ptr1; \
type* lvar=new type(); \
(ptr1)->name(*lvar);

#define Class_Supports_PublModifier2(x,name,type) \
x*  v; \
type var; \
(v)->name(var);

#define Class_Supports_ProtectedModifier(x,name,type) \
class  deriv : public x { \
void test() {type var;  this->name(var);}; \
};

#define Assignment_XtoY_OK(x,y) \
x from_arg; \
y to_arg; \
to_arg = from_arg;

#define Operator_XtoY_OK(oper,x,y) \
x* from_arg; \
y* to_arg; \
*to_arg oper *from_arg;

#define Class_Has_PublConstructor(x) \
x* var = new x();

#define Class_Has_PublConstructor_Parameter1(x,p) \
p arg; \
x* var = new x(arg);

#define Class_Has_PublConstructor_Parameter1_2(x,p) \
p* arg; \
x* var = new x(*arg);

#define Class_Has_PublConstructor_Parameter14(x,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14) \
p1 arg1; \
p2 arg2; \
p3 arg3; \
p4 arg4; \
p5 arg5; \
p6 arg6; \
p7 arg7; \
p8 arg8; \
p9 arg9; \
p10 arg10; \
p11 arg11; \
p12 arg12; \
p13 arg13; \
p14 arg14; \
x* var = new x(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,arg10,arg11,arg12,arg13,arg14);

#define Class_Has_ProtConstructor(x) \
class  x##deriv : public x { \
public: \
 x##deriv() {x();}; \
 }; \
x##deriv TestVar;

#define Class_Has_ProtDestructor(x) \
class  deriv : public x { \
public: \
 ~deriv() {~x();}; \
 };

#define Class_Has_PublMemFunction_Result_FormParameter3(x,name,r,p1,p2,p3) \
r (x::*pf)(p1,p2,p3) = NULL; \
pf = x::name;

#define Produce_forClass_ServerImplementation(x) \
class x##_impl : public virtual POA_##x { \
};

#define Redefine_forServerClass_virtualPublMemFunction_Result_FormParameter3(x,name,r,p1,p2,p3) \
class x##_impl : public virtual POA_##x { \
r name(p1 a,p2 b,p3 c VSORB_SRC_ENV2) VSORB_THROW_SYSTEMEXCEPTION {} \
};

#define Redefine_forClass_virtualPublMemFunction_Result_FormParameter3(x,name,r,p1,p2,p3) \
class x##_impl : virtual public  x { \
r name(p1 a,p2 b,p3 c){} \
};

#define PublicClassDerivation_XfromY_OK(x,y) \
x *rptr;  \
y *lptr; \
lptr = rptr;

#define Widening_XtoY(x,y) \
x r; \
y l; \
l = r;

#define Class_Supports_PublMemFunction_Type_Res_InOutInout(x,f,type) \
x* ptr1; \
type p; \
type res; \
res = ptr1->f(p, p, p );

#define Generate_Public_Object_fromClass(x) \
x obj;

#define Class_Has_PublicDestructor(x) \
x* ptr; \
ptr->delete();

#define Class_Supports_PublMember(x,name,type) \
x*  aclass; \
type lvar; \
lvar = (*aclass).name; \
(*aclass).name = lvar;

#define Class_Has_PrivatAssignment(x) \
class abc: public x { 	\
public:	abc();		\
	void op(){		\
		abc *a, *b;	\
		(*a)=(*b);	\
	}			\
};


#define Class_Supports_PublSubscribtion_Operator(x,type,j)\
x* ptr; \
type test;\
for(int i=0;i<j; i++)\
  test = (*ptr)[i];

#define Class_Supports_Array_Operator_2Dim(x,type,imax,jmax)\
  type var_;\
  x *Ar;\
  for (int i=0;i<imax; i++)\
    { \
      for(int j=0;j<jmax;j++) \
	{ \
	  var_=(*Ar)[i][j]; \
	  (*Ar)[i][j]=var_; \
	} \
    }


#define Catch_Exception_ofOperation(extype,exmem,exmemtype,ptrtype,oper,opres) \
ptrtype x_ptr; \
opres res; \
exmemtype ex_item; \
try { res = x_ptr->oper();} \
catch (extype &ex) { ex_item = ex.exmem;} \
catch (CORBA::SystemException &ex) {}
