//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: tset/c++/sii/include/syncinfo.hh
//
// Modifications:
// $Log: syncinfo.hh,v $
// Revision 1.1.1.1  2000/02/09 17:15:43  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.1  1997/11/25 16:00:57  james
// Initial Source
//
//
//

#ifndef VSORB_SYNC_HH
#define VSORB_SYNC_HH

// Number of second to wait for a TET remote sync
// event to complete

#define VS_TIMEOUT  15

#define SERVER_TO_CLIENT  3000  

#define PROXY  1
#define SERVER 2
#define CLIENT 3

#define CSW SERVER
#define SSW CLIENT

#define SEVENT SERVER_TO_CLIENT 
#define CEVENT SERVER_TO_CLIENT


#endif

