//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//

#include <tet_api.h>
#include <orb_supp.hh>
#include <tin.hh>
#include "types.hh"
#include "server.hh"
#include "ernie.hh"


extern Ernie ernie;
 


CORBA::Char
idlServer_imp::Lychees( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 
  CORBA::Char ReturnValue;

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lychees\n");
#endif
  
  ernie.seed("LycheesCall");
  
  ernie.seed("LycheesReturn"); 
  
  GetChar(ReturnValue);
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lychees\n");
#endif
  ::tet_result(TET_PASS);
  
  return ReturnValue;
}

void
idlServer_imp::Lychees(CORBA::Char _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lychees\n");
#endif
  
  ernie.seed("LycheesCall");
  AddName("_attr");
  if (!CheckChar(_attr))
    ::tet_result(TET_FAIL);
  RemoveName();
  
  ernie.seed("LycheesReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lychees\n");
#endif
  ::tet_result(TET_PASS);
  
  
}

void
idlServer_imp::Lemon( VSORB_SRC_ENV2)
    throw(CORBA::SystemException)
{ 

#ifdef DEBUG
  ::tet_infoline("server: executing ::idlServer::Lemon\n");
#endif
  
  ernie.seed("LemonCall");
  
  ernie.seed("LemonReturn"); 
  
	
#ifdef DEBUG
  ::tet_infoline("server: returning from ::idlServer::Lemon\n");
#endif
  ::tet_result(TET_PASS);
  
  
}



