//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:13  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/05/04 12:06:37  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/11 18:15:42  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetLoganBerryBlackCherryStarfruit(::LoganBerry::BlackCherry::Starfruit &);
int CheckLoganBerryBlackCherryStarfruit(const ::LoganBerry::BlackCherry::Starfruit &);
void GetLoganBerryParsnipGinger(::LoganBerry::Parsnip::Ginger &);
int CheckLoganBerryParsnipGinger(const ::LoganBerry::Parsnip::Ginger &);
void GetLoganBerryParsnipCeleryLychees(::LoganBerry::Parsnip::Celery::Lychees &);
int CheckLoganBerryParsnipCeleryLychees(const ::LoganBerry::Parsnip::Celery::Lychees &);
void GetLoganBerryParsnipCeleryWhiteCabbage(::LoganBerry::Parsnip::Celery::WhiteCabbage &);
int CheckLoganBerryParsnipCeleryWhiteCabbage(const ::LoganBerry::Parsnip::Celery::WhiteCabbage &);
void GetLoganBerryAppleOrange(::LoganBerry::Apple::Orange &);
int CheckLoganBerryAppleOrange(const ::LoganBerry::Apple::Orange &);
void GetLoganBerryAppleMint(::LoganBerry::Apple::Mint &);
int CheckLoganBerryAppleMint(const ::LoganBerry::Apple::Mint &);
void GetLoganBerryBananaGaliaMelon(::LoganBerry::Banana::GaliaMelon &);
int CheckLoganBerryBananaGaliaMelon(const ::LoganBerry::Banana::GaliaMelon &);
void GetCarrotsTurnip(::Carrots::Turnip &);
int CheckCarrotsTurnip(const ::Carrots::Turnip &);
void GetidlServerOrange(::idlServer::Orange &);
int CheckidlServerOrange(const ::idlServer::Orange &);



