//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::LoganBerry* LoganBerryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void LoganBerryAttr(const ::LoganBerry &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::LoganBerry* LoganBerryOp(const ::LoganBerry &p1,::LoganBerry_out p2,::LoganBerry &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsnip_slice * ParsnipAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ParsnipAttr(const ::Parsnip _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsnip_slice * ParsnipOp(const ::Parsnip p1,::Parsnip_out p2,::Parsnip p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Celery* CeleryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void CeleryAttr(const ::Celery &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Celery* CeleryOp(const ::Celery &p1,::Celery_out p2,::Celery &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::WhiteCabbage_slice * WhiteCabbageAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void WhiteCabbageAttr(const ::WhiteCabbage _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::WhiteCabbage_slice * WhiteCabbageOp(const ::WhiteCabbage p1,::WhiteCabbage_out p2,::WhiteCabbage p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Aniseed* AniseedAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void AniseedAttr(const ::Aniseed &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Aniseed* AniseedOp(const ::Aniseed &p1,::Aniseed_out p2,::Aniseed &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Bayleaf_slice * BayleafAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BayleafAttr(const ::Bayleaf _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Bayleaf_slice * BayleafOp(const ::Bayleaf p1,::Bayleaf_out p2,::Bayleaf p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Dill* DillAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void DillAttr(const ::Dill &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Dill* DillOp(const ::Dill &p1,::Dill_out p2,::Dill &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Oregano_slice * OreganoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void OreganoAttr(const ::Oregano _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Oregano_slice * OreganoOp(const ::Oregano p1,::Oregano_out p2,::Oregano p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

