//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Sweetcorn* SweetcornAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void SweetcornAttr(const ::Sweetcorn &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sweetcorn* SweetcornOp(const ::Sweetcorn &p1,::Sweetcorn_out p2,::Sweetcorn &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Onion_slice * OnionAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void OnionAttr(const ::Onion _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Onion_slice * OnionOp(const ::Onion p1,::Onion_out p2,::Onion p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Shallots* ShallotsAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ShallotsAttr(const ::Shallots &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Shallots* ShallotsOp(const ::Shallots &p1,::Shallots_out p2,::Shallots &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Plum_slice * PlumAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void PlumAttr(const ::Plum _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Plum_slice * PlumOp(const ::Plum p1,::Plum_out p2,::Plum p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KidneyBean* KidneyBeanAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void KidneyBeanAttr(const ::KidneyBean &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KidneyBean* KidneyBeanOp(const ::KidneyBean &p1,::KidneyBean_out p2,::KidneyBean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Zucchini_slice * ZucchiniAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ZucchiniAttr(const ::Zucchini _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Zucchini_slice * ZucchiniOp(const ::Zucchini p1,::Zucchini_out p2,::Zucchini p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::ButterBean* ButterBeanAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ButterBeanAttr(const ::ButterBean &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::ButterBean* ButterBeanOp(const ::ButterBean &p1,::ButterBean_out p2,::ButterBean &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado_slice * AvocadoAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void AvocadoAttr(const ::Avocado _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Avocado_slice * AvocadoOp(const ::Avocado p1,::Avocado_out p2,::Avocado p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

