//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Melon* MelonAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void MelonAttr(const ::Melon &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Melon* MelonOp(const ::Melon &p1,::Melon_out p2,::Melon &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Elderberry_slice * ElderberryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ElderberryAttr(const ::Elderberry _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Elderberry_slice * ElderberryOp(const ::Elderberry p1,::Elderberry_out p2,::Elderberry p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Fennell* FennellAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void FennellAttr(const ::Fennell &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Fennell* FennellOp(const ::Fennell &p1,::Fennell_out p2,::Fennell &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chickpea_slice * ChickpeaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ChickpeaAttr(const ::Chickpea _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Chickpea_slice * ChickpeaOp(const ::Chickpea p1,::Chickpea_out p2,::Chickpea p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Plantain* PlantainAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void PlantainAttr(const ::Plantain &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Plantain* PlantainOp(const ::Plantain &p1,::Plantain_out p2,::Plantain &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::LimaBean_slice * LimaBeanAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void LimaBeanAttr(const ::LimaBean _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::LimaBean_slice * LimaBeanOp(const ::LimaBean p1,::LimaBean_out p2,::LimaBean p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedPepper* RedPepperAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RedPepperAttr(const ::RedPepper &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedPepper* RedPepperOp(const ::RedPepper &p1,::RedPepper_out p2,::RedPepper &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sharanfruit_slice * SharanfruitAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void SharanfruitAttr(const ::Sharanfruit _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Sharanfruit_slice * SharanfruitOp(const ::Sharanfruit p1,::Sharanfruit_out p2,::Sharanfruit p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

