//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Papaya* PapayaAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void PapayaAttr(const ::Papaya &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Papaya* PapayaOp(const ::Papaya &p1,::Papaya_out p2,::Papaya &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Raspberry_slice * RaspberryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RaspberryAttr(const ::Raspberry _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Raspberry_slice * RaspberryOp(const ::Raspberry p1,::Raspberry_out p2,::Raspberry p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Damsons* DamsonsAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void DamsonsAttr(const ::Damsons &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Damsons* DamsonsOp(const ::Damsons &p1,::Damsons_out p2,::Damsons &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Artichokes_slice * ArtichokesAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void ArtichokesAttr(const ::Artichokes _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Artichokes_slice * ArtichokesOp(const ::Artichokes p1,::Artichokes_out p2,::Artichokes p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::CookingApple* CookingAppleAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void CookingAppleAttr(const ::CookingApple &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::CookingApple* CookingAppleOp(const ::CookingApple &p1,::CookingApple_out p2,::CookingApple &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GreenChilly_slice * GreenChillyAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GreenChillyAttr(const ::GreenChilly _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GreenChilly_slice * GreenChillyOp(const ::GreenChilly p1,::GreenChilly_out p2,::GreenChilly p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::YellowPepper* YellowPepperAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void YellowPepperAttr(const ::YellowPepper &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::YellowPepper* YellowPepperOp(const ::YellowPepper &p1,::YellowPepper_out p2,::YellowPepper &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Blueberry_slice * BlueberryAttr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BlueberryAttr(const ::Blueberry _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Blueberry_slice * BlueberryOp(const ::Blueberry p1,::Blueberry_out p2,::Blueberry p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

