//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:27  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1999/05/04 12:06:57  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.4  1997/12/09 11:27:17  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetZucchini1(::Zucchini1 );
int CheckZucchini1(const ::Zucchini1 );
void GetRedOnion1(::RedOnion1 &);
int CheckRedOnion1(const ::RedOnion1 &);
void GetJuniperBerries1(::JuniperBerries1 );
int CheckJuniperBerries1(const ::JuniperBerries1 );
void GetTarragon1(::Tarragon1 &);
int CheckTarragon1(const ::Tarragon1 &);
void GetElderberry1(::Elderberry1 );
int CheckElderberry1(const ::Elderberry1 );
void GetPlantain1(::Plantain1 &);
int CheckPlantain1(const ::Plantain1 &);
void GetSharanfruit1(::Sharanfruit1 );
int CheckSharanfruit1(const ::Sharanfruit1 );
void GetDamsons1(::Damsons1 &);
int CheckDamsons1(const ::Damsons1 &);
void GetEddo1(::Eddo1 );
int CheckEddo1(const ::Eddo1 );
void GetCoxPippin1(::CoxPippin1 &);
int CheckCoxPippin1(const ::CoxPippin1 &);
void GetKiwanoMelon1(::KiwanoMelon1 );
int CheckKiwanoMelon1(const ::KiwanoMelon1 );
void GetRedCabbage1(::RedCabbage1 &);
int CheckRedCabbage1(const ::RedCabbage1 &);
void GetPimpernel1(::Pimpernel1 );
int CheckPimpernel1(const ::Pimpernel1 );
void GetBlackCherry2(::BlackCherry2 &);
int CheckBlackCherry2(const ::BlackCherry2 &);
void GetCucumber2(::Cucumber2 &);
int CheckCucumber2(const ::Cucumber2 &);
void GetidlServerZucchini1Excpt(::idlServer::Zucchini1Excpt &);
int CheckidlServerZucchini1Excpt(const ::idlServer::Zucchini1Excpt &);
void GetidlServerRedOnion1Excpt(::idlServer::RedOnion1Excpt &);
int CheckidlServerRedOnion1Excpt(const ::idlServer::RedOnion1Excpt &);
void GetidlServerJuniperBerries1Excpt(::idlServer::JuniperBerries1Excpt &);
int CheckidlServerJuniperBerries1Excpt(const ::idlServer::JuniperBerries1Excpt &);
void GetidlServerTarragon1Excpt(::idlServer::Tarragon1Excpt &);
int CheckidlServerTarragon1Excpt(const ::idlServer::Tarragon1Excpt &);
void GetidlServerElderberry1Excpt(::idlServer::Elderberry1Excpt &);
int CheckidlServerElderberry1Excpt(const ::idlServer::Elderberry1Excpt &);
void GetidlServerPlantain1Excpt(::idlServer::Plantain1Excpt &);
int CheckidlServerPlantain1Excpt(const ::idlServer::Plantain1Excpt &);
void GetidlServerSharanfruit1Excpt(::idlServer::Sharanfruit1Excpt &);
int CheckidlServerSharanfruit1Excpt(const ::idlServer::Sharanfruit1Excpt &);
void GetidlServerDamsons1Excpt(::idlServer::Damsons1Excpt &);
int CheckidlServerDamsons1Excpt(const ::idlServer::Damsons1Excpt &);
void GetidlServerEddo1Excpt(::idlServer::Eddo1Excpt &);
int CheckidlServerEddo1Excpt(const ::idlServer::Eddo1Excpt &);
void GetidlServerCoxPippin1Excpt(::idlServer::CoxPippin1Excpt &);
int CheckidlServerCoxPippin1Excpt(const ::idlServer::CoxPippin1Excpt &);
void GetidlServerKiwanoMelon1Excpt(::idlServer::KiwanoMelon1Excpt &);
int CheckidlServerKiwanoMelon1Excpt(const ::idlServer::KiwanoMelon1Excpt &);
void GetidlServerRedCabbage1Excpt(::idlServer::RedCabbage1Excpt &);
int CheckidlServerRedCabbage1Excpt(const ::idlServer::RedCabbage1Excpt &);
void GetidlServerPimpernel1Excpt(::idlServer::Pimpernel1Excpt &);
int CheckidlServerPimpernel1Excpt(const ::idlServer::Pimpernel1Excpt &);
void GetidlServerBlackCherry2Excpt(::idlServer::BlackCherry2Excpt &);
int CheckidlServerBlackCherry2Excpt(const ::idlServer::BlackCherry2Excpt &);
void GetidlServerCucumber2Excpt(::idlServer::Cucumber2Excpt &);
int CheckidlServerCucumber2Excpt(const ::idlServer::Cucumber2Excpt &);



