//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: CORVAL2
//


#include "idlmacros.hh"

class idlServer_imp : public virtual POA_idlServer
{
  ::Parsnip2_slice * Parsnip2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Parsnip2Attr(const ::Parsnip2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsnip2_slice * Parsnip2Op(const ::Parsnip2 p1,::Parsnip2_out p2,::Parsnip2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Prunes2* Prunes2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Prunes2Attr(const ::Prunes2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Prunes2* Prunes2Op(const ::Prunes2 &p1,::Prunes2_out p2,::Prunes2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Plum2_slice * Plum2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Plum2Attr(const ::Plum2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Plum2_slice * Plum2Op(const ::Plum2 p1,::Plum2_out p2,::Plum2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::EggPlant2* EggPlant2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void EggPlant2Attr(const ::EggPlant2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::EggPlant2* EggPlant2Op(const ::EggPlant2 &p1,::EggPlant2_out p2,::EggPlant2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mustard2* Mustard2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Mustard2Attr(const ::Mustard2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Mustard2* Mustard2Op(const ::Mustard2 &p1,::Mustard2_out p2,::Mustard2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Elderberry2_slice * Elderberry2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Elderberry2Attr(const ::Elderberry2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Elderberry2_slice * Elderberry2Op(const ::Elderberry2 p1,::Elderberry2_out p2,::Elderberry2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedPepper2* RedPepper2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void RedPepper2Attr(const ::RedPepper2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::RedPepper2* RedPepper2Op(const ::RedPepper2 &p1,::RedPepper2_out p2,::RedPepper2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Artichokes2_slice * Artichokes2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Artichokes2Attr(const ::Artichokes2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Artichokes2_slice * Artichokes2Op(const ::Artichokes2 p1,::Artichokes2_out p2,::Artichokes2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KiwanoMelon2_slice * KiwanoMelon2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void KiwanoMelon2Attr(const ::KiwanoMelon2 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::KiwanoMelon2_slice * KiwanoMelon2Op(const ::KiwanoMelon2 p1,::KiwanoMelon2_out p2,::KiwanoMelon2 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BritishQueens2* BritishQueens2Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void BritishQueens2Attr(const ::BritishQueens2 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::BritishQueens2* BritishQueens2Op(const ::BritishQueens2 &p1,::BritishQueens2_out p2,::BritishQueens2 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Starfruit3_slice * Starfruit3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Starfruit3Attr(const ::Starfruit3 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Starfruit3_slice * Starfruit3Op(const ::Starfruit3 p1,::Starfruit3_out p2,::Starfruit3 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsnip3_slice * Parsnip3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Parsnip3Attr(const ::Parsnip3 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Parsnip3_slice * Parsnip3Op(const ::Parsnip3 p1,::Parsnip3_out p2,::Parsnip3 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Billberries3* Billberries3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Billberries3Attr(const ::Billberries3 &_attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Billberries3* Billberries3Op(const ::Billberries3 &p1,::Billberries3_out p2,::Billberries3 &p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GooseBerry3_slice * GooseBerry3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void GooseBerry3Attr(const ::GooseBerry3 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::GooseBerry3_slice * GooseBerry3Op(const ::GooseBerry3 p1,::GooseBerry3_out p2,::GooseBerry3 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Elderberry3_slice * Elderberry3Attr( VSORB_SRC_ENV2)
    throw(CORBA::SystemException);
  void Elderberry3Attr(const ::Elderberry3 _attr VSORB_SRC_ENV)
    throw(CORBA::SystemException);
  ::Elderberry3_slice * Elderberry3Op(const ::Elderberry3 p1,::Elderberry3_out p2,::Elderberry3 p3 VSORB_SRC_ENV)
    throw(CORBA::SystemException);
};

