//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:38  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/05/04 12:07:10  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:00:30  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetCultra66(::Cultra66 &);
int CheckCultra66(const ::Cultra66 &);
void GetPimpernel66(::Pimpernel66 &);
int CheckPimpernel66(const ::Pimpernel66 &);
void GetPimpernel66KerrsPinks66(::Pimpernel66::KerrsPinks66 &);
int CheckPimpernel66KerrsPinks66(const ::Pimpernel66::KerrsPinks66 &);
void GetPimpernel66KerrsPinks66Wilja66(::Pimpernel66::KerrsPinks66::Wilja66 &);
int CheckPimpernel66KerrsPinks66Wilja66(const ::Pimpernel66::KerrsPinks66::Wilja66 &);
void GetBroadbeans67(::Broadbeans67 &);
int CheckBroadbeans67(const ::Broadbeans67 &);
void GetChineseLeaves67(::ChineseLeaves67 &);
int CheckChineseLeaves67(const ::ChineseLeaves67 &);
void GetChineseLeaves67Clementine67(::ChineseLeaves67::Clementine67 &);
int CheckChineseLeaves67Clementine67(const ::ChineseLeaves67::Clementine67 &);
void GetChineseLeaves67Clementine67Chestnut67(::ChineseLeaves67::Clementine67::Chestnut67 &);
int CheckChineseLeaves67Clementine67Chestnut67(const ::ChineseLeaves67::Clementine67::Chestnut67 &);
void GetCeleriac68(::Celeriac68 &);
int CheckCeleriac68(const ::Celeriac68 &);
void GetRedChilly68(::RedChilly68 &);
int CheckRedChilly68(const ::RedChilly68 &);
void GetRedChilly68Chayato68(::RedChilly68::Chayato68 &);
int CheckRedChilly68Chayato68(const ::RedChilly68::Chayato68 &);
void GetRedChilly68Chayato68KiwanoMelon68(::RedChilly68::Chayato68::KiwanoMelon68 &);
int CheckRedChilly68Chayato68KiwanoMelon68(const ::RedChilly68::Chayato68::KiwanoMelon68 &);
void GetScallion69(::Scallion69 &);
int CheckScallion69(const ::Scallion69 &);
void GetVineTomatoes69(::VineTomatoes69 &);
int CheckVineTomatoes69(const ::VineTomatoes69 &);
void GetVineTomatoes69Chervil69(::VineTomatoes69::Chervil69 &);
int CheckVineTomatoes69Chervil69(const ::VineTomatoes69::Chervil69 &);
void GetVineTomatoes69Chervil69GreenChilly69(::VineTomatoes69::Chervil69::GreenChilly69 &);
int CheckVineTomatoes69Chervil69GreenChilly69(const ::VineTomatoes69::Chervil69::GreenChilly69 &);
void GetPeanuts70(::Peanuts70 &);
int CheckPeanuts70(const ::Peanuts70 &);
void GetSatsuma70(::Satsuma70 &);
int CheckSatsuma70(const ::Satsuma70 &);
void GetSatsuma70Parsley70(::Satsuma70::Parsley70 &);
int CheckSatsuma70Parsley70(const ::Satsuma70::Parsley70 &);
void GetSatsuma70Parsley70Peach70(::Satsuma70::Parsley70::Peach70 &);
int CheckSatsuma70Parsley70Peach70(const ::Satsuma70::Parsley70::Peach70 &);
void GetMullberry71(::Mullberry71 &);
int CheckMullberry71(const ::Mullberry71 &);
void GetChives71(::Chives71 &);
int CheckChives71(const ::Chives71 &);
void GetChives71Rasin71(::Chives71::Rasin71 &);
int CheckChives71Rasin71(const ::Chives71::Rasin71 &);
void GetChives71Rasin71Cherry71(::Chives71::Rasin71::Cherry71 &);
int CheckChives71Rasin71Cherry71(const ::Chives71::Rasin71::Cherry71 &);
void GetDamsons72(::Damsons72 &);
int CheckDamsons72(const ::Damsons72 &);
void GetPepinoMelon72(::PepinoMelon72 &);
int CheckPepinoMelon72(const ::PepinoMelon72 &);
void GetPepinoMelon72Raspberry72(::PepinoMelon72::Raspberry72 &);
int CheckPepinoMelon72Raspberry72(const ::PepinoMelon72::Raspberry72 &);
void GetPepinoMelon72Raspberry72Peppercorn72(::PepinoMelon72::Raspberry72::Peppercorn72 &);
int CheckPepinoMelon72Raspberry72Peppercorn72(const ::PepinoMelon72::Raspberry72::Peppercorn72 &);
void GetFrenchBeans73(::FrenchBeans73 &);
int CheckFrenchBeans73(const ::FrenchBeans73 &);
void GetBeefTomatoes73(::BeefTomatoes73 &);
int CheckBeefTomatoes73(const ::BeefTomatoes73 &);
void GetBeefTomatoes73Pear73(::BeefTomatoes73::Pear73 &);
int CheckBeefTomatoes73Pear73(const ::BeefTomatoes73::Pear73 &);
void GetBeefTomatoes73Pear73Walnuts73(::BeefTomatoes73::Pear73::Walnuts73 &);
int CheckBeefTomatoes73Pear73Walnuts73(const ::BeefTomatoes73::Pear73::Walnuts73 &);
void GetPlantain74(::Plantain74 &);
int CheckPlantain74(const ::Plantain74 &);
void GetOkra74(::Okra74 &);
int CheckOkra74(const ::Okra74 &);
void GetOkra74Chickpea74(::Okra74::Chickpea74 &);
int CheckOkra74Chickpea74(const ::Okra74::Chickpea74 &);
void GetOkra74Chickpea74Uglifruit74(::Okra74::Chickpea74::Uglifruit74 &);
int CheckOkra74Chickpea74Uglifruit74(const ::Okra74::Chickpea74::Uglifruit74 &);
void GetBeechNut75(::BeechNut75 &);
int CheckBeechNut75(const ::BeechNut75 &);
void GetRedGrapes75(::RedGrapes75 &);
int CheckRedGrapes75(const ::RedGrapes75 &);
void GetRedGrapes75Cassava75(::RedGrapes75::Cassava75 &);
int CheckRedGrapes75Cassava75(const ::RedGrapes75::Cassava75 &);
void GetRedGrapes75Cassava75Daikan75(::RedGrapes75::Cassava75::Daikan75 &);
int CheckRedGrapes75Cassava75Daikan75(const ::RedGrapes75::Cassava75::Daikan75 &);
void GetTarragon76(::Tarragon76 &);
int CheckTarragon76(const ::Tarragon76 &);
void GetPomegranate76(::Pomegranate76 &);
int CheckPomegranate76(const ::Pomegranate76 &);
void GetPomegranate76Thyme76(::Pomegranate76::Thyme76 &);
int CheckPomegranate76Thyme76(const ::Pomegranate76::Thyme76 &);
void GetPomegranate76Thyme76Strawberry76(::Pomegranate76::Thyme76::Strawberry76 &);
int CheckPomegranate76Thyme76Strawberry76(const ::Pomegranate76::Thyme76::Strawberry76 &);
void GetEggPlant77(::EggPlant77 &);
int CheckEggPlant77(const ::EggPlant77 &);
void GetGooseBerry77(::GooseBerry77 &);
int CheckGooseBerry77(const ::GooseBerry77 &);
void GetGooseBerry77HazelNut77(::GooseBerry77::HazelNut77 &);
int CheckGooseBerry77HazelNut77(const ::GooseBerry77::HazelNut77 &);
void GetGooseBerry77HazelNut77Onion77(::GooseBerry77::HazelNut77::Onion77 &);
int CheckGooseBerry77HazelNut77Onion77(const ::GooseBerry77::HazelNut77::Onion77 &);
void GetGoldenDelicous78(::GoldenDelicous78 &);
int CheckGoldenDelicous78(const ::GoldenDelicous78 &);
void GetAvocado78(::Avocado78 &);
int CheckAvocado78(const ::Avocado78 &);
void GetAvocado78Zucchini78(::Avocado78::Zucchini78 &);
int CheckAvocado78Zucchini78(const ::Avocado78::Zucchini78 &);
void GetAvocado78Zucchini78Plum78(::Avocado78::Zucchini78::Plum78 &);
int CheckAvocado78Zucchini78Plum78(const ::Avocado78::Zucchini78::Plum78 &);
void GetLolloRossa79(::LolloRossa79 &);
int CheckLolloRossa79(const ::LolloRossa79 &);
void GetCantelopeMelon79(::CantelopeMelon79 &);
int CheckCantelopeMelon79(const ::CantelopeMelon79 &);
void GetCantelopeMelon79Tangarine79(::CantelopeMelon79::Tangarine79 &);
int CheckCantelopeMelon79Tangarine79(const ::CantelopeMelon79::Tangarine79 &);
void GetCantelopeMelon79Tangarine79Oregano79(::CantelopeMelon79::Tangarine79::Oregano79 &);
int CheckCantelopeMelon79Tangarine79Oregano79(const ::CantelopeMelon79::Tangarine79::Oregano79 &);
void GetPrunes80(::Prunes80 &);
int CheckPrunes80(const ::Prunes80 &);
void GetTofu80(::Tofu80 &);
int CheckTofu80(const ::Tofu80 &);
void GetTofu80Mushroom80(::Tofu80::Mushroom80 &);
int CheckTofu80Mushroom80(const ::Tofu80::Mushroom80 &);
void GetTofu80Mushroom80Almonds80(::Tofu80::Mushroom80::Almonds80 &);
int CheckTofu80Mushroom80Almonds80(const ::Tofu80::Mushroom80::Almonds80 &);
void GetAniseed81(::Aniseed81 &);
int CheckAniseed81(const ::Aniseed81 &);
void GetWhiteCabbage81(::WhiteCabbage81 &);
int CheckWhiteCabbage81(const ::WhiteCabbage81 &);
void GetWhiteCabbage81Parsnip81(::WhiteCabbage81::Parsnip81 &);
int CheckWhiteCabbage81Parsnip81(const ::WhiteCabbage81::Parsnip81 &);
void GetWhiteCabbage81Parsnip81Ginger81(::WhiteCabbage81::Parsnip81::Ginger81 &);
int CheckWhiteCabbage81Parsnip81Ginger81(const ::WhiteCabbage81::Parsnip81::Ginger81 &);
void GetGaliaMelon82(::GaliaMelon82 &);
int CheckGaliaMelon82(const ::GaliaMelon82 &);
void GetAsparagus82(::Asparagus82 &);
int CheckAsparagus82(const ::Asparagus82 &);
void GetAsparagus82Mint82(::Asparagus82::Mint82 &);
int CheckAsparagus82Mint82(const ::Asparagus82::Mint82 &);
void GetAsparagus82Mint82BlackEyedBeans82(::Asparagus82::Mint82::BlackEyedBeans82 &);
int CheckAsparagus82Mint82BlackEyedBeans82(const ::Asparagus82::Mint82::BlackEyedBeans82 &);
void GetLychees83(::Lychees83 &);
int CheckLychees83(const ::Lychees83 &);
void GetCoconut83(::Coconut83 &);
int CheckCoconut83(const ::Coconut83 &);
void GetCoconut83Lime83(::Coconut83::Lime83 &);
int CheckCoconut83Lime83(const ::Coconut83::Lime83 &);
void GetCoconut83Lime83PentlandDell82(::Coconut83::Lime83::PentlandDell82 &);
int CheckCoconut83Lime83PentlandDell82(const ::Coconut83::Lime83::PentlandDell82 &);
void GetRhubarb84(::Rhubarb84 &);
int CheckRhubarb84(const ::Rhubarb84 &);
void GetStarfruit84(::Starfruit84 &);
int CheckStarfruit84(const ::Starfruit84 &);
void GetStarfruit84Lemon84(::Starfruit84::Lemon84 &);
int CheckStarfruit84Lemon84(const ::Starfruit84::Lemon84 &);
void GetStarfruit84Lemon84Banana84(::Starfruit84::Lemon84::Banana84 &);
int CheckStarfruit84Lemon84Banana84(const ::Starfruit84::Lemon84::Banana84 &);
void GetMarisPiper84(::MarisPiper84 &);
int CheckMarisPiper84(const ::MarisPiper84 &);
void GetRooster84(::Rooster84 &);
int CheckRooster84(const ::Rooster84 &);
void GetRooster84Pimpernel84(::Rooster84::Pimpernel84 &);
int CheckRooster84Pimpernel84(const ::Rooster84::Pimpernel84 &);
void GetRooster84Pimpernel84Clementine84(::Rooster84::Pimpernel84::Clementine84 &);
int CheckRooster84Pimpernel84Clementine84(const ::Rooster84::Pimpernel84::Clementine84 &);
void GetBritishQueens85(::BritishQueens85 &);
int CheckBritishQueens85(const ::BritishQueens85 &);
void GetHomeguard85(::Homeguard85 &);
int CheckHomeguard85(const ::Homeguard85 &);
void GetHomeguard85Potato85(::Homeguard85::Potato85 &);
int CheckHomeguard85Potato85(const ::Homeguard85::Potato85 &);
void GetHomeguard85Potato85ChineseLeaves85(::Homeguard85::Potato85::ChineseLeaves85 &);
int CheckHomeguard85Potato85ChineseLeaves85(const ::Homeguard85::Potato85::ChineseLeaves85 &);
void GetCauliflower86(::Cauliflower86 &);
int CheckCauliflower86(const ::Cauliflower86 &);
void GetGalaApple86(::GalaApple86 &);
int CheckGalaApple86(const ::GalaApple86 &);
void GetGalaApple86RedChilly86(::GalaApple86::RedChilly86 &);
int CheckGalaApple86RedChilly86(const ::GalaApple86::RedChilly86 &);
void GetGalaApple86RedChilly86Chervil86(::GalaApple86::RedChilly86::Chervil86 &);
int CheckGalaApple86RedChilly86Chervil86(const ::GalaApple86::RedChilly86::Chervil86 &);
void GetIcebergLettuce87(::IcebergLettuce87 &);
int CheckIcebergLettuce87(const ::IcebergLettuce87 &);
void GetChestnut87(::Chestnut87 &);
int CheckChestnut87(const ::Chestnut87 &);
void GetChestnut87PricklyPear87(::Chestnut87::PricklyPear87 &);
int CheckChestnut87PricklyPear87(const ::Chestnut87::PricklyPear87 &);
void GetChestnut87PricklyPear87VineTomatoes87(::Chestnut87::PricklyPear87::VineTomatoes87 &);
int CheckChestnut87PricklyPear87VineTomatoes87(const ::Chestnut87::PricklyPear87::VineTomatoes87 &);
void GetCoxPippin88(::CoxPippin88 &);
int CheckCoxPippin88(const ::CoxPippin88 &);
void GetBasil88(::Basil88 &);
int CheckBasil88(const ::Basil88 &);
void GetBasil88Satsuma88(::Basil88::Satsuma88 &);
int CheckBasil88Satsuma88(const ::Basil88::Satsuma88 &);
void GetBasil88Satsuma88Rasin88(::Basil88::Satsuma88::Rasin88 &);
int CheckBasil88Satsuma88Rasin88(const ::Basil88::Satsuma88::Rasin88 &);
void GetCorn89(::Corn89 &);
int CheckCorn89(const ::Corn89 &);
void GetGreenChilly89(::GreenChilly89 &);
int CheckGreenChilly89(const ::GreenChilly89 &);
void GetGreenChilly89Eddo89(::GreenChilly89::Eddo89 &);
int CheckGreenChilly89Eddo89(const ::GreenChilly89::Eddo89 &);
void GetGreenChilly89Eddo89Chives89(::GreenChilly89::Eddo89::Chives89 &);
int CheckGreenChilly89Eddo89Chives89(const ::GreenChilly89::Eddo89::Chives89 &);
void GetidlServerCultra66Excpt(::idlServer::Cultra66Excpt &);
int CheckidlServerCultra66Excpt(const ::idlServer::Cultra66Excpt &);
void GetidlServerPimpernel66Excpt(::idlServer::Pimpernel66Excpt &);
int CheckidlServerPimpernel66Excpt(const ::idlServer::Pimpernel66Excpt &);
void GetidlServerKerrsPinks66Excpt(::idlServer::KerrsPinks66Excpt &);
int CheckidlServerKerrsPinks66Excpt(const ::idlServer::KerrsPinks66Excpt &);
void GetidlServerWilja66Excpt(::idlServer::Wilja66Excpt &);
int CheckidlServerWilja66Excpt(const ::idlServer::Wilja66Excpt &);
void GetidlServerBroadbeans67Excpt(::idlServer::Broadbeans67Excpt &);
int CheckidlServerBroadbeans67Excpt(const ::idlServer::Broadbeans67Excpt &);



