//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:45  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/05/04 12:07:16  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:03:54  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetEggPlant138(::EggPlant138 &);
int CheckEggPlant138(const ::EggPlant138 &);
void GetGooseBerry138(::GooseBerry138 &);
int CheckGooseBerry138(const ::GooseBerry138 &);
void GetGooseBerry138HazelNut138(::GooseBerry138::HazelNut138 &);
int CheckGooseBerry138HazelNut138(const ::GooseBerry138::HazelNut138 &);
void GetGooseBerry138HazelNut138Onion138(::GooseBerry138::HazelNut138::Onion138 &);
int CheckGooseBerry138HazelNut138Onion138(const ::GooseBerry138::HazelNut138::Onion138 &);
void GetGooseBerry138HazelNut138Onion138RowanBerry138(::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &);
int CheckGooseBerry138HazelNut138Onion138RowanBerry138(const ::GooseBerry138::HazelNut138::Onion138::RowanBerry138 &);
void GetEggPlant139(::EggPlant139 &);
int CheckEggPlant139(const ::EggPlant139 &);
void GetGooseBerry139(::GooseBerry139 &);
int CheckGooseBerry139(const ::GooseBerry139 &);
void GetGooseBerry139HazelNut139(::GooseBerry139::HazelNut139 &);
int CheckGooseBerry139HazelNut139(const ::GooseBerry139::HazelNut139 &);
void GetGooseBerry139HazelNut139CrabApple139(::GooseBerry139::HazelNut139::CrabApple139 &);
int CheckGooseBerry139HazelNut139CrabApple139(const ::GooseBerry139::HazelNut139::CrabApple139 &);
void GetGooseBerry139HazelNut139CrabApple139Lentil139(::GooseBerry139::HazelNut139::CrabApple139::Lentil139 &);
int CheckGooseBerry139HazelNut139CrabApple139Lentil139(const ::GooseBerry139::HazelNut139::CrabApple139::Lentil139 &);
void GetRedOnion140(::RedOnion140 &);
int CheckRedOnion140(const ::RedOnion140 &);
void GetCrabApple140(::CrabApple140 &);
int CheckCrabApple140(const ::CrabApple140 &);
void GetCrabApple140Lentil140(::CrabApple140::Lentil140 &);
int CheckCrabApple140Lentil140(const ::CrabApple140::Lentil140 &);
void GetCrabApple140Lentil140CantelopeMelon140(::CrabApple140::Lentil140::CantelopeMelon140 &);
int CheckCrabApple140Lentil140CantelopeMelon140(const ::CrabApple140::Lentil140::CantelopeMelon140 &);
void GetCrabApple140Lentil140CantelopeMelon140Sultana140(::CrabApple140::Lentil140::CantelopeMelon140::Sultana140 &);
int CheckCrabApple140Lentil140CantelopeMelon140Sultana140(const ::CrabApple140::Lentil140::CantelopeMelon140::Sultana140 &);
void GetRedOnion141(::RedOnion141 &);
int CheckRedOnion141(const ::RedOnion141 &);
void GetCrabApple141(::CrabApple141 &);
int CheckCrabApple141(const ::CrabApple141 &);
void GetCrabApple141Lentil141(::CrabApple141::Lentil141 &);
int CheckCrabApple141Lentil141(const ::CrabApple141::Lentil141 &);
void GetCrabApple141Lentil141Avocado141(::CrabApple141::Lentil141::Avocado141 &);
int CheckCrabApple141Lentil141Avocado141(const ::CrabApple141::Lentil141::Avocado141 &);
void GetCrabApple141Lentil141Avocado141Oregano141(::CrabApple141::Lentil141::Avocado141::Oregano141 &);
int CheckCrabApple141Lentil141Avocado141Oregano141(const ::CrabApple141::Lentil141::Avocado141::Oregano141 &);
void GetFig142(::Fig142 &);
int CheckFig142(const ::Fig142 &);
void GetLentil142(::Lentil142 &);
int CheckLentil142(const ::Lentil142 &);
void GetLentil142Avocado142(::Lentil142::Avocado142 &);
int CheckLentil142Avocado142(const ::Lentil142::Avocado142 &);
void GetLentil142Avocado142Tangarine142(::Lentil142::Avocado142::Tangarine142 &);
int CheckLentil142Avocado142Tangarine142(const ::Lentil142::Avocado142::Tangarine142 &);
void GetLentil142Avocado142Tangarine142BrazilNut142(::Lentil142::Avocado142::Tangarine142::BrazilNut142 &);
int CheckLentil142Avocado142Tangarine142BrazilNut142(const ::Lentil142::Avocado142::Tangarine142::BrazilNut142 &);
void GetFig143(::Fig143 &);
int CheckFig143(const ::Fig143 &);
void GetLentil143(::Lentil143 &);
int CheckLentil143(const ::Lentil143 &);
void GetLentil143Avocado143(::Lentil143::Avocado143 &);
int CheckLentil143Avocado143(const ::Lentil143::Avocado143 &);
void GetLentil143Avocado143Zucchini143(::Lentil143::Avocado143::Zucchini143 &);
int CheckLentil143Avocado143Zucchini143(const ::Lentil143::Avocado143::Zucchini143 &);
void GetLentil143Avocado143Zucchini143Plum143(::Lentil143::Avocado143::Zucchini143::Plum143 &);
int CheckLentil143Avocado143Zucchini143Plum143(const ::Lentil143::Avocado143::Zucchini143::Plum143 &);
void GetButterBean144(::ButterBean144 &);
int CheckButterBean144(const ::ButterBean144 &);
void GetZucchini144(::Zucchini144 &);
int CheckZucchini144(const ::Zucchini144 &);
void GetZucchini144Plum144(::Zucchini144::Plum144 &);
int CheckZucchini144Plum144(const ::Zucchini144::Plum144 &);
void GetZucchini144Plum144Brocoli144(::Zucchini144::Plum144::Brocoli144 &);
int CheckZucchini144Plum144Brocoli144(const ::Zucchini144::Plum144::Brocoli144 &);
void GetZucchini144Plum144Brocoli144BlackEyedBeans144(::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144 &);
int CheckZucchini144Plum144Brocoli144BlackEyedBeans144(const ::Zucchini144::Plum144::Brocoli144::BlackEyedBeans144 &);
void GetidlServerEggPlant138Excpt(::idlServer::EggPlant138Excpt &);
int CheckidlServerEggPlant138Excpt(const ::idlServer::EggPlant138Excpt &);
void GetidlServerGooseBerry138Excpt(::idlServer::GooseBerry138Excpt &);
int CheckidlServerGooseBerry138Excpt(const ::idlServer::GooseBerry138Excpt &);
void GetidlServerHazelNut138Excpt(::idlServer::HazelNut138Excpt &);
int CheckidlServerHazelNut138Excpt(const ::idlServer::HazelNut138Excpt &);
void GetidlServerOnion138Excpt(::idlServer::Onion138Excpt &);
int CheckidlServerOnion138Excpt(const ::idlServer::Onion138Excpt &);
void GetidlServerRowanBerry138Excpt(::idlServer::RowanBerry138Excpt &);
int CheckidlServerRowanBerry138Excpt(const ::idlServer::RowanBerry138Excpt &);
void GetidlServerEggPlant139Excpt(::idlServer::EggPlant139Excpt &);
int CheckidlServerEggPlant139Excpt(const ::idlServer::EggPlant139Excpt &);
void GetidlServerGooseBerry139Excpt(::idlServer::GooseBerry139Excpt &);
int CheckidlServerGooseBerry139Excpt(const ::idlServer::GooseBerry139Excpt &);
void GetidlServerHazelNut139Excpt(::idlServer::HazelNut139Excpt &);
int CheckidlServerHazelNut139Excpt(const ::idlServer::HazelNut139Excpt &);
void GetidlServerCrabApple139Excpt(::idlServer::CrabApple139Excpt &);
int CheckidlServerCrabApple139Excpt(const ::idlServer::CrabApple139Excpt &);



