//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:47  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.6  1999/05/04 12:07:19  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.5  1997/12/12 09:04:52  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetAniseed163(::Aniseed163 &);
int CheckAniseed163(const ::Aniseed163 &);
void GetWhiteCabbage163(::WhiteCabbage163 &);
int CheckWhiteCabbage163(const ::WhiteCabbage163 &);
void GetWhiteCabbage163Parsnip163(::WhiteCabbage163::Parsnip163 &);
int CheckWhiteCabbage163Parsnip163(const ::WhiteCabbage163::Parsnip163 &);
void GetWhiteCabbage163Parsnip163Orange163(::WhiteCabbage163::Parsnip163::Orange163 &);
int CheckWhiteCabbage163Parsnip163Orange163(const ::WhiteCabbage163::Parsnip163::Orange163 &);
void GetWhiteCabbage163Parsnip163Orange163Sultana163(::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &);
int CheckWhiteCabbage163Parsnip163Orange163Sultana163(const ::WhiteCabbage163::Parsnip163::Orange163::Sultana163 &);
void GetLoganBerry164(::LoganBerry164 &);
int CheckLoganBerry164(const ::LoganBerry164 &);
void GetOrange164(::Orange164 &);
int CheckOrange164(const ::Orange164 &);
void GetOrange164Sultana164(::Orange164::Sultana164 &);
int CheckOrange164Sultana164(const ::Orange164::Sultana164 &);
void GetOrange164Sultana164Coconut164(::Orange164::Sultana164::Coconut164 &);
int CheckOrange164Sultana164Coconut164(const ::Orange164::Sultana164::Coconut164 &);
void GetOrange164Sultana164Coconut164Wilja163(::Orange164::Sultana164::Coconut164::Wilja163 &);
int CheckOrange164Sultana164Coconut164Wilja163(const ::Orange164::Sultana164::Coconut164::Wilja163 &);
void GetLoganBerry165(::LoganBerry165 &);
int CheckLoganBerry165(const ::LoganBerry165 &);
void GetOrange165(::Orange165 &);
int CheckOrange165(const ::Orange165 &);
void GetOrange165Sultana165(::Orange165::Sultana165 &);
int CheckOrange165Sultana165(const ::Orange165::Sultana165 &);
void GetOrange165Sultana165Asparagus165(::Orange165::Sultana165::Asparagus165 &);
int CheckOrange165Sultana165Asparagus165(const ::Orange165::Sultana165::Asparagus165 &);
void GetOrange165Sultana165Asparagus165PentlandDell164(::Orange165::Sultana165::Asparagus165::PentlandDell164 &);
int CheckOrange165Sultana165Asparagus165PentlandDell164(const ::Orange165::Sultana165::Asparagus165::PentlandDell164 &);
void GetTurnip166(::Turnip166 &);
int CheckTurnip166(const ::Turnip166 &);
void GetSultana166(::Sultana166 &);
int CheckSultana166(const ::Sultana166 &);
void GetSultana166Asparagus166(::Sultana166::Asparagus166 &);
int CheckSultana166Asparagus166(const ::Sultana166::Asparagus166 &);
void GetSultana166Asparagus166Lime166(::Sultana166::Asparagus166::Lime166 &);
int CheckSultana166Asparagus166Lime166(const ::Sultana166::Asparagus166::Lime166 &);
void GetSultana166Asparagus166Lime166Mango166(::Sultana166::Asparagus166::Lime166::Mango166 &);
int CheckSultana166Asparagus166Lime166Mango166(const ::Sultana166::Asparagus166::Lime166::Mango166 &);
void GetTurnip167(::Turnip167 &);
int CheckTurnip167(const ::Turnip167 &);
void GetSultana167(::Sultana167 &);
int CheckSultana167(const ::Sultana167 &);
void GetSultana167Asparagus167(::Sultana167::Asparagus167 &);
int CheckSultana167Asparagus167(const ::Sultana167::Asparagus167 &);
void GetSultana167Asparagus167Mint167(::Sultana167::Asparagus167::Mint167 &);
int CheckSultana167Asparagus167Mint167(const ::Sultana167::Asparagus167::Mint167 &);
void GetSultana167Asparagus167Mint167BlackEyedBeans167(::Sultana167::Asparagus167::Mint167::BlackEyedBeans167 &);
int CheckSultana167Asparagus167Mint167BlackEyedBeans167(const ::Sultana167::Asparagus167::Mint167::BlackEyedBeans167 &);
void GetGardenPeas168(::GardenPeas168 &);
int CheckGardenPeas168(const ::GardenPeas168 &);
void GetMint168(::Mint168 &);
int CheckMint168(const ::Mint168 &);
void GetMint168BlackEyedBeans168(::Mint168::BlackEyedBeans168 &);
int CheckMint168BlackEyedBeans168(const ::Mint168::BlackEyedBeans168 &);
void GetMint168BlackEyedBeans168PassionFruit168(::Mint168::BlackEyedBeans168::PassionFruit168 &);
int CheckMint168BlackEyedBeans168PassionFruit168(const ::Mint168::BlackEyedBeans168::PassionFruit168 &);
void GetMint168BlackEyedBeans168PassionFruit168ChineseLeaves167(::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167 &);
int CheckMint168BlackEyedBeans168PassionFruit168ChineseLeaves167(const ::Mint168::BlackEyedBeans168::PassionFruit168::ChineseLeaves167 &);
void GetGardenPeas169(::GardenPeas169 &);
int CheckGardenPeas169(const ::GardenPeas169 &);
void GetMint169(::Mint169 &);
int CheckMint169(const ::Mint169 &);
void GetMint169BlackEyedBeans169(::Mint169::BlackEyedBeans169 &);
int CheckMint169BlackEyedBeans169(const ::Mint169::BlackEyedBeans169 &);
void GetMint169BlackEyedBeans169Ginger169(::Mint169::BlackEyedBeans169::Ginger169 &);
int CheckMint169BlackEyedBeans169Ginger169(const ::Mint169::BlackEyedBeans169::Ginger169 &);
void GetMint169BlackEyedBeans169Ginger169Pimpernel168(::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168 &);
int CheckMint169BlackEyedBeans169Ginger169Pimpernel168(const ::Mint169::BlackEyedBeans169::Ginger169::Pimpernel168 &);
void GetidlServerAniseed163Excpt(::idlServer::Aniseed163Excpt &);
int CheckidlServerAniseed163Excpt(const ::idlServer::Aniseed163Excpt &);
void GetidlServerWhiteCabbage163Excpt(::idlServer::WhiteCabbage163Excpt &);
int CheckidlServerWhiteCabbage163Excpt(const ::idlServer::WhiteCabbage163Excpt &);
void GetidlServerParsnip163Excpt(::idlServer::Parsnip163Excpt &);
int CheckidlServerParsnip163Excpt(const ::idlServer::Parsnip163Excpt &);
void GetidlServerOrange163Excpt(::idlServer::Orange163Excpt &);
int CheckidlServerOrange163Excpt(const ::idlServer::Orange163Excpt &);
void GetidlServerSultana163Excpt(::idlServer::Sultana163Excpt &);
int CheckidlServerSultana163Excpt(const ::idlServer::Sultana163Excpt &);
void GetidlServerLoganBerry164Excpt(::idlServer::LoganBerry164Excpt &);
int CheckidlServerLoganBerry164Excpt(const ::idlServer::LoganBerry164Excpt &);
void GetidlServerOrange164Excpt(::idlServer::Orange164Excpt &);
int CheckidlServerOrange164Excpt(const ::idlServer::Orange164Excpt &);
void GetidlServerSultana164Excpt(::idlServer::Sultana164Excpt &);
int CheckidlServerSultana164Excpt(const ::idlServer::Sultana164Excpt &);
void GetidlServerCoconut164Excpt(::idlServer::Coconut164Excpt &);
int CheckidlServerCoconut164Excpt(const ::idlServer::Coconut164Excpt &);



