//
// Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
//
// All rights reserved. No part of this source code may be reproduced,
// stored in a retrieval system, or transmitted, in any form or by any
// means, electronic, mechanical, photocopying, recording or otherwise,
// except as stated in the end-user licence agreement, without the prior
// permission of the copyright owners.
//
// Developed for X/Open by ApTest Ireland Limited.
//
// Project: VSORB
//
// File: src/idl/templates/types.hh
//
// Modifications:
// $Log: types.hh,v $
// Revision 1.1.1.1  2000/02/09 17:16:58  mli
// Imported TOG's VSOrb 1.1.1
//
// Revision 1.5  1999/05/04 12:07:33  james
// SR# 101 Changed CORBA::Char* to char*
//
// Revision 1.4  1997/12/09 11:29:31  james
// Code Regenerated
//
//
//

void AddName(char*);
void RemoveName(void);

void GetULong(CORBA::ULong &);
int CheckULong(const CORBA::ULong);
void GetLong(CORBA::Long &);
int CheckLong(const CORBA::Long);
void GetUShort(CORBA::UShort &);
int CheckUShort(const CORBA::UShort);
void GetShort(CORBA::Short &);
int CheckShort(const CORBA::Short);
void GetBoolean(CORBA::Boolean &);
int CheckBoolean(const CORBA::Boolean);
void GetOctet(CORBA::Octet &);
int CheckOctet(const CORBA::Octet);
void GetChar(CORBA::Char &);
int CheckChar(const CORBA::Char);
void GetFloat(CORBA::Float &);
int CheckFloat(const CORBA::Float);
int CompareFloats(float one, float two);
void GetDouble(CORBA::Double &);
int CheckDouble(const CORBA::Double);
int CompareDoubles(double one,double two);
char * GetString();
int CheckString(const char *);
int CheckString(char *);
char * GetString(int);
int CheckString(const char *,int);
int CheckString(char *,int);
void GetAny(CORBA::Any &);
int CheckAny(const CORBA::Any &);
CORBA::Object_ptr Getobject(void);
int Checkobject(CORBA::Object_ptr v);
void GetCORBATypeCode_ptr(CORBA::TypeCode_ptr &);
int CheckCORBATypeCode_ptr(const CORBA::TypeCode_ptr &);

void GetBanana(::Banana &);
int CheckBanana(const ::Banana &);
void GetAvocado(::Avocado &);
int CheckAvocado(const ::Avocado &);
void GetAvocadoMango(::Avocado::Mango &);
int CheckAvocadoMango(const ::Avocado::Mango &);
void GetAvocadoMangoStarfruit(::Avocado::Mango::Starfruit &);
int CheckAvocadoMangoStarfruit(const ::Avocado::Mango::Starfruit &);
void GetAvocadoMangoStarfruitDates(::Avocado::Mango::Starfruit::Dates &);
int CheckAvocadoMangoStarfruitDates(const ::Avocado::Mango::Starfruit::Dates &);
void GetAvocadoMangoStarfruitDatesLime(::Avocado::Mango::Starfruit::Dates::Lime &);
int CheckAvocadoMangoStarfruitDatesLime(const ::Avocado::Mango::Starfruit::Dates::Lime &);
void GetAvocadoMangoStarfruitDatesLimeLeek(::Avocado::Mango::Starfruit::Dates::Lime::Leek &);
int CheckAvocadoMangoStarfruitDatesLimeLeek(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek &);
void GetAvocadoMangoStarfruitDatesLimeLeekGinger(::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &);
int CheckAvocadoMangoStarfruitDatesLimeLeekGinger(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger &);
void GetAvocadoMangoStarfruitDatesLimeLeekGingerMint(::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &);
int CheckAvocadoMangoStarfruitDatesLimeLeekGingerMint(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint &);
void GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &);
int CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeas(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas &);
void GetAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &);
int CheckAvocadoMangoStarfruitDatesLimeLeekGingerMintGardenPeasSultana(const ::Avocado::Mango::Starfruit::Dates::Lime::Leek::Ginger::Mint::GardenPeas::Sultana &);
void GetidlServerBananaExcpt(::idlServer::BananaExcpt &);
int CheckidlServerBananaExcpt(const ::idlServer::BananaExcpt &);
void GetidlServerAvocadoExcpt(::idlServer::AvocadoExcpt &);
int CheckidlServerAvocadoExcpt(const ::idlServer::AvocadoExcpt &);
void GetidlServerMangoExcpt(::idlServer::MangoExcpt &);
int CheckidlServerMangoExcpt(const ::idlServer::MangoExcpt &);
void GetidlServerStarfruitExcpt(::idlServer::StarfruitExcpt &);
int CheckidlServerStarfruitExcpt(const ::idlServer::StarfruitExcpt &);
void GetidlServerDatesExcpt(::idlServer::DatesExcpt &);
int CheckidlServerDatesExcpt(const ::idlServer::DatesExcpt &);
void GetidlServerLimeExcpt(::idlServer::LimeExcpt &);
int CheckidlServerLimeExcpt(const ::idlServer::LimeExcpt &);
void GetidlServerLeekExcpt(::idlServer::LeekExcpt &);
int CheckidlServerLeekExcpt(const ::idlServer::LeekExcpt &);
void GetidlServerGingerExcpt(::idlServer::GingerExcpt &);
int CheckidlServerGingerExcpt(const ::idlServer::GingerExcpt &);
void GetidlServerMintExcpt(::idlServer::MintExcpt &);
int CheckidlServerMintExcpt(const ::idlServer::MintExcpt &);
void GetidlServerGardenPeasExcpt(::idlServer::GardenPeasExcpt &);
int CheckidlServerGardenPeasExcpt(const ::idlServer::GardenPeasExcpt &);
void GetidlServerSultanaExcpt(::idlServer::SultanaExcpt &);
int CheckidlServerSultanaExcpt(const ::idlServer::SultanaExcpt &);



