/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing advanced features of the valuetype construct 
// Test subgroup description: Testing scope of typedef declarations with the valuetype inheritance 

// Test case Nr. 4 
// Name: tc01 
// Testcase goal: Valuetype inheritance and support of interface with typedef 
// Directory: va_t03 


extern "C"
void test1(void)
{
   /* Public Accessor in interface Intf for attribute IntfAttr of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Public Modifier in interface Intf for attribute IntfAttr of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Public Member in interface Intf for operation op1 with in parameter of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Public Accessor in valuetype BaseVal for attribute BaseValMbr of type FixSvalue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Public Modifier in valuetype BaseVal for attribute BaseValMbr of type FixSvalue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp5.run();
}

extern "C"
void test6(void)
{
   /* Public Member in valuetype BaseVal for operation op2 with in parameter of type FixSvalue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* Public Accessor in valuetype Val supporting interface Intf for attribute IntfAttr of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp7.run();
}

extern "C"
void test8(void)
{
   /* Public Modifier in valuetype Val supporting interface Intf for attribute IntfAttr of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp8.run();
}

extern "C"
void test9(void)
{
   /* Public Member in valuetype Val supporting interface Intf for operation op1 with in parameter of type ShortValue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp9.run();
}

extern "C"
void test10(void)
{
   /* Public Accessor in valuetype Val derived from BaseVal for attribute BaseValMbr of type FixSvalue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp10.run();
}

extern "C"
void test11(void)
{
   /* Public Modifier in valuetype Val derived from valuetype BaseVal for attribute BaseValMbr of type FixSvalue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp11.run();
}

extern "C"
void test12(void)
{
   /* Public Member in valuetype Val derived from valuetype BaseVal for operation op2 with in parameter of type FixSvalue (type defined as typedef) */

  tet_printf("TC: Valuetype inheritance and support of interface with typedef\n");
  tp12.run();
}
