/********************************************************************
 * Copyright (c) 2000
 * GMD FOKUS
 * Kaiserin-Augusta-Allee 31
 * 10589 Berlin
 * Germany
 * Tel: +49-30-3463-7000
 * Fax: +49-30-3463-8000
 *
 * All rights reserved. No part of this source code may be
 * reproduced, stored in a retrieval system, or transmitted,
 * in any form or by any means, electronic, mechanical,
 * photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement,
 * without the prior permission of the copyright owners.             
 * Project: CORVAL2
 *
 * Contact:
 *
 * Dorota Witaszek
 * e-mail: dow@fokus.gmd.de
 *
 * Alain Vouffo-Feudjio
 * e-mail: avf@fokus.gmd.de
 *
 * Date: Jan. 2001
 ********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <tet_api.h>
#include "orb_supp.hh"
#include "tin.hh"
#include "tppses.hh"

// Created by tpsl 
//
// Test group description: Testing features of the valuetype construct 
// Test subgroup description: Testing the valuetype as operation parameter 

// Test case Nr. 1 
// Name: tc01 
// Testcase goal: Classes for a Valuetype 
// Directory: vt_b01 


extern "C"
void test1(void)
{
   /* Existence Of  Class Val, mapping for valuetype Val */

  tet_printf("TC: Classes for a Valuetype\n");
  tp1.run();
}

extern "C"
void test2(void)
{
   /* Existence of class OBV_Val for valuetype Val */

  tet_printf("TC: Classes for a Valuetype\n");
  tp2.run();
}

extern "C"
void test3(void)
{
   /* Exitsence of class Val_init for valuetype Val */

  tet_printf("TC: Classes for a Valuetype\n");
  tp3.run();
}

extern "C"
void test4(void)
{
   /* Existence of Val_var for valuetype Val */

  tet_printf("TC: Classes for a Valuetype\n");
  tp4.run();
}

extern "C"
void test5(void)
{
   /* Existence of Val_out for valuetype Val */

  tet_printf("TC: Classes for a Valuetype\n");
  tp5.run();
}

// Test case Nr. 2 
// Name: tc02 
// Testcase goal: Features of the class Val for valuetype Val 
// Directory: vt_b01 


extern "C"
void test6(void)
{
   /* Definition of public static _downcast() in class Val for valuetype Val */

  tet_printf("TC: Features of the class Val for valuetype Val\n");
  tp6.run();
}

extern "C"
void test7(void)
{
   /* Extraction/insertion from/to any */

  tet_printf("TC: Features of the class Val for valuetype Val\n");
  tp7.run();
}

// Test case Nr. 3 
// Name: tc03 
// Testcase goal: Data member in a Valuetype 
// Directory: vt_b01 


extern "C"
void test8(void)
{
   /* Accessor functions  in class Val for public basic type data members for valuetype Val */

  tet_printf("TC: Data member in a Valuetype\n");
  tp8.run();
}

extern "C"
void test9(void)
{
   /* Modifier functions  in class Val for public basic type data members for valuetype Val */

  tet_printf("TC: Data member in a Valuetype\n");
  tp9.run();
}

// Test case Nr. 4 
// Name: tc04 
// Testcase goal: Features of the class Val_init for valuetype Val 
// Directory: vt_b01 


extern "C"
void test10(void)
{
   /* Existence of initializer operation in the factory class Val_init for the valuetype Val */

  tet_printf("TC: Features of the class Val_init for valuetype Val\n");
  tp10.run();
}

// Test case Nr. 5 
// Name: tc05 
// Testcase goal: Features of the class Val_out for valuetype Val (server side) 
// Directory: vt_b01 


extern "C"
void test11(void)
{
   /* Existence of public constructors in the  class Val_out for the valuetype Val */

  tet_printf("TC: Features of the class Val_out for valuetype Val (server side)\n");
  tp11.run();
}

extern "C"
void test12(void)
{
   /* Possible assignment between Val_out and Val* */

  tet_printf("TC: Features of the class Val_out for valuetype Val (server side)\n");
  tp12.run();
}

extern "C"
void test13(void)
{
   /* Existence of ptr() function in the  class Val_out for the valuetype Val */

  tet_printf("TC: Features of the class Val_out for valuetype Val (server side)\n");
  tp13.run();
}

extern "C"
void test14(void)
{
   /* Existence of operator-> in the  class Val_out for the valuetype Val */

  tet_printf("TC: Features of the class Val_out for valuetype Val (server side)\n");
  tp14.run();
}
