/*
   Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group.
  
   All rights reserved. No part of this source code may be reproduced,
   stored in a retrieval system, or transmitted, in any form or by any
   means, electronic, mechanical, photocopying, recording or otherwise,
   except as stated in the end-user licence agreement, without the prior
   permission of the copyright owners.
  
   Developed for X/Open by ApTest Ireland Limited.
  
   Project: VSORB
  
   File: tset/c++/include/ir_support.hh
  
   Purpose:
  
   Modifications:
   $Log: ir_support.hh,v $
   Revision 1.1.1.1  2000/02/09 17:17:13  mli
   Imported TOG's VSOrb 1.1.1

   Revision 1.2  1998/04/21 09:41:27  stephen
   Copyright changes.

   Revision 1.1  1997/12/05 16:19:59  cwatson
   Moved orb_supp.h to orb_supp.hh.
   ir_support.hh now uses the CORBA scope.

   Revision 1.2  1997/10/04 17:02:30  stephen
   Updated to use corba_supp.hh.

   Revision 1.1  1997/10/04 15:54:51  cwatson
   Initial version of ORB support code.

*/

#ifndef IRSUPPORT_H
#define IRSUPPORT_H

#include <corba_supp.hh>
#include <orb_supp.hh>

class IRSupport
{
    OrbSupport	*m_osupp;
public:
    IRSupport();
    virtual ~IRSupport();

    CORBA::Repository_ptr get_repository();
    CORBA::Contained_ptr get_contained(CORBA::Repository_ptr,CORBA::ScopedName);
};

#endif

